import * as THREE from './js/3rdparty/threejs/build/three.module.js';
import { GUI } from './js/other/dat.gui.module.js';
import { CSS3DRenderer }  from './js/3rdparty/threejs/examples/jsm/renderers/CSS3DRenderer.js';
import {CSS3DObject } from './js/3rdparty/threejs/examples/jsm/renderers/CSS3DRenderer.js';
import CameraControls from './js/other/camera-controls.module.js';


CameraControls.install( { THREE: THREE } );

var ANX = {}

ANNE.ANX = ANX;

ANX.animationID = null;

ANX._lookatLbls = [];

ANX.white_material = null;
ANX.white_material_low_alpha = null;
ANX.green_material = null;
ANX.yellow_material = null;
ANX.yellow_material_low_alpha = null;

ANX.tick = 0;
ANX.tick_block = 0;  //attempt to auto-correct flag error from unkown gui happenings that interupted tweens (and flag settings)

ANX.vol = 32*255/2;

//holds the materials for pos/neg/neu (to resuse)
ANX.awarez_mats = null;

ANX._lastARING = null;
ANX._ANNEfolio = null;
ANX._REVELATIAN = null;

ANX.bMLOOKOK = false;
ANX.bGETOURSTUFF1TIME = false; 
ANX.bFOOTERINIT = false; 
ANX.b3JSACTIVE = true;
ANX.bEMULATE_DATA = false;
ANX.bTRAVELLING = false;
ANX.bONETIME = false;

ANX.color_array_by_base = [];
ANX.color_array_by_base [0x00ff00] = [0x00ffff, 0x00ff44, 0x00ff99, 0x00ffcc, 0x33ff33];
ANX.color_array_by_base [0xff0000] = [0x00ffff, 0xff0011, 0xff0022, 0xff1133, 0xfefe00];
ANX.color_array_by_base [0xfefe17] = [0x00ffff, 0xeeeeee, 0xeefe17, 0xffff55, 0xfefefe];

ANX._snapRequest = null;

ANX.cameraHomePosition = new THREE.Vector3();
ANX.cameraHomeRotation = new THREE.Vector3();
ANX.cameraHomeZoom = .5;

ANX.getPosMat = function() { return ANX.awarez_mats[9];}
ANX.getNegMat = function() { return ANX.awarez_mats[10];}
ANX.getNeuMat = function() { return ANX.awarez_mats[11];}

ANX.activateOrbit = function($target) {
    ANX.controls = new CameraControls( ANX.camera, ANX.rendererCSS.domElement );
    ANX.controls.maxPolarAngle = 1.5088724652651286;
    ANX.controls.minPolarAngle = 0;
    ANX.controls.setTarget( $target.x, $target.y, $target.z );
    ANX.controls.minDistance = 100;
    ANX.controls.maxDistance = 5000;
    ANX.controls.minZoom = .3;
    ANX.controls.maxZoom = 4.8;
    ANX.controls.zoomTo(1.4, false);
    ANX.controls.mouseButtons.wheel = CameraControls.ACTION.ZOOM;
    ANX.controls.mouseButtons.right = CameraControls.ACTION.TRUCK;
}

ANX.preload = function() {
    window.THREE = THREE;
    const textureLoader = new THREE.TextureLoader();
    //ANX.logo_texture = textureLoader.load('./imgs/annex_green_ico.png');
    //ANX.listener = new THREE.AudioListener();
    ANX.colors = [0x00ff00, 0xff0000, 0xfefe17];

    ANX.awarez_mats = [
        new THREE.MeshBasicMaterial({ color: 0x00ff00, wireframe:true, transparent:true, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0xff0000, wireframe:true, transparent:true, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0xfefe17, wireframe:true, transparent:true, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0x00ff00, wireframe:true, transparent:true, opacity:1 }),
        new THREE.MeshBasicMaterial({ color: 0xff0000, wireframe:true, transparent:true, opacity:1 }),
        new THREE.MeshBasicMaterial({ color: 0xfefe17, wireframe:true, transparent:true, opacity:1 }),
        new THREE.MeshBasicMaterial({ color: 0x00ff00, transparent:true, side: THREE.DoubleSide, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0xff0000, transparent:true, side: THREE.DoubleSide, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0xfefe17, transparent:true, side: THREE.DoubleSide, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0x00ff00, transparent:true, side: THREE.DoubleSide, opacity:1 }),
        new THREE.MeshBasicMaterial({ color: 0xff0000, transparent:true, side: THREE.DoubleSide, opacity:1 }),
        new THREE.MeshBasicMaterial({ color: 0xfefe17, transparent:true, side: THREE.DoubleSide, opacity:1 }),
    ];


    var skyboxGeo = new THREE.BoxGeometry(30000, 30000, 30000);
    const ft = new THREE.TextureLoader().load("./imgs/skybox/corona_ft.png");
    const ft_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: ft, side: THREE.DoubleSide });
    const bk = new THREE.TextureLoader().load("./imgs/skybox/corona_bk.png");
    const bk_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: bk, side: THREE.DoubleSide });
    const up = new THREE.TextureLoader().load("./imgs/skybox/corona_up.png");
    const up_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: up, side: THREE.DoubleSide });
    const downz = new THREE.TextureLoader().load("./imgs/skybox/corona_dn.png");
    const dn_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: downz, side: THREE.DoubleSide });
    const rt = new THREE.TextureLoader().load("./imgs/skybox/corona_rt.png");
    const rt_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: rt, side: THREE.DoubleSide });
    const lf = new THREE.TextureLoader().load("./imgs/skybox/corona_lf.png");
    const lf_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: lf, side: THREE.DoubleSide });
    ANX.skyboxMesh = new THREE.Mesh(skyboxGeo, [
        ft_mesh, bk_mesh, up_mesh, dn_mesh, rt_mesh, lf_mesh  
    ]);
}


/**
 * 
 */
ANX.init = function($cb=null) {

    //tie the rnd_header with a toggler.
    //toggleMinMaxBtn("rnd_header", "left_header_body", "", true);
    ANNE.A.wireShowHideToggler("left_header_toggle", "left_header_body", )

    //use the dat gui but use it with our settings ico in the footer...
    var gui = new GUI({ autoPlace: false, closeOnTop:true, useLocalStorage:true });
    var container = document.getElementById('dat_gui_container');
    container.appendChild(gui.domElement);
    ANX.settings = gui.addFolder ('settings');
    ANX.settings.add(ANX, 'bEMULATE_DATA', ANX.bEMULATE_DATA).name("emulate data").onChange(
        function() {
            console.log("emulate data toggled:"+ANX.bEMULATE_DATA);
        }
    );
    ANX.settings.open();
    var el_close = container.querySelector(".close-button");
    el_close.addEventListener("click", e=>{
        gui.open();
        ANNE.A.hide("dat_gui_container");
    });
    
    ANNE.CSS3DObject = CSS3DObject;

    var container = document.getElementById( 'container' );
    ANX.renderer = new THREE.WebGLRenderer({antialias: true});
    ANX.renderer.setPixelRatio( window.devicePixelRatio );
    ANX.renderer.setSize( window.innerWidth, window.innerHeight );
    ANX.renderer.setClearColor(0x000000); // Set a dark color (black)
    ANX.renderer.gammaOutput = true;
    ANX.renderer.gammaFactor = 2.2;
    ANX.renderer.toneMapping = THREE.ACESFilmicToneMapping;
	ANX.renderer.toneMappingExposure = 0.8;  //causes darker tone .. darkness..
    container.appendChild( ANX.renderer.domElement );

    ANX.scene = new THREE.Scene();
    ANX.scene.add(ANX.skyboxMesh);

    const ambientLight = new THREE.AmbientLight(0x202020, 0.5); // Color, Intensity
    ANX.scene.add(ambientLight);

    var csscontainer = document.getElementById( 'csscontainer' );
    ANX.rendererCSS = new CSS3DRenderer();
    //ANX.renderer.setPixelRatio( window.devicePixelRatio );
    ANX.rendererCSS.setSize( window.innerWidth, window.innerHeight );
    ANX.rendererCSS.domElement.style.position = 'absolute';
    ANX.rendererCSS.domElement.style.top = 0;
    csscontainer.appendChild( ANX.rendererCSS.domElement );

    combinedCanvas.setAttribute("width", window.innerWidth * window.devicePixelRatio);
    combinedCanvas.setAttribute("height", window.innerHeight * window.devicePixelRatio);
    
    ANX.white_material = new THREE.MeshBasicMaterial({ color: 0xffffff, wireframe:true });
    ANX.white_material_low_alpha = new THREE.MeshBasicMaterial({ color: 0xffffff, wireframe:true, transparent:true, opacity:.2 });
    ANX.yellow_material = new THREE.MeshBasicMaterial({ color: 0xfefe17, wireframe:true });
    ANX.yellow_material_low_alpha =  new THREE.MeshBasicMaterial({ color: 0xfefe17, wireframe:true, transparent:true, opacity:.2 });
    ANX.green_material = new THREE.MeshBasicMaterial({ color: 0x00ff00, wireframe:true });

    // Set up the camera
    ANX.camera = new THREE.PerspectiveCamera(55, window.innerWidth / window.innerHeight, 0.1, 30000);
    ANX.camera.zoom=1;
    ANX.camera.position.z = 1270;

    ANX.cameraHomePosition.copy(ANX.camera.position);
    ANX.cameraHomeRotation.copy(ANX.camera.rotation);
    ANX.cameraHomeZoom = ANX.camera.zoom;
    
    ANX.savedRotation = new THREE.Vector3();
    ANX.savedPosition = new THREE.Vector3();
    ANX.saveZoom = ANX.camera.zoom;
    ANX.savedExposure = 1;


    ANX.LOOKATME = null;

    ANX.mouseLock = false;
    ANX.raycaster = new THREE.Raycaster();
    ANX.pointer = new THREE.Vector2();
    ANX.mouse = new THREE.Vector2();

    ANX._entryTileMeshes = [];

    window.addEventListener( 'resize', e=>{
            ANX.camera.aspect = window.innerWidth / window.innerHeight;
            ANX.camera.updateProjectionMatrix();
            ANX.renderer.setSize( window.innerWidth, window.innerHeight );
            ANX.rendererCSS.setSize( window.innerWidth, window.innerHeight );
        }, false );


    window.addEventListener('wheel', $e=>{
        if (ANX.b3JSACTIVE==false) return;

        if ($e.target.getAttribute("overlay")!=undefined) {
            return;
        }
        if ($e.target.parentElement!=undefined) {
            if ($e.target.parentElement.getAttribute("overlay")!=undefined) {
                console.log("skipping event from overlay")
                return;
            }
            if ($e.target.parentElement.parentElement!=undefined 
                && $e.target.parentElement.parentElement.getAttribute("overlay")!=undefined) {
                console.log("skipping event from overlay")
                return;
            }
        }

        const zoomSpeed = 0.01; 
        const minZoom = .3; 
        const maxZoom = 2.8; 
        const zoomLevel = ANX.camera.zoom + ($e.deltaY/10 * -zoomSpeed);
        ANX.camera.zoom = Math.max(minZoom, Math.min(maxZoom, zoomLevel));
        ANX.camera.updateProjectionMatrix();
    });


    //for mouse over obj events...
    window.addEventListener( 'pointermove', $e=> {

        ANX.pointer.x = ( $e.clientX / window.innerWidth ) * 2 - 1;
        ANX.pointer.y = - ( $e.clientY / window.innerHeight ) * 2 + 1;
        
        ANX.mouse.x = $e.clientX;
        ANX.mouse.y = $e.clientY;

        if (ANX.bTRAVELLING==true || ANX.b3JSACTIVE==false) return;

        //avoid pointermove here.
        if (ANX._lastARING!=null) {
            if (ANX._lastARING.bHOVERABLESACTIVE==false) return;
            if (ANX._lastARING.bDOINGARINGTUNNEL==true) return;
        } 
        
        //pointer move for mouse look here.
        if (ANX.bMLOOKOK==true && ANX.mouseLock==true) {
            const movementX = $e.movementX || $e.mozMovementX || $e.webkitMovementX || 0;
            const movementY = $e.movementY || $e.mozMovementY || $e.webkitMovementY || 0;
            ANX.camera.rotation.y -= movementX * 0.004;
            ANX.camera.rotation.x -= movementY * 0.002;
        }

        //hoverables for lastARING.
        //we could move this handling into the ring..but i dont wan't to.
        if (ANX._lastARING!=null && ANX._lastARING._hoverableSections.length>0) {

            ANX.raycaster.setFromCamera( ANX.pointer, ANX.camera );
    
            //if mouse is over a hoverable object, change the cursor
            const intersects = ANX.raycaster.intersectObjects( ANX._lastARING._hoverableSections );
            if (intersects.length>0) {
                //document.body.style.cursor = 'grab';
                var hovObj = intersects[0].object;
    
                if (hovObj.ATYPE==AWAREZ_RINGASBAR) {
                    ANX.tick_block=0;
                    hovObj.awarezRing.handleRingAsBarHover(hovObj);
                }
                else if (hovObj.ATYPE==AWAREZ_BUCKET) {
                    hovObj.parent.parent.awarezRing.handleBucketHover(hovObj);
                }
            }
        }
    });


    /**
     * 
     */
    document.addEventListener("mousedown", async $e=>{
        if ($e.button === 2) return; //right click
        if (ANX.bTRAVELLING==true || ANX.b3JSACTIVE==false) return;

        if (ANX._lastARING!=null && ANX._lastARING.bDOINGARINGTUNNEL==true) return;
        if ($e.target.getAttribute("overlay")!=undefined) {
            return;
        }
        if ($e.target.parentElement!=undefined) {
            if ($e.target.parentElement.getAttribute("overlay")!=undefined) {
                //console.log("skipping event from overlay")
                return;
            }
            if ($e.target.parentElement.parentElement!=undefined 
                && $e.target.parentElement.parentElement.getAttribute("overlay")!=undefined) {
                //console.log("skipping event from overlay")
                return;
            }
        }

        if (ANX.bMLOOKOK==false) {
            if (ANX._lastARING!=null) {
                ANX.pointer.x = ( $e.clientX / window.innerWidth ) * 2 - 1;
                ANX.pointer.y = - ( $e.clientY / window.innerHeight ) * 2 + 1;
                ANX.raycaster.setFromCamera( ANX.pointer, ANX.camera );
                const intersects = ANX.raycaster.intersectObjects( ANX._lastARING._hoverableSections );
                if (intersects.length>0) {
                    var hovObj = intersects[0].object;
                    if (hovObj.ATYPE==AWAREZ_BUCKET) {
                        hovObj.parent.parent.awarezRing.makeTunnel(hovObj);
                    }
                }

                //click on nothing while lastARing present,
                //go back to home view.
                else {
                }
                return;
            }
            return;
        }

        //if mouselook is ok (note: we do click+mousemove for mouselook), and the user clicked on a non overlay,
        //do the mouselook (and save rotation to tween back when mouse look done)
        else {
            ANX.savedRotation.copy(ANX.camera.rotation);
            ANX.mouseLock=true;
            ANX.pointer.x = ( $e.clientX / window.innerWidth ) * 2 - 1;
            ANX.pointer.y = - ( $e.clientY / window.innerHeight ) * 2 + 1;
            ANX.raycaster.setFromCamera( ANX.pointer, ANX.camera );
            const intersects = ANX.raycaster.intersectObjects( ANX._entryTileMeshes );
            if (intersects.length==0) return;
            var clickObj = intersects[0].object;
            if (clickObj.ATYPE==ENTRY_TILE) {
                clickObj.cb(clickObj);
                //ANX.goThroughTile(hovObj);
            }
        }
    });


    /**
     * Must be in mouselock for this to work.
     * Otherwise it will throw us WAY off!  :)
     */
    document.addEventListener("mouseup", $e=>{
        if (ANX.bTRAVELLING==true || ANX.b3JSACTIVE==false) return;
        
        if (ANX._lastARING!=null && ANX._lastARING.bDOINGARINGTUNNEL==true) return;
        if (ANX.bMLOOKOK==false) return;
        ANX.mouseLock=false;

        gsap.to(ANX.camera.rotation, {
            x:ANX.savedRotation.x,
            y:ANX.savedRotation.y,
            z:ANX.savedRotation.z,
            ease:"power4.inOut",
            duration: .5,
        });
    });

    //ANX.maintrack.play();
    //ANX.analyser = new THREE.AudioAnalyser(ANX.maintrack, 32);
    ANX.animate();

    var camPosA = new THREE.Vector3(-2000, 0, -3800);
    var spawnPosA = new THREE.Vector3(-3000, 0, -3000);
    var camPosB = new THREE.Vector3(2000, 0, -3800)
    var spawnPosB = new THREE.Vector3( 3000, 0, -3000);

    ANX.makePlaneClicker("ANNEX Highest Levels", ANX.doTop10AnnexByLevel, "./imgs/annex_yellow_ico.png", camPosA, spawnPosA);
    ANX.makePlaneClicker("Awarvu", ANX.doAwarvu, "./imgs/feelz_logo.png", camPosA, spawnPosA);     //aware view?
    ANX.makePlaneClicker("ANNEX What's Hot", ANX.whatsHot, "./imgs/annex_red_ico.png", camPosA, spawnPosA);
    ANX.makePlaneClicker("ANNEfolio", ANX.annfolio, "./imgs/ico_anne_white.png", camPosA, spawnPosA);  
    ANX.makePlaneClicker("REVELATIAN", ANX.goToRevelatian, "./imgs/REVELATIAN.png", new THREE.Vector3(3200, 0, -4600), new THREE.Vector3( 3400, 0, -4400));  
    ANX.makePlaneClicker("ANNEXer Whales", ANX.doAnnexerWhales, "./imgs/annex_blue_ico.png", camPosB, spawnPosB);
    ANX.makePlaneClicker("ANNE Wallet", ANX.ANNEWallet, "./imgs/anne_yellow_arch_on_black.png", camPosB, spawnPosB);

    ANX.placePlanes2x3x2();

    ANX.SOUV = new souvenirs(ANX, ANX.addedSouvenir);

   
    ANNE.A.show("footer_tiles");    //holds go home and camera ico

    ANX.initFooterEvents();
    
    ANX.initLukat();
    
    ANX.initOtherEvents();

    ANX.initANNEfolioFooterEvents();

    var el_close = document.getElementById("popup_close");
    el_close.addEventListener("click", (e)=>{
        ANNE.A.setHTML("popup_body", "");
        ANNE.A.hide("popup_blocker");
    });

    if($cb!=null) $cb();
}


/**
 * 
 * @param {*} $elid 
 * @param {*} $name 
 */
ANX.makeMemeFromEL=function($elid, $name="test") {
    var elToConvert = ANNE.A.__getEl($elid);
    htmlToImage.backgroundColor = "transparent";
    
    htmlToImage.toCanvas(elToConvert).then(function (csscanvas) {
        var imgData = csscanvas.toDataURL('image/jpeg');
        var img = new Image();
        img.src = imgData;
        //document.body.appendChild(img);
        img.onload = function() {
            ANX.SOUV.addSouvenir(SOUV_THUMBNAIL, {somevar:"meme", dataUrl:imgData, default_name:$name});
        };
    }).catch(function ($e) {
        console.error('An error occurred during conversion:', $e);
    });
}


ANX.test11=function() {
    var grid = ANNE.A.build1con1con();
    var memObj = ANNE.A.memeframer("900px", ANNE.ANX.makeMemeFromEL);
    memObj.body.appendChild(grid.parent_el);
    ANX.showPopup(memObj.el);
}

ANX.test12=function() {
    var grid = ANNE.A.build1con2con();
    var memObj = ANNE.A.memeframer("900px", ANNE.ANX.makeMemeFromEL);
    memObj.body.appendChild(grid.parent_el);
    ANX.showPopup(memObj.el);
}
ANX.test21=function() {
    var grid = ANNE.A.build2con1con();
    var memObj = ANNE.A.memeframer("900px", ANNE.ANX.makeMemeFromEL);
    memObj.body.appendChild(grid.parent_el);
    ANX.showPopup(memObj.el);
}
ANX.test22=function() {
    var grid = ANNE.A.build2con2con();
    var memObj = ANNE.A.memeframer("900px", ANNE.ANX.makeMemeFromEL);
    memObj.body.appendChild(grid.parent_el);
    ANX.showPopup(memObj.el);
}


ANX.showPopup=function($html) {
    if (typeof $html ==="string") {
        ANNE.A.setHTML("popup_body", $html);
    }
    else {
        var elpb = ANNE.A.setHTML("popup_body", "");
        elpb.appendChild($html);
    }
    ANNE.A.fadeIn("popup_blocker");
}


/**
 * 
 */
ANX.initFooterEvents=function() {
    var el_home = document.getElementById("btn_home_view");
    el_home.addEventListener("click", e=>{
        console.log("home");
        ANX.travelHome();
    });

    var el_cam = document.getElementById("cam_snap");
    ANNE.A.show(el_cam);
    el_cam.addEventListener("click", e=>{
        var dt =  new Date();
        dt = dt.toString().trim().replaceAll(" ", "_");
        ANX.takeSnapshot("basic", "snap_"+dt);
        ANNE.A.play("camera");
    })

    var el_settings = document.getElementById("btn_footer_settings");
    el_settings.addEventListener("click", e=>{
        ANNE.A.toggle("dat_gui_container") 
    });
    ANNE.A.hide("dat_gui_container");



    //these are shown during the awarevu RING.. 
    //they apply to the current neuron in view in the awarvu ring.

    var btn_nf_awarvu = document.getElementById("btn_nf_awarvu");
    btn_nf_awarvu.addEventListener("click", e=>{
        console.log("awarvu clicked");
        ANNE.A.hide("btn_nf_awarvu");
        ANNE.A.show("btn_nf_annex");
        if (ANX._lastARING!=null) {    
            ANX._lastARING.handleAwarvuFooterClick();
        }

        //we may have revelation for this too.
        //ANX.showFZWidgetOverlay(ANX._lastARING.nObj.nid);
    });

    var btn_nf_annex = document.getElementById("btn_nf_annex");
    btn_nf_annex.addEventListener("click", e=>{
        console.log("annex clicked");
        ANNE.A.show("btn_nf_awarvu");
        ANNE.A.hide("btn_nf_annex");
        if (ANX._lastARING!=null) {
            ANX._lastARING.handleAnnexFooterClick();
        }
        //we may have revelation for this too.
    });

    var btn_nf_annet = document.getElementById("btn_nf_annet");
    btn_nf_annet.addEventListener("click", e=>{
        //launch annet app.
        var url = '/ANNE.html?page=annet&nid='+ANX._lastARING.nObj.nid;
         window.open(url, '_blank');

    });

    var el_widget_close = document.getElementById("fzWidget_close_anx");
    el_widget_close.addEventListener("click", e=>{
        ANNE.A.hide("fzWidgetOverlayOutter_anx");
    });
    
}


/**
 * 
 * @param {*} $forNid 
 */
ANX.showFZWidgetOverlay = function($forNid) {
    ANNE.A.show('fzWidgetOverlayOutter_anx');
    var el_fzWidgetOverlay = document.getElementById("fzWidgetOverlay_anx");
    ANNE.A.emptySelfAfterChild(el_fzWidgetOverlay, 0);

    var nObj = MEMG.getNeuronByNid($forNid);

    //flag ico view like in explorer?
    ANNE.A.setHTML("fzWidget_name_anx", nObj.bestNameHTML());
    
    AWARE.makeFeedbackWidget(el_fzWidgetOverlay, USER._userNObj.nid, $forNid, TARGET_NID);

    ANX.b3JSACTIVE=false;
    var cssel = document.getElementById("csscontainer");
    cssel.style.pointerEvents="none";
    var tjsel = document.getElementById("container");
    tjsel.style.pointerEvents="none";

}


/**
 * Callback after send queue
 * @param {*} $obj 
 */
ANX.updateAwarvu=function($obj){
    console.log($obj); //what do we get to work with here???  :)
    console.log("update anneid data, update awarevu data for the to");

    var cssel = document.getElementById("csscontainer");
    cssel.style.pointerEvents="all";
    var tjsel = document.getElementById("container");
    tjsel.style.pointerEvents="all";

    if (ANX._lastARING==null) return;  //???

    //redo the gui with the new data. (however small or big the change was)
    //default to the awarevu view (not annex)
    
    var nid = ANX._lastARING.nObj.nid;
    var nObj = MEMG.getNeuronByNid(nid);

    if (ANX._lastARING!=null) {
        ANX._lastARING.cleanup();
        ANX._lastARING = null;
    }
    ANX.makeNewNeuronView(nObj, "awarvu");
}



ANX.initOtherEvents = function() {
    var el = document.getElementById("lh_reset");
    el.addEventListener("click", e=> {
        ANNE.A.empty("lh_content");
        ANNE.A.hide("left_holder2");
    }) 
}

/**
 * 
 */
ANX.initANNEfolioFooterEvents = function() {
    if(ANX.bFOOTERINIT==true) return;
    ANX.bFOOTERINIT = true;
    
    var aicos = document.querySelectorAll(".annefolio-ico");

    for (var a=0; a < aicos.length; a++) {
        //click event.
        aicos[a].addEventListener("click", e=>{
            var bRESET = false;
            var aicos = document.querySelectorAll(".annefolio-ico");
            var thisIco = ANNE.A.getFirstParentOf(e.target, "annefolio-ico");
            if (thisIco.classList.contains("on")==true) {
                bRESET=true;
            }
            for (var a=0; a < aicos.length; a++) { aicos[a].classList.remove("on");}
            if (bRESET==true) {
                console.log("(ANX.initANNEfolioFooterEvents) need to reset all filters");
                ANX._ANNEfolio.resetAllFilters();
                return;
            }
           
            var btn = ANNE.A.getFirstParentOf(e.target, "annefolio-ico");
            btn.classList.add("on");
            var nid = btn.getAttribute("nid");
            
            ANNE.A.hide("left_holder2");    //reshow the left bar
            if (ANX._ANNEfolio!=null) {
                ANX._ANNEfolio.ANNEfolioFilter(nid, btn);   
            }
            else if (ANX._REVELATIAN!=null) {
                ANX._ANNEfolio.RevelatianFilter(nid, btn);  
            }      
        });

        
        var el_ranks = document.getElementById("link_id_ranks");

        el_ranks.addEventListener("click", e=>{
            e.stopImmediatePropagation();
            e.preventDefault();
            ANNE.A.show("injected_div");
            ANNE.A.show("id_identity_view");
            ANNE.A.addRemoveClass("injected_div", "unBlurFadeIn", "blurFadeOut")
        })
    }
}


/**
 * 
 */
ANX.initLukat = function($bCHASEIT=true) {
    ANX.el_input = document.getElementById("anne_lukat_search");
    ANX.el_input.addEventListener("keyup", $e=>{
        if ($e.keyCode === 13) { 
            console.log("enter key hit");
            $e.stopImmediatePropagation();
            $e.preventDefault();
            ANX.doLukat();
            return;
        }
    });
    ANX.el_lukatit_btn = document.getElementById("btn_lukait");
    ANX.el_lukatit_btn.addEventListener("click", $e=>{
        $e.stopImmediatePropagation();
        $e.preventDefault();
        ANX.doLukat();
    });

    var el_lukat_quick_searches = document.getElementById("lukat_quick_searches");
    var nodes =  el_lukat_quick_searches.querySelectorAll(".lnas");
    const bCHASEIT = $bCHASEIT;
    for (var n=0; n < nodes.length; n++) {
        nodes[n].addEventListener("click", async $e=>{
            if ($e!=null) {
                $e.stopImmediatePropagation();
                $e.preventDefault();
            }
            
            //if user clicked on search items while in ANNEID, nuke ANNEID injected page.
            ANX.lastInjectedCleanup();

            var btn = $e.target;
            var classn = btn.getAttribute("anne-class");
            var classNOBJ = MEMG.getNeuronByNid(classn);  
            console.log(classNOBJ);
            var nids = [classNOBJ.nid];
            var aMatches = await CHASE.search_recents_by_class(nids, bCHASEIT);
            this.el_lukatit_btn.setAttribute("disable", false);
            console.log(aMatches);

            var nids = [];
            for (var a=0; a < aMatches.length; a++) {
                var nObj = aMatches[a];
                nids.push(nObj.nid);
            }
            if (nids.length) await ANNE.CHASE.loadLocalBEMs(nids);

            ANX.renderMatches(aMatches);
        });
    }
}


/**
 * lukat search
 */
ANX.doLukat=async()=>{
            
    //if user did search while in ANNEID, nuke ANNEID injected page.
    ANX.lastInjectedCleanup();
    
    var searchval = ANX.el_input.value;
    ANX.el_input.value="";

    var aMatches = await CHASE.nakedSearch(searchval);
    console.log(aMatches);

    ANX.renderMatches(aMatches);
}


/**
 * This search is ready to be much more robust but we don't use this yet (until we activate the search options)
 * It really isn't important in this app to activate the search settings/options.
 * This app is not intended for users to search for NON-ANNE-owned stuff.
 * @param {*} $searchVal 
 * @param {*} $beClassNids 
 * @param {*} $lets 
 * @param {*} $bAPPLYWVTOBELINE 
 * @param {*} $inbeline 
 * @param {*} $bEXACT 
 * @returns 
 */
ANX.makeSearch=function($searchVal, $beClassNids=[], $lets=[], $bAPPLYWVTOBELINE=false, $inbeline=0, $bEXACT=true){
    if (ANNE.USER._bWORLDVIEWBIPASS==false) var wvs_live = MEM.getWorldViewNidList();
    else var wvs_live = [];
    if (wvs_live==undefined) wvs_live = [];
    if (wvs_live.indexOf(USER._userNObj.nid)==-1) wvs_live.push(USER._userNObj.nid);
    var bes_tnids = [];
    if ($beClassNids.length) {
        for (var b=0; b < $beClassNids.length; b++) {
            var be = $beClassNids[b];
            var beNOBJ = MEMG.getNeuronByNid(be);
            bes_tnids.push(beNOBJ.temp_nid);
        }
    }
    //we are letting in other worldviews here (in addition to our own and ANNE)
    if ($lets.length) {
        for (var w=0; w < $lets.length; w++) {
            var wv = $lets[w];
            if (wvs_live.indexOf(wv)==-1) wvs_live.push(wv);
        }
    }
    return { 
            text:$searchVal, 
            original:$searchVal,
            context:[],
            wvs:wvs_live, 
            bes:$beClassNids,
            bes_tnids:bes_tnids,
            exact:$bEXACT,
            applywvtobeline:$bAPPLYWVTOBELINE,
            inbeline:$inbeline,
            chaseIt:true
    };
}


/**
 * 
 * @param {*} $aMatches 
 */
ANX.renderMatches=function($aMatches) {
    //console.log("render matches", $aMatches);
    ANNE.A.show("left_holder2");
    //put the matches on the left hand side.
    //render them the best we can.



    for (var m=0; m < $aMatches.length; m++) {
        var match = $aMatches[m];
        if (ANX._REVELATIAN!=null) {
            ANNE.A.play("sharpbeep");            
            ANX.addRevelatianBtn(match, "", "lh_content", "");


            if(ANX._REVELATIAN.n1==null && ANX._REVELATIAN.n2==null) {
                var revbtns = document.getElementById("left_header_body");
                revbtns.innerHTML = "<span style='padding-top:20px; padding:8px; font-weight:700; font-sie:12px; color:#fefe17'>Pick a neuron from the search and <span style='color:#00FF00'>click on it</span>.  Then pick another.  Enjoy the show.</span>";
            }

        }
        else {
            ANX.addSearchResultBtn(match, "", "lh_content", "");
        }
    }
}


/**
 * 
 */
ANX.goToRevelatian = function($clickObj) {
    if (ANX._ANNEfolio!=null) {
        ANX._ANNEfolio.cleanup();
        ANX._ANNEfolio = null;
    }
    else if (ANX._REVELATIAN!=null) {
        ANX._REVELATIAN.cleanup();
        ANX._REVELATIAN = null;
    }

    ANX.bMLOOKOK=false;
        
    //on clean up we will return these values to where they were.
    var elrholder = ANNE.A.__getEl("right_holder");
    elrholder.style["width"]="333px";
    elrholder.style["background"]="rgb(0 0 0 / 12%)";

    ANX._REVELATIAN = new revelatian(ANX, ANX.scene, ANX.camera, ANX.rendererCSS, $clickObj.helperObj, ANX.bEMULATE_DATA);
    ANNE.A.play("woosh2");
    
    ANX.travelToObj(ANX._REVELATIAN.mesh.position, $clickObj.helperObj.camPosition, function() {
        console.log("travel callback footer tiles show")
        ANNE.A.show("btn_home_view");
        ANNE.A.show("revelatian_footer");
    });
}


/**
 * 
 */
ANX.doTop10AnnexByLevel = async($clickObj)=> {
    console.log("doTop10AnnexByLevel");
    ANNE.A.empty("lh_content");
    ANX.bMLOOKOK=true;
    var aData = null;
    if (ANX.bEMULATE_DATA==true) {
        aData = await AWARE.emulateANNEXTopX(10);
    }
    else {
        aData = await ANNE.API.getTopXAnnexByLevel();
    }
    var nids = [];
    for (var a=0; a < aData.length; a++) {
        var nObj = aData[a];
        nids.push(nObj.nid);
    }
    if (nids.length) await ANNE.CHASE.loadLocalBEMs(nids);

    for (var a=0; a < aData.length; a++) {
        const nOBJ = aData[a];
        //console.log(nOBJ.nid+" "+nOBJ.text);
        const rank = "<span class='color-yellow'>#"+(a+1)+"&nbsp;</span><span class='n-name'>"+nOBJ.bestNameHTML()+"</span><em> A<span class='color-yellow'>"+nOBJ._aplex.price_lvl+"</span></em>";
        gsap.to({bob:1}, {
            ease:"none",
            delay:a*.1,
            duration: .1,
            onComplete:function() {
                ANX.addNeuronAnnexBtn(nOBJ, rank, "lh_content", "yellow");
            }
        })
    }
    ANNE.A.show("btn_home_view");

    
    if (aData.length==0) {
        //alert("no results");    
    }
    
}


/**
 * 
 */
ANX.whatsHot = async($clickObj)=> {
    console.log("whatsHot");
    ANNE.A.empty("lh_content");
    ANX.bMLOOKOK=true;
    var aData = null;   //aData is {.nObj .cnt}

    if (ANX.bEMULATE_DATA==true) {
        aData = await AWARE.emulateWhatsHot(10);
    }
    else {
        aData = await ANNE.API.getLatestXAnnexes(10);
    }

    var nids = [];
    for (var a=0; a < aData.length; a++) {
        var data = aData[a];
        nids.push(data.nObj.nid);
    }
    if (nids.length) await ANNE.CHASE.loadLocalBEMs(nids);

    //no need to overjazz the gui.
    //just animate through the top 20 and pop in a souvenir.
    //user clicks souvenir and we can load a detailed view of that neuron.
    for (var a=0; a < aData.length; a++) {
        const nOBJ = aData[a].nObj;
        const rank = "<span class='color-red'>#"+(a+1)+"(+"+aData[a].cnt+")</span>&nbsp;"+nOBJ.bestNameHTML();
        gsap.to({bob:1}, {
            ease:"none",
            delay:a*.1,
            duration: .1,
            onComplete:function() {
                ANX.addNeuronAnnexBtn(nOBJ, rank, "lh_content", "red");
            }
        })
    }
    ANNE.A.show("btn_home_view");

    if (aData.length==0) {
        //alert("no results");    
    }
}


/**
 * Who is doing the most annexing?
 */
ANX.doAnnexerWhales = async($clickObj)=> {
    console.log("doAnnexerWhales");
    ANNE.A.empty("lh_content");
    ANX.bMLOOKOK=true;
    var aData = null;

    if (ANX.bEMULATE_DATA==true) {
        aData = await AWARE.emulateAnnexerWhales(10);
    }
    else {
        aData = await ANNE.API.getAnnexerWhales(); //getANNEXWhales
    }

    
    //ensure it is sorted.
    aData.sort(function($a, $b){
        if ($a._anneid.did_annex>$b._anneid.did_annex) return -1;
        if ($a._anneid.did_annex<$b._anneid.did_annex) return 1;
        return 0;
    })

    ANNE.A.show("btn_home_view");

    //no need to overjazz the gui.
    //just animate through the top 20 and pop in a souvenir.
    //user clicks souvenir and we can load a detailed view of that neuron.
    var nids = [];
    
    for (var a=0; a < aData.length; a++) {
        var nObj = aData[a];
        nids.push(nObj.nid);
    }

    //get our data from IDB into RAM.
    if (nids.length>0) await ANNE.CHASE.loadLocalBEMs(nids);

    var nids = [];
    for (var a=0; a < aData.length; a++) {
        var nObj = aData[a];
        if(nObj.text=="" || nObj.bes.length==0) nids.push(nObj.nid);
    }

    //we need basic data on our whales... arrrrg.
    //annexerWhales query should have atleast gotten .text.
    if (nids.length) {
        console.log("%c WE NEED MORE DATA SMOKEY ", ANNE.TALK.bgbigred);
        await ANNE.CHASE.queryForOutsFroms_not(nids, true, [2,3,4,5,6,7,8]); //only need 0/1
    }
    
    for (var a=0; a < aData.length; a++) {
        const nOBJ = aData[a];
        console.log("(doAnnexerWhales) audit text "+nOBJ.text);
        
        const rank = "<span class='color-blue'>#"+(a+1)+"</span>&nbsp;"+nOBJ.bestNameHTML();
        gsap.to({bob:1}, {
            ease:"none",
            delay:a*.1,
            duration: .1,
            onComplete:function() {
                ANX.addNeuronIdentityBtn(nOBJ, rank, "lh_content", "blue");
            }
        })
    }

    if (aData.length==0) {
        //alert("no results");    
    }
}


/**
 */
ANX.ANNEWallet = async($clickObj)=> {

    ANNE.A.hide("left_holder2");
    ANNE.A.hide("id_annefolio_filters");
    ANNE.A.hide("revelatian_footer");
    ANNE.A.hide("neuron_footer");
    ANNE.A.hide("right_holder");    //no room to risk showing this and no real reason.

    await ANNE.MEM_UDF.loadSolo("anneid.html", "injected_div", "");
    await ANNE.ANNEID.initAsync();

    ANX.travelToObj($clickObj.helperObj.objSpawnPosition, $clickObj.helperObj.camPosition, function() {
        console.log("travel callback footer tiles show")
        ANNE.A.show("btn_home_view");

        ANX.stopAnimation();
    });
}


/**
 * Awarvu is top level awarez sys wide.
 */
ANX.doAwarvu = async($clickObj)=> {
    ANX.switchViewCleanup();

    console.log("doAwarvu", $clickObj);
    ANX.bMLOOKOK = false; //no mouselook on feelzyWorld.

    //hmmm.  (maybe we need a reset button for the user to choose when to clear out their souvenirs?)
    ANNE.A.empty("right_holder");

    var aplexDataObj = null;
    if (ANX.bEMULATE_DATA==true) {
        aplexDataObj = AWARE.emulateANNESummary();
    }
    else {
        //get applex data from anne for basic display requirements
        aplexDataObj = await ANNE.API.getAwarvuMetaSummary(0);
    }

    if (aplexDataObj==null) {
        alert('fix this, no aplexDataObj.. catastrophic.');
        return;
    }

    //var osp = $clickObj.helperObj.objSpawnPosition;
    ANX._lastARING = new awarvu_ring(ANX.scene, ANX, aplexDataObj);
    if (ANX._lastARING.bCATASTROPHIC==true) {
        ANX._lastARING.cleanup();
        ANX._lastARING = null;
        return;
    }
    
    await ANX._lastARING.initARing("awarvu", $clickObj.helperObj, ANX.bEMULATE_DATA);

    //adjust the obj to face where are camera will be coming from.
    ANX._lastARING.ARing.lookAt($clickObj.helperObj.camPosition);
    ANX._lastARING = ANX._lastARING;
    
    ANX.travelToObj(ANX._lastARING.ARing.position, $clickObj.helperObj.camPosition, function() {
        console.log("travel callback footer tiles show")
        ANNE.A.show("btn_home_view");
    });
}


/**
 * 
 * @param {*} $nObj 
 * @param {*} $boosties 
 * @param {function} $cb - callback
 */
ANX.boostiesNow=async($nObj, $boosties=0, $cb=null)=>{
    var aplex = $nObj._aplex;
    var gui_extras = new Object();
    gui_extras.payment = parseInt($boosties);
    var sys_msg_rel = ANNE.MEMZ.ez_new_sys_msg($nObj, MEM.boosties.nid, TO_TYPE_NUMBER, gui_extras.payment, gui_extras);
    if (aplex.last_fullhash!=undefined && aplex.last_fullhash!="") {
        sys_msg_rel.referencedTransactionFullHash = aplex.last_fullhash;
    }

    ANNE.MEM_UDF.hide3js();
    
    await ANNE.MEM_UDF.loadSolo("sender.html", "injected_div_SENDER", "");

    //cancel/success callbacks.
    var pgui = {pObj:{p1:"ANNEX <style='color-green'>"+$nObj.text+"</style>", 
        c_cbk:function(){
            ANNE.A.emptySelf("injected_div_SENDER");
            ANNE.A.hide("injected_div_SENDER");
            ANNE.MEM_UDF.show3js(false);
        },
        s_cbk:function(){
            ANNE.A.emptySelf("injected_div_SENDER");
            ANNE.A.hide("injected_div_SENDER");
            ANNE.MEM_UDF.show3js(false);
            if ($cb) $cb();
        }
    }};
    
    ANNE.SENDER.init(pgui);
    
    ANNE.A.show("injected_div_SENDER");
}


/**
 * 
 * @param {anne_neuron} $nObj 
 * @param {function} $cb 
 */
ANX.annexNow=async($nObj, $cb=null)=> {
    var aplex = $nObj._aplex;
    var gui_extras = new Object();
    gui_extras.payment = aplex.calculated_cost;
    var sysmsg_rel = await ANNE.MEMZ.ez_new_sys_msg(USER._userNObj, MEM.annex.nid, TO_TYPE_ANNE, $nObj.nid, gui_extras, null);
    
    //critical for this to get accepted via the node if it is anything other than 
    //the first lvl of annexing.  All non-first lvls must reference the previous annex
    //transaction to create a chain of annexings that flow for annex documentation in time.
    //We have this data without the chain but it is an extra helper that is useful.
    if (aplex.last_fullhash!=undefined && aplex.last_fullhash!="") {
        sysmsg_rel.referencedTransactionFullHash = aplex.last_fullhash;
    }

    ANNE.MEM_UDF.hide3js();

    await ANNE.MEM_UDF.loadSolo("sender.html", "injected_div_SENDER", "");

    //cancel/success callbacks.
    const NOBJ = $nObj;
    var pgui = {pObj:{p1:"ANNEX <style='color-green'>"+$nObj.text+"</style>", 
        c_cbk:function(){
            ANNE.A.emptySelf("injected_div_SENDER");
            ANNE.A.hide("injected_div_SENDER");
            ANNE.MEM_UDF.show3js(false);
        },
        f_cb:function() {
            console.log("something went wrong");
            ANNE.A.emptySelf("injected_div_SENDER");
            ANNE.A.hide("injected_div_SENDER");
            ANNE.MEM_UDF.show3js(false);
        },
        s_cbk:function(){
            console.log("called on success only.");
            ANNE.A.emptySelf("injected_div_SENDER");
            ANNE.A.hide("injected_div_SENDER");
            ANNE.MEM_UDF.show3js(false);
            NOBJ._aplex.has_pending=true;
            if ($cb!=null) $cb();
        }
    }};
    
    ANNE.SENDER.init(pgui);
    
    ANNE.A.show("injected_div_SENDER");
}


/**
 * 
 */
ANX.loadSenderFromNon3js=async()=>{
    await ANNE.MEM_UDF.loadSolo("sender.html", "injected_div_SENDER", "");
    //hide injected_div?
    //or let it be seen in back?
    ANNE.A.pointerEventsNone("injected_div");
    //cancel/success callbacks.
    var pgui = {pObj:{ 
        c_cbk:function(){
            ANNE.A.emptySelf("injected_div_SENDER");
            ANNE.A.hide("injected_div_SENDER");
            ANNE.A.pointerEventsAll("injected_div");
        },
        f_cb:function() {
            console.log("something went wrong");
            ANNE.A.emptySelf("injected_div_SENDER");
            ANNE.A.hide("injected_div_SENDER");
            ANNE.A.pointerEventsAll("injected_div");
        },
        s_cbk:function(){
            console.log("called on success only.");
            ANNE.A.emptySelf("injected_div_SENDER");
            ANNE.A.hide("injected_div_SENDER");
            ANNE.A.pointerEventsAll("injected_div");;
        }
    }};
    
    ANNE.SENDER.init(pgui);
    ANNE.A.show("injected_div_SENDER");
}


/**
 *  
 */
ANX.makeNewNeuronView = async($nObj=null, $default="awarvu")=> {
    var aplexSummaryDataObj = null;
    ANX.bMLOOKOK=false;
    ANX.b3JSACTIVE=true;

    //we need to get the basic neuron info (+ BEM) from the annode and load it into RAM.

    ANX.switchViewCleanup();

    //var backlink = ANNE.MEMG.getUnconfirmedAnnex(this.nObj.outs);
    //TYPE_SYS_MSG from asset with reln for intra block pending 7772178508525445062
    if (ANX.bEMULATE_DATA==true) {
        if ($nObj!=null) {
            aplexSummaryDataObj = AWARE.emulateDataSpecificNeuron($nObj, 100);
        }
        else aplexSummaryDataObj = AWARE.emulateANNESummary();
    }

    else {
        if ($nObj._aplex==undefined || $nObj._aplex==null) {
            console.log("%c NEURON APLEX bug hunt! (ANX.makeNewNeuronView)", ANNE.TALK.bgbigred);
            var _aplex = await ANNE.API.getAplex($nObj, 0);
            console.log(_aplex); //allows us to get price and key annex vars.
        }

        //will calc them if we didn't just get them.
        //sometimes we already have an _aplex (light) obj with no annex vals.
        //NOTE: when going back n forth annexing with an interested party...
        //we're going to have to refresh this data... hmm.
        await $nObj._aplex.calculate_annex_vars($nObj);
        
        //get applex data from anne for basic display requirements
        if ($nObj._aplex_sum==undefined || $nObj._aplex_sum==null) {
            aplexSummaryDataObj = await ANNE.API.getAwarvuSummaryFor($nObj, 0);
        }
        else aplexSummaryDataObj = $nObj._aplex_sum;
    }

    if (aplexSummaryDataObj==null) {
        alert("fix this");
        return;
    }


    //get data footprint for this thing (other than specific awareness relons)
    await ANNE.API.queryForOuts_not($nObj.nid);

    var helperObj = ANX._entryTileMeshes[1].helperObj;

    ANX._lastARING = new awarvu_ring(ANX.scene, ANX, aplexSummaryDataObj);
    await ANX._lastARING.initARing($default, helperObj, ANX.bEMULATE_DATA);

    //adjust the obj to face where are camera will be coming from.
    ANX._lastARING.ARing.lookAt(helperObj.camPosition);
    ANX._lastARING = ANX._lastARING;
    
    ANX.travelToObj(ANX._lastARING.ARing.position, helperObj.camPosition, function() {
        console.log("travel callback footer tiles show")
        ANNE.A.show("btn_home_view");
    });
}


/**
 * 
 */
ANX.switchViewCleanup = function() {
    
    ANNE.A.hide("id_annefolio_filters");
    ANNE.A.hide("revelatian_footer");
    ANNE.A.hide("neuron_footer");
    ANNE.A.stopPlay("inspire_space");

    if (ANX._lastARING!=null) {
        ANX._lastARING.cleanup();
        ANX._lastARING = null;
    }
    else if (ANX._ANNEfolio!=null) {
        ANX._ANNEfolio.cleanup();
        ANX._ANNEfolio = null;
    }
    else if (ANX._REVELATIAN!=null) {
        ANX._REVELATIAN.cleanup();
        ANX._REVELATIAN = null;
    }
    ANX.lastInjectedCleanup();

    if (ANX.animationID==null) ANX.restartAnimation();

    //make sure we're good on the zoom.
    if (ANX.camera.zoom!=ANX.cameraHomeZoom) {
        gsap.to(ANX.camera, {
            zoom:ANX.cameraHomeZoom,
            ease:"power2.inOut",
            duration: 1,
            onUpdate:function(){
                ANX.camera.updateProjectionMatrix();
            }
        });
    }
}


ANX.lastInjectedCleanup = function() {
    ANNE.A.emptySelf("injected_div", true);  //empty and hide
}


/**
 * 
 * @param {*} $nObj 
 * @param {*} $default 
 */
ANX.makeNewIdentityView = async($nObj=null)=> {
    console.log("makeNewIdenityView");
    
    var el_id = document.getElementById("injected_div");
    if (el_id.classList.contains("unBlurFadeIn")==true) el_id.classList.remove("unBlurFadeIn");
    if (el_id.classList.contains("blurFadeOut")==true) el_id.classList.remove("blurFadeOut");
    
    var _anneid = null;
    ANX.bMLOOKOK=false;

    ANX.switchViewCleanup();
    
    if (ANX.bEMULATE_DATA==true) {
        _anneid = $nObj._anneid;
        if (_anneid==undefined || _anneid==null) {
            _anneid = new anneid($nObj);
            var thisTotalUsers = Math.ceil(Math.random() * 100);
            _anneid.emulate(1000, thisTotalUsers);
        }
    }
    else {
        _anneid = $nObj._anneid;
        if (_anneid==undefined || _anneid==null || _anneid.total_users==0) {
            _anneid = await ANNE.API.getANNEID_ranks($nObj, false);
        }
    }

    const helperObj = ANX._entryTileMeshes[4].helperObj;

    await ANNE.MEM_UDF.loadSolo("identity_view.html", "injected_div", "");

    ANNE.A.hide("injected_div");

    ANNE.A.setHTML("id_name", $nObj.bestNameHTML());
    var parentNOBJ = $nObj.getParent();
    if (parentNOBJ!=null) {
        ANNE.A.setHTML("id_class_type", parentNOBJ.bestNameHTML());
    }
    else {
        ANNE.A.setHTML("id_class_type", "fix this jerky");
    }
    
    ANNE.A.setHTML("blocks_mined", UTILS.commas(_anneid.blocks_mined));
    ANNE.A.setHTML("rank_bm", _anneid.colorizeRank(_anneid.rank_bm));
    
    ANNE.A.setHTML("share_mines", UTILS.commas(_anneid.share_mines));
    ANNE.A.setHTML("rank_sm", _anneid.colorizeRank(_anneid.rank_sm));
    
    ANNE.A.setHTML("andy_actions", UTILS.commas(_anneid.andy_actions));
    ANNE.A.setHTML("rank_aa", _anneid.colorizeRank(_anneid.rank_aa));

    ANNE.A.setHTML("hanais", UTILS.commas(_anneid.hanais));
    ANNE.A.setHTML("rank_ha", _anneid.colorizeRank(_anneid.rank_ha));

    ANNE.A.setHTML("sponsored_neurons", UTILS.commas(_anneid.sponsored_neurons));
    ANNE.A.setHTML("rank_sn", _anneid.colorizeRank(_anneid.rank_sn));
    
    ANNE.A.setHTML("relons_sponsored", UTILS.commas(_anneid.relons_sponsored));
    ANNE.A.setHTML("rank_rs", _anneid.colorizeRank(_anneid.rank_rs));
   
    ANNE.A.setHTML("did_annex", UTILS.commas(_anneid.did_annex));
    ANNE.A.setHTML("rank_da", _anneid.colorizeRank(_anneid.rank_da));
   
    ANNE.A.setHTML("got_annexed", UTILS.commas(_anneid.got_annexed));
    ANNE.A.setHTML("rank_ga", _anneid.colorizeRank(_anneid.rank_ga));
 
    ANNE.A.setHTML("boostybacks_won", UTILS.commas(_anneid.boostybacks_won));
    ANNE.A.setHTML("rank_bw", _anneid.colorizeRank(_anneid.rank_bw));

    const NOBJ = $nObj;

    var el_af_link = document.getElementById("id_af_link");
    el_af_link.addEventListener("click", e=>{
        ANX.doANNEfolioView(NOBJ, helperObj);
        ANNE.A.hide(el_af_link);
    });
    if($nObj.nid==MEM.USER._userNObj.nid) {
        id_af_link.innerHTML = "[view my ANNEfolio]";
    }
    else {
        id_af_link.innerHTML = "[view their ANNEfolio]";
    }

    var el_close = document.getElementById("id_view_close");
    el_close.addEventListener("click", e=>{
        ANNE.A.hide(el_id);
        if (ANX._ANNEfolio==null) {
            ANX.doANNEfolioView(NOBJ, helperObj);
        }

        //it was already showing in the back behind this element.
        else {

        }
    });
    //var posfix = "&nbsp;<span class='color-white'><b>"+UTILS.commas(_anneid.sponsored_neurons)+"</b>&nbsp;neurons</span>";
    ANNE.A.setHTML("annefolio_name", "<span class='color-white'>ANNEfolio</span>&nbsp;"+$nObj.bestNameHTML());

    ANNE.A.show("injected_div");
    ANNE.A.addRemoveClass("injected_div", "unBlurFadeIn", "blurFadeOut")

    ANX.travelToObj(helperObj.objSpawnPosition, helperObj.camPosition, function() {
        ANNE.A.show("btn_home_view");
    });
}


/**
 * User's profile.
 * @param {*} $clickObj 
 */
ANX.annfolio = async($clickObj)=> {
    if(ANX.bGETOURSTUFF1TIME==false) {
        await ANX.getOurStuffOneTime();
        ANX.bGETOURSTUFF1TIME=true;
    }
    await ANX.makeNewIdentityView(USER._userNObj);
}


/**
 * 
 * @param {*} $nObj 
 */
ANX.doANNEfolioView = async($nObj, $helperObj)=> {
    ANNE.A.hide("injected_div");
    ANNE.A.show("id_annefolio_filters");
    console.log("DO THE ANNEFOLIO VIEW");

    if (ANX._ANNEfolio!=null) {
        ANX._ANNEfolio.cleanup();
        ANX._ANNEfolio = null;
    }
    else if (ANX._REVELATIAN!=null) {
        ANX._REVELATIAN.cleanup();
        ANX._REVELATIAN = null;
    }

    //if we come ot our own identity view before we hit the annefolio...
    if ($nObj.nid==ANNE.USER._userNObj.nid && ANX.bGETOURSTUFF1TIME==false) {
        await ANX.getOurStuffOneTime();
        ANX.bGETOURSTUFF1TIME=true;
    }

    ANNE.A.play("inspire_space");

    ANX._ANNEfolio = new ANNEfolio(ANX, ANX.scene, ANX.camera, ANX.rendererCSS, $nObj, $helperObj, ANX.bEMULATE_DATA);
}


ANX.addAwarezBtn = function($target_nid, $target_reln, $extra_class="") {
    console.log("(addAwarezBtn)");
    var obj = {target_nid:$target_nid, target_reln:$target_reln};
    if ($extra_class!="") obj.extra_class = $extra_class;
    ANX.SOUV.addSouvenir(SOUV_AWARENESS, obj);
}

ANX.takeSnapshot = async($somevar="BLAH", $default_name="thumbnail.jpg", $extra_class="")=> {
    console.log("(takeSnapshot"); 
    ANX._snapRequest = {somevar:$somevar, dataUrl:null, default_name:$default_name};
    if ($extra_class!="") ANX._snapRequest.extra_class = $extra_class;
}

ANX.addNeuronAwarvuBtn = function($nObj, $prefName = "", $el="lh_content", $colorClass="green") {
    console.log("(addNeuronAwarvuBtn)");
    var obj = {nid:$nObj.nid, pref_name:$prefName, highlight:"awarvu", el:$el, colorClass:$colorClass};
    if ($extra_class!="") obj.extra_class = $extra_class;
    ANX.SOUV.addSouvenir(SOUV_NEURON, obj);
}
ANX.addNeuronAnnexBtn = function($nObj, $prefName = "", $el="lh_content", $colorClass="green", $extra_class="") {
    console.log("(addNeuronAnnexBtn)");
    var obj = {nid:$nObj.nid, pref_name:$prefName, highlight:"annex", el:$el, colorClass:$colorClass};
    if ($extra_class!="") obj.extra_class = $extra_class;
    ANX.SOUV.addSouvenir(SOUV_NEURON, obj);
}
ANX.addNeuronIdentityBtn = function($nObj, $prefName = "", $el="lh_content", $colorClass="green", $extra_class="") {
    console.log("(addNeuronIdentityBtn)");
    var obj = {nid:$nObj.nid, pref_name:$prefName, el:$el, colorClass:$colorClass};
    if ($extra_class!="") obj.extra_class = $extra_class;
    ANX.SOUV.addSouvenir(SOUV_IDENTITY, obj);
}
ANX.addSearchResultBtn = function($nObj, $prefName = "", $el="lh_content", $colorClass="green", $extra_class="") {
    console.log("(addSearchResultBtn)");
    var obj = {nid:$nObj.nid, pref_name:$prefName, el:$el, colorClass:$colorClass};
    if ($extra_class!="") obj.extra_class = $extra_class;
    ANX.SOUV.addSouvenir(SOUV_SEARCH, obj);
} 

ANX.addRevelatianBtn = function($nObj, $prefName = "", $el="lh_content", $colorClass="green", $extra_class="") {
    console.log("(addRevelatianBtn)");
    var obj = {nid:$nObj.nid, pref_name:$prefName, el:$el, colorClass:$colorClass};
    if ($extra_class!="") obj.extra_class = $extra_class;
    ANX.SOUV.addSouvenir(SOUV_SEARCH_REVELATIAN, obj);
} 




/**
 * A souvenir was added.
 * Handle it.
 * @param {*} $sObj 
 * @param {*} $type 
 */
ANX.addedSouvenir = async($sObj, $type)=> {
    if ($type==SOUV_AWARENESS) {
        var target_awarez_reln = $sObj.obj.target_reln;
        var nObj = MEMG.getNeuronByNid(target_awarez_reln);
        if (nObj.pol==undefined) {
            console.log("app sets .pol, must have .pol set.")
            return;
        }
        var el=document.createElement("button");
        el.classList = "aware-"+nObj.pol+"-btn";
        el.setAttribute("target_reln", target_awarez_reln);
        el.setAttribute("target_nid", nObj.nid);
    
        var span = document.createElement("span");
        span.innerHTML = nObj.text;
        el.appendChild(span);
        el.addEventListener("click", e=>{
            var clone = span.cloneNode(true);
            span.parentNode.append(clone);    //we will do float this thingy after clicked.
            clone.classList.add("fandf");
            clone.addEventListener('animationend', () => {
                clone.remove();
            });
        })
        var el_rholder = document.getElementById("right_holder");
        ANNE.A.showParent(el_rholder);
        el_rholder.append(el);
    }

    else if ($type==SOUV_SEARCH) {
        var el = $sObj.obj.el;
        var el_holder = document.getElementById(el);
        ANNE.A.showParent(el_holder);
        const souv_nid = $sObj.obj.nid;
        
        const nObj = MEMG.getNeuronByNid(souv_nid);
        var pref_name = $sObj.obj.pref_name;
        if (pref_name==undefined) pref_name="";

        var newel = null;
        
        //if identity, show identity view.
        if (MEM.isIdentityINST(nObj)==true) {
            newel = await ANNE.A.neuronIdentityDisplay(nObj, ANX.bEMULATE_DATA, pref_name);
            el_holder.prepend(newel);
            if ($sObj.obj.extra_class!=undefined) newel.classList.add($sObj.obj.extra_class);
            newel.addEventListener("click", async(e)=>{
                if (newel.parentNode.children.length==1) {
                    ANNE.A.hideParent(newel.parentNode);
                }
                newel.remove();
                await ANX.makeNewIdentityView(nObj);
            });
        }

        //show annex if annexable, otherwise just show awarevu (feelz/awarez)
        else {
            newel = await ANNE.A.neuronAplexDisplay(nObj, ANX.bEMULATE_DATA, pref_name, "green");
            el_holder.prepend(newel);
            if ($sObj.obj.extra_class!=undefined) newel.classList.add($sObj.obj.extra_class);
            var bANNEXABLE =  ANNEX.assessAnnexabiltyNoChase(nObj);
            var highlight = "";
            if (bANNEXABLE==true) highlight = "annex";
            else highlight="awarvu";
            newel.addEventListener("click", async(e)=>{
                var nObj = MEMG.getNeuronByNid(souv_nid);
                if (newel.parentNode.children.length==1) {
                    ANNE.A.hideParent(newel.parentNode);
                }
                newel.remove();
                ANX.makeNewNeuronView(nObj, highlight);
               
            });
        }
    }

    else if ($type==SOUV_SEARCH_REVELATIAN) {
        var el = $sObj.obj.el;
        var el_holder = document.getElementById(el);
        ANNE.A.showParent(el_holder);
        const souv_nid = $sObj.obj.nid;
        const nObj = MEMG.getNeuronByNid(souv_nid);
        var newel = await ANNE.A.neuronRevelatianDisplay(nObj);
        el_holder.prepend(newel);
        if ($sObj.obj.extra_class!=undefined) newel.classList.add($sObj.obj.extra_class);
        
        newel.addEventListener("click", async(e)=>{
            if (ANX._REVELATIAN!=null) {
                await ANX._REVELATIAN._action_addNetwork(nObj);
            }
            newel.remove();
            var el_lhc=document.getElementById("lh_content");
            if (el_lhc.children.length==0) {
                ANNE.A.hide("left_holder2");
            }
        });
    }

    //spawn an identity view
    else if ($type==SOUV_IDENTITY) {
        var el  = $sObj.obj.el;
        if (el==undefined) el = "right_holder"; //default;
        
        var el_holder = document.getElementById(el);
        ANNE.A.showParent(el_holder);

        const souv_nid = $sObj.obj.nid;

        const nObj = MEMG.getNeuronByNid(souv_nid);
        var pref_name = $sObj.obj.pref_name;
        if (pref_name==undefined) pref_name="";

        console.log("%c audit souv identity "+nObj.text+" nid:"+nObj.nid);
        var newel = await ANNE.A.neuronIdentityDisplay(nObj, ANX.bEMULATE_DATA, pref_name);
        el_holder.appendChild(newel);
        
        if ($sObj.obj.extra_class!=undefined) newel.classList.add($sObj.obj.extra_class);
    
        newel.addEventListener("click", async(e)=>{
            await ANX.makeNewIdentityView(nObj);
        });
    }

    else if ($type==SOUV_NEURON) {
        var el  =$sObj.obj.el;
        if (el==undefined) el = "right_holder"; //default;

        var el_holder = document.getElementById(el);
        ANNE.A.showParent(el_holder);
        const souv_nid = $sObj.obj.nid;

        var highlight = $sObj.obj.highlight;
        if (highlight==undefined) highlight = "awarvu";

        var nObj = MEMG.getNeuronByNid(souv_nid);
        var pref_name = $sObj.obj.pref_name;
        if (pref_name==undefined) pref_name="";

        var colorClass = $sObj.obj.colorClass;
        if (colorClass==undefined) colorClass="green";
        //console.log("sponsored by audit:"+nObj.sponsored_by);
        var newel = await ANNE.A.neuronAplexDisplay(nObj, ANX.bEMULATE_DATA, pref_name, colorClass);
        el_holder.appendChild(newel);

        if ($sObj.obj.extra_class!=undefined) newel.classList.add($sObj.obj.extra_class);

        newel.addEventListener("click", e=>{
            var nObj = MEMG.getNeuronByNid(souv_nid);
            ANX.makeNewNeuronView(nObj, highlight);
        })
    }

    else if ($type==SOUV_THUMBNAIL) {

        var el_holder = document.getElementById("right_holder");
        ANNE.A.showParent(el_holder);

        var elImg = document.createElement("img");
        elImg.setAttribute("width", 110);
        elImg.classList = "souvenir-snapshot";

        elImg.src = $sObj.obj.dataUrl;
        el_holder.append(elImg);
        //wipe?
        //var combinedCanvas = document.getElementById("combinedCanvas");

        elImg.addEventListener('click', () => {
            const link = document.createElement('a');
            link.href = $sObj.obj.dataUrl;
            link.download = $sObj.obj.default_name;
            link.click();
            link.remove();
            $sObj.obj.dataUrl = null;
            ANNE.A.removeSelf(elImg);
        });
    }
}



/**
 * moves and lerps the rotation of the camera to lookat our object.
 * note: if p1 is moving then this will be wrong!!!
 * We don't pass a ref to the obj, we pass its position.. so if that changes this will not be right.
 */
ANX.travelToObj=function($p1, $p2, $callback=null) {
    
    ANX.bTRAVELLING = true;

    var backupmlook = false;
    if (ANX.bMLOOKOK==true) backupmlook = true;

    ANX.bMLOOKOK=false;

    var las = new lookatSmooth(ANX.camera, null, $p2);
    las.startLookOnly(1, "none", 0, 1, null);
    var tween = gsap.to(ANX.camera.position, {
        x:$p2.x,
        y:$p2.y,
        z:$p2.z,
        ease:"power2.inOut",
        duration: 3,
        onUpdate:function() {
            if (tween.time()>1/3) {
                ANX.camera.lookAt($p1);
            }
        },
        onComplete:function() {
            ANX.bTRAVELLING = false;
            if (backupmlook==true) {
                ANX.bMLOOKOK=true;
            }
            if ($callback!=null) $callback();
        }
    })
}


/**
 * 
 */
ANX.travelHome = function() {
    ANX.switchViewCleanup();
    ANNE.A.hide("btn_home_view");
    ANNE.A.hide("id_annefolio_filters");
    
    ANNE.A.show("left_holder2");

    const THIS = this;

    //set the camera position and rotation back to home position.
    //(we may need to lerp rotation, look at that later)
    gsap.to(ANX.camera.position, {
        y:ANX.cameraHomePosition.y,
        x:ANX.cameraHomePosition.x,
        z:ANX.cameraHomePosition.z,
        duration:1,
        onComplete:function() {
            THIS.camera.updateProjectionMatrix();
        }
      });

    //rotate cam back
    gsap.to(ANX.camera.rotation, {
        y:ANX.cameraHomeRotation.y,
        x:ANX.cameraHomeRotation.x,
        z:ANX.cameraHomeRotation.z,
        duration:1,
        onComplete:function() {
            THIS.camera.updateProjectionMatrix();
        }
    });


    //have to zoom it back.
    gsap.to(ANX.camera, {
        zoom:ANX.cameraHomeZoom,
        duration:1,
        onComplete:function() {
            THIS.camera.updateProjectionMatrix();
            ANX.bMLOOKOK=true;
            //console.log("%c"+ANX.camera.position, TALK.bgblue);
            //console.log("%c"+ANX.camera.zoom, TALK.bgblue);
        }
    });


}


/**
 * one-time load.. we don't do this before the first animation..
 * we do it after it..  This will load IDB local mem of our relons/neurons
 * specific to us.
 * 
 * NOTE: technically, we could do this only when viewing our own ANNEfolio.
 */
ANX.getOurStuffOneTime = async()=> {            
    if (ANNE.isANNE(USER._userNObj.nid)==false) {
        await ANNE.API.getAllMyStuff(USER._userNObj.nid, true);
    }
}



/**
 * 
 */
ANX.placePlanes2x3x2 = function() {
    //console.log("placePlanes2x3x2");
    ANX.camera.position.z = 2000;
    ANX.camera.position.y = 100;
    ANX.camera.position.x = -400;
    gsap.to(ANX.camera.position, {
        x:0,
        y:0,
        z:1270,
        ease:"power2.in",   
        duration:3
    });

    this.bMLOOKOK=true;
    var pts = [];
    var Z = -200;
    var INCR = 400;
    var Ybump = -433;
    pts.push(new THREE.Vector3(-INCR/2, 2*INCR+Ybump, Z));
    pts.push(new THREE.Vector3(INCR/2, 2*INCR+Ybump, Z));
    pts.push(new THREE.Vector3(-INCR, INCR+Ybump, Z));
    pts.push(new THREE.Vector3(0, INCR+Ybump, Z));
    pts.push(new THREE.Vector3(INCR, INCR+Ybump, Z));
    pts.push(new THREE.Vector3(-INCR/2, 0+Ybump, Z));
    pts.push(new THREE.Vector3(INCR/2, 0+Ybump, Z));
    
    //a speherical ring around 0,0,0
    const super_radius = 3000;
    const radStep = (Math.PI * 2) / pts.length; 

    

    for (var p=0; p < pts.length; p++) {
        var hp  = new THREE.Vector3(pts[p].x, pts[p].y, pts[p].z);
        ANX._entryTileMeshes[p].helperObj.homePosition = hp;
        ANX._entryTileMeshes[p].helperObj.radStep=radStep;
        ANX._entryTileMeshes[p].radius=super_radius;

        gsap.to(ANX._entryTileMeshes[p].position, {
            x:pts[p].x,
            y:pts[p].y,
            z:pts[p].z,
            ease:"power2.in",   
            duration:3
        });
    }
}


/**
 * 
 * @param {*} $title 
 * @param {*} $cb 
 */
ANX.makePlaneClicker = function($title, $cb=null, $imgRef="", $camPos, $spawnPos) {
    const planeGeometry = new THREE.PlaneGeometry(333, 333);
    const planeMaterial = new THREE.MeshBasicMaterial({transparent:true, opacity:0, side:THREE.DoubleSide});
    const entryTile = new THREE.Mesh(planeGeometry, planeMaterial);
    entryTile.position.set((Math.random()-.5)*1500, (Math.random()-.5)*1500, -3000);
    entryTile.ATYPE=ENTRY_TILE;
    ANX._entryTileMeshes.push(entryTile);

    entryTile.helperObj = {camPosition:$camPos, objSpawnPosition:$spawnPos};

    const elClicker = document.createElement("div");
    elClicker.classList.add("tile");

    if ($imgRef!="") {
        const elImg = document.createElement("img");
        elImg.classList.add("tile-img");
        elImg.setAttribute("width", 180);
        elImg.src = $imgRef;
        elClicker.appendChild(elImg);
    }

    const elClickerTitle = document.createElement("div");
    elClickerTitle.classList.add("tile-title");
    elClickerTitle.innerHTML = $title;
    elClicker.appendChild(elClickerTitle);

    const tileCSSOBJ = new ANNE.CSS3DObject( elClicker );
    tileCSSOBJ.position.set( 0, 0, 0);

    entryTile.add(tileCSSOBJ);
    entryTile.tileCSSOBJ =tileCSSOBJ;
    entryTile.cb = $cb;
    tileCSSOBJ.cb = $cb;

    ANX.scene.add(entryTile);
    return entryTile;
}



/**
 * 
 */
ANX.animate = function() {
    //if(ANX.b3JSACTIVE==false) return; //don't bother.

    ANX.tick+=1;

    //animate through a tunnel.
    if (ANX._lastARING!=null && ANX._lastARING.bDOINGARINGTUNNEL==true && ANX._lastARING.ATunnel) {
        ANX._lastARING.ATunnel.tunnelTravel();
    }

    const thresholdDistance = 200;

    //ANX._lastARING is the awareness display.
    if (ANX._lastARING!=null) {
        for (var c = 0; c  < ANX._lastARING._lookatLbls.length; c++) {
            const css3DObject = ANX._lastARING._lookatLbls[c];
            const distance = css3DObject.parent.position.distanceTo(ANX.camera.position);
            if (distance > thresholdDistance) {
                ANNE.A.hide(css3DObject.element);
                continue;
            } 
            else {
                ANNE.A.show(css3DObject.element);
            }
            css3DObject.lookAt(ANX.camera.position);
        }
    }

    else if (ANX._lastTop20!=null && ANX._lastTop20.bDOINGMOTION==true) {
        for (var c = 0; c  < ANX._lastTop20._lookAts.length; c++) {
            const css3DObject = ANX._lastTop20._lookAts[c];
            css3DObject.lookAt(ANX.camera.position);
        }
    }

    else if (ANX._ANNEfolio!=null) {
        ANX.skyboxMesh.rotation.y+=.0001;
        ANX._ANNEfolio.animate();
    }
    
    else if (ANX._REVELATIAN!=null) {
        ANX.skyboxMesh.rotation.y+=.0001;
        ANX._REVELATIAN.animate();
    }

    const time = performance.now() * 0.001;
    ANX.animationID = requestAnimationFrame(ANX.animate);

    if (ANX._snapRequest!=null) {
        ANX.rendererCSS.preserveDrawingBuffer = true;
        ANX.renderer.preserveDrawingBuffer = true;
    }

    ANX.renderer.render(ANX.scene, ANX.camera);
    ANX.rendererCSS.render( ANX.scene, ANX.camera );
    
    
    //do snaps after we know we've rendered the scene.
    if (ANX._snapRequest!=null && ANX.bONETIME==false) {
        ANX.rendererCSS.preserveDrawingBuffer = false;
        ANX.renderer.preserveDrawingBuffer = false;
        ANX.bONETIME=true;
        ANX.finalsnap(ANX._snapRequest);
    }
}

ANX.stopAnimation=function() {
    cancelAnimationFrame(ANX.animationID);
    ANX.animationID = null;
}

ANX.restartAnimation=function() {
    ANX.animate();
}

/**
 * 
 * @returns 
 */
ANX.finalsnap=async()=>{
    if(ANX._snapRequest==null) return
    const combinedCanvas = document.getElementById("combinedCanvas");
    const ctx = combinedCanvas.getContext('2d');
    ctx.clearRect(0, 0, combinedCanvas.width, combinedCanvas.height);
    const jpegImg = new Image();
    const pngCssImg = new Image();
    jpegImg.src = ANX.renderer.domElement.toDataURL('image/jpeg');
    
    jpegImg.onload = function() {
        ctx.drawImage(jpegImg, 0, 0);
        
        htmlToImage.backgroundColor = "transparent";

        //this is erroring on snaps now for the cool stuff :(
        htmlToImage.toCanvas(ANX.rendererCSS.domElement).then(function (csscanvas) {
            pngCssImg.src = csscanvas.toDataURL('image/png');
            pngCssImg.onload = function() {
                ctx.drawImage(pngCssImg, 0, 0);
    
                //the combined jpeg with png overlay (as a jpeg)
                var finaldata = combinedCanvas.toDataURL('image/jpeg');
    
                ANX.SOUV.addSouvenir(SOUV_THUMBNAIL, {somevar:ANX._snapRequest.somevar, dataUrl:finaldata, default_name:ANX._snapRequest.default_name});
                ANX._snapRequest=null;
                ANX.rendererCSS.preserveDrawingBuffer = false;
                ANX.renderer.preserveDrawingBuffer = false;
                ANX.bONETIME=false;
            };
        }).catch(function ($e) {
            console.error('An error occurred during conversion:', $e);
            ANX._snapRequest=null;
            ANX.bONETIME=false;
        });
    }
}