var AQL = {};
AQL.conveyorMap = null;
AQL.quantifierMap = null;
AQL.ez_rezMap = null;


AQL.prepConveyor=function($str, $nid) {
    
}

//TODO -- do the LUKAT table results.
//Show a filter adder/editor
//to easily reduce the query-set further with similar cmds.
//ie, you get a list of american politicians.
//you filter for MUST be a participant of any WEF or bilderberg meeting.

//what this is actually doing is creating a new dataset.
//this data set can be stored in relons (the generation of it)
//and then put in ANNE to share with others.
//This is also the basis of a DIG --> to load a dataset neuron

AQL.init=function(){
    AQL.get = ANNE.MEMG.getOrMakeIfNew("7504671458621463772");

    AQL.conveyorMap = new arraymap();
    AQL.conveyorMap.setMapKey("wd");

    AQL.conveyorMap.addU({wd:"get", cmd:AQL.get.nid, reln:[]});
    AQL.conveyorMap.addU({wd:"show", cmd:AQL.get.nid, reln:[]});
    AQL.conveyorMap.addU({wd:"find", cmd:AQL.get.nid, reln:[]});
    AQL.conveyorMap.addU({wd:"retrieve", cmd:AQL.get.nid, reln:[]});
    AQL.conveyorMap.addU({wd:"query", cmd:AQL.get.nid, reln:[]});
    AQL.conveyorMap.addU({wd:"return", cmd:AQL.get.nid, reln:[]});
    AQL.conveyorMap.addU({wd:"born", cmd:null, reln:[ANNE.MEM.birthday.nid, ANNE.MEM.birthplace.nid]});
    AQL.conveyorMap.addU({wd:"died", cmd:null, reln:[ANNE.MEM.deathday.nid, ANNE.MEM.deathplace.nid]});
    AQL.conveyorMap.addU({wd:"elected", cmd:null, reln:[]});

    AQL.quantifierMap = new arraymap();
    AQL.quantifierMap.setMapKey("wd");
    AQL.quantifierMap.addU({wd:"all", q:"*"});
    AQL.quantifierMap.addU({wd:"any", q:"*"});
    

    AQL.ez_rezMap = new arraymap();
    AQL.ez_rezMap.setMapKey("wd");
    AQL.ez_rezMap.addU({wd:"people", type:TYPE_BE, be_nid:ANNE.MEM.person.nid, ntype:NTYPE_INST});
    AQL.ez_rezMap.addU({wd:"companies", type:TYPE_BE, be_nid:ANNE.MEM.company.nid, ntype:NTYPE_INST});
    AQL.ez_rezMap.addU({wd:"jew", type:TYPE_BE, be_nid:ANNE.MEM.person.nid, cdx:{type:TYPE_BE, reln:ANNE.MEM.tribal.nid, to_s:ANNE.MEM.jewish.nid}, ntype:NTYPE_INST});
    AQL.ez_rezMap.addU({wd:"jews", type:TYPE_BE, be_nid:ANNE.MEM.person.nid, cdx:{type:TYPE_BE, reln:ANNE.MEM.tribal.nid, to_s:ANNE.MEM.jewish.nid}, ntype:NTYPE_INST});
    AQL.ez_rezMap.addU({wd:"jewish", type:TYPE_BE, be_nid:ANNE.MEM.person.nid, cdx:{type:TYPE_BE, reln:ANNE.MEM.tribal.nid, to_s:ANNE.MEM.jewish.nid}, ntype:NTYPE_INST});
    AQL.ez_rezMap.addU({wd:"zionists", type:TYPE_BE, be_nid:ANNE.MEM.person.nid, cdx:{type:TYPE_BE, reln:ANNE.MEM.tribal.nid, to_s:ANNE.MEM.jewish.nid}, ntype:NTYPE_INST});
    
    //convert 21st century to a date range.

    //use role mappers for words->roles
    //AQL.role = ["where", "when", "before", "after", "between", "in", "who", "what"];
}

const AQP_UNK = 0;
const AQP_CONVEYOR = 1;
const AQP_QUANTIFIER = 2;
const AQP_CDX = 3;

class aq_part {
    constructor($wd, $w_index, $part_type=AQP_UNK) {
        this.str = $wd;
        this.w_index = $w_index;
        this.part_type=$part_type;
        
        //when parsing.. and figuring out what it is.
        this.nlp_wd = null;
    }

    setRezMapObj=function($obj) {
        this.rezMapObj=$obj;
    }
}

class anne_query_lang {
    constructor($str) {
        this.aql_string = $str;             //the string to parse
        this.wds = [];                      //array of strings

        this.conveyors = [];
        this.quantifier = null;
        this.conditions = [];

        //will send this to api.
        this.query_parts_to_process = [];   //aq_parts needed to process still.
        this.rel_cmds_for_query = [];       //processed ready cmds
        this._lastCmd = null;
        this._primary_thing_cmd = null;
    }


    /**
     * 
     * @returns 
     */
    executeAQL = async()=> {
        var resp = await ANNE.API.queryByRelonJSON(this.rel_cmds_for_query);
        var nids = [];
        for (var r=0; r < resp.length; r++) {
            if (nids.indexOf(resp[r].from_nid)==-1) nids.push(resp[r].from_nid);
        }
        return ANNE.MEMG.getNObjsFromList(nids);
    }



    /**
     * 
     * @param {*} $aql_string 
     * @param {*} $bPIPETOSEARCH 
     * @returns 
     */
    parseAQL = async($aql_string="", $bPIPETOSEARCH=true)=> {
        var str = $aql_string;
        if (str=="") str = this.aql_string;
        console.log("%cparseAQL%c"+str, ANNE.TALK.bgblue, ANNE.TALK.bggreen);
        
        var quotedPhrases = str.match(/'([^']+)'/g);
        var stringWithoutQuotes = str.replace(/'([^']+)'/g, '');
        var words = stringWithoutQuotes.match(/[^,\s]+/g);
        if (quotedPhrases!=null && quotedPhrases.length>0) {
            this.wds = words.concat(quotedPhrases.map(phrase => phrase.replace(/'/g, ''))); 
            this.highlights = quotedPhrases.map(phrase => phrase.replace(/'/g, ''));   
        }
        else this.wds = words;

        this.tokenize();

        if (this.query_parts_to_process.length) {
            this.resolveWords();
        }

        if (this.query_parts_to_process.length>0) {
            for (var q=0; q < this.query_parts_to_process.length; q++) {
                var wd = this.query_parts_to_process[q].str;
                ANNE.TALK.printf_console(_RED, " UNHANDLED QUERY WD ", _GREEN, " "+wd+" ");
            }
            return [];
        }

        else if (this.rel_cmds_for_query.length==0) {
            ANNE.TALK.printf_console(_RED, " NO QUERY CMDS EXTRACTED ");
            return [];
        }
        else {
            delete this.rel_cmds_for_query[this.rel_cmds_for_query.length-1].results_pool_name;
            var matches = await this.executeAQL();
            console.log("matches:"+matches.length);
            console.log(matches); //we can pipe to the search
            if ($bPIPETOSEARCH==true) {
                var misc = {matches:matches, title:"AQL: "+$aql_string, table_format:true};
                PAGES.openPage("lukat_search", null, null, null, misc);
            }
            else {
                return matches;
            }
        }
    }


    /**
     * 
     */
    tokenize=function() {
        for (var w=0; w < this.wds.length; w++) {
            var wd = this.wds[w].toLowerCase();
            var aqp = null;

            if (AQL.conveyorMap.contains(wd)==true) {
                aqp = new aq_part(wd, w, AQP_CONVEYOR);
                this.conveyors.push(aqp);
            }
            else if (AQL.quantifierMap.contains(wd)==true) {
                aqp = new aq_part(wd, w, AQP_QUANTIFIER);
                this.quantifier=aqp;
            }
            else if (AQL.ez_rezMap.contains(wd)==true) {
                var obj = AQL.ez_rezMap.get(wd);
                if (this._primary_thing_cmd!=null) {
                    if (this._primary_thing_cmd.to.val==obj.be_nid) {
                        ANNE.TALK.printf_console(_RED, " skipping word ", _GREEN, " "+wd+" ", _WHITE, " already covered in last word cmd.");
                        continue;
                    }
                }
                aqp = new aq_part(wd, w, AQP_CDX);
                aqp.setRezMapObj(obj);

                if (this.query_parts_to_process.length==0) {
                    this.__thingQuery_aqp(aqp);
                }
                else {
                    alert("think this through.")
                    this.__thingCondition_aqp(aqp);
                }
            }
            else {
                aqp = new aq_part(wd, w, AQP_UNK);
                this.query_parts_to_process.push(aqp);
            }
        }
    }


    resolveWords = async()=> {
        for (var p=0; p < this.query_parts_to_process.length; p++) {
            var aqp = this.query_parts_to_process[p];
            aqp.nlp_wd = nlp_wd.addWdBlank();
            aqp.nlp_wd.str = aqp.str;
            var nObjs = await ANNE.MEM.searchTextIndex(aqp.str, true, false);
            if (nObjs.length==0) {
                if (ANNE.BRAIN.NLP==null) {
                    ANNE.BRAIN.init();
                }
                ANNE.BRAIN.NLP.LC.LANG._nakedEndingsDetector(aqp.nlp_wd); 
                console.log(aqp.nlp_wd);
                if (aqp.nlp_wd.psbl_morphs.length) {
                    var biggest = aqp.nlp_wd.psbl_morphs[0];
                    if (biggest.plural==true) {
                        nObjs = await ANNE.MEM.searchTextIndex(biggest.str, true, false);
                        if (nObjs.length>0) {
                            aqp.used_morph = aqp.nlp_wd.psbl_morph[0];
                        }
                    }
                }
            }
            
            var nObj = null;
            if (nObjs.length==0) {
                return;
            }
            else if (nObjs.length==1) {
                nObj = nObjs[0];
            }
            else {
                nObj = this.pickBest(nObjs);
            }

            //how do i know what politicians are?
            //their primary be class and lateral be to politicians?
            //for any concepts we don't pre-handle with patterns, we must figure out here.
            //the best way to search for them.
            var obj = this.makeBestRezObj(nObj);
            aqp.setRezMapObj(obj);

            if (this.query_parts_to_process.length==0) {
                this.__thingQuery_aqp(aqp);
            }
            else {
                alert("RESOLVE WORDS. think this through beter.")
                this.__thingCondition_aqp(aqp);
            }

            console.log(aqp);
        }
        console.log("hmm");
    }


    /**
     * 
     * @param {*} $nObj 
     * @returns 
     */
    makeBestRezObj=function($nObj) {
        var cdx = {};
        var obj = {wd:$nObj.text, type:null, be_nid:null, ntype:null, cdx:cdx};
        var ntype = NTYPE_INST;

        if ($nObj.is(ANNE.MEM._GENERAL_PROP_CLASS)==true) {
            //this is likely for another class..
            //ie, politician = person  with lateral relationship
            //we can observe what we have in our system for politician.. what it  most often
            //is connected into.. and then search with that.
            //do a heuristic tally of relon TYPE and RELN..  if big on one RELN
            //use/set it (as the CDX).. otherwise, don't set RELN, only set TO and TYPE.
            
        }

        var be_nid = ANNE.MEM.person.nid;
        return {wd:$nObj.text, type:TYPE_BE, be_nid:be_nid, ntype:ntype, cdx:cdx};
    }


    /**
     * We could do IN-LINE disambuation to the text prompt.
     * Pop in some stuffs for the user to see, they click the item and we get the right nid..
     * in a nid disambuation in-line syntax (with comments too.. both get stripped by the parse)
     * @param {*} $nObjs 
     * @returns 
     */
    pickBest = function($nObjs) {
        return $nObjs[0];
    }



    /**
     * 
     * @param {*} $aqp 
     * @returns 
     */
    __thingQuery_aqp = function($aqp) {
        var rezMapObj = $aqp.rezMapObj;

        var thingNOBJ = ANNE.MEMG.getNeuronByNid(rezMapObj.be_nid);
        var ntypeNOBJ = null;
        
        if (rezMapObj.ntype==NTYPE_INST) ntypeNOBJ = ANNE.MEM.inst;
        else ntypeNOBJ = ANNE.MEM.class;

        //we do not presume a pool name here..
        //as this can just be our primary BE value 
        //and we can optimize using another value in the relon WITH the primary BE.
        var rcmd = {
            from:{val:"", op:""},
            reln:{val:ntypeNOBJ.nid, op:"="},
            to_type:TO_TYPE_ANNE,
            to:{val:thingNOBJ.nid, op:"="},
            pool_type:"match",
        }

        if (rezMapObj.type!=null) rcmd.type=rezMapObj.type;
        this.rel_cmds_for_query.push(rcmd);
        this._lastCmd = rcmd;
        this._primary_thing_cmd = rcmd;

        ANNE.TALK.printf_console(_YELLOW, " adding primary thing ", _GREEN, " "+$aqp.str+" ", _BLUE, ntypeNOBJ.text);

        if (rezMapObj.cdx!=undefined) {
            this.__thingCondition(rezMapObj.cdx.type, rezMapObj.cdx.reln, rezMapObj.cdx.to_s);
        }
        return rcmd;
    }



    /**
     * 
     * @param {*} $relType 
     * @param {*} $reln 
     * @returns 
     */
    __thingCondition = function($relType, $reln, $to_s) {
        if ($relType==undefined || $relType==null) return;
        if ($reln==undefined || $reln==null) return;
        if ($to_s==undefined || $to_s==null) return;
        
        var rcmd = 
        {
            from:{val:"", op:""},
            reln:{val:$reln, op:"="},
            to_type:TO_TYPE_ANNE,
            to:{val:$to_s, op:"="},
            pool_type:"match"
        };

        if ($relType!=null) rcmd.type=$relType;

        //var r = this.rel_cmds_for_query.length;
        //rcmd.use_results_from_pool = "r"+(r-1);
        //rcmd.results_pool_name="r"+(r);
        
        this.rel_cmds_for_query.push(rcmd);
        this._lastCmd = rcmd;
        return rcmd;
    }
}