const NLP_LEARN_NEWCONCEPT = 1;

class anne_nlp_parse {
    constructor($LC, $text){
        this.LC = $LC;
        this.str = $text;
        this.wdsObj = null;
        this.phrase_parts = [];
        this.phrase_parts_flat = [];    //all parts in linear order pre-process
        
        this.conveyor_part = null;   
        this.conveyor_role = null;
        this.conveyor_part_be = false;
        this.conveyor_part_has = false;

        this.aux_part = null;           //if the parse has an aux, we first store it here. (before clump)
        this.mode_part = null;          //if the parse has a mode, we first store it here. (before clump)

        this.has_aux = false;
        this.fph_psbl_actions = [];
        
        this.psbl_question=false;               //question signals encountered.
        this.question = false;                  //if a quesion symbol is confirmed.
        

        //we should include the parent EXPERIENCE for where this clump is being formed/made.
        //during a convo?  During a self-reflected moment?  While watching TV?
        //Remember, experiential mem is different than semantic mem.
        this.clump = new nlp_clump(this, $text);
        
        this.tenseNOBJ = null;  //set by setTense in neuron which calls setTense here

        this._open_ph = null;   //can use to handle parsing.

        this.top_index = -1;    //incriment for depth 1 phrases (top phrases)
    }

    
    /**
     * 
     */
    start=async()=>{
        //BRAIN.ctp.initStream();
    }

    /**
     * 
     * @param {*} $valueText 
     * @param {*} $roleNOBJ 
     * @param {*} $valueNOBJ 
     * @param {*} $phPart 
     * @param {*} $conf 
     * @param {*} $bNEW 
     * @returns 
     */
    addRole = function($valueText="", $roleNOBJ=null, $valueNOBJ=null, $phPart=null, $conf=.5, $bNEW=false) {
        console.log("add role from nlp parse");
        return this.clump.nlpRolesObj.addRole(this.clump, $valueText, $roleNOBJ, $valueNOBJ, $phPart, $conf, $bNEW);
    }


    //interal funct..
    newPhPartFlat = function($debug="", $isSigPart=false, $isModPart=false) {
        var fph = new nlp_phrase_flat_part();
        fph.debug = $debug;
        this.phrase_parts_flat.push(fph);
        if ($isSigPart==true) {
            fph.isSigPart=true;
        }
        if ($isModPart==true) fph.isModPart=true;
        return fph;
    }

    setTense = function($tenseNOBJ) {
        this.tenseNOBJ = $tenseNOBJ;
    }

    handleQuestion=function() {
        
    }
    handleStatement=function(){
        
    }



    /**
     *  We only make mode at level 1
     *  If we are in a nested clause with another modal
     *  we need to handle it in its own nlpParse.
     *  ie, "the woman [[THAT] might go to the store] is coming to my house later tonight".
     *  These are always nested context and should first be identified as such.
     *  They can be handled as a condition after the general statement structure is understood.
     */
    makeMode=function($open_ph, $flat_ph) {
        var open_ph = $open_ph;
        
        //keep it open and add in any adverbs or the main vb.
        if ($open_ph.parts.length>0) {
            open_ph = open_ph.closePh();
            while(open_ph.depth>0) {
                open_ph = open_ph.closePh();
            }
            var mode_ph = open_ph.addFlatToPh(this, $flat_ph);     //add the signal to the new phrase (it has only the signal)
            mode_ph.is_mode = true;
        }
        else {
            while(open_ph.depth>0) {
                open_ph=open_ph.closePh();
            }
            if (open_ph.pre_open==false) {
                var mode_ph = open_ph.addFlatToPh(this, $flat_ph);     //add the signal to the new phrase (it has only the signal)
                mode_ph.is_mode=true;
            }
    
            //ph is already open and ready (leading manner preceeding this.. etc)
            else {
                open_ph = $open_ph;
                while(open_ph.depth>0) {
                    open_ph=open_ph.closePh();
                }
                var mode_ph = $open_ph.addFlatToPh(this, $flat_ph);
                mode_ph.is_mode=true;
            }
        }

        $nlpP.mode_part = open_ph;
        return open_ph.closePh();//close the mode 
    }
    
    
    /**
     * 
     * @param {*} $open_ph 
     * @param {*} $flat_ph 
     * @returns 
     */
    makeAction=function($open_ph, $flat_ph) {
        var open_ph = null;
        
        if ($open_ph.depth==1 && this.conveyor_part!=null && this.conveyor_part.can_be_aux==true) {
            //we want to move the prev vb to aux position.
            var aux_flat = this.conveyor_part.flat_ph;
            this.conveyor_part.is_conveyor = true;
            this.conveyor_part.flat_ph = null;
            aux_flat.is_aux = true;
            var convpart = this.conveyor_part.addFlatToPh(this, $flat_ph);//add the real vb.
            convpart.is_conveyor = true;
            this.conveyor_part.makeChildMod(this, aux_flat)
            
            open_ph = this.conveyor_part.closePh();

            //we had a be/has conveyor before but now it is just the aux
            this.conveyor_part_be = false;

            //has will make a TYPE_HAS relon (if possible)
            //if clump is needed it will make a clump and point to it from the FROM with a TYPE_HAS
            this.conveyor_part_has = false;  
            
            return open_ph;
        }

        //straight-away vb, no preceeding false alarm aux
        var conveyor_part = $open_ph.addFlatToPh(this, $flat_ph);
        if ($open_ph.depth<=1) {
            this.conveyor_part = conveyor_part;
            $open_ph.is_conveyor = true;
        }
        open_ph = $open_ph.closePh();
        open_ph = open_ph.makeChildPartOfCurrentPh(this);    //future phrase
        open_ph.pre_open=true;
        return open_ph;
    }

    
    /**
     */
    makeManner = function($open_ph, $flat_ph) {
        var open_ph = $open_ph;
        
        //if we aren't in an existing manner phrase...
        //close the phrase.  (only relevant for multiple manners to keep tacking them on)
        while(open_ph.depth>0 && open_ph.is_manner==false) {
            open_ph = open_ph.closePh();
        }
        
        open_ph = open_ph.makeChildPartOfCurrentPh(this);
        var manner_ph = open_ph.addFlatToPh(this, $flat_ph);
        manner_ph.is_manner=true;
        open_ph.is_manner=true;
        //KEEP MANNER open in case of 
        //open_ph = open_ph.closePh();
        //open_ph = open_ph.makeChildPartOfCurrentPh();    //future phrase
        //open_ph.pre_open=true;
        return open_ph;
    }

    
    /**
     * 
     * @param {*} $open_ph 
     * @param {*} $flat_ph 
     * @returns 
     */
    closePhAndMakeAction=function($open_ph, $flat_ph) {
        var open_ph = $open_ph;

        if (this.conveyor_part==null) {
            while(open_ph.depth>0 && open_ph.is_conveyor==false) {
                open_ph = open_ph.closePh();  
            }
        }

        if (this.conveyor_part!=null && this.conveyor_part.can_be_aux==true) {
            //we want to move the prev vb to aux position.
            return this._setVbMoveExistingToAux($flat_ph);//do we want to closePh
        }

        //just add the main vb.
        else {
            this.conveyor_part = open_ph.addFlatToPh(this, $flat_ph);    //new vb part within the top lvl
            this.clump.addedMainVbPh(this.conveyor_part);
            open_ph = open_ph.makeChildPartOfCurrentPh(this);    //future phrase
            open_ph.pre_open = true;
            return open_ph;
        }
    }
    

    /**
     * Accept a new vb and move the vb to the aux slot.
     * A previous is/was/were/has/had/have has been confirmed to be an aux vb, not the real vb.
     * @returns 
     */
    _setVbMoveExistingToAux=function($flat_ph) {
        var aux_flat = this.conveyor_part.flat_ph;//the prev vb, but now aux
        var open_ph = this.conveyor_part;
        open_ph.is_conveyor = true;
        this.conveyor_part = open_ph.addFlatToPh(this, $flat_ph);  //add the real vb part.
        this.clump.addedMainVbPh(this.conveyor_part);                 //document this in the clump.
        open_ph.makeAux(this, aux_flat);             //make the aux part
        return open_ph;
    }

        

    /**
     * in flat parse we don't know nesting of phrases yet.
     * an embedded clause with its own vb can look like the main vb at this stage.
     */
    setPsblFlatAction=function($fph){
        this.fph_psbl_actions.push($fph);
    }


    printRoles=function() {
        this.clump.printRoles();
    }
    


}



//DEPRECATED METHOD, BUT USE AS A RESOURCE.

/**
 * note:  if in dialogue mode and a sentence comes through w/ too many unknowns..
 * save the text of the sentences..
 * dive in to clarify mode..
 * then reparse the sentence
 */
class anne_nlp {
    constructor ($BRAIN, $SOA) {
        this.BRAIN = $BRAIN;
        this.SOA = $SOA;
        this.tests = [];
        this.LC = null;
        this._lastTokenObj = null;
        this._standards = [];   //standard roles any clump can take. (set in init)
        this._chars = [];       //single chars map (all valid single chars)
        
        //used in parsing  (doesn't matter what it is as long as it is unique)
        this.next_id=0;
    }

    init = async($initLang="EN")=> {
        var keys = Object.keys(ANNE.MEM.ASCII);  //loaded mod from pk and pk2 and ascii neurons
        for (var k=0; k < keys.length; k++) {
            var key = keys[k];
            if (key=="name" || key=="status") continue;
            var ascii_nObj = MEM.ASCII[key];
            var charCode = parseInt(ascii_nObj.pk_val);
            var ascii_quick_obj = new nlp_char(ascii_nObj.pk2_val, charCode, ascii_nObj);
            this._chars[ascii_nObj.charCode] = ascii_quick_obj; 
        }


        this.LC = new language_circuit(this, $initLang);
        await this.LC.init();
        //this.tests = ["bob received present from suzy."];
        //this.tests = ["suzy gave bob presents."];
        //this.tests = ["suzy gave presents to bob."];
        //this.tests = ["Astronauts Bruce McCandless II and Robert L. Stewart make the first untethered space walk."];
        //this.tests = ["February 8 – 19, 1984 – The 1984 Winter Olympics are held in Sarajevo, Yugoslavia."];
        //this.tests = ["February 13, 1984 – Konstantin Chernenko succeeds the late Yuri Andropov as General Secretary of the Communist Party of the Soviet Union."];
        //this.tests.push("February 23, 1984 - TED (conference) founded.");
        //this.tests.push("TED (conference) founded on February 23, 1984");
        //this.tests.push("On February 29, Pierre Trudeau announced his retirement.");
        //this.tests.push("February 29 - Canadian prime minister, Pierre Trudeau, announces his retirement.");
        //this.tests.push("What is the capital of the United States of America?");
        this.tests.push("Joe Biden is the President of the USA.");
        this.tests.push("United States of America was founded on July 6, 1776.");
        this.tests.push("The founding of the United States of America was July 6, 1776.");
        this.tests.push("A dog is an animal.");
        this.tests.push("Elon Musk founded the Boring Company on December 17, 2016.");
        this.tests.push("Steve Davis is the president of the Boring Company.");
        this.tests.push("The Boring Company is headquartered in Pflugerville, Texas, USA.");
        this.tests.push("The headquarters of the Boring Company is Pflugerville, Texas, USA.");
        //fixes (to put in node)

        //may not need need these, relook.
        /* this._standards=[
            MEM.role_action.temp_nid, 
            MEM.role_manner.temp_nid, 
            MEM.role_actor.temp_nid, 
            MEM.role_actor_mod.temp_nid, 
            MEM.role_tense.temp_nid,
            MEM.role_when.temp_nid, 
            MEM.role_when_mod.temp_nid, 
            MEM.role_where.temp_nid, 
            MEM.role_when_mod.temp_nid
        ]; */

    }


    _getCharByCode=function($code) {
        if (this._chars[$code]!=undefined) return this._chars[$code];
        return null;
    }



    /**
     * 
     * @returns 
     */
    chaseClassNid = function() {
        return this._lastTokenObj.chaseClassNid;
    }



    
    /**
     */
    processWinner = function() {
        console.log(this._lastTokenObj);
        var winnerClump = null;
        var highScore = 0;

        for (var c=0; c < this._lastTokenObj.conceptualized_clumps.length; c++) {
            var cclump = this._lastTokenObj.conceptualized_clumps[c];
            console.log("clump #"+(c+1), cclump);
            cclump.calcConfidence();
            
            if (cclump.psbl_question==true) {
                if (cclump.psbl_question_confirmed==true) {
                    console.log("%c QUESTION DECTION CONFIRMED",TALK.bgblackyellow);
                }
                else {
                    console.log("%c QUESTION DECTECTED, %cUNCONFIRMED",TALK.bgblackyellow, TALK.bgblackred);
                }
            }

            if (cclump.tense!=null){
                console.log("%c"+cclump.clump_type+"%c"+cclump.tense.text, TALK.bgpurple, TALK.bgpink);
            }
            else {
            }
            for (var p=0; p < cclump.phrases.length; p++) {
                var ph = cclump.phrases[p];
                if (ph.redundant==true) continue;
                this.__printPhStatus(ph);
            }

            if (cclump.conf>highScore) {
                highScore=cclump.conf;
                winnerClump=cclump;
            }
            console.log("___________________________________________________", "\n");
        }

        ANNE.BRAIN.ctp.ph_ecpool.printPool();          // wds + ec_concepts
        ANNE.BRAIN.ctp.roles_ecpool.printPool();        // roles + ec_concepts

        //put this in the context pool for NLP processing if we dont have target_role_only set.
        //we will have far more ways to robusting handling modality/intent of NLP later.
        if (winnerClump!=null && this._lastTokenObj.target_role_only==null) {
            ANNE.BRAIN.nlpClumpIn(cclump);
        }

        return winnerClump;
    }


    /**
     */
    __printPhStatus = function($ph) {
        if ($ph.handled) {
            var ric_msg = "";
            var rtr = null;
            var printable = 0;
            if ($ph.is_context==true) return;   //the parent role will print this.
            for (var r=0; r < $ph.conceptualized_to_roles.length; r++) {
                rtr = $ph.conceptualized_to_roles[r];
                if (rtr.mod_role==true) {
                    if (rtr.mod_parent!=null) {
                        rtr = null;
                        continue; //we will print this on its parent role.
                    }
                    break;
                }
                else printable+=1;
            }
            if (printable==0) return;
            console.log(rtr);
            if (rtr==null) {
                console.log("% mod role printing issue for phrase %c"+$ph.phrase, TALK.bgred, TALK.green);
                return;
            }
            var rezcss = "";
            var text = "";
            if (rtr.needs_ric==false) {
                if (rtr.new==true) {
                    ric_msg="**new concept**";
                    rezcss=TALK.bgblackyellow;
                }
                else {
                    ric_msg="**context resolved**";
                    rezcss=TALK.bgfire;
                }
            }
            else {
                if (rtr.new==true) {
                    ric_msg="**new concept**";
                    rezcss=TALK.bgblackyellow;
                }
                else {
                    ric_msg="**needs context resolution**";
                    rezcss=TALK.bgblackyellow;
                }
            }

            //no mods
            if (rtr.mods.length==0) { 
                console.log("%c'"+$ph.phrase+"' %c conceptualized to %c["+rtr.role_text+"] %c"+rtr.text+" %c"+ric_msg, TALK.green, TALK.bgblack, TALK.bgblue, TALK.bggreen, rezcss);
            }

            //has mods.
            else {                         
                console.log("%c'"+$ph.phrase+"' %c[has mods] %cconceptualized to %c["+rtr.role_text+"] %c"+rtr.ph.leftover+" %c"+ric_msg, TALK.green, TALK.bggreen, TALK.bgblack, TALK.bgblue, TALK.bggreen, rezcss);
                for (var m=0; m < rtr.mods.length; m++) {
                    var modrole=rtr.mods[m];
                    var nr = false;
                    if (modrole.new==true) {
                        console.log("|___%c mod %c["+modrole.role_text+"] %c (new neuron) '"+modrole.text+"'", TALK.bgblack, TALK.bgblackyellow, TALK.green);
                    }
                    else if (modrole.needs_ric==true) {
                        console.log("|___%c mod %c["+modrole.role_text+"] (needs context rez) %c'"+modrole.text+"'", TALK.bgblack, TALK.bgred, TALK.green);
                    }
                    else {
                        console.log("|___%c mod %c["+modrole.role_text+"] %c'"+modrole.text+"'%c resolved to %c"+modrole.nObj.text, TALK.bgblack, TALK.bgblue, TALK.black, TALK.green, TALK.bggreen);
                    }
                }    
            }
        }
        else {
            console.log("%c'"+$ph.phrase+"' %cUNCONCEPTUALIZED", TALK.green, TALK.bgred);
            console.log($ph);
        }  
    }


    /**
     * Is this nObj a prefix?
     */
    _isPrefix = function($nObj) {
        return MEMG.besOf($nObj, MEM.LC_prefix.temp_nid);//any lang
    }


    /**
     * Is this nObj a suffix?
     */
    _isSuffix = function($nObj) {
        return MEMG.besOf($nObj, MEM.LC_suffix.temp_nid);//any lang
    }


    __getFirstRealWd = function($wds) {
        for (var w=0; w < $wds.length; w++) { if ($wds[w].type=="wd") return $wds[w];}
        return null;
    }


    /**
     */
    static _sortMatchObjByFire=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null || $a.fire==undefined || $b.fire==undefined) return 0;
        if ($a.fire > $b.fire) return -1;
        if ($a.fire < $b.fire) return 1;
        return 0;
    }
    static _sortMatchObjByHits=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null || $a.hits==undefined || $b.hits==undefined) return 0;
        if ($a.hits > $b.hits) return -1;
        if ($a.hits < $b.hits) return 1;
        return 0;
    }
    static _sortMatchObjByWeight=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null || $a.weight==undefined || $b.weight==undefined) return 0;
        if ($a.weight > $b.weight) return -1;
        if ($a.weight < $b.weight) return 1;
    }
    
    static _sortByLastCIAndHits=function($a,$b) {
        if ($a==undefined || $a==null 
                || $b==undefined || $b==null 
                || $a.fire==undefined || $b.fire==undefined
                || $a.last_ci==undefined || $b.last_ci==undefined
                ) return 0;
        
        
        if ($a.last_ci > $b.last_ci) return -1;
        if ($a.last_ci < $b.last_ci) return 1;
        
        //if tied..
        if ($a.fire > $b.fire) return -1;
        if ($a.fire < $b.fire) return 1;

        return 0;
    }
}



class nlp_roles {
    constructor($clump) {
        this._roles = [];
        this._clump = $clump;
    }

    
    setRoleFlags=function($nlpP, $clump) {
        for (var r=0; r < this._roles.length; r++) {
            var role = this._roles[r];
            if (role.ph==null) continue;
            if (role.ph.index < $nlpP.conveyor_part.index) role.subj=true;
            else role.pred=true;

            if (role.ph.sig_parts.length) {
                for (var s=0; s < role.ph.sig_parts.length; s++) {
                    var sig_part = role.ph.sig_parts[s];
                    if (sig_part.has_indef==true) {
                        role.indef = true;
                        role.needs_ric = false; //we don't need to resolve this.
                    }
                }
            }
        }
    }
    
    
    /**
     * make the action, tense, and aux roles, if necessary.
     * the conveyor should ALWAYS BE STORED IN PRESENT TENSE.
     * @param {nlp_phrase_flat_part} $conveyorPart 
     * @param {anne_neuron} $conveyorNOBJ 
     * @param {String} $tense 
     * @param {nlp_phrase_flat_part} $mode_part 
     */
    makeConveyor=function($nlpP, $conveyorPart, $conveyorNOBJ, $modePart=null) {

        //add the conveyor.
        $conveyorPart.role = this.addRole($nlpP.clump, $conveyorNOBJ.text, MEM.role_action, $conveyorNOBJ, $conveyorPart, 1, false);
        $conveyorPart.role.needs_ric = false;
        $conveyorPart.role.nObj = $conveyorNOBJ;
        
        //add a tense role.
        if ($nlpP.tenseNOBJ!=null && $nlpP.tenseNOBJ.temp_nid!=MEM.tense_present.temp_nid) {
            $conveyorPart.role_tense = this.addRole($nlpP.clump, $nlpP.tenseNOBJ.text, MEM.role_tense, $nlpP.tenseNOBJ, null, 1, false);
        }

        if ($modePart!=null) {
            //todo.
            console.log("TO DO MODE PART");
        }

        $nlpP.clump.conveyor_role = $conveyorPart.role;
        $nlpP.conveyor_role = $conveyorPart.role;

        $conveyorPart.needs_ric = false;//no resolution in context for a conveyor is needed.
    }


    /**
     */
    printRoles = function() {
        for (var r=0; r < this._roles.length; r++) {
            var role = this._roles[r];
            role.printRole();
            console.log(role);
        }   
    }
    
    
    /**
     * @param {nlp_clump}
     * @param {string}
     * @param {anne_neuron}
     * @param {anne_neuron}
     * @param {nlp_phrase}
     * @param {number}
     * @param {boolean}
     */
    addRole = function($clump, $valueText="", $roleNOBJ=null, $valueNOBJ=null, $phPart=null, $conf=.5, $bNEW=false) {
        if (($roleNOBJ instanceof anne_neuron) == false) {
            console.throw("error! roleNOBJ must be a neuron");
            console.log("%c BAD PARAM", TALK.bgerror);
            return;
        }
        if ($valueNOBJ!=null && ($valueNOBJ instanceof anne_neuron) == false) {
            console.throw("error! valueNOBJ must be a neuron");
            console.log("%c BAD PARAM", TALK.bgerror);
            return;
        }

        $valueText = $valueText.trim();
        
        var role = new nlp_role(this._clump, $valueText, $roleNOBJ, $valueNOBJ, $phPart, $conf, $bNEW);
        
        if (this[$roleNOBJ.temp_nid]==undefined) this[$roleNOBJ.temp_nid]=[];
        
        this[$roleNOBJ.temp_nid].push(role);  
        this._roles.push(role);  //ez print single array.

        if ($clump.default_roles[$roleNOBJ.temp_nid]!=undefined) $clump.default_roles[$roleNOBJ.temp_nid].found=true;

        //document things cnt
        if ($roleNOBJ.is(MEM.role_thing)==true) $clump.thing_cnt+=1;
        
        //TODO new concept during parse time may get a better parent via resolution time.
        role.printRole();
        return role;
    }
    

    /**
     * @param {nlp_role}
     * @param {string}
     * @param {anne_neuron}
     * @param {anne_neuron}
     * @param {nlp_ph}
     * @param {number}
     * @param {boolean}
     */
    addModRole = function($role, $valueText="", $roleNOBJ=null, $valueNOBJ=null, $ph=null, $conf=.5, $bNEW=false) {
        if (($roleNOBJ instanceof anne_neuron) == false) {
            console.throw("error! roleNOBJ must be a neuron");
            console.log("%c BAD PARAM", TALK.bgerror);
            return;
        }
        if (($valueNOBJ instanceof anne_neuron) == false) {
            console.throw("error! valueNOBJ must be a neuron");
            console.log("%c BAD PARAM", TALK.bgerror);
            return;
        }      
        var role = new nlp_role(this.clump, $valueText, $roleNOBJ, $valueNOBJ, $ph, $conf, $bNEW);
        if ($role!=undefined && $role!=null) $role.mods.push(role);
        role.mod_role=true;
        role.mod_parent = $role;
        
        //we need to enact the nestedhex
        
        return role;
    }




    static getModRole=function($nObj) {
        if ($nObj.temp_nid==MEM.role_actor.temp_nid) return MEM.role_actor_mod;
        else if ($nObj.temp_nid==MEM.role_affected_thing.temp_nid) return MEM.role_affected_thing_mod;
        else if ($nObj.temp_nid==MEM.role_be_thing.temp_nid) return MEM.role_be_thing_mod;
        else if ($nObj.temp_nid==MEM.role_posn_thing.temp_nid) return MEM.role_posn_thing_mod;
        else if ($nObj.temp_nid==MEM.role_instrument.temp_nid) return MEM.role_instrument_mod;
        else return null;
    }

    static getTopMatchRoleFromRole=function($role_temp_nid) {
        if ($role_temp_nid==MEM.role_manner.temp_nid) return MEM.role_manner.temp_nid;
        else if ($role_temp_nid==MEM.role_action_thing.temp_nid) return MEM.role_thing.temp_nid;
        else if ($role_temp_nid==MEM.role_thing.temp_nid) return MEM.role_thing.temp_nid;
        else if ($role_temp_nid==MEM.role_actor.temp_nid) MEM.role_thing.temp_nid;
        else if ($role_temp_nid==MEM.role_affected_thing.temp_nid) return MEM.role_thing.temp_nid;
        else if ($role_temp_nid==MEM.role_posn_thing.temp_nid) return MEM.role_thing.temp_nid;
        else if ($role_temp_nid==MEM.role_be_thing.temp_nid) return MEM.role_thing.temp_nid;
        else if ($role_temp_nid==MEM.role_action.temp_nid) return MEM.role_action.temp_nid;
        else if ($role_temp_nid==MEM.role_state.temp_nid) return MEM.role_state.temp_nid;
        else if ($role_temp_nid==MEM.role_when.temp_nid) return MEM.role_thing.temp_nid;
        else if ($role_temp_nid==MEM.role_where.temp_nid) return MEM.role_thing.temp_nid;
        else if ($role_temp_nid==MEM.role_theme_thing.temp_nid) return MEM.role_thing.temp_nid;
        else if ($role_temp_nid==MEM.role_connector.temp_nid) return MEM.role_connector.temp_nid;
        else if ($role_temp_nid==MEM.role_mode.temp_nid) return MEM.role_mode.temp_nid;
        else if ($role_temp_nid==MEM.role_aux_action.temp_nid) return MEM.role_aux_action.temp_nid;
        else if ($role_temp_nid==MEM.role_thing_mod.temp_nid) return MEM.role_thing_mod.temp_nid;
        else {
            var nOBJ = MEMG.getNeuronByTempNid($role_temp_nid);
            console.log("%c unhandled (getTopMatchRoleFromRole) %c "+nOBJ.text, TALK.bgred, TALK.green);
            return $role_temp_nid;
        }
    }

    //these roles are intermediate roles for our conceptualization.
    //we want to first get the statement into 
    //ROLE_THING, ROLE_MANNER, ROLE_ACTION, ROLE_MODE, ROLE_ACTION_AUX,
    //ROLE_WHEN, ROLE_WHERE, ROLE_STATE

    //wds are made with top parents of thing/manner/action/expect_action/mode/is/posn

    //NOTE: signals won't use this. They have their expected/psbl roles already specified in the LC load.
    static getRoleFromECTop=function($ec_temp_nid) {
        if ($ec_temp_nid==MEM.ec_thing.temp_nid) return MEM.role_thing.temp_nid;
        else if ($ec_temp_nid==MEM.ec_action.temp_nid) return MEM.role_action.temp_nid;
        else if ($ec_temp_nid==MEM.ec_manner.temp_nid) return MEM.role_manner.temp_nid;
        else if ($ec_temp_nid==MEM.ec_state.temp_nid) return MEM.role_state.temp_nid;
        else if ($ec_temp_nid==MEM.ec_posn.temp_nid) return MEM.role_action.temp_nid;
        else if ($ec_temp_nid==MEM.ec_is.temp_nid) return MEM.role_action.temp_nid;
        else if ($ec_temp_nid==MEM.ec_mode.temp_nid) return MEM.role_mode.temp_nid;
        
        else if ($ec_temp_nid==MEM.ec_expect_when.temp_nid) return MEM.role_when.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_where.temp_nid) return MEM.role_where.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_more_of_prev.temp_nid) return MEM.role_connector.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_actionthing.temp_nid) return MEM.role_thing.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_action.temp_nid) return MEM.role_aux_action.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_question.temp_nid) return  MEM.role_question.temp_nid;
        
        //thing role mods are intermediate conceptualized into thing mod
        //test "of the USA"
        else if ($ec_temp_nid==MEM.ec_expect_thing_mod.temp_nid) return MEM.role_thing_mod.temp_nid;
        
        //can't get role from this alone.  Not enough info.
        else if ($ec_temp_nid==MEM.ec_expection.temp_nid) return null;
        else if ($ec_temp_nid==MEM.ec_resolve.temp_nid) return null;

        else if ($ec_temp_nid==MEM.integer.temp_nid) return MEM.role_thing_mod.temp_nid;
        
        else {
            var nOBJ = MEMG.getNeuronByTempNid($ec_temp_nid);
            console.log("%c unhandled (getECTopFromRoleEC) %c "+nOBJ.text, TALK.bgred, TALK.green);
        }
    }


    /**
     * This is for inner phrase handling..
     * We can have a role of WHERE but still need to match a thing inside that phrase.
     * ec_posn and ec_is are conceptualized as R_ACTION on their first pass.. 
     * this is the verb... They can potentially convert into lessor clumps.
     * eg,  "the dog is red" is just a TYPE_HAS->color->red on the dog.
     * TYPE_HAS is not possessive in ANNE, it is an attribute.  TYPE_BE is for class-defining
     * BE relationships.  bob is a programmer = TYPE_BE bob->[is/be/job/career]->programmer
     */
    static getPhRoleForMatchesFromECTop=function($ec_temp_nid) {
        if ($ec_temp_nid==MEM.ec_thing.temp_nid) return MEM.role_thing.temp_nid;
        else if ($ec_temp_nid==MEM.ec_action.temp_nid) return MEM.role_action.temp_nid;
        else if ($ec_temp_nid==MEM.ec_manner.temp_nid) return MEM.role_manner.temp_nid;
        else if ($ec_temp_nid==MEM.ec_state.temp_nid) return MEM.role_state.temp_nid;
        else if ($ec_temp_nid==MEM.ec_posn.temp_nid) return MEM.role_action.temp_nid;
        else if ($ec_temp_nid==MEM.ec_is.temp_nid) return MEM.role_action.temp_nid;
        else if ($ec_temp_nid==MEM.ec_mode.temp_nid) return MEM.role_mode.temp_nid;
        else if ($ec_temp_nid==MEM.integer.temp_nid) return MEM.role_thing_mod.temp_nid;
        
        else if ($ec_temp_nid==MEM.ec_expect_when.temp_nid) return MEM.role_thing.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_where.temp_nid) return MEM.role_thing.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_more_of_prev.temp_nid) return MEM.role_connector.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_actionthing.temp_nid) return MEM.role_thing.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_action.temp_nid) return MEM.role_aux_action.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_thing_mod.temp_nid) return MEM.role_thing_mod.temp_nid;
        else if ($ec_temp_nid==MEM.ec_expect_question.temp_nid) return  MEM.role_question.temp_nid;
       
        //can't get role from this alone.  Not enough info.
        else if ($ec_temp_nid==MEM.ec_expection.temp_nid) return null;
        else if ($ec_temp_nid==MEM.ec_resolve.temp_nid) return null;
        
        else {
            var nOBJ = MEMG.getNeuronByTempNid($ec_temp_nid);
            console.log("%c unhandled (getPhRoleForMatchesFromECTop) %c "+nOBJ.text, TALK.bgred, TALK.green);
        }
    }

}

class nlp_role {

    /**
     * @param {nlp_clump} - the clump this is apart of
     * @param {string} - text of the role value
     * @param {anne_neuron} - neuron of the role reln (ie, mem.role_action)
     * @param {anne_neuron} - value of role
     * @param {nlp_phrase}  - phrase object
     * @param {Number} - confidence of role assignement
     * @param {Boolean} - new if unknown, not new if known
     */ 
    constructor ($clump, $text="", $roleNOBJ=null, $valueNOBJ=null, $ph=null, $conf=.5, $bNEW=false) {
        this.clump = $clump;
        this.text = $text;      //the text of the value of the role (text of nObj, if not new)
        if (typeof $text !=="string") {
            console.log("%c (nlp_role) constructor, pass in a string, silly willy", TALK.bgerror);
            if ($text.text!=undefined) $text =  $text.text;
        }
        if ($roleNOBJ!=null && ($roleNOBJ instanceof anne_neuron) == false) {
            console.throw("error! roleNOBJ must be a neuron");
            console.log("%c BAD PARAM", TALK.bgerror);
            return;
        }  
        if ($valueNOBJ!=null && ($valueNOBJ instanceof anne_neuron) == false) {
            console.throw("error! roleNOBJ must be a neuron");
            console.log("%c BAD PARAM", TALK.bgerror);
            return;
        } 

        this.roleNOBJ=$roleNOBJ;//the nObj of the role
        this.roleTempNid = $roleNOBJ.temp_nid;
        this.role_text=$roleNOBJ.text;     //the text (for display in debugger) of this role.

        this.nObj=$valueNOBJ;   //the value of the role (if new it is null)
        
        if (this.nObj==null) {
            this.new=true;
        }
        else this.new=$bNEW;         //on if this is a new word (unknown)
            
        this.ph=$ph;            //the phrase this is tied to
        
        if (this.ph!=null && this.ph.resolvable==true) {
            this.needs_ric = true;
        }
        else this.needs_ric = false; //we have resolved this to an expression that needs resolution in context
        
        //in lieu of resolution, we may have an idea of what this class is.
        this.best_class_tnid = -1;
        
        this.confidence=$conf;  //0-1
        

        //if the value is a new nOBJ, override the bNEW
        if ($valueNOBJ && $valueNOBJ.bNEW==true) this.new=true;

        this.mods = [];         //values that modify the meaning of the main role.
        this.mod_role = false;  //THIS is a mod role.
        this.mod_parent = null; //the parent role that this mod applies to.
        this.learning = null;   
        this.parentLine = null; 
        this.all_expects = [];
        this.pMorphUsed = null;
        this.winningExpect = null;
        this.ric_resolved = false;
        this.pre_ric = null;
        this.pre_text = "";
        this.pre_mods = null;

        //set in the  setRoleFlags.
        this.indef = false;
        this.subj = false;
        this.pred = false;
        
        //we don't try to resolve question signals like we do other PNs or resolvables.
        //They inform us of the target role a question is after and we attack it based on that.
        //ie,  "what" is the capital of France?  
        this.question_signal = false;

        //for fast reference when resolving multiple role phrases.
        //char enders operate as signals that may help us match a pattern.
        this.charObj_ender=null;


        this.alt_resolutions = [];

        //the actual role relon from its clump.
        //in parsing we don't store these yet until we resolve the role..
        //AND figure out what we want to store.
        //(we may not store a role)
        //Many non primary roles can be stored on the THINGS they modify,
        //as base-level knowledge.
        //There is a dog that is red.   That dog has   dog->color->red.
        //When referenced someone may say "The red dog".  This modifier, red, is just context to help
        //us disambiguate -- to identify "which" dog we are talking about.  As such, we don't need to store
        //anything about "red" in the clump.   The dog that "the red dog" resolves to already specifies it is 
        //red.  It is also giant, and it also speaks.   So when we verbalize that concept we could say,
        //the giant speaking red dog.
        this.rObj = null;


        if ($ph!=null && $ph.resolved_nObj==null && $ph.resolve_nObj!=null) {
            this.resolve_nObj = $ph.resolve_nObj;
        }
        else this.resolve_nObj = null;  //we don't have anything  yet to try to resolve.

    }



    /**
     * in convo mode we can get this wrong...
     * at times we go back (with further context) to swap options.
     * save the alts.
     */
    setWinningCandidate = function($candidates) {
        if ($candidates.length==0) return;
        var winner = $candidates[0];
        if ($candidates.length>1) this.alt_resolutions = $candidates;
        this.updateResolved(winner.nObj);
        return;
    }

    
    /**
     * 
     * @param {*} $nObj 
     */
    updateResolved=function($nObj) {
        this.nObj = $nObj;
        this.needs_ric = false;
        this.ric_resolved = true;
    }


    /**
     * We print roles at various points of the process to generate them.
     * sometimes we know they are new and have created a new neuron..
     * Othertimes we know they are new and have not yet created the neuron
     * Also, we may know this needs context resolution (in either of the above cases)
     */
    printRole = function() {
        var strval =  "";
        var roleVal = "";
        var class_clue = "";
        
        if (this.ph!=null) strval = this.ph.l1str;
        
        //already set role nObj (final value)
        if (this.nObj!=null) {
            roleVal = this.nObj.text;
            if (this.nObj.bNEW==true || this.new==true) {
                roleVal+="**NEW and made**";
            }
        }

        //not yet set role final value.
        else {
            if (this.best_class_tnid!=-1) {
                var classClueNOBJ = MEMG.getNeuronByTempNid(this.best_class_tnid);
                class_clue = " '"+classClueNOBJ.text+"'";
                roleVal = "make **NEW** neuron "+this.ph.l1str_nosignal+" [class "+class_clue+"]";
            }
            else {
                roleVal = "make **NEW** neuron "+this.ph.l1str_nosignal;
            }
        }

        //known resolution in context needed (still yet to occur)
        var ric = "";
        var ric_color = TALK.bggreen;
        
        if (this.needs_ric==true) {
            ric_color = TALK.bgred;
            ric = "[needs_ric]";
        }
        
        var role_name = this.roleNOBJ.text.toUpperCase();

        
        console.log("%c["+role_name+"]%c'"+strval+"'%c:"+roleVal+"%c"+ric, TALK.bgyellow, TALK.bggreen, TALK.bgblue, ric_color);
    }
}



class nlp_ph {
    constructor($nlpP, $depth) {
        this.nlpP  = $nlpP;
        this.depth = $depth;
        
        this.id = ANNE.BRAIN.NLP.next_id++;
        this.parent=null;
        this.flat_ph=null;
        this.sig_parts=[]; 
        this.sig_parts_str="";
        this.parts=[]; 
        this.parts_str="";
        this.mod_ph_parts=[];
        this.mod_ph_str="";
        this.context_ph_parts = [];
        this.full_str=""; 
        this.mods=[]; 
        this.total_parts=0; 
        
        this.isPartPart=false; //main part (ie, noun in a np)
        this.isSigPart=false;  //signal part (ie, a prep in a prep phrase)
        this.isModPart=false;  //mode part (ie, red in red dog)
        this.isContextPart=false; //context part (ie, "bones" in Jon "bones" Jones)
        
        this.bCLOSED=false;
        this.pre_open=false;
        this.alt_parents=[];
        this.can_be_aux=false;
        this.question_signal=false;
        this.is_conveyor=false;           //is vbs, actions vbs, state vbs.
        this.is_manner=false;
        this.is_mode=false;
        this.is_connector=false;
        this.is_aux=false;
        this.likelyConcept=null;
        this.index = -1;            //only will be set if depth =1.  (otherwise not relevant)
        this.expects_roles = [];
        this.has_indef=false;  
        this.resolvable = false;

        this.x_when = false;
        this.x_where = false;

        this.l1wds=[];
        this.l1str="";
        this.l1str_nosignal="";
        this.l1str_nosignal_wds = [];

        //same as having a .role set.
        this.conceptualized = false;        //this is back-filled
        this.role = null;                   //this is back-filled

        //can be just the direct neuron referenced or the resolve value
        this.resolve_nObj = null;
        this.resolved_nObj = null;
        
        this.resolve_thing = false;     //set for traditional pns that need direction 1:1 resolution, in context. 
        
        //this is a special mapper, "like speaker" or "audience" that certain prounouns depend on.
        //YOU in dialogue, or I in dialogue..
        this.resolve_to_concept = null;

        //test for regen as it was.
        this.ordered_parts = [];

        this.starts_with_sig=false;
    }


    /**
    */
    updateL1Wds=function($flat_ph, $keepIt=false) {
        //we want the wds of l1 here.
        for (var w=0; w<$flat_ph.wds.length; w++) {
            this.l1wds.push( $flat_ph.wds[w]);
            
            if ($flat_ph.wds[w].has_ender==true && w==$flat_ph.wds.length-1) {
                console.log("(updateL1Wds skip ender");
                continue;
            }

            this.l1str+=$flat_ph.wds[w].str;

            if ($flat_ph.isSigPart==false) {
                this.l1str_nosignal+=$flat_ph.wds[w].str;
                if ($flat_ph.wds[w].str!=" ") {
                    this.l1str_nosignal_wds.push($flat_ph.wds[w]);
                }
            }
            else if ($keepIt==true) {
                if (this.l1str.length>0 && this.l1str_nosignal_wds.length>0) {
                    this.l1str_nosignal+=$flat_ph.wds[w].str;
                    this.l1str_nosignal_wds.push($flat_ph.wds[w]);
                }
            }
        }
         if (this.depth>1 && this.parent!=null && this.parent.depth>0) {
            this.parent.updateL1Wds($flat_ph, $keepIt);
        }
    }

    
    /**
     * 
     * @param {*} $tnids 
     */
    addExpectedRoles = function($tnids) {
        for (var t=0; t < $tnids.length; t++) {
            if (this.expects_roles.indexOf($tnids[t])==-1) {
                this.expects_roles.push($tnids[t]);
            }
        }
    }

    /**
     * 
     * @param {*} $nlpP 
     * @param {*} $aux_flat 
     */
    makeAux = function($nlpP, $aux_flat) {
        $nlpP.has_aux = true;
        $nlpP.aux_part = this.makeChildMod($nlpP, $aux_flat) //add the aux
    }


    /**
     * Set the flatPh for this nlp ph and copy expected roles.
     * Anytime we set a flat phrase we want to copy all expected roles into this nlp_ph
     * @param {*} $flat_ph 
     */
    setFlatPh = function($flat_ph) {
        this.flat_ph = $flat_ph;
        if ($flat_ph.expects_roles.length>0) {
            this.addExpectedRoles($flat_ph.expects_roles);
            if (this.depth>1) {
                this.parent.addExpectedRoles($flat_ph.expects_roles);
            }
        }
        if ($flat_ph.x_when!=undefined) this.x_when = true;
        if ($flat_ph.x_where!=undefined) this.x_where = true;
    }            
    
    
    /**
     * 
     * @param {*} $nlpP 
     * @param {*} $flat_ph 
     * @returns 
     */
    addFlatToPh=function($nlpP, $flat_ph) {
        var ph_part = this.makeNPHere($nlpP);
        if (ph_part.parts.length==0) ph_part.setFlatPh($flat_ph);
        ph_part.updateL1Wds($flat_ph);
        if ($flat_ph.likelyConcept!=null) ph_part.likelyConcept=$flat_ph.likelyConcept;
        if ($flat_ph.resolve_to_concept!=null) {
            ph_part.resolve_to_concept=$flat_ph.resolve_to_concept;
        }
        this.parts.push(ph_part);
        this.ordered_parts.push(ph_part);

        this.pre_open=false;    //this was a one time flag to help us get this flat in
        ph_part.isPartPart=true;    //THIS INDICATES WHAT ARRAY IT IS IN (of its parent)ent)
        this.total_parts+=1;
        return ph_part;
    }

    

    /**
     * 
     * @param {nlp_phrase_flat_part} $flat_ph 
     * @returns 
     */
    addFlatToSigPh=function($nlpP, $flat_ph) {
        var sig_part = this.makeNPHere($nlpP);
        sig_part.setFlatPh($flat_ph);
        
        if ($flat_ph.has_indef!=undefined && $flat_ph.has_indef==true) {
            sig_part.indef = true;
        }
        
        sig_part.updateL1Wds($flat_ph);
        
        this.sig_parts.push(sig_part);
        this.ordered_parts.push(sig_part);

        this.total_parts+=1;
        
        sig_part.isSigPart=true;    //THIS INDICATES WHAT ARRAY IT IS IN (of its parent)
        if (this.total_parts==1) {
            this.starts_with_sig = sig_part;
        }
        
        //who, what, when, where, why, how,  (is, did)
        if ($flat_ph.question_signal==true) {
            this.question_signal=true;
            $nlpP.psbl_question = true;
        }
        return sig_part;
    }


    /**
     * all new nlp_ph instatiations come through here.  (other than the sentence top lvl in the LC)
     * @param {*} $nlpP 
     * @returns 
     */
    makeNPHere=function($nlpP) {
        var np = new nlp_ph($nlpP, this.depth+1);
        np.parent = this;
        if (this.depth==0) {
            np.index = ++$nlpP.top_index;
        }
        return np;
    }
    
    
    /**
     * 
     * @param {nlp_phrase_flat_part} $flat_ph 
     * @returns 
     */
    makeChildPartOfCurrentPh=function($nlpP, $flat_ph=null) {
        var child_ph_part = this.makeNPHere($nlpP);
        this.parts.push(child_ph_part);
        this.ordered_parts.push(child_ph_part);

        this.total_parts+=1;

        if ($flat_ph!=null) {
            child_ph_part.setFlatPh($flat_ph);
            child_ph_part.updateL1Wds($flat_ph);
        }
        
        return child_ph_part;
    }


    /**
     * 
     * @param {nlp_phrase_flat_part} $flat_ph 
     * @returns 
     */
    makeChildMod=function($nlpP, $flat_ph) {
        var child_ph_mod = this.makeNPHere($nlpP);
        this.mod_ph_parts.push(child_ph_mod);
        this.ordered_parts.push(child_ph_mod);

        this.total_parts+=1;
        child_ph_mod.isModPart = true;         //THIS INDICATES WHAT ARRAY IT IS IN (of its parent)
        child_ph_mod.setFlatPh($flat_ph); 
        child_ph_mod.updateL1Wds($flat_ph, true); //keep mod sigs in l1str_nosignal str gen 
        return child_ph_mod;
    }

    //hmm
    makeChildContext=function($nlpP, $flat_ph) {
        var context_ph_mod = this.makeNPHere($nlpP);
        this.context_ph_parts.push(context_ph_mod);
        this.ordered_parts.push(context_ph_mod);

        //this.total_parts+=1;
        context_ph_mod.isContextPart = true;         //THIS INDICATES WHAT ARRAY IT IS IN (of its parent)
        context_ph_mod.setFlatPh($flat_ph); 
        //context_ph_mod.updateL1Wds($flat_ph, true); //keep mod sigs in l1str_nosignal str gen 
    }

    /**
     * @param {nlp_parse} $nlpP 
     * @param {nlp_phrase_flat_part} $flat_ph 
     * @returns 
     */
    makeChildModWithSignalPh=function($nlpP, $flat_ph=null) {
        var child_ph_mod = this.makeNPHere($nlpP);
        this.mod_ph_parts.push(child_ph_mod);
        
        this.total_parts+=1;
        child_ph_mod.isModPart = true;     
        var sig_part = child_ph_mod.makeNPHere($nlpP);   //sig gets its own part, and is the part of that 
        sig_part.setFlatPh($flat_ph);
        
        sig_part.updateL1Wds($flat_ph, true); //keep mod sigs in l1str_nosignal str gen 
        
        child_ph_mod.sig_parts.push(sig_part);
        
        this.ordered_parts.push(sig_part);
        this.ordered_parts.push(child_ph_mod);

        child_ph_mod.total_parts+=1;
        
        sig_part.isSigPart=true;    //THIS INDICATES WHAT ARRAY IT IS IN (of its parent)
        
        return child_ph_mod;
    }



    /**
     * if we try to close the no-parent phrase, don't.
     * this is a top level.
     * @returns 
     */
    closePh=function(){
        if (this.parent==null) return this;
        this.bCLOSED =true;

        this.l1str = this.l1str.trim();
        this.l1str_nosignal = this.l1str_nosignal.trim();

        //lookup listr_nosignal here?
        if (this.l1str_nosignal.length!=this.l1str.length) {
            
            this.tnids = MEMG.getTnidsByAnbl(this.l1str_nosignal);
            
            if (this.tnids.length==1) {
                this.resolve_nObj = MEMG.getNeuronByTempNid(this.tnids[0]); //this could also be the resolved_nObj...
            }
        }

    
        if (this.flat_ph!=null) {
            if (this.flat_ph.resolve_to_concept!=null) this.resolve_to_concept = this.flat_ph.resolve_to_concept;
            
            //check if indef comes through here..
            if (this.resolve_thing==true) {
                for (var s=0; s < this.flat_ph.signal_arr.length; s++) {
                    var sig = this.flat_ph.signal_arr[s];
                    if (this.tnids.indexOf(sig.nObj.temp_nid)==-1) this.tnids.push(sig.nObj.temp_nid);
                    if (this.resolve_nObj==null) {
                        this.resolve_nObj = sig.nObj;
                    }
                    //if (sig)
                }
            }
            if (this.flat_ph.bestPat!=null) {
                this.bestPat = flat_ph.bestPat;
            }
        } 
        else {
            if (this.parts.length==1 && this.parts[0].flat_ph!=null && this.parts[0].flat_ph.bestPat!=null) {
                this.bestPat = this.parts[0].flat_ph.bestPat;
            }
        }

        //if any sig parts are indef, flag this phrase as indef=true.
        if (this.sig_parts.length) {
            for (var s=0; s < this.sig_parts.length; s++) {
                var sig_part = this.sig_parts[s];
                if (sig_part.flat_ph!=null) {
                    if (sig_part.flat_ph.indef==true) {
                        this.indef=true;

                        //if this is an indef with a known class, it is resolved already.
                        //needs_ric should be set to false.
                        if (this.resolve_nObj!=null && this.resolve_nObj.ntype==NTYPE_CLASS) {
                            this.resolved_nObj=this.resolve_nObj;
                        }
                        break;
                    }
                }
            }
        }
        return this.parent;
    }

}


const CLUMP_TYPE_Q = "question";
const CLUMP_TYPE_S = "statement";
const CLUMP_SUBTYPE_DEFN="defn";
const CLUMP_SUBTYPE_POSN="posn";
const CLUMP_SUBTYPE_ACTION="action";

//I hate Donald Trump.   I hate Joe Biden.. etc
//These are actually "feelz" relons (no need for a clump)
//note:  we won't be in any dialogue mode anytime soon so this is irrelevant for now
//..but when that comes it will be helpful to store the single relons and not a clump.
const CLUMP_SUBTYPE_SELF_AWAREZ="awarez";


/**
 */
class nlp_clump {
    constructor($nlpP, $orig) {
        this.nlpP = $nlpP;
        this.orig_str = $orig;
        this.default_roles=[];
        this.default_exp_roles=[];  
        this.nlpRolesObj = new nlp_roles(this);  
        this.clump_type = "";
        this.clump_sub_type = "";

        this.voice = "active";                  //"active" or "passive";

        //extracted from the vb and/or a "will" modal (for future in english).  
        //Other languages set it based on their rules.
        this.tense = "present";         //present or future or past
        this.has_aux = false;

        //potentially deprecated.
        //set when we hit a question role..
        //we can confirm this with intonation and/or punctuation.
        this.psbl_question = false; 
        this.psbl_question_confirmed = false; 

        this.thing_cnt = 0;//incremented when we conceptualize a thing lvl=1 role.
        this.default_roles = [];
        this.known_anvert = false;//yin/yang anverts  give/receive
        
        //used in stream method, we expect to find these & prioritize them
        this.default_exp_roles_found=[];
        
        this.phrases = [];
        this.phs_handled=0; 
        this.clump_index = ANNE.BRAIN.clump_index++;
        
        this.conveyor_role = null;
        this.clumpNOBJ = null;
         
        //dep
        this.new_role_attempts = [];    //desperation mode.
        this.aux = []; 
        this._confidence = {wds:0, phs:0, roles:0, resolution:0};
        this.conf = 0;
        this.aux_with_no_action=false;
        this.aux_cnt = 0;
        this.action_cnt = 0;
        this.has_valid_thing = true;    

        //some clumps can be simplified down to a single relon.
        this.single_relon = null; 
        this.extraps = [];  
    }

    
    getConveyorNObj = function() {
        if (this.conveyor_role==null) return null;
        return this.conveyor_role.nObj;
    }
    
    /**
     */
    canBeSingleBeRelon = function() {
        if (this.clump_sub_type!=CLUMP_SUBTYPE_DEFN) return false;
        for (var r=0; r <this.nlpRolesObj._roles.length; r++) {
            var role = this.nlpRolesObj._roles[r];
            if (role.roleTempNid==MEM.role_actor.temp_nid) continue;
            else if (role.roleTempNid==MEM.role_action.temp_nid) continue;
            else if (role.roleTempNid==MEM.role_be_thing.temp_nid) continue;
            else if (role.roleTempNid==MEM.role_tense.temp_nid && role.nObj.temp_nid==MEM.tense_present.temp_nid) continue;
            else return false;
        }
        return true;
    }


    /**
     */
    canBeSingleHasRelon = function() {
        if (this.clump_sub_type!=CLUMP_SUBTYPE_POSN) return false;
        for (var r=0; r <this.nlpRolesObj._roles.length; r++) {
            var role = this.nlpRolesObj._roles[r];
            if (role.roleTempNid==MEM.role_actor.temp_nid) continue;
            else if (role.roleTempNid==MEM.role_action.temp_nid) continue;
            else if (role.roleTempNid==MEM.role_be_thing.temp_nid) continue;
            else if (role.roleTempNid==MEM.role_tense.temp_nid && role.nObj.temp_nid==MEM.tense_present.temp_nid) continue;
            else return false;
        }
        return true;
    }
    
    
    setRoleFlags = function($nlpP, $clump) {
        this.nlpRolesObj.setRoleFlags($nlpP, $clump);
    }
    
    printRoles = function() {
        this.nlpRolesObj.printRoles();
    }
    
    /**
     * 
     * @param {*} $valueText 
     * @param {*} $roleNOBJ 
     * @param {*} $valueNOBJ 
     * @param {*} $phPart 
     * @param {*} $conf 
     * @param {*} $bNEW 
     */
    addRole = function($valueText="", $roleNOBJ=null, $valueNOBJ=null, $phPart=null, $conf=.5, $bNEW=false) {
        return this.nlpRolesObj.addRole(this, $valueText, $roleNOBJ, $valueNOBJ, $phPart, $conf, $bNEW);
    }


    /**
     */
    getDefaultRoleTnids = function() {
        var keys = Object.keys(this.default_roles);
        var tnids = [];
        //populate clump's default roles.
        for (var d=0; d < keys.length; d++) {
            var role = this.default_roles[ keys[d]];
            if (role.roleTempNid==undefined) {
                console.log("what is this??");
                continue;
            }
            tnids.push(role.roleTempNid);
        }
        return tnids;
    }

    
    /**
    */
    setDefaultRoles = async($vbNOBJ)=> {
        var drs = await $vbNOBJ.defaultRolesForClumpForNLP();
        var keys = Object.keys(drs);

        //populate clump's default roles.
        for (var d=0; d < keys.length; d++) {
            var role = drs[ keys[d]];
            if (role.roleTempNid==undefined) {
                console.log("what is this??");
                continue;
            }
            if (this.default_roles[role.roleTempNid]==undefined) {
                this.default_roles[role.roleTempNid]=role;
            }

            //set in the $clump.action_vb.defaultRolesForClumpForNLP
            if (role.priority==1) {
                this.default_exp_roles.push(role.roleTempNid);
                //?  (do we need to fire off this expecation?  I don't think so)
                //ANNE.BRAIN.ctp.expFutureRole(role.roleTempNid, $ph.p_index+1, 0);
            }
        }    
    }
    
    
    /**
     * 
     * @param {*} $flat_ph 
     */
    addedMainVbPh=function($ph) {
        $ph.is_conveyor = true;
    }


    /**
     * Review this approach... hmmm.
     */
    getPosblThingRoles = function() {
        var thing_roles = [];
        for (var d = 0; d < this.default_exp_roles.length; d++) {
            var role_tnid = this.default_exp_roles[d];
            if (this.default_exp_roles_found.indexOf(role_tnid)!=-1) continue;

            //unfound default role..
            if (role_tnid==MEM.role_affected_thing.temp_nid) {
                thing_roles.push(MEM.role_affected_thing);
            }
            else if (role_tnid==MEM.role_theme_thing.temp_nid) {
                thing_roles.push(MEM.role_theme_thing);
            }
        }
        return thing_roles;
    }




    /**
     * wire this back to the LANG as each language could be different
     * @param {language_circuit}
     * @param {nlp_phrase_flat_part}
     */
    getLangPart=function($LC, $fph) {
        return $LC.LANG.getLangPart(this, $fph);
    }



    /**
     * Our confidence in the parsing of text to wds, to phrases to roles, up until
     * the point that we have to resolve things in context which we already put into roles.
     * ie, "the dog" "a dog" "her" "I" "that man" "the big fuzzy creature".
     */
    calcConfidence() {
        //this.calcPhConfidence();
        //this.calcRoleConfidence();
        //this.calcFinalConfidence();
        //console.log(this._confidence);
    }




    /**
     * Our confidence in the the handling of phrases
     */
    calcPhConfidence = function() {
        //var phHandledRatio = 0;
        //if (this.phs_handled==undefined || this.phs_handled==0) this._confidence.phs=0;
        //else this._confidence.phs = (this.phs_handled / this.phrases.length) * this._confidence.wds;
    }


    /**
     */
    calcRoleConfidence = function() {
        /*
        var sum  = 0;
        for (var r=0; r <this.nlpRolesObj._roles.length; r++) {
            var role = this.nlpRolesObj._roles[r];
            if (role.confidence==undefined) {
                console.log("why does this role have no confidence>??? ::",role);
                continue;
            }
            sum += role.confidence;
        }
        if (sum==0 || this.nlpRolesObj._roles.length==0) this._confidence.roles = 0;
        else this._confidence.roles = (sum/this.nlpRolesObj._roles.length) * this._confidence.phs;
        */
    }

    /**
     */
    calcFinalConfidence = function() {
        /*
        var roles_handled = 0;

        for (var r=0; r <this.nlpRolesObj._roles.length; r++) {
            var role = this.nlpRolesObj._roles[r];
            //we still need to resolve this!!
            if (role.needs_ric==false) roles_handled+=1;
        }
        if (roles_handled==0) this._confidence.resolution=0;
        else this._confidence.resolution = (roles_handled / this.nlpRolesObj._roles.length)*this._confidence.roles;
        
        this.conf=this._confidence.resolution;
        */
    }


    /**
     * 
     * @param {*} $bFROMACTIVE 
     * @returns 
     */
    flipVoice = function($bFROMACTIVE=true) {
        if ($bFROMACTIVE==true) this.voice = "passive"; 
        else this.voice = "active";
        return;
    }


    /**
     * This is an easy/light pool to make matches.
     * We are trying to discern the best role match for the unconceptualized phrase.
     * 
     * @param {nlp_clump} $clump 
     * @param {Array} $priority_roles 
     * @param {Array} $other_roles 
     * @param {anne_nlp_parse} $ph 
     */
    makeRolePool = function($priority_roles, $other_roles, $ph) {
        var rolePool  = new pool_core($ph.l1str_nosignal);
        if ($ph.expects_roles.length) rolePool.initHighPriority($ph.expects_roles, 3.3);
        //no signal was present..
        else {
            if ($priority_roles.length) rolePool.initHighPriority($priority_roles, 1.2);
            if ($other_roles.length) rolePool.init($other_roles);
        }
        return rolePool;
    }
}


class nlp_phrase_flat_part {
    constructor() {
        this.wd_cnt = 0;    
        this.str = "";
        this.bCLOSED=false;
        this.isSigPart = false;
        this.isContextPart = false;
        this.wds_no_punct = [];
        this.wds = [];
        this.flagsArr=[];
        this.signal_arr = [];

        //a parent class-ish
        this.likelyConcept = null;

        //the resolved concept.  (may not be resolved here at the flat phrase stage, but sometimes is)
 
        this.psbl_list = false;
        this.psbl_action = false;
        this.psbl_manner = false;
        this.question_signal = false;
        this.question = false;  //has a known question symbol (different than a question signal)
        this.expects_roles = [];
        this.inProgStr = "";

        this.tnids = [];

        this.bestPat = null;    //pat used to match something.  (ie, a date, location, name .. etc)
    
    
    }


    likelyConveyorTest=function($nlpP, $next_wd) {
        var likely = .7;
        if (this.wd_cnt>1) {
            likely+=(this.wd_cnt-1)*.1;
            if ($nlpP.conveyor_part==null)  likely+=.2;
        }
        else if ($nlpP.conveyor_part==null)  likely+=.1;

        //if there are existing phrase parts already...
        if ($nlpP.phrase_parts.length==1 && $nlpP.phrase_parts[0].phrase_parts.length>0) {
            likely+=$nlpP.phrase_parts[0].phrase_parts.length*.1;
        }
        console.log("(likelyConveyorTest) wd "+$next_wd.str+" likely "+likely);
        if (likely>=1) return true;
        return false;
    }
    
    

    /**
     * The final resolved neuron for this flat phrase.
     * @param {*} $nObj 
     */
    setResolvedNObj = function($nObj) {
        //alert("setResolvedNObj");
        this.resolved_nObj = $nObj;
    }
    
    /**
     * The words of the phrase are resolved but they have not yet been resolved IN CONTEXT.
     * Ie, "she", "he", "they"
     * @param {*} $nObj 
     */
    setResolveNObj = function($nObj) {
        this.resolve_nObj = $nObj;
    }


    /**
     * Possilble tnids of resolution (or neurons that need resolution) for this flat phrase.
     * @param {*} $tnids 
     */
    setTnids = function($tnids) {
         this.tnids = $tnids;
    }

    
    //add all expected roles from all possible versions of the signal to this phrase.
    //we don't know which signal is being used yet.
    addExpectedRoleTnid=function($tnid){
        if (this.expects_roles.indexOf($tnid)==-1) this.expects_roles.push($tnid);
    }


    /**
     * This is set by a pool match when processing the wds of the phrase.
     */
    setLikelyConcept = function($nObj) {
        this.likelyConcept = $nObj;
    }


    addWdPunct=function($wd){
        this.wds.push($wd); 
        if ($wd.str==" " && this.inProgStr=="") return;
        if ($wd.has_ender==true || $wd.str==".") {
            return;
        }
        this.inProgStr += $wd.str;
    }

    
    /**
     * 
     * @param {*} $wd 
     */
    addWd = function($wd) {
        this.wds_no_punct.push($wd);   //signal like "of"
        this.wd_cnt=this.wds_no_punct.length;
        this.wds.push($wd); 
        if ($wd.has_ender==true || $wd.str==".") {
            return;
        }
        this.inProgStr += $wd.str;
    }

    addWdFromPunctOnly = function($wd){
        this.wds_no_punct.push($wd);   //signal like "of"
        this.wd_cnt=this.wds_no_punct.length;
    }

    
    getInProgressString=function($wd) {
        return this.inProgStr+$wd.str;
    }
    

    /**
     * @param {*} $closeUp 
     */
    closePhrasePartFlat=function(){
        if (this.bCLOSED==true) return;
        this.wd_cnt = this.wds_no_punct.length;
        this.str = "";
        for (var w=0; w < this.wds_no_punct.length; w++) {
            var wd = this.wds_no_punct[w];
            this.str += wd.str.trim();
            var wd2 = this.wds_no_punct[w+1];
            //sometimes we DO put punct in here but only as part of a pattern.
            //a : may be in a name, or a "comma" may be part of a date pat.
            //if so, don't add a space before the symbol.
            if (wd2==undefined || wd2.charObj==null) this.str=this.str+" ";    
        }
        this.str = this.str.trim();

        this.bCLOSED = true;
    }
}



class nlp_char {
    constructor($char, $charCode, $nObj) {
        this.charNOBJ = $nObj;
        this.char = $char;
        this.charCode = $charCode;
        this.num=false;
        this.alpha=false;
        this.other=false;
        this.cap=false;
        this.pats=[];

        this.quote = false;
        this.breaker = false;
        this.ender = false;
        this.question = false;
        this.spacer = false;
        this.inner_breaker = false;

        if ($charCode>=48 && $charCode<=57) this.num=true;
        else if ($charCode>=65 && $charCode<=90) {
            this.alpha=true;
            this.cap=true;
        }
        else if ($charCode>=97 && $charCode<=122) this.alpha=true;
        else this.other=true;
    }
}

/**
 * Used to make tokens for words/punctuation in the first pass.
 */
class nlp_wd {

    /**
     * @param {string} - type of wd ('wd', 'punct')
     * @param {string} - string of the word
     */
    constructor($type, $str) {
        this.charObj = null;    //applicable to chars only. (like comma)
        this.connector = false; //applicable lang specifc for various types of punctuations.

        //new flatter method.  pre-process wds multiple times first.
        this.signal_arr = null; 

        this.type = $type;
        this.str = $str;
        this.handled = false;
        this.index = -1;
        
        this.charObj_ender = null;  //for type="wd", what caused the end of this wd obj?
        
        //populated in wds when we first parse them
        //moved over from prefix/suffix we already have prior to the parse
        this.psbl_morphs = [];  //[{morph,p,p_cnt,prefixes,s,s_cnt,suffixes}]
        this.psbl_plural_morph = null;

        //this.ecpool_wd_adds=[]; //helps with ec types we expect 
        this.dpool_adders=[];   //helps resolve the phrase context

        this.psbl_mod = false;
        this.psbl_abbreviation = false;       
        this.psbl_sentence_ender = false;     
        this.psbl_date = false;

        //set in flat parse
        this.psbl_manner = false;
        this.psbl_action = false;
        this.psbl_new_action_morph = false;
        this.psbl_state = false;
        this.psbl_thing = false;
        
        this.is_date = false;

        //set when the symbol denotes a question symbol.
        this.question=false;

        this.has_apostrophe = false;
        this.has_alpha = false;
        this.has_num = false;
        this.has_breaker = false;
        this.has_mixed = false;     //has alpha AND num 
        this.has_ender = false;
        this.has_spacer = false;
        this.has_period = false;
        this.has_nonalpha_num = false;
        this.has_innerbreaker = false;
        
        this.is_int = false;
        this.is_num = false;
        this.is_alpha = false;

        this.alts = [];     //things seperated by innerbreakers.
        this.parts = [];    //integral parts of the wdObj.  "johnson-smith" "12/12/2012"
        this.special_obj = {};

        this.tnids = null;
        this.ec_tops = [];
        this.fppp_status = null;

        //for obvious nested context clues.
        //this.end_context = null;
        this.end_context_depth = 0;
        //this.start_context = null;
        this.start_context_depth = 0;

        this.assessed = false;
        
        this.end_of_coms = false;
    }

    /**
     * Add a psbl morph, no dupes.
     * @param {*} $morph 
     */
    addPsblMorph = function($morph) {
        for (var m=0; m < this.psbl_morphs.length; m++) {
            var morph = this.psbl_morphs[m];
            if (morph.morph==$morph.morph) continue;    
        }
        this.psbl_morphs.push($morph);
    }
    
    
    /**
     *  This is for early quick hit stages of the flat parse.
     *  
     *  TODO: We do not want a to guess a new vb (based on morphs) in a nested clause if we have the real vb.
     *  This is not a good way to learn.
     */
    assessNonSignalWd = async($nlpP)=> {
        //check the word, as-is.
        if (this.tnids==null || this.tnids.length==0) {
            this.tnids = MEMG.getTnidsByAnbl(this.str);
        }
        
        for (var n=0; n < this.tnids.length; n++) {
            var nObj = MEMG.getNeuronByTempNid(this.tnids[n]);
            if (nObj.is(MEM.ec_action)==true) {
                this.psbl_action = true;
            }

            //straight-away manner.
            if (nObj.is(MEM.ec_manner)==true) {
                this.psbl_manner = true;
            }
            if (nObj.is(MEM.ec_state)==true) {
                this.psbl_state = true;
            }
            if (nObj.is(MEM.ec_state)==true) {
                this.psbl_thing = true;
            }
        }

        //if (neurons.length>0) return;
        
        if (this.psbl_morphs.length==0) return;

        //look for found wds with morphs that make the wd something else.
        //unk vb "bark" used as "barked";
        for (var m=0; m < this.psbl_morphs.length; m++) {
            var morph = this.psbl_morphs[m];
            var suffixes = morph.suffixes;
            if (suffixes.length==0) continue;

            for (var s=0; s < suffixes.length; s++) {
                var suf = suffixes[s];
                //ending only understanding here.
                if (ANNE.BRAIN.NLP.LC._suffixIs(suf, MEM.ec_action.temp_nid)==true) {
                    //if we don't have the morph we're not going to count the suffix/ending match for verbs
                    //our morphs are algo gen'd and some don't exist (ever) so we don't want a ton
                    //of false positive matches.
                    if (morph.morph_known==false) {
                        this.psbl_new_action_morph = true;
                        continue;
                    }   

                    //this is a subclass of the root morph.
                    var morphNOBJ = MEMG.getNeuronByTempNid(this.tnids[0]);
                    var local_nObj = await ANNE.BRAIN.ctp.makeLocalNeuron(this.str, NTYPE_CLASS, morphNOBJ);
                    this.tnids = [];
                    if (local_nObj!=null) this.tnids = [local_nObj.temp_nid];//replace the tnids of the root since we now have the morph+ending.
                    //make tense on temp neuron.
                    //if (suf && suf.tense!==null && suf.tense!=undefined && suf.tense.nid!=MEM.tense_present.nid) {
                        //MEM.makeTempRelon(local_nObj, TYPE_BE, MEM.tense, TO_TYPE_ANNE, suf.tense.nid, true);
                    //}
                    this.psbl_action = true;
                    continue;
                }

                //only presume new manner morphs based on obvious rules.
                if (ANNE.BRAIN.NLP.LC._suffixIs(suf, MEM.ec_manner.temp_nid)==true) {
                    this.psbl_manner = true;
                    this.surmised_as_manner = true;
                    var morphNOBJ = MEMG.getNeuronByTempNid(this.tnids[0]);
                    var local_nObj = await ANNE.BRAIN.ctp.makeLocalNeuron(this.str, NTYPE_CLASS, morphNOBJ);
                    this.tnids = [local_nObj.temp_nid];//replace the tnids of the root since we now have the morph+ending.
                    
                    continue;
                }

                if (ANNE.BRAIN.NLP.LC._suffixIs(suf, MEM.ec_state.temp_nid)==true) {
                    if (morph.morph_known==false) {
                        this.psbl_new_state_morph = true;
                        continue;
                    }
                    var morphNOBJ = MEMG.getNeuronByTempNid(this.tnids[0]);
                    var local_nObj = await ANNE.BRAIN.ctp.makeLocalNeuron(this.str, NTYPE_CLASS, morphNOBJ);
                    this.tnids = [local_nObj.temp_nid];//replace the tnids of the root since we now have the morph+ending.
                    
                    this.psbl_state = true;
                    continue;
                }

                if (ANNE.BRAIN.NLP.LC._suffixIs(suf, MEM.ec_thing.temp_nid)==true) {
                    if (morph.morph_known==false) {
                        this.psbl_new_thing_morph = true;
                        continue;
                    }
                    var morphNOBJ = MEMG.getNeuronByTempNid(this.tnids[0]);
                    var local_nObj = await ANNE.BRAIN.ctp.makeLocalNeuron(this.str, NTYPE_CLASS, morphNOBJ);
                    this.tnids = [local_nObj.temp_nid];//replace the tnids of the root since we now have the morph+ending.
                    
                    this.psbl_thing = true;
                    continue;
                }
            }
        }

        this.assessed=true;

        return;
    }
    


    static addWdBlank() {
        return new nlp_wd("", "");
    }

    /**
     * Set on non space/non ender/non breaker real wd str
     * @param {anne_nlp_parse} - the main parse this word is in
     * @param {language_circuit} - the LC module
     * @param {array} - the wds array
     * @param {nlp_char} - the single char obj (null for anything > 1 ascii char)
     * 
     * @author {mrscatman}
     */
    setWd=function($nlpP, $LC, $wds, $charObj_ender) {
        this.type="wd";
        var pfx = $LC._getPrefix(this.str);
        if (pfx!=null) this.wd_is_prefix = pfx;
        var sfx = $LC._getSuffix(this.str);
        if (sfx!=null) this.wd_is_suffix = sfx;

        this.index = $wds.length;
        $wds.push(this);

        if ($charObj_ender!=null) {
            this.charObj_ender = $charObj_ender;
        }
        
        if (this.has_apostrophe==true) $LC.LANG.handleApostrophe(this);

        //populate psbl_morphs in wds with morph/p/pcnt/prefixes/s/scnt/suffixes.
        //this is done in the FIRST PASS PUNC.
        if (this.tnids==null || this.tnids.length==0) {
            this.tnids = MEMG.getTnidsByAnbl(this.str);
            
            for (var n=0; n < this.tnids.length; n++) {
                var ec_top_nObj = MEM._aNeurons[this.tnids[n]].getECTop();
                if (ec_top_nObj==null || ec_top_nObj==undefined) continue;
                if(this.ec_tops.indexOf(ec_top_nObj.temp_nid)==-1) this.ec_tops.push(ec_top_nObj.temp_nid);
            }
        }
        
        if (this.tnids.length==0) {
            $LC.LANG._nakedEndingsDetector(this); 

            //alert("get creative text search going here!");
            if (this.psbl_morphs.length) {

                //we have a psbl_morph..
                //let's look for the psbl root (if we have it)
                for (var m=0; m < this.psbl_morphs.length; m++) {
                    var morph = this.psbl_morphs[m];
                    var tnids2 = MEMG.getTnidsByAnbl(morph.morph);
                    if (tnids2.length) {
                        morph.morph_known=true; //mark this morph as more weighty since we have it.
                        for (var t=0; t < tnids2.length; t++) {
                            if (this.tnids.indexOf(tnids2[t])!=-1) continue;
                            this.tnids.push (tnids2[t])
                        }
                    }
                }
            }
        }
        
        if(this.has_num==true) {
            if(this.has_alpha==false) {
                if (this.has_nonalpha_num==false) {
                    if(this.has_period==true) this.is_num=true;
                    else this.is_int=true;
                }
            }
        }
        else if (this.has_alpha==true) {
            if(this.has_num==false && this.has_nonalpha_num==false) this.is_alpha=true;
        }  
    }
    

    /**
     * @param {string} - type of wd ('wd', 'punct')
     * @param {string} - string of the word
     * @param {array} - the wds array
     * @param {language_circuit} - the LC module
     */
    static addBreaker($LC, $wds, $char, $charObj) {
        var wdObj = new nlp_wd("punct-break", $char);
        wdObj.index = $wds.length;
        wdObj.has_breaker = true;
        wdObj.charCode = $char.charCodeAt(0);
        wdObj.charObj = $charObj;
        $wds.push(wdObj);

        
        return wdObj;
    }
    static addEnder($LC, $wds, $char) {
        var wdObj = new nlp_wd("punct-end", $char);
        wdObj.index = $wds.length;
        wdObj.has_ender = true;
        wdObj.charCode = $char.charCodeAt(0);
        $wds.push(wdObj);

        return wdObj;
    }
    static addSpacer($LC, $wds, $char) {
        var wdObj = new nlp_wd("punct-break", $char);
        wdObj.index = $wds.length;
        wdObj.has_spacer = true;
        wdObj.has_breaker = true;
        wdObj.charCode = $char.charCodeAt(0);
        $wds.push(wdObj);
        return wdObj;
    }
}

class nlp_morph {
    constructor($morph="", $p="", $p_cnt=0, $prefixes=[], $s="", $s_cnt=0, $suffixes=[]) {
        this.morph = $morph;
        this.prefixes = $prefixes;
        this.p = $p;
        this.p_cnt = $p_cnt;
        this.suffixes = $suffixes;
        this.s = $s;
        this.s_cnt = $s_cnt;
        this.ec_type_tnid = null;   //moved up from suffix/prefix
        this.plural = false;        //moved up from suffix/prefix
        this.bCANBESTATE = false;
        this.morph_known = false;
    }
    static make_prefix($morph="", $p="", $p_cnt=1, $prefixes=[]) {
        return new nlp_morph($morph, $p, $p_cnt, $prefixes); 
    }
    static make_suffix($morph="", $s="", $s_cnt=1, $suffixes=[]) {
        return new nlp_morph($morph, 0, 0, [], $s, $s_cnt, $suffixes); 
    }
    static make_prefix_and_suffix($morph="", $p="", $p_cnt=1, $prefixes=[], $s="", $s_cnt=1, $suffixes=[]) {
        return new nlp_morph($morph, $p, $p_cnt, $prefixes, $s, $s_cnt, $suffixes); 
    }

}

/**
 * Critical structure words cross any language
 * expectations (signals), resolves, modes, connectors
 */
class nlp_signal {
    constructor($text, $nObj, $tnid) {
        this.str=$text;
        this.nObj=$nObj;
        this.tnid=$tnid;

        this.resolve=false;
        this.expects=false;
        this.signal=false;
        this.connector=false;
        this.aux=false;
        this.mod=false;

        this.is = false;
        this.posn = false;

        this.psbl_roles=[];       //roles this wd ALONE resolves to

        this.expects_roles=[];    //clues for what roles to expect
        this.expects_ecs=[];      //clues for what ectypes to expect (thing, action etc)
        this.dpool_adders=[];     //clues to help resolve the disambig pool
        
        //raw relon of expectation (x_where, x_when) we can use to blow out a mini-pool
        this.expect_pool = [];
    }

    
    /**
     * We want a summation of the flags of all psbl signals this "wd" can be functioning as.
     * This will be potentially called multiple times for the same wd (with multiple signals)
     * so ensure the flagsArr is a summation and not overwritten.
     * @param {nlp_phrase_flat_part} $target 
     */
    copyFlags = function($target, $bDOFLAGSARR=true){
        var keys = Object.keys(this);
        var dont_copy = ["str", "nObj", "tnid", "psbl_roles", "expects_roles", "expects_ecs", "dpool_adders", "expect_pool"];
        for (var k=0; k < keys.length; k++) {
            var key = keys[k];
            if (dont_copy.indexOf(key)!=-1) continue;
            if ($target[key]!=undefined && $target[key]==true) continue;    //if true, don't overwrite
            else $target[key] = this[key];  //if false, or not set,  set or overwrite (w/true or false)
            if (this[key]==true) {
                if ($bDOFLAGSARR==true) {
                    if ($target.flagsArr==undefined) $target.flagsArr=[];
                    if ($target.flagsArr==null) $target.flagsArr=[];
                    if ($target.flagsArr.indexOf(key)==-1) $target.flagsArr.push(key);
                }
            }
        }

        //move over any of the expect_pool objs we use in the flat/phrase portion of the parse.
        //this will help us expect, and then confirm, dates, places, etc.
        if (ANNE.UTILS.isset(this.expect_pool)==true) {
            if ($target.expect_pool==undefined) $target.expect_pool=[this.expect_pool];
            else {
                for (var e=0; e < $target.expect_pool.length; e++) {
                    var expectP = $target.expect_pool[e];
                    if (expectP.nid==this.expect_pool.nid) {
                        return;
                    }
                }
                $target.expect_pool.push(this.expect_pool);
            }
        }

        
        //tnids of expected roles
        for (var e=0; e < this.expects_roles.length; e++) {
            var tnid_er = this.expects_roles[e];
            //console.log("audit "+MEM._aNeurons[tnid_er].text);
            $target.addExpectedRoleTnid(tnid_er);
        }

    }
    

    //resolve this word on the spot.
    static addResolve($nObj, $tnid, $text) {
        var sig = new nlp_signal($text, $nObj, $tnid);
        sig.resolve=true;
        return sig;
    }

    //expect an action.
    static addMode($nObj, $tnid, $text) {
        var sig = new nlp_signal($text, $nObj, $tnid);
        sig.signal = true;
        sig.mode = true;
        return sig;
    }

    //expects an ec_type or a role to come.
    static addExpects($nObj, $tnid, $text) {
        var sig = new nlp_signal($text, $nObj, $tnid);
        sig.expects = true;
        return sig;
    }

    static addIs($nObj, $tnid, $text) {
        var sig = new nlp_signal($text, $nObj, $tnid);
        sig.is = true;
        return sig;
    }

    static addPosn($nObj, $tnid, $text) {
        var sig = new nlp_signal($text, $nObj, $tnid);
        sig.posn = true;
        return sig;
    }
}

/**
 * neuron mappers are an object with .['textstring'] (aka object.prop) pointing
 * to either an object with .nObj:ann_neuron or an array of objects w/ misc props on it.
 */
class neuron_mapper {
    constructor() {
    }

    /**
     * @param {string} - the string to search the map with.
     */
    getByText=function($str) {
        $str = $str.trim().toLowerCase();
        var pfx = this[$str];
        if(pfx!=undefined) return pfx;
        return null;
    }


    /**
     * @param {anne_neuron} - the nObj to add.
     * note: WE MAY HAVE MULTIPLE SUFFIX HERE FROM DIFF LANGS.. hmm.
     */
    addUniqueSingleNObj=function($nObj) {
        if (this[$nObj.text.toLowerCase()]==undefined) {
            var sObj = {nObj:$nObj};//[{nObj:$nObj}];
            this[$nObj.text.toLowerCase()] = [sObj];
            return sObj;
        }
        else {
            var sObjs = this[$nObj.text.toLowerCase()];
            for (var s=0; s < sObjs.length; s++) {
                if (sObjs[s].nObj.temp_nid==$nObj.temp_nid) return sObj;
            }
            var sObj = {nObj:$nObj};
            sObjs.push( sObj );
            return sObj;
        }
    }
    

    /**
     * @param {anne_neuron} - the nObj to add.
     */
    addResolveNObjArr=function($nObj) {
        var text = $nObj.text.toLowerCase();
        var tnid = $nObj.temp_nid;
        var rezObj = nlp_signal.addResolve($nObj, tnid, text);
        if (this[text]==undefined) this[text] = [rezObj];
        else this[text].push(rezObj);
        return rezObj;
    }


    /**
     * Psbl roles are what this wd can be conceptualized as.
     * Expect roles are what this wd signals is coming.
     * @param {anne_neuron} - the nObj to add.
     */
    addModeSignalNObjArr=function($nObj) {
        var text = $nObj.text.toLowerCase();
        var tnid = $nObj.temp_nid;
        var mObj = nlp_signal.addMode($nObj, tnid, text);
        if (this[text]==undefined) this[text] = [mObj];
        else this[text].push(mObj);
        return mObj;
    }

    addIsSignalNObjArr=function($nObj) {
        var text = $nObj.text.toLowerCase();
        var tnid = $nObj.temp_nid;
        var isObj = nlp_signal.addIs($nObj, tnid, text);
        if (this[text]==undefined) this[text] = [isObj];
        else this[text].push(isObj);
        return isObj;
    }

    addPosnSignalNObjArr=function($nObj) {
        var text = $nObj.text.toLowerCase();
        var tnid = $nObj.temp_nid;
        var posnObj = nlp_signal.addPosn($nObj, tnid, text);
        if (this[text]==undefined) this[text] = [posnObj];
        else this[text].push(posnObj);
        return posnObj;
    }

    /**
     * Psbl roles are what this wd can be conceptualized as.
     * Expect roles are what this wd signals is coming.
     * @param {anne_neuron} - the nObj to add.
     */
    addExpectsNObjArr=function($nObj) {
        var text = $nObj.text.toLowerCase();
        var tnid = $nObj.temp_nid;
        var eObj = nlp_signal.addExpects($nObj, tnid, text);
        if (this[text]==undefined) this[text] = [eObj];
        else this[text].push(eObj);
        return eObj;
    }
}