class nlp_expectation_pool {
    constructor($name="ec pool") {
        this.expectations = [];
        this._cycle = 0;
        this.name = $name;
        console.log("%c nlp_expectation_pool STARTED", 'background: purple; color: white'); 
    }

    cleanUpForNextClump = function() {
        //port over any umet non clump expectations.
        //role exp, concept exp..
    }
        
    __has = function($type, $tnid, $ph, $bMULTIPLEOK=false, $bMUSTBEINTHISPH=false) {
        var debug = MEMG.getNeuronByTempNid($tnid);
        for (var e=0; e <this.expectations.length; e++) {
            var eObj = this.expectations[e];
            if (eObj.met==true) continue;
            if (eObj.active==false) continue;
            if (eObj.tnid!=$tnid) continue;
            if ($type!="" && eObj.type!=$type) continue;
            if ($bMULTIPLEOK == false && eObj.met == true) continue;
            if ($bMUSTBEINTHISPH==true && eObj.p_index!=$ph.temp_p_index) continue;
            eObj.fire*=1.1;
            console.log("%c __has lookup for "+debug.text+" %c found it!", TALK.bgpurple, TALK.bggreen);
            return true;
        }
        console.log("%c __has lookup for "+debug.text+" %c not found :(", TALK.bgpurple, TALK.bgred);
        return false;
    }
    __hasAny = function($type, $bMULTIPLEOK=false) {
        for (var e=0; e <this.expectations.length; e++) {
            var eObj = this.expectations[e];
            if (eObj.active==false) continue;
            if (eObj.type!=$type) continue;
            if ($bMULTIPLEOK == false && eObj.met == true) continue;
            return true;    //atleast one exists
        }
        return false    //non exists
    }
    __get = function($type, $tnid, $ph, $bMULTIPLEOK=false, $bMUSTBEINTHISPH=false) {
        var debug = MEMG.getNeuronByTempNid($tnid);
        for (var e=0; e <this.expectations.length; e++) {
            var eObj = this.expectations[e];
            if ($bMULTIPLEOK==false && eObj.met==true) continue;
            if (eObj.active==false) continue;
            if (eObj.type!=$type) continue;
            if ($bMUSTBEINTHISPH==true && eObj.p_index!=$ph.temp_p_index) continue;
            console.log("%c __get "+debug.text+" %c found it!", TALK.bgpurple, TALK.bggreen);
            return eObj.tnid;    
        }
        console.log("%c __get "+debug.text+" %c not found :(", TALK.bgpurple, TALK.bgred);
        return null;
    }
    __getAny = function($type, $ph, $bMULTIPLEOK=false, $bMUSTBEINTHISPH=false) {
        for (var e=0; e <this.expectations.length; e++) {
            var eObj = this.expectations[e];
            if ($bMULTIPLEOK==false && eObj.met==true) continue;
            if (eObj.active==false) continue;
            if (eObj.type!=$type) continue;
            if ($bMUSTBEINTHISPH==true && eObj.p_index!=$ph.temp_p_index) continue;
            return eObj.tnid;    
        }
        return null;
    }


    __markFound=function($type, $tnid, $ph, $bMUSTBEINTHISPH=true) {
        for (var e=0; e <this.expectations.length; e++) {
            var eObj = this.expectations[e];
            if (eObj.met==true) continue;
            if (eObj.active==false) continue;
            if ($type!="" && eObj.type!=$type) continue;
            if (eObj.tnid!=$tnid) continue;
            if ($bMUSTBEINTHISPH==true && eObj.p_index!=$ph.temp_p_index) continue;
            eObj.met = true;
            eObj.met_by={ph:$ph};
            eObj.met_cycle=this._cycle;
            if (eObj.p_index!=$ph.temp_p_index) {
                eObj.phrase_delta = Math.abs(eObj.p_index, $ph.temp_p_index);
            }
            this.___metExp(eObj, $ph);
            return true;
        }
    }


    ___metExp=function($eObj, $ph){
        var foundObj = {
            type:"sys-met-exp", 
            cycle:this._cycle++,
            met_exp:$eObj,
            ph:$ph
        };
        this.expectations.push(foundObj);
        foundObj.e_index=this.expectations.length;
    }


    /**
     * Do not call this directly, use the ctp
     */
    __addNew=function($type, $clump_index, $tnid, $p_index, $w_index, $fire=1) {
        var NOBJ = MEMG.getNeuronByTempNid($tnid); //delete this and debug in prod.
        console.log("%c (__addNew) type:"+$type+" %c tnid:"+$tnid+" "+NOBJ.text+" ci:"+$clump_index+" p:"+$p_index+" w:"+$w_index, TALK.bgpink, TALK.bgblack); 
        var text = NOBJ.text;
        //dbug this.
        //console.log(text);
        
        var phwdExpObj = {
                            ci:$clump_index, 
                            debug:NOBJ.text,
                            tnid:$tnid, 
                            type:$type, 
                            cycle:this._cycle++, 
                            met_cycle:-1, 
                            met:false,
                            met_by:null,
                            p_index:$p_index, 
                            w_index:$w_index,
                            fire:$fire,
                            hits:1,
                            bONECANCELSOTHERS:false,
                            active:true
                        };
        this.expectations.unshift(phwdExpObj);
        phwdExpObj.e_index=this.expectations.length;
        return phwdExpObj;
    }

    /**
     * We are seeing something come through..
     * this let's us know how similar it is to things we recently had.
     * We build this pool ONLY WITH THE BE RELONS of the previously resolved neurons.
     * Not their assocs or brain connects or anything else.  ONLY THE TYPE_BEs.
     * 
     * Why?  We don't want all connections as we will find similarity.
     * We want this to be more of a boolean.
     * Sometimes a thing-thing role combo is redunant info...
     * We already resolved it properly via the first thing (Austin, Texas)
     * Othertimes, it can inform us we went the wrong way on the first wd...
     * Further, it can tell us MOD info that can be used to either
     * define a new thing more clearly or resolve a thing more accurately.
     * Language is funny like that... it is a guessing game.. we pick a path as 
     * the info comes in.. and we adjust as things become more clear (more info).
     * 
     * Returns a max of 1, full match.
     * Degrades to 0 if we find this thing in later earlier clumps or
     * zero for not found.
     * 
     * Note:  A list item of different things should score low here.
     * A list of connected things could  score somewhat but not high.
     * We want this to score high for the SAME thing.
     * ie, Austin (resolved to Austin, Texas) and Texas.  (we already captured Texas when resolving Austin).
     * If we have Austin, TX but not Austin, OH, then if we see Austin we will resolve it to Texas.
     * We should next realize that was the wrong resolution and create a new neuron for Austin, OH.
     * If done proper, and context was present going in, we could create Austin,OH straight...
     * ie:  I love Ohio.  There is a little city there I love named Austin.
     */
     poolSimilarity=function($temp_nid, $clump_index, $p_index_max, $maxlookback=5) {
        for (var e=0; e < this.expectations.length; e++) {
            var eObj = this.expectations[e];
            if (eObj.p_index > $p_index_max) continue;
            if ((eObj.ci+$maxlookback) < $clump_index) break;
            if (eObj.tnid==$temp_nid) {
                return Math.min(1, Math.pow((eObj.ci+1)/($clump_index+1),2));
            }
        }
        return 0;
    }

    printPool=function(){
        console.log("%c "+this.name+" expectations:%c"+this.expectations.length, TALK.pooltitle, TALK.bgblue);
        for (var e=0; e < this.expectations.length; e++) {
            var eObj = this.expectations[e];

            //sys documenting meeting an expectation (in time)
            if (eObj.type=="sys-met-exp") {
                console.log("%c e#"+eObj.e_index+" cycle:"+this._cycle+"%c met e#"+eObj.met_exp.e_index+" by %c "+eObj.ph.phrase, ANNE.TALK.bgblack, ANNE.TALK.bgblue, ANNE.TALK.bggreen);
                continue;
            } 

            var nOBJ = MEMG.getNeuronByTempNid(eObj.tnid);
            var metColor = ANNE.TALK.bggreen;
            var met = "met";
            var typecolor = ANNE.TALK.bgblue;
            var obj_text = "";
            var obj_color = ANNE.TALK.bgblackyellow;
            if (eObj.type=="exp-future-role" || eObj.type=="exp-this-role") {
                typecolor = ANNE.TALK.bgpurple;
                obj_text = "["+nOBJ.text+"]";
            }
            else if (eObj.type=="exp-next-wd-ec" || eObj.type=="exp-prev-wd-ec" || eObj.type=="exp-neuron") {
                obj_text = nOBJ.text;
                obj_color = ANNE.TALK.bgivoryblue;
            }
            else {
                obj_text = nOBJ.text;
                obj_color = TALK.bgpink;
            }

            if (eObj.met==false) {
                metColor = ANNE.TALK.bgred;
                met = "not met";
            }
            console.log("%c e#"+eObj.e_index+" ci:"+eObj.ci+" p:"+eObj.p_index+" w:"+eObj.w_index+" cycle:"+this._cycle+"%c "+eObj.type+" %c "+obj_text+"%c fire:"+eObj.fire+" h:"+eObj.hits+" %c "+met, ANNE.TALK.bgblack, typecolor, obj_color, ANNE.TALK.bgfire, metColor);
        }
    }
}
