
var ANNEX = {};

//relon sponsors get paid each time a neuron is ANNEX'd.  This incentivizes building
//good data and COLLAB with ANNE on ANNE-owned USER-sponsored neurons.  Anyone can collab 
//and provide new usable data for an ANNE-owned neuron.  As sponsor they get the fire fee 
//for any feedback on THAT RELON (if someone "loves" the fact Tom Cruise has a birthday of July 3, 1962).
//Note, if they LOVE "July 3, 1962" then the sponsor of that DATE neuron gets the fire fee.
//Any sponsors of relons accumulate the fees as the relon is rated -- but each time the neuron
//is annexed (changes sponsor rights holder) they get paid 3 additional coins.
ANNEX.RELON_SPONSOR_FIRE = 300;

//all relons caculate the same value (regardless of their individual feedback)
//or their type (TEXT/URLS cost more to make but do not generate higher value here)
//if a relon gains feedback ratings that is more valuable but that value is given to the 
//relon sponsor, not the neuron.  This can measure/inform us how popular/active a neural
//circuit is -- but that shows us total "value" of that circuit and relon-feedback doesn't affect the cost of ANNEX.
//Also, NEURON feedback is a value that shows how much this neuron generates.  It does not alter
//the price --- it alters the VALUE.  If a neuron pulls in alot of awareness relons holding its
//sponsorship is lucrative thus it has a high value compared to the annex price (thus is a good deal).
ANNEX.RELON_VALUE = 2000;

ANNEX.no_annex_classes = [];

ANNEX.init=function() {
    ANNEX.no_annex_classes.push(MEM.bounty.nid);
}


/**
 * 
 * @param {*} $nObj 
 * @returns 
 */
ANNEX.assessAnnexabiltyNoChase=function($nObj) {
    if ($nObj.owned_by!=ANNE_ACCTID) return false;
    if ($nObj.is(MEM.identity)==true && ($nObj.ntype==NTYPE_INST || $nObj.ntype==NTYPE_UNKNOWN)) return false;
    if ($nObj.is(MEM.__ANNE_SYS_CLASS)==true && $nObj.is(MEM.gregorian_date)==false) return false;
    if ($nObj.bes[0]==MEM.anndle.temp_nid) return false;
    if ($nObj.bes[0]==MEM.subanndle.temp_nid) return false;
    if ($nObj.is(MEM.PDN)==true) return false;
    if ($nObj.is(MEM.ASDF)==true) return false;
    if ($nObj.is(MEM.bounty)==true) return false;
    return true;
}


/**
 * We need to get BEM line be/sys relons for this nid to figure this out.
 */
ANNEX.assessAnnexability=async($nObj, $bCHASE=false)=> {
    
    if ($nObj.nid==MEM.___SELF___.nid) return false;
    
    if ($nObj.owned_by!=ANNE_ACCTID) return false;
    
    if ($nObj.is(MEM.__ANNE_SYS_CLASS)==true && $nObj.ntype==NTYPE_INST) return false;
    if ($nObj.bes[0]==MEM.anndle.temp_nid) return false;
    if ($nObj.bes[0]==MEM.subanndle.temp_nid) return false;
    if ($nObj.is(MEM.PDN)==true) return false;
    if ($nObj.is(MEM.ASDF)==true) return false;
    if ($nObj.is(MEM.bounty)==true) return false;
    return true;
}


/**
 * 
 */
class anne_annex_gui {
    constructor($el, $GUID="", $nObj=null, $send_cb=null) {
        this.el = $el;
        this.ID = $GUID;
        this.nObj = $nObj;
        this.backlink = null;
        this.new_boosties_in_annecoin = 0;
        this.send_cb = $send_cb;
        this.dossierPTR = null;
        if ($nObj._aplex!=undefined && $nObj._aplex!=null && $nObj._aplex.has_pending==true) {
            this.has_pending=true;
        }
        else this.has_pending=false;
    }


    setParentPtr = function($ptr) {
        this.dossierPTR = $ptr;
    }

    /** 
    smartRefresh = async()=> {
        if (this.nObj!=null && this.el!=null && this.ID!="") {
            ANNE.A.empty("annex_lvl_"+this.ID);
            ANNE.A.empty("annex_cost_to_annex_"+this.ID);
            ANNE.A.empty("annex_boosties_"+this.ID);
            ANNE.A.empty("annex_last_price_"+this.ID);
            ANNE.A.empty("annex_annies_in_"+this.ID);
            ANNE.A.empty("annex_fire_"+this.ID);
            ANNE.A.empty("annex_non_awareness_outs_"+this.ID);
            ANNE.A.empty("annex_sponsored_relons_"+this.ID);
            ANNE.A.empty("annex_total_awareness_"+this.ID);
            ANNE.A.empty("annex_bootsies_input_"+this.ID);
            this.populateANNEX_div(false);
        }
    }
    */

    /**
     */
    annecoin_entered = async($e)=>{
        var el_input = $e.target;
        var val = ANNE.A.getValue(el_input)+"";
        var newval = "";
        var lastChar = "";

        if (val.length==1) lastChar = val;
        else lastChar = val[val.length-1];
        
        if (lastChar=="k" || lastChar=="K") {
            val = val.substring(0, val.length-1);
            this.new_boosties_in_annecoin = Number.parseFloat(val) * 1000;
            el_input.value = this.new_boosties_in_annecoin;
        }
        else if (lastChar=="m" || lastChar=="M") {
            val = val.substring(0, val.length-1);
            this.new_boosties_in_annecoin = Number.parseFloat(val) * 1000000;
            el_input.value = this.new_boosties_in_annecoin;
        }
        else if (lastChar=="b" || lastChar=="B") {
            val = val.substring(0, val.length-1);
            this.new_boosties_in_annecoin = Number.parseFloat(val) * 1000000000;
            el_input.value = this.new_boosties_in_annecoin;
        }

        else {
            for (var v=0; v < val.length; v++) {
                if ("0123456789.,".indexOf(val[v])==-1) continue;
                newval = newval+val[v];
            }
            this.new_boosties_in_annecoin = newval;
        }

        ANNE.A.setValue(el_input, this.new_boosties_in_annecoin);

        var el_boosties_final_btn = document.getElementById("annex_boosties_final_btn_"+this.ID);
        this.new_boosties_in_annecoin = parseInt(this.new_boosties_in_annecoin);
        
        if (this.new_boosties_in_annecoin>=400) {
            ANNE.A.show(el_boosties_final_btn);
            ANNE.A.displayAnnecoinWithCommas("annex_boosties_annies_"+this.ID, this.new_boosties_in_annecoin, true);
        }
        else {
            ANNE.A.hide(el_boosties_final_btn);
            ANNE.A.setHTML("annex_boosties_annies_"+this.ID, "");
        }
    }
    

    /**
     * Boosties are a sys message sent from the neuron being boosted
     * It works like a collab relon in the SYS dimension.
     * If the user is not the current sponsor on record the TX will be rejected.
     */
    final_boosties_submit = async($e)=>{
        var el_boosties_final_btn= document.getElementById("annex_boosties_final_btn_"+this.ID);   
        var el_bootsies_input= document.getElementById("annex_bootsies_input_"+this.ID);
        ANNE.A.hide(el_boosties_final_btn);
        if (parseInt(this.new_boosties_in_annecoin)<=0) {
            el_bootsies_input.focus();
            return;
        }

        ANNE.A.hide(el_bootsies_input);

        if (this.send_cb!=null) {
            this.send_cb(this.new_boosties_in_annecoin * ANNE.ANNE_TO_ANNIES);
            return;
        }

        //this could just be a payment but we want to document it with a relon.
        var aplex = this.nObj._aplex;
        var gui_extras = new Object();
        gui_extras.payment = parseInt(this.new_boosties_in_annecoin * ANNE.ANNE_TO_ANNIES);
        var sys_msg_rel = ANNE.MEMZ.ez_new_sys_msg(this.nObj, MEM.boosties.nid, TO_TYPE_NUMBER, gui_extras.payment, gui_extras);
        if (aplex.last_fullhash!=undefined && aplex.last_fullhash!="") {
            sys_msg_rel.referencedTransactionFullHash = aplex.last_fullhash;
        }

        ANNE.SENDQ.___sendQueue();
    }


    /**
     * 
     */
    soloUseEvents =function($btn, $amtDiv, $input, $finalBtn) {
        $finalBtn.addEventListener("click", e=>this.final_boosties_submit(e));
        $input.addEventListener("input", e=>this.annecoin_entered(e));
        const btn = $btn;
        const amtDiv = $amtDiv;
        const input = $input;
        $btn.addEventListener("click", function($e){
            ANNE.A.show(amtDiv);
            ANNE.A.hide(btn);
            input.focus();
        });
    }


    /**
     * ANNEXes must be confirmed (mined) before they are active.
     * 
     * @param {*} $bDOEVENTS 
     * @param {Object} $backlink - pending annex
     * @returns 
     */
    populateANNEX_div = async($bDOEVENTS=true, $backlink=null)=> {
        this.bDOEVENTS = $bDOEVENTS;
        this.backlink = $backlink;

        if (this.nObj.ghost==true) return;

        //get a new aplex every time now.
        if (this.nObj._aplex!=null && this.nObj._aplex.getAgeInSecs()>10) {
            this.nObj._aplex = null;
        } 

        //console.log("%c NEURON APLEX bug hunt! (ANX.populateANNEX_div)", ANNE.TALK.bgbigred);  
        var aplex = await ANNE.API.getAplex(this.nObj);

        if (aplex==undefined || aplex==null) {
            console.warn("THIS SHOULD NEVER HAPPEN");
            return false;
        }

        if (this.backlink==null) {
            this.backlink = ANNE.MEMG.getUnconfirmedAnnex(this.nObj.outs);
        }

        
        //try for backlink now..
        if (this.nObj._aplex.pending_relon!=null) {
            this.backlink=this.nObj._aplex.pending_relon;
        }
        

        if (ANNE.SETTINGS.debug()==true) console.log(aplex);
        var ret = await aplex.calculate_annex_vars(this.nObj);
        if (ret==undefined) {
            console.log("PROBLEM.");
            alert("fix this annex display issue mr.scatman.");
        }
        if (ret==-1) {
            ANNE.A.hide(el_annex_btn);
            ANNE.A.hide(el_boosties_btn);
            ANNE.A.hide("anneflap_"+this.ID);
            return false;
        }
        ANNE.A.setHTML("annex_lvl_"+this.ID, aplex.price_lvl);
        ANNE.A.setHTML("annexlvltitle_"+this.ID, aplex.price_lvl);
        ANNE.A.empty("annex_cost_to_annex_"+this.ID);
        ANNE.A.ezAnniesToAnneDisplay("annex_cost_to_annex_"+this.ID, aplex.calculated_cost);
        ANNE.A.setHTML("annex_refs_to_profit_"+this.ID, UTILS.formatNumberCommas(Math.ceil(aplex.calculated_cost/200)));

        ANNE.A.empty("annex_boosties_"+this.ID);
        ANNE.A.ezAnniesToAnneDisplay("annex_boosties_"+this.ID, aplex.boosties);

        ANNE.A.empty("annex_last_price_"+this.ID);  
        ANNE.A.ezAnniesToAnneDisplay("annex_last_price_"+this.ID, aplex.prev_annex_price);

        
        ANNE.A.empty("annex_annies_in_"+this.ID);  
        ANNE.A.ezAnniesToAnneDisplay("annex_annies_in_"+this.ID, aplex.annies_in);
        
        
        ANNE.A.setHTML("annex_fire_"+this.ID, UTILS.formatNumberCommas(aplex.fire));
        ANNE.A.setHTML("annex_non_awareness_outs_"+this.ID, UTILS.formatNumberCommas(aplex.non_awareness_outs));
        ANNE.A.setHTML("annex_sponsored_relons_"+this.ID, UTILS.formatNumberCommas(aplex.annex_sponsored_relons));
        ANNE.A.setHTML("annex_total_awareness_"+this.ID, UTILS.formatNumberCommas(aplex.total));
        ANNE.A.fadeIn(this.el);
        var el_annex_btn= document.getElementById("annex_btn_"+this.ID);
        var el_boosties_btn = document.getElementById("annex_boosties_btn_"+this.ID);
        var el_boosties_amt_div= document.getElementById("annex_boosties_amt_div_"+this.ID);
        ANNE.A.hide(el_boosties_amt_div);
        var el_bootsies_input= document.getElementById("annex_bootsies_input_"+this.ID);
        var el_boosties_final_btn= document.getElementById("annex_boosties_final_btn_"+this.ID);

 
        //no self-annex.
        //boosties ok.
        if (this.nObj.sponsored_by==USER._userNObj.nid || (this.nObj.sponsored_by=="" && this.nObj.owned_by==USER._userNObj.nid)) {
            ANNE.A.hide(el_annex_btn);
            ANNE.A.show(el_boosties_btn);

            //we need a boosties modal with boosty amount
            if ($bDOEVENTS) {
                if (el_boosties_final_btn!=null) el_boosties_final_btn.addEventListener("click", e=>this.final_boosties_submit(e));
                if (el_bootsies_input!=null) {
                    el_bootsies_input.addEventListener("input", e=>this.annecoin_entered(e));
                }
                if (el_boosties_btn!=null) el_boosties_btn.addEventListener("click", function($e){
                    ANNE.A.show(el_boosties_amt_div);
                    ANNE.A.hide(el_boosties_btn);
                    el_bootsies_input.focus();
                });
            }
        }

        else {
            if (el_annex_btn!=null) ANNE.A.show(el_annex_btn);
            if (el_boosties_btn!=null) ANNE.A.hide(el_boosties_btn);
            if ($bDOEVENTS) {
                if (el_annex_btn!==null) el_annex_btn.addEventListener("click", e=>this.annexNow(e));
            }
        }

        if (this.backlink!=null) {
            var el_backlink = document.getElementById("annex_pending_"+this.ID);
            if (el_backlink==null) {
                return true;
            }
            var what = "";
            if (this.backlink.r==ANNE.MEM.annex.temp_nid) {
                what="annex ";
            }
            else if (this.backlink.r==ANNE.MEM.boosties.temp_nid) {
                what="boosties ";
            }
            EXT_BTNS.makeRelonViewLink_SMART(el_backlink, this.backlink, false, 8, true, "", "MEMPOOL HAS PENDING "+what+"CHANGE");
            ANNE.A.show(el_backlink);
            ANNE.A.hide(el_annex_btn);
            ANNE.A.hide(el_boosties_btn);
            var el_refresh = ANNE.A.show("annex_pending_refresh");
            if (el_refresh!=null) el_refresh.addEventListener("click", e=>this.refreshThis(e));
        }
        else if (this.has_pending==true) {
            console.log(this.nObj._aplex);
            var el_backlink = document.getElementById("annex_pending_"+this.ID);
            if (el_backlink==null) {
                return true;
            }
            el_backlink.innerHTML="MEMPOOL HAS PENDING CHANGE";
            ANNE.A.show(el_backlink);
            ANNE.A.hide(el_annex_btn);
            ANNE.A.hide(el_boosties_btn);
            var el_refresh = ANNE.A.show("annex_pending_refresh");
            if (el_refresh!=null) {
                el_refresh.addEventListener("click", e=>this.refreshThis(e));
            }
        }

        //do we freeze on annex pending still?
        //have to check the annode.. arrrrg.
        else if (this.nObj.freeze==1) {
            el_annex_btn.setAttribute("disabled", true);
            el_annex_btn.setAttribute("title", "When prev TXs are mined the neuron will be unfrozen.");
            ANNE.A.hide(el_annex_btn);
            
            el_boosties_btn.setAttribute("disabled", true);
            el_boosties_btn.setAttribute("title", "When prev TXs are mined the neuron will be unfrozen.");
            ANNE.A.hide(el_boosties_btn);
        }

        return true;
    }
    

    /**
     * Refresh this..
     * @param {*} $e 
     */
    refreshThis = async($e)=>{
        if (this.dossierPTR!=null) {
            this.dossierPTR.refreshAnnex();
        }
    }


    /**
     * in TXB handler we will set the .has_pending for this session.
     * It will get updated when a new _annex obj is pulled.
     */
    annexNow = async($e)=>{
        var aplex = this.nObj._aplex;
        var gui_extras = new Object();
        gui_extras.payment = aplex.calculated_cost;
        
        var sysmsg_rel = await ANNE.MEMZ.ez_new_sys_msg(USER._userNObj, MEM.annex.nid, TO_TYPE_ANNE, this.nObj.nid, gui_extras, null);
        
        //critical for this to get accepted via the node if it is anything other than 
        //the first lvl of annexing.  All non-first lvls must reference the previous annex
        //transaction to create a chain of annexings that flow for annex documentation in time.
        //We have this data without the chain but it is an extra helper that is useful.
        if (aplex.last_fullhash!=undefined && aplex.last_fullhash!="") {
            sysmsg_rel.referencedTransactionFullHash = aplex.last_fullhash;
        }

        //const _APLX = aplex;
        ANNE.SENDQ.___sendQueue();
    }
}
