class feedback_widget {
    constructor($identity_nid, $target_id, $targetType=TARGET_NID, $bFEELZ=true, $bOPINIONZ=true){
        this.guid = UTILS.randHex(4);
        this.target_id = $target_id;
        this.target_type = $targetType;
        this.identity_nid = $identity_nid;
        this.bFEELZ = $bFEELZ;
        this.bOPINIONZ = $bOPINIONZ;
        this._target_nObj = null;
        this._target_relon = null;
        this._target_obj = null;
        this.el_container = null;
        this.search_btns = [];
        this.search_btns_selected = [];
        
        this._onBucket = null;
        if ($targetType==TARGET_NID) {
            this._target_nObj = MEMG.getNeuronByNid($target_id);
            this.to_type = TO_TYPE_ANNE;
            console.log("target nobj set");
            this._target_obj = this._target_nObj;
        }
        else if ($targetType==TARGET_TXID) {
            this._target_relon = MEMG.lookupByTXID($target_id);
            this.to_type = TO_TYPE_TXID;
            console.log("target relon set");
            this._target_obj = this._target_relon;
        }
        this._refreshCb = null;
    }

 
    /**
     * User has clicked a single button to toggle
     */
    btnToggleSelected = async($e)=>{
        var btn=$e.target;
        btn = ANNE.A.getFirstParentOf(btn, "afb-lower-btn", true);
        var tnid = btn.getAttribute("tnid");
        if (tnid==undefined) return; //should not  happen.
        tnid = parseInt(tnid);

        if (btn.classList.contains("selected")==true) {
            btn.classList.remove("selected");
            UTILS.removeFromNidArray(this.search_btns_selected, tnid);

            //if its polarity is different than the active polarity
            //remove this btn that was on but now is off.
            var pol = btn.getAttribute("polarity");
            if (pol!=this.active_polarity) {
                ANNE.A.removeSelf(this.guid+"_"+tnid);//remove it from the dipaly form.
            }
        }
        else {
            btn.classList.add("selected");
            this.search_btns_selected.push(tnid);
            var nOBJ = MEMG.getNeuronByTempNid(tnid);
            //console.log(nOBJ.text+" "+nOBJ.nid);
        }
        this._showhideSubmit();
    }


    /**
     */
    _removeAllNonSelected=function(){
        //remove btns on screen that are NOT IN MATCHES (if they are not in SELECTED).
        for (var s=0; s < this.search_btns.length; s++) {
            var tnid = this.search_btns[s];
            if (this.search_btns_selected.indexOf(tnid)==-1) {
                ANNE.A.removeSelf(this.guid+"_"+tnid);
                this.search_btns.splice(s, 1);
                s = s-1;
            }
        }
    }


    /**
     * All feedback is first ghosted.
     * It can be thus used by users with no ANNE coin.
     * It can also help prevent accidental clicks of items that become 
     * permanant.  Data can be deleted in ANNE hypergraph indexes but it can never
     * be taken out of the broadcasted transactions in the blockchain layer.
     * Also relevant, AWARENESS relons of feelz/opinionz CANNOT be pruned.  They can be updated
     * and are relevant snapshots of any given "moment" in time (for a given user).
     * 
     * U may love politican X right now.. and hate them next year.  That is relevant.
     */
    _submitFeedback=async($e)=>{
        ANNE.A.hide(this.el_submit);
        ANNE.A.empty(this.el_submit_msg, true);
        console.log("submit selected feedback relons");
        var new_rels = [];
        for (var s=0; s < this.search_btns_selected.length; s++) {
            var tnid = this.search_btns_selected[s];
            var feedbackNOBJ = MEMG.getNeuronByTempNid(tnid);
            var awarezROBJ = ANNE.MEM.makeTempRelon(USER._userNObj, TYPE_AWARENESS, feedbackNOBJ.nid, this.to_type, this.target_id, true, false);
            MEMZ.ez_setNARRPtrsForNew(awarezROBJ); 
            new_rels.push(awarezROBJ);

            //we add in this one data point.. since we will not be going to the ANNODE
            //to pull a new aplex (which adds in ghost tallies after pull)
            AWARE.tallyTempAplex(this._target_obj, this.target_id, feedbackNOBJ);
        }

        //we want to send FEEDBACK STRAIGHT AWAY, no queue.

        await GHOSTDATA.localGhostTheRelons(new_rels);

            
        //don't delete our injected el_search_matches_lowerz.
        ANNE.A.emptyAllBut(this.el_search_matches, this.el_search_matches_lowerz, true);
        
        ANNE.A.empty(this.el_search_matches_lowerz, true);
        this.search_btns_selected = [];
        this.search_btns = [];


        for (var r=0; r < new_rels.length; r++) {
            await SENDQ.addRelonToSendQ(new_rels[r], false, TXB.TXTYPE_SELF_RELON);   
        }
        
        ANNE.playSound("success");
        
        return await ANNE.MEM_UDF.sendFeelzQueue();

        //+return await SENDQ.___sendQueue();
    }

    /**
     * 
     */
    _showhideSubmit=function(){
        if (this.search_btns_selected.length) this._showSubmit();
        else this._hideSubmit();
    }

    /**
     * 
     */
    _showSubmit=function(){
        ANNE.A.show(this.el_submit);
        //var str = ANNE.MEMG.getTextListStrFromTnids(this.search_btns_selected, ", ");
        //ANNE.A.setHTML(this.el_submit_msg, str, true);
        this._buildColorTags();
    }

    /**
     * 
     */
    _hideSubmit=function(){
        ANNE.A.hide(this.el_submit);
        ANNE.A.empty(this.el_submit_msg, true);
    }

    /**
     * 
     */
    _buildColorTags = function(){
        ANNE.A.empty(this.el_submit_msg);
        for (var s=0; s < this.search_btns_selected.length; s++) {
            var nObj = MEMG.getNeuronByTempNid( this.search_btns_selected[s] );
            var pol = nObj.pol;
            if (pol==undefined) continue;
            ANNE.A.ezSpan(this.el_submit_msg, "", "text-tag-"+nObj.pol, nObj.text);
        }
        ANNE.A.show(this.el_submit_msg);
    }

    /**
     * User has typed in the feedback widget.
     * Show all feelz/opinionz that match typed in text.
     */
    _search = async($val)=>{
        if ($val.length<=1) {
            this._removeAllNonSelected();
            if (this.search_btns_selected.length==0) this._hideSubmit();
            return;
        }

        var matches = AWARE.lookupAny($val);
        var match_tnids=[];

        for (var m=0; m < matches.length; m++) {
            var match = matches[m];
            match_tnids.push(match.nObj.temp_nid);
            
            if (this.search_btns.indexOf(match.nObj.temp_nid)!=-1) continue;

            if (match.nObj.pol==undefined || match.nObj.atype==undefined) {
                console.log(match);
                console.log(match.nObj.text + " "+match.nObj.nid);
                continue;
            }

            var btn = ANNE.A.ezFbwBtn(this.el_search_matches_lowerz, match.nObj.temp_nid, this.guid, "afb-lower-btn afb-"+match.nObj.pol, this.btnToggleSelected); 
            ANNE.A.ezEl(btn, "div", "afb-"+match.nObj.atype+" bg-"+match.nObj.pol);
            ANNE.A.ezEl(btn, "div", "afb-lower-text", match.nObj.bestName());
            this.search_btns.push(match.nObj.temp_nid);
        }

        //remove btns on screen that are NOT IN MATCHES (if they are not in SELECTED).
        for (var s=0; s < this.search_btns.length; s++) {
            var tnid = this.search_btns[s];
            if (match_tnids.indexOf(tnid)==-1) {                    //this search didn't include a prev result..
                if (this.search_btns_selected.indexOf(tnid)==-1) {  //if not selected, remove
                    var nOBJ = MEMG.getNeuronByTempNid(tnid);
                    ANNE.A.removeSelf(this.guid+"_"+nOBJ.temp_nid);
                    this.search_btns.splice(s, 1);
                    s = s-1;
                }
            }
        }

        if (this.search_btns.length==0 && this.search_btns_selected.length==0) {
            ANNE.A.hide(this.el_search_matches_lowerz);
        }
        else ANNE.A.show(this.el_search_matches_lowerz);
    }

    

    /**
     */
    buildWidgetGUI=async($el, $bDOFEEDBACKLINE=false)=> {
        this.el_container = ANNE.A.__getEl($el);

        
        //if we already have _aplex object, use it.
        if (this._target_nObj!=null && this._target_nObj._aplex!=null) {
            this._aplex=this._target_nObj._aplex;
        }

        else {
            if (this._target_nObj._aplex_sum!=undefined && this._target_nObj._aplex_sum!=null && this._target_nObj._aplex_sum._aplex!=null) {
                this._aplex=this._target_nObj._aplex_sum._aplex;
            }
            else {
                console.log("%c NEURON APLEX bug hunt! (buildWidgetGUI)", ANNE.TALK.bgbigred);
                this._aplex = await CHASE.get_aplex_data(this.target_id, false, "feedback_widget.buildWidgetGUI");
            }
        }

        console.log(this._aplex);
        
        this.el_widget = ANNE.A.ezEl(this.el_container, "div", "afb-widget", "", "fbw_"+this.target_id);
        var row = ANNE.A.ezEl(this.el_widget, "div", "afb-layout");
        var col2 = ANNE.A.ezEl(row, "div", "afb-search");
        this.el_search_input = ANNE.A.ezInputText(col2, "input_"+this.guid, "afb-search-input2", "feelz/opinionz", this._search);
        
        var col3 = ANNE.A.ezEl(row, "div", "aware-nest");
        this.classicWidget(col3);

        this.el_submit = ANNE.A.ezButtonWithIcoClass(row, "", "<span style='margin-top:4px'>&nbsp;broadcast feedback</span>", "broadcast-btn hide", this._submitFeedback, "broadcast-ico");
       
        this.el_submit_msg = ANNE.A.ezEl(this.el_widget, "div", "afb-msg", "");
        this.el_search_matches = ANNE.A.ezEl(this.el_widget, "div", "afb-search-matches");
        this.el_search_matches_lowerz = ANNE.A.ezEl(this.el_search_matches, "div", "afb-search-matches-lowerz");
        
        ANNE.A.hide(this.el_search_matches);
        
        if ($bDOFEEDBACKLINE==true) {
            this._assessMyFeedback();
        }
    }

    
    /**
     * 
     * @param {*} $el 
     * @returns 
     */
    classicWidget = function($el){
        var el = ANNE.A.__getEl($el);
        if (el == null) return;

        
        this.el_btn_row = ANNE.A.ezEl(el, "div", "tg-btns", "", "");
        
        var THISWIDGET=this;
        THISWIDGET.active_polarity = "";

        /**************************** */
        //TOP POSITIVE POLARITY BUTTON
        this.btn_pos = ANNE.A.ezButton(this.el_btn_row, "btn_pos_"+this.guid, "+", "aware-pos-btn", ($e)=>{
            this.btn_neu.classList.remove("selected", false);
            this.btn_neg.classList.remove("selected",  false);
            if (this.btn_pos.classList.contains("selected")==false) {
                THISWIDGET.resetAllFromPolSwitch();
                this.btn_pos.classList.add("selected",  true);
            
                //turn buckets on.
                THISWIDGET.makeBuckets(this.btn_pos, AWARE._awarez.bucket_pos, AWARE._awarez.op_pos);
                THISWIDGET.active_polarity = "pos";
            }
            else {
                THISWIDGET.resetAllFromPolSwitch();
                THISWIDGET.active_polarity = "";
                this.btn_pos.classList.remove("selected");
                
            }
        });
        this.btn_pos.setAttribute("polarity", "pos");
        this.btn_pos.setAttribute("active", false);
        this.btn_pos.setAttribute("tnid", MEM.positive.temp_nid);
        /**************************** */
       

        /**************************** */
        //TOP NEGATIVE POLARITY BUTTON
        this.btn_neu = ANNE.A.ezButton(this.el_btn_row, "btn_neu_"+this.guid, "/", "aware-neu-btn", ($e)=>{
            this.btn_pos.classList.remove("selected", false);
            this.btn_neg.classList.remove("selected",  false);
            if (this.btn_neu.classList.contains("selected")==false) {
                THISWIDGET.resetAllFromPolSwitch();
                this.btn_neu.classList.add("selected",  true);
                THISWIDGET.makeBuckets(this.btn_neu, AWARE._awarez.bucket_neu, []);
                THISWIDGET.active_polarity = "neu";
            }
            else {
                THISWIDGET.resetAllFromPolSwitch();
                THISWIDGET.active_polarity = "";
                this.btn_neu.classList.remove("selected");
            }
        });
        this.btn_neu.setAttribute("polarity", "neu");
        this.btn_neu.setAttribute("active", false);
        this.btn_neu.setAttribute("tnid", MEM.neutral.temp_nid);
        /**************************** */


        /**************************** */
        //TOP NEUTRAL POLARITY BUTTON
        this.btn_neg = ANNE.A.ezButton(this.el_btn_row, "btn_neg_"+this.guid, '-', "aware-neg-btn", ($e)=>{
            this.btn_neu.classList.remove("selected", false);
            this.btn_pos.classList.remove("selected",  false);
            if (this.btn_neg.classList.contains("selected")==false) {
                THISWIDGET.resetAllFromPolSwitch();
                this.btn_neg.classList.add("selected",  true);
                THISWIDGET.makeBuckets(this.btn_neg, AWARE._awarez.bucket_neg, AWARE._awarez.op_neg);
                THISWIDGET.active_polarity = "neg";
            }
            else {
                THISWIDGET.resetAllFromPolSwitch();
                THISWIDGET.active_polarity = "";
                this.btn_neg.classList.remove("selected", false); 
            }
        });
        this.btn_neg.setAttribute("polarity", "neg");
        this.btn_neg.setAttribute("active",false);
        this.btn_neg.setAttribute("tnid", MEM.negative.temp_nid);
        /**************************** */

    }
    

    /**
     * A top level +-/ button has been closed.  (was open, now is closing)
     * remove buttons from gui.
     */
    resetAllFromPolSwitch=function(){
        console.log("buttons selected:"+this.search_btns_selected.length);
        console.log("buttons in results:"+this.search_btns.length);
        //removes all buttons.
        for (var s=0; s < this.search_btns.length; s++) {
            var tnid = this.search_btns[s];

            //if the button was selected, leave it in the gui.
            if (this.search_btns_selected.indexOf(tnid)!=-1) continue; //leave this one on

            var nOBJ = MEMG.getNeuronByTempNid(tnid);
            ANNE.A.removeSelf(this.guid+"_"+nOBJ.temp_nid);
        }

        this.search_btns=[];
        this._onBucket = null;

        //remove any emulated opinion polarity bucket that were injected
        ANNE.A.removeSelf(this.guid+"_opz_pos");
        ANNE.A.removeSelf(this.guid+"_opz_neg");
        ANNE.A.removeSelf(this.guid+"_opz_neu");
            
        //replace any search val btns from the input field text that persists.
        var val = ANNE.A.getValue("input_"+this.guid);
        this._search(val);
    }


    /**
     * Turn off a polarity if it is on.
     * ANOTHER top level polarity has been turned on.
     * We need to remove all the other stuff (not selected) from the gui.
     * 
     * Remove buttons from GUI and the search_btns tracking array.
     * @param {*} $btn 
     */
    wipeAll = async($btn, $arr)=>{
        var btn = ANNE.A.__getEl($btn);

        if (btn.classList.contains("selected")==true) {
            btn.classList.remove("selected");
            btn.setAttribute("active", 0);
            for (var b=0; b < $arr.length; b++) {
                var bucket = $arr[b];
                for (var f=0; f < bucket.feelz.length; f++) {
                    var feelz = bucket.feelz[f];
                    if (this.search_btns_selected.indexOf(feelz.nObj.temp_nid)!=-1) continue; //leave this one on
                    UTILS.removeFromNidArray(this.search_btns, feelz.nObj.temp_nid);
                    ANNE.A.removeSelf(this.guid+"_"+feelz.nObj.temp_nid);
                }
            }
            this._onBucket=null;
        }
    }



    /**
     * Turn a fz bucket off (remove all sub feelz) if it is on.
     * @param {*} $bucket 
     * @returns 
     */
    turnOffBucketIfOn = async($bucket)=>{
        if ($bucket==null) return false;
        var btn = ANNE.A.__getEl(this.guid+"_"+$bucket.nObj.temp_nid);
        btn.classList.remove("selected");
        btn.setAttribute("active", 0);
        var feelz = $bucket.feelz;

        for (var f=0; f < feelz.length; f++) {
            if (this.search_btns_selected.indexOf(feelz[f].nObj.temp_nid)!=-1) continue; //leave this one on
            UTILS.removeFromNidArray(this.search_btns, feelz[f].nObj.temp_nid);
            ANNE.A.removeSelf(this.guid+"_"+feelz[f].nObj.temp_nid);
        }
        return true;
    }


    /**
     * Makes feelz and opinion bucket of a given polarity.y
     * @returns 
     */
    makeBuckets=function($btn, $arr, $op_arr=null){

        //+-/ pol button is already active... which means we are CLOSING the div via a click.
        //var active  = $btn.getAttribute("selected");
        //if (parseInt(active)==1) {
            //$btn.setAttribute("active", 0);
            //this.resetAllNoBtnsOpen();
            //return;
        //}

        //turn the bucket button on.
        $btn.setAttribute("active", 1);
        if ($btn.classList.contains("selected")==false) $btn.classList.add("selected"); //redundant.
        
        //get the polarity of the bucket
        var polarity = $btn.getAttribute("polarity");

        console.log("polarity of OPENED bucket "+polarity);

        //loop this fz bucket for its buttons.
        for (var p=0; p < $arr.length; p++) {
            var bucket =  $arr[p];
            if (this.search_btns.indexOf(bucket.nObj.temp_nid)!=-1) continue;
            if (bucket.nObj.pol==undefined || bucket.nObj.atype==undefined) continue;
            var btn = ANNE.A.ezFbwBtn_prepend(this.el_search_matches, bucket.nObj.temp_nid, this.guid, "afb-btn afb-"+bucket.nObj.pol, this.btnToggleFzBucket); 
            btn.setAttribute("id", this.guid+"_"+bucket.nObj.temp_nid);
            ANNE.A.ezEl(btn, "div", "afb-"+bucket.nObj.atype+" bg-"+bucket.nObj.pol);
            ANNE.A.ezEl(btn, "div", "afb-text", bucket.nObj.bestName());
            btn.setAttribute("polarity", bucket.nObj.pol);
            this.search_btns.push(bucket.nObj.temp_nid);
        }

        //loop the opinions array (if it exists for the polarity)
        if ($op_arr!=null && $op_arr.length) {
            var btn = ANNE.A.ezFbwBtn_prepend(this.el_search_matches, "", this.guid, "afb-btn afb-"+polarity, this.btnToggleOpBucket); 
            btn.setAttribute("id", this.guid+"_opz_"+polarity);
            btn.setAttribute("opz", polarity);
            ANNE.A.ezEl(btn, "div", "afb-opz-bucket bg-"+polarity);
            ANNE.A.ezEl(btn, "div", "afb-text", "opinions");
            btn.setAttribute("polarity", polarity);
        }
 
        //show the matches.
        ANNE.A.show(this.el_search_matches);
        ANNE.A.show(this.el_search_matches_lowerz);
    }




    /**
     * A opinion polarity button has been toggled.
     * @param {*} $e 
     */
    btnToggleOpBucket = async($e)=> {
        var btn=$e.target;
        btn = ANNE.A.getFirstParentOf(btn, "afb-btn", true);
        var opz = btn.getAttribute("opz");
        if (ANNE.UTILS.isset(opz)==false) return; //should not  happen.
        
        console.log("(btnToggleOpBucket) opz "+opz);
        
        var opz_arr = [];
        if (opz=="pos") opz_arr = AWARE._awarez.op_pos;
        else opz_arr = AWARE._awarez.op_neg;
       
        //remove all opinions not selected from the gui.
        //this opinion bucket is being closed.
        if (btn.classList.contains("selected")==true) {
            btn.classList.remove("selected");
            btn.setAttribute("active", 0);
            for (var a=0; a < opz_arr.length; a++) {
                var opNOBJ = opz_arr[a];
                if (this.search_btns_selected.indexOf(opNOBJ.temp_nid)!=-1) continue; //leave this one on
                UTILS.removeFromNidArray(this.search_btns, opz_arr[a].temp_nid);
                ANNE.A.removeSelf(this.guid+"_"+opNOBJ.temp_nid);
            }
        }

        //display all opinions in this opinionz polarity bucket.
        else {
            btn.classList.add("selected");
            btn.setAttribute("active", 1);
            for (var a=0; a < opz_arr.length; a++) {
                var opNOBJ = opz_arr[a];
                var btn = ANNE.A.ezFbwBtn(this.el_search_matches_lowerz, opNOBJ.temp_nid, this.guid, "afb-lower-btn afb-"+opNOBJ.pol, this.btnToggleSelected);
                btn.setAttribute("id", this.guid+"_"+opNOBJ.temp_nid); 
                btn.setAttribute("polarity", opNOBJ.pol);
                //ANNE.A.ezEl(btn, "div", "afb-"+opNOBJ.atype+" bg-"+opNOBJ.pol);
                ANNE.A.ezEl(btn, "div", "afb-lower-text", opNOBJ.bestName());
                if(this.search_btns_selected.indexOf(opNOBJ.temp_nid)!=-1) continue;
                
                this.search_btns.push(opNOBJ.temp_nid);
            }
        }

        this._showhideSubmit();
    }


    /**
     * 
     * @param {*} $e 
     * @returns 
     */
    btnToggleFzBucket = async($e)=>{
        var btn=$e.target;
        btn = ANNE.A.getFirstParentOf(btn, "afb-btn", true);
        var tnid = btn.getAttribute("tnid");
        if (tnid==undefined) return; //should not  happen.
        
        tnid = parseInt(tnid);
        console.log("(btnToggleFzBucket) tnid "+tnid);
        
        var nOBJ = MEMG.getNeuronByTempNid(tnid);
        console.log(nOBJ.text+" "+nOBJ.nid);
        console.log(nOBJ);
        var bucket = AWARE._awarez.bucketMap[tnid];
        if (bucket==null) return;

        var feelz = bucket.feelz;

        //remove all feelz not selected from the gui.
        //this feelz bucket is being closed.
        if (btn.classList.contains("selected")==true) {
            btn.classList.remove("selected");
            btn.setAttribute("active", 0);
            for (var f=0; f < feelz.length; f++) {
                if (this.search_btns_selected.indexOf(feelz[f].nObj.temp_nid)!=-1) continue; //leave this one on
                UTILS.removeFromNidArray(this.search_btns, feelz[f].nObj.temp_nid);
                ANNE.A.removeSelf(this.guid+"_"+feelz[f].nObj.temp_nid);
            }
        }

        else {

            //turn off any other bucket (if it was on);
            this.turnOffBucketIfOn(this._onBucket); 

            btn.classList.add("selected");
            this._onBucket = bucket;

            for (var f=0; f < feelz.length; f++) {
                var fNOBJ = feelz[f].nObj;
                var btn = ANNE.A.ezFbwBtn(this.el_search_matches_lowerz, fNOBJ.temp_nid, this.guid, "afb-lower-btn afb-"+fNOBJ.pol, this.btnToggleSelected); 
                btn.setAttribute("id", this.guid+"_"+fNOBJ.temp_nid);
                ANNE.A.ezEl(btn, "div", "afb-"+fNOBJ.atype+" bg-"+fNOBJ.pol);
                ANNE.A.ezEl(btn, "div", "afb-lower-text", fNOBJ.bestName());
                btn.setAttribute("polarity", fNOBJ.pol);
                if(this.search_btns_selected.indexOf(fNOBJ.temp_nid)!=-1) continue;
                this.search_btns.push(fNOBJ.temp_nid);
            }
        }

        this._showhideSubmit();
    }


    
    /**
     */
    _assessMyFeedback=function() {
        this._myfeelz = MEM_UDF.getMyFeelzFor(this.target_id, this.to_type);
        if (this._myfeelz.length>0) {
            if (this.el_results==null) {
                this.buildResultsGUI();
            }
            //rebuilt bar.
            else {
                ANNE.A.empty(this.el_results);
                this.buildResultsGUI();
            }
        }
    }


    /**
     */
    buildResultsGUI=function(){
        if (this.el_results==null) {
            this.el_results = ANNE.A.ezElPrepend(this.el_widget, "div", "afb-results");
        }
        var total = this._aplex.total;
        var posPercent = "";
        var neuPercent = "";
        var negPercent = "";
        var totalBarTime=2;
        var timepos = 0;
        var timeneu = 0;
        var timeneg = 0;
        var delayneu = 0;
        var delayneg = 0;

        if (this._aplex.pos>0) {
            posPercent = 100*(this._aplex.pos/total)+"%";
            timepos = totalBarTime*(this._aplex.pos/total);
        }
        if (this._aplex.neu>0) {
            neuPercent = 100*(this._aplex.neu/total)+"%";
            timeneu = totalBarTime*(this._aplex.neu/total);
            delayneu = timepos;
        }
        if (this._aplex.neg>0) {
            negPercent = 100*(this._aplex.neg/total)+"%";
            timeneg = totalBarTime*(this._aplex.neg/total);
            delayneg = timepos+timeneu;
        }

        if (posPercent.length>0) {
            var elPosBar = ANNE.A.ezEl(this.el_results, "div", "bar-positive");
            elPosBar.style.width="0%";
            elPosBar.setAttribute("title", UTILS.commas(this._aplex.pos)+ " of "+total);
            elPosBar.style['transition-duration']=timepos+"s";
            window.getComputedStyle(elPosBar);
            elPosBar.style['width']=posPercent;
        }
        if (neuPercent.length>0) {
            var elNeuBar = ANNE.A.ezEl(this.el_results, "div", "bar-neutral");
            elNeuBar.style.width="0%";
            elNeuBar.setAttribute("title", UTILS.commas(this._aplex.neu)+ " of "+total);
            elNeuBar.style['transition-delay']=delayneu+"s";
            elNeuBar.style['transition-duration']=timeneu+"s";
            window.getComputedStyle(elNeuBar);
            elNeuBar.style['width']=neuPercent;
        }
        if (negPercent.length>0) {
            var elNegBar = ANNE.A.ezEl(this.el_results, "div", "bar-negative");
            elNegBar.style.width="0%";
            elNegBar.setAttribute("title", UTILS.commas(this._aplex.neg)+ " of "+total);
            elNegBar.style['transition-delay']=delayneg+"s";
            elNegBar.style['transition-duration']=timeneg+"s";
            window.getComputedStyle(elNegBar);
            elNegBar.style['width']=negPercent;
        }
    }
}


/** 
 * This is the TYPE_AWARENESS DIMENSION relons. 
 * It will include feelz and opinionz, among other classes.
 */
 var AWARE = {}
 AWARE._jt = {};         //json template
 AWARE._aWidgets = [];
 AWARE._aindex = [];
 AWARE._preloadedRAM_emulateID=false;   //only need to do this once (if emulating)
 AWARE.fzOpNids = []; //for relons to push to right IDB 
 AWARE._all = [];
 AWARE._opinionz =[];
 AWARE._feelz = [];
 AWARE._awarez = {};
 AWARE._awarez.op_pos = [];
 AWARE._awarez.op_neg = [];
 AWARE._awarez.bucket_pos = [];
 AWARE._awarez.bucket_neg = [];
 AWARE._awarez.bucket_neu = [];

 AWARE.init = async()=> {
    AWARE.awareness = MEMG.getNeuronByNid("7771625230671441430");
    AWARE.polarity = MEMG.getNeuronByNid("7778811780002344235");
    AWARE.neg_op_bucket = MEMG.getNeuronByNid("7772878965553112082");
    AWARE.pos_op_bucket = MEMG.getNeuronByNid("7775045073476665086");
    
    var feelzBuckets = [];
    var bucketMap = {};

    //opinionz are not necessarily classified as be-children of opinionz.
    //they can be things, states.. etc.. but then are tied laterally to their opinionz bucket.

    AWARE.neg_op_bucket.outs.sort(UTILS.sortRelonsByToNObjText);
    var bucketNegOp = {nObj:AWARE.neg_op_bucket, _opinionz:[], pol:"neg", parent_tnid:MEM.negative.temp_nid};
    bucketMap[AWARE.neg_op_bucket.temp_nid] = bucketNegOp;
    AWARE.neg_op_bucket.pol="neg";
    for (var n=0; n < AWARE.neg_op_bucket.outs.length; n++) {
        var rel = AWARE.neg_op_bucket.outs[n];
        if (rel.type!=TYPE_HAS) continue;
        if (rel.r!=MEM.opinionz.temp_nid) continue;
        var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
        toNOBJ.polarity = -1;
        toNOBJ.pol="neg";
        toNOBJ.atype="opz";
        AWARE._all.push({nObj:toNOBJ, bucket:bucketNegOp});
        AWARE.fzOpNids.push(toNOBJ.nid);
        AWARE._opinionz.push(toNOBJ);
        AWARE._awarez.op_neg.push(toNOBJ);
        bucketNegOp._opinionz.push(toNOBJ);
    }

    AWARE.pos_op_bucket.outs.sort(UTILS.sortRelonsByToNObjText);
    AWARE.pos_op_bucket.pol="pos";
    var bucketPosOp = {nObj:AWARE.pos_op_bucket, _opinionz:[], pol:"pos", parent_tnid:MEM.positive.temp_nid};
    bucketMap[AWARE.pos_op_bucket.temp_nid] = bucketPosOp;
    for (var p=0; p < AWARE.pos_op_bucket.outs.length; p++) {
        var rel = AWARE.pos_op_bucket.outs[p];
        if (rel.type!=TYPE_HAS) continue;
        if (rel.r!=MEM.opinionz.temp_nid) continue;
        var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
        toNOBJ.polarity = 1;
        toNOBJ.pol="pos";
        toNOBJ.atype="opz";
        AWARE._all.push({nObj:toNOBJ, bucket:bucketPosOp});
        AWARE.fzOpNids.push(toNOBJ.nid);
        AWARE._opinionz.push(toNOBJ);
        AWARE._awarez.op_pos.push(toNOBJ);
        bucketPosOp._opinionz.push(toNOBJ);
        //AWARE.addToAINDEX(toNOBJ);
        //console.log("opinionz (+1):"+toNOBJ.text);
    }
    
    for (var f=0; f < MEM.feeling.ins.length; f++) {
        var bucket_rel = MEM.feeling.ins[f];
        if (bucket_rel.type!=TYPE_BE) continue;
        if (bucket_rel.r!=MEM.class.temp_nid) continue;

        //don't need ec -> relon.
        if (bucket_rel.from_nid==7770855606276797271) continue;
        
        var bucketNOBJ = MEMG.getNeuronByTempNid(bucket_rel.f);
        var polarity = bucketNOBJ.polarity;

        if (polarity==undefined) MEM.polarity.set_value(bucketNOBJ);
        
        if (polarity==undefined) {
            console.warn("THIS SHOULD NOT STILL BE POSSBILE HERE");
            console.warn(bucketNOBJ.text+" "+bucketNOBJ.nid);
            continue;
        }

        var bucket = {nObj:bucketNOBJ, feelz:[]};
        feelzBuckets.push(bucket);
        bucketMap[bucketNOBJ.temp_nid] = bucket;
        
        bucketNOBJ.atype="fz-bucket";
        if (polarity==1) {
            bucketNOBJ.pol="pos";
            bucket.pol="pos";
            bucket.parent_tnid = MEM.positive.temp_nid;
            AWARE._awarez.bucket_pos.push(bucket);
        }
        else if (polarity==0) {
            bucket.parent_tnid = MEM.neutral.temp_nid;
            bucketNOBJ.pol="neu";
            bucket.pol="neu";
            AWARE._awarez.bucket_neu.push(bucket);
        }
        else if (polarity==-1) {
            bucket.parent_tnid = MEM.negative.temp_nid;
            bucketNOBJ.pol="neg";
            bucket.pol="neg";
            AWARE._awarez.bucket_neg.push(bucket);
        }
    }

    for (var f=0; f < feelzBuckets.length; f++) {
        var bucket = feelzBuckets[f];
        var bucketNOBJ = bucket.nObj;
        var polarity = bucketNOBJ.polarity;
        var pol = "";
        if (polarity==-1) pol="neg";
        else if (polarity==0) pol="neu";
        else if (polarity==1) pol="pos";
        else {
            alert("BIG TROUBLE");   //remove in prod
        }
     
        //look for BRAIN ins to the bucket.
        //ldr(Consts.TYPE_BRAIN, newNid, weight, bucket);
        for (var i=0; i < bucketNOBJ.ins.length; i++) {
            var feelz_rel = bucketNOBJ.ins[i];

            if (feelz_rel.type!=TYPE_BRAIN) continue;

            var feelzNOBJ = MEMG.getNeuronByTempNid(feelz_rel.f);
            
            if (feelzNOBJ.nid==bucketNOBJ.nid) continue;    //don't want the bucket in itself.

            feelzNOBJ.text = feelzNOBJ.text.toLowerCase();

            if (feelzNOBJ.text=="thankfullness") {
                console.log("TEST");
            }
            if (feelzNOBJ.bes.indexOf(MEM.feelz.temp_nid)==-1) {
                //console.log("feelz not BE feelz");
                //console.log(feelzNOBJ);
                //ANNE.TALK.printRelons(feelzNOBJ.outs);
                continue;
            }

            //no feelz buckets here.  FOR PETE'S SAKE.
            if (feelzNOBJ.bes.indexOf(MEM.feeling.temp_nid)!=-1) continue;

            feelzNOBJ.polarity = polarity;
            feelzNOBJ.atype="fz";
            feelzNOBJ.pol=pol;
            bucket.feelz.push({nObj:feelzNOBJ, bucket:bucket});
            AWARE._feelz.push(feelzNOBJ);
            AWARE._all.push({nObj:feelzNOBJ, bucket:bucket});
            AWARE.fzOpNids.push(feelzNOBJ.nid);
        }
    }
    AWARE._awarez.all = AWARE._all;
    AWARE._awarez._opinionz = AWARE._opinionz;
    AWARE._awarez._feelz = AWARE._feelz;
    AWARE._awarez._feelz_buckets = feelzBuckets;
    AWARE._awarez.bucketMap = bucketMap;
    AWARE._awarez.all.sort(AWARE.sortAll);
}


/**
 * 
 * @param {*} $nid 
 * @returns 
 */
AWARE.getBucket=function($nid) {
    var auditNOBJ = MEMG.getNeuronByNid($nid);
    var bucket = AWARE._awarez.bucketMap[auditNOBJ.temp_nid];

    if (bucket!=undefined) return bucket;

    for (var n=0; n < AWARE._all.length; n++) {
        var obj = AWARE._all[n];
        if (obj.nObj.nid==$nid) {
            return obj.bucket;
        }
    }

    console.log(auditNOBJ.text+ " nid:"+$nid+" not found???");

    return null;
}


/**
 * 
 * @returns 
 */
AWARE.getRandPosBucketVal=function($seed) {
    if (Math.random()>.3) {
        var arr = AWARE._awarez.bucket_pos;
        var bucket = arr [ Math.floor(Math.random()*arr.length)];
        if (Math.random()>.9) return bucket.nObj.nid;
        else return ANNE.UTILS.getScatModSeedArrItem($seed, bucket.feelz).nObj.nid;
    }
    else {
        var arr = AWARE._awarez.op_pos;
        return ANNE.UTILS.getScatModSeedArrItem($seed, arr).nid;
    }
}


/**
 * 
 * @returns 
 */
AWARE.getRandNegBucketVal=function($seed) {
    if (Math.random()>.3) {
        var arr = AWARE._awarez.bucket_neg;
        var bucket = arr [ Math.floor(Math.random()*arr.length)];
        if (Math.random()>.9) return bucket.nObj.nid;
        else return ANNE.UTILS.getScatModSeedArrItem($seed, bucket.feelz).nObj.nid;
    }
    else {
        var arr = AWARE._awarez.op_neg;
        return ANNE.UTILS.getScatModSeedArrItem($seed, arr).nid;
    }
}


/**
 * 
 * @returns 
 */
AWARE.getRandNeuBucketVal=function($seed) {
    var arr = AWARE._awarez.bucket_neu;
    var bucket = arr [ Math.floor(Math.random()*arr.length)];
    if (Math.random()>.9) return bucket.nObj.nid;
    else return ANNE.UTILS.getScatModSeedArrItem($seed, bucket.feelz).nObj.nid;
}


/**
 * 
 * @param {*} $a 
 * @param {*} $b 
 * @returns 
 */
AWARE.sortAll=function($a, $b) {
    if($a.nObj.text.toLowerCase() < $b.nObj.text.toLowerCase()) return -1;
    else if($a.nObj.text.toLowerCase() > $b.nObj.text.toLowerCase()) return 1;
    return 0;
}

AWARE.lookupAny=function($txt) { return AWARE.lookupByArr(AWARE._all, $txt);}
AWARE.lookupFeelz=function($txt) { return AWARE.lookupByArr(AWARE._feelz, $txt);}
AWARE.lookupOpinionz=function($txt) { return AWARE.lookupByArr(AWARE._opinionz, $txt);}
AWARE.lookupByArr=function($arr, $txt){
    var matches = [];
    var match_tnids = [];
    var lower = $txt.toLowerCase();
    for (var a=0; a < $arr.length; a++) {
        if ($arr[a].nObj.text.toLowerCase().indexOf(lower)==0) {
            
            if ($arr[a].bucket!=null) {
                if ($arr[a].bucket.feelz.length){
                    for (var f=0; f < $arr[a].bucket.feelz.length; f++) {
                        if (match_tnids.indexOf($arr[a].bucket.feelz[f].nObj.temp_nid)!=-1) continue;
                        matches.push($arr[a].bucket.feelz[f])
                        match_tnids.push($arr[a].bucket.feelz[f].nObj.temp_nid);
                    }
                }
            }
            else {
                if (match_tnids.indexOf($arr[a].nObj.temp_nid)!=-1) continue;
                matches.push($arr[a]);
                match_tnids.push($arr[a].nObj.temp_nid);
            }
        }
    }
    return matches;
}


 
/**
 * @param {element} - where to put the widget
 * @param {int} - nid of the identity
 * @param {int} - NID or TXID of the target.
*/
AWARE.makeFeedbackWidget=async($el, $identityNID, $targetID, $targetType, $bFEELZ=true, $bOPINIONZ=true)=> {
    if ($targetID[0]=="z") return;
    var AFB = new feedback_widget($identityNID, $targetID, $targetType, $bFEELZ, $bOPINIONZ);
    await AFB.buildWidgetGUI($el, true);
}


/**
 * Our ghosts (user using the app) are not added in the feedback aplex object..
 * This drives the bar chart data.
 * Let's add them in.  Each time we pull the live aplex object
 * the ghost incriments are wiped (by design)
 */
AWARE.augmentGhosts = function($obj) {
    var bGHOSTS=true;
    if ($obj.txid!=undefined) {
        if($obj._aplex==undefined) new aplex($obj, $obj.txid, null);
        ghosts = MEM_UDF.getMyFeelzFor($obj.txid, TO_TYPE_TXID, bGHOSTS);
    }
    else if ($obj.nid!=undefined) {
        if($obj._aplex==undefined) new aplex($obj, $obj.nid, null);
        ghosts = MEM_UDF.getMyFeelzFor($obj.nid, TO_TYPE_ANNE, bGHOSTS);
    }
    if (ghosts.length) {
        for (var g=0; g < ghosts.length; g++) {
            var ghost_rel = ghosts[g];
            var awarenessNOBJ = MEMG.getNeuronByTempNid(ghost_rel.r);
            if (awarenessNOBJ.polarity==undefined) {
                MEM.polarity.set_value(awarenessNOBJ);
            }
            if (awarenessNOBJ.polarity==undefined) continue;
            if (awarenessNOBJ.polarity==1) {
                $obj._aplex.pos+=1;
                $obj._aplex.total+=1;
            }
            else if (awarenessNOBJ.polarity==-1) {
                $obj._aplex.neg+=1;
                $obj._aplex.total+=1;
            }
            else if (awarenessNOBJ.polarity==0) {
                $obj._aplex.neu+=1;
                $obj._aplex.total+=1;
            }
            $obj._aplex.fire+=1;
        }
    }
}


/**
 * $obj can be relon or neuron here
 * as both can receive feedback
 */
AWARE.tallyTempAplex = function($obj, $obj_id, $awarezNOBJ) {
    if ($obj._aplex==undefined || $obj._aplex==null) {
        new aplex($obj, $obj_id, null);
    }
    if ($awarezNOBJ.polarity==undefined) {
        MEM.polarity.set_value($awarezNOBJ);
    }
    if ($awarezNOBJ.polarity==undefined || $awarezNOBJ.polarity==null) return;
    if ($awarezNOBJ.polarity==1) {
        $obj._aplex.pos+=1;
        $obj._aplex.total+=1;
    }
    else if ($awarezNOBJ.polarity==-1) {
        $obj._aplex.neg+=1;
        $obj._aplex.total+=1;
    }
    else if ($awarezNOBJ.polarity==0) {
        $obj._aplex.neu+=1;
        $obj._aplex.total+=1;
    }

    //do we want to update widgets here?  This could get nizzzzzasty.
}


/**
 * Summary of all neurons in ANNE is a summary neuron line with the top of the __SELF__ neuron.
 * @param {*} $bFORCEEQUAL 
 * @returns 
 */
AWARE.emulateANNESummary = function($bFORCEEQUAL=false) {
    return AWARE.emulateSummaryData(MEM.___SELF___, 10000, $bFORCEEQUAL);
}


/**
 * 
 * @param {*} $cnt 
 * @returns 
 */
AWARE.emulateLatestXAnnexes = async($cnt=10)=> {
    var rand_nObjs = [];
    var aplex_objs = [];
    for (var n=0; n < ANNE.MEM._aNeurons.length; n++) {
        var nObj = ANNE.MEM._aNeurons[n];
        
        var bANNEXABLE = await ANNE.ANNEX.assessAnnexability(nObj, false);
        if (bANNEXABLE==false) continue;

        if (Math.random()>.9) {
            rand_nObjs.push(nObj);
            var apx = new aplex(nObj, nObj.nid, null);
            apx.emulateAplex();
            aplex_objs.push(apx);//debug
            if (rand_nObjs.length==$cnt) break;
        }
    }


    //debug only, delete after happy
    aplex_objs.sort( function($a, $b) {
        if ($a.price_lvl > $b.price_lvl) return -1;
        else if ($a.price_lvl < $b.price_lvl) return 1;
        return 0;
    });

    console.log(aplex_objs);


    rand_nObjs.sort( function($a, $b) {
        if ($a._aplex.price_lvl > $b._aplex.price_lvl) return -1;
        else if ($a._aplex.price_lvl < $b._aplex.price_lvl) return 1;
        return 0;
    });

    return rand_nObjs;
}


/**
 * Whales are emulated as anything else within ANNEID would be..
 * but for now i want this named function for clarity in my code.
 */
AWARE.emulateAnnexerWhales = async($limit=10, $factor=100)=> {
    return await AWARE.emulateANNEIDs($limit, $factor);
}

/**
 * 
 * @param {*} $limit 
 * @param {*} $factor 
 * @returns 
 */
AWARE.emulateANNEIDs=async($limit=10, $factor=100)=>{
    if (AWARE._preloadedRAM_emulateID==false) {
        //here we want the basic applex record for the top annexers in the system.
        //we should return the nObjs (anne idenitites)
        await ANNE.CHASE.loadChildrenFromIDB(MEM.valid_identity_classes)
        AWARE._preloadedRAM_emulateID=true;
    }
    var annexers = [];
    var identities = MEMZ.ezInstChildren(MEM.identity, []);
    if (identities.length<10) {
        await ANNE.API.getIdentities(100); //grab 100 identities
        identities = MEMZ.ezInstChildren(MEM.identity, []);
    }

    for(var i=0; i < identities.length; i++) {
        var idNOBJ = identities[i];
        if (idNOBJ._anneid==null) {
            AWARE.emulateANNEID(idNOBJ);
        }
        annexers.push(idNOBJ);
        if (annexers.length==$limit) break;
    }

    //ensure it is sorted.
    annexers.sort(function($a, $b){
        if ($a._anneid.did_annex > $b._anneid.did_annex) return -1;
        if ($a._anneid.did_annex < $b._anneid.did_annex) return 1;
        return 0;
    })

    for (var a=0; a < annexers.length; a++) {
        console.log("audit sort "+annexers[a].text+" did_annex:"+annexers[a]._anneid.did_annex);
    }
    
    return annexers;
}


/**
 * 
 * @param {*} $nObj 
 * @returns 
 */
AWARE.emulateANNEID = function($nObj) {
    var _anneid = new anneid($nObj);
    _anneid.emulate();
    return $nObj._anneid;
}



/**
 * This will use objects w/ props .nObj, .cnt
 * @param {*} $cnt 
 */
AWARE.emulateWhatsHot = async($cnt=10)=> {
    var rand_objs = [];
    var aplex_objs = [];
    for (var n=0; n < ANNE.MEM._aNeurons.length; n++) {
        var nObj = ANNE.MEM._aNeurons[n];

        var bPASS = await ANNE.ANNEX.assessAnnexability(nObj);
        if (bPASS==false) {
            continue;
        }
        
        if (Math.random()>.9) {
            if (Math.random()>.95 && rand_objs.length>0) {
                var i = Math.floor(Math.random()*rand_objs.length);
                rand_objs[i].cnt+=1;
                continue;
            }
            else rand_objs.push({nObj:nObj, cnt:1});
            var apx = new aplex(nObj, nObj.nid, null);
            apx.emulateAplex();
            aplex_objs.push(apx);//debug
            if (rand_objs.length==$cnt) break;
        }
    }


    rand_objs.sort( function($a, $b) {
        if ($a.cnt > $b.cnt) return -1;
        else if ($a.cnt < $b.cnt) return 1;
        return 0;
    });

    return rand_objs; //an array of {nObj: cnt:}
}



/**
 * Emulate the top x data we will get from the annode for annex topx
 */
AWARE.emulateANNEXTopX = async($cnt=10)=> {
    var rand_nObjs = [];
    var aplex_objs = [];
    for (var n=0; n < ANNE.MEM._aNeurons.length; n++) {
        var nObj = ANNE.MEM._aNeurons[n];
        var bPASS = await ANNE.ANNEX.assessAnnexability(nObj);
        if (bPASS==false) {
            continue;
        }
        if (Math.random()>.9) {
            rand_nObjs.push(nObj);
            var apx = new aplex(nObj, nObj.nid, null);
            apx.emulateAplex();
            aplex_objs.push(apx);//debug
            if (rand_nObjs.length==$cnt) break;
        }
    }

    
    //debug only, delete after happy
    aplex_objs.sort( function($a, $b) {
        if ($a.price_lvl > $b.price_lvl) return -1;
        else if ($a.price_lvl < $b.price_lvl) return 1;
        return 0;
    });

    console.log(aplex_objs);


    rand_nObjs.sort( function($a, $b) {
        if ($a._aplex.price_lvl > $b._aplex.price_lvl) return -1;
        else if ($a._aplex.price_lvl < $b._aplex.price_lvl) return 1;
        return 0;
    });

    return rand_nObjs;
}



/**
 * 
 * @param {*} $nObj 
 * @param {*} $factor 
 * @param {*} $bFORCEEQUAL 
 * @returns 
 */
AWARE.emulateSummaryData = function($nObj, $factor=10, $bFORCEEQUAL=false) {
    var aplx = new aplex_sum($nObj, APLEX_SUMMARY_NEURON_LINE);
    aplx.emulateSummaryData($factor, $bFORCEEQUAL);
    return aplx;
}

/**
 * Use the _aplex we may have already (if emulating)
 * This way the neuron ico chart and the big chart will match in color.
 * @param {*} $nObj 
 * @param {*} $factor 
 * @param {*} $bFORCEEQUAL 
 * @returns 
 */
AWARE.emulateDataSpecificNeuron = function($nObj, $factor=10, $bFORCEEQUAL=false) {
    var aplx = new aplex_sum($nObj, APLEX_SUMMARY_SPECIFIC_NEURON);
    if ($nObj._aplex!=null) {
        aplx.emulateSummaryDataWithAplex($nObj._aplex);
        aplx._aplex=$nObj._aplex;   //standard aplex (non-summary with price_lvl etc)
    }
    else aplx.emulateSummaryData($factor, $bFORCEEQUAL);
    return aplx;
}


/**
 * a super summary function
 * @param {*} $nObj 
 */
AWARE.setMacroAplex = async($nObj)=>{

    
}