/**
 * events are instances of an action verb.
 */
 class dossier_event_inst extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_event_inst", TALK.bgredbig);
    }

    initASYNC = async($pguicopy)=>{
        await this.getData(false, this.nObj);
        await this.doHeading();
        
        this.alterLayout("100%", 0);

        if (this.nObj.ntype!=NTYPE_INST) {
            console.log("%c dossier_event_inst IS NOT USED FOR CLASS NEURONS!!!", TALK.bgredbig);
            return;
        }

        ANNE.A.hide(this.el_bes_content);
        ANNE.A.addRemoveClass(this.el_content, "doss-body-box-full", "doss-body-box");
        
        var outputOBJ = await this.nObj.processActionNeuron();
        var order = outputOBJ.order;

        ANNE.A.ezEl(this.el_content, "div", "simple-row sentence-big", outputOBJ.output, "disp_sent_"+this.ID);

        //var el_new_roles = ANNE.A.ezEl(this.el_content, "div", "simple-row add-more-dark");
        //el_new_roles.style['padding-top']="6px";

        this.roles_displayed = [];
        this.el_roles = ANNE.A.ezEl(this.el_content, "div", "");
        this.el_roles.style['padding-top']="10px";


        //src roles processed in to here.
        var sources = [];

        var dupe_txids = [];

        //display roles for viewing or editing.
        //order is the roles the TALK print out so we can display those in the same order.
        for (var r=0; r < order.length; r++){
            
            var roleNOBJ = MEMG.getNeuronByTempNid(order[r].r);
            console.log("(order r="+r+") doing roleNOBJ "+roleNOBJ.text);
                
            if (roleNOBJ.temp_nid==MEM.role_src_ref.temp_nid) {
                sources.push(order[r]);
                continue;
            }
            
            //double check dupes.. (they're ugly on the gui. shouldn't be here, but just in case.)
            var relz = order[r];
            if (dupe_txids.indexOf(relz.txid)!=-1) continue;
            dupe_txids.push(relz.txid);

            var el_role = ANNE.A.ezEl(this.el_roles, "div", "simple-row role-row", "", "role_row_"+order[r].txid);            
            this.roles_displayed.push(order[r].r);  //limit the +role box to those not on the screen.

            //if (this.nObj.owned_by!=USER._userNObj.nid) {
               // ANNE.A.ezRoleDisplay(el_role, order[r], this.ID);
            //}

            //we own this clump.
            //some basic stuff we can edit for event clumps (for now)
            //the protcol handles FAR MORE robustness but I can't chase super detailed GUIs with my solo manpower..
            //just can vet what is in L1 is working and will allow for massive expansion in many directions.
            //else {
                var bEDIT = true;
                
                //we don't edit the action.
                if (roleNOBJ.temp_nid == MEM.role_action.temp_nid) bEDIT = false;
                else if (roleNOBJ.temp_nid == MEM.role_actor.temp_nid) bEDIT = false;

                var bMOD = false;
                if (roleNOBJ.temp_nid==MEM.role_affected_thing.nid) bMOD=true;
                else if (roleNOBJ.temp_nid==MEM.role_theme_thing.nid) bMOD=true;
                else if (roleNOBJ.temp_nid==MEM.role_action.nid) bMOD=true;  

                await ANNE.A.ezRoleEdit(el_role, this.nObj.nid, order[r], this.ID, bEDIT, bMOD, this.el_dynodata, this.newRoleSuccess, this.cancelInject, this.deleletRoleRelon, null);
            //}
        }
        
        if (sources.length) {
            var el_srcs = ANNE.A.ezEl(this.el_content, "div", "simple-row section-title", "sources"); 
        }
        for (var s=0; s < sources.length; s++) {
            var srel = sources[s];
            ANNE.A.ezEl(el_srcs, "div", "simple-row", "source: "+MEM.__MASTER_TO_VALUE(srel)); 

        }

        
        this.doKwds();
        this.doAssociate();
        
        //await this.doAnumSection(this.el_content);

        this.addAwarvu();
        
        await this.doImgs(this.el_thumbs); //images after the body

        await this.doHas(this.el_content, "HAS attributes", true);    //generic.   

        //ANNE.A.ezSpan(el_new_roles,"","simple-col tal","add roles for this event&nbsp;");
        //var col2 = ANNE.A.ezEl(el_new_roles, "div", "simple-col f2 tar", "");
        await this.doAllParams(this.el_content);

        /*
        var tnid_roles = [];
        for (var pr =0; pr < this.nObj._param_roles.length; pr++){
            var prel = this.nObj._param_roles[pr];
            if (this.roles_displayed.indexOf(prel.r)!=-1) continue;
            if (tnid_roles.indexOf(prel.r)==-1) tnid_roles.push(prel.r);
        }
        ANNE.A.ezDD(col2, tnid_roles, this.addNewRoleFromDD, "&plus;&nbsp;add role", true, "btn-blue-tiny-sq", false, false);
        */
        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }
    

    addNewRoleFromDD = async($e)=> {
        var target = $e.target;
        if (ANNE.UTILS.isset(target)==false) return;
        var role_value = target.value;
        if (ANNE.UTILS.isset(role_value)==false) return;
        
        console.log(role_value);
        var roleNOBJ = MEMG.getNeuronByNid(role_value);

        //we need params for every role if we do this... like this.
        var prel = MEMG.getParamRelon(this.all_relons, roleNOBJ.temp_nid);

        var el_role = ANNE.A.ezEl(this.el_roles, "div", "simple-row role-row", "", "role_row_"+prel.txid);

        //user wants a new role added to the gui that isn't in there.
        await ANNE.A.ezRoleEdit(el_role, this.nObj.nid, prel, this.ID, true, false, this.el_dynodata, this.newRoleSuccess, this.cancelInject, this.deleletRoleRelon, null);
    
        var btnAdd = ANNE.A.__getEl("add_"+prel.rid+"_"+this.ID);
        ANNE.A.editRoleLaunchSelector(btnAdd.parentNode, this.newRoleSuccess, this.cancelInject);
    }



    /**
     * 
     * @param {Object} $ge 
     * @returns 
     */
    cancelInject = async($ge)=> {
        console.log($ge);
        await this.smartDefocus(false);   
        await PAGES.closeInjectedDetails($ge);
    }


    /**
     * New role addded.  For dossier_event_inst the new potential roles are not displayed ready to be filled.
     * That is done in the clump.js role entry.  This is intended for minor edits so the desired role
     * can be selected from the role drop down and added anew.
     * Multiples for the same role can be launched but will create a new role row (not be put with the existing one)
     * @param {*} $ge 
     * @param {*} $new_nid 
     * @param {*} $new_relon 
     * @returns 
     */
    newRoleSuccess=async($ge, $new_nid, $new_relon=null)=> {
        console.log("newRoleSuccess");
        console.log($ge, $new_nid, $new_relon);
        
        var roleNOBJ = MEMG.getNeuronByTempNid($new_relon.r);
        var el_role = ANNE.A.ezEl(this.el_roles, "div", "simple-row role-row");

        var bEDIT = true;
        if (roleNOBJ.temp_nid == MEM.role_action.temp_nid) bEDIT = false;
        else if (roleNOBJ.temp_nid == MEM.role_actor.temp_nid) bEDIT = false;

        var bMOD = false;
        if (roleNOBJ.temp_nid==MEM.role_affected_thing.nid) bMOD=true;
        else if (roleNOBJ.temp_nid==MEM.role_theme_thing.nid) bMOD=true;
        else if (roleNOBJ.temp_nid==MEM.role_action.nid) bMOD=true;  
        
        await ANNE.A.ezRoleEdit(el_role, this.nObj.nid, $new_relon, this.ID, bEDIT, bMOD, this.el_dynodata, this.newRoleSuccess, this.cancelInject, this.deleletRoleRelon);

        await this.smartDefocus(false); //uses dossier's
        await PAGES.closeInjectedDetails($ge);
        await this.displaySentence();

        this.roles_displayed.push($new_relon.r);

        var prel = MEMG.getParamRelon(this.all_relons, roleNOBJ.temp_nid);
        ANNE.A.removeSelf("role_row_"+prel.txid);

        return;
    }


    displaySentence = async()=> {
        var outputOBJ = await this.nObj.processActionNeuron(this.all_relons);
        ANNE.A.setHTML("disp_sent_"+this.ID, outputOBJ.output);
    }



    /**
     * Delete a ghost relon.
     * @param {Element} $span2 
     * @returns 
     */
     deleletRoleRelon = async($span2, $btn)=>{
        var txid = $btn.getAttribute("txid");
        if (ANNE.UTILS.isset(txid)==false) return;
        
        var role_row = ANNE.A.getFirstParentOf($span2,"role-row",true); 
        ANNE.A.empty(role_row);

        var role_relon = MEMG.lookupByTXID(txid);

        await this.nObj.deleteRolefromClump(txid);

        for (var r=0; r < this.roles_displayed.length; r++) {
            if (this.roles_displayed[r]==role_relon.r) {
                this.roles_displayed.splice(r, 1);
                break;
            }
        }

        UTILS.removeObjInObjArr(this.all_relons, "txid", txid);

        await this.displaySentence();
    }
}

