/**
 * idiom
 */
 class dossier_idiom extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_idiom", TALK.bgredbig);
    }
    initASYNC = async($pguicopy)=>{
        await this.getData(false, this.nObj, [], true);
        await this.doHeading();
        
        if (this.nObj.ntype!=NTYPE_CLASS) {
            console.log("%c dossier_idiom should be for CLASS NEURONS ONLY", TALK.bgredbig);
            return;
        }

        //we should linkify the sentence if this is a class def..
        var talkOBJ = await this.nObj.processActionNeuron(this.all_relons, true, [], this.el_content);
        console.log(talkOBJ);

        var meaningNOBJ = this.nObj;
        var meaning_rel = null;
        if (talkOBJ.meta_meaning_talk!=null) {
            meaningNOBJ =talkOBJ.meta_meaning_NOBJ;
            meaning_rel = talkOBJ.meta_meaning_rel;
            talkOBJ = talkOBJ.meta_meaning_talk;
        }


        if (talkOBJ.poa!=null) ANNE.A.ezEl(this.el_content, "div", "part-of-anne", talkOBJ.poa.text+", "+talkOBJ.tense_lbl);
        ANNE.A.ezEl(this.el_content, "div", "verbish-def-heading", talkOBJ.output);


        if (meaning_rel!=null) {
            var row = ANNE.A.ezEl(this.el_content, "div", "simple-row section-title");
            var col1 = ANNE.A.ezEl(row, "div", "simple-col tal50");
            var col2 = ANNE.A.ezEl(row, "div", "simple-col tal50");
            EXT_BTNS.makeNeuronLink(col1, meaning_rel.reln);
            EXT_BTNS.makeRelonViewLink_SMART(col2, meaning_rel, false, 8, true);
            EXT_BTNS.makeNeuronLink(col2, meaning_rel.to_s);
        }

        var elC = this.el_content;

        function doNests($mods, $indent) {
            var keys = Object.keys($mods);
            for (var k=0; k < keys.length; k++) {
                var role_meaning = $mods[ keys[k] ];
                //if (role_meaning.nameless && role_meaning.temp==true) continue;
                var row = ANNE.A.ezEl(elC, "div", "simple-row");
                var col1 = ANNE.A.ezEl(row, "div", "simple-col tal50");
                col1.style['padding-left']=($indent*4)+"px";
                var pre="";
                for (var p=0;p<$indent;p++){
                    pre+="--";
                }
                if (pre.length>0) pre+=':'
                var col2 = ANNE.A.ezEl(row, "div", "simple-col tal50");
                EXT_BTNS.makeNeuronLink(col1, role_meaning.reln, "",  pre);
                EXT_BTNS.makeRelonViewLink_SMART(col2, role_meaning, false, 8, true);
                EXT_BTNS.makeNeuronLink(col2, role_meaning.to_s);
                if (role_meaning.mods!=undefined) {
                    doNests(role_meaning.mods, $indent+1);
                }
            }
        }

        for (var r=0; r < meaningNOBJ._roles.length; r++) {
            var mrel = meaningNOBJ._roles[r];
            var row = ANNE.A.ezEl(this.el_content, "div", "simple-row");
            var col1 = ANNE.A.ezEl(row, "div", "simple-col tal50");
            var col2 = ANNE.A.ezEl(row, "div", "simple-col tal50");
            EXT_BTNS.makeNeuronLink(col1, mrel.reln);
            EXT_BTNS.makeRelonViewLink_SMART(col2, mrel, false, 8, true);
            if (mrel.nameless==undefined) EXT_BTNS.makeNeuronLink(col2, mrel.to_s);

            if (mrel.mods!=undefined) {
                doNests(mrel.mods, 1);
            }
        }

        this.doAltBES(this.el_bes_content);
        //this.doAKA(this.el_bes_content);
        //this.doFKA(this.el_bes_content);

        //TODO, print out meaning here like a dictionary would in infinitive form.
        //jump,  to motate upwardly
        
        //display the existing _meaning_roles  (here they should be dupes of the _roles array)
        if (ANNE.UTILS.isset(this.nObj._meaning_roles==true)) {
            for (var r=0; r < this.nObj._meaning_roles.length; r++){
                ANNE.A.ezRoleDisplay(this.el_content, this.nObj._meaning_roles[r], this.ID);
            }
        }

        
        //show the roles this verb assigns.
        var patsDiv = ANNE.A.ezEl(this.el_bes_content, "div", "section-title-center", "Recognition Patterns");
        var pat_rels = MEMG.getPatternRels(this.nObj.outs);
        for (var p=0; p < pat_rels.length; p++) {
            var pat = pat_rels[p];
            var row = ANNE.A.ezEl(patsDiv, "div", "simple-row");
            var col1 = ANNE.A.ezEl(row, "div", "simple-col tal50");
            var col2 = ANNE.A.ezEl(row, "div", "simple-col tal50");
            EXT_BTNS.makeNeuronLink(col1, pat.reln);
            EXT_BTNS.makeRelonViewLink_SMART(col2, pat, false, 8, true);
            EXT_BTNS.makeNeuronLink(col2, pat.to_s);
        }

        //do similar?
        //do opposite?
        this.doAssociate();

        await this.doAllInsSection2(this.el_content, "inbound references", true);
       
        await this.doAnumSection(this.el_content);
        
        this.addAwarvu();

        await this.doImgs(this.el_thumbs); //images after the body

        this.doAdminRelons(this.el_content);

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }
}