
class anne_location {
    constructor($val=null, $bCLEANIT=true) {
        this.nObj = null;
        this.neurons = [];
        this.bNEW = false;
        this.originalStr = $val;
        this.locationStr = $val;
        this._unfoundCityTop=true;
        this._foundCityAnyIn=false;
        this.bDIDLOOKUP=false;
        this.bHASCOUNTRYORTERR=false;
        this.bAMBIGUOUS = false;
        this.matches = []; //for multiple ambiguous matches
    
        this.nObj = null;
        this.neurons = [];
        this.bNEW = false;
        this.parts_nobjs = [];
        this.fixed_location_str = "";
        
        this.parts = [];
        
        if ($val!=null && typeof $val !="string") {
            if (Array.isArray($val)==true) {
                this.locationStr = $val.join(",");
                if ($bCLEANIT==true) {
                    this.locationStr = this.locationStr.replace(/ *\[[^\]]*]/g, '');
                    this.locationStr = this.locationStr.replace(/\([^()]*\)/g, '');                         //remove (xxxx)
                    this.locationStr = this.locationStr.trim();    
                }
                this.parts = this.locationStr.split(",");
            }
            else {
                alert("unhandled location input");
            }
        }
        else if ($val!=null){
            this.locationStr = $val;
            if ($bCLEANIT==true) {
                this.locationStr = this.locationStr.replace(/ *\[[^\]]*]/g, '');
                this.locationStr = this.locationStr.replace(/\([^()]*\)/g, '');                         //remove (xxxx)
                this.locationStr = this.locationStr.trim();
            }
            $val = $val.trim()
            if ($val.indexOf(",")!=-1) this.parts = $val.split(",");
            else if ($val.indexOf("-")!=-1) this.parts = $val.split("-");
            else {

                //perhaps do a quick pool/nn type process on a multi spaced word
                //to ascertain if it is likely a geo site, site, or city/state/country location with no spaces.
                //ie,  Great Appalachian Valley   vs   New York City USA.
                //const spaceCount = ($val.match(/\s/g) || []).length;
                this.parts = [$val];
                
            }
        }

        this._unfoundCityTop=true;
        this._foundCityAnyIn=false;

        this.bDIDLOOKUP=false;
        this.bHASCOUNTRYORTERR=false;

        this.bAMBIGUOUS = false;
        this.matches = []; //for multiple ambiguous matches
        this.final_parts = [];
        console.log("%c doing anne_location %c"+$val, ANNE.TALK.bgbigred, ANNE.TALK.bgyellow);
        
        for (var p=0; p<this.parts.length; p++) {
            this.parts[p] = this.parts[p].trim(); 
        }

        this.TOPNONCOUNTRY_PART = null;
        this.COUNTRY_PART = null;
        this.REGION_PART = null;
        this.CITYOTHER1_PART=null;
        this.CITYOTHER2_PART=null;
        this.CITYOTHER3_PART=null;    
        this.CITYOTHER4_PART=null;  

        //a site/geosite part of a location.
        this.SITE_PART = null;
        this.site_str = "";
        this.site_classNOBJ = null;
    }


    /**
     * If we find this, we already have found our location. 
     * @param {*} $str 
     * @param {*} $classNOBJ 
     */
    setSiteStrAndClass=function($str, $classNOBJ) {
        this.site_classNOBJ = $classNOBJ;
        this.site_str = $str;
    }


    /**
     * 
     * @param {*} $nObj 
     */
    loadFromNeuron=function($nObj) {
        this.nObj = $nObj;
    }


    /**
     * @returns 
     */
    prepLocation = async()=> {
        var ourparts = [];
        var flow = "";

        if (this.locationStr.indexOf(",")==-1) {
            if (this.locationStr.indexOf("-")==-1) {
                //this is just a single entry location.
                console.log("single mode");
            }
        }


        var TOPNONCOUNTRY = null;
        var COUNTRY = null;
        var REGION = null;
    

        for (var p=0; p  < this.parts.length; p++) {
            var part_str = this.parts[p].trim();
            
            var part = {str:part_str, 
                        context:null,
                        nObj:null,
                        top_non_country_conf:0, 
                        country_conf:0,
                        mid_conf:0, 
                        bottom_conf:0, 
                        used:false, 
                        status:"not processed",
                        partstr:"unknown",
                        chased_constitutents:false,
                        original_index:p};
            
            if (this.site_str!="" && part_str==this.site_str && this.site_classNOBJ!=null) {
                part.partstr = this.site_classNOBJ.text;
                part.bottom_conf=1;
                part.used=true;
                this.SITE_PART = part;
                part.extras = [
                    {type:TYPE_BE, reln:ANNE.MEM.ec_is.nid, to_type:TO_TYPE_ANNE, to_s:this.site_classNOBJ.nid}
                ];
            }
            
            //we don't want a period at the end of the last part.
            if (this.parts.length-1==p) {
                if (part.str.endsWith(".")==true) {
                    part.str = part.str.slice(0, -1);
                }
            }
            if (part_str.indexOf("(")!=-1) {
                var fixedObj = ANNE.UTILS.stripParens(part.str);
                part.str = fixedObj.str;
                if (fixedObj.context!=null && fixedObj.context!="") part.context = fixedObj.context;
            }
            ourparts.push(part);
        }

        //basic expectation.
        //country is last, flow from small (city) ---> to big (country)
        var expect_country = ourparts.length-1;
        flow = "SMALL2BIG";

        //look for noncountry top part  (ie, British Empire, or British America, or even Ontario")
        for (var p=0; p < ourparts.length; p++) {
            if (p!=0 && p!=ourparts.length-1) continue; //must be first or last here.
            var part = ourparts[p];
            if (part.used==true) continue;

            TOPNONCOUNTRY = await this.checkForNonCountryTop(part.str);
            if (TOPNONCOUNTRY==null && part.context!=null) {
                if (Array.isArray(part.context)==true) part.context = part.context[0];
                TOPNONCOUNTRY = await this.checkForNonCountryTop(part.context);
            }
            if (TOPNONCOUNTRY!=null) {
                if (p==0) {
                    flow = "BIG2SMALL";
                    expect_country = p+1;
                }
                else if (p==ourparts.length-1) {
                    flow = "SMALL2BIG";  
                    expect_country = p-1;
                }
                this.TOPNONCOUNTRY_PART = part;
                this.TOPNONCOUNTRY_PART.top_non_country_conf=1;
                this.TOPNONCOUNTRY_PART.nObj=TOPNONCOUNTRY;
                this.TOPNONCOUNTRY_PART.used=true;
                this.TOPNONCOUNTRY_PART.status = "REAL";
                this.TOPNONCOUNTRY_PART.p = p;
                this.TOPNONCOUNTRY_PART.partstr = "above country";
                break;
            }
        }

        //look for country part.
        //BIGLY problem!
        //US has city names that are other countries!!! (lolz)
        //if we cannot depend on order this is a challenge.
        
        for (var p=0; p < ourparts.length; p++) {
            var part = ourparts[p];
            if (part.used==true) continue;

            if (TOPNONCOUNTRY==null) {
                if (p!=0 && p!=ourparts.length-1) continue; //must be first or last here.
            }
            
            COUNTRY = await this.checkForCountry(part.str);
            if (COUNTRY==null && part.context!=null) {
                if (Array.isArray(part.context)==true) part.context = part.context[0];
                COUNTRY = await this.checkForCountry(part.context);
            }
            if (COUNTRY!=null) {
                this.COUNTRY_PART = part;
                var testOtherSideStr = "";
                var testOtherPart = null;
                
                if (flow=="") {
                    if (p==0) {
                        flow = "BIG2SMALL";
                    }
                    else if (p==ourparts.length-1) {
                        flow = "SMALL2BIG";
                    }
                }
                else {
                    if (flow=="BIG2SMALL" && p!=0) {
                        flow = "BIG2SMALL_mixed";
                    }
                    else if (ourparts.length>1 && flow=="SMALL2BIG" && p!=ourparts.length-1) {
                        flow = "SMALL2BIG_mixed";
                    }
                }

                
                if (ourparts.length>1 && (p==0 || (TOPNONCOUNTRY!=null && p==1))) {
                    testOtherPart = ourparts[ ourparts.length-1 ];
                    testOtherSideStr = testOtherPart.str;
                    
                    //look for country at the end.. if so, we have a potential couutry-city name!
                    var countrytest_otherside = await this.checkForCountry(testOtherSideStr);
                    if (countrytest_otherside==null && testOtherPart.context!=null) {
                        if (Array.isArray(testOtherPart.context)==true) testOtherPart.context = testOtherPart.context[0];
                        countrytest_otherside = await this.checkForCountry(testOtherPart.context);
                    }
                    if (countrytest_otherside!=null) {

                        //we need to look for a state!  if we have a state then the country is USA!
                        for (var pp=0; pp < ourparts.length; pp++) {
                            var regionstate = await this.checkForRegionOrState(ourparts[pp].str);
                            if (regionstate==null && ourparts[pp].context!=null) {
                                if (Array.isArray(ourparts[pp].context)==true) ourparts[pp].context = ourparts[pp].context[0];
                                regionstate = await this.checkForRegionOrState(ourparts[pp].context);
                            }
                            //we have a state.. this is a new country city name within a US state!
                            //ie, "england, texas".
                            if (regionstate!=null) {

                                if (countrytest_otherside.nid==MEM.usa.nid) {
                                    
                                    testOtherPart.top_conf=1;
                                    testOtherPart.nObj=countrytest_otherside;
                                    testOtherPart.used=true;
                                    testOtherPart.status = "REAL";
                                    testOtherPart.partstr = "country";

                                    COUNTRY = countrytest_otherside;
                                    this.COUNTRY_PART = testOtherPart;
                                    flow = "SMALL2BIG"
                                    //this current part is NOT a country --- it is a city, or site, or 
                                    //the last lower of this chain.
                                    break;
                                }
                            }
                        }
                    }
                }
                
                //normal country.
                part.top_conf=1;
                part.nObj=COUNTRY;
                part.used=true;
                part.status = "REAL";
                part.partstr = "country";
                break;
            }
            else {
                REGION = await this.checkForRegionOrState(part.str);
                if (REGION==null) {
                    await ANNE.API.getLocationParts(part.str);
                    REGION = await this.checkForRegionOrState(part.str);
                    if (REGION==null) continue;
                }
                
                part.mid_conf=1;
                part.nObj=REGION;
                part.used=true;
                part.status = "REAL";
                part.partstr = "region";
                this.REGION_PART = part;
            }
        }

        //look for state in US first, otherwise, generalize next lower region.
        for (var p=0; p < ourparts.length; p++) {
            var part = ourparts[p];
            if (part.used==true) continue;

            //special case for US location handling.
            //hmmm.. seems a bit weak.
            if (COUNTRY!=null && COUNTRY.nid==MEM.usa.nid) {
                REGION = await this.checkForRegionOrState(part.str);
                if (REGION!=null) {
                    REGION = await this.isConstituentOf(part.str, COUNTRY);
                    if (REGION!=null) {
                        this.REGION_PART = part;
                        part.mid_conf=1;
                        part.nObj=REGION;
                        part.used=true;
                        part.status = "REAL";
                        part.partstr = "region";
                        break;
                    }
                }
            }

            //see if this is a known constituent of the country/top non-country.
            if ((COUNTRY!=null || TOPNONCOUNTRY!=null) && REGION==null) {
                if (COUNTRY!=null) {
                    REGION = await this.isConstituentOf(part.str, COUNTRY);
                    if (REGION!=null) {
                        this.REGION_PART = part;
                        part.mid_conf=1;
                        part.nObj=REGION;
                        part.used=true;
                        part.status = "REAL";
                        part.partstr = "region";
                        break;
                    }
                }
            }
        }

        if (ourparts.length>1 && COUNTRY!=null && flow == "SMALL2BIG") {
            ourparts.reverse(); //we want lower parts getting smaller from left to right as we process them from here.
        }
        //console.log("FLOW:"+flow);

        //look for city others.  max 4.. this is kind of crazy.. like  lion display, the bronx zoo, the bronx, nyc, new york, USA.
        var lowers=0;
        for (var p=0; p < ourparts.length; p++) {
            var part = ourparts[p];
            if (part.used==true) continue;
            part.bottom_conf=.5;
            part.used=true;
            part.status = "unhandled";
            if (lowers==0) {
                this.CITYOTHER1_PART = part;
            }
            else if (lowers==1) {
                this.CITYOTHER2_PART = part;
            }
            else if (lowers==2) {
                this.CITYOTHER3_PART = part;
            }
            else if (lowers==3) {
                this.CITYOTHER4_PART = part;
            }
            else break;
            lowers+=1;
        }    
            
        var final_parts_str = [];

        //city4-1 were not resolved yet

        //this was jammed in knowing we were to parse a site location.
        if (this.SITE_PART!=null) {
            final_parts_str.push(this.SITE_PART.str);
            this.final_parts.push(this.SITE_PART);
            if (this.SITE_PART.ghost==false) this.SITE_PART.ghost = false;
            this.SITE_PART.partstr = "site";
        }
        if (this.CITYOTHER4_PART!=null) {
            final_parts_str.push(this.CITYOTHER4_PART.str);
            this.final_parts.push(this.CITYOTHER4_PART);
            if (this.CITYOTHER4_PART.ghost==false) this.CITYOTHER4_PART.ghost = false;
            this.CITYOTHER4_PART.partstr = "city4";
        }
        if (this.CITYOTHER3_PART!=null) {
            final_parts_str.push(this.CITYOTHER3_PART.str);
            this.final_parts.push(this.CITYOTHER3_PART);
            if (this.CITYOTHER3_PART.ghost==false) this.CITYOTHER3_PART.ghost = false;
            this.CITYOTHER3_PART.partstr = "city3";
        }
        if (this.CITYOTHER2_PART!=null) {
            final_parts_str.push(this.CITYOTHER2_PART.str);
            this.final_parts.push(this.CITYOTHER2_PART);
            if (this.CITYOTHER2_PART.ghost==false) this.CITYOTHER2_PART.ghost = false;
            this.CITYOTHER2_PART.partstr = "city2";
        }
        if (this.CITYOTHER1_PART!=null) {
            final_parts_str.push(this.CITYOTHER1_PART.str);
            this.final_parts.push(this.CITYOTHER1_PART);
            if (this.CITYOTHER1_PART.ghost==false) this.CITYOTHER1_PART.ghost = false;
            this.CITYOTHER1_PART.partstr = "city1";
        }
        if (REGION!=null) {
            final_parts_str.push(REGION.text);
            this.final_parts.push(this.REGION_PART);
            if (REGION.ghost==false) REGION.ghost = false;
            REGION.partstr = "region";
        }
        if (COUNTRY!=null) {
            if (COUNTRY.alpha3!=undefined && COUNTRY.alpha3!="") final_parts_str.push(COUNTRY.alpha3);
            else final_parts_str.push(COUNTRY.text);
            this.final_parts.push(this.COUNTRY_PART);
            if (COUNTRY.ghost==false) COUNTRY.ghost = false;
            COUNTRY.partstr = "country";
        }
        
        if (TOPNONCOUNTRY!=null) {
            final_parts_str.push(TOPNONCOUNTRY.text);
            this.final_parts.push(this.TOPNONCOUNTRY_PART);
            if (TOPNONCOUNTRY.ghost==false) TOPNONCOUNTRY.ghost = false;
            TOPNONCOUNTRY.partstr = "top";
        }

        this.locationStr = final_parts_str.join(",");
        
        return this.locationStr;
    }


    /**
     * 
     * @param {*} $neurons 
     * @param {*} $bMUSTBECOUNTRY 
     * @param {*} $bMAKEGHOST 
     * @returns 
     */
    processFull=async($neurons=[], $bMUSTBECOUNTRY=false, $bMAKEGHOST=false)=> {
        var _lastUpperGroup = null;
        var _prevUpperGroup = null;
        
        //preplocation first.
        if (this.final_parts.length==0) {
            await this.prepLocation();
        }

        if (this.final_parts.length==1) {
            if (this.final_parts[0].status=="unhandled") {
                
                //no country was found but this location required a country/top.
                if ($bMUSTBECOUNTRY==true) return;

                _lastUpperGroup = await this.checkForKnown(this.final_parts[0].str);
                if (_lastUpperGroup==null) {
                    //we just need to make this thing... but what is it???
                    //a location of somekind.
                    return;
                }
            }
            else {
                this.nObj = this.final_parts[0].nObj;
                return this.nObj;
            }
        }
        else {
            var toppart = this.final_parts[this.final_parts.length-1];
            if (toppart.status=="unhandled") {
                //we can't do anything with a location with an unknown top.
                console.log("unknown top with multiple parts, cannot continue.")
                return;
            }
            else {
                _lastUpperGroup = toppart.nObj;
            }
        }

        //process from the upper...
        var bMAKE = false;
        var bLASTPART = false;
        var bFIRSTNONTOPPART = true;

        for (var p=this.final_parts.length-2; p >=0; p--) {
            var part = this.final_parts[p];
            if (p==0) bLASTPART = true;
            if (p<this.final_parts.length-2) bFIRSTNONTOPPART=false;

            if (part.status=="REAL") {
                _prevUpperGroup = _lastUpperGroup;
                _lastUpperGroup = part.nObj;
                continue;
            }
            else if (bMAKE==false && part.status=="unhandled") {
                if (_lastUpperGroup==null) {
                    var test = await this.checkForKnown(part.str);
                    if (test!=null) {
                        _lastUpperGroup = test;
                    }
                    else {
                        bMAKE=true;
                    }
                }
                else {
                    if (bFIRSTNONTOPPART==false) {
                        var testpart = (part.str+", "+_lastUpperGroup.text);   //Washington, DC
                        var test =  await this.isConstituentOf(testpart, _lastUpperGroup);
                        if (test!=null) {
                            _lastUpperGroup = test;
                            continue;
                        }  
                    }
                    
                    var test =  await this.isConstituentOf(part.str, _lastUpperGroup);
                    if (test==null) {
                        await ANNE.API.getLocationParts(part.str);
                        test = await this.isConstituentOf(part.str, _lastUpperGroup);
                    }

                    //check to see if this is a KNONW THING by name..
                    //if so, look at its constituent parent.
                    //see if this parent has a constituent parent of _lastUpperGroup.
                    if (test==null) {
                        var testNOBJ = await this.checkForKnown(part.str);
                        if (testNOBJ!=null) {
                            var constitofNOBJ = testNOBJ.getConstituentOf();
                            if (constitofNOBJ!=null && constitofNOBJ.hasConstitParentOf(_lastUpperGroup.nid)==true) {
                                test = testNOBJ;
                            }
                        }
                    }
                    
                    if (test!=null) {
                        _lastUpperGroup = test;
                        part.nObj = _lastUpperGroup;
                        part.status = "REAL";
                        continue;
                    }
                    else {
                        bMAKE=true;
                    }
                }
            }

            //once we start making.. we gotta keep making until we exhaust our parts.
            if (bMAKE==true) {
                part.status="NEW";
                if (_lastUpperGroup!=null) {
                    _prevUpperGroup = _lastUpperGroup;
                }

                if ($bMAKEGHOST==true) {
                    console.log("location part:"+part.str);
                    _lastUpperGroup = await GHOSTDATA.makeGhostNeuron(MEM.location, part.str, NTYPE_INST);
                    
                    //we will ignore this when broadcasting relons for location.
                    //this is a helper for ghost mode in the app when a user shuts down and reloads from ghost memory.
                    if (bLASTPART==true && _lastUpperGroup.getNameRelon()==null) {
                        _lastUpperGroup.makeNameTempRelon(this.locationStr);
                    }
                }

                //make only temp neuron.
                else _lastUpperGroup = MEM.makeTempNObjOnly(USER._userNObj, NTYPE_INST, part.str, MEM.location, true);

                if (part.extras!=undefined && part.extras.length>0) {
                    for (var e=0; e < part.extras.length; e++) {
                        var e_rel = part.extras[e];
                        
                        //make ghost
                        if ($bMAKEGHOST==true) {
                            await ANNE.GHOSTDATA.makeGhostRelon(e_rel.type, _lastUpperGroup, e_rel.nid, TO_TYPE_ANNE, e_rel.to_s);
                        }
                        else {
                            ANNE.MEM.makeTempRelon(_lastUpperGroup, e_rel.type, e_rel.nid, TO_TYPE_ANNE, e_rel.to_s, true);
                        }
                    }
                }

                part.nObj = _lastUpperGroup; 
                _lastUpperGroup.bNEW=true;
                _lastUpperGroup.__functInherit(MEM.location, "anne_location.processFull");
                $neurons.push(_lastUpperGroup);

                //last location is a BE constituent_of the previous location.
                //has constituent will be made by the ANNODE for a free index
                //when the location is accepted.
                if (_prevUpperGroup!=null) {
                    if ($bMAKEGHOST==true) {
                        await ANNE.GHOSTDATA.new_ghost_be(_lastUpperGroup, MEM.constituent_of.nid, TO_TYPE_ANNE, _prevUpperGroup.nid);
                    }
                    //make temp relon.
                    else {
                        ANNE.MEM.makeTempRelon(_lastUpperGroup, e_rel.type,  MEM.constituent_of.nid, TO_TYPE_ANNE, _prevUpperGroup.nid, true);
                    }
                }
                continue;
            }

            if(part.status=="unhandled") {
                console.log("???????");
            }
        }

        //known..
        if ($neurons.length==0 && _lastUpperGroup!=null) {
            this.nObj = _lastUpperGroup;
            return this.nObj;
        } 

        this.nObj = $neurons[$neurons.length-1];
        return this.nObj;
    }


    /**
     * 
     */
    print = function() {
        if (ANNE.SETTINGS.debugExternal()==true) console.log("______________________________________________");
        if (ANNE.SETTINGS.debugExternal()==true) console.log("original str: "+this.originalStr);
        if (ANNE.SETTINGS.debugExternal()==true) console.log("prepped str:  "+this.locationStr);
        
        if (this.nObj==null) {
            if (ANNE.SETTINGS.debugExternal()==true) console.log("no nOBJ --> something went wrong.");
        }
        
        for (var r=0; r<this.final_parts.length; r++) {
            var part = this.final_parts[r];
            var polity="";
            if (ANNE.SETTINGS.debugExternal()==true) console.log("["+part.status+"] ("+part.partstr+") "+part.str);
        }
    }


    /**
     * Some locations can be empire/territory or dynasty based.
     * They are historic in nature (mostly) but document the more accurate "location"
     * Present day locations can be tied to historic emptire.
     * (ie, modern day X is located within the old Y empire)
     * 
     * note: we are not setup to handle the location
     * Virginia, British America, British Empire
     * We are setup for Virginia, British America OR Virginia British Empire
     * 
     * @param {*} $str 
     * @returns 
     */
    checkForNonCountryTop=async($str)=>{
        var str = $str.toLowerCase();

        if ($str=="UK" || $str=="U.K." || $str=="United Kingdom" || $str=="The United Kingdom") {
            if (MEM.COUNTRY['p_GB']!=undefined) return MEM.COUNTRY['p_GB'];
        }
        
        //check empire first
        for (var e=0; e < MEM.empire.ins.length; e++) {
            var in_rel = MEM.empire.ins[e];
            if (in_rel.r!=MEM.polity.temp_nid) continue;
            var nOBJ = MEMG.getNeuronByTempNid(in_rel.f);
            if (nOBJ.owned_by=="") continue;
            var owned_byNOBJ = MEMG.getNeuronByNid(nOBJ.owned_by);
            if (MEM._activeWorldViewTempNids.length && MEM._activeWorldViewTempNids.indexOf(owned_byNOBJ.temp_nid)==-1) continue
            if (str == nOBJ.text.toLowerCase()) return nOBJ;
        }

        //check territory.
        for (var i=0; i < MEM.territory.ins.length; i++) {
            var in_rel = MEM.territory.ins[i];
            if (in_rel.r!=MEM.polity.temp_nid) continue;
            var nOBJ = MEMG.getNeuronByTempNid(in_rel.f);
            if (nOBJ.owned_by=="") continue;
            var owned_byNOBJ = MEMG.getNeuronByNid(nOBJ.owned_by);
            if (MEM._activeWorldViewTempNids.length && MEM._activeWorldViewTempNids.indexOf(owned_byNOBJ.temp_nid)==-1) continue
            if (str == nOBJ.text.toLowerCase()) return nOBJ;
        }

        return null;
    }


    /**
     * 
     * @param {*} $str 
     * @returns 
     */
    checkForCountry=async($str)=> {
        if ($str.indexOf("Kingdom of")!=-1) {
            $str = $str.replace("Kingdom of", "");
        }
        if ($str=="UK") $str="GB";

        $str = $str.trim();
        var nodots = "";
        if ($str.indexOf(".")!==-1) nodots = $str.replace(/\./g, ''); 
        else nodots = $str;

        //do alpha 2 lookup
        if (nodots.length==2) {
            if (MEM.COUNTRY['p_'+nodots]!=undefined) return MEM.COUNTRY['p_'+nodots];
            return null;
        }
        //do alpha 3 lookup
        else if (nodots.length==3) {
            if (MEM.COUNTRY['p_'+nodots]!=undefined) return MEM.COUNTRY['p_'+nodots];
            return null;
        }
        
        var country = await this.checkCountriesNeuronDirect(nodots);
        return country;
        
    }


    /**
     * Region, state, province... 
     * Something lower than country but bigger than city.
     * @param {*} $str 
     * @returns 
     */
    checkForRegionOrState=async($str)=>{
        //console.log("(checkForRegionOrState) "+$str);
        if (!!$str==false) return null;
        if ($str=="") return null;
        if (typeof $str!=="string") {
            $str = $str.str;
            if (typeof $str!=="string") {
                alert("still shitty code");
                console.log($str);
                return null;
            }
        }
        $str = $str.trim();
        $str = $str.toLowerCase();
        
        var nodots = "";
        if ($str.indexOf(".")!==-1) nodots = $str.replace(/\./g, ''); 
        else nodots = $str;

        //do alpha 2 lookup
        if (nodots.length==2) {
            if (MEM.STATE[nodots]!=undefined) return MEM.STATE[nodots];
            return null;
        }
        else {
            var state = this.checkStatesNeuronDirect(nodots);
            if (state!=null) return state;
        }

        //for locations like "Ottowa, Ontario"  (expected to know Ontario is in Canada)
        for (var i=0; i < MEM.province.ins.length; i++) {
            var in_rel = MEM.province.ins[i];
            if (in_rel.r!=MEM.polity.temp_nid) continue;
            var nOBJ = MEMG.getNeuronByTempNid(in_rel.f);
            if (nOBJ.owned_by=="") continue;
            var owned_byNOBJ = MEMG.getNeuronByNid(nOBJ.owned_by);
            if (MEM._activeWorldViewTempNids.length && MEM._activeWorldViewTempNids.indexOf(owned_byNOBJ.temp_nid)==-1) continue
            if ($str == nOBJ.text.toLowerCase()) return nOBJ;
        }

        //mispelling on purpose to not confuse with country.
        for (var i=0; i < MEM.cownty.ins.length; i++) {
            var in_rel = MEM.cownty.ins[i];
            if (in_rel.r!=MEM.polity.temp_nid) continue;
            var nOBJ = MEMG.getNeuronByTempNid(in_rel.f);
            if (nOBJ.owned_by=="") continue;
            var owned_byNOBJ = MEMG.getNeuronByNid(nOBJ.owned_by);
            if (MEM._activeWorldViewTempNids.length && MEM._activeWorldViewTempNids.indexOf(owned_byNOBJ.temp_nid)==-1) continue
            if ($str == nOBJ.text.toLowerCase()) return nOBJ;
        }

        return null;
    }


    /**
     * 
     * @param {*} $str 
     * @returns 
     */
    checkForKnown=async($str)=> {
        $str = $str.trim();

        //use the SEARCH SS if we have it.
        if (ANNE.SEARCH!=null && ANNE.SEARCH.SS!=null) {
            var searchObj = ANNE.SEARCH.SS.getDefaultSearchObj($str, [MEM.location.nid]);
            searchObj.thresh = 0.9;
            //this returns all matching relons from memory (not just the search)
            var bDOPRE = true; //ok to end by finding match
            var aMatches = await ANNE.CHASE.anne_global_search(searchObj, bDOPRE);
            if (aMatches.length) {
                console.log(aMatches);
                aMatches.sort(UTILS.sortByFireThenIns);
                return aMatches[0];
            }
        }

        //otherwise, just hit the CIRCUIT
        else if (ANNE.CIRCUIT!=null) {
            var matches = await ANNE.CIRCUIT.searchToResolve($val[v], MEM.location);
            return matches[0];
        }

        //just look up memory -- perhaps use the anbls and look for class 
        //if we have anbls.. (that is only for NLP use cases)
        else {
            console.log("improper js classes loaded for using anne_location")
        }
        return null;
    }


    /**
     * 
     * @param {*} $countryText 
     * @returns 
     */
    checkCountriesNeuronDirect = async($countryText)=> {
        var countryText = $countryText.toLowerCase();
        //this uses the COUNTRY mod made at bootup since these are not classified
        //as countries.  They are be->polity country and we build a MOD based on rules
        //since in this application we want countries easily handy but we don't want to
        //loop through a hundred thousand cities searching for text strings.
        if (MEM.COUNTRY._aChildren.length<150) {
            //our country mod is broken????????????
            return await this.theLongWayToGetCountry($countryText);
        }
        for (var c=0; c < MEM.COUNTRY._aChildren.length; c++) {
            var country = MEMG.getNeuronByTempNid(MEM.COUNTRY._aChildren[c]);
            if (country.text.toLowerCase()==countryText) {
                var owned_byNOBJ = MEMG.getNeuronByNid(country.owned_by);
                if (MEM._activeWorldViewTempNids.length && MEM._activeWorldViewTempNids.indexOf(owned_byNOBJ.temp_nid)==-1) {
                    continue
                }
                return country;
            }

            //aka match (quick array, more mem, less processing time)
            else {
                if (country.aka_lower!=undefined) {
                    if (country.aka_lower.indexOf(countryText)!=-1) {
                        return country;
                    }
                }
            }
        }
        return null;
    }


    /**
     * 
     * @param {*} $text 
     */
    theLongWayToGetCountry = async($text)=> {
        console.warn("doing the longwaytogetcountry, no MEM.country.aChildren!");

        await ANNE.API.getLocationParts($countryText);
        await ANNE.IDB.queryForText($text, null, true);

        var arr = ANNE.MEM.searchTextIndex($text);
        for (var a=0; a < arr.length; a++) {
            var nObj = arr[a];
            if (nObj.owned_by!=ANNE.MEM.ANNE_ACCTID && nObj.owned_by!=ANNE.USER._userNObj.nid) continue;

            //something named text, owned by user or ANNE.  It it be country?
            if (nObj.bes.indexOf(ANNE.MEM.country.temp_nid)!=-1) {
                return nObj;
            }
        }
        return null;
    }



    /**
    */
    isKnownLocation = function($name) {
        
    }
    
    
    /**
     * 
     * @param {*} $stateText 
     * @returns 
     */
    checkStatesNeuronDirect = function($stateText) {
        var stateText = $stateText.toLowerCase();
        for (var c=0; c < MEM.STATE._aChildren.length; c++) {
            var state=MEM.STATE._aChildren[c];
            if (state.text.toLowerCase()==stateText) {
                if (ANNE.isANNE(state.owned_by)==true) return state;
                var owned_byNOBJ = MEMG.getNeuronByNid(state.owned_by);
                if (MEM._activeWorldViewTempNids.length && MEM._activeWorldViewTempNids.indexOf(owned_byNOBJ.temp_nid)==-1) {
                    continue
                }
                return state;
            }

            //aka match (quick array, more mem, less processing time)
            //"New York State" should match through here.
            else {
                if (state.aka_lower!=undefined) {
                    if (state.aka_lower.indexOf(stateText)!=-1) return state;
                }
            }
        }
        return null;
    }


    /**
     * is this str a constituent of ANYTHING that is a constituent of the top?
     * 
     * This basically says, if we have a CITY, then COUNTRY...
     * and we already know of a CITY named that,  in a region/state/some middle layer, in that COUNTRY,
     * then assume this is the same one.
     * 
     * To get a city named the same but in a different country we need to distinguish that by 
     * providing a different inner-region (state, region, district, etc)
     * 
     * @param {*} $str 
     * @param {*} $topNOBJ 
     * @returns 
     */
    isConstituentOfAnyIn=async($str, $topNOBJ)=>{
        var location_lowercase = $str.toLowerCase();
        if ($topNOBJ==undefined || $topNOBJ==null || $topNOBJ.nid==undefined) return null;
        var ins = [];
        if ($topNOBJ.ins!=undefined) {
            ins = $topNOBJ.ins;
        }
        else return null;

        for (var i=0; i < ins.length; i++) {
            var rObj = ins[i];
            //we want the ins of constituent to see if this str
            //is a known constituent of this known topNOBJ location.
            if (rObj.r!=MEM.constituent_of.temp_nid) continue;
            if (rObj.type!=TYPE_HAS && rObj.type!=TYPE_BE) continue;
            if (rObj.to_type!=TO_TYPE_ANNE) continue;
            var cNOBJ = MEMG.getNeuronByNid(rObj.from_nid);

            for (var ii=0; ii < cNOBJ.ins.length; ii++) {
                var rObj2 = cNOBJ.ins[ii];
                //we want the ins of constituent to see if this str
                //is a known constituent of this known topNOBJ location.
                if (rObj2.r!=MEM.constituent_of.temp_nid) continue;
                if (rObj2.type!=TYPE_HAS && rObj.type!=TYPE_BE) continue;
                if (rObj2.to_type!=TO_TYPE_ANNE) continue;
                        
                //text must match
                var testMatchNOBJ = MEMG.getOrMakeIfNew(rObj2.from_nid);
                if (testMatchNOBJ.bes.length==0) continue;

                //must be a location
                if (testMatchNOBJ.bes[0]!=MEM.location.temp_nid) continue;

                //can't accept anything but ANNE or self owned locations.
                if (ANNE.isANNE(testMatchNOBJ.owned_by)==false && testMatchNOBJ.owned_by!=USER._userNObj.nid) continue;
                if (testMatchNOBJ.text.toLowerCase()!=location_lowercase) continue;

                return testMatchNOBJ;
            }
        }
        return null;
    }


    /**
     * 
     * @param {*} $str 
     * @param {*} $constituentOfNOBJ 
     * @returns 
     */
    isConstituentOf=async($str, $constituentOfNOBJ)=>{
        var location_lowercase = $str.toLowerCase();
        if ($constituentOfNOBJ==undefined || $constituentOfNOBJ==null || $constituentOfNOBJ.nid==undefined) return null;
        var ins = [];
        if ($constituentOfNOBJ.ins!=undefined) {
            ins = $constituentOfNOBJ.ins;
        }
        else return null;
        for (var i=0; i < ins.length; i++) {
            var rObj = ins[i];

            //we want the ins of constituent to see if this str
            //is a known constituent of this known constituentOfNOBJ location.
            if (rObj.r!=MEM.constituent_of.temp_nid) continue;
            if (rObj.type!=TYPE_HAS && rObj.type!=TYPE_BE) continue;
            if (rObj.to_type!=TO_TYPE_ANNE) continue;

            //text must match
            var testMatchNOBJ = MEMG.getOrMakeIfNew(rObj.from_nid);
            //console.log($str+" vs "+testMatchNOBJ.text);

            //can't accept anything but ANNE or self owned locations.
            if (ANNE.isANNE(testMatchNOBJ.owned_by)==false && testMatchNOBJ.owned_by!=USER._userNObj.nid) continue;

            //test match the location name and any akas we have registered for it.
            if (this.isLowerAny(testMatchNOBJ, location_lowercase)==false) continue;

            //if we do not have a be class, chase the outs.
            if (testMatchNOBJ.bes.length==0) continue;

            //must be a location
            if (testMatchNOBJ.bes[0]!=MEM.location.temp_nid) continue;

            return testMatchNOBJ;
        }
        return null;
    }


    /**
     * 
     * @param {*} $nObj 
     * @param {*} $lowerstr 
     * @returns 
     */
    isLowerAny = function($nObj, $lowerstr) {
        if ($nObj.text.toLowerCase()!=$lowerstr) {
            var bFOUND=false;
            if ($nObj.aka!=null && $nObj.aka.length) {
                for (var k=0; k < $nObj.aka.length; k++) {
                    if ($nObj.aka[k].toLowerCase()==$lowerstr) return true;
                }
            }
        }
        else return true;

        return false;
    }


    /**
     * 
     * @param {anne_neuron} $gNOBJ 
     * @returns 
     */
    getConstituentOf=function($gNOBJ) {
        var rel = MEMG.getRelonByTempR($gNOBJ.outs, MEM.constituent_of.temp_nid);
        if (rel==null) return null;
        return MEMG.getNeuronByTempNid(rel.t);
    }


    /**
     * 
     * @param {*} $str 
     * @param {anne_neuron} $constituentOfNOBJ 
     * @returns 
     */
    getTnidsConstituentOf=async($str, $constituentOfNOBJ)=>{
        var parentLoc = this.getConstituentOf(this.nObj);
        if (parentLoc==null || parentLoc.bNEW==true) return [];
        if (parentLoc.ins!=undefined) ins = parentLoc.ins;
        else return [];

        var tnids = [];
        for (var i=0; i < ins.length; i++) {
            var rObj = ins[i];

            //we want the ins of constituent to see if this str
            //is a known constituent of this known constituentOfNOBJ location.
            if (rObj.r!=MEM.constituent_of.temp_nid) continue;
            if (rObj.type!=TYPE_HAS && rObj.type!=TYPE_BE) continue;
            if (rObj.to_type!=TO_TYPE_ANNE) continue;

            var testMatchNOBJ = MEMG.getOrMakeIfNew(rObj.from_nid);
            
            //can't accept anything but ANNE or self owned locations.
            if (ANNE.isANNE(testMatchNOBJ.owned_by)==false && testMatchNOBJ.owned_by!=USER._userNObj.nid) continue;

            //if we do not have a be class, chase the outs.
            if (testMatchNOBJ.bes.length==0) continue;

            //must be a location
            if (testMatchNOBJ.bes[0]!=MEM.location.temp_nid) continue;

            return tnids.push(testMatchNOBJ.temp_nid);
        }
        return null;
    }


    getAllOutsForGhosting = function() {
        var outs = [];
        for(var n=0; n < this.neurons.length; n++) {
            outs = outs.concat(this.neurons[n].outs);
        }
        return outs;
    }


    /**
     * 
     * @param {*} $str 
     * @param {*} $constituentOfNOBJ 
     * @returns 
     */
    isConstituentOf=async($str, $constituentOfNOBJ)=>{
        var location_lowercase = $str.toLowerCase();
        if ($constituentOfNOBJ==undefined || $constituentOfNOBJ==null || $constituentOfNOBJ.nid==undefined) return null;
        var ins = [];
        if ($constituentOfNOBJ.ghost==false) await ANNE.API.queryForIns($constituentOfNOBJ.nid);
        
        if ($constituentOfNOBJ.ins!=undefined) {
            ins = $constituentOfNOBJ.ins;
        }
        else {
            
        }
        for (var i=0; i < ins.length; i++) {
            var rObj = ins[i];

            //we want the ins of constituent to see if this str
            //is a known constituent of this known constituentOfNOBJ location.
            if (rObj.r!=MEM.constituent_of.temp_nid) continue;
            if (rObj.type!=TYPE_HAS && rObj.type!=TYPE_BE) continue;
            if (rObj.to_type!=TO_TYPE_ANNE) continue;

            //text must match
            var testMatchNOBJ = MEMG.getOrMakeIfNew(rObj.from_nid);
 
            //can't accept anything but ANNE or self owned locations.
            if (ANNE.isANNE(testMatchNOBJ.owned_by)==false && testMatchNOBJ.owned_by!=USER._userNObj.nid) continue;

            //test match the location name and any akas we have registered for it.
            if (this.isLowerAny(testMatchNOBJ, location_lowercase)==false) continue;

            //if we do not have a be class, chase the outs.
            if (testMatchNOBJ.bes.length==0) continue;

            //must be a location
            if (testMatchNOBJ.bes[0]!=MEM.location.temp_nid) continue;

            return testMatchNOBJ;
        }
        return null;
    }


    /**
     * helpful to display so we know which parts are ghost and which real
     *
     * @param {*} $partsMax 
     * @returns 
     */
     printFullIcoString = function($partsMax=2) {
        var aParts = [];
        var part = ANNE.A.getPrintNameIcoSpan(this.nObj);
        aParts.push(part);
        var parentLoc = this.getConstituentOf(this.nObj);
        var safety=0;
        while (safety++<7 && parentLoc!=null && aParts.length<$partsMax) {
            var part = ANNE.A.getPrintNameIcoSpan(parentLoc);
            aParts.push(part);
            parentLoc = this.getConstituentOf(parentLoc);
        }
        return aParts.join(",&nbsp;");
    }


    printFullDebugString = function() {
        if (this.nObj==null) return;
        if (ANNE.SETTINGS.debug()==true) console.log("%c**parsed location** %c"+this.nObj.text, TALK.bgblack, TALK.bggreen)
        if (ANNE.SETTINGS.debug()==true) console.log("bNEW "+this.bNEW); 
        for (var n=0; n < this.neurons.length; n++) {
            var subnobj = this.neurons[n];
            if (ANNE.SETTINGS.debug()==true) console.log("%c temp:"+subnobj.temp+"%c"+subnobj.text, TALK.bgblack, TALK.bggreen)
        }
    }
}