class wiki_service {
    constructor($pgui, $makergui) {
        this.$pgui = $pgui;
        this.maker_gui = $makergui;
        this.pgui = $pgui;
        this.ID = $pgui._guid;
        this.pObj = $pgui.pObj;
        this.dismbig_fix = "";
        if (this.pObj) {
            this.misc = this.pObj.misc;
            if (this.pObj.s_cbk) this.success_callback = this.pObj.s_cbk; 
            if (this.pObj.f_cbk) this.fail_callback = this.pObj.f_cbk;
        }
        else {
            this.misc = null;
            this.success_callback = null; 
            this.fail_callback = null;
        }
        this.nid = this.pObj.p2;
        //this.el_admin_msg = document.getElementById("valid_msg_"+this.ID);
        this.el_extras = document.getElementById("extras_display_only_"+this.ID);
        this.origin_search_val = "";

        this.el_helper_msg = document.getElementById("helper_msg_"+this.ID);
        ANNE.A.hide(this.el_helper_msg);
    }


    doExtra = function($lbl, $val) {
        ANNE.A.ezSpan(this.el_extras, "", "extra-wiki-data", "<span class='wiki-extra-lbl'>"+$lbl+"</span>&nbsp;<span class='data-medium'>"+$val+"</span>", {display:"block"});
    }

    /**
     */
    setLocationObj=async($refPropName="birth_placeOBJ", $val="Austin,Texas", $lbl="birthplace", $existingEl=null)=>{
        console.log("%c "+$lbl+" to conceptualize %c"+$val,TALK.bgred, TALK.bgblackgreen);
        this[$refPropName] = new anne_location($val); 
        await this[$refPropName].processFull();
        this[$refPropName].print();

        if (this[$refPropName].nObj!=null) {
            console.log(this[$refPropName].nObj);
            var icostring = this[$refPropName].printFullIcoString(3);
            this.doExtra($lbl, icostring);;
        }
    }

    setDateObj=async($refPropName="birth_dateOBJ", $val="1960-01-01", $lbl="birthdate", $existingEl=null)=> {
        console.log("%c "+$lbl+" to conceptualize %c"+$val,TALK.bgred, TALK.bgblackgreen);
        this[$refPropName] =  new anne_date($val);
        if (this[$refPropName]!=null) {
            if ($existingEl!=null) {
                ANNE.A.setValue($existingEl, this[$refPropName].dateStr);
            }
            await this[$refPropName].testDate();
            return;
        }
        this[$refPropName] = null;
        return null;
    }

    /**
    */
    resetANNEMsg = function() {
        ANNE.A.setHTML(this.el_helper_msg, "");
        ANNE.A.hide(this.el_helper_msg);
    }

    setANNEMsg = function($msg){
        ANNE.A.setHTML(this.el_helper_msg, $msg, true); 
    }
}


class service_person_by_wiki extends wiki_service {
    constructor ($pgui, $makergui=null) {
        super($pgui);
        this._wtype="person";
        this.maker_gui = $makergui;
        this.existing_nid = null;
        this.personName = "";       //name (required)    
        this.enter = "wiki";
        this.el_input = document.getElementById("dynamic_input_"+this.ID);
        this.el_input.addEventListener("keyup", e=>this.returnPressPerson(e, this));
        this.el_input.addEventListener("input",  e=>this.inputPersonNameEventHandler(e));
        this.el_input.focus();
        this.el_check_anne_btn = document.getElementById("check_new_btn_"+this.ID);
        this.el_check_anne_btn.addEventListener("click", e=>this.testPersonNameOnly(e));
        this.el_saveghostbtn = document.getElementById("make_new_ghost_btn_"+this.ID);
        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewPersonGhost(e));
        this.el_wikibtn = document.getElementById("btn_wikipedia_"+this.ID);
        this.el_wikibtn.addEventListener("click", e=>this.wikiSearchPerson(e));
        this.el_extras = document.getElementById("extras_display_only_"+this.ID);
    }

    
    /**
     * 
     * @param {*} $wikiLukatPassthruObj 
     * @returns 
     */
    initFromObj =  async($wikiLukatPassthruObj)=> {
        this.el_input.value = $wikiLukatPassthruObj.name!=undefined ? $wikiLukatPassthruObj.name : $wikiLukatPassthruObj.search_val;
        this.personName = this.el_input.value;
        this.resetANNEMsg("");
        await this.pesonFromWiki($wikiLukatPassthruObj);
        await this.testNewPerson(null);
    }


    /**
     * type in name
     */
    inputPersonNameEventHandler=async($e)=> {
        this.personName = ANNE.A.getValue(this.el_input);
        ANNE.A.hide(this.el_wikibtn);
        ANNE.A.hide(this.el_check_anne_btn);
        ANNE.A.hide(this.el_saveghostbtn);

        //first check ANNE for this company.
        if (this.personName.length>0) {
            this.enter="lookup";
            this.setEnterStatusPerson(false);
        }
        else {
            this.enter= "none";
        }
    }


    /**
     */
    setEnterStatusPerson=function($bINITWIKISEARCH=false){
        this.resetANNEMsg();
        if (this.personName.length>0) {
            if ($bINITWIKISEARCH==true) {
                this.setANNEMsg("parsed wiki data.  Ready to make ghost.");
                ANNE.A.show(this.el_saveghostbtn);
                ANNE.A.hide(this.el_check_anne_btn);
                this.enter="submit";
            }
            else {
                ANNE.A.show(this.el_check_anne_btn);
                ANNE.A.hide(this.el_saveghostbtn);
                this.setANNEMsg("");
                this.enter="lookup";
            }
        }

        //we need the person name
        else {
            var val = ANNE.A.getValue(this.el_input)
            if (val.length==0) {
                this.setANNEMsg("Please enter the person's name");
                ANNE.A.hide(this.el_check_anne_btn);
                ANNE.A.hide(this.el_saveghostbtn);
                this.enter="none";
            }
            else {
                this.resetANNEMsg();
                ANNE.A.show(this.el_check_anne_btn);
                ANNE.A.hide(this.el_saveghostbtn);
                this.enter="wiki";
            }
        }
    }

    
    /**
     * 
     * @param {*} $e 
     */
    testPersonNameOnly = async($e)=>{
        ANNE.A.hide(this.el_check_anne_btn);
        var rez = await CHASE.getPerson(this.personName);

        if (rez.status=="good" && rez.message=="available") {
            //ANNE.A.show(this.el_saveghostbtn);
            this.enter = "submit";
            this.setANNEMsg("<span class='text-success-lbl'>"+this.personName+" is not yet in the ANNE worldview!</span>");
            //ANNE.A.show(this.el_saveghostbtn);
            ANNE.A.show(this.el_wikibtn);
            this.enter = "wiki";
        }

        //TODO: user may still want to power forward with a new person with same name..
        //should we permit this here? 
        else {
            this.resetANNEMsg();
            ANNE.A.hide(this.el_saveghostbtn);
            var nOBJ = MEMG.getNeuronByNid(rez.result.nid);
            if (nOBJ.ghost==true || nOBJ.owned_by==USER._userNObj.nid) {
                var el = ANNE.A.ezEl(this.el_helper_msg, "span", '');
                EXT_BTNS.makeNeuronLink(el, rez.result.nid);
                var el2 = ANNE.A.ezEl(el, "span", 'text-primary-lbl');
                el2.append(" is already your neuron.");
            }
            else { 
                var el = ANNE.A.ezEl(this.el_helper_msg, "span", '');
                EXT_BTNS.makeNeuronLink(el, rez.result.nid);
                var el2 = ANNE.A.ezEl(el, "span", 'text-primary-lbl');
                el2.append(" is already in the ANNE worldview!");
            }
            this.enter = "none";
            ANNE.A.show(this.el_helper_msg);
        }
    }


    returnPressPerson = async($e)=> {
        $e.preventDefault();
        $e.stopImmediatePropagation();
        if ($e.keyCode === 13) {
            if (this.enter=="wiki") return this.wikiSearchPerson($e);
            else if (this.enter=="none") return;
            else if (this.enter=="lookup") return this.testPersonNameOnly($e);
            else if (this.enter=="submit") return this.makeNewPersonGhost($e);
        }
    }

    doExtra = function($lbl, $val) {
        ANNE.A.ezSpan(this.el_extras, "", "extra-wiki-data", "<span class='lbl-medium'>"+$lbl+"</span>&nbsp;<span class='data-medium'>"+$val+"</span>", {display:"block"});
    }

    /**
     */
    success = function($obj) {
        console.log($obj);
        this.setANNEMsg("<span class='text-success-lbl'>"+this.makeclass_nObj.text+" created!</span>"); 
    }

    /**
     * WE ARE NOT DOING THIS, ARE WE????
     */
    wikiSearchPerson = async($e, $dimabig_override="")=> {
        this.personName = null;       //name (required)
        ANNE.A.hide(this.el_wikibtn);
        var val = ANNE.A.getValue(this.el_input);
        if (val.length==0) return;
        ANNE.A.show("loading");
        ANNE.A.empty(this.el_extras);
        this.origin_search_val = val;
        this.personName = val;

        var dataObj = null;
        if ($dimabig_override!="") dataObj = await ANNE.WIKIDATA.getExternalWikiData($dimabig_override, "person", null);
        else dataObj = await ANNE.WIKIDATA.getExternalWikiData(val, "person", null);
        
        return await this.personFromWiki(dataObj);
    }


    /**
     * person data from wikipedia.
     */
     personFromWiki=async($dataObj, $type="result")=>{
        ANNE.A.hide("loading");
        if ($dataObj==null) {
            this.setANNEMsg("no results from wikipedia");
            ANNE.A.show(this.el_saveghostbtn);
            return;
        }
        if ($dataObj.status=="error") {
            this.setANNEMsg($dataObj.error_msg);
            return;
        }

        //we need more info
        else if ($dataObj.status=="need_info" && $dataObj.result_type=="disambig" && $dataObj.pages.length) {
            ANNE.A.empty(this.el_helper_msg);
            ANNE.A.ezEl(this.el_helper_msg, "span", "dib text-danger-lbl", "disambig name");

            //auto disambig
            for (var p=0; p < $dataObj.pages.length; p++) {
                var page = $dataObj.pages[p];
                this.dismbig_fix = page;
                if (page.indexOf("(company)")==-1) continue;
                var nii = page.indexOf("(");
                var nameOnly = page.substring(0, nii-1).trim();
                ANNE.A.setValue(this.el_input, nameOnly); //use original typed-in name.
                this.wikiSearchPerson(null, page);       //use dismabig name
            }
            
            //we should clean up the possible disambig options to only put in in companies, but it isn't easy.
            ANNE.A.ezDD_basic(this.el_helper_msg, $dataObj.pages, "disambiguate this", async($val)=>{
                console.log("dd select"+$val);
                if ($val!="") {
                    this.dismbig_fix = $val;
                    var nii = $val.indexOf("(");
                    if (nii!=-1) {
                        var nameOnly = $val.substring(0, nii-1).trim();
                        ANNE.A.setValue(this.el_input, nameOnly);
                    }
                    else ANNE.A.setValue(this.el_input, $val);
                    this.wikiSearchPerson(null, $val);
                }
            })
            return;
        }

        //we're going to pass this through to the launch neuron if the user makes this company.
        this._dataObj = $dataObj;

        ANNE.A.empty(this.el_extras);
        this.resetANNEMsg();
        console.log($dataObj);

        this.wiki_type = $dataObj.wiki_type;
        this.doExtra("wiki type", this.wiki_type);

        var WD = new wikipediadata2();
        await WD.processResults(this._dataObj);       //this will set this._dataObj.results

        if (WD.logo!="" || WD._imgs.length) {
            var imgref = WD.logo;
            if (imgref=="") imgref = WD._imgs[0];
            var wikic = "http://commons.wikimedia.org/wiki/Special:FilePath/"+imgref+"?width=200";
            var imgel = ANNE.A.doImageDyno2("wiki_img", "", wikic, 200, "");
        }
        else ANNE.A.hide("wiki_img");

        this.setEnterStatusPerson(true);

        return;
    }


    
    /**
     * new method -- using similiar to connectors
     * @param {*} $e 
     */
    makeNewPersonGhost=async($e)=> {
        console.log("making makeNewPersonGhost neuron");
        ANNE.A.hide(this.el_saveghostbtn);
        var relons_to_ghost = [];

        var proper_name = this.personName;
        if(this._dataObj!=null && this._dataObj.name != undefined && this._dataObj.name.length) {
            proper_name == this._dataObj.name;
        }
        var newGhostNOBJ = await MEM.makeGhostNObj(USER._userNObj.nid, NTYPE_INST, proper_name, MEM.person, true, true);
        newGhostNOBJ.bNEW=true;
        relons_to_ghost = newGhostNOBJ.outs.concat();

        //make an aka for the name the user typed if it is different than the proper name.
        if (proper_name!=this.personName && this.personName.length>0) {
            var rel_aka = MEM.makeTempRelon(newGhostNOBJ, TYPE_BE, MEM.aka.nid, TO_TYPE_STRING, this.personName, true);
            relons_to_ghost.push(rel_aka);
        }

        //store the wikipart
        var wikipart = this.personName;
        if (this.dismbig_fix!="") wikipart = this.dismbig_fix;
        var rel_wikipart = MEM.makeTempRelon(newGhostNOBJ, TYPE_SYS, MEM.wikipart.nid, TO_TYPE_STRING, wikipart, true);
        relons_to_ghost.push(rel_wikipart);

        if (this._dataObj && this._dataObj.results!=undefined && this._dataObj.results!=null) {
            //supporting/new data on this new ghost (we extracted from wikipedia)
            for (var d=0; d < this._dataObj.results.length; d++) {
                var propObj = this._dataObj.results[d];
                console.log(propObj);
    
                var type = propObj.type;
                var to_type = propObj.to_type;
                var relnNOBJ = MEMG.getNeuronByNid(propObj.reln)
                
                //the actual values in an array (which we processed a gazillion times)
                for (var p=0; p < propObj.prop_value_arr.length; p++) {
                    var obj = propObj.prop_value_arr[p];
                    var to_s = obj.to_s;
                    if (to_s==undefined || to_s==null || to_s=="") continue;
               
                    //primary RELON specified in the data.  (it may be FLIPPED to first make)
                    //check for dupe information.
                    var x_relon = MEMG.getRelonFromWithTo(newGhostNOBJ.outs, type, relnNOBJ.nid, to_s);
                    if (relnNOBJ.nid==ANNE.MEM.birthplace.nid) {
                        var toNOBJ = MEMG.getNeuronByNid(to_s);
                        console.log(toNOBJ.text);
                        type=TYPE_BE;
                    }
                    if (relnNOBJ.nid==ANNE.MEM.deathplace.nid) {
                        var toNOBJ = MEMG.getNeuronByNid(to_s);
                        console.log(toNOBJ.text);
                        type=TYPE_BE;
                    }
                    if (x_relon==null) {
                        await GHOSTDATA.makeGhostRelon(type, newGhostNOBJ, relnNOBJ.nid, to_type, to_s);
                    }
    
                    if (obj.extras!=undefined) {
                        for (var e=0; e < obj.extras.length; e++) {
                            var erel =  obj.extras[e];
                            await GHOSTDATA.makeGhostRelon(erel.type, newGhostNOBJ, erel.reln, erel.to_type, erel.to_s);
                        }
                    }
                }
            } 
        }

        if (relons_to_ghost.length) {
            await ANNE.GHOSTDATA.localGhostTheRelons(relons_to_ghost);
        }
        
        PAGES.launchNeuron(newGhostNOBJ.nid);
    }
}


class maker_person_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid,  $ANNKH._bSHOWOW, false, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM.person.temp_nid]);
        
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
        this.main_class = new service_person_by_wiki($pgui, this);
    }

    initASYNC=async($miscObj)=> {
        await this.main_class.initFromObj($miscObj);
    }


    //test this, if it works, do the same for all others.
    checkChg = function($ANNKH) {
        console.log("checkChg");
        //todo.
    }
}


/*******************************************************************
 * ****************************************************************
 * ****************************************************************/



//CORP
class service_company_by_wiki extends wiki_service {
    constructor ($pgui, $makergui=null) {
        super($pgui);
        this._wtype="company";
        this.maker_gui = $makergui;
        this.existing_nid = null;
        this.companyName = "";       //name (required)
        this.registrationPolityObj = null;    
        this.disbandedOnObj = null;       
        this.hqplaceObj = null;     
        this.hqCountryplaceObj = null;     
        this.enter = "wiki";
        this.el_input = document.getElementById("dynamic_input_"+this.ID);
        this.el_input.addEventListener("keyup", e=>this.returnPressCompany(e, this));
        this.el_input.addEventListener("input",  e=>this.inputCorpNameEventHandler(e));
        this.el_input.focus();
        this.el_check_anne_btn = document.getElementById("check_new_btn_"+this.ID);
        this.el_check_anne_btn.addEventListener("click", e=>this.testCompanyNameOnly(e));
        this.el_saveghostbtn = document.getElementById("make_new_ghost_btn_"+this.ID);
        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewCompanyGhost(e));
        this.el_wikibtn = document.getElementById("btn_wikipedia_"+this.ID);
        this.el_wikibtn.addEventListener("click", e=>this.wikiSearchCompany(e));
        this.el_extras = document.getElementById("extras_display_only_"+this.ID);
    }

    
    /**
     * 
     * @param {*} $wikiLukatPassthruObj 
     * @returns 
     */
    initFromObj =  async($wikiLukatPassthruObj)=> {
        this.el_input.value = $wikiLukatPassthruObj.name!=undefined ? $wikiLukatPassthruObj.name : $wikiLukatPassthruObj.search_val;
        this.companyName = this.el_input.value;
        this.resetANNEMsg("");
        await this.companyFromWiki($wikiLukatPassthruObj);
        await this.testNewCompany(null);
    }


    /**
     * type in name
     */
    inputCorpNameEventHandler=async($e)=> {
        this.companyName = ANNE.A.getValue(this.el_input);
        ANNE.A.hide(this.el_wikibtn);
        ANNE.A.hide(this.el_check_anne_btn);
        ANNE.A.hide(this.el_saveghostbtn);

        //first check ANNE for this company.
        if (this.companyName.length>0) {
            this.enter="lookup";
            this.setEnterStatusCorp(false);
        }
        else {
            this.enter= "none";
        }
    }


    /**
     * Altering this to not make registration polity required..
     */
     setEnterStatusCorp=function($bINITWIKISEARCH=false){
        this.resetANNEMsg();
        if (this.companyName.length>0) {
            if ($bINITWIKISEARCH==true) {
                this.setANNEMsg("parsed wiki data.  Ready to make ghost.");
                ANNE.A.show(this.el_saveghostbtn);
                ANNE.A.hide(this.el_check_anne_btn);
                this.enter="submit";
            }
            else {
                ANNE.A.show(this.el_check_anne_btn);
                ANNE.A.hide(this.el_saveghostbtn);
                this.setANNEMsg("");
                this.enter="lookup";
            }
        }

        //we need the company name
        else {
            var val = ANNE.A.getValue(this.el_input)
            if (val.length==0) {
                this.setANNEMsg("Please enter the company name");
                ANNE.A.hide(this.el_check_anne_btn);
                ANNE.A.hide(this.el_saveghostbtn);
                this.enter="none";
            }
            else {
                this.resetANNEMsg();
                ANNE.A.show(this.el_check_anne_btn);
                ANNE.A.hide(this.el_saveghostbtn);
                this.enter="wiki";
            }
        }
    }

    
    /**
     * 
     * @param {*} $e 
     */
    testCompanyNameOnly = async($e)=>{
        ANNE.A.hide(this.el_check_anne_btn);
        var rez = await CHASE.getCompany(this.companyName, 0);
        console.log("lookupNewCompany", rez);
        if (rez.status=="good" && rez.message=="available") {
            ANNE.A.show(this.el_saveghostbtn);
            this.enter = "submit";
            this.setANNEMsg("<span class='text-success-lbl'> corp entity "+this.companyName+" is not yet in the ANNE worldview!</span>");
            ANNE.A.hide(this.el_saveghostbtn);
            ANNE.A.show(this.el_wikibtn);
            this.enter = "wiki";
        }
        else {
            this.resetANNEMsg();
            ANNE.A.hide(this.el_saveghostbtn);
            var nOBJ = MEMG.getNeuronByNid(rez.result.nid);
            if (nOBJ.ghost==true || nOBJ.owned_by==USER._userNObj.nid) {
                var el = ANNE.A.ezEl(this.el_helper_msg, "span", '');
                EXT_BTNS.makeNeuronLink(el, rez.result.nid);
                var el2 = ANNE.A.ezEl(el, "span", 'text-primary-lbl');
                el2.append(" is already your neuron.");
            }
            else { 
                var el = ANNE.A.ezEl(this.el_helper_msg, "span", '');
                EXT_BTNS.makeNeuronLink(el, rez.result.nid);
                var el2 = ANNE.A.ezEl(el, "span", 'text-primary-lbl');
                el2.append(" is already in the ANNE worldview!");
            }
            this.enter = "none";
            ANNE.A.show(this.el_helper_msg);
        }
    }


    returnPressCompany = async($e)=> {
        $e.preventDefault();
        $e.stopImmediatePropagation();
        if ($e.keyCode === 13) {
            if (this.enter=="wiki") return this.wikiSearchCompany($e);
            else if (this.enter=="none") return;
            else if (this.enter=="lookup") return this.testCompanyNameOnly($e);
            else if (this.enter=="submit") return this.makeNewCompanyGhost($e);
        }
    }

    doExtra = function($lbl, $val) {
        ANNE.A.ezSpan(this.el_extras, "", "extra-wiki-data", "<span class='lbl-medium'>"+$lbl+"</span>&nbsp;<span class='data-medium'>"+$val+"</span>", {display:"block"});
    }


    /**
     */
    success = function($obj) {
        console.log($obj);
        this.setANNEMsg("<span class='text-success-lbl'>"+this.makeclass_nObj.text+" created!</span>"); 
    }

    /**
     */
    wikiSearchCompany = async($e, $dimabig_override="")=> {
        this.companyName = null;       //name (required)
        this.registrationPolityObj = null;     
        this.disbandedOnObj = null;       
        this.hqplaceObj = null;     
        this.hqCountryplaceObj = null;  
        ANNE.A.hide(this.el_wikibtn);
        var val = ANNE.A.getValue(this.el_input);
        if (val.length==0) return;
        ANNE.A.show("loading");
        ANNE.A.empty(this.el_extras);
        this.origin_search_val = val;
        this.companyName = val;
        var dataObj = null;
        if ($dimabig_override!="") dataObj=await ANNE.WIKIDATA.getExternalWikiData($dimabig_override, "company");
        else dataObj = await ANNE.WIKIDATA.getExternalWikiData(val, "company");
        await this.companyFromWiki(dataObj);
        return;
    }


    /**
     * company/corp data from wikipedia.
     */
     companyFromWiki=async($dataObj, $type="result")=>{
        ANNE.A.hide("loading");
        if ($dataObj==null) {
            this.setANNEMsg("no results from wikipedia");
            ANNE.A.show(this.el_saveghostbtn);
            return;
        }
        if ($dataObj.status=="error") {
            this.setANNEMsg($dataObj.error_msg);
            return;
        }

        //we need more info
        else if ($dataObj.status=="need_info" && $dataObj.result_type=="disambig" && $dataObj.pages.length) {
            ANNE.A.empty(this.el_helper_msg);
            ANNE.A.ezEl(this.el_helper_msg, "span", "dib text-danger-lbl", "disambig name");

            //auto disambig
            for (var p=0; p < $dataObj.pages.length; p++) {
                var page = $dataObj.pages[p];
                this.dismbig_fix = page;
                //if (page.indexOf("(company)")==-1) continue;
                var nii = page.indexOf("(");
                var nameOnly = page.substring(0, nii-1).trim();
                ANNE.A.setValue(this.el_input, nameOnly); //use original typed-in name.
                this.wikiSearchCompany(null, page);       //use dismabig name
            }
            
            //we should clean up the possible disambig options to only put in in companies, but it isn't easy.
            ANNE.A.ezDD_basic(this.el_helper_msg, $dataObj.pages, "disambiguate this", async($val)=>{
                console.log("dd select"+$val);
                if ($val!="") {
                    this.dismbig_fix = $val;
                    var nii = $val.indexOf("(");
                    if (nii!=-1) {
                        var nameOnly = $val.substring(0, nii-1).trim();
                        ANNE.A.setValue(this.el_input, nameOnly);
                    }
                    else ANNE.A.setValue(this.el_input, $val);
                    this.wikiSearchCompany(null, $val);
                }
            })
            return;
        }

        //we're going to pass this through to the launch neuron if the user makes this company.
        this._dataObj = $dataObj;

        ANNE.A.empty(this.el_extras);
        this.resetANNEMsg();
        console.log($dataObj);

        this.wiki_type = $dataObj.wiki_type;
        this.doExtra("wiki type", this.wiki_type);

        var WD = new wikipediadata2();
        await WD.processResults(this._dataObj);       //this will set this._dataObj.results

        if (WD.logo!="" || WD._imgs.length) {
            var imgref = WD.logo;
            if (imgref=="") imgref = WD._imgs[0];
            var wikic = "http://commons.wikimedia.org/wiki/Special:FilePath/"+imgref+"?width=200";
            var imgel = ANNE.A.doImageDyno2("wiki_img", "", wikic, 200, "");
        }
        else ANNE.A.hide("wiki_img");

        this.setEnterStatusCorp(true);
    }


    
    /**
     * new method -- using similiar to connectors
     * @param {*} $e 
     */
    makeNewCompanyGhost=async($e)=> {
        console.log("making makeNewCompanyGhost neuron");
        ANNE.A.hide(this.el_saveghostbtn);
        var relons_to_ghost = [];

        var proper_name = this.companyName;
        if(this._dataObj!=null && this._dataObj.name!=undefined && this._dataObj.name.length) {
            proper_name == this._dataObj.name;
        }
        var newGhostNOBJ = await MEM.makeGhostNObj(USER._userNObj.nid, NTYPE_INST, proper_name, MEM.company, true, true);
        newGhostNOBJ.bNEW=true;
        relons_to_ghost = newGhostNOBJ.outs.concat();

        //make an aka for the name the user typed if it is different than the proper name.
        if (proper_name!=this.companyName && this.companyName.length>0) {
            var rel_aka = MEM.makeTempRelon(newGhostNOBJ, TYPE_BE, MEM.aka.nid, TO_TYPE_STRING, this.companyName, true);
            relons_to_ghost.push(rel_aka);
        }

        //store the wikipart
        var wikipart = this.companyName;
        if (this.dismbig_fix!="") wikipart = this.dismbig_fix;
        var rel_wikipart = MEM.makeTempRelon(newGhostNOBJ, TYPE_SYS, MEM.wikipart.nid, TO_TYPE_STRING, wikipart, true);
        relons_to_ghost.push(rel_wikipart);
        
        //supporting/new data on this new ghost (we extracted from wikipedia)
        if (this._dataObj!=null && this._dataObj.results!=undefined && this._dataObj.results!=null) {
            for (var d=0; d < this._dataObj.results.length; d++) {
                var propObj = this._dataObj.results[d];
                console.log(propObj);
    
                var type = propObj.type;
                var to_type = propObj.to_type;
                var reln = MEMG.getNeuronByNid(propObj.reln)
                
                //the actual values in an array (which we processed a gazillion times)
                for (var p=0; p < propObj.prop_value_arr.length; p++) {
                    var obj = propObj.prop_value_arr[p];
                    var to_s = obj.to_s;
                    if (to_s==undefined || to_s==null || to_s=="") continue;
               
                    //primary RELON specified in the data.  (it may be FLIPPED to first make)
                    //check for dupe information.
                    var x_relon = MEMG.getRelonFromWithTo(newGhostNOBJ.outs, type, reln, to_s);
                    if (x_relon==null) {
                        await GHOSTDATA.makeGhostRelon(type, newGhostNOBJ, reln, to_type, to_s);
                    }
    
                    if (obj.extras!=undefined) {
                        for (var e=0; e < obj.extras.length; e++) {
                            var erel =  obj.extras[e];
                            await GHOSTDATA.makeGhostRelon(erel.type, newGhostNOBJ, erel.reln, erel.to_type, erel.to_s);
                        }
                    }
                }
            }    
        }

        PAGES.launchNeuron(newGhostNOBJ.nid);
    }
}


class maker_company_gui extends maker_gui {
    constructor($pgui, $ANNKH) {
        super($pgui);
        this.nObjs = MEMG.getMyStuffByClass(USER._userNObj.nid,  $ANNKH._bSHOWOW, false, $ANNKH._bSHOWRM, $ANNKH._bSHOWGH, [MEM.company.temp_nid]);
        this.nObjs.sort(ANNE.UTILS.sortByTextNoCase);
        this.main_class = new service_company_by_wiki($pgui, this);
    }
    initASYNC=async($miscObj)=> {
        await this.main_class.initFromObj($miscObj);
    }

    //test this, if it works, do the same for all others.
    checkChg = function($ANNKH) {
        console.log("checkChg");
        //todo.
    }
}