
            //var lat = MEMG.getLat(this.nObj);
            //var long = MEMG.getLong(this.nObj);

class anne_geo {
    constructor($nObj) {
        this.nObj = $nObj;
        this.googleMap = null;
        this.lat =MEMG.getHasValue(MEM.gps_lat.temp_nid);
        this.long =MEMG.getHasValue(MEM.gps_long.temp_nid);
    }
}

class anne_role_mapper {
    constructor($cNOBJ) {
        this.conveyorNOBJ = $cNOBJ;
    }


    /**
     * 
     * @param {nlp_clump} $clump 
     * @param {string} $reln_part_nid 
     * @param {string} $debug 
     * @returns 
     */
    getMapperRoleNid = function($clump, $reln_part_nid, $debug="") {
        for (var r=0; r < this.conveyorNOBJ.outs.length; r++) {
            if (this.conveyorNOBJ.outs[r].to_s==$reln_part_nid) {
                var mapper_role_temp_nid=this.conveyorNOBJ.outs[r].r;
                var role_tnid =  MEM.role_map[mapper_role_temp_nid];
                if (role_tnid==undefined) return null;
                var auditNOBJ = MEMG.getNeuronByTempNid(role_tnid);
                console.log("(getMapperRoleNid) %c"+$debug+" %c"+auditNOBJ.text, ANNE.TALK.bgyellow, ANNE.TALK.bggreen);
                var roles = $clump.nlpRolesObj[role_tnid];
                if (roles!=undefined) {
                    var rolesValueNOBJ = roles[0].nObj;
                    if (rolesValueNOBJ==null) continue;
                    console.log("(getMapperRoleNid) roel value %c"+rolesValueNOBJ.text, ANNE.TALK.bggreen);
                    return rolesValueNOBJ;
                }
            }
        }
        return null;
    }


    /**
     * 
     * @param {nlp_clump} $clump 
     * @returns 
     */
    extrap=async($clump)=>{
        var defines = MEMG.getDefines(this.conveyorNOBJ);
        //(for die we would have deathday, and death place here)
        if (defines.length==0) return;

        //for cNOBJ die:  deathday, deathplace
        for (var d=0; d < defines.length; d++) {
            
            var dNOBJ = defines[d];
            console.log("conveyor %c"+this.conveyorNOBJ.text+" %c"+dNOBJ.text, ANNE.TALK.bgyellow, ANNE.TALK.bggreen);
            //deathday, role_when
            
            var dROLE = MEMG.getDefinedBy(dNOBJ);
            if (dROLE==null) continue;

            console.log("conveyor %c"+this.conveyorNOBJ.text+" %c"+dROLE.text, ANNE.TALK.bgyellow, ANNE.TALK.bggreen);
            
            //extract the right role  (ie, )
            if ($clump.nlpRolesObj[dROLE.temp_nid]!=undefined) {
                //var role_value = $clump.nlpRolesObj[dROLE.temp_nid].nObj;    //ie, the when..
                var fromNOBJ = this.getMapperRoleNid($clump, MEM.relon_from.nid, "mapping "+dNOBJ.text);
                if (fromNOBJ==null) continue;
    
                //not sure if we map the reln (ever??)
                //it should be the mapped object (dNOBJ)
                //ie, birthday, deathday, death place.. etc.
                //that is the reln of the TYPE_HAS.
                var relnNOBJ = this.getMapperRoleNid($clump, MEM.relon_reln.nid);
                if (relnNOBJ==null) relnNOBJ = dNOBJ;
                if (relnNOBJ==null) continue;
                
                var toNOBJ = this.getMapperRoleNid($clump, MEM.relon_to.nid);
                if (toNOBJ==null) continue;
                
                var rel = await ANNE.GHOSTDATA.new_ghost_has(fromNOBJ, relnNOBJ.nid, TO_TYPE_ANNE, toNOBJ.nid);    
                $clump.extraps.push(rel);
            }
        }
    }
}


class anne_date_range {
    constructor() {
        this.nid1 = null;
        this.nid2 = null;
        this.ad1 = null;
        this.ad2 = null;
        this.nObj1 = null;
        this.nObj2 = null;

        this.rangeNOBJ = null;      //for proper range neurons that cover ranges
        this.simpleDisplay = "";

        this.error_msg = "";

        //for parsing year month date ranges (no day)
        this.d1_str = "";
        this.d2_str = "";
    }


    //wikipedia ranges.
    //March–October 2006
    //2006–2007
    //2023–present
    parseFromString=async($str, $bMAKE=false)=>{
        var obj = ANNE.UTILS.stripParens($str);
        var str = obj.str;

        //just a start date.
        if (str.indexOf("-present")!=-1) {
            str = str.replace("-present", "");
            if (parseInt(str)>0) {
                this.ad1 = new anne_date(str, false);
                if (this.ad1!=null) {
                    await this.ad1.testDate($bMAKE);
                    this.nObj1 = this.ad1.nObj;
                    if (this.nObj1!=null) this.nid1 = this.nObj1.nid;
                }
            }
            return;
        }

        //just one part.
        var parts = str.split("–");
        if (parts.length==1) parts = str.split("-");
        if (parts==1) {
            if (parseInt(str)>0) {
                this.ad1 = new anne_date(str, false);
                if (this.ad1!=null) {
                    await this.ad1.testDate($bMAKE);
                    this.nObj1 = this.ad1.nObj;
                    if (this.nObj1!=null) {
                        this.nid1 = this.nObj1.nid;
                        this.d1_str = this.nObj1.text;
                    }
                }
            }
            return;
        }

        var part1=parts[0].trim();
        var part2=parts[0].trim();

        //parse the parts.  This is a standard range string like: 2006–2007
        if (parseInt(part1)>0 && parseInt(part2>0)) {
            this.ad1 = new anne_date(part1, false);
            if (this.ad1!=null) {
                await this.ad1.testDate($bMAKE);
                this.nObj1 = this.ad1.nObj;
                if (this.nObj1!=null) {
                    this.nid1 = this.nObj1.nid;
                    this.d1_str = this.nObj1.text;
                }
            }
            this.ad2 = new anne_date(part2, false);
            if (this.ad2!=null) {
                await this.ad2.testDate($bMAKE);
                this.nObj2 = this.ad2.nObj;
                if (this.nObj2!=null) {
                    this.nid2 = this.nObj2.nid;
                    this.d2_str = this.nObj2.text;
                }
            }
        }
        
        //same year month range
        //March–October 2006
        //["March", "October 2006"]
        else {
            var month_start = null;
            var month_end = null;
            var year_both = null;

            if (isNaN(partsInt(part1))==true) {
                var month_start = ANNE.MEM._monthMap[part1.toLowerCase()];
                if (month_start==null) {
                    this.error_msg = "Can't decipher "+$str+" with present range parsing code.";
                    return;
                }
            }

            if (part2.indexOf(" ")!=-1) {
                //["October 2006"]
                var part2_parts = part2.split(" ");
                if (part2_parts.length!=2) {
                    this.error_msg = "Can't decipher 2nd part of month range in "+$str+" with present range parsing code.";
                    return;
                }
                var part2_part1 = part2_parts[0].trim();
                var month_end = ANNE.MEM._monthMap[part2_part1.toLowerCase()];
                if (month_end==null) {
                    this.error_msg = "Can't decipher 2nd month of month range in "+$str+" with present range parsing code.";
                    return;
                }
                var part2_part1 = part2_parts[1].trim();
                var year_both = 0;
                if (isNaN(partsInt(part1))==true) {
                    this.error_msg = "Can't decipher year month range in "+$str+" with present range parsing code.";
                }
                else {
                    year_both = parseInt(part_part1);
                }

                //these are now date parts.
                //our year month format is:  JAN-1953
                this.d2_str = month_start.text.toUpperCase().substring(0,3)+"-"+year_both;
                this.ad1 = new anne_date(this.d2_str, false, true, month_start, null);
                await this.ad1.testDate($bMAKE);
                if (this.ad1.nObj!=null) {
                    this.nObj1 = this.ad2.nObj;
                    this.nid1 = this.ad1.nObj.nid;
                }

                this.d2_str = month_end.text.toUpperCase().substring(0,3)+"-"+year_both;
                this.ad2 = new anne_date(this.d2_str, false, true, month_end, null);
                await this.ad2.testDate($bMAKE);
                if (this.ad2.nObj!=null) {
                    this.nObj2 = this.ad2.nObj;
                    this.nid2 = this.ad2.nObj.nid;
                }
            }
        }

        return;
    }


    /**
     * Use this with any two date nids..
     * for custom/ad-hoc ranges.
     * @param {*} $d1_nid 
     * @param {*} $d2_nid 
     */
    loadFromDates=async($d1_nid=null, $d2_nid=null)=> {
        this.nid1 = $d1_nid;
        this.nid2 = $d2_nid;

        if (this.nid1==null && this.nid2==null) return;

        if (this.nid1!=null) this.nObj1 = MEMG.getNeuronByNid(this.nid1);
        else this.nObj1 = null;
        
        if (this.nid2!=null) this.nObj2 = MEMG.getNeuronByNid(this.nid2);
        else this.nObj2 = null;

        var queryNids = [];
        if (this.nid1 && this.nObj1 && this.nObj1.outs.length < 5 && this.nObj1.ghost==false) queryNids.push(this.nid1);
        if (this.nid2 && this.nObj2 && this.nObj2.outs.length < 5 && this.nObj2.ghost==false) queryNids.push(this.nid2);
        
        //need to get the basics for these dates.
        if (queryNids.length) {
            await ANNE.API.queryForOutsFroms_not(queryNids, false, [4], true, false);
        }

        if (this.nObj1!=null) {
            this.ad1 = new anne_date(this.nObj1.text, false);
            this.ad1.loadFromNeuron(this.nObj1, false);
        }
        if (this.nObj2!=null) {
            this.ad2 = new anne_date(this.nObj2.text, false);
            this.ad2.loadFromNeuron(this.nObj2, false);    
        }
        
        if (this.nObj2!=null) {
            if (this.ad1!=null) {
                this.simpleDisplay = "("+this.ad1.year+" - "+this.ad2.year+")";
            }
            else {
                this.simpleDisplay = "(? - "+this.ad2.year+")";
            }
        }   
        else if (this.nObj1!=null) {
            this.simpleDisplay = "("+this.ad1.year+" - )";
        }
        else this.simpleDisplay("(? - ?)");
    }

    genBornDeadDisplay=function() {
        if (this.nObj2!=null) {
            if (this.ad1!=null) {
                this.simpleDisplay = "(b."+this.ad1.year+" - d."+this.ad2.year+")";
            }
            else {
                this.simpleDisplay = "(b.? - d."+this.ad2.year+")";
            }
        }   
        else if (this.nObj1!=null) {
            this.simpleDisplay = "(b."+this.ad1.year+" - )";
        }
        else this.simpleDisplay("(b.? - d.?)");
    }
    

    /**
     * write this when needed.. we have range neurons that hold ranges..
     * @param {*} $rangeNeuron 
     */
    loadFromRangeNeuron=async($rangeNeuron)=>{
        this.rangeNOBJ = $rangeNeuron;
    }


    getYears=function() {
        if (this.ad1!=null && this.ad2!=null) {
            return this.ad2.year - this.ad1.year;
        }
    }

    getdays=function() {
        if (this.ad1!=null && this.ad2!=null) {
            return this.ad2.aed - this.ad1.aed;
        }
    }
}



class anne_date {
    constructor($dateString, $bFROMWIKI=true, $bMONTH_YEAR=false, $MY_M=null, $MY_Y=null) {
        this.dateString = $dateString;
        this.day = -1;
        this.month = -1;
        this.year = -1;
        this.era = "";

        this.new = true;
        this.bNEW = true;
        this.nObj = null;
        this.bTESTED = false;

        this.makeClassNOBJ = MEM.date_gregorian;

        this.dayNOBJ = null;
        this.monthNOBJ = null;
        this.yearNOBJ = null;
        this.eraNOBJ = null;
        this.dotyNOBJ = null;
        this.dotwNOBJ = null;
        this.anneepochday = null;
        this.daymonthNOBJ = null;
        this.monthyearNOBJ = null;
        this.aed = null;

        this.bLIKELY_MONTHYEAR = $bMONTH_YEAR;
        
        if ($bMONTH_YEAR==true) {
            this.parseMonthYearStr($dateString, $MY_M, $MY_Y);
        }
        else if($bFROMWIKI==true) {
            this.parseWikiDateStr($dateString);
        }
        else this.parseANNEDateStr($dateString);
    }


    /**
     * 
     * @param {*} $dateString 
     * @returns 
     */
    desperadoDatePartParse = function($dateString) {
        this.dateStr = $dateString;
        this.makeClassNOBJ = MEM.monthyear;

        var parts = $dateString.split(" ");
        if (parts.length==1) parts = $dateString.split("-");
        if (parts.length!=2) return;

        this.monthNOBJ = ANNE.MEM._monthMap[parts[0].toLowerCase().trim()];
        if (this.monthNOBJ==null) {  
            this.monthNOBJ = ANNE.MEM._monthMap[parts[1].toLowerCase().trim()];
            if (this.monthNOBJ==null) {
                this.monthNOBJ=null;
                this.month=-1;
                return;
            }   
            else {
                this.month=this.monthNOBJ.value;
                var yr_part = parts[0].trim();
                if (isNaN(partsInt(yr_part))==true) {
                    this.yearNOBJ=null;
                    this.year = -1;
                    return;
                }
                else {
                    this.year = partsInt(yr_part);
                    this.dateStr = this.monthNOBJ.text.toUpperCase().substring(0,3)+"-"+this.year;
                }
            }
        }

        else {
            this.month=this.monthNOBJ.value;
            var yr_part = parseInt(parts[1].trim());
            if (isNaN(yr_part)==true) {
                this.yearNOBJ=null;
                this.year = -1;
                return;
            }
            else {
                this.year = parseInt(yr_part);
                this.dateStr = this.monthNOBJ.text.toUpperCase().substring(0,3)+"-"+this.year;
            }
        }
    }


    /**
     * 
     * @param {*} $dateString 
     * @param {*} $MY_M 
     * @param {*} $MY_Y 
     * @returns 
     */
    parseMonthYearStr = function($dateString, $MY_M=null, $MY_Y=null) {
        if ($MY_M!=null) {
            this.monthNOBJ = $MY_M;
            this.month = this.monthNOBJ.value;
        }

        //must get month here or no-can-go-forward.
        else {
            return this.desperadoDatePartParse($dateString);
        }

        if ($MY_Y!=null) {
            this.yearNOBJ = $MY_Y;
            this.year = $MY_Y.value;
        }
        else {
            this.yearNOBJ=null;
            this.year = -1;
        }

        if ($dateString!=null) {
            this.dateStr = $dateString;
        }
        else if (this.monthNOBJ!=null && this.yearNOBJ!=null) {
            this.dateStr = this.monthNOBJ.text.toUpperCase().substring(0,3)+"-"+this.yearNOBJ.text;
        }
    }


    sameMonthYear = function($ad) {
        if ($ad==null) return false;
        if (this.monthyearNOBJ==null && $ad.monthyearNOBJ==null) return false;
        if (this.monthyearNOBJ.nid == $ad.monthyearNOBJ.nid) return true;
        return false;
    }
    sameDayMonth = function($ad) {
        if ($ad==null) return false;
        if (this.daymonthNOBJ==null && $ad.daymonthNOBJ==null) return false;
        if (this.daymonthNOBJ.nid == $ad.daymonthNOBJ.nid) return true;
        return false;
    }
    sameYear = function($ad) {
        if ($ad==null) return false;
        if (this.yearNOBJ==null && $ad.yearNOBJ==null) return false;
        if (this.yearNOBJ==null) {
            if (this.nObj.nid==$ad.yearNOBJ.nid) return true;
            else return false;
        }
        else if ($ad.yearNOBJ==null) {
            if (this.yearNOBJ.nid == $ad.nObj.nid) return true;
            else return false;
        }
        else if (this.yearNOBJ.nid == $ad.yearNOBJ.nid) {
            return true;
        }
        return false;
    }

    
    /**
     * 
     * @param {*} $dateNOBJ 
     * @param {*} $bPARSESTRING 
     */
    loadFromNeuron=function($dateNOBJ, $bPARSESTRING=true) {
        this.nObj = $dateNOBJ;

        if ($bPARSESTRING==true) {
            if (this.nObj.ghost==true) {
                this.parseANNEDateStr($dateNOBJ.text);
            }
            else {
                //load the relons
                //TO DO..
                this.parseANNEDateStr($dateNOBJ.text);
            }
        }

        else {
            this.dayNOBJ = ANNE.MEMG.getHasNObj(this.nObj.outs, ANNE.MEM.day.temp_nid);
            this.monthNOBJ = ANNE.MEMG.getHasNObj(this.nObj.outs, ANNE.MEM.month.temp_nid);
            if (this.monthNOBJ!=null) {
                //set this.month value from monthNOBJ
            }
            this.yearNOBJ =  ANNE.MEMG.getHasNObj(this.nObj.outs, ANNE.MEM.year.temp_nid);
            if (this.yearNOBJ!=null) {
                this.year = parseInt(this.yearNOBJ.text); // or better, use value
            }
            this.eraNOBJ = ANNE.MEMG.getHasNObj(this.nObj.outs, ANNE.MEM.era.temp_nid);
            this.daymonthNOBJ = ANNE.MEMG.getHasNObj(this.nObj.outs, ANNE.MEM.daymonth.temp_nid);
            this.monthyearNOBJ = ANNE.MEMG.getHasNObj(this.nObj.outs, ANNE.MEM.monthyear.temp_nid);
            this.dotyNOBJ = ANNE.MEMG.getHasNObj(this.nObj.outs, ANNE.MEM.doty.temp_nid);
            this.dotwNOBJ = ANNE.MEMG.getHasNObj(this.nObj.outs, ANNE.MEM.dotw.temp_nid);
            this.aed = ANNE.MEMG.getHasInt(this.nObj.outs, ANNE.MEM.ANNE_EPOCH_DAY.temp_nid);
        }
        
    }


    /**
     * preferred ANNE date string format.
     */
    getANNEDateStr = function($sep="-") {
        var annedateStr = "";
        if (this.year!=-1) annedateStr = UTILS.formatDigits(this.year, 4);
        if (this.month!=-1) annedateStr+=$sep+UTILS.formatDigits(this.month, 2);
        if (this.day!=-1) annedateStr+=$sep+UTILS.formatDigits(this.day, 2);
        if (this.era!="") annedateStr+=" "+this.era;
        //console.log("(getANNEDateStr) "+annedateStr);
        return annedateStr;
    }

    
    /**
     * test date with default worldview ANNE and the active user.
     */
    testDate = async($bMAKEGHOST=false)=> {
        if (this.dateStr==null || this.dateStr==undefined || this.dateStr=="") {
            this.nObj = null;
            return;
        }

        var bMUSTPULL=true;
        
        //just an integer... ( a single year ) 
        if (this.year>-1 && this.month==-1 && this.day==-1) {
            this.nObj = await MEMG.getOrMakeIfNewInteger(null, this.year+"");
            if (this.nObj.bNEW!=undefined) {
                this.new = this.nObj.bNEW;
                this.bNEW = this.nObj.bNEW;
            }
        }

        //a year month like "JAN-1953"
        else if (this.year>-1 && this.month>-1 && this.day==-1) {
            this.nObj = await ANNE.API.queryForMonthYear(this.dateStr, [MEM.ANNE_ACCTID, USER._userNObj.nid], bMUSTPULL);
            if (this.nObj==null) {
                await this.makeTempDate($bMAKEGHOST);
            }
        }

        //an actual date    
        else {
            //quick index search (should have don before this, but still give it a go)
            //a partial date is valid as well.
            this.nObj = await ANNE.MEMG.getDateNeuron(this.dateStr);
            if (this.nObj!=null) {
                this.bTESTED=true;
                return;
            }

            //this will return null or a single date NOBJ
            this.nObj = await ANNE.API.queryForDate(this.dateStr, [MEM.ANNE_ACCTID, USER._userNObj.nid], bMUSTPULL);
            
            console.log(this.nObj);
            if (this.nObj==null) {
                console.log("%c "+this.dateStr+" %cthis is a new date", TALK.bgblackgreen, TALK.bgblue);
                await this.makeTempDate($bMAKEGHOST);
            }
            else {
                console.log("%c "+this.dateStr+" %cthis is a known date", TALK.bgblackgreen, TALK.bggreen);
                this.new=false;
                this.bNEW=false;
            } 
         }
        
        this.bTESTED=true;
        
        return;
    }

    isAlpha=function($v) {
        const regExp = new RegExp(/^[a-z0-9]+$/i)
        return regExp.test($v);
    }


    parseANNEDateStr = function($str) {
        var str = $str.replaceAll(","," ");
        str = str.replaceAll("-", " ");
        str = str.replaceAll("/", " ");
        str = str.replace(/\s+/g, " ");
        
        var dateParts = str.split(" ");

        //assume single item is year
        if (dateParts.length==1) {
            this.year=parseInt(dateParts[0]);
        }

        //two items is either YEAR ERA (10,000 BC) or MONTHYEAR (JULY 2000)
        else if (dateParts.length==2) {
            if (this._isEra(dateParts[1])==false) {
                this.year=parseInt(dateParts[1]);
                this.month=parseInt(dateParts[0]);
                return;
            }
            else {
                this.era = dateParts[1];
                this.year = dateParts[0];
                this.dateStr = this.getANNEDateStr();
                return;
            }
        }

        //YYYY MM DD
        else if (dateParts.length==3) {
            this.year=parseInt(dateParts[0]);
            this.month=parseInt(dateParts[1]);
            this.day=parseInt(dateParts[2]);
        }

        else if (dateParts.length==4) {
            if (this._isEra(dateParts[3])==false) {
                alert("unhandled 4 part date");
                console.log(dateParts);
                return;
            }

            this.year=parseInt(dateParts[0]);
            this.month=parseInt(dateParts[1]);
            this.day=parseInt(dateParts[2]);
            this.era=parseInt(dateParts[3]);
        }
        this.dateStr = this.getANNEDateStr();
    }



    /**
     * Wiki external data uses full form month names.  We have to parse those.
     */
    parseWikiDateStr = function($str="") {
        if ($str==undefined || $str==null || $str=="") return "";
        $str = $str+"";
        
        var str = $str.replaceAll(",", " ");
        str = str.replaceAll("-", " ");
        str = str.replaceAll("/", " ");
        str = str.replace(/\s+/g, " ");
        
        var dateParts = str.split(" ");
        var again = dateParts.join("");
        if (UTILS.isNum(again)==true) return this.parseANNEDateStr($str); //all numbers


        //1935-08-20 dupe?
        
        if (dateParts.length==1) {
            this.year=parseInt(dateParts[0]);
        }

        //this could be a YEAR/MONTH  or  YEAR AD/BC
        else if (dateParts.length==2) {

            //first check for ear (like 10000 BC)
            if (this._isEra(dateParts[1])==true) {
                this.era = dateParts[1];
                this.year=parseInt(dateParts[0]);
                this.dateStr = this.getANNEDateStr();
                return;
            }


            //next check our 2 parts for a space (could be June 2000)
            this.month = ANNE.MEM._monthMap[dateParts[0]+"".toLowerCase()];
            if (this.month !=undefined) {
                if (parseInt(dateParts[1])>1600) this.year = parseInt(dateParts[1]);
            }
            else {
                var safu = dateParts[1]+"";
                this.month = ANNE.MEM._monthMap[safu.toLowerCase()];
            }

            if(this.month==undefined) {
                var part0 = parseInt(dateParts[0]);
                var part1 = parseInt(dateParts[1]);
                if (part0>31 && part1 < 13) {
                    this.year = part0;
                    this.month = part1;
                }
                else if (part1>31 && part0 < 13) {
                    this.year = part1;
                    this.month = part0;
                }
                else {
                    this.year = -1;
                    this.month = -1;
                    return;
                }
                
            }
        }

        else if (dateParts.length==3) {

            //2 parts with ERA
            if (this._isEra(dateParts[2])==true) {
                console.log(dateParts);
                return;
            }

            //3 parts, non numeric
            else {
                var parts = [
                        {found:false, part:dateParts[0]+""},
                        {found:false, part:dateParts[1]+""},
                        {found:false, part:dateParts[2]+""}]


                //named text month.
                for (var p=0; p < parts.length; p++) {
                    var part = parts[p].part.toLowerCase();
                    if (ANNE.UTILS.isNum(part)==true) continue;
                    var month_test = ANNE.MEM._monthMap[part];
                    if (month_test!=undefined) {
                        this.month = month_test.value;
                        parts.splice(p,1);
                        break;
                    }
                }

                //look for a numbered month.
                if (this.month == 0) {
                    for (var p=0; p < parts.length; p++) {
                        var month_test = ANNE.MEM._monthMap[parts[p].part.toLowerCase()];
                        if (month_test!=undefined) {
                            this.month = month_test.value;
                            parts.splice(p,1);
                            break;
                        }
                    }
                }


                //pick the bigger one for year.  Not perfect but fine for us.
                //who puts July 23, 2 for a year?
                if (this.month>0){
                    var part1 = parseInt(parts[0].part);
                    var part2 = parseInt(parts[1].part);
                    if (part1>part2 && part2<32) {
                        this.year = part1;
                        this.day = part2;
                    }
                    else if (part1<32){
                        this.year = part2;
                        this.day = part1;
                    }
                }
  
            }
        }

        if (this.year>-1 && this.month>0) {
            if (this.day==-1) {
                this.makeClassNOBJ = MEM.monthyear;
                this.dateStr = this.getShort(this.month)+"-"+this.getMin2(this.day);
            }
            else {
                this.makeClassNOBj = MEM.date_gregorian;
                this.dateStr = this.getANNEDateStr()
            }
        }
            
        else this.dateStr = this.getANNEDateStr();
    }

    getMin2=function($n) {
        if ($n+"".length==1) return "0"+$n;
        return $n;
    }

    getShort=function($m){
        if ($m==1) return "JAN";
        else if ($m==2) return "FEB";
        else if ($m==3) return "MAR";
        else if ($m==4) return "APR";
        else if ($m==5) return "MAY";
        else if ($m==6) return "JUN";
        else if ($m==7) return "JUL";
        else if ($m==8) return "AUG";
        else if ($m==9) return "SEP";
        else if ($m==10) return "OCT";
        else if ($m==11) return "NOV";
        else if ($m==12) return "DEC";
        return "";
    }

    /**
     * Make a temp date.  
     * No extra relons needed for temp dates (just the text and the be class) as they 
     * will be officially created by the ANNODE using the GLOBAL feature.  Dates are safe 
     * to make straight away by the ANNODE (with no approval/review) since bad data can be
     * tested by script (no human intervention).  Temp dates are for ghosts to use in 
     * building circuits and testing them before making them for real.
     */
    makeTempDate=async($bGHOST=false)=>{
        if ($bGHOST==true) {

            if (this.year>0 && (this.era =="" || this.era=="AD") && this.month==-1 && this.day==-1) {
                this.nObj = await MEMG.getOrMakeIfNewInteger(null, this.year+"");
            }

            else {
                this.nObj = await GHOSTDATA.makeGhostNeuron(this.makeClassNOBJ, this.dateStr, NTYPE_INST);
            }
        }

        this.new=true;
        this.bNEW=true;

        //if we don't store a temp name relon (which we don't need when submitting to ANNE)
        //our ghost won't have a name on refresh of ghost db (new session)
        //MEM.GHOSTDATA.makeNameRelon(this.nObj, this.dateStr);
    }

    
    /**
     */
     _isEra = function($part) {
        var part = $part.toLowerCase();
        if (part=="bc" || part=="b.c." || part=="bce" ||  part=="b.c.e." 
            || part=="ad" || part=="a.d.") return true;
        return "";
    }
}


class anne_person {
    constructor($name) {
        this.name = $name;
        this.first = "";
        this.middle = "";
        this.middle2 = "";
        this.last = "";
        this.suffix = "";
        this.fullName = "";

        this.nObj = null;

        this.setNameParts();
    }

    /**
     * Legal name suffixes (no titles)
     */
    suffixChk = function($test) {
        if (UTILS.isUSSuffix($test)==true) return true;
        return false;
    }


    /**
     */
    setNameParts = function() {
        var aParts = this.name.split(" ");

        this.first = "";
        this.middle = "";
        this.middle2 = "";
        this.last = "";
        this.suffix = "";

        this.first = aParts[0];
        if (aParts.length==1) {
            this.last = aParts[0];
            this.first="";
        }
        else if (aParts.length==2) {
            var isSuffix = this.suffixChk(aParts[1]);
            if (isSuffix==true) this.suffix = aParts[1];
            else this.last = aParts[1];
        }
        else if (aParts.length==3) {
            var isSuffix = this.suffixChk(aParts[2]);
            if (isSuffix==true) {
                this.suffix = aParts[2];
                this.last = aParts[1];
            }
            else {
                this.last = aParts[2];
                this.middle = aParts[1];
            }
        }
        else if (aParts.length==4) {
            var isSuffix = this.suffixChk(aParts[3]);
            if (isSuffix==true) {
                this.suffix = aParts[3];
                this.last = aParts[2];
                this.middle = aParts[1];
            }
            else {
                this.last = aParts[3];
                this.middle2 = aParts[2];
                this.middle = aParts[1];
            }
        }
        else if (aParts.length==5) {
            var isSuffix = this.suffixChk(aParts[4]);
            if (isSuffix==true) {
                this.suffix = aParts[4];
                this.last = aParts[3];
                this.middle2 = aParts[2];
                this.middle = aParts[1];
            }
            else {
                this.last = aParts[4];
                this.middle2 = aParts[3];
                this.middle = aParts[1]+" "+aParts[2];
            }
        }

        //we will store the full name as the neuron's text.
        if (this.first) this.fullName=this.first;
        if (this.middle) this.fullName+=" "+this.middle;
        if (this.middle2) this.fullName+=" "+this.middle2;
        if (this.last) this.fullName+=" "+this.last;
        if (this.suffix) this.fullName+=" "+this.suffix;

        this.fullName = this.fullName.trim();
    }
}


class anneid {
    constructor($nObj=null, $rez=null) {
        this.nObj = $nObj;
        if ($nObj==null) {
            console.warn(" nOBJ is required here");
            return;
        }
        this.nid = $nObj.nid;
        this.andy_actions = 0; 
        this.relons_sponsored = 0;  
        this.hanais = 0; 
        this.sponsored_neurons = 0; 
        this.did_annex = 0;  
        this.got_annexed = 0;  
        this.blocks_mined = 0 ;  
        this.share_mines = 0;
        this.boostybacks_won = 0; 
        $nObj._anneid = this;
        this.bRANKS=false;

        this.total_users = 0;
        this.rank_aa = 0;
        this.rank_rs = 0;
        this.rank_ha = 0;
        this.rank_sn = 0;
        this.rank_da = 0;
        this.rank_ga = 0;
        this.rank_bm = 0;
        this.rank_sm = 0;
        this.rank_bw = 0;

        if ($rez!=null) this.processFromObj($rez);
    }


    /**
     * 
     * @param {*} $anneidObj 
     */
    processFromObj = function($anneidObj) {
        if ($anneidObj==undefined || $anneidObj==null) return;
        
        this.andy_actions = parseInt($anneidObj.andy_actions);
        this.relons_sponsored = parseInt($anneidObj.relons_sponsored);
        this.hanais = parseInt($anneidObj.hanais);
        this.sponsored_neurons = parseInt($anneidObj.sponsored_neurons);
        this.did_annex = parseInt($anneidObj.did_annex);
        this.got_annexed = parseInt($anneidObj.got_annexed);
        this.blocks_mined = parseInt($anneidObj.blocks_mined);
        this.share_mines = parseInt($anneidObj.share_mines);
        this.boostybacks_won = parseInt($anneidObj.boostybacks_won/100);

        if ($anneidObj.rank_total_users!=undefined) {
            this.processRanksFromObj($anneidObj);
        }
    }


    /**
     */
    getRanks=async()=>{
        return ANNE.API.getANNEID_ranks(this.nObj);
    }
    

    /**
     * 
     * @param {*} $obj 
     */
    processRanksFromObj=function($obj) {
        this.bRANKS=true;
        this.total_users = parseInt($obj.rank_total_users);
        this.rank_aa = parseInt($obj.rank_andy_actions);
        this.rank_rs = parseInt($obj.rank_relons_sponsored);
        this.rank_ha = parseInt($obj.rank_hanais);
        this.rank_sn = parseInt($obj.rank_sponsored_neurons);
        this.rank_da = parseInt($obj.rank_did_annex);
        this.rank_ga = parseInt($obj.rank_got_annexed);
        this.rank_bm = parseInt($obj.rank_blocks_mined);
        this.rank_sm = parseInt($obj.rank_share_mines);
        this.rank_bw = parseInt($obj.rank_boostybacks_won);
    }


    /**
     * 
     */
    emulate=function($factor = 1000, $total_users=33) {    
        this.total_users = $total_users;
        this.andy_action = 0;
        if (Math.random()>.3) this.andy_action = Math.round($factor * Math.random());
        var f2 = Math.pow(2, Math.random());
        this.relons_sponsored = Math.round(Math.random()*$factor*100*f2);
        this.hanais = Math.round(Math.random()*$factor);
        this.sponsored_neurons = Math.round(Math.random()*$factor)*10;
        this.did_annex = Math.round(Math.random()*$factor/2);
        this.got_annexed = Math.round(Math.random()*$factor/2);

        if (Math.random()>.3) {
            this.blocks_mined = Math.round(Math.random()*$factor)*30;
        }
        if (Math.random()>.3) {
            this.share_mines = Math.round(Math.random()*$factor)*333;
        }

        if (Math.random()>.7) {
            this.boostybacks_won = Math.round(Math.random()*2000000);
        }
 
        this.rank_bm = UTILS.range(1, this.total_users);
        this.rank_sm = UTILS.range(1, this.total_users);
        this.rank_aa = UTILS.range(1, this.total_users);
        this.rank_ha = UTILS.range(1, this.total_users);
        this.rank_sn = UTILS.range(1, this.total_users);
        this.rank_rs = UTILS.range(1, this.total_users);
        this.rank_da = UTILS.range(1, this.total_users);
        this.rank_ga = UTILS.range(1, this.total_users);
        this.rank_bw = UTILS.range(1, this.total_users);
    }


    colorizeRank = function($rank) {
        var colorized = "color-yellow";
        var green_tier = .8;
        var yellow_tier = .5;
        var rper = ((this.total_users+1)-$rank)/this.total_users;        
        var hash = "<span style='font-size:.9rem'>#</span>";
        if (rper >=green_tier) colorized="<span class='color-green'>"+hash+$rank+"<span class='rank-of'>/"+this.total_users+"</span></span>";
        else if (rper >=yellow_tier) colorized="<span class='color-yellow'>"+hash+$rank+"<span class='rank-of'>/"+this.total_users+"</span></span>";
        else colorized="<span class='color-orange'>"+hash+$rank+"<span class='rank-of'>/"+this.total_users+"</span></span>";
        return colorized;
    }
}


const APLEX_SUMMARY_SPECIFIC_NEURON = 0;    //awarenesses for a specific neuron (class or inst at any level)
const APLEX_SUMMARY_NEURON_LINE = 1;        //awareness for a neuron line starting at a top neuron including children classes and insts.
const APLEX_SUMMARY_IDENTITY = 2;           //awarenesses OF a specific user 
const APLEX_SUMMARY_IDENTITY_GROUP = 3;     //awaarenesses of an identity group of some kind (any group of ANNE IDs)


/**
 * summary of aplex data at various levels in a tree structure..
 * (classes include summary of their direct value, subclasses, and instances)
 */
class aplex_sum {
    constructor($nObj, $summaryType=APLEX_SUMMARY_SPECIFIC_NEURON, $rez=null) {
        this.nid = $nObj.nid;
        this.pos = 0;
        this.neu = 0;
        this.neg = 0;
        this.fire = 0;
        this.bEMULATED=false;
        this.since_height=0;

        this.posPer = 0;
        this.negPer = 0;
        this.neuPer = 0;
        
        $nObj._aplex_sum = this;

        this.bucket_neg=[];
        this.bucket_neu=[];
        this.bucket_pos=[];

        this.id_type = 0;
        this.summary_type = $summaryType;

        this._aplex = null; //standard aplex obj (non-summary) with price_lvl etc
        if ($nObj._aplex!=undefined && $nObj._aplex!=null) {
            this._aplex = $nObj._aplex;
        }
        
        //test this with live data (not emulated)
        if ($rez!=null) {
            this.processAwarezSummaryIntoBucketsObj($rez);
        }
    }



    /**
     * 
     * @param {*} $sumObj 
     */
    processSumObj = function($sumObj) {
        this.pos = $sumObj.sum_POS;
        this.neg = $sumObj.sum_NEG;
        this.neu = $sumObj.sum_NEU;
        this.fire = $sumObj.sum_FIRE;
        var sum = this.pos+this.neg+this.neu;
        this.posPer = Math.floor(100*this.pos/sum)/100;
        this.negPer = Math.floor(100*this.neg/sum)/100;
        this.neuPer = Math.floor(100*this.neu/sum)/100;
    }


    /**
     * 
     * @param {*} $aplex 
     */
    emulateSummaryDataWithAplex = function($aplex) {
        if ($aplex==undefined || $aplex==null) return;

        this.pos = $aplex.pos;
        this.neg = $aplex.neg;
        this.neu = $aplex.neu;
        this.fire = this.pos+this.neg+this.neu;
        this.posPer = Math.floor(1000*this.pos/this.fire)/1000;
        this.negPer = Math.floor(1000*this.neg/this.fire)/1000;
        this.neuPer = Math.floor(1000*this.neu/this.fire)/1000;
        console.log("%cEMULATE DATA %c fire "+UTILS.commas(this.fire)+"%c"+UTILS.commas(this.pos)+"%c"+UTILS.commas(this.neg)+"%c"+UTILS.commas(this.neu), TALK.bgfire, TALK.bgblack, TALK.bgpos, TALK.bgneg, TALK.bgneu);
        this.bEMULATED=true;

        //how we will process them from the API when pulling a summary of buckets.
        var nidCntArr = this.emulateBucketVals();
        console.log(nidCntArr); //an array of objs with .nid and .count just like it came form the API.

        //wraap it in the same way the API returns it in its wrapper
        var emulatedRez = {"result":nidCntArr, "results":nidCntArr.length, "since_height":this.since_height, "for_nid":this.nid};

        //this is the same processor for emulated and real.
        this.processAwarezSummaryIntoBucketsObj(emulatedRez);
    }


    /**
     * 
     * @param {*} $factor 
     */
    emulateSummaryData = function($factor=1, $bFORCEEQUAL=false, $bEMULATEBUCKETS=true) {
        this.pos = Math.floor(Math.random() * 101)*$factor;
        if ( $bFORCEEQUAL==true) {
            this.neg = this.pos;
            this.neu = this.pos;
        }
        else {
            this.neg = Math.floor(Math.random() * 101)*$factor;
            this.neu = Math.floor(Math.random() * 101)*$factor;
        }
        
        this.fire = this.pos+this.neg+this.neu;
        this.posPer = Math.floor(1000*this.pos/this.fire)/1000;
        this.negPer = Math.floor(1000*this.neg/this.fire)/1000;
        this.neuPer = Math.floor(1000*this.neu/this.fire)/1000;
        console.log("%cEMULATE DATA %c fire "+UTILS.commas(this.fire)+"%c"+UTILS.commas(this.pos)+"%c"+UTILS.commas(this.neg)+"%c"+UTILS.commas(this.neu), TALK.bgfire, TALK.bgblack, TALK.bgpos, TALK.bgneg, TALK.bgneu);
        this.bEMULATED=true;

        if ($bEMULATEBUCKETS==false) return;
    
        //how we will process them from the API when pulling a summary of buckets.
        var nidCntArr = this.emulateBucketVals();
        console.log(nidCntArr); //an array of objs with .nid and .count just like it came form the API.

        //wraap it in the same way the API returns it in its wrapper
        var emulatedRez = {"result":nidCntArr, "results":nidCntArr.length, "since_height":this.since_height, "for_nid":this.nid};

        //this is the same processor for emulated and real.
        this.processAwarezSummaryIntoBucketsObj(emulatedRez);
    }




    /**
     * We're going to go the long road here
     * to emulate these as they may look coming back from the API when pulled for real.
     * 
     * When we do query for buckets we grab all the buckets in a "nid" and incriment a "count".
     * We can then organize these into a fz bucket object for easy traversal and use in the GUIS.
     */
    emulateBucketVals=function() {
        var nidCntArr = [];
        
        var seed = Math.random()*69350;
        while(this.pos>0) {
            if (Math.random() > .995) {
                if(nidCntArr[MEM.positive.nid]==undefined) nidCntArr[MEM.positive.nid]={"count":1};
                else nidCntArr[MEM.positive.nid]["count"]+=1;
            }
            else {
                var nid = AWARE.getRandPosBucketVal(seed);
                if (nid==undefined) {
                    alert("IMPOSSIBLE");
                }
                if(nidCntArr[nid]==undefined) nidCntArr[nid]={"count":1};
                else nidCntArr[nid]["count"]+=1;
            }
            this.pos=this.pos-1;
        }

        var seed = Math.random()*296.9;
        while(this.neg>0) {
            if (Math.random() > .995) {
                if(nidCntArr[MEM.negative.nid]==undefined) nidCntArr[MEM.negative.nid]={"count":1};
                else nidCntArr[MEM.negative.nid]["count"]+=1;
            }
            else {
                var nid = AWARE.getRandNegBucketVal(seed);
                if (nid==undefined) {
                    alert("IMPOSSIBLE");
                }
                if(nidCntArr[nid]==undefined) nidCntArr[nid]={"count":1};
                else nidCntArr[nid]["count"]+=1;
            }
            this.neg=this.neg-1;
        }

        var seed = Math.random()*66579;
        while(this.neu>0) {
            if (Math.random() > .995) {
                if(nidCntArr[MEM.neutral.nid]==undefined) nidCntArr[MEM.neutral.nid]={"count":1};
                else nidCntArr[MEM.neutral.nid]["count"]+=1;
            }
            else {
                var nid = AWARE.getRandNeuBucketVal(seed);
                if (nid==undefined) {
                    alert("IMPOSSIBLE");
                }
                if(nidCntArr[nid]==undefined) nidCntArr[nid]={"count":1};
                else nidCntArr[nid]["count"]+=1;
            }
            this.neu=this.neu-1;
        }

        if (this.neu!=0 || this.neg!=0 || this.pos!=0) {
            alert("BAD EMULATION");
        }
        var oldFireAudit = this.fire;
        console.log("old fire audit %c"+oldFireAudit, TALK.bgred);
        this.fire=0;

        var newFireAudit = 0;

        //use a normaal array.. not an associative.
        //that was helpful to easily find dupes.
        var keys = Object.keys(nidCntArr);
        var nidFinalArr = [];
        for (var k=0; k < keys.length; k++) {
            var nid = keys[k];
            if(nid==undefined || nid==undefined) {
                alert("IMPOSSIBLE.");
            }
            var obj = nidCntArr[nid];
            obj.nid=nid;
            newFireAudit+=parseInt(obj.count);
            nidFinalArr.push(obj);
        }
        console.log(nidFinalArr);
        console.log("new fire audit %c"+newFireAudit, TALK.bgred);

        return nidFinalArr;
    }


    /**
     * We want to recalc the gui but we already know what the updates are since we just 
     * made the AWAREZ relons ourself with this app!
     * 
     * Update the summary here.
     * We can also update the anneid summaries too.
     * @param {*} $rels 
     */
    
    updateFromLiveSend = function($rels) {

        const THIS = this;
        
        var addOrIncrPos = function($bnid) {
            for (var b=0; b < THIS.bucket_pos.length; b++) {
                if(THIS.bucket_pos[b].nid==$bnid){
                    THIS.bucket_pos[b].count+=1;
                    THIS.pos+=1;
                    THIS.fire+=1;
                    return;
                }
            }
            THIS.addPos({nid:$bnid, count:1});
        }
        var addOrIncrNeg = function($bnid) {
            for (var b=0; b < THIS.bucket_neg.length; b++) {
                if(THIS.bucket_neg[b].nid==$bnid){
                    THIS.bucket_neg[b].count+=1;
                    THIS.neg+=1;
                    THIS.fire+=1;
                    return;
                }
            }
            THIS.addNeg({nid:$bnid, count:1});
        }
        var addOrIncrNeu = function($bnid) {
            for (var b=0; b < THIS.bucket_neu.length; b++) {
                if(THIS.bucket_neu[b].nid==$bnid){
                    THIS.bucket_neu[b].count+=1;
                    THIS.neu+=1;
                    THIS.fire+=1;
                    return;
                }
            }
            THIS.addNeu({nid:$bnid, count:1});
        }

        for (var r=0; r < $rels.length; r++) {
            var rel = $rels[r];
            var nOBJ = MEMG.getOrMakeIfNew(rel.reln);
            if (nOBJ.owned_by!=ANNE_ACCTID && nOBJ.owned_by!=USER._userNObj.nid) {
                console.log("we're not interested in this.");
                continue;
            }

            var bucket = AWARE.getBucket(nOBJ.nid);
            if (bucket==null || bucket.nObj==undefined || bucket.nObj==null) {
                continue;
            }

            var bucket_nid = bucket.nObj.nid;

            var pol = bucket.pol;
            if (pol==undefined || pol==null) {
                if (nOBJ!=null) pol = nOBJ.pol;
            }

            if (pol=="pos") addOrIncrPos(bucket_nid);
            else if (pol=="neg") addOrIncrNeg(bucket_nid);
            else if (pol=="neu") addOrIncrNeu(bucket_nid);
            else console.log(" unmapped, won't make the summary!", bucket);
        }


        this.posPer = Math.floor(1000*this.pos/this.fire)/1000;
        this.negPer = Math.floor(1000*this.neg/this.fire)/1000;
        this.neuPer = Math.floor(1000*this.neu/this.fire)/1000;
    }



    /**
     * We need to iteratea through a list of AWARE reln nids with counts and put them in their pos/neg/neu buckets.
     * @param {*} $rez 
     */
    processAwarezSummaryIntoBucketsObj=function($rez) {

        var rez = $rez.result;
        if (rez==undefined || rez==null) rez=[];
        
        this.since_height = $rez.since_height;

        var tempPosArr = [];
        var tempNegArr = [];
        var tempNeuArr = [];
        
        var fireAuditAgain = 0;
        var fireauditInner = 0;

        var unmapped_fire = 0;
        
        for (var r=0; r < rez.length; r++) {
            var rezObj = rez[r];
            var nid = rezObj.nid;
            
            if (fireAuditAgain!=fireauditInner) {
                console.log("debug here");
            }

            //these nids are from AWAREZ relons... and the nid was the RELN of those RELONS.
            //these must be ANNE owned or self-owned, otherwise we're not summarizing them.
            var nOBJ = MEMG.getOrMakeIfNew(nid);
            if (nOBJ.owned_by!=ANNE_ACCTID && nOBJ.owned_by!=USER._userNObj.nid) {
                console.log("we're not interested in this.");
                continue;
            }

            var count = parseInt(rezObj.count);
            fireAuditAgain+=count;

            //for the final bucket click view we want our leafs (feelz/op/buckets/polarityneurons) with specific vals.
            var doLeaf = function($arr, $bnid, $nid, $count) {
                if ($count==undefined) {
                    console.log("why no count?");
                }
                if ($arr[$bnid].leafs==undefined) {
                    $arr[$bnid].leafs=[];
                    $arr[$bnid].leafs[$nid]={"count":$count};
                }
                else {
                    if ($arr[$bnid].leafs[$nid]==undefined) {
                        $arr[$bnid].leafs[$nid]={"count":$count};
                    }
                    else {
                        $arr[$bnid].leafs[nid].count+=$count;
                    }
                }
            }

            if (nid==MEM.positive.nid) {
                if (tempPosArr[MEM.positive.nid]==undefined) tempPosArr[MEM.positive.nid]={nid:MEM.positive.nid, count:count};
                else tempPosArr[MEM.positive.nid].count+=count;
                doLeaf(tempPosArr, MEM.positive.nid, MEM.positive.nid, count);
                fireauditInner+=count;
                continue;
            }
            else if (nid==MEM.negative.nid) {
                if (tempNegArr[MEM.negative.nid]==undefined) tempNegArr[MEM.negative.nid]={nid:MEM.negative.nid, count:count};
                else tempNegArr[MEM.negative.nid].count+=count;
                doLeaf(tempNegArr, MEM.negative.nid, MEM.negative.nid, count);
                fireauditInner+=count;
                continue;
            }
            else if (nid==MEM.neutral.nid) {
                if (tempNeuArr[MEM.neutral.nid]==undefined) tempNeuArr[MEM.neutral.nid]={nid:MEM.neutral.nid, count:count};
                else tempNeuArr[MEM.neutral.nid].count+=count;
                doLeaf(tempNeuArr, MEM.neutral.nid, MEM.neutral.nid, count);
                fireauditInner+=count;
                continue;
            }

            var bucket = AWARE.getBucket(nid);
            if (bucket==null || bucket.nObj==undefined || bucket.nObj==null) {
                alert("PROBLEM, get bucket yielded no bucket.");
                continue;
            }

            var bucket_nid = bucket.nObj.nid;
            

            var pol = bucket.pol;
            if (pol==undefined || pol==null) {
                if (nOBJ!=null) pol = nOBJ.pol;
            }

            if (pol=="pos") {
                if (tempPosArr[bucket_nid]==undefined) tempPosArr[bucket_nid]={nid:bucket_nid, count:count};
                else tempPosArr[bucket_nid].count+=count;
                fireauditInner+=count;
                doLeaf(tempPosArr, bucket_nid, nid, count);
            }
            else if (pol=="neg") {
                if (tempNegArr[bucket_nid]==undefined) tempNegArr[bucket_nid]={nid:bucket_nid, count:count};
                else tempNegArr[bucket_nid].count+=count;
                fireauditInner+=count;
                doLeaf(tempNegArr, bucket_nid, nid, count);
            }
            else if (pol=="neu") {
                if (tempNeuArr[bucket_nid]==undefined) tempNeuArr[bucket_nid]={nid:bucket_nid, count:count};
                else tempNeuArr[bucket_nid].count+=count;
                fireauditInner+=count;
                doLeaf(tempNeuArr, bucket_nid, nid, count);
            }
            else {
                unmapped_fire+=count;
                console.log(" unmapped, won't make the summary!", bucket);
            }
        }

        //console.log("unmapped_fire %c"+unmapped_fire, TALK.bgfire);
        //console.log("fireauditInner %c"+fireauditInner, TALK.bgfire);
        //console.log("fireAuditAgain %c"+fireAuditAgain, TALK.bgfire);

        //now we have pos/neg/neu buckets to use that map to our bars..
        //with proper counts
        var keys = Object.keys(tempPosArr);
        for (var k=0; k < keys.length; k++) {this.addPos(tempPosArr[ keys[k] ]);}

        var keys2 = Object.keys(tempNegArr);
        for (var k=0; k < keys2.length; k++) {this.addNeg(tempNegArr[ keys2[k] ]);}
        
        var keys3 = Object.keys(tempNeuArr);
        for (var k=0; k < keys3.length; k++) {this.addNeu(tempNeuArr[ keys3[k] ]);}

        //console.log("%cold percents %c"+UTILS.commas(this.posPer)+"%c"+UTILS.commas(this.negPer)+"%c"+UTILS.commas(this.neuPer), TALK.bgblack, TALK.bgpos, TALK.bgneg, TALK.bgneu);
        if (this.pos>0 && this.fire>0) this.posPer = Math.floor(1000*this.pos/this.fire)/1000;
        if (this.neg>0 && this.fire>0) this.negPer = Math.floor(1000*this.neg/this.fire)/1000;
        if (this.neu>0 && this.fire>0) this.neuPer = Math.floor(1000*this.neu/this.fire)/1000;

        //console.log("%cEMULATE DATA %c fire "+UTILS.commas(this.fire)+"%c"+UTILS.commas(this.pos)+"%c"+UTILS.commas(this.neg)+"%c"+UTILS.commas(this.neu), TALK.bgfire, TALK.bgblack, TALK.bgpos, TALK.bgneg, TALK.bgneu);
        //console.log("%cnew percents %c"+UTILS.commas(this.posPer)+"%c"+UTILS.commas(this.negPer)+"%c"+UTILS.commas(this.neuPer), TALK.bgblack, TALK.bgpos, TALK.bgneg, TALK.bgneu);
        
        //we should have these equal.
        //this.auditPos();
        //this.auditNeg();
        //this.auditNeu();
    }

    auditPos=function() {
        var bucket_audit=0;
        for (var b=0; b < this.bucket_pos.length; b++) {
            bucket_audit+=this.bucket_pos[b].count;
        }
        console.log("pos bucket audit:"+bucket_audit+" .pos:"+this.pos);
    }
    addPos=function($obj) {
        this.bucket_pos.push($obj);
        this.pos+=$obj.count;
        this.fire+=$obj.count;
    }
    auditNeg=function() {
        var bucket_audit=0;
        for (var b=0; b < this.bucket_neg.length; b++) {
            bucket_audit+=this.bucket_neg[b].count;
        }
        console.log("neg bucket audit:"+bucket_audit+" .neg:"+this.neg);
    }
    addNeg=function($obj) {
        this.bucket_neg.push($obj);
        this.neg+=$obj.count;
        this.fire+=$obj.count;
    }
    auditNeu=function() {
        var bucket_audit=0;
        for (var b=0; b < this.bucket_neu.length; b++) {
            bucket_audit+=this.bucket_neu[b].count;
        }
        console.log("neu bucket audit:"+bucket_audit+" .neu:"+this.neu);
    }
    addNeu=function($obj) {
        this.bucket_neu.push($obj);
        this.neu+=$obj.count;
        this.fire+=$obj.count;
    }
}

const APLEX_ID_NEURON = 0;  //the majority of all awarenesses will be on neurons.
const APLEX_ID_RELON = 1;   //we can take awarenesses on relons too, by txid

class aplex {
    /**
     */
    constructor($obj, $obj_id, $aplexJsonObj=null) {
        this.id=$obj_id;
        this.id_type=APLEX_ID_NEURON; //default nid
        this.annies_in = 0;
        this.fire = 0;
        this.prev_annex_price=0;
        this.boosties=0;
        this.price_lvl=0;
        this.neg = 0;
        this.neu = 0;
        this.pos = 0;
        this.total = 0;

        //a pending annex/boosties change is in the mempool and affects this neuron.
        this.has_pending = false;   
        this.pending_sponsored_by = "";
        
        //must be calc'd.
        this.calculated_cost = 0;
        this.annex_sponsored_relons = 0;
        this.non_awareness_outs = 0;

        this.boosties = 0;
        this.fibo_factor = 0;
        this.last_fullhash = "";

        this.bANNEX_CALCULATED=false;
        this.bANNEXABLE = false; //update tfhis 
        this.pending_relon = null;
        
        if ($aplexJsonObj!=null) {
            this.processObj($aplexJsonObj);
        }
        if ($obj!=null) {
            $obj._aplex = this;

            //set the aplex_sum ptr back to the _aplex object.
            //this is for if we already had the aplex sum obj before we had the aplex obj
            if ($obj._aplex_sum!=undefined && $obj._aplex_sum._aplex==null) {
                $obj._aplex_sum._aplex = this;
            }    
        }

        this.pulled_when = Date.now()/1000;
    }

    getAgeInSecs = function() {
        if (this.pulled_when==null) {
            return 0;
        }
        return (Date.now()/1000) - this.pulled_when;
    }
    
    /**
     * 
     * @param {*} $obj 
     */
    processObj = function($obj) {
        this.id_type=$obj.id_type;
        if ($obj.annies_in==null) this.annies_in=0;
        else this.annies_in=parseInt($obj.annies_in);
        
        if ($obj.fire==null) $obj.fire=0;
        else this.fire=parseInt($obj.fire);

        if(ANNE.UTILS.isset($obj.prev_annex_price)==true) this.prev_annex_price=parseInt($obj.prev_annex_price);
        else this.prev_annex_price=0;

        if(ANNE.UTILS.isset($obj.boosties)==true) this.boosties=parseInt($obj.boosties);
        else this.boosties = 0;

        //console.log("boosties:"+this.boosties);
        if($obj.price_lvl!=undefined) this.price_lvl=$obj.price_lvl;

        //if (this.price_lvl==0) this.price_lvl=1;
        if (ANNE.UTILS.isset($obj.neg)==true) this.neg=parseInt($obj.neg);
        else this.neg=0;

        if (ANNE.UTILS.isset($obj.neu)==true) this.neu=parseInt($obj.neu);
        else this.neu=0;

        if (ANNE.UTILS.isset($obj.pos)==true) this.pos=parseInt($obj.pos);
        else this.pos=0;

        this.total=this.neg + this.neu + this.pos;

        //this val muts be set in the cmdObj when annex :)
        if (ANNE.UTILS.isset($obj.prev_hash)==true) this.last_fullhash = $obj.prev_hash;
        else this.last_full_hash = "";

        if (this.pos>0 && this.total>0) this.posPer = Math.round(1000*this.pos/this.total)/1000;
        else this.posPer=0;
        
        if (this.neg>0 && this.total>0) this.negPer = Math.round(1000*this.neg/this.total)/1000;
        else this.negPer=0;

        if (this.neu>0 && this.total>0) this.neuPer = Math.round(1000*this.neu/this.total)/1000;
        else this.neuPer = 0;

        //some free RAM vars we can get..
        //these won't be retained in INDEXDB tho since they didn't come in relons.
        if (this.id_type==APLEX_ID_NEURON) {
            var nObj = MEMG.getNeuronByNid(this.id);

            //snagged this in the API as a solid for pulling sets and having basic infos for display.
            if ($obj.sponsored_by!=undefined && nObj.sponsored_by=="") {
                nObj.addSponsoredBy($obj.sponsored_by);
            }
            if($obj.owned_by!=undefined) {
                nObj.addOwnedBy($obj.owned_by);
            }
            if ($obj.ntype!=undefined) {
                nObj.ntype = $obj.ntype;
            }
            if ($obj.origin!=undefined) {
                nObj.origin = $obj.origin;
            }
            if($obj.parent!=undefined) {
                var parentNOBJ = MEMG.getOrMakeIfNew($obj.parent);
                if (nObj.bes.indexOf(parentNOBJ.temp_nid)==-1) {
                    nObj.setBeTempNid(parentNOBJ.temp_nid);
                }
            }
        }


        //sometimes we can get these for low-cost on a process/pull of aplex so we do it 
        //in advance so we have it.
        if ($obj.sponsored_relons!=undefined) {
            this.processAnnexVars($obj);
        }

        
        if ($obj.has_pending==true) {
            this.has_pending=true;
            console.log($obj.pending);
            if ($obj.pending.result!=null) {
                this.pending_relon = $obj.pending.result;
                var sysROBJ = MEMG.lookupByTXID(this.pending_relon.sys_ref_txid);
                if (sysROBJ!=null) {
                    ANNE.TALK.printRelon(sysROBJ);
                }
            }
            console.log(this);
        }
        
    }


    /**
     * emulate the numbers for testing
     */
    emulateAplex = function($factor=10000) {
        if (Math.random()>.9) this.boosties = Math.ceil(Math.random()*10 * Math.random()*10 * 10000);
        this.price_lvl = 1+parseInt((Math.floor(Math.random()* (Math.ceil(Math.random()*5)-1))));
        this.fibo_factor = UTILS.nthFib(this.price_lvl+3);
        this.annex_sponsored_relons = Math.ceil(Math.random()*Math.random()*1000);
        this.non_awareness_outs = Math.ceil(Math.random()*Math.random()*1000);
        var spr_val = this.annex_sponsored_relons * ANNEX.RELON_SPONSOR_FIRE;  //they get 1 coin extra 
        var nao_val = this.non_awareness_outs * ANNEX.RELON_VALUE;      //20 coins per out.
        var factor_total = this.fibo_factor*(spr_val+nao_val);
        this.calculated_cost = factor_total+this.boosties;

        this.neg = Math.ceil(Math.random()*$factor);
        this.neu = Math.ceil(Math.random()*$factor);
        this.pos = Math.ceil(Math.random()*$factor);
        this.total = this.neg+this.neu+this.pos;
        this.fire = this.total;

        //just something (for display)
        if (this.price_lvl>0) {
            this.prev_annex_price = (this.calculated_cost - this.boosties)*.8;
        }

        this.annies_in = this.total*200;


        //we need an annexer..  who is the pretend sponsor of this neuron?
        //sponsored_by
        var nObj = MEMG.getNeuronByNid(this.id);

        if (nObj.is(MEM.identity)==false) {
            if (Math.random()>.5) nObj.sponsored_by = MEM.mr_scatman.nid;
            else nObj.sponsored_by = MEM.johnny5.nid;
        }

        this.initPercents();
    }


    //helpful in gui calcs.
    initPercents = function() {
        this.posPer = Math.round(1000*this.pos/this.total)/1000;
        this.negPer = Math.round(1000*this.neg/this.total)/1000;
        this.neuPer = Math.round(1000*this.neu/this.total)/1000;
    }



    /**
     * Switched to node based pricing for better alignment.
     * ANNEX PRICING works with a one block lag.
     * Pricing of relons is based on what relons were present up through the last mined block.
     * @param {*} $nObj 
     * @returns 
     */
    calculate_annex_vars = async($nObj)=>{
        if (this.bANNEX_CALCULATED==true || $nObj.nid!=this.id) return 1;

        var rez = await ANNE.API.calculateAnnexPrice($nObj.nid);
        if (rez==null) {
            console.log("ERROR -- couldn't get accurate ANNEX pricing data.");
            this.bANNEXABLE=false;
            return -1;
        }
        if (rez.nid!=$nObj.nid) {
            console.log("WRONG NEURON.");
            this.bANNEXABLE=false;
            return -1;
        }

        return this.processAnnexVars(rez);
    }


    /**
     * 
     * @param {*} $rez 
     * @returns 
     */
    processAnnexVars = function($rez) {
        this.boosties = parseInt($rez.boosties);
        this.calculated_cost = $rez.annex_price;
        this.annex_sponsored_relons = parseInt($rez.sponsored_relons);
        this.non_awareness_outs = parseInt($rez.non_awareness_relons);
        this.fibo_factor = parseInt($rez.fibo_factor);
        this.price_lvl = parseInt($rez.price_lvl);
        
        this.bANNEX_CALCULATED = true;

        return this.calculated_cost;
    }



    /**
     * Here we tally non awareness neurons.  (those are captured in the pos/neu/neg total).
     * We want to know how many relons are sponsored.  Those relon sponsors get paid one coin
     * when an ANNEX occurs.
     * We also want to know how many data outs this neuron has.  This tells us the value of the 
     * neuron based on the data in its definition.  We will multiple these numbers 
     * by the LEVEL factor (how high of a level this neuron is determines that factor)
     */
    tallyRelons = function($nObj) {
        var asr = 0;
        var nao = 0;
        for (var r=0; r < $nObj.outs.length; r++) {
            var rel = $nObj.outs[r];
            if (rel.ghost==true) continue;
            if (rel.temp==true) continue;
            if (rel.type==TYPE_AWARENESS) continue;
            if (rel.type==TYPE_SYS_MSG) continue;
            if(rel.relon_sponsor!=undefined && rel.relon_sponsor!="") asr+=1;
            nao+=1;
        }
        this.annex_sponsored_relons = asr;
        this.non_awareness_outs = nao;
    }
}
