/** 
 * These are for selecting TO values for relons.
 * We alter the injection based on the required TO class and type.
 * 
 * If the selector needs a smart search widget that class will be in the ss_selectors.js
 */
class anne_selectors {
    constructor($pgui) {
        this.pgui = $pgui;
        this.ID = $pgui._guid;
        this.pObj = $pgui.pObj;
        this.misc = this.pObj.misc;
        this.param_relon = null;
        
        this.bDUPESTOPPER = false;
        console.log("*******************");
        console.log(this.pObj);
        console.log("*******************");
        console.log(this.misc);
        
        this.bSELECTMODE=true;

        if (this.pObj.s_cbk && typeof this.pObj.s_cbk==="function") this.success_callback = this.pObj.s_cbk;
        else this.success_callback = null;

        if (this.pObj.c_cbk && typeof this.pObj.c_cbk==="function") this.cancel_callback = this.pObj.c_cbk; 
        else this.cancel_callback = null;

        if (this.pObj.f_cbk && typeof this.pObj.f_cbk==="function") this.fail_callback = this.pObj.f_cbk;
        else this.fail_callback=null;

        if (this.misc && this.misc.param_txid) {
            this.param_relon = MEMG.lookupByTXID(this.misc.param_txid);
        }
        //else alert("populate the param relon!!!");

        this.encrypted = this.pgui.page.encrypted;
        this.encryption_method = null;

        if (this.encrypted==undefined) this.encrypted = false;
        
        //if we are using the PDN SECRET we use the ANNODE SHARED KEY method to encrypt at run-time.
        //otherwise, we use the self-encryption (only the sender can ever see the real value)
        else if (this.encrypted==true) {
            if (this.misc.reln_nid!=undefined && this.misc.reln_nid==MEM.PDN_SECRET.nid) {
                this.encryption_method = TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY;
            }
            else this.encryption_method = TXB.ENCRYPT_WITH_SELF_KEY;
        }

        this.voverride=null;
        if (this.misc.validate_class_override!=undefined) {
            this.voverride = this.misc.validate_class_override
            this.voNOBJ = ANNE.MEMG.getNeuronByNid(this.voverride);
        }
        this.from_nid = null;
        this.fNObj = null;
        if (this.misc.from_nid!=undefined) {
            this.from_nid = this.misc.from_nid;
            this.fNObj = MEMG.getNeuronByNid(this.from_nid);
        }
        else console.log("no misc from_nid provided");
        this.reln_nid = null;
        this.rNObj = null;
        if (this.misc.reln_nid!=undefined) {
            this.reln_nid = this.misc.reln_nid;
            this.rNObj = MEMG.getNeuronByNid(this.reln_nid);
        }
        else console.log("no misc reln_nid provided");
        this.type = TYPE_HAS;
        if (this.misc.type!=null) {
            this.type = this.misc.type;
        }
        if (this.rNObj!=null && this.rNObj.target_type!=undefined && this.rNObj.target_type!=null) {
            if (this.type!=this.rNObj.target_type) {
                if (ANNE.SETTINGS.debug()==true) console.log("relon type conflict.. take the nObj val");
                this.type = this.rNObj.target_type;
            }
        }
        this.to_type = TO_TYPE_ANNE;

        //make a relon to an existing neuron or non anne-neuron value.
        this.el_make_ghost_relon_btn = document.getElementById("make_ghost_relon_btn_"+this.ID);
        this.el_make_ghost_relon_btn.addEventListener("click", e=>this.select_existing_value_handler(e), false);

        this.el_save_gneuron_and_relon = document.getElementById("make_new_ghostN_and_relon_btn_"+this.ID);
        //events handled by each resepect sub-classer

        this.el_valid_msg = document.getElementById('valid_msg_'+this.ID);
        this.el_input = document.getElementById('dynamic_input_'+this.ID);
        this.el_select = null;
  
        if (this.encrypted==false) {
            var ecmsg = document.getElementById('encrypted_reminder_'+this.ID);
            if (ecmsg) ANNE.A.removeSelf(ecmsg);
        }
        this.to_s = null; //set to the value we want to store.
        
        //set to the value we want to store (for dynamic relns);
        this.reln_dynamic = null; 
        
        this.el_dynamic_cancel = document.getElementById("dynamic_cancel_"+this.ID);
        ANNE.A.empty(this.el_dynamic_cancel);

        if (this.cancel_callback!=null && this.el_dynamic_cancel!=null) {
            ANNE.A.ezSquareDelete(this.el_dynamic_cancel, this.cancel_callback, [this.pgui], "36px", "nevermind");
        }

        //for ss/dds and other sub-classes that allow for creation of new things
        //if the thing being looked for doesn't exist.
        this.bNEWVALUESOK = false;
        this.bSEARCHFORNEWOK = false;
        this.bINSTSONLY = false;
        this.bSHOWDISAMBIGNID=true;
        
        if (this.misc.newOk!=undefined) this.bNEWVALUESOK=this.misc.newOk;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        if (this.bSEARCHFORNEWOK==undefined) this.bSEARCHFORNEWOK = this.misc.searchFornewOK;
        if (this.misc.insts_only!=undefined && this.misc.insts_only==1) {
            if (ANNE.SETTINGS.debug()==true) console.log("INSTANCES ONLY IN THE SELECTOR");
            this.bINSTSONLY=true;
        }
        this.prompt = "";
        if (this.misc.prompt!=undefined && this.misc.prompt.length>0) this.prompt=this.misc.prompt;
    
        if (this.misc.showNid!=undefined && this.misc.showNid==0) this.bSHOWDISAMBIGNID=false;

        if (this.misc.min_val!=undefined) this.min_val = parseFloat(this.misc.min_val);
        else this.min_val = null;

        if (this.misc.max_val!=undefined) this.max_val = this.misc.max_val;
        else this.max_val = null;

        if (this.misc.default_basic_val!=undefined) this.default_basic_val = this.misc.default_basic_val;
        else this.default_basic_val = null;
        

        //ie, "location"
        this.classNid = this.misc.classRestrictNid;
        if (this.classNid!=undefined && this.classNid!=null) {
            this.classNOBJ = MEMG.getNeuronByNid(this.classNid);
        }
        else if (this.classNOBJ==undefined) this.classNOBJ=null;
        
        if (ANNE.SETTINGS.debug()==true) console.log(this);
    
        //ensure these are in all html selector templates.
        //we've had so many iterations of this stuff it needs to be cleaned up (again).
        this.el_this = document.getElementById("service_"+this.ID);
    
        //to disambiguate neuron selections.
        //not relevant for simple values.
        this.el_disambig =  document.getElementById('disambig_'+this.ID);
        ANNE.A.hide(this.el_disambig);

        //TODO
        //figure this drama out so we only have a single disambig and then
        //a valid OR audit msg.
        this.el_msg = document.getElementById("valid_msg_"+this.ID);
        this.el_audit_msg = document.getElementById("audit_msg_"+this.ID);
        this.el_dynamic_msg = document.getElementById("dynamic_msg_"+this.ID);

        //won't be found for simple values (only neuron vals)
        this.el_checkbtn = document.getElementById("check_new_btn_"+this.ID);

        //sub-classes must specify the inputEventHandler event.

        //if the injected page has a helperMsg_ and the misc provided a helperMsg,
        //display it.
        if (this.misc.helperMsg!=undefined && this.misc.helperMsg!="") {
            this.el_helperMsg = ANNE.A.showParent("helperMsg_"+this.ID);
            if (this.el_helperMsg!=undefined && this.el_helperMsg!=null) {
                this.el_helperMsg.innerHTML=this.misc.helperMsg;
            }
        }
    }


    /** 
     * lookup used for globals classes we target with ANNE's worldview.
     */
     lookupGlobal = async($val, $classNOBJ=null)=> {
        console.log("lookup global val "+$val);

        var classNOBJ = $classNOBJ;
        if (classNOBJ==null) classNOBJ = this.classNOBJ;

        var result = await CHASE.getGlobal(classNOBJ, $val);
        if (result.status=="good" && result.message=="available") {
            //let us select our own date if we have a ghost or our neuron.
            if (this.bSELECTMODE==true) {
                for (var c=0; c < classNOBJ.children.length; c++) {
                    var childNOBJ = MEMG.getNeuronByTempNid(classNOBJ.children[c]);
                    if (childNOBJ.mine==false) continue;
                    if (childNOBJ.text==$val) {
                        this.enter = "select";
                        this.existing_nid = result.result.nid;
                        ANNE.A.show(this.el_make_ghost_relon_btn);
                        ANNE.A.hide(this.el_save_gneuron_and_relon);
                        this.existing_nid = childNOBJ.nid;
                        this.el_msg.innerHTML="<span class='text-success-lbl'>You have a ghost neuron for this already.</span>";
                        return;
                    }
                }
            }

            ANNE.A.show(this.el_save_gneuron_and_relon);
            this.enter = "submit";
            this.el_msg.innerHTML="<span class='text-success-lbl'>"+classNOBJ.text+" available to sponsor</span>";
        }
        
        else {
            ANNE.A.empty(this.el_msg);
            if (this.bSELECTMODE==true && this.bNEWONLY==false) {
                this.enter = "select";
                this.existing_nid = result.result.nid;
                ANNE.A.show(this.el_make_ghost_relon_btn);
                ANNE.A.hide(this.el_save_gneuron_and_relon);
            }
            else {
                var el = ANNE.A.ezEl(this.el_msg, "span", 'text-danger-lbl');
                EXT_BTNS.makeNeuronLink(el, result.result.nid);
                el.append("is already sponsored");
                ANNE.A.hide(this.el_save_gneuron_and_relon);
                this.enter = "lookup";
            }
        }
    }

    /**
     * Only relevant sub-classes that require validation of a value
     */
    validation_fail = function() {
        this.el_msg.innerHTML="<span class='text-danger-lbl'>This is not a valid "+this.classNOBJ.text+"</span>";
        ANNE.A.hide(this.el_make_ghost_relon_btn);
        ANNE.A.hide(this.el_save_gneuron_and_relon);
        ANNE.A.hide(this.el_checkbtn);
        this.enter = "none";
    }


    geRetObj = function() {
        var ge = new Object();
        ge.guitracker = this.misc.guitracker;
        ge.pgui = this.pgui;
        ge.misc = this.misc;    //just get them all..
        ge.pObj = this.pObj;
        ge.param_relon = this.param_relon;
        return ge;
    }


    /**
     * Select an existing value and make a relon with it.
     */
    select_existing_value_handler = async($e)=> {
        var to_s = this.to_s;
        if (to_s==null) to_s = this.el_input.value; //try to make sure to set to_s in the sub-class.
        
        //external handler will deal with this.
        if (this.pObj.misc.action_override!=undefined) {
            console.log("passing off to external handler");  //example anne_circuit_explorer (edit)
            return this.pObj.misc.action_override(this.pObj, to_s);
        }


        //this should have just been a gui_extras to begin with..  doh.
        var gui_extras = this.geRetObj();

        if (this.encryption_method!=null) {
            gui_extras.encryption_method  = this.encryption_method;

            //if we are encryptng with the ANNODE SHARED KEY then we better use the right one!
            //use the one documented in this PDN.
            //the sharedkey is stored in the AAUTH

            //NOTE!!! For GHOST NEURONS ----
            //This is essentially a dry run for actually encrypting the to.
            //we can't properly encrypt the to with the ephemeral (genated) key until
            //we get the real FROM_NID which comes from the annode at run-time!!!!
            if (this.encryption_method==TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY) {
                var annode_uri_relon = MEMG.getRelonFromWith(this.fNObj.outs, TYPE_HAS, MEM.ANNODE_URI.nid);
                if (annode_uri_relon!=null) gui_extras.annode_uri = annode_uri_relon.to_s;
                
                var annode_uri = gui_extras.annode_uri;

                //make sure we are handshaked with the right annode.
                //each shared key is specific to the annode we handshake with.
                var shared_secretObj = await USER.getSharedSecret();
                if (shared_secretObj.status=="success") {
                    var final_reln = this.reln_nid; //from misc.reln_nid

                    //override final_reln if reln_dynamic is set.
                    if (this.reln_dynamic!=null) final_reln = this.reln_dynamic;
                    
                    var rObj = MEM.makeTempRelon(this.fNObj, this.misc.type, final_reln, this.to_type, to_s, true);
                    var bUDPATERELONWITHENCRYPTION = false;
                    if (this.fNObj.ghost==true) bUDPATERELONWITHENCRYPTION = false;
                    else bUDPATERELONWITHENCRYPTION = true;
                    var encryptionDone = await USER.encryptRelonToWithSS(shared_secretObj.seed, rObj, bUDPATERELONWITHENCRYPTION);
                    if (encryptionDone==false) {
                        this.el_msg.innerHTML="<span class='text-danger-lbl'>**!! ENCRYPTION PROBLEM !!**</span>";
                        ANNE.A.show(this.el_msg);
                        return;
                    } 
                    await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
                    if (this.success_callback!=null && typeof this.success_callback==="function") {
                        this.success_callback(gui_extras, to_s, rObj);
                    }
                }
                else {
                    this.el_msg.innerHTML="<span class='text-danger-lbl'>SHARED KEY PROBLEM W/ THE ANNODE YOU ARE USING</span>";
                    ANNE.A.show(this.el_msg);
                    return;
                }
                return;
            }
        }

        var final_reln = this.reln_nid; //from misc.reln_nid

        //override final_reln if reln_dynamic is set.
        if (this.reln_dynamic!=null) final_reln = this.reln_dynamic;
        var rObj = await GHOSTDATA.makeGhostRelon(parseInt(this.misc.type), this.fNObj, final_reln, this.to_type, to_s);
        
        if (this.success_callback!=null && typeof this.success_callback==="function") {
            this.success_callback(gui_extras, to_s, rObj);
        }
    }
}



/***
 * date string (not a date neuron) - basic  relon only (no new ghost neuron)
 */
 class selector_url extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_url", TALK.bgredbig);
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_URL;
        else this.to_type = TO_TYPE_URL;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        var ttObj = MEMG.getTerminatingType(this.rNObj);
        if (ttObj==null) console.log("no tt");
        this.el_input = document.getElementById('dynamic_input_'+this.ID)
        var msg = "What is the "+this.rNObj.text+" url for "+this.fNObj.text+"?";
        console.log(msg);
        var prompt = this.misc.prompt;
        if (prompt!="") msg = prompt;
        ANNE.A.setAttribute('dynamic_input_'+this.ID, "placeholder", msg);
        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerUrl(e));
        //var base_url_relon = MEM.__isBaseUrl(this.rNObj);
        //URL is now just used for full URL.  base url+part will be a string or number.
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));
        
        //passed through from button->misc
        if (this.default_basic_val!=null) {
            this.el_input.value = this.default_basic_val;
            this.inputEventHandlerUrl(null);
        }
    }

    returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if (this.bVALID==true) super.select_existing_value_handler(e); 
        }
    }

    inputEventHandlerUrl=function($e) {
        var url = this.el_input.value.trim();
        var valid = ANNE.A.validator(this.el_input, this.el_make_ghost_relon_btn, this.rNObj, null, url);

    
        //a frienly for AONs.
        //they make most sense on nodes with real addresses, not local addresses.
        //THEY CAN STILL BE USED LOCALLY, for help with a user onboarind theirself (lolz)...
        //but it is easier to just send a direct funding TX to the new acct in that case.
        if (this.param_relon!=null && this.param_relon.reln==MEM.ANNODE_URI.nid) {
            if (url.indexOf("localhost")!=-1 || url.indexOf("127.0.0.1")!=-1) {
                var elmsg = ANNE.A.setHTML("valid_msg_"+this.ID, "NOTE: You are making a faucet for a local node address that only you will be able to use.")
                elmsg.classList.add("bg-warning");
            }
            else ANNE.A.empty("valid_msg_"+this.ID, true);
        }
        else ANNE.A.empty("valid_msg_"+this.ID, true);
        
        if (valid) {
            ANNE.A.show(this.el_make_ghost_relon_btn);
            this.to_s = url;
        }
        else {
            ANNE.A.hide(this.el_make_ghost_relon_btn);
            this.to_s="";
        }
    }
}


/***
 */
 class selector_ipv4 extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_ipv4", TALK.bgredbig);
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_URL;
        else this.to_type = TO_TYPE_URL;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        var ttObj = MEMG.getTerminatingType(this.rNObj);
        if (ttObj==null) console.log("no tt");
        this.el_input = document.getElementById('dynamic_input_'+this.ID)
        var msg = "What is the "+this.rNObj.text+" ipv4 for "+this.fNObj.text+"?";
        console.log(msg);
        var prompt = this.misc.prompt;
        if (prompt!="") msg = prompt;
        ANNE.A.setAttribute('dynamic_input_'+this.ID, "placeholder", msg);
        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerIPV4(e));
        //var base_url_relon = MEM.__isBaseUrl(this.rNObj);
        //URL is now just used for full URL.  base url+part will be a string or number.
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));
        
        //passed through from button->misc
        if (this.default_basic_val!=null) {
            this.el_input.value = this.default_basic_val;
            this.inputEventHandlerIPV4(null);
        }
    }

    returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if (this.bVALID==true) super.select_existing_value_handler(e); 
        }
    }

    inputEventHandlerIPV4=function($e) {
        var url = this.el_input.value.trim();
        var valid = ANNE.A.validator(this.el_input, this.el_make_ghost_relon_btn, this.rNObj, null, url);
        if (valid) {
            ANNE.A.show(this.el_make_ghost_relon_btn);
        }
        else ANNE.A.show(this.el_make_ghost_relon_btn);
    }
}


/***
 */
 class selector_ipv6 extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_ipv6", TALK.bgredbig);
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_URL;
        else this.to_type = TO_TYPE_URL;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        var ttObj = MEMG.getTerminatingType(this.rNObj);
        if (ttObj==null) console.log("no tt");
        this.el_input = document.getElementById('dynamic_input_'+this.ID)
        var msg = "What is the "+this.rNObj.text+" ipv6 for "+this.fNObj.text+"?";
        console.log(msg);
        var prompt = this.misc.prompt;
        if (prompt!="") msg = prompt;
        ANNE.A.setAttribute('dynamic_input_'+this.ID, "placeholder", msg);
        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerIPV6(e));
        //var base_url_relon = MEM.__isBaseUrl(this.rNObj);
        //URL is now just used for full URL.  base url+part will be a string or number.
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));
        
        //passed through from button->misc
        if (this.default_basic_val!=null) {
            this.el_input.value = this.default_basic_val;
            this.inputEventHandlerIPV6(null);
        }
    }

    returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if (this.bVALID==true) super.select_existing_value_handler(e); 
        }
    }

    inputEventHandlerIPV6=function($e) {
        var url = this.el_input.value.trim();
        var valid = ANNE.A.validator(this.el_input, this.el_make_ghost_relon_btn, this.rNObj, null, url);
        if (valid) {
            ANNE.A.show(this.el_make_ghost_relon_btn);
        }
        else ANNE.A.show(this.el_make_ghost_relon_btn);
    }
}


/***
 * TXID - basic  relon only (no new ghost neuron)
 */
 class selector_txid extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_txid", TALK.bgredbig);
        this.type = TYPE_SYS;

        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_TXID;
        else this.to_type = TO_TYPE_TXID;

        var ttObj = MEMG.getTerminatingType(this.rNObj);
        if (ttObj==null) console.log("no tt");
        this.el_select = document.getElementById('dynamic_select_'+this.ID);
        this.el_input = document.getElementById('dynamic_input_'+this.ID);
    }


    /** 
     */
     initASYNC = async($pguicopy)=>{
        if (this.rNObj.temp_nid==MEM.inhibit_relon.temp_nid || this.rNObj.temp_nid==MEM.arbor_prune.temp_nid) {
            msg = "Which relon (edge/txid) would you like to inhibit?";
            var bCHASE = false;
            var bSLIM = false;
            var aList = await ANNE.GUI_STUFF.___buildListDisplayFor(this.fNObj, [TYPE_PARAM, TYPE_HAS], bCHASE, bSLIM);
            console.log(aList);
            ANNE.A.hide(this.el_input);
            ANNE.GUI_STUFF.___madeDDfromValTextArr(this.el_select, aList, "<b>** Valid Relons to Inhibit **</b>");
            this.el_select.addEventListener("change", e=> this.selectHandler(e));
        }
        else {
            var prompt = misc.prompt;
            if (prompt!=undefined && prompt!=null && prompt!="") msg = prompt;
            ANNE.A.show(this.el_input);
            ANNE.A.hide(this.el_select);
        }
        ANNE.A.setHTML(this.el_dynamic_msg, msg);
        this.el_input.addEventListener("change",  (e)=> this.inputEventHandlerTXID(e));
    }

    inputEventHandlerTXID=function($e) {
        ANNE.A.validator(this.el_input, this.el_make_ghost_relon_btn, this.rNObj, null, this.el_input.value);
    }

    selectHandler=function($e) {
        if (this.el_select.value) var txid = this.el_select.trim();
        console.log(txid);
        if (txid.length) {
            ANNE.A.show(this.el_make_ghost_relon_btn);
            this.to_s = txid;
        }
        else ANNE.A.hide(this.el_make_ghost_relon_btn);
    }
}


/***
 * blob - basic  relon only (no new ghost neuron)
 */
 class selector_blob extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_blob", TALK.bgredbig);
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_BLOB;
        else this.to_type = TO_TYPE_BLOB;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        var ttObj = MEMG.getTerminatingType(this.rNObj);
        if (ttObj==null) console.log("no tt");
        this.el_input = document.getElementById('dynamic_input_'+this.ID);
        var msg = "What is the "+this.rNObj.text+" description for "+this.fNObj.text+"?";
        console.log(msg);
        var prompt = this.misc.prompt;
        if (prompt!="") msg = prompt;
        ANNE.A.setAttribute('dynamic_input_'+this.ID, "placeholder", msg);
        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerBLOB(e));
    }
    inputEventHandlerBLOB=function($e) {
        var txt = ANNE.A.getValue(this.el_input).trim();;
        if (txt.length>254 || txt.length==0) {
            ANNE.A.addRemoveClass(this.el_input, "invalid", "valid");
            ANNE.A.hide(this.el_make_ghost_relon_btn);
        }
        else {
            ANNE.A.addRemoveClass(this.el_input, "valid", "invalid");
            ANNE.A.show(this.el_make_ghost_relon_btn);
        }
    }
}


/***
 * date string (not a date neuron) - basic  relon only (no new ghost neuron)
 */
 class selector_filehash extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_filehash", TALK.bgredbig);
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_FILEHASH;
        else this.to_type = TO_TYPE_FILEHASH;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        var ttObj = MEMG.getTerminatingType(this.rNObj);
        if (ttObj==null) console.log("no tt");
        this.el_input = document.getElementById('dynamic_input_'+this.ID)
        var msg = "What is the "+this.rNObj.text+" filehash for "+this.fNObj.text+"?";
        console.log(msg);
        var prompt = this.misc.prompt;
        if (prompt!="") msg = prompt;
        ANNE.A.setAttribute('dynamic_input_'+this.ID, "placeholder", msg);
        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerFilehash(e));
    }
    inputEventHandlerFilehash=function($e) {
        var txt = ANNE.A.getValue(this.el_input).trim();
        ANNE.A.addRemoveClass(this.el_input, "valid", "invalid");
        ANNE.A.show(this.el_make_ghost_relon_btn);
    }
}




/***
 * date string (not a date neuron) - basic  relon only (no new ghost neuron)
 * TO DO
 */
 class selector_time extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_time", TALK.bgredbig);
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_TIME;
        else this.to_type = TO_TYPE_TIME;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        var ttObj = MEMG.getTerminatingType(this.rNObj);
        if (ttObj==null) console.log("no tt");
        this.el_input = document.getElementById('dynamic_input_'+this.ID)
        var msg = "What is the "+this.rNObj.text+" time for "+this.fNObj.text+"?";
        console.log(msg);
        var prompt = this.misc.prompt;
        if (prompt!="") msg = prompt;
        ANNE.A.setAttribute('dynamic_input_'+this.ID, "placeholder", msg);
        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerTime(e));
    }
    inputEventHandlerTime=function($e) {
        var txt = ANNE.A.getValue(this.el_input).trim();
        ANNE.A.addRemoveClass(this.el_input, "valid", "invalid");
        ANNE.A.show(this.el_make_ghost_relon_btn);
    }
}

/***
 * date string (not a date neuron) - basic  relon only (no new ghost neuron)
 * TO DO
 */
 class selector_datetime extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_datetime", TALK.bgredbig);
        ANNE.A.setKeyUpDate(this.el_input.id);
        //ANNE.A.setKeyUpTime(this.el_input2.id);
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_DATETIME;
        else this.to_type = TO_TYPE_DATETIME;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        var ttObj = MEMG.getTerminatingType(this.rNObj);
        if (ttObj==null) console.log("no tt");
        this.el_input = document.getElementById('dynamic_input_'+this.ID)
        var msg = "What is the "+this.rNObj.text+" date time for "+this.fNObj.text+"?";
        console.log(msg);
        var prompt = this.misc.prompt;
        if (prompt!="") msg = prompt;
        ANNE.A.setAttribute('dynamic_input_'+this.ID, "placeholder", msg);
        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerDateTime(e));
    }
    inputEventHandlerDateTime=function($e) {
        var txt = ANNE.A.getValue(this.el_input).trim();
        ANNE.A.addRemoveClass(this.el_input, "valid", "invalid");
        ANNE.A.show(this.el_make_ghost_relon_btn);
    }
}


/***
 * date string (not a date neuron) - basic  relon only (no new ghost neuron)
 */
 class selector_date_string extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_date_string", TALK.bgredbig);
        ANNE.A.setKeyUpDate(this.el_input.id);
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_DATE;
        else this.to_type = TO_TYPE_DATE;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        var ttObj = MEMG.getTerminatingType(this.rNObj);
        if (ttObj==null) console.log("no tt");
        this.el_input = document.getElementById('dynamic_input_'+this.ID)
        var msg = "What is the "+this.rNObj.text+" date string for "+this.fNObj.text+"?";
        console.log(msg);
        var prompt = this.misc.prompt;
        if (prompt!="") msg = prompt;
        ANNE.A.setAttribute('dynamic_input_'+this.ID, "placeholder", msg);
        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerDateString(e));
    }
    inputEventHandlerDateString=function($e) {
        var txt = ANNE.A.getValue(this.el_input).trim();
        ANNE.A.addRemoveClass(this.el_input, "valid", "invalid");
        ANNE.A.show(this.el_make_ghost_relon_btn);
    }
}


/***
 * boolean - basic relon only (no new ghost neuron)
 */
 class selector_boolean extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_boolean", TALK.bgredbig);
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_BOOLEAN;
        else this.to_type = TO_TYPE_BOOLEAN;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        var ttObj = MEMG.getTerminatingType(this.rNObj);
        if (ttObj==null) console.log("no tt");
        this.el_input = document.getElementById('dynamic_input_'+this.ID)
        var msg = "What is the "+this.rNObj.text+" yes/no value for "+this.fNObj.text+"?";
        console.log(msg);
        var prompt = this.misc.prompt;
        if (prompt!="") msg = prompt;
        this.el_bools = document.getElementsByName("bool_tf_"+this.ID);
        for (const rad of this.el_bools) {
            rad.addEventListener("change", e=>this.inputEventHandlerBoolean(e));
        }
        ANNE.A.show(this.el_make_ghost_relon_btn);
        this.to_s = "1"; //default to true, ready to save
    }

    inputEventHandlerBoolean=async($e)=> {
        for (var r=0; r < this.el_bools.length; r++) { 
            var rad = this.el_bools[r];
            if (rad.checked==false) continue;
            this.to_s = rad.value;
            if (this.to_s=="true" || this.to_s==true) this.to_s="1";
            else if (this.to_s=="false" || this.to_s==false) this.to_s="0";
            break;
        }
        console.log(this.to_s);
    }
}



/***
 * string entry.
 * (not really a selector because we don't let existing strings be selected)
 */
 class selector_string extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c selector_string", TALK.bgredbig);
        this.bVALID = false;
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_STRING;
        else this.to_type = TO_TYPE_STRING;
        if (this.misc.type!=undefined) this.type = this.misc.type;

        //get base url for audit. 
        var base_url_relon = MEM.__isBaseUrl(this.rNObj);
        if (base_url_relon!=null) {
            console.log("doing base url mode");
            this.misc.AUDIT_BASE_URL = base_url_relon.to_s;
        }
        else this.misc.AUDIT_BASE_URL="";
        this.el_input = document.getElementById('dynamic_input_'+this.ID);
        this.el_input.addEventListener("keyup", (e)=>this.returnKeyPress(e, this));
        if (this.misc.setval!=undefined && this.misc.setval!="") this.el_input.value = this.misc.setval;
        if (this.rNObj.placeholder!=undefined) {
            this.el_input.attr('placeholder', this.rNObj.placeholder);
        }
        this.voNOBJ = null;
        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerString(e));

        var msg = this.prompt;
        if (msg=="") {
            var name = this.fNObj.bestNameHTML();
            msg = "Enter in the&nbsp;<span class='text-success-lbl'>"+this.rNObj.text+"</span>&nbsp;for&nbsp;<em><b>"+name+"</b></em>";    
        }
        ANNE.A.setHTML(this.el_dynamic_msg, msg);

        //sometimes we use string handler for a number.
        //both string and number are stored in the TO_S in the hypergraph (not a to_a)
        if (this.default_basic_val!=null) {
            this.el_input.value = this.default_basic_val;
            this.inputEventHandlerNumber({data:this.default_basic_val[this.default_basic_val.length-1]});       //needs the last char "typed"
        }

        if (this.min_val!=null && this.max_val!=null) {
            ANNE.A.ezEl(this.el_input.parentNode, "span", "small-lbl-minus160", "<span class='lbl-bgwhite'>min:"+this.min_val+"&nbsp;max:"+this.max_val+"</span>");
            this.inputEventHandlerNumber({data:this.el_input.value[this.el_input.value.length-1]});
        }
        else if (this.min_val!=null) {
            ANNE.A.ezEl(this.el_input.parentNode, "span", "small-lbl-minus80", "<span class='lbl-bgwhite'>min:"+this.min_val+"</span>");
            this.el_input.value = this.min_val;
            this.inputEventHandlerNumber({data:this.el_input.value[this.el_input.value.length-1]});
        }
        else if (this.max_val!=null) {
            ANNE.A.ezEl(this.el_input.parentNode, "span", "small-lbl-minus80", "<span class='lbl-bgwhite'>max:"+this.max_val+"</span>");
            this.el_input.value = this.max_val;
            this.inputEventHandlerNumber({data:this.el_input.value[this.el_input.value.length-1]});
        }
        
        //why won't this take focus??  hmmm.
        this.el_input.focus();
    }


    /**
     * 
     * @param {Event} $e 
     */
    inputEventHandlerNumber=async($e)=> {
        var val = ANNE.A.getValue(this.el_input);
        var amt = val;
        var newval = 0;

        if ($e.data=="k" || $e.data=="K") {
            newval = Number.parseFloat(val) * 1000;
            var annies = Math.round ( Number.parseFloat( newval ) * ANNE.ANNE_TO_ANNIES );
            amt = annies;
            this.el_input.value = newval;
        }
        else if ($e.data=="m" || $e.data=="M") {
            newval = Number.parseFloat(val) * 1000000;
            var annies = Math.round ( Number.parseFloat( newval ) * ANNE.ANNE_TO_ANNIES );
            amt = annies;
            this.el_input.value = newval;
        }
        else if ($e.data=="b" || $e.data=="B") {
            newval = Number.parseFloat(val) * 1000000000;
            var annies = Math.round ( Number.parseFloat( newval ) * ANNE.ANNE_TO_ANNIES );
            amt = annies;
            this.el_input.value = newval;
        }
        else if ("0123456789.,".indexOf($e.data)==-1) {
            var newAmt = 0;
            for (var a=0; a < amt.length; a++) {
                if ((a!=(amt.length-1)) && "kKmMbB".indexOf(amt[a])!=-1) continue;
                else if ("0123456789.,".indexOf(amt[a])!=-1) continue;
                newAmt = newAmt+amt[a];
            }
            amt = newAmt;
            this.el_input.value = amt;
        }

        //external validate func passed in via the misc obj.
        if (this.misc.validate_data_entry_cb!=undefined) {
            var rez = await this.misc.validate_data_entry_cb(this.el_input.value);
            if (rez.valid==false) {
                this.el_valid_msg.innerHTML=rez.msg;
                ANNE.A.hide(this.el_make_ghost_relon_btn);
                return;
            }
        }


        if (this.min_val!=null && parseFloat(this.el_input.value) < this.min_val) {
            this.el_valid_msg.innerHTML="min value "+this.min_val;
            ANNE.A.hide(this.el_make_ghost_relon_btn);
        }

        else if (this.max_val!=null && parseInt(this.el_input.value) > this.max_val) {
            this.el_valid_msg.innerHTML="max value "+this.max_val;
            ANNE.A.hide(this.el_make_ghost_relon_btn);
        }

        else if ((this.el_input.value+"").length>0) {
            ANNE.A.show(this.el_valid_msg);
            ANNE.A.show(this.el_make_ghost_relon_btn);
        }
        else {
            this.el_valid_msg.innerHTML="";
            ANNE.A.hide(this.el_make_ghost_relon_btn);
        }
        if (this.el_symbol) this.updateConversion(this.el_input.value);
        else {
            if (parseInt(this.el_input.valueO)>100) this.el_valid_msg.innerHTML = "number: "+UTILS.commas(this.el_input.value);
            else this.el_valid_msg.innerHTML = "number: "+this.el_input.value;
        }
    }


    /**
    */
    returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if (this.bVALID==true) super.select_existing_value_handler(e); 
        }
    }


    /**
     * 
     * @param {*} $e 
     */
    inputEventHandlerString=async($e)=> {
        var txt = ANNE.A.getValue(this.el_input);
        if (txt.length && this.rNObj!=null && this.rNObj.formatter!=undefined) {
            console.log("we have a reln based form validator");
            txt = this.rNObj.formatter(txt);
        }
        this.bVALID = ANNE.A.validator(this.el_input, this.el_make_ghost_relon_btn, this.rNObj, this.voNOBJ, txt);
        if (this.bVALID==true && this.misc.AUDIT_BASE_URL!="") {
            ANNE.A.empty(this.el_valid_msg);
            this.el_valid_msg.append("audit: ");
            ANNE.A.ezHref(this.el_valid_msg, this.misc.AUDIT_BASE_URL+txt);
        }
    }
}


/***
 */
 class selector_number extends anne_selectors {
    constructor($pgui) { 
        super($pgui); 
        this.bJUSTDOANNECOIN = false;
        console.log("%c selector_number", TALK.bgredbig);
        this.bDECIMALOK = false;
        this.el_symbol = null;
        if (this.misc.type!=undefined) this.type = this.misc.type;
        if (this.misc.decimal_ok!=undefined) this.bDECIMALOK = this.misc.decimal_ok;
        
        //explore potential of upgrading to integer if they type in an integer
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_NUMBER;
        else this.to_type = TO_TYPE_NUMBER

        this.el_input = document.getElementById('dynamic_input_'+this.ID)
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));

        this.el_input.style['max-width']="400px";
        this.el_input.parentNode.style['max-width']="400px";
        
        console.log(this.misc);

        this.toNObj = MEMG.getNeuronByNid(this.misc.classRestrictNid);
        
        if (this.toNObj==undefined) {
            console.log("%cno toNOBJ in the misc obj", TALK.bgredbig);
            this.toNObj=null;
        }

        
        //unit of measure as determined by the TO NOBJ or the RELN NOBJ (if the toNOBJ is null)
        this.uom = null;
        if (this.toNObj!=null) {
            this.uom = MEM.unitOfMeasure(this.toNObj);  
        }
        else {
            this.uom = MEM.unitOfMeasure(this.rNObj); 
        }

        //if UOM update prompt (override anything else)
        console.log(this.uom);
        var msg = "";
        if (this.misc.nounit!=undefined) {
            console.log("no unit");
            this.uom = null;
            this.bJUSTDOANNECOIN=false;
            var msg = this.prompt;
            if (msg=="") {
                var name = this.fNObj.bestNameHTML();
                msg = "Enter in the&nbsp;<span class='text-success-lbl'>"+this.rNObj.text+"</span>&nbsp;for&nbsp;<em><b>"+name+"</b></em>";
            }
            ANNE.A.setHTML(this.el_dynamic_msg, msg);
        }
        else if (this.uom!=null) {
            this.el_symbol = document.getElementById("uom_symbol_"+this.ID);
            if(this.uom.unit_lbl=="ANNE") {
                var pl = "annecoin";
                this.bJUSTDOANNECOIN=true;
                ANNE.A.hide(this.el_symbol);
                this.el_symbol = null;
            }
            else {
                var pl = this.uom.unit_lbl;
                this.bJUSTDOANNECOIN=false;
            }
            if (this.prompt!=null && this.prompt!="") msg = this.prompt;
            else msg = "How many <span class='text-warning-lbl'>"+pl+"</span> for <span class='text-primary-lbl'>"+this.fNObj.text+"</span>?";
            this.el_input.setAttribute('placeholder', pl);
            if (this.el_symbol && this.bJUSTDOANNECOIN==false) this.updateConversion(0);
            ANNE.A.setHTML(this.el_dynamic_msg, msg);
        }
        else {

            //massive RUBE fix.
            if (this.misc!=undefined && this.misc.annieshack!=undefined) {
                this.bJUSTDOANNECOIN=true; 
            }

            var msg = this.prompt;
            if (msg=="") {
                var name = this.fNObj.bestNameHTML();
                msg = "Enter in the&nbsp;<span class='text-success-lbl'>"+this.rNObj.text+"</span>&nbsp;for&nbsp;<em><b>"+name+"</b></em>";
            }
            ANNE.A.setHTML(this.el_dynamic_msg, msg);
        }

        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerNumber(e));

        //if there is a min_val, default the val to that.
        if (this.default_basic_val!=null) {
            this.el_input.value = this.default_basic_val;
            this.inputEventHandlerNumber({data:this.default_basic_val[this.default_basic_val.length-1]});       //needs the last char "typed"
        }
        var min_display = this.min_val;
        if (this.min_val>100) min_display = UTILS.commas(this.min_val);

        var max_display = this.max_val;
        if (this.max_val>100) max_display = UTILS.commas(this.max_val);

        if (this.min_val!=null && this.max_val!=null) {
            ANNE.A.ezEl(this.el_input.parentNode, "span", "small-lbl-minus160", "<span class='lbl-bgwhite'>min:"+min_display+"&nbsp;max:"+max_display+"</span>");
            this.el_input.value = this.min_val;
            this.inputEventHandlerNumber({data:this.el_input.value[this.el_input.value.length-1]});
        }
        else if (this.min_val!=null) {
            ANNE.A.ezEl(this.el_input.parentNode, "span", "small-lbl-minus80", "<span class='lbl-bgwhite'>min:"+min_display+"</span>");
            this.el_input.value = this.min_val;
            this.inputEventHandlerNumber({data:this.el_input.value[this.el_input.value.length-1]});
        }
        else if (this.max_val!=null) {
            ANNE.A.ezEl(this.el_input.parentNode, "span", "small-lbl-minus80", "<span class='lbl-bgwhite'>max:"+max_display+"</span>");
            this.el_input.value = this.max_val;
            this.inputEventHandlerNumber({data:this.el_input.value[this.el_input.value.length-1]});
        }

        this.el_input.focus();
    }


    /**
     * A key has been pressed while in the input field.
     * We want to handle the return key press.
     * @param {Event} $e 
     * @param {selector_number} $this 
     */
    returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if (this.bVALID==true) super.select_existing_value_handler(e); 
        }
    }


    /**
     * Yanking annies from the display has been a shite fest ...
     * this.bJUSTDOANNECOIN is a rube from hell but it does the trick, for now.
     * @param {Event} $e 
     */
    inputEventHandlerNumber=async($e)=> {
        var val = ANNE.A.getValue(this.el_input)+"";
        var newval = "";
        var lastChar = "";
        if (val.length==1) lastChar = val;
        else lastChar = val[val.length-1];

        if (lastChar=="k" || lastChar=="K") {
            val = val.substring(0, val.length-1);
            newval = Number.parseFloat(val) * 1000;
            if(this.bJUSTDOANNECOIN==true) {
                this.to_s = Math.round ( Number.parseFloat( newval ) * ANNE.ANNE_TO_ANNIES );
            }
            else this.to_s = newval;
            this.el_input.value = newval;
        }
        else if (lastChar=="m" || lastChar=="M") {
            val = val.substring(0, val.length-1);
            newval = Number.parseFloat(val) * 1000000;
            if(this.bJUSTDOANNECOIN==true) {
                this.to_s = Math.round ( Number.parseFloat( newval ) * ANNE.ANNE_TO_ANNIES );
            }
            else this.to_s = newval;
            this.el_input.value = newval;
        }
        else if (lastChar=="b" || lastChar=="B") {
            val = val.substring(0, val.length-1);
            newval = Number.parseFloat(val) * 1000000000;
            if(this.bJUSTDOANNECOIN==true) {
                this.to_s = Math.round ( Number.parseFloat( newval ) * ANNE.ANNE_TO_ANNIES );
            }
            else this.to_s = newval;
            this.el_input.value = newval;
        }

        else {
            for (var v=0; v < val.length; v++) {
                if ("0123456789.,".indexOf(val[v])==-1) continue;
                newval = newval+val[v];
            }

            this.el_input.value = newval;
    
            if (this.bJUSTDOANNECOIN==true) {
                this.to_s = Number.parseFloat(newval) * ANNE.ANNE_TO_ANNIES;
            }
            else this.to_s = newval;
        }


        //external validate func passed in via the misc obj.
        if (this.misc.validate_data_entry_cb!=undefined) {
            var rez = await this.misc.validate_data_entry_cb(this.el_input.value);
            if (rez.valid==false) {
                this.el_valid_msg.innerHTML=rez.msg;
                ANNE.A.hide(this.el_make_ghost_relon_btn);
                return;
            }
        }

        //if max is also a deci float, we're in trouble here.. 
        if (this.min_val!=null && parseFloat(this.el_input.value) < this.min_val) {
            this.el_valid_msg.innerHTML="min value "+this.min_val;
            ANNE.A.hide(this.el_make_ghost_relon_btn);
        }

        else if (this.max_val!=null && parseInt(this.el_input.value) > this.max_val) {
            this.el_valid_msg.innerHTML="max value "+this.max_val;
            ANNE.A.hide(this.el_make_ghost_relon_btn);
        }

        else if ((this.el_input.value+"").length>0) {
            ANNE.A.show(this.el_valid_msg);
            ANNE.A.show(this.el_make_ghost_relon_btn);
        }
        else {
            this.el_valid_msg.innerHTML="";
            ANNE.A.hide(this.el_make_ghost_relon_btn);
        }

        if (this.el_symbol && this.bJUSTDOANNECOIN==false) {
            this.updateConversion(this.el_input.value);
        }
            
        //annecoin is now the display, not annies
        else {
            if (this.misc.dispAC!=undefined) {
                ANNE.A.ezAnnecoinDisplay(this.el_valid_msg, this.el_input.value, true);
            }
            else if (parseInt(this.el_input.value)>100) this.el_valid_msg.innerHTML = "number: "+UTILS.commas(this.el_input.value);
            else this.el_valid_msg.innerHTML = "number: "+this.el_input.value;
        }
    }


    /**
     * Good, maybe -- later.. but we abandoned using annies in the GUI
     * so we don't have an immediate need for conversions. 
     * 
     * This architecture is built and will do conversions based on neural definitions so this is 
     * now mostly for later.
     * @param {String} $val 
     * @returns 
     */
    updateConversion = function($val) {
        if (this.uom==null) return;
        var thisconv = null;
        if (this.uom.conversions!=undefined && this.uom.conversions["_"+$val]!=undefined) {
            thisconv = this.uom.conversions["_"+$val];
        }
        else thisconv = this._convert($val, this.uom);
        this.el_symbol.innerHTML=thisconv.total+"<span>&nbsp;"+thisconv.post+"</span>";
    }


    /**
     * 
     * @param {String} $val 
     * @param {Object} $uom 
     * @returns 
     */
    _convert = function ($val, $uom) {
        var post = "";
        if ($uom.unit_lbl.length) post=" "+$uom.unit_lbl;
        if ($uom.symbolHTML) post=post+$uom.symbolHTML;
        var factor = Math.ceil(1/$uom.factored);
        var total = Math.round(($uom.factored*parseFloat($val))*factor)/factor;

        //10B max annies
        if (total>10000000000) {
            total = 10000000000;
            this.el_input.value = total;
        }

        if (total>0) {
            var parts = (total+"").split(".");
            var commas = UTILS.commas(parts[0]);
            parts[0]=commas;
            total = parts.join(". ");
        }

        var thisconv = {val:$val, total:total, post:post};
        if ($uom.conversions==undefined) $uom.conversions = [];
        $uom.conversions["_"+$val]=thisconv;
        return thisconv;
    }
}



/**
 * Select and existing or make a new date.
 * @author {Mr.Scatman}
 */ 
 class selector_date extends anne_selectors {
    constructor ($pgui) {
        super($pgui);
        console.log("%c selector_date", TALK.bgredbig);
        ANNE.A.setKeyUpDate(this.el_input.id);
        console.log(this.misc);

        if (this.el_save_gneuron_and_relon!=null) {
            this.el_save_gneuron_and_relon.addEventListener("click", e=>this.makeNewDate(e));  
        }

        //if value is not found we can check for a new one.
        this.el_checkbtn.addEventListener("click", e=>this.checkANNEForDate(e));
        this.el_bdera = document.getElementsByName("date_era_"+this.ID);
        
        //we have been passed a default val (esstially we need to lookup
        //this val or make a new one. 
        //This is most often done by external data btns (pulling info in)
        if (this.misc.default_value!=undefined) {
            ANNE.A.setHTML(this.el_dynamic_msg, "Create the "+this.rNObj.text+" for "+this.fNObj.text);
            var thedate = new anne_date(this.misc.default_value);
            console.log(thedate);
            this.el_input.value=thedate.dateStr;
            this.el_input.setAttribute("disabled", true);
            for (const rad of this.el_bdera) {
                rad.setAttribute("disabled", true);
            }
            this.checkANNEForDate(null);
            if (this.el_save_gneuron_and_relon!=null) {
                var btxt = '<img class="dib" src="../imgs/ghost_white_ico.png" width="12px" title="make ghost">';
                btxt = btxt+' make new <b>'+this.rNObj.text+'</b> for <b>'+this.fNObj.text+'</b>';
                ANNE.A.setHTML(this.el_save_gneuron_and_relon, btxt);
            }
            return;
        }

        ANNE.A.setHTML(this.el_dynamic_msg, "select or create new the "+this.rNObj.text+" for "+this.fNObj.text);
        for (const rad of this.el_bdera) {
            rad.addEventListener("change", this.eraChange);
        }

        this.el_input.addEventListener("input",  (e)=>this.inputEventHandlerDate(e));
    }


    inputEventHandlerDate=function($e) {
        ANNE.A.hide(this.el_checkbtn);
        ANNE.A.hide(this.el_save_gneuron_and_relon);
        ANNE.A.hide(this.el_make_ghost_relon_btn);
        var txt = ANNE.A.getValue(this.el_input);
        var parts = txt.split("-");
        if (parts.length==3) ANNE.A.show(this.el_checkbtn);
        else ANNE.A.hide(this.el_checkbtn);
    }

    
    /**
     */
    eraChange = async($e)=> {
        this.inputEventHandler($e);
    }


    /**
     */
    checkANNEForDate = async($e)=> {
        ANNE.A.hide(this.el_checkbtn);
        ANNE.A.hide(this.el_save_gneuron_and_relon);
        ANNE.A.hide(this.el_make_ghost_relon_btn);
        var val = ANNE.A.getValue(this.el_input);
        var parts =  val.split("-");
        if (parts.length!=3) this.validation_fail();
        else {
            var era = ANNE.A.getValue(this.el_bdera);
            if (era=="BC") {
                val = val + " BC";
            }

            console.log("looking for val:"+val);
            //check local first
            for (var d=0; d < MEM.date_gregorian.children.length; d++) {
                var childNOBJ = MEMG.getNeuronByTempNid(MEM.date_gregorian.children[d]);
                if (childNOBJ.text==val) {
                    this.enter = "select";
                    this.existing_nid = childNOBJ.nid;
                    this.to_s = childNOBJ.nid;
                    console.log("this existing nid:"+this.existing_nid);
                    ANNE.A.show(this.el_make_ghost_relon_btn);
                    ANNE.A.hide(this.el_save_gneuron_and_relon);
                    this.el_msg.innerHTML="<span class='text-success-lbl'>This neuron exists already.</span>";
                    return;
                } 
            }

            await this.lookupGlobal(val, MEM.date_gregorian);
            
            this.el_audit_msg.innerHTML = "**audit** "+MEM.date_gregorian.frenlyPrint(parts, era);
        }
    }


    /**
     * make new date
     * this is only intended for date_gregorian.  It doesn't matter what the classNOBJ is.
     */
    makeNewDate = async($e)=>{
        ANNE.A.hide(this.el_save_gneuron_and_relon);
        var val = this.el_input.value;
        var era = ANNE.A.getValue(this.el_bdera);
        if (era=="BC") val = val + " "+era;
        var gui_extras = this.geRetObj();
        console.log("makeNewDate type:"+this.misc.type);
        var ghostObj = await GHOSTDATA.newGhostWithRelon(MEM.date_gregorian, val, this.fNObj, this.misc.type, this.misc.reln_nid);
        if (this.success_callback!=null) {
            this.success_callback(gui_extras, ghostObj.nObj.nid, ghostObj.rel);
            return;
        }
        PAGES.launchNeuron(ghostObj.nObj.nid);
    }
}



//picking media assigned to other other neurons..
//and tying them to another neuron.
//DO WE STILL USE THIS??
const PICKER_MODE_NEURON = 1;       //gen a picker based on NEURON
const PICKER_MODE_DATA_URL = 2;     //gen a picker based on URL
const PICKER_MODE_SPONSOR = 3;      //gen a picker based on sponsor
const PICKER_MODE_OWNER = 4;        //gen a picker based on owner
class selector_mediapicker {
    constructor($pgui) {
        console.log($pgui);
        this.pgui = $pgui;
        this.pObj = $pgui.pObj;
        this.picker_mode = PICKER_MODE_DATA_URL;

        //pick by the url of the link
        if ($pgui.pObj.misc.picker_mode!=undefined) this.picker_mode = $pgui.pObj.misc.picker_mode;        
        
    }
}

/**
 * media choice
 * works with "img", "video", "audio", or "file"
 */
class selector_mediachoice {
    constructor($pgui) {
        console.log("%c selector_mediachoice", TALK.bgredbig);
        console.log("here");
        console.log($pgui);
        this.pgui = $pgui;
        this.media_type = this.pgui.pObj.misc.media_type;
        this.media_neuron = this.pgui.pObj.misc.media_neuron;
        this.el_dynamic_cancel = document.getElementById("dynamic_cancel_"+this.pgui._guid);
        if (this.pgui.pObj.c_cbk!=undefined) {
            ANNE.A.ezSquareDelete(this.el_dynamic_cancel, this.pgui.pObj.c_cbk, [this.pgui], "36px", "nevermind");
        }
        this.el_new = document.getElementById("btn_new_media_"+this.pgui._guid);
        this.el_new.addEventListener("click", async(e)=>{
            this.pgui.pObj.bNEWONLY=true;
            PAGES.openPart(this.pgui.pObj.misc.media_type+"neuron", this.pgui.pObj);
        });
        this.el_existing = document.getElementById("btn_existing_media_"+this.pgui._guid)
        this.el_existing.addEventListener("click",  async(e)=>{
            alert("to do");
            //$pgui.pObj.misc.picker_mode=PICKER_MODE_NEURON;
            //PAGES.openPart($pgui.pObj.misc.media_type+"picker", $pgui.pObj);
        });
        this.el_existing.innerHTML="link to an existing known "+this.media_neuron.text+" neuron";
        this.el_new.innerHTML="link to a new "+this.media_neuron.text+" neuron";
    }
}


/**************************************************** 
 * TODO: NEED TO restest THE PDN STUFF
 ****************************************************/


/***
 * The PDN owner has set a price for directly questioning the 
 * value that is encrypted.  This is a loose equivalence (case-insensitive if text)
 * check.
 * 
 * Any encrypted data type qualifies for using this check.
 */
 class selector_pdn_query extends anne_selectors {
    constructor($pgui) { 
        super($pgui);
        console.log("%c selector_pdn_query", TALK.bgredbig);
        this.bDECIMALOK = true; 
        this.to_type = TO_TYPE_ENCR_STRING; //we will encrypt their question for no leaking
        this.encrypted = true;
        this.encryption_method = TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY;
        this.ss_seed_relon = this.misc.ss_seed_relon;
        this.el_make_ghost_relon_btn = document.getElementById("make_new_relon_btn2_"+this.ID);
        this.el_make_ghost_relon_btn.addEventListener("click", e=>this.select_existing_value_handler2(e));
    }

    select_existing_value_handler2 = async($e)=> {
        var ge = new gui_extras(this.pgui);
        ge.ss_seed_relon = this.ss_seed_relon;

        ge.callback_funct = async($relon, $ge)=> {
            //INSERT new temp relon into DB with new decrypted value.
            if ($ge!=undefined && $ge!=null && $ge.decrypted!=undefined) {
                var nOBJ = MEMG.getNeuronByTempNid(ge.ss_seed_relon.f);
                var pdn_encrypted_dt =  MEMG.getRelonByTempR(nOBJ.outs, MEM.ENCRYPED_DATA_TYPE.temp_nid);
                if (pdn_encrypted_dt!=null) {
                    var ET = MEMG.getNeuronByTempNid(pdn_encrypted_dt.t);
                    var newToType = parseInt(parseInt(ET.SYS_ENUM_VAL)-20);
                }
                var temp_relon = MEM.makeTempRelon(nOBJ, TYPE_HAS, MEM.PDN_SECRET.nid, newToType, $ge.decrypted, true);
            }

            if (temp_relon) await DB.___update(temp_relon);
            else alert("problem with decryption of msg from ANNODE");

            //play reveal mp3.

            var pgui = $ge.pgui;
            if (pgui) {
                await pgui._parent_pgui.addRelon(temp_relon);
            }
        }

        ge.udf_service_fee = this.misc.udf_service_fee;
        ge.encryption_method=this.encryption_method;
        
        await MEMZ.ez_new_sys_msg(this.fNObj, this.reln_dynamic, this.to_type, this.to_s, ge);
    }

}


/**
 * Simple query for equals.  Any value the user types in is a valid query.
 */
class selector_pdn_valquestion extends selector_pdn_query {
    constructor($pgui) { 
        super($pgui);
        console.log("%c selector_pdn_valquestion", TALK.bgredbig);
        this.el_input = document.getElementById('dynamic_input_'+this.ID);
        ANNE.A.show(this.el_input);
        ANNE.A.setAttribute(this.el_input, "placeholder", "enter the equivalence value to query");
        this.el_input.addEventListener("input", e=>this.inputEventHandlerPDNVALQ(e)); 
        this.reln_dynamic = MEM.PDN_EQUALITY_QUESTION.nid;
    }

    inputEventHandlerPDNVALQ=function($e) {
        var txt = ANNE.A.getValue(this.el_input);
        //console.log("text "+txt);
        if (txt.length) {
            this.to_s = txt;
            ANNE.A.formatSpanStrings(this.el_valid_msg, ['text-danger-lbl', 'text-warning-lbl','text-success-lbl'], ["PDN value", "equals", this.to_s], "<b>query<b> % % %?", true);
            ANNE.A.show(this.el_make_ghost_relon_btn);
        }
        else {
            this.to_s = "";
            this.el_valid_msg.innerHTML="";
            ANNE.A.hide(this.el_make_ghost_relon_btn);
        }
    }
}


/***
 * The PDN owner has set a price for sending an op-based question of the encrypted value.
 * One use case that will use this is selective disclosure in the REAL-ESTATE industry.
 * Sellers want to know if the potential buyer is qualified to spend atleast a certain
 * amount (buy price).   The Lender company would approve the buyer and use an app 
 * to store a PDN on-behalf-of the potential buyer.  The seller, when engaging with the
 * potential buyer, would query the PDN with a >= op asking "is MrSmith approved for atleast
 * 500k or greater?".  
 * 
 * Only NUMBER, DATE, DATETIME and TIME can be used with ops.
 * 
 * PDN_OP_QUESTION relons from PDN neurons will render a pgui that uses this class.
 * 
 */

 class selector_pdn_opquestion extends selector_pdn_query {
    constructor($pgui) { 
        super($pgui);
        console.log("%c selector_pdn_opquestion", TALK.bgredbig);
        this.el_input = document.getElementById('dynamic_input_'+this.ID);

        var dt_rel = MEMG.getRelonByTempR(this.fNObj.outs, MEM.ENCRYPED_DATA_TYPE.temp_nid);
        if (dt_rel==null) {
            this.el_valid_msg.innerHTML = "<b>To use question val there must be an encrypted data type set.</b>";
            if (this.el_input) ANNE.A.hide(this.el_input);
            ANNE.A.removeSelf("ss_div_"+this.ID);
            var ecmsg = document.getElementById('encrypted_reminder_'+this.ID);
            if (ecmsg!=nul) ANNE.A.removeSelf(ecmsg);
            var bgel = ANNE.A.getFirstParentOf(this.el_input, "ijt-bg", false);
            if (bgel) bgel.classList.add("bg-error");
            return;
        }
        else {
            if (dt_rel.t!=MEM.e_number.temp_nid) {
                this.el_valid_msg.innerHTML = "<b>To use question val the encrypted data type must be a number.</b>";
                if (this.el_input) ANNE.A.hide(this.el_input);
                ANNE.A.removeSelf("ss_div_"+this.ID);
                var ecmsg = document.getElementById('encrypted_reminder_'+this.ID);
                if (ecmsg!=nul) ANNE.A.removeSelf(ecmsg);
                var bgel = ANNE.A.getFirstParentOf(this.el_input, "ijt-bg", false);
                if (bgel) bgel.classList.add("bg-error");
                return;
            }
        }

        var valid_ops = MEM.pdnactions_tnids.slice(1);    //all but the first.
        this._SS = new smart_search("ss_div_"+this.ID, this.ID, MEM.XOP.temp_nid, false, "select the question operator");
        this._SS.init_dd_vals(valid_ops);
        this._SS.onValid = this.validSelection;
        this._SS.onInValid = this.invalidSelection;

        this.el_input.addEventListener("input", e=>this.inputEventHandlerOPQ(e)); 
    }

    invalidSelection = function() {
        ANNE.A.hide(this.el_make_ghost_relon_btn);
        ANNE.A.hide(this.el_input);
        this.reln_dynamic = null;
    }

    //show the value input.. and perhaps the submit btn
    validSelection = async($nObj)=> {
        if ($nObj==undefined || $nObj==null) {
            ANNE.A.hide(this.el_make_ghost_relon_btn);
            ANNE.A.hide(this.el_input);
            this.reln_dynamic = null;
            return;
        }
        this.reln_dynamic = $nObj.nid;
        ANNE.A.show(this.el_input);
        this.inputEventHandler(null);
    }
    
    inputEventHandlerOPQ=function($e) {
        var txt = ANNE.A.getValue(this.el_input);
        //console.log("text "+txt);
        var newString = UTILS.inputNumberOnly(txt, this.bDECIMALOK);
        this.el_input.value = newString;
        this.to_s = newString;
        if (newString.length) {
            if (this.reln_dynamic) {
                var relnNOBJ = MEMG.getNeuronByNid(this.reln_dynamic);
                ANNE.A.formatSpanStrings(this.el_valid_msg, ['text-danger-lbl', 'text-warning-lbl','text-success-lbl'], ["PDN secret", relnNOBJ.text, this.to_s], "<b>is the<b> % % %?", true);
                ANNE.A.show(this.el_make_ghost_relon_btn);
            }
        }
        else {
            this.el_valid_msg.innerHTML="";
            ANNE.A.hide(this.el_make_ghost_relon_btn);
        }
    }
}