class img_picker {
    constructor($el, $ID, $tnids, $lbl="") {
        this._el = ANNE.A.__getEl($el);
        this.ID = $ID;
        this.tnids = $tnids;
        this._validCb = null;
        this._inValidCb = null;
        this.lbl = $lbl;
        this.imgs_holder = null;
        this.buildGUI();
    }

    /**
     * @param {function} $c
     */
    set onValid($c) { 
        if (typeof $c ==='function') 
        this._validCb = $c;
    }

    /**
     * @param {function} $c
     */
    set onInValid($c) { 
        if (typeof $c ==='function') this._inValidCb = $c;
    }

    buildGUI = function() {
        this.imgs_holder = ANNE.A.ezEl(this._el, "div", "simple-row thumb-widget");
        for (var i=0; i <this.tnids.length; i++) {
            var imgNOBJ = MEMG.getNeuronByTempNid(this.tnids[i]);
            var afile = ANNE.IMAGES.getAnyValidImgAFILE(imgNOBJ, 40);
            if (url==null) continue;
            var imgbtn = ANNE.A.imgButtonB64(this.imgs_holder, "", afile, "thumb-widget-img", this.selectImg);
            imgbtn.setAttribute("nid", imgNOBJ.nid);
        }
    }
    

    selectImg = async($e)=> {
        var imgs = this.imgs_holder.querySelectorAll("thumb-widget-img");
        for (var i=0; i < imgs.length; i++) {
            imgs[i].classList.remove("picked");
        }
        $e.target.classList.add("picked");
        var nid = $e.target.getAttribute("nid");
        if (nid==undefined) return;
        var imgNOBJ = MEMG.getNeuronByNid(nid);
        this._validCb(imgNOBJ, $e.target);
    }
}


class smart_search {
    constructor($el, $ID, $class_tnid, $bSMARTSEARCH=true, $lbl="", $bTESTFORNEWOK=true, $bLVLSMODE=false) {
        this._el = ANNE.A.__getEl($el);
        this.ID = $ID;
        this.class_tnid = $class_tnid;
        this.bSMARTSEARCH = $bSMARTSEARCH;
        this.lbl = $lbl;
        this.el_btn_holder = null;
        this.nObj = null;
        this.bes = [];
        this.wvs = [];
        this.bLVLSMODE=$bLVLSMODE;
        this.bV1ONLY=false;

        if (this.class_tnid!=null)  {
            this.nObj = MEMG.getNeuronByTempNid(this.class_tnid);

            //unless otherwise overriden, any smart searches will use this
            //neuron as the only valid BE. (parent)
            this.bes = [this.nObj.nid]; //ie, identity.  (will need to be overriden)

            //unless otherwise overridden, any smart searches will use this
            //neuron's WV query (adopts and owner) as the only valid WVS.
            //NOTE: adopts here are not hanai, they are adopted exteneral WVs
            //(signal that you give permission for another worldview to be brought in to your view)
            if (this.nObj.wvBIPASS!=undefined && this.nObj.wvBIPASS==true) this.wvs = [];
            else this.wvs = this.nObj.getWVForQuery();
        }

        //if we want the wvs restriction to apply to the BE enforcement, set this to true.
        //This means the WVs don't matter for the nObj.. just the parent class.. and the
        //WV of the parent class.  This is relevant for identity.  We don't care who owns the identity
        //inst neuron but we do want to know that it is a child of a VALID IDENTITY CLASS which
        //is defined as being any identiy sub-class that is owned by ANNE.
        //This is often used in conjunction with the inbeline nid.. where inbeline would be identity
        //and we'd let the annode search determine if the parent class was in that be line.
        this.bAPPLYWVTOBELINE = false;

        //if this is set we don't look at bes, we only look to see if this neuron is in this be line.
        this.inbeline = 0;     
        this.tnids = [];
        this.bSORTALPHA = true;
        this.search_roots = [];
        this.el_lbl = null;
        this.el_ss = null;
        this.el_datalist = null;
        this.el_ss_btn = null;

        //only used by some smart searches depending on the class definiton
        //and if make_new_inject is set.
        this.el_make_new = null;  

        //turn this off to ensure NO NEW NEURONS are permitted in this use 
        //This can be helpful when doing something like location.. which requires
        //a smart search for the constituent.  If the constituent isn't yet made then
        //we're in a nested rabbit hole.. the outter constituent (highest, or widest)
        //should be first created.. then lower levels from there.
        this.bTESTFORNEWOK = $bTESTFORNEWOK;    
        this.bNEWOK = false;
        this.selected_tnid = null;
        this._validCb = null;
        this._inValidCb = null;
        this._newCb = null;
        this._searchCb = null;
        this.ss_contraint = null;

        this._ss_input_size = 20;

        this.genGui();
        this.makeEvents();
    }


    emptySelection = function() {
        this.selected_tnid = null;
        this.el_ss.value = "";
    }


    destroy = function() {
        if (this._el) ANNE.A.removeSelf(this._el);
    }


    /**
     * If we search the ANNODE for the string and a constraint, 
     * we also pass this constraint to further narrow the search.
     * 
     * Example:  The SS is for picking a city IN a country.  
     * To search for a city in the USA we would have a constraint of 
     * reln_nid: "constituent of"  and to_nid: "Texas".
     *
     * Note: we would need more complex handling if we wanted to catch 
     * complex locations that were listed with city NOT under state ...
     * since that pattern would be reln_nid: "constituent of",  to_nid: "USA", gens:*.
     * We could then find Dallas, North Texas, Texas.
     * 
     * @param {string} $reln_nid - nid long string for the reln
     * @param {string} $to_nid   - nid long string for the to
     * @param {int} $gens    - gens for the constraint.
     */  
    setConstraint($reln_nid, $to_nid, $gens=1) {
        this.ss_contraint = {reln_nid:$reln_nid, to_nid:$to_nid, $gens:$gens};
    }


    /**
     * Sometimes we have a text value from an external data source that 
     * we need to map to a real value.  We set that as the default.
     * If we do not find it we can create it new according to the proper
     * callback 
     * 
     * @param {string} $textVal
     */
    setDefaultValue($textVal) {
        ANNE.A.setValue(this.el_ss, $textVal);
        this.smartListInput(null);
    }

    hideSearch() {
        ANNE.A.hide(this.el_ss_btn);
        ANNE.A.hideParent(this.el_ss_btn);
    }


    /**
     * If not set we use the standard SS search.
     * If set we call back out to manage a more complex search.
     * @param {function} $c
     */
    set searchCallback($c) {
        this._searchCb = $c;
    }

    /**
     * @param {function} $c
     */
    set onValid($c) { 
        if (typeof $c ==='function') 
        this._validCb = $c;
    }

    /**
     * @param {function} $c
     */
    set newCallback($c) { 
        if (typeof $c ==='function') {
            this._newCb = $c;
            if (this.bTESTFORNEWOK==true) {
                this.bNEWOK = true;
                this.el_make_new = document.createElement("button");
                this.el_make_new.classList = "anne-btn2 btn-blue-invert btn-stpd-xsm";
                this.el_make_new.innerHTML="make new instance";
                this.el_make_new.addEventListener("click", e=>{
                    ANNE.A.hide(this.el_make_new);
                    this._newCb(e);
                });
                this.el_make_new.style.display="none";
                this.el_btn_holder.append(this.el_make_new);
            }
        }
    } 

    /**
     * @param {function} $c
     */
    set onInValid($c) { if (typeof $c ==='function') this._inValidCb = $c;}
    
    /**
     * @param {array} $bes
     */
    set searchBes($bes) { this.bes = $bes; }

    /**
     * @param {array} $wvs
     */
    set searchWVs($wvs) { this.wvs = $wvs; }

    /**
     * @param {boolean} $awvtb
     */
    set applyWvToBeLine($awvtb=true) { this.bAPPLYWVTOBELINE = $awvtb; }

     /**
     * @param {int} $ibl
     * 1 for in, 0 for not relevant.
     */
    set IBL($ibl=0) { this.inbeline = $ibl; }

    /**
     * @param {string} $txt
     */
    set setMakeText($txt) { 
        if (this.el_make_new==null) return;
        this.el_make_new.innerHTML=$txt;
    }

    showMakeBtn=function() { ANNE.A.show(this.el_make_new);}
    hideMakeBtn=function() { ANNE.A.hide(this.el_make_new);}
    
    /**
     * Pre-select a value and lock the widget.
     * 
     * @param {ing} $selectedTnid
     */
    disableChanges = function($selectedTnid) {
        this.selected_tnid = $selectedTnid;
        this.el_make_new.setAttribute("disable", true);
        this.el_ss.setAttribute("disable", true);
    }


    genGui() {
        this.el_data_row = document.createElement("div");
        this.el_data_row.classList = "simple-row";
        this._el.append(this.el_data_row);

        var col1=document.createElement("div");
        col1.classList="smart-search-div";

        this.el_ss = document.createElement("input");
        if (this.lbl!="") this.el_ss.setAttribute("placeholder", this.lbl);

        this.el_ss.setAttribute("autocomplete", "off");
        this.el_ss.setAttribute("type", "text");
        this.el_ss.setAttribute("name", this.nObj.bestNameHTML());
        this.el_ss.setAttribute("id", "ss_"+this.ID+"_"+this.class_tnid);
        this.el_ss.setAttribute("list", "ss_"+this.ID+"_"+this.class_tnid+"_list");
        this.el_ss.setAttribute("size", this._ss_input_size);
        this.el_ss.classList="ss-widget";
        
        col1.append(this.el_ss);
        this.el_data_row.append(col1);

        //we will append options to here as we pull them in from searches..
        //and also when we do any prepop.
        this.el_datalist = document.createElement("datalist");
        this.el_datalist.setAttribute("id", "ss_"+this.ID+"_"+this.class_tnid+"_list");
        this.el_data_row.append(this.el_datalist);

        this.el_btn_holder=document.createElement("div");
        this.el_btn_holder.classList="simple-col f2";

        this.el_ss_btn = document.createElement("button");
        this.el_ss_btn.setAttribute("id", "ss_"+this.ID+"_"+this.class_tnid+"_btn");
        this.el_ss_btn.classList="anne-btn2 btn-yellow-sq btn-stpd-sm ss-dyno";
        this.el_ss_btn.innerHTML="search ANNE";
        this.el_ss_btn.setAttribute("display_restore", "inline-block");
        this.el_ss_btn.style.display="none";

        this.el_btn_holder.append(this.el_ss_btn);
        this.el_data_row.append(this.el_btn_holder);
    }

    getVal() { 
        if (this.selected_tnid!=null && this.selected_tnid!=null) {
            var selectedNOBJ = MEMG.getNeuronByTempNid(this.selected_tnid);
            return selectedNOBJ.nid;
        }
        return this.el_ss.value;
    }
    getValue() { 
        return this.getVal();
    }
    

    /**
     */
    makeEvents() {
        this.el_ss.addEventListener('input', e=>this.smartListInput(e));
        if (this.bSMARTSEARCH) {
            this.el_ss_btn.addEventListener('click', e=>this.smartListSearch(e));
        }
    }


    /**
     * We are pre-loading a value into our smart search.
     * We want to snag an item if it matches OR auto-launch the ANNE search
     */
    triggerSelectOrAutoSearch=async($defaultVal, $bDISABLEINPUT=true)=> {
        console.log("doing (triggerSelectOrAutoSearch)");
        ANNE.A.setValue(this.el_ss, $defaultVal);
        if ($bDISABLEINPUT==true) {
            this.el_ss.setAttribute("disabled", true);
        }

        for (var j = 0; j < this.el_datalist.options.length; j++) {
            if (this.el_datalist.options[j].value.toLowerCase()==$defaultVal) {
                bFOUND = true;
                if (this.el_make_new!=null) this.el_make_new.display="none";
                this.selected_tnid = parseInt( this.el_datalist.options[j].getAttribute("temp_nid") );
                break;
            }
        }

        if (this.selected_tnid==null) {
            await this.smartListSearch(null);
        }
    }


    /**
     * Smart list input detected.
     * 
     * User has typed into the combo box or selected an item.
     */
     smartListInput($e=null) {
        var bFOUND=false;
        this.selected_tnid = null;
        var textValue = this.el_ss.value.toLowerCase().trim();
        for (var j = 0; j < this.el_datalist.options.length; j++) {
            if (this.el_datalist.options[j].value.toLowerCase()==textValue) {
                bFOUND = true;
                if (this.el_make_new!=null) this.el_make_new.display="none";
                this.selected_tnid = parseInt( this.el_datalist.options[j].getAttribute("temp_nid") );
                break;
            }
        }

        if (textValue=="") {
            ANNE.A.hide(this.el_ss_btn);
            ANNE.A.hide(this.el_make_new);
            return;
        }

        //some DDs have a limited list and that's the end of it.
        //no searching the ANNODE for more and no new data.
        //On these types of lists we already chased the values and loaded them
        //into the app because they were managable and made sense to do so.
        //ie, ~ < 200 items.
        //For something like keyword or location, we could have hundreds of thousands.
        if (this.bSMARTSEARCH==true) {
            if (bFOUND==true)  ANNE.A.hide(this.el_ss_btn);
            else {
                if (this.search_roots.length) {
                    for (var s=0; s < this.search_roots.length; s++) {
                        
                        //if we have any search roots that match the 0 slot of this
                        //new search string, we've already gotten all we will get.
                        if (this.el_ss.value.indexOf(this.search_roots[s])===0) {
                            ANNE.A.hide(this.el_ss_btn);
                            return;
                        }
                    }
                }

                //we haven't searched yet with this root string.
                //we may find valid results at the other side of the ANNODE
                //rainbow.
                ANNE.A.setHTML(this.el_ss_btn, "search ANNE for "+textValue, true);
            }
        }

        //if we have a selected_tnid, notify the outside world.
        //typically this will mean turning on a valid submit button to 
        //create a relon.
        if (this.selected_tnid!=null) {
            if (this._validCb!=null) {
                var selectedNOBJ = MEMG.getNeuronByTempNid(this.selected_tnid);
                return this._validCb(selectedNOBJ);
            }
            else console.warn("no valid callback set");
        }
        else {
            if (this._inValidCb!=null) {
                return this._inValidCb(textValue); //pass the partial back out.
            }
            else console.warn("no valid invalid callback set");
        }

        return;
    }


    /**
     * SS widget search of ANNE hypergraph for text value.
     * 
     * @param {$e} - event
     * @param {$bOVDERRIDECB} - overrides the search callback (if set) to use default SS text search
     */
     smartListSearch=async($e=null, $bOVDERRIDECB=false)=> {
        var val = this.el_ss.value;
        val = val.trim();
         
        if (this._searchCb!=null && $bOVDERRIDECB==false) {
            this._searchCb(val)
            return;
        }

        ANNE.A.show("loading");
        ANNE.A.hide(this.el_ss_btn);

        if (this.bes.length && this.bes[0]==MEM.identity.nid) {
            var relons = await ANNE.API.queryForIdentity(val);
        }
         
        
        else {
            var relons = await ANNE.API.queryForText(val, this.wvs, this.bes, false, this.bAPPLYWVTOBELINE, this.inbeline); 
        }
         
        var new_tnids = MEM.extractTempNidsFromRelonsFrom(relons);
        
        var redo=false;
        var rez=0;

        //build valid tnids for this search widget
        for (var t=0; t < new_tnids.length; t++) {
            var new_tnid = new_tnids[t];
            if (this.tnids.indexOf(new_tnid)!==-1) continue;
            this.tnids.push(new_tnid);
            redo=true;
            rez+=1;
        }
        this.search_roots.push(val);

        //new results, redo the widget datalist
        if (redo==true) {
            var s = "s";            //TODO: use TALK plural
            if (rez==1) s = "";
            //if (this.el_lbl!=null) {
                //this.el_lbl.innerHTML="<span class='text-success-lbl'>"+rez+" new "+this.nObj.text+s+" found</span>";
            //}
            ANNE.A.empty(this.el_datalist);
            if (this.bLVLSMODE==false) this.init_dd_vals(this.tnids, this.bSORTALPHA);
            else this.init_dd_vals_with_lvls(this.tnids, this.bSORTALPHA, this.bV1ONLY);
        
            //re-run the input event as-if they typed new data.
            this.smartListInput(null);
        }

        //show the add new btn
        //we will do this only if applicable via the this.make_new_inject
        //set.  For now, just turn it on (testing)
        else if (this.bNEWOK==true) {
            ANNE.A.show(this.el_make_new);
            this._inValidCb(val, true, 0);
        }
        else {
            this._inValidCb(val, true, 0);
        }
        ANNE.A.hide("loading");
        return;
    }


    /**
    * Redo the DD
    * 
    * @param {array} $tnids - an array of neuron tnids we want in the valid selections
    * @param {boolean} $bSORTALPHA - flag to sort selections by alpha
    */    
    redoDD($tnids, $bSORTALPHA=true) {
        ANNE.A.empty(this.el_datalist);
        this.el_ss.value = "";
        this.init_dd_vals($tnids, $bSORTALPHA);
    }
    

    /**
    * Build the dd with the known children in local mem.
    * 
    * @param {Array} $tnids - an array of neuron tnids we want in the valid selections
    * @param {Boolean} $bSORTALPHA - flag to sort selections by alpha
    */
    init_dd_vals($tnids, $bSORTALPHA=true) {
        if ($tnids==undefined || $tnids==null) return;
        this.tnids = $tnids;
        this.bSORTALPHA=$bSORTALPHA;
        
        if (this.bSORTALPHA==true) {
            this.tnids = MEM.sortTnidsAlpha(this.tnids);
        }


        var unique_tnids = [];
        for (var t=0; t < this.tnids.length; t++) {
            if (unique_tnids.indexOf(this.tnids[t])!=-1) continue;
            unique_tnids.push(this.tnids[t]);
        }

        this.tnids = unique_tnids;

        for (var t=0; t < this.tnids.length; t++) {
            var nObj = MEMG.getNeuronByTempNid(this.tnids[t]);
            if (ANNE.SETTINGS.debug()==true) console.log("t:"+t+"  %c"+nObj.text, ANNE.TALK.bggreen);
            var option = document.createElement("option");
            option.setAttribute("value", nObj.bestSelectDisplay("", true, true));
            option.setAttribute("temp_nid", nObj.temp_nid);
            this.el_datalist.append(option);
        }
        
        this.el_ss.setAttribute("title", this.tnids.length+" options");
    }


    /**
     * Tnids should be the tops of the tree.
     * 
     * @param {Array} $tnids - an array of neuron tnids we want in the valid selections
     * @param {Boolean} $bSORTALPHA - flag to sort selections by alpha
     * @param {Boolean} $bV1ONLY - only show present tense vbs.
     * @returns 
     */
    init_dd_vals_with_lvls = function ($tnids, $bSORTALPHA=true, $bV1ONLY=false) {
        this.bV1ONLY=$bV1ONLY;
        if ($tnids==undefined || $tnids==null) return;
        this.tnids = $tnids;
        this.bSORTALPHA=$bSORTALPHA;
        if (this.bSORTALPHA==true) this.tnids = MEM.sortTnidsAlpha(this.tnids);

        for (var n=0; n < this.tnids.length; n++) {
            var nObj = MEMG.getNeuronByTempNid(this.tnids[n]);
            
            //we only want V1 vbs.
            if (this.bV1ONLY == true) {
                var rel_vbForm = MEMG.getBeRelon(nObj.outs, MEM.vb_form.temp_nid);
                if (rel_vbForm != null) {
                    if (rel_vbForm.t != MEM.vb_v1.temp_nid) {
                        console.log("skipping non v1");
                        continue;
                    }
                }
            }

            var downline = [];
            nObj.getAllDownlineChildren(downline, 0, false, false, true, false);
            var opt = document.createElement("option");
            opt.setAttribute("value", nObj.bestSelectDisplay("", true, true));
            opt.setAttribute("temp_nid", nObj.temp_nid);
            opt.classList = "option-top";

            this.el_datalist.append(opt);

            for (var a = 0; a < downline.length; a++) {
                var childNOBJ = downline[a];

                //we only want v1 vbs.
                if (this.bV1ONLY == true) {
                    var rel_vbForm = MEMG.getBeRelon(childNOBJ.outs, MEM.vb_form.temp_nid);
                    if (rel_vbForm != null) {
                        if (rel_vbForm.t != MEM.vb_v1.temp_nid) {
                            console.log("skipping non v1");
                            continue;
                        }
                    }
                }

                var indent = "┖─";//&#9494;";
                var space = ' '; //&#160;&#160;
                if (childNOBJ.be_lvl == 0) space = "";
                else {
                    for (var i = 0; i < childNOBJ.be_lvl - 1; i++) { space += ' '; } //&#160;&#160;
                    space = space + indent;
                }
                var opt2 = document.createElement("option");
                opt.setAttribute("value", nObj.bestSelectDisplay(space, true, true));
                opt.setAttribute("temp_nid", nObj.temp_nid);
                this.el_datalist.append(opt2);
            }
        }
    }
}