/**
 * Basically, an array of objects, and a corresponding map to help manage their
 * addition/tracking/grouping
 */
class arraymap {
    constructor() {
        this.arr = [];
        this.map = new Object();
        this.mapKey = "";
        this.arr_other = [];

        this.secondary_mapKey = "";
        this.secondary_map = null;
        this.secondary_mapKey_forceLowerCase = false;
    }

    //good enough...
    copy = function($arraymap) {
        this.mapKey = $arraymap.mapKey;
        this.secondary_mapKey = $arraymap.secondary_mapKey;

        var keys = Object.keys($arraymap.arr);
        for (var k=0; k < keys.length; k++) {
            this.arr[keys[k]] = $arraymap.arr[ keys[k]]
        }
        if ($arraymap.secondary_map!=null) {
            var keys2 = Object.getKeys($arraymap.arr_other);
            for (var k=0; k < keys2.length; k++) {
                this.arr_other[keys2[k]] = $arraymap.arr_other[ keys2[k]]
            }
        }
    }


    setMapKey = function($mk) {
        this.mapKey = $mk;
    }

    setSecondaryIndex = function($2ndkey, $bMAKELOWER=false) {
        this.secondary_mapKey = $2ndkey;
        this.secondary_mapKey_forceLowerCase = $bMAKELOWER;
        this.secondary_map = new Object();
    }

    addArray = function($inputArr) {
        for(var i=0; i<$inputArr.length; i++) {
            this.addU($inputArr[i]);
        }
    }

    contains = function($mapKey) {
        if (this.map[$mapKey]==undefined) return false;
        return true;
    }

    getKeys = function() {
        return Object.getKeys(this.map);
    }

    get = function($mapKey) {
        if (this.map[$mapKey]!=undefined) return this.map[$mapKey];
        return null;
    }

    get2 = function($mapKey2) {
        if (this.secondary_mapKey=="") {
            console.warn("can't use get2 without a secondary index set!");
        }
        if (this.secondary_map[$mapKey2]==undefined) return null;
        return this.secondary_map[$mapKey2];
    }

    get2_partial = function($mapKey2) {
        if (this.secondary_mapKey=="") {
            console.warn("can't use get2 without a secondary index set!");
        }
        var txt =$mapKey2;
        if (this.secondary_mapKey_forceLowerCase==true) txt = $mapKey2.toLowerCase();
        var matches = [];
        var keys = Object.keys(this.secondary_map);
        for (var k=0; k < keys.length; k++) {
            if (keys[k].indexOf(txt)==0 && keys[k].length>txt.length){ 
                matches.push( this.secondary_map[ keys[k]]);
            }
        }
        return matches;
    }


    addIndex2 = function($pkOrObj, $val) {
        if (this.secondary_mapKey=="") {
            console.warn("can't use addIndex2 without a secondary index set!");
        }
        if (typeof pk==="string") {
            var obj = this.get($pkOrObj);
            if (obj==null) return null;
            this.secondary_map[$val]=obj;
        }
        else {
            if ($val!=$pkOrObj[this.secondary_mapKey]) {
                console.log("houston we have a problem!");
            }
            this.secondary_map[$val]=$pkOrObj;
        }
    }

    quickAddMK = function($obj) {
        if (this.mapKey=="") {
            console.warn("U can't use quick add without a quickAddMK set.");
            return;
        }
        if (this.map[$obj[this.mapKey]]==undefined) {
            this.map[$obj[this.mapKey]]=$obj;
            this.arr.push($obj);
        }
    }

    quickAdd = function($obj) {
        this.arr.push($obj);
    }
    
    addUnique = function($obj, $mapKeyVal) {
        if (this.map[$mapKeyVal]==undefined) {
            this.map[$mapKeyVal]=$obj;
            this.arr.push($obj);
            if (this.secondary_map!=null) {
                var val2 = $obj[this.secondary_mapKey];
                if (val2!=undefined) {
                    if (this.secondary_mapKey_forceLowerCase==true) {
                        this.addIndex2($obj, val2.toLowerCase());
                    }
                    else this.addIndex2($obj, val2);
                }
            }
            return true;
        }
        else {
            if (this.secondary_map!=null) {
                var obj = this.map[$mapKeyVal];
                var val2 = $obj[this.secondary_mapKey];
                if (this.secondary_mapKey_forceLowerCase==true) {
                    this.addIndex2(obj, val2.toLowerCase());
                }
                else this.addIndex2(obj, val2);
            }
        }
        return false;
    }

    /**
     * Use this when mapKey is set.
     * @param {*} $obj 
     */
    addU = function($obj) {
        if (this.mapKey=="") {
            console.warn("must have map key set to use addU");
            return;
        }
        if (this.map[$obj[this.mapKey]]==undefined) {
            this.map[$obj[this.mapKey]]=$obj;
            this.arr.push($obj);
            if (this.secondary_map!=null) {
                var val2 = $obj[this.secondary_mapKey];
                if (val2!=undefined) {
                    if (this.secondary_mapKey_forceLowerCase==true) {
                        this.addIndex2($obj, val2.toLowerCase());
                    }
                    else this.addIndex2($obj, val2);
                }
            }
            return true;
        }

        //still add secondary key if relevant.
        else {
            if (this.secondary_map!=null) {
                var obj = this.map[$mapKeyVal];
                var val2 = $obj[this.secondary_mapKey];
                if (val2!=undefined) {
                    if (this.secondary_mapKey_forceLowerCase==true) {
                        this.addIndex2(obj, val2.toLowerCase());
                    }
                    else this.addIndex2(obj, val2);
                }
            }
        }
        return false;
    }
    
    removeNoKey = function($index) {
        this.arr.splice($index, 1); 
    }

    remove = function($mapKey, $prop="") {
        if ($prop!="") this.prop = $prop;
        if (this.map[$mapKey]!=undefined) {
            delete this.map[$mapKey];
            for (var i=0; i < this.arr.length; i++) {
                if (this.arr[i][this.prop]==$mapKey) {
                    this.arr.splice(i, 1);
                    return;
                }
            }
        }
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $objkey 
     * @returns 
     */
    addArrAM = function($obj, $objkey="txid") {
        if (this.mapKey=="") {
            console.warn("must have map key set to use addArrAM");
            return;
        }
        var mk = $obj[this.mapKey];
        if (this.map[mk]==undefined) {
            this.map[mk]=new arraymap();
            if (this.map[mk].addUnique($obj, $objkey)==true) {
                this.arr.push($obj);
                return true;
            }
            return false;
        }
        if (this.map[mk].addUnique($obj, $objkey)==true) {
            this.arr.push($obj);
            return true;
        }
        return false;
    }


    addArrObj = function($obj, $mapKey) {
        if (this.map[$mapKey]==undefined) {
            this.map[$mapKey]=[$obj];
            this.arr.push($obj);
            return true;
        }
        this.map[$mapKey].push($obj);
        this.arr.push($obj);
        return false;
    }

    sortArrDesc = function($prop) {
        if (this.arr.length==0) return;
        this.arr.sort(function($a, $b) {
            if ($a[$prop] < $b[$prop]) return 1;
            else if ($a[$prop] > $b[$prop]) return -1;
            return 0;
        })
    }

}