const MEDIA_AUDIT_NOTRUN = 0;
const MEDIA_AUDIT_PASSED = 1;
const MEDIA_AUDIT_PASSED_W_NEWDATA = 2;
const MEDIA_AUDIT_MISSING_DATA = -2; //missing data
const MEDIA_AUDIT_CONFLICTING_TYPE = -3; 
const MEDIA_AUDIT_CONFLICTING_SIZE = -4;
const MEDIA_AUDIT_FINGER_DOES_NOT_MATCH = -5;

class anne_file {
    constructor(){
        this.size = 0;
        this.mimetype = "";     //from the annode cache add or pull
        this.mimetype2 = "";    //from the blob pulled from the fetch
        this.mtNOBJ = null;
       
        this.stored_finger = null;
        this.live_finger = null;

        this.url = "";
        this.keywords = []; 
        this.audit = 0;         //1 for passed, //-1 for failed, //0 for not run, 
        this.fileNOBJ=null;
        this.tie_rel = null;
        this.b64data = null;    //we pull this from the files dir now localhost (not annode b64)
        this.ext = "";
        this.filename = "";
        this.bLOADED = false;
        
        this.relativepath = "";
        this.relativeInternalPath = ""; //located on annode (in /imgs, /mp3 etc)
    
        this.last_audio = null;
    }

    getFinger = function() {
        if (this.live_finger!=null) return this.live_finger;
        if (this.stored_finger!=null) return this.stored_finger;
        if (this.fileNOBJ!=null) return this.nid;
        return null;
    }

    setNOBJ = function($nObj) {
        this.fileNOBJ = $nObj;    
    }
    

    /**
     * 
     * @param {*} $nObj 
     * @returns 
     */
    setFromNeuronAndLoad = async($nObj)=>{
        if ($nObj.outs.length<3) {
            await ANNE.API.queryForOuts($nObj.nid, true, [0,1,2,3,4,5,6,7,8,9]);
        }

        this.setFromNeuron($nObj);

        if (this.url=="" || this.mimetype=="") return;

        var nid = "";
        if (this.fileNOBJ!=null) nid = this.fileNOBJ.nid;

        if (this.ext=="") this.ext = this.extractExtFromUrl(this.url);

        var resp = await ANNE.API.getAndANNODECacheTheFile(this.url, this.ext, nid);
        if (resp.status=="bad") return;
        if (resp.finger!=undefined) {
            this.live_finger = resp.finger;
        }
        this.b64data = resp.b64data;
        this.audit = MEDIA_AUDIT_PASSED;
        this.filename = resp.filename;
        this.mimetype2 = resp.mimetype2;
        this.bLOADED=true;  
        return;
    }


    /**
     * This is a file on the annode in one of the app directories.
     * We want to load it.
     * 
     * @param {*} $nObj 
     * @param {*} $realitveInternalpath 
     * @returns 
     */
    setFromLocalRelativePathAndLoad=async($nObj, $realitveInternalpath="")=> {
        if ($nObj==null) return;
        if (this.relativeInternalPath=="" && $realitveInternalpath=="") return;
        if (this.relativeInternalPath=="") {
            this.relativeInternalPath = $realitveInternalpath;
        }
        
        this.setNOBJ($nObj);

        var resp = await ANNE.API.loadLocalOnlyFile(this.relativeInternalPath, this.ext, $nObj.nid);
        if (resp.status!=undefined && resp.status=="bad") return;
        if (resp.finger!=undefined) this.live_finger = resp.finger;
        this.b64data = resp.b64data;
        this.audit = MEDIA_AUDIT_PASSED;
        this.filename = resp.filename;
        this.mimetype2 = resp.mimetype2;
        this.bLOADED=true; 
        return;
    }



    /**
     */
    setManually=function($finger="", $url="", $size, $mimetype="", $mtNOBJ=null){
        this.size = $size;
        this.mimetype = $mimetype;
        this.mtNOBJ = $mtNOBJ;
        if ($finger!=undefined) this.live_finger = $finger;
        this.url = $url;
        this.ext = this.extractExtFromUrl(this.url);
    }


    /**
     * 
     * @param {anne_neuron} $nObj 
     * @returns 
     */
    setFromNeuron = function($nObj) {
        if ($nObj==null) return;

        //$nObj.printRelons();
        
        var rel_fp = MEMG.getRelonFromWithRToType($nObj.outs, TYPE_HAS, MEM.fileFingerPrint.temp_nid, TO_TYPE_FILEHASH);
        if (rel_fp!=null) {
            this.stored_finger=rel_fp.to_s;
        }
        else {
            //calculate it then.. dummy face.
            console.log("missing fingerprint in "+$nObj.nid+" "+$nObj.text);
        }
        var rel_url = MEMG.getRelonFromWithRToType($nObj.outs, TYPE_HAS, MEM.dataUrl.temp_nid, TO_TYPE_URL);
        if (rel_url!=null) {
            this.url=rel_url.to_s;
        }
        
        //neurons that are shipped on the annode already, pre-existing.
        //no antor needed, tho that is also fine.
        var relativeInternalPath = MEMG.getRelonFromWithRToType($nObj.outs, TYPE_HAS, MEM.dataRelativePath.temp_nid, TO_TYPE_URL);
        if (relativeInternalPath!=null) this.relativeInternalPath=relativeInternalPath.to_s;

        var rel_fs = MEMG.getRelonFromWithRToType($nObj.outs, TYPE_HAS, MEM.fileSize.temp_nid, TO_TYPE_NUMBER);
        if (rel_fs!=null) this.size=rel_fs.to_s;

        var rel_mt = MEMG.getRelonFromWithRToType($nObj.outs, TYPE_HAS, MEM.mimetype.temp_nid, TO_TYPE_ANNE);
        if (rel_mt!=null) {
            this.mtNOBJ = MEMG.getNeuronByTempNid(rel_mt.t);
            this.mimetype=this.mtNOBJ.text;
            this.extractExtFromUrl(this.url);
        }
        this.fileNOBJ = $nObj;
    }

        
    extractExtFromUrl=function($url) {
        var ext =  $url.split('.').pop();
        if (ext.indexOf("?")!==-1) {        //?w=x blah blah
            var Q = ext.indexOf("?");
            ext = ext.substring(0,Q);
        }
        return ext;
    }


    /**
     * make ghost img (ready for upgrade to ANNE)
     * include tie from initiating fromNOBJ
     * @returns {anne_neuron}
     */
    makeGhost = async($parentImgClassNObj=null, $fromNOBJ=null, $type=null, $reln_nid="", $name_text="")=> {
        if (this.url=="") return;

        var parentClass = $parentImgClassNObj;
        if (parentClass==null) parentClass = MEM.neuronImg;
        var new_rels = [];

        var name = "";

        //extract extension from url.
        //if no url, extract extension from mimetype.
        var ext = this.extractExtFromUrl(this.url);

        //this.filename  we should use filetype here.
        if ($fromNOBJ==null) {
            if ($name_text=="") {
                alert("we have no means of naming this new img neuron");
                return;
            }

            //new file name standard.  neuoron.text(img).ext
            //we should allow for better names of these imgs.
            else if (ext!=null && ext.length>0) {
                name = $name_text+"(img)."+ext;
            }
            else name = $name_text+" (img)";
        }
        else name = $fromNOBJ.shortName()+" (img)";

        console.log(name);
        
        var nOBJ = await MEM.makeGhostNObj(USER._userNObj.nid, NTYPE_INST, name, parentClass, true, true);
        MEM.makeTempRelon(nOBJ, TYPE_BE, MEM.name.nid, TO_TYPE_STRING, name, true);
        
        if(this.live_finger!=null) {
            var rel_finger = MEM.makeTempRelon(nOBJ, TYPE_HAS, MEM.fileFingerPrint.nid, TO_TYPE_FILEHASH, this.live_finger, true);
            MEMZ.ez_setNARRPtrsForNew(rel_finger); 
            new_rels.push(rel_finger);    
        }
        
        var rel_url = MEM.makeTempRelon(nOBJ, TYPE_HAS, MEM.dataUrl.nid, TO_TYPE_URL, this.url, true);
        MEMZ.ez_setNARRPtrsForNew(rel_url); 
        new_rels.push(rel_url);

        //optional size
        if (this.size!=null) {
            var filesize_relon = MEM.makeTempRelon(nOBJ, TYPE_HAS, MEM.fileSize.nid, TO_TYPE_NUMBER, this.size, true);
            MEMZ.ez_setNARRPtrsForNew(filesize_relon); 
            new_rels.push(filesize_relon);
        }

        //optional mimetype
        if (this.mtNOBJ!=null) {
            var filesize_mt = MEM.makeTempRelon(nOBJ, TYPE_HAS, MEM.mimetype.nid, TO_TYPE_ANNE, this.mtNOBJ.nid, true);
            MEMZ.ez_setNARRPtrsForNew(filesize_mt); 
            new_rels.push(filesize_mt);
        }

        //relon to tie this img to something.
        if ($fromNOBJ!=null && $type!=null && $reln_nid!="") {
            var tie_relon = MEM.makeTempRelon($fromNOBJ, $type, $reln_nid, TO_TYPE_ANNE, nOBJ.nid);
            MEMZ.ez_setNARRPtrsForNew(tie_relon); 
            new_rels.push(tie_relon);
            this.tie_rel = tie_relon;
        }

        this.fileNOBJ = nOBJ;

        await GHOSTDATA.localGhostTheRelons(new_rels);
        return nOBJ;
    }


    /**
     * if we have loaded MEM then we could easily get these..
     * also, we can build a MIMETYPE MOD (like momth, lang, ascii etc)
     * however, in some mini-apps we don't have mem.. so we need to go the long road here.
     * @param {*} $mt 
     * @returns 
     */
    getANNEParentFromMIMETYPE=function($mt, $ext) {
        $ext = $ext.toLowerCase()
        if ($mt=="audio/aac") return MEM.neuronImg;

        //not a big deal.. just capture a few of these if possible.
        if ($mt=="application/octet-stream") {
            if ($ext=="png" || $ext=="jpg" || $ext=="jpeg" || $ext=="bmp" || $ext=="psd" || $ext=="eps") return MEM.neuronImg;
            if ($ext=="mp3" || $ext=="wav") return MEM.neuronAudio;
            if ($ext=="mp4" || $ext=="avi" || $ext=="mov" || $ext=="mpeg" || $ext=="wmv") return MEM.neuronVideo;
            return MEM.fileX;
        }
        if ($mt=="image/bmp") return MEM.neuronImg;
        if ($mt=="application/x-cdf") return MEM.fileX;
        if ($mt=="text/css") return MEM.fileX;
        if ($mt=="image/jpeg") return MEM.neuronImg;
        if ($mt=="audio/mpeg") return MEM.neuronAudio;
        if ($mt=="text/javascript") return MEM.fileX;
        if ($mt=="application/json") return MEM.fileX;
        if ($mt=="audio/mp4") return MEM.neuronAudio;
        if ($mt=="video/mpeg") return MEM.neuronVideo;
        if ($mt=="application/msword") return MEM.fileX;
        if ($mt=="application/vnd.oasis.opendocument.spreadsheet") return MEM.fileX;
        if ($mt=="application/vnd.oasis.opendocument.text") return MEM.fileX;
        if ($mt=="audio/ogg") return MEM.neuronAudio;
        if ($mt=="video/ogg") return MEM.neuronVideo;
        if ($mt=="font/otf") return MEM.fileX;
        if ($mt=="image/png") return MEM.neuronImg;
        if ($mt=="application/pdf") return MEM.fileX;
        if ($mt=="image/svg+xml") return MEM.neuronImg;
        if ($mt=="application/x-shockwave-flash") return MEM.fileX;
        if ($mt=="application/x-tar") return MEM.fileX;
        if ($mt=="image/tiff") return MEM.neuronImg;
    }


    /**
     */
    printDebug = function() {
        if (ANNE.SETTINGS.bCONSOLE_DEBUG==false) return;
        if (this.fileNOBJ!=null) console.log("for img nid:"+this.fileNOBJ.nid);
        if (this.live_finger!=null) console.log("live finger:"+this.live_finger);
        if (this.stored_finger!=null) console.log("live finger:"+this.stored_finger);
        if (this.url) console.log("url:"+this.url);
        if (this.size) console.log("size:"+this.size);
        if (this.mimetype) console.log("type:"+this.mimetype);
    }


    /**
     * REDO DO THIS IF THE USER WANTS TO AUDIT A PUBLIC ANNODE'S FINGERPRINTING.
     * FOR LOCAL IT MAKES NO SENSE BECAUSE THEIR ANNODE PROVIDED THE FINGER.
     */
    auditFile = async()=> {
        
        //if (this.stored_finger==null && this.live_finger==null) {  //must have finger to audit
            //this.audit = MEDIA_AUDIT_MISSING_DATA;
            //return false;
        //}
        if (this.url=="") {     //must have url to audit
            this.audit = MEDIA_AUDIT_MISSING_DATA;
            this.printDebug();
            return false;
        }
        
        var nid = "";
        if (this.fileNOBJ!=null) nid = this.fileNOBJ.nid;

        //if we cached this, it should be good.
        var afile = ANNE.A2A.getFileByUrlOrNid(this.url, nid);
        if (afile!=null && this.live_finger!=null) {
            if (this.live_finger!=this.stored_finger) {
                console.warn("audit blunder "+this.live_finger+" vs "+this.stored_finger);
                //still pass it in testing.
                this.printDebug();
            }
            this.audit = MEDIA_AUDIT_PASSED;
            return afile;
        }
        
        if (this.ext==null) {
            if (this.url!="") {
                this.ext = this.extractExtFromUrl(this.url);
            }
        }

        var resp = await ANNE.API.getAndANNODECacheTheFile(this.url, this.ext, nid);
        if (resp.status=="bad") return false;
        
        this.b64data = resp.b64data;
        this.mimetype = resp.mimetype2;
        if (this.mimetype==undefined) this.mimetype =resp.mimetype;
        if (this.mimetype==undefined) this.mimetype="";

        if (resp.finger!=null) {
            this.live_finger = resp.finger;
        }
        if (this.stored_finger!=null) {
            if (this.live_finger!=this.stored_finger) {
                console.warn("audit blunder "+this.live_finger+" vs "+this.stored_finger);
                //still pass it in testing.
                this.printDebug();
            }
            this.audit = MEDIA_AUDIT_PASSED;
        }
        this.filename = resp.filename;
        this.bLOADED = true;
        ANNE.A2A.addToCache(this);
    }
}


var IMAGES = {};
IMAGES.TMDB_poster_base = "https://image.tmdb.org/t/p/w185";
IMAGES.TMDB_profile_base = "https://image.tmdb.org/t/p/w185";
IMAGES.TMDB_backdrop_base = "https://image.tmdb.org/t/p/original";
IMAGES.TMDB_logo_base = "https://image.tmdb.org/t/p/w154";
IMAGES.TMDB_logo_big_base = "https://image.tmdb.org/t/p/w185";
IMAGES.deadUrls = [];


/**
 * For self or ANNE-owned image buttons we do not audit (fetch/fingerprint validation).
 * For other owned images we do.
 */
IMAGES.doImgBtnB64=async($el, $imgNOBJ, $imgclass="search-img-small", $callback=null, $title="view img neuron")=>{
    var imgbtn = null;

    var border_class = ANNE.A.getImgBorder($imgNOBJ);
    if ($imgclass=="") $imgclass=border_class;
    else $imgclass=$imgclass+" "+border_class;

    //no audit needed for thumb display of self-owned or ANNE-owned imgs.
    if (ANNE.isANNE($imgNOBJ.owned_by)==true || $imgNOBJ.owned_by==USER._userNObj.nid) {
        var afile = await ANNE.IMAGES.loadFromNOBJ($imgNOBJ);
        if (afile==null) return imgbtn;
        imgbtn = ANNE.A.imgButtonB64($el, "", afile, $imgclass, $callback);
        if (imgbtn==null) {
            console.warn("this shouldn't be null here1.");
        }
    }

    //audit required even for thumbs (not full page view) of imgs.
    else {
        var afile = await ANNE.IMAGES.loadAndAuditFromNObj($imgNOBJ);
        if (afile.audit>MEDIA_AUDIT_NOTRUN) {
            $imgNOBJ.audit="good";
            imgbtn = ANNE.A.imgButtonB64($el, "", afile, $imgclass, $callback);
            if (imgbtn==null) {
                console.warn("this shouldn't be null here2.");
            }
        }
        else {
            $imgNOBJ.audit="bad";
            imgbtn = ANNE.A.imgBadAudit($el, "", "", $imgclass, $callback);
            if (imgbtn==null) {
                console.warn("this shouldn't be null here3.");
            }
        }
    }
    
    //no callback defaults to neuron launcher.
    if ($callback==null && imgbtn!=null) {
        EXT_BTNS.makeAnyElNeuronLaunch(imgbtn, $imgNOBJ.nid);
        imgbtn.title=$title;
    }
    return imgbtn;
}


/**
 * Get the default neuron image.
 * For any given neuron, get the default img, audit it for finger, and display.
 */
IMAGES.getDNI_lad=async($parentNOBJ, $nObj, $el, $imgClass, $w=600, $h=900, $max=600)=>{
    if ($nObj==null) return null;
    if ($nObj.bes.length==0) return null;
    var parentNOBJ = $parentNOBJ;
    if (parentNOBJ==null) parentNOBJ = MEMG.getNeuronByTempNid($nObj.bes[0]);
    if (parentNOBJ==null) return null;
    var neuronImgNOBJ = MEM.__GET_DEFAULT_IMG_NEURON($parentNOBJ, $nObj);
    if (neuronImgNOBJ==null) return null;
    var afile = await IMAGES.loadAuditAndDisplayFromNObj(neuronImgNOBJ, $el, $imgClass, $w, $h, $max);
    if (afile.imgel!=null) afile.imgel.setAttribute("nid", neuronImgNOBJ.nid);
    return afile;
}


/**
 * 
 * @param {*} $afile 
 * @param {*} $el 
 * @param {*} $w 
 * @returns 
 */
IMAGES.loadAfileIntoEl=function($afile, $el, $w="99px") {
    var el = ANNE.A.__getEl($el);
    if (el==null) return;
    if ($afile!=null) {            
        $el.style.backgroundSize='cover';
        $el.style.backgroundPosition='center';  
        var imgel = document.createElement("img");
        $afile.imgel = imgel;
        if ($afile.b64data.indexOf("data:")!=-1) imgel.setAttribute('src', $afileafile.b64data); 
        else imgel.setAttribute('src', 'data:'+$afile.mimetype+';base64,'+$afile.b64data);
        if($w!=0) imgel.setAttribute("width", $w);
        $el.appendChild(imgel);
    }
}


IMAGES.loadElIntoBG=async($nObj, $el, $w=54)=> {
    var afile = await ANNE.IMAGES.getAnyValidImgAFILE($nObj);
    if (afile!=null) {            
        $el.style.backgroundSize='cover';
        $el.style.backgroundPosition='center';  
        var imgel = document.createElement("img");
        afile.imgel = imgel;
        if (afile.b64data.indexOf("data:")!=-1) imgel.setAttribute('src', afile.b64data); 
        else imgel.setAttribute('src', 'data:'+afile.mimetype+';base64,'+afile.b64data);
        if($w!=0) imgel.setAttribute("width", $w);
        $el.appendChild(imgel);
    }
}


/**
 * 
 * @param {*} $nObj 
 * @returns {anne_file}
 */
IMAGES.getAnyValidImgAFILE=async($nObj, $width=200)=> {
    //console.log("get any valid img afile "+$nObj.text);

    if ($nObj==null) return null;
    if ($nObj.bes.length==0) return null;
    
    var afile = A2A.getFileByNid($nObj.nid);
    if (afile!=null) return afile;

    //we already tried this.
    if (afile == null && ANNE.A2A.nids_tried.indexOf($nObj.nid)!=-1) {
        ANNE.A2A.nids_tried.push($nObj.nid);
        return null;
    }
    
    var parentNOBJ = $nObj.getParent();
    if (parentNOBJ==null) return null;



 
    var neuronImgNOBJ = MEM.__GET_DEFAULT_IMG_NEURON(parentNOBJ, $nObj);
    if (neuronImgNOBJ==null) {
        var img_rels = MEMG.getHasRelons($nObj.outs, MEM.neuronImg.temp_nid);
        if (img_rels.length) {
            for (var i=0; i<img_rels.length; i++) {
                neuronImgNOBJ = MEMG.getNeuronByNid(img_rels[i].to_s);

                if (neuronImgNOBJ==null) {
                    console.log("WHY??????");
                    continue;
                }
                
                //not our image, or ANNE's -- we don't look at these in this app.
                //TODO: make setting for user to decide.
                if(neuronImgNOBJ.ghost==false && ANNE.isANNE(neuronImgNOBJ.owned_by)==false
                    && neuronImgNOBJ.owned_by!=USER._userNObj.nid) continue;

                if (neuronImgNOBJ!=null) {
                    var afile = A2A.getFileByNid(neuronImgNOBJ.nid);
                    if (afile!=null) {
                        return afile;
                    }
                    afile = new anne_file();
                    await afile.setFromNeuronAndLoad(neuronImgNOBJ);
                    return afile;
                    //if (afile.url!="") {
                       // var afile2 = ANNE.A2A.getFileByUrl(afile.url);
                       // if (afile2!=null) {
                         //   return afile2;
                       // }
                       // afile =  null;
                       // afile2 = null;
                   // }
                }
            }
        }
    }

    //use a imgpart from dbpedia.  (not a real img neuron, just a ref part tacked on to a known base)
    //we can add others here if we have them.. these are fine for now.
    //var test = MEMG.getHasRelon($nObj.outs, MEM.wcImgUriPart_thumbnail.temp_nid);
    //if (test==null) {
        //test = MEMG.getHasRelon($nObj.outs, MEM.wcImgUriPart_Skyline.temp_nid);
        //if (test==null) {
            //test = MEMG.getHasRelon($nObj.outs, MEM.wcImgUriPart_Map.temp_nid);
            //if (test==null) {
                //test = MEMG.getHasRelon($nObj.outs, MEM.wcImgUriPart_Flag.temp_nid); 
                //if (test==null) test = MEMG.getHasRelon($nObj.outs, MEM.wcImgUriPart_Seal.temp_nid); 
            //}
        //}
    //}

    //these wikicommon links are horse shit.
    //if (test!=null) {
        //var url = "https://commons.wikimedia.org/wiki/File:"+test.to_s+"?width="+$width;
        //console.log("old: https://commons.wikimedia.org/wiki/Special:FilePath/"+test.to_s+"?width="+$width);
        //console.log("new "+url);
        //return await ANNE.A2A.getOrMakeFilebyUrl(url, test);
   // }
    
    
    return null;
}




IMAGES.getBasicB64Thumb=async($parentNOBJ, $nObj, $el, $imgClass, $w=600, $h=900, $max=600)=>{
    if ($nObj==null) {
        return null;
    }
    if ($nObj.bes.lenth==0) {
        return null;
    }
    var parentNOBJ = $parentNOBJ;
    if (parentNOBJ==null) parentNOBJ = MEMG.getNeuronByTempNid($nObj.bes[0]);
    if (parentNOBJ==null) {
        return null;
    }
    var afile = ANNE.A2A.getFileByNid($nObj.nid);
    if (afile==null) {
        var neuronImgNOBJ = MEM.__GET_DEFAULT_IMG_NEURON($parentNOBJ, $nObj);
        if (neuronImgNOBJ==null) {
            afile = await ANNE.IMAGES.getAnyValidImgAFILE($nObj);
        }
    }

    //we already tried this.
    if (afile==null && ANNE.A2A.nids_tried.indexOf($nObj.nid)!=-1) {
        ANNE.A2A.nids_tried.push($nObj.nid);
        return null;
    }
    
    if (afile!=null && afile.b64data!=null) {
        afile.imgel=$el;    //update the img el
        if ($w==0 && $h==0 && $max==0) {
            imgel = ANNE.A.doImageDynoB64($el, "", afile, $imgClass);
        }
        else if ($w==0 && $h==0 && $max!=0) {
            imgel = ANNE.A.doImageDyno2_B64($el, "", afile, $max, $imgClass);
        }
        else {
            imgel = ANNE.A.doImageB64($el, "", afile, $w, $h, $imgClass, $max);
        }
    }
        
    else if (neuronImgNOBJ!=null) {
        afile = await IMAGES.loadAuditAndDisplayFromNObj(neuronImgNOBJ, $el, $imgClass, $w, $h, $max);
        if (afile!=null) {
            afile.imgel=$el;
            afile.imgel.setAttribute("nid", neuronImgNOBJ.nid);
        }
    }
    
    return afile;
}


//get default neuron image load and display
//allow for neuron_img to real img neurons here too
IMAGES.getDNI_lad2=async($parentNOBJ, $nObj, $el, $w=600, $h=900, $max=600)=>{
    if ($nObj==null) return null;
    if ($nObj.bes.lenth==0) return null;
    var parentNOBJ = $parentNOBJ;
    if (parentNOBJ==null) parentNOBJ = MEMG.getNeuronByTempNid($nObj.bes[0]);
    if (parentNOBJ==null) return null;
    var neuronImgNOBJ = MEM.__GET_DEFAULT_IMG_NEURON(parentNOBJ, $nObj);
    if (neuronImgNOBJ==null) {
        var img_rels = MEMG.getHasRelons($nObj.outs, MEM.neuronImg.temp_nid);
        if (img_rels.length) {

            for (var i=0; i<img_rels.length; i++) {
                neuronImgNOBJ = MEMG.getNeuronByNid(img_rels[i].to_s);
                if(neuronImgNOBJ.ghost==false && neuronImgNOBJ.owned_by!=MEM.ANNE_ACCTID
                    && neuronImgNOBJ.owned_by!=USER._userNObj.nid) continue;
                if (neuronImgNOBJ!=null) break;
            }
        }
        if (neuronImgNOBJ==null) return null;
    }
    var border_class = ANNE.A.getImgBorder(neuronImgNOBJ);
    var afile = await IMAGES.loadAuditAndDisplayFromNObj(neuronImgNOBJ, $el, border_class, $w, $h, $max);
    if (afile.imgel!=null) afile.imgel.setAttribute("nid", neuronImgNOBJ.nid);
    return afile;
}


/**
 * @param {*} $nObj 
 * @returns {anne_file}
 */
IMAGES.loadFromNOBJ=async($nObj)=>{
    var afile = new anne_file();
    await afile.setFromNeuronAndLoad($nObj);
    return afile;
}


/**
 */
IMAGES.loadAuditAndDisplayFromNObj=async($nObj, $el, $imgClass, $w=600, $h=900, $max=600)=> {
    var afile = await ANNE.IMAGES.loadAndAuditFromNObj($nObj);
    var imgel = null;
     
    if (afile.audit>MEDIA_AUDIT_NOTRUN) {
        if ($w==0 && $h==0 && $max==0) {
            imgel = ANNE.A.doImageDynoB64($el, "", afile, $imgClass);
        }
        else if ($w==0 && $h==0 && $max!=0) {
            imgel = ANNE.A.doImageDyno2_B64($el, "", afile, $max, $imgClass);
        }
        else {
            imgel = ANNE.A.doImageB64($el, "", afile, $w, $h, $imgClass, $max);
        }
        $nObj.audit="good";
    }
    else {
        $nObj.audit="bad";
    }
    //could put a failed img audit here.
    return {afile:afile, imgel:imgel, audit:afile.audit};
}


/**
 * no audit.
 * @param {*} $nObj 
 * @param {*} $el 
 * @param {*} $imgClass 
 * @param {*} $w 
 * @param {*} $h 
 * @param {*} $max 
 * @param {*} $icoStyle 
 * @returns 
 */
IMAGES.loadAndDisplayFromNObj=async($nObj, $el, $imgClass, $w=600, $h=900, $max=600, $icoStyle=null)=> {
    var afile = ANNE.IMAGES.loadFromNOBJ($nObj);
    var imgel = null;
    if ($w==0 && $h==0 && $max==0) {
        imgel = ANNE.A.doImageDynoB64($el, "", afile, $imgClass);
    }
    else if ($w==0 && $h==0 && $max!=0) {
        imgel = ANNE.A.doImageDyno2_B64($el, "", afile, $max, $imgClass);
    }
    else {
        imgel = ANNE.A.doImageB64($el, "", afile, $w, $h, $imgClass, $max);
    }
    $nObj.audit="good";
    return {afile:afile, imgel:imgel, audit:afile.audit};
}


/**
 * 
 * @param {*} $nObj 
 * @returns 
 */
IMAGES.getUrl=function($nObj) {
    var afile = new anne_file();
    afile.setFromNeuron($nObj);
    if (afile.url!="") return afile.url;
    return "";
}


/**
 * 
 * @param {*} $nObj 
 * @returns {anne_file}
 */
IMAGES.loadAndAuditFromNObj=async($nObj)=> {
    var afile = ANNE.A2A.getFileByNid($nObj.nid);
    if (afile!=null) return afile;
    afile = new anne_file();
    afile.setFromNeuron($nObj);
    if (afile.url!="") await afile.auditFile();
    return afile;
}


/**
 */
IMAGES.uniqueByUrl=function($nObj, $url) {
    for (var r=0; r < $nObj.outs.length; r++) {
        var rel = $nObj.outs[r];
        if (rel.r != MEM.neuronImg.temp_nid) continue;
        var imgNOBJ=MEMG.getNeuronByTempNid(rel.t);
        if (imgNOBJ==null) continue;
        var url_rel = MEMG.getRelonFromWithRToType(imgNOBJ.outs, TYPE_HAS, MEM.dataUrl.temp_nid, TO_TYPE_URL);
        if (url_rel && url_rel.to_s == $url) return false;
    }
    return true;
}


/**
 */
IMAGES.getFingerPrint=async($fileData)=> {
    var data = $fileData.trim();
    return await ANNE.other.sha256(data);
}



/**
 * 
 * @param {*} $url 
 * @param {*} $base 
 * @param {*} $elid 
 * 
 * @returns {anne_file} 
 */
IMAGES.getImgMetaFromUrlElement = async($url, $base, $elid)=> {
    //if (IMAGES.deadUrls.indexOf($url)!=-1) return null;
    if (ANNE.UTILS.isset($url)==false) {
        console.log("(getImgMetaFromUrl) no url passed");
        return null;
    }
    var afile = ANNE.A2A.getFileByUrl($url);
    if (afile!=null) {
        return afile;
    }
    
    afile = new anne_file();
    var ext = afile.extractExtFromUrl($url);

    //this gets a file by URL and caches it in the cache folder (not the neurons folder)
    var resp = await ANNE.API.getAndCacheFileFromElement($url, ext, $base, $elid);
    if (resp.status!="good") {
        //IMAGES.deadUrls.push($url);
        console.warn("(getImgMetaFromUrlElement) status is not good");
        return null;
    }

    if (resp.actual_src!=undefined) {
        $url = resp.actual_src;
    }

    var live_finger = resp.finger;
    var mtNOBJ = null;
    var mt = "";

    //vet this mimetype as coming back as png -- when it should.
    //we are getting png imgs stored but relons of mimetype jpg.
    //the b64 data shows when in-use in-app the files are png..
    //so the AFILES on the ANNODE is confused looking for a jpg (and doesn't find it)
    if (resp.mimetype2!=undefined) {
        mt  = resp.mimetype2;
        mtNOBJ = IMAGES.__getMimeTypeByText(resp.mimetype2);
    }
    if (mtNOBJ==null && resp.mimetype!=undefined) {
        mt = resp.mimetype;
        mtNOBJ = IMAGES.__getMimeTypeByText(resp.mimetype);
    }

    //var url = $url;
    //if (urlMoved!=null) url = urlMoved; //save the actual url... and fix the relon!
    afile.setManually(live_finger, $url, resp.filesize, mt, mtNOBJ);
    afile.b64data = resp.b64data;
    afile.audit = MEDIA_AUDIT_PASSED;
    afile.relativepath = resp.relativepath;
    afile.printDebug();
    ANNE.A2A.addToCache(afile, true);
    return afile;
}



/**
 * 
 * @param {*} $url 
 * @returns {anne_file} 
 */
IMAGES.getImgMetaFromUrl = async($url)=> {
    //if (IMAGES.deadUrls.indexOf($url)!=-1) return null;
    if (ANNE.UTILS.isset($url)==false) {
        console.log("(getImgMetaFromUrl) no url passed");
        return null;
    }
    if ($url.indexOf("Image:")==0) {
        console.warn("Image: syntax is unhandled");
        return null;
    }

    var afile = ANNE.A2A.getFileByUrl($url);
    if (afile!=null) return afile;

    afile = new anne_file();
    var ext = afile.extractExtFromUrl($url);

    //this gets a file by URL and caches it in the cache folder (not the neurons folder)
    var resp = await ANNE.API.getAndANNODECacheTheFile($url, ext, "");
    if (resp.status!="good") {
        //IMAGES.deadUrls.push($url);
        if (resp.message!=undefined) {
            console.warn("msg:"+resp.message);
        }
        console.warn("(getImgMetaFromUrl) status is not good");
        return null;
    }

    var live_finger = resp.finger;
    var mtNOBJ = null;
    var mt = "";
    if (resp.mimetype2!=undefined) {
        mt  = resp.mimetype2;
        mtNOBJ = IMAGES.__getMimeTypeByText(resp.mimetype2);
    }
    if (mtNOBJ==null && resp.mimetype!=undefined) {
        mt = resp.mimetype;
        mtNOBJ = IMAGES.__getMimeTypeByText(resp.mimetype);
    }

    //var url = $url;
    //if (urlMoved!=null) url = urlMoved; //save the actual url... and fix the relon!
    afile.setManually(live_finger, $url, resp.filesize, mt, mtNOBJ);
    afile.b64data = resp.b64data;
    afile.audit = MEDIA_AUDIT_PASSED;
    afile.relativepath = resp.relativepath;
    afile.printDebug();
    ANNE.A2A.addToCache(afile);
    return afile;
}


/**
 */
IMAGES.__getMimeTypeByText=function($mt){
    var mt = $mt.toLowerCase();
    if (ANNE.MEM==undefined || ANNE.MEM==null || ANNE.MEMG==undefined || ANNE.MEMG==null) {
        return;
    }
    for (var m=0; m < ANNE.MEM.mimetype.children.length; m++) {
        var childOBJ = ANNE.MEMG.getNeuronByTempNid(MEM.mimetype.children[m]);
        if (mt==childOBJ.text.toLowerCase()) return childOBJ;
    }
}