/**
 * 
 * poor man's block explorer and peer monitor.
 * Didn't want all the extra app stuff.. just a quick informative viewer.
 * 
 * Anyone can create any types of really lovely js apps with the ANNE data.  This is just
 * a quick and dirty simple view that refreshes new blocks and peer data.
 * 
 * Blocks are saved in INDEXDB to reduce loadup costs and wasted data transfer.
 */

var ANNE = {NET:null, SIGNA:null, A:null, MEM_UDF:null, UTILS:null, DB_blocks:null};
ANNE.SIGNA = {sig:null};
if (typeof sig$ != "undefined") ANNE.SIGNA.sig = sig$;
if (typeof sig$crypto != "undefined") ANNE.SIGNA.crypto = sig$crypto;
if (typeof sig$http != "undefined") ANNE.SIGNA.http = sig$http;
if (typeof sig$util != "undefined") ANNE.SIGNA.util = sig$util;
if (typeof A != "undefined") ANNE.A = A;
if (typeof UTILS != "undefined") ANNE.UTILS = UTILS;
if (typeof TALK != "undefined") ANNE.TALK = TALK;

var _BLOCKS = [];
var _blockMap = new Object();
var _PEERS = [];
var _ramvars = {};
const REFRESH_RATE_MS = 30000;
var highest = 0;
var lowest = 999999999;
var _tbl_cols = null;
var __tableObj = null;
var _el_superfooter = null;

document.addEventListener("DOMContentLoaded", async (event) => {
    //console.log("dom loaded");
    ANNE.A.show("loading");
    const port = window.location.port;
    //console.log(port);
    ANNE.NET = new ANNE_NET(window.origin);


    if (typeof DB_blocks != "undefined") {
        ANNE.DB_blocks = DB_blocks;
        if (!('indexedDB' in window)) {
            console.log('This browser does not support IndexedDB');
            ANNE.DB_blocks.bSUPPORTED=false;
            ANNE.DB_blocks=null;
        }
        else {	
            ANNE.DB_blocks.bSUPPORTED=true;
            return await ANNE.DB_blocks.___init(preloadBlocksFromIDB); 
        }
    }
    else {
        ANNE.DB_blocks=null;
        initPeers();
        initBlocks(_ramvars.height);
    } 
});


var getPeerByID = function($uid,) {
    for (var p=0; p < _PEERS.length; p++) {
        if (_PEERS[p].uid==$uid) return _PEERS[p];
    }
    return null;
}

var updatePeerObj = function($newPeerDataObj) {
    for (var p=0; p < _PEERS.length; p++) {
        if (_PEERS[p].uid==$newPeerDataObj.uid) {
            _PEERS[p].annode_mode = $newPeerDataObj.annode_mode;
            _PEERS[p].announced_addr = $newPeerDataObj.announced_addr;
            _PEERS[p].blacklisted = $newPeerDataObj.blacklisted;
            _PEERS[p].blockDiff = $newPeerDataObj.blockDiff;
            _PEERS[p].blockchainHeight = $newPeerDataObj.blockchainHeight;
            _PEERS[p].commonBlockHeight = $newPeerDataObj.commonBlockHeight;
            _PEERS[p].commonBlockId = $newPeerDataObj.commonBlockId;
            _PEERS[p].cumulativeDifficulty = $newPeerDataObj.cumulativeDifficulty;
            _PEERS[p].errors = $newPeerDataObj.errors;
            _PEERS[p].inbound_lastUpdate = $newPeerDataObj.inbound_lastUpdate;
            _PEERS[p].inbound_state= $newPeerDataObj.inbound_state;
            _PEERS[p].last_block_timestamp= $newPeerDataObj.last_block_timestamp;
            _PEERS[p].outbound_lastUpdate= $newPeerDataObj.outbound_lastUpdate;
            _PEERS[p].outbound_state= $newPeerDataObj.outbound_state;
            _PEERS[p].peer_addr= $newPeerDataObj.peer_addr;
            _PEERS[p].port= $newPeerDataObj.port;
            _PEERS[p].secs_since_lastblock= $newPeerDataObj.secs_since_lastblock;
            _PEERS[p].share_address= $newPeerDataObj.share_address;
            _PEERS[p].uid= $newPeerDataObj.uid;
            _PEERS[p].versions= $newPeerDataObj.versions;
            break;
        }
    }
}

var initPeers = async()=>{
    ANNE.A.empty("peers");
    var ramVars = await ANNE.NET.query("debug_getRAMvars");
    console.log(ramVars);

    var allPeers = ramVars.all_peers.concat();
    delete ramVars.all_peers;

    for (var r=0; r < allPeers.length; r++) {
        var peer = getPeerByID(allPeers[r].uid);
        if(peer==null) {
            peer = allPeers[r];
            _PEERS.push(peer);
        }
    }

    _ramvars = ramVars;

    var el_peer_details = document.getElementById("peer_details");
    el_peer_details.addEventListener("click", e=>{
        var el_pd = ANNE.A.hide("peer_details");
        el_pd.style.pointerEvents="none";
    });

    doPeerGui();
    console.log(_PEERS);

    //refresh every 30 seconds.
    setInterval(refreshData, REFRESH_RATE_MS);

    //TODO: we can now just listen for blocks via the websocket.
    //see:  socketTest_chainData.html
}


/**
 * update the bars..
 * 
 * (later we will also get the new blocks for the table)
 */
var refreshData = async()=>{
    var ourExistingH = _ramvars.height;
    
    console.log("our existing h:"+ourExistingH);

    var ramVars = await ANNE.NET.query("debug_getRAMvars");
    //console.log(ramVars);
    for (var r=0; r < ramVars.all_peers.length; r++) {
        var peer = getPeerByID(ramVars.all_peers[r].uid, true);
        if(peer==null) {
            peer = ramVars.all_peers[r];
            _PEERS.push(peer);
        }
        else {
            updatePeerObj(ramVars.all_peers[r]);
        }
    }
    
    delete ramVars.all_peers;
    _ramvars = ramVars;

    if (ourExistingH<_ramvars.height) {
        //ANNE.A.play("forge");

        //go get the latest block.
        var block_response = await ANNE.NET.query("getBlock", {height:_ramvars.height});
        if (block_response.status=="fail") {
            return;   
        }
        storeBlocksInDB(block_response.blocks, true);
        
        var _BLOCKS_INDEX = _BLOCKS.length;

        var blocks = block_response.blocks;
        preprocessBlocks(blocks);
        
        for (var b=_BLOCKS_INDEX; b < _BLOCKS.length; b++) {
            var block = _BLOCKS[b];
            block.prev_block = getBlockById(block.previousBlock);
            if (block.prev_block!=null) block.prev_block.next_block = block;
            block.timediff=0;
            if (block.prev_block && block.prev_block.timestamp) {
                block.timediff = block.timestamp - block.prev_block.timestamp;
            }
        }

        //add to gui table.
    }

    this.doPeerGui();
}


/**
 * 
 * @returns 
 */
var doPeerGui=function() {
    var el_peers = document.getElementById("peers");

    var our_h = _ramvars.height;

    const BASIS=0.85;   //the colored bars area is only 85 percent usable (the title takes up 15)

    //const screenHeight = window.innerHeight;
    //const barHeight = (screenHeight * 0.5) / _PEERS.length;
    //document.documentElement.style.setProperty('--bar-height', `${barHeight}px`);
    
    for (var p=0; p < _PEERS.length; p++) {
        var peer = _PEERS[p];

        var blocks_same = 0;
        var blocks_different_from_common = 0;
        var blocks_missing = 0;

        var their_h = peer.blockchainHeight;
        
        //there will be a missing value here
        if (their_h < our_h) {
            blocks_missing = our_h - their_h;
        }

        var common_h = peer.commonBlockHeight;
        blocks_different_from_common = Math.min(our_h - common_h, their_h - common_h);
        
        blocks_same = peer.commonBlockHeight;

        var total = blocks_same + blocks_different_from_common + blocks_missing;

        var same = 0;
        if (blocks_same!=0) same = Math.round(((blocks_same / total) * BASIS)*100);
        var diff = 0;
        if (blocks_different_from_common!=0) diff = Math.round(((blocks_different_from_common / total)  * BASIS)*100);
        var missing = 0;
        if (blocks_missing!=0) missing = Math.round(((blocks_missing / total) * BASIS)*100);


        //we are refreshing data here.
        if (peer.el_same!=undefined && peer.el_same!=null) {
            peer.el_same.style="width:"+same+"%";
            peer.el_different.style="width:"+diff+"%";
            peer.el_missing.style="width:"+missing+"%";
            return;
        }

        var el_peer = document.createElement("div");
        el_peer.classList = "peer";
        el_peer.setAttribute("uid", peer.uid+"");
        el_peers.appendChild(el_peer);

        //shows the peer details, activates the click event to close them.
        el_peer.addEventListener("click", $e=>{
            console.log("do popup.");
            var elp = ANNE.A.getFirstParentOf($e.target, "peer", true);
            var uid = elp.getAttribute("uid");
            var peer2 = getPeerByID(uid);
            loadPeerDetails(peer2);
            var el_pd = ANNE.A.show("peer_details");
            el_pd.style.pointerEvents="all";
        })

        var el_peerbar = document.createElement("div");
        el_peerbar.classList = "peerbar";
        el_peer.appendChild(el_peerbar);
        
        
        var el_peername = document.createElement("div");
        el_peername.id = "peer_name";
        el_peername.innerHTML = peer.peer_addr;
        el_peername.style="width:15%";
        el_peerbar.append(el_peername);
    
        //easy access for later updating with new data.
        peer.el_same = document.createElement("span");
        peer.el_same.classList="same";
        peer.el_same.style="width:"+same+"%";
        el_peerbar.append(peer.el_same);
    
        peer.el_different = document.createElement("span");
        peer.el_different.classList="different";
        peer.el_different.style="width:"+diff+"%";
        el_peerbar.append(peer.el_different);
    
        peer.el_missing = document.createElement("span");
        peer.el_missing.classList="missing";
        peer.el_missing.style="width:"+missing+"%";
        el_peerbar.append(peer.el_missing);

        if (peer.el_same!=null) console.log("el_same ptr set");
    }
}


/**
 * 
 * @param {*} $peer 
 */
var loadPeerDetails = function($peer) {
    ANNE.A.setHTML("peer_addr", $peer.peer_addr);
    ANNE.A.setHTML("port", $peer.port);

    var el_mode = ANNE.A.setHTML("annode_mode", $peer.annode_mode);
    if ($peer.annode_mode=="LIVE") {
        el_mode.classList = "bg-green";
    }
    else el_mode.classList = "bg-red";

    var el_is = ANNE.A.setHTML("inbound_state", $peer.inbound_state);
    if ($peer.inbound_state=="CONNECTED") {
        el_is.classList = "bg-green";
    }
    else el_is.classList = "bg-red";

    var el_os = ANNE.A.setHTML("outbound_state", $peer.outbound_state);
    if ($peer.outbound_state=="CONNECTED") {
        el_os.classList = "bg-green";
    }
    else el_os.classList = "bg-red";
    

    var el_bh = ANNE.A.setHTML("blockchainHeight", $peer.blockchainHeight);
    if ($peer.blockchainHeight==_ramvars.height) {
        el_bh.classList = "bg-green";
    }
    else el_bh.classList = "bg-red";

    var el_cbh = ANNE.A.setHTML("commonBlockHeight", $peer.commonBlockHeight);
    if ($peer.blockchainHeight==_ramvars.commonBlockHeight) {
        el_cbh.classList = "bg-green";
    }
    else el_cbh.classList = "bg-red";
    
    var el_common = ANNE.A.setHTML("commonBlockId", $peer.commonBlockId);
    if ($peer.blockchainHeight==_ramvars.commonBlockHeight) {
        el_common.classList = "bg-green";
    }
    else el_common.classList = "bg-red";

    var el_diff = ANNE.A.setHTML("blockDiff", $peer.blockDiff);
    if ($peer.blockDiff>0) {
        el_diff.classList = "bg-green";
    }
    else el_diff.classList = "bg-red";

    ANNE.A.setHTML("last_block_timestamp", $peer.last_block_timestamp);
    ANNE.A.setHTML("secs_since_lastblock", UTILS.secsElapsedToDHMS($peer.secs_since_lastblock));


    var el_blacklisted = ANNE.A.setHTML("blacklisted", $peer.blacklisted);
    if ($peer.blacklisted==false) {
        el_blacklisted.classList = "bg-green";
    }
    else el_blacklisted.classList = "bg-red";

    var el_errors = ANNE.A.setHTML("errors", $peer.errors);
    if ($peer.errors==0) {
        el_errors.classList = "bg-green";
    }
    else if ($peer.errors<3) {
        el_errors.classList = "bg-yellow";
    }
    else el_errors.classList = "bg-red";

    ANNE.A.setHTML("version", $peer.versions);
    
}


/**
 * 
 * @param {*} $blocks 
 */
var preloadBlocksFromIDB = async($blocks)=> {
    if ($blocks.length) {
        console.log("loaded "+$blocks.length+" from memory");
        preprocessBlocks($blocks);
    }
    await initPeers();
    initBlocks(_ramvars.height);
}


/**
 * Anytime we get a dupe.. we just presume it is the updated info.
 * We may get rollbacks and block then have to be replaced (in db mem)
 * @param {*} $blocks 
 * @param {*} $bUPDATEGUITABLE 
 * @returns 
 */
var storeBlocksInDB=async($blocks, $bUPDATEGUITABLE=false)=>{
    if (ANNE.DB_blocks==null) {
        return;
    }
    var newBlocks = [];
    var deleteBlocks = [];
    for (var b =0; b < $blocks.length; b++) {
        var newBlock = $blocks[b];
        if (_blockMap[newBlock.height]!=null) {
            deleteBlocks.push(newBlock); 
            updateMapsByHeight(newBlock);
        }
        newBlocks.push(newBlock);
    }
    if (deleteBlocks.length)  await ANNE.DB_blocks.___delete(deleteBlocks); 
    if (newBlocks.length) await ANNE.DB_blocks.___insert(newBlocks);
    if ($bUPDATEGUITABLE==true) {
        wireBlocks();
        var el_blocks = document.getElementById("blocks");
        ANNE.A.empty(el_blocks);
        __tableObj = new neuron_table(null);
        __tableObj.setPrimaryKey("blockId");
        __tableObj.setManualCols(_tbl_cols, _BLOCKS);
        var bb = el_blocks.getBoundingClientRect();
        var estimatedTableBodyTop = bb.top;
        __tableObj.buildDOMTable(el_blocks, estimatedTableBodyTop, null, true, true, 17.5); 
    }
    return;
}

var log = function($msg) {
    if (ANNE.SETTNGS.debug()==false) return;
    console.log($msg);
}


/**
 */
var initBlocks = async($height=0)=> {
    if ($height>0) {
        ANNE.A.emptySelf("blocks");
        if ($height!=highest) {
            var next_top = $height+1;
            //lowest and highest are our actual blocks in mem.
            //_ramvars.height is the latest height we know is on the annode.
            while (lowest>0) {
                var block_response = await ANNE.NET.query("getLastBlocks", {height:next_top-1});
                var blocks = block_response.blocks;
                storeBlocksInDB(blocks, false);
                preprocessBlocks(blocks);
                next_top = lowest;
            } 
        }
    }
    
    GUI_processBlocks();
    
    ANNE.A.hide("loading");
}



/**
 * 
 * @param {*} $blocks 
 */
var preprocessBlocks=function($blocks) {
    for (var b=0; b < $blocks.length; b++) {
        var block = $blocks[b];
        _BLOCKS.push(block);
        _blockMap[block.height] = block;
        var h = parseInt(block.height);
        if (h > highest) highest = h;
        if (h < lowest) lowest = h;
    }
     _BLOCKS.sort( sortOnHeight );
}


/**
 * 
 */
var GUI_processBlocks = function() {
    var el_blocks = document.getElementById("blocks");
    
    _tbl_cols = [
        {   neuron_link:false,
            relon_link:false,
            title:"height",
            prop:"height",
            class1:"height",
            classH:"header-col height-H",
            s_prop:"height",
            s_type:"numeric",
            default_sort:"desc"
        },
        {   neuron_link:false,
            relon_link:false,
            title:"blockId",
            prop:"blockId",
            class1:"blockId",
            classH:"header-col blockId-H",
        },
        {   neuron_link:false,
            relon_link:false,
            title:"blockId-s",
            prop:"blockId_s",
            class1:"blockId-signed",
            classH:"header-col blockId-signed-H",
        },
        {   neuron_link:false,
            relon_link:false,
            title:"miner",
            prop:"generatorId",
            class1:"miner",
            classH:"header-col miner-H",
        },
        {   neuron_link:false,
            relon_link:false,
            title:"nonce",
            prop:"nonce",
            class1:"nonce",
            classH:"header-col nonce-H",
        },
        {   neuron_link:false,
            relon_link:false,
            title:"timestamp",
            prop:"timestamp",
            class1:"timestamp",
            classH:"header-col timestamp-H",
        },
        {   neuron_link:false,
            relon_link:false,
            title:"Δtime",
            prop:"timediff",
            class1:"timediff",
            classH:"header-col timediff-H",
            s_prop:"timediff",
            s_type:"numeric",
        },
        {   neuron_link:false,
            relon_link:false,
            title:"fees",
            prop:"totalFeeNQT",
            class1:"totalFeeNQT",
            classH:"header-col totalFeeNQT-H",
            s_prop:"totalFeeNQT",
            s_type:"numeric",
        },
        {   neuron_link:false,
            relon_link:false,
            title:"annies",
            prop:"totalAmountNQT",
            class1:"totalAmountNQT",
            classH:"header-col totalAmountNQT-H",
            s_prop:"totalAmountNQT",
            s_type:"numeric",
        }
    ];
    
    wireBlocks();

    var bb = el_blocks.getBoundingClientRect();
    var estimatedTableBodyTop = bb.top;
    __tableObj = new neuron_table(null);
    __tableObj.setManualCols(_tbl_cols, _BLOCKS);
    __tableObj.buildDOMTable(el_blocks, estimatedTableBodyTop, null, true, true, 17.5); 
    _el_superfooter = document.createElement("div");
    _el_superfooter.classList = "superfooter";
    el_blocks.appendChild(_el_superfooter);
    _el_superfooter.innerHTML="some footer stuff goes here <a>[export csv] (todo) </a>";
    updateSuperFooter();
}

var updateSuperFooter = function() {
    //for (var b=0; b < _BLOCKS.length; b++) {

    //}
}

var wireBlocks = function() {
    _BLOCKS.sort( sortOnHeight );
    for (var b=0; b < _BLOCKS.length; b++) {
        var block = _BLOCKS[b];

        //wire to prev block.
        block.prev_block = getBlockById(block.previousBlock);
        
        //wire prev to next.
        if (block.prev_block!=null) {
            block.prev_block.next_block = block;
        }
        else if (block.height!=0) {
            //alert("didnt' find prev block in mem");
            block.timedDiff = 0;
        }
        
        block.timediff=0;
        if (block.prev_block && block.prev_block.timestamp) {
            block.timediff = block.timestamp - block.prev_block.timestamp;
        }
    }
}


/**
 * sort DESC as default.
 * 
 * @param {*} $b1 
 * @param {*} $b2 
 * @returns 
 */
var sortOnHeight = function ($b1, $b2) {
    if ($b1.height < $b2.height) return 1;
    if ($b1.height > $b2.height) return -1;
    if ($b1.height == $b2.heigth) {
        console.log("we have a problem.");
    }
}


var updateMapsByHeight = function($block) {
    for (var b=0; b < _BLOCKS.length; b++) {
        if (_BLOCKS[b].height==$block.height) {
            _BLOCKS[b]=$block;
            return;
        }
    }
    _blockMap[$block.height] = $block;
}


var updateBlockByID = function($block) {
    for (var b=0; b < _BLOCKS.length; b++) {
        if (_BLOCKS[b].blockId==$block.blockId) {
            _BLOCKS[b]=$block;
            return;
        }
    }
}


var getBlockById = function($id) {
    for (var b=0; b < _BLOCKS.length; b++) {
        if (_BLOCKS[b].blockId==$id) return _BLOCKS[b];
    }
    return null;
}