var DB_local = {};
DB_local.db = null;
DB_local.dbName = "ANNODE_local";
DB_local.bSUPPORTED = false;


/**
 * Do we even use full pull history at all anymore in DB LOCAL????
 * @author {Mr.Scatman}
 */
 DB_local.___init=async($onLoadCallback=null, $callbackCallback=null)=> {
    
    if (this._annodeDetails!=null && this._annodeDetails.network=="ANNE-TESTNET") {
        DB_local.dbName = "ANNE_local_testnet";
    }
    
    if (DB_local.bSUPPORTED==false) {
        if ($onLoadCallback!=null) $onLoadCallback([], [], $callbackCallback);
        return;
    }
    //open existing (or new, if first time) DB_local.
    var done = await DB_local.openConnection(DB_local.dbName, 2);
    if (done==true) {
        var aFullPullHistory = await DB_local.loadAll("fullPullHistory");
        if ($onLoadCallback!=null) {
            $onLoadCallback(aFullPullHistory, $callbackCallback);
        }
    }
    else if ($onLoadCallback!=null) {
        $onLoadCallback([], $callbackCallback);
    }
}

DB_local.getDBSize=async()=> {
    var size = await DB_local.getDBTblSize("collab_relons");
    size+= await DB_local.getDBTblSize("fullPullHistory");
    size+= await DB_local.getDBTblSize("ghost_relons");
    size+= await DB_local.getDBTblSize("traditional_txs");
    size+= await DB_local.getDBTblSize("achat_overview");
    size+= await DB_local.getDBTblSize("achat_msgs");
    size+= await DB_local.getDBTblSize("awareness_relons");
    return size;
}

DB_local.getDBTblSize=async($tbl, $method="readwrite")=> {
    var transaction  = DB_local.db.transaction([$tbl], $method);
    if (transaction==null) return;
    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;
    return new Promise((resolve, reject) => {
        //FULL PULL HISTORY RETREIVAL
        if ('getAll' in objectStore) {
            objectStore.getAll().onsuccess = function(event) {
                var arr = event.target.result;
                var json = JSON.stringify(arr);
                size = json.length;
                return resolve(size);
            };
        } 
    });
}

/**
 * We wait until we know what user we are dealing with to get these ones
 */
DB_local.__getGhostsOnly=async($onLoadCallback=null)=>{
    if (DB_local.bSUPPORTED==false) {
        if ($onLoadCallback!=null) $onLoadCallback(null, null, $callbackCallback);
        return [];
    }
    var aGhostRelons = await DB_local.loadAll("ghost_relons");
    return aGhostRelons;
}


/**
 * get ACHAT.
 */
DB_local.__getACHAT=async()=>{
    if (DB_local.bSUPPORTED==false) return {overview:[], msgs:[]};
    var aACHATOverview = await DB_local.__getOverviewOnly();
    var aACHATMsgs = await DB_local.__getACHATMsgsOnly();
    return {overview:aACHATOverview, msgs:aACHATMsgs};
}


/**
 * Only return the logged-in user's msgs.
 */
DB_local.__getOverviewOnly=async()=> {
    if (DB_local.bSUPPORTED==false) return [];
    var overview = await DB_local.loadAll("achat_overview");
    var final_arr = [];
    for (var o=0; o < overview.length; o++) {
        //if (overview[o].anne_app_user!=USER._userNObj.nid) continue;
        final_arr.push(overview[o]);
    }
    return final_arr;
}


/**
 */
DB_local.__getACHATMsgsOnly=async()=>{
    if (DB_local.bSUPPORTED==false) return [];
    var msgs = await DB_local.loadAll("achat_msgs");
    var final_msgs = [];
    for (var m=0; m < msgs.length; m++) {
        //if (msgs[m].anne_app_user!=USER._userNObj.nid) continue;
        final_msgs.push(msgs[m]);
    }
    return final_msgs;
}


/**
 */
DB_local.__getStoredTxs=async()=>{
    if (DB_local.bSUPPORTED==false) return [];
    return await DB_local.loadAll("traditional_txs");
}


/**
 */
 DB_local.__getCollabRelons=async()=>{
    if (DB_local.bSUPPORTED==false) return [];
    var aCollabs = await DB_local.loadAll("collab_relons");
    var ours = [];
    for (var c=0; c < aCollabs.length; c++) {
        if(aCollabs[c].from_nid==ANNE.USER._userNObj.nid) ours.push(aCollabs[c]);
        else if(aCollabs[c].to_s==ANNE.USER._userNObj.nid) ours.push(aCollabs[c]);
        else if(aCollabs[c].collaborator==ANNE.USER._userNObj.nid) ours.push(aCollabs[c]);
        else {
            //do we have right to approve this?
        }
    }
    return ours;
}


/**
 * @author {Mr.Scatman}
 */
DB_local.___deleteEntireDB=async()=> {
    if (DB_local.bSUPPORTED==false) return;
    if (DB_local.db==null) return;
    return new Promise((resolve, reject) => {
        DB_local.db.close();
        var request = indexedDB.deleteDatabase(DB_local.dbName, 2);
        request.onblocked = function () {
            console.log("Delete blocked.");
            return resolve(false);
        }
        request.onerror = function () {
            console.log("Error deleting the DB");
            return resolve(false);
        };
        request.onsuccess = function () {
            console.log("Deleted OK.");
            return resolve(true);
        }   
    });             
}

/**
 * @author {Mr.Scatman}
 */
DB_local.openConnection=async($dbName, $version)=> {
    if (DB_local.db!=null) return true;
    return new Promise((resolve, reject) => {
        var request = indexedDB.open($dbName, $version);
        request.onerror = function(event) {
            console.log("openConnection request.Error");
            return resolve(false);
        };

        request.onsuccess = function(event) {
            DB_local.db = event.target.result;
            return resolve(true);
        };
        
        request.onupgradeneeded = function(event) {
            console.log("openConnection request.onUpradeneeded");
            DB_local.db = event.target.result;

            var ghostObjStore = DB_local.db.createObjectStore("ghost_relons", { keyPath:"txid" });
            ghostObjStore.createIndex("txid", "txid", { unique: true });
            
            var fullPullHistoryStore = DB_local.db.createObjectStore("fullPullHistory", { keyPath:"pullid" });
            fullPullHistoryStore.createIndex("pullid", "pullid", { unique: true });

            var collabRelonStore = DB_local.db.createObjectStore("collab_relons", { keyPath:"txid" });
            collabRelonStore.createIndex("txid", "txid", { unique: true });
            
            var ttStore = DB_local.db.createObjectStore("traditional_txs", { keyPath:["txid", "anne_app_user"] });
            ttStore.createIndex("usertxid", ["txid", "anne_app_user", "confirmed"], { unique: true });
            
            var achatOverviewStore = DB_local.db.createObjectStore("achat_overview", { keyPath: ["sesh_id", "sesh_participant_id"] });
            achatOverviewStore.createIndex("sesh_participant", ["sesh_id", "sesh_participant_id"], { unique: true });
            
            var achatMsgStore = DB_local.db.createObjectStore("achat_msgs", { keyPath:"msg_id" });
            achatMsgStore.createIndex("msg_id", "msg_id", { unique: true });
            
            var awarenessRelons = DB_local.db.createObjectStore("awareness_relons", { keyPath:"txid" });
            awarenessRelons.createIndex("txid", "txid", { unique: true });

            return resolve(false);  //no load needed
        };
    });
}


DB_local.loadAll=async($tbl, $method="readwrite")=> {
    if (DB_local.db==null) return;
    if (DB_local.db.transaction==undefined) {
        return;
    }
    
    var transaction  = DB_local.db.transaction([$tbl], $method);
    if (transaction==null) return;

    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;

    return new Promise((resolve, reject) => {
        //FULL PULL HISTORY RETREIVAL
        if ('getAll' in objectStore) {
            objectStore.getAll().onsuccess = function(event) {
                return resolve(event.target.result);
            };
        } 
        else {
            var arr = [];

            // Fallback to the traditional cursor approach if getAll isn't supported.
            objectStore.openCursor().onsuccess = function(event) {
                var cursor = event.target.result;
                if (cursor) {
                    arr.push(cursor.value);
                    cursor.continue();
                } 
                else return resolve(arr);
            };
        }
    });
}



DB_local.___insert = async($objs, $tbl="collab_relons", $method="readwrite", $callaback=null)=> {
    if (DB_local.bSUPPORTED==false) return;
    if ($objs.length==0) return;

    var transaction  = DB_local.db.transaction([$tbl], $method);
    if (transaction==null) return;

    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;

    //console.log("%cdoing insert of "+$objs.length+" objs for tbl:"+$tbl, TALK.bggreen);
    //console.log($objs);

    return new Promise((resolve, reject) => {    
        $objs.forEach(function($obj) {
            var request = null;

            if ($tbl=="ghost_relons") {

                //dont save this relon, EVER
                if ($obj.reln==MEM.INTRA_BLOCK_PENDING.nid) return;

                if ($obj.txid==undefined || $obj.txid==null || $obj.txid=="") return;

                //used in the gui but never broadcast.
                var TEMP_ONLY = false;
                if ($obj.TEMP_ONLY==true) {
                    TEMP_ONLY=true;
                }

                var sanitized_obj = {
                    from_nid: $obj.from_nid,
                    reln: $obj.reln,
                    rorigin: $obj.rorigin,
                    time:$obj.time,
                    to_s: $obj.to_s,
                    to_type: $obj.to_type,
                    txid: $obj.txid,
                    type: $obj.type,
                    ghost_order: $obj.ghost_order,
                    ghost_owner: $obj.ghost_owner,
                    TEMP_ONLY: TEMP_ONLY
                }
                if ($obj.from_text!=undefined) sanitized_obj.from_text = $obj.from_text;

                request = objectStore.add(sanitized_obj);
            }
                
            else if ($tbl=="awareness_relons") {
                request = objectStore.add($obj);
            }

            //will need collab sanitized stuff too. (TO DO)
            else if ($tbl=="collab_relons") {
                //dont save this relon, EVER
                if ($obj.reln==MEM.INTRA_BLOCK_PENDING.nid) return;

                request = objectStore.add($obj);
            }
            
            else request = objectStore.add($obj);

        });

        transaction.onsuccess = function(event) {
            return resolve(true);
        };
        transaction.onerror = function(event) {
            return resolve(false);
        }
        return resolve(true);
    });
}


DB_local.___insert_single = async($obj, $tbl="collab_relons", $method="readwrite", $callaback=null)=> {
    if (DB_local.bSUPPORTED==false) return;

    //dont save this relon, EVER
    if ($obj.reln==MEM.INTRA_BLOCK_PENDING.nid) return;

    var transaction  = DB_local.db.transaction([$tbl], $method);
    if (transaction==null) return;
    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;
    return objectStore.add($obj);    
}

DB_local.___updateAll = async($objs, $tbl="collab_relons", $method="readwrite")=> {
    for (var r=0; r < $objs.length; r++) {
        await DB_local.___update($objs[r], $tbl, $method);
    }
}

DB_local.___update = async($rObj, $tbl="collab_relons", $method="readwrite", $callaback=null)=> {
    if ($rObj==undefined || $rObj==null || $rObj.txid==undefined) return;
    if (DB_local.bSUPPORTED==false) return;
    var transaction  = DB_local.db.transaction([$tbl], $method);
    if (transaction==null) return;
    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;
    var sanitized_obj  = {};
    if ($tbl=="ghost_relons") {

        var TEMP_ONLY = false;
        if ($rObj.TEMP_ONLY==true) {
            TEMP_ONLY=true;
        }

        sanitized_obj = {
            from_nid: $rObj.from_nid,
            reln: $rObj.reln,
            rorigin: $rObj.rorigin,
            time:$rObj.time,
            to_s: $rObj.to_s,
            to_type: $rObj.to_type,
            txid: $rObj.txid,
            type: $rObj.type,
            ghost_order: $rObj.ghost_order,
            ghost_owner: $rObj.ghost_owner,
            TEMP_ONLY:TEMP_ONLY
        }
        if ($rObj.flathexint!=undefined) sanitized_obj=$rObj.fathexint;
        if ($rObj.from_text!=undefined) sanitized_obj.from_text = $rObj.from_text;
    }
    else sanitized_obj = $rObj;

    return new Promise((resolve, reject) => {
        var request = objectStore.put(sanitized_obj);
        request.onsuccess = function(event) {
            return resolve(true);
        };
        request.onerror = function(event) {
            console.log(event);
            return resolve(false);
        }
    });
}


DB_local.___delete = async ($txids, $tbl="collab_relons", $method="readwrite", $callback=null)=> {
    if (DB_local.bSUPPORTED==false) return false;
    if ($txids.length==0) return false;
    var transaction  = DB_local.db.transaction([$tbl], $method);
    if (transaction==null) return;
    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;
    for (var t=0; t < $txids.length; t++) {
        if ($txids[t]==undefined || typeof $txids[t]!=='string') continue;
        await DB_local.__deleteFinal(objectStore, $txids[t]);
    }
}


DB_local.__deleteFinal = async($objectStore, $txid)=>{
    return new Promise((resolve, reject) => {
        var request = $objectStore.delete($txid);
        request.onsuccess = function(event) { 
            return resolve(true); 
        }
        request.onerror = function(event) { 
            return resolve(false); 
        } 
    });
}