var DB_blocks = {};
DB_blocks.db = null;
DB_blocks.dbName = "ANNODE_blocks";
DB_blocks.bSUPPORTED = false;


/**
 * @author {Mr.Scatman}
 */
 DB_blocks.___init=async($onLoadCallback=null, $callbackCallback=null)=> {
    if (DB_blocks.bSUPPORTED==false) {
        if ($onLoadCallback!=null) $onLoadCallback([], [], $callbackCallback);
        return;
    }
    //open existing (or new, if first time) DB_blocks.
    var done = await DB_blocks.openConnection(DB_blocks.dbName, 2);
    if (done==true) {
        var aBlocks = await DB_blocks.loadAll("blocks");
        if ($onLoadCallback!=null) {
            $onLoadCallback(aBlocks, $callbackCallback);
        }
    }
    else if ($onLoadCallback!=null) {
        $onLoadCallback([], $callbackCallback);
    }
}

DB_blocks.getDBSize=async()=> {
    var size = await DB_blocks.getDBTblSize("blocks");
    return size;
}

DB_blocks.getDBTblSize=async($tbl, $method="readwrite")=> {
    var transaction  = DB_blocks.db.transaction([$tbl], $method);
    if (transaction==null) return;
    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;
    return new Promise((resolve, reject) => {
        //FULL PULL HISTORY RETREIVAL
        if ('getAll' in objectStore) {
            objectStore.getAll().onsuccess = function(event) {
                var arr = event.target.result;
                var json = JSON.stringify(arr);
                size = json.length;
                return resolve(size);
            };
        } 
    });
}




/**
 * @author {Mr.Scatman}
 */
DB_blocks.___deleteEntireDB=async()=> {
    if (DB_blocks.bSUPPORTED==false) return;
    if (DB_blocks.db==null) return;
    return new Promise((resolve, reject) => {
        DB_blocks.db.close();
        var request = indexedDB.deleteDatabase(DB_blocks.dbName, 2);
        request.onblocked = function () {
            console.log("Delete blocked.");
            return resolve(false);
        }
        request.onerror = function () {
            console.log("Error deleting the DB");
            return resolve(false);
        };
        request.onsuccess = function () {
            console.log("Deleted OK.");
            return resolve(true);
        }   
    });             
}

/**
 * @author {Mr.Scatman}
 */
DB_blocks.openConnection=async($dbName, $version)=> {
    if (DB_blocks.db!=null) return true;
    return new Promise((resolve, reject) => {
        var request = indexedDB.open($dbName, $version);
        request.onerror = function(event) {
            console.log("openConnection request.Error");
            return resolve(false);
        };

        request.onsuccess = function(event) {
            DB_blocks.db = event.target.result;
            return resolve(true);
        };
        
        request.onupgradeneeded = function(event) {
            console.log("openConnection request.onUpradeneeded");
            DB_blocks.db = event.target.result;

            var blocksObjStore = DB_blocks.db.createObjectStore("blocks", { keyPath:"blockId" });
            blocksObjStore.createIndex("blockId", "blockId", { unique: true });
        
            return resolve(false);  //no load needed
        };
    });
}


DB_blocks.loadAll=async($tbl, $method="readwrite")=> {
    if (DB_blocks.db==null) return;
    if (DB_blocks.db.transaction==undefined) {
        return;
    }
    
    var transaction  = DB_blocks.db.transaction([$tbl], $method);
    if (transaction==null) return;

    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;

    return new Promise((resolve, reject) => {
        //FULL PULL HISTORY RETREIVAL
        if ('getAll' in objectStore) {
            objectStore.getAll().onsuccess = function(event) {
                return resolve(event.target.result);
            };
        } 
        else {
            var arr = [];

            // Fallback to the traditional cursor approach if getAll isn't supported.
            objectStore.openCursor().onsuccess = function(event) {
                var cursor = event.target.result;
                if (cursor) {
                    arr.push(cursor.value);
                    cursor.continue();
                } 
                else return resolve(arr);
            };
        }
    });
}



DB_blocks.___insert = async($objs, $tbl="blocks", $method="readwrite", $callaback=null)=> {
    if (DB_blocks.bSUPPORTED==false) return;
    if ($objs.length==0) return;
    var transaction  = DB_blocks.db.transaction([$tbl], $method);
    if (transaction==null) return;
    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;
    return new Promise((resolve, reject) => {    
        $objs.forEach(function($obj) {
            var request = null;
            request = objectStore.add($obj);
        });
        transaction.onsuccess = function(event) {
            return resolve(true);
        };
        transaction.onerror = function(event) {
            console.warn("fail "+$tbl+" add, do next");
            return resolve(false);
        }
        return resolve(true);
    });
}


DB_blocks.___insert_single = async($obj, $tbl="blocks", $method="readwrite", $callaback=null)=> {
    if (DB_blocks.bSUPPORTED==false) return;
    var transaction  = DB_blocks.db.transaction([$tbl], $method);
    if (transaction==null) return;
    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;
    return objectStore.add($obj);    
}


DB_blocks.___update = async($block, $tbl="blocks", $method="readwrite", $callaback=null)=> {
    if (DB_blocks.bSUPPORTED==false) return;
    var transaction  = DB_blocks.db.transaction([$tbl], $method);
    if (transaction==null) return;
    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;
    
    return new Promise((resolve, reject) => {
        var request = objectStore.put($block);
        request.onsuccess = function(event) {
            return resolve(true);
        };
        request.onerror = function(event) {
            console.log(event);
            return resolve(false);
        }
    });
}


DB_blocks.___delete = async ($blockids, $tbl="blocks", $method="readwrite", $callback=null)=> {
    if (DB_blocks.bSUPPORTED==false) return false;
    if ($blockids.length==0) return false;
    var transaction  = DB_blocks.db.transaction([$tbl], $method);
    if (transaction==null) return;
    var objectStore = transaction.objectStore($tbl);
    if (objectStore==null) return;
    for (var t=0; t < $blockids.length; t++) {
        if ($blockids[t]==undefined || typeof $blockids[t]!=='string') continue;
        await DB_blocks.__deleteFinal(objectStore, $blockids[t]);
    }
}


DB_blocks.__deleteFinal = async($objectStore, $blockids)=>{
    return new Promise((resolve, reject) => {
        var request = $objectStore.delete($blockids);
        request.onsuccess = function(event) { 
            return resolve(true); 
        }
        request.onerror = function(event) { 
            return resolve(false); 
        } 
    });
}