

//throttle for high traffic situations.
const MAX_BAIL_ON_NON_RELATED_ANNEX = 20;
const MAX_BAIL_ON_NON_RELATED_BOOSTIES = 20;
const MAX_BAIL_ON_NON_RELATED_HANAI = 20;

class anne_msg {
    constructor ($type, $msg, $msg_el, $showtime=5000, $sound=null, $ico="", $recourseCallback=null) {
        this.type=$type;
        this.msg=$msg;
        this.msg_el=$msg_el;    //prepped msg el.
        this.showtime=$showtime;
        this.sound=$sound;
        this.ico=$ico;
        this.recourseCallback = $recourseCallback;
        this.showDelay = 300;
        this.el=null;
        this.sound2 = null;
        this.height = -1;
        this.bDEADEVENTS = false;   //set when interrupting on purpose to go back.

        this.st_index = ANNE.MSGS.getNextTrackingIndex();

        this.testValue = "";
        this.msgObj = null;
    }
}

class anne_messages {
    constructor() {
        this._msgs=[];
        this._OLD_MSGS=[];
        this.el_messages = null;    //will show our messages.
        this._activeMsg = null;
        this._bINIT=false;
        this._divActions = "";
        this._bDOINGSYSMSGS = true;
        this._bMSGINPROGRESS = false;
        this.sequential_tracking_index=0;
        this._backClickTimes = [];


        this.bDOINGBACK = false;
        
    }

    getNextTrackingIndex=function() {
        this.sequential_tracking_index+=1;
        return this.sequential_tracking_index;
    }

    init = function() { 
        this._bINIT = true;
        console.warn("init!"); 
    }

    initMsgs = function($el_msgs="msgs_alerts") {
        this.el_messages = ANNE.A.show($el_msgs);
        this._bINIT = true;

        this.el_back = document.getElementById("btn_msg_back");
        if (this.el_back==null) {
            console.log("this module must have btn_msg_back in the DOM");
            return;
        }
   
        this.el_back.addEventListener("click", async(e)=>{
            console.log("go back bGOINGBACK"+this.bDOINGBACK);
            if (ANNE.MSGS.bGOINGBACK==true) {
                
                return;
            }
            const now = Date.now()/1000;
            ANNE.MSGS._backClickTimes.push(now);
            var hits=0;
            for (var t=0; t < ANNE.MSGS._backClickTimes.length; t++) {
                var diff = (now - ANNE.MSGS._backClickTimes[t]);
                if (diff < 2000) {
                    if (ANNE.SETTINGS.debug()==true) console.log("HIT! t="+t+" diff:"+diff+" now:"+now+" slot "+ANNE.MSGS._backClickTimes[t]);
                    hits+=1;
                    if (hits>7) {
                        //console.log(ANNE.MSGS._backClickTimes);
                        ANNE.MSGS._backClickTimes = [];
                        ANNE.SETTINGS.playSlowDown();
                        return;
                    }
                }
            }
            var done = await ANNE.MSGS.showPrevMessage();
            ANNE.MSGS.bDOINGBACK=false;
        });
    }

    
    /**
     * Set an actions div to get actions to the gui
     * 
     * @param {string}
     * @author {Mr.Scatman}
     */
    setActionsDivid = function ($a) { 
        this._divActions=$a;
    }

    addWelcomeBackMsg = async()=> {
        console.log("%c addWelcomeBackMsg", TALK.bggreen);
        this.addNewMsg("welcome_back", "Welcome back fren!", null, 5000, "modem_dial");
    }
    

    addWelcomeMsg = async()=> {
        console.log("%c addWelcomeMsg", TALK.bggreen);
        await this.addNewMsg("welcome", "Welcome, too ANNE, beautiful h00man.", null, 8000, "beautiful");
    }

    addSysWarningMsg = async($warning, $recourseCALLBACK=null)=> {
        console.log("%c addSysWarningMsg", TALK.bggreen);
        await this.addNewMsg("sys-warning", $warning, null, 8000, "attention", $recourseCALLBACK);
    }

    doThumb = async($el, $nid)=> {
        var nObj = MEMG.getNeuronByNid($nid);
        var beNOBJ = nObj.getParent();
        if (beNOBJ!=null) {
            var eldiv = document.createElement("div");
            eldiv.classList = "msg-img";
            $el.appendChild(eldiv);
            return await ANNE.IMAGES.getBasicB64Thumb(beNOBJ, nObj, eldiv, "", 0,36,36)
        }
        return;
    }

    /**
     * TO DO ---> alter sound based on current user and their involvement
     * @param {*} $msgObj 
     * @param {*} $showtime 
     */
    doHanai=async($msgObj, $showtime=5000)=> {
        var sound = null;
        var bInvolved = false;

        var $asset_nid=$msgObj.nid;
        var $new_sponsor= $msgObj.sponsornid;
        var $height = $msgObj.height;

        if ($new_sponsor==USER._userNObj.nid) {
            if (ANNE.SETTINGS.isPrefValue("show_my_hanais", false)==true) {
                console.log("skipping show of my hanai");
                return;
            }
            if (ANNE.SETTINGS.isPrefValue("sound_my_hanais", false)==false) {
                sound = ANNE.SETTINGS.theme["my_neuron_hanaid"];  
            } 
            bInvolved = true;
        }
        else {
            if (ANNE.SETTINGS.isPrefValue("show_other_hanais", false)==true) {
                console.log("skipping show of other hanai");
                return;
            }
            if (this._msgs.length>MAX_BAIL_ON_NON_RELATED_HANAI) return;
            if (ANNE.SETTINGS.isPrefValue("sound_other_hanais", false)==false) {
                sound = ANNE.SETTINGS.theme["other_neuron_hanaid"]; 
            } 
            bInvolved=false;
        }
        var el = document.createElement("span");
        el.classList.add("msg-msg");
        
        await ANNE.MSGS.doThumb(el, $asset_nid);
        
        this.makeNeuronLink(el, $asset_nid, "msg-neuron-link");
        var sp = document.createElement("span");
        sp.innerHTML="<span class='msg-whitetype'>hanai'd</span> to <b>ANNE</b> by";
        //sp.setAttribute("title", "at height "+$height);
        el.appendChild(sp);

        if (bInvolved==false) {
            this.makeNeuronLink(el, $new_sponsor, "msg-neuron-link");
        }
        else {
            var sp2 = document.createElement("span");
            sp2.classList="msg-whitetype highlight-self";
            sp2.innerHTML="you";
            el.appendChild(sp2);
        }

        var sp3 = document.createElement("span");
        sp3.classList="msg-block";
        sp3.innerHTML="@block <b>"+$height+"</b>";
        el.appendChild(sp3);

        var msg = await this.addNewMsg("hanai", "",  el, $showtime, sound);
        msg.height = $height;
        msg.msgObj = $msgObj;
        this.showNextMessage();
    }


    /**
     * TO DO ---> alter sound based on level.
     *       ---> alter sound based on current user and their involvement
     * @param {*} $msgObj
     * @param {*} $showtime 
     */
    doAnnex=async($msgObj, $showtime=5000)=> {
        var sound = null;
        var sound2 = null;
        var bInvolved = false;

        var $asset_nid = $msgObj.nid;
        var $new_sponsor= $msgObj.sponsornid;
        var $old_sponsor = $msgObj.annexedfromnid;
        var $annies = $msgObj.annies;
        var $lvl= $msgObj.level;
        var $height= $msgObj.height;

        if ($old_sponsor!=USER._userNObj.nid) {
            
            //this doesn't pertain to us and we have too many msgs queued.
            if ($new_sponsor!=USER._userNObj.nid) {
                if (ANNE.SETTINGS.isPrefValue("show_other_annexed", false)==true) {
                    console.log("skipping show of other annexed");
                    return;
                }
                if (this._msgs.length>MAX_BAIL_ON_NON_RELATED_BOOSTIES) return;

                if ($lvl<=7) sound = ANNE.SETTINGS.theme["fomo"+$lvl];
                else sound = ANNE.SETTINGS.theme["fomo7"];
                bInvolved = false;

                if (ANNE.SETTINGS.isPrefValue("sound_other_annexed", false)==true) {
                    sound=null;
                }
            }

            //we are the new annexer!  We got it!
            else {
                if (ANNE.SETTINGS.isPrefValue("show_i_annexed", false)==true) {
                    console.log("skipping show of i annexed");
                    return;
                }
                if ($lvl<=8) sound = ANNE.SETTINGS.theme["ian_l"+$lvl];
                else sound = ANNE.SETTINGS.theme["ian_l8"];
                sound2 = ANNE.SETTINGS.theme["kaching"];  
                
                bInvolved = true;

                if (ANNE.SETTINGS.isPrefValue("sound_i_annexed", false)==true) {
                    sound=null;
                }
            }
        }

        else {
            if (ANNE.SETTINGS.isPrefValue("show_i_got_annexed", false)==true) {
                console.log("skipping show of i got annexed");
                return;
            }
            if (ANNE.SETTINGS.isPrefValue("sound_i_got_annexed", false)==false) {
                sound = ANNE.SETTINGS.theme["mna_l"+$lvl];
                sound2 = ANNE.SETTINGS.theme["kaching"];
            }
            bInvolved = true; 
        }

        var el = document.createElement("span");
        el.classList.add("msg-msg");
        
        await ANNE.MSGS.doThumb(el, $asset_nid);
        this.makeNeuronLink(el, $asset_nid, "msg-neuron-link");

        var sp = document.createElement("span");
        sp.innerHTML="<b class='lvl-msg'>A"+$lvl+"</b>&nbsp;<span class='msg-whitebgtype'>annex'd</span> ";
        sp.setAttribute("title", "at height "+$height);
        el.appendChild(sp);

        if (bInvolved==false) {
            this.makeNeuronLink(el, $new_sponsor, "msg-neuron-link");
        }
        else {
            var sp2 = document.createElement("span");
            sp2.classList="msg-blacktype";
            if ($new_sponsor==ANNE.USER._userNObj.nid) {
                sp2.innerHTML="by you";
            }
            else {
                sp2.innerHTML="from you";
            }
            el.appendChild(sp2);
        }
        
        var annecoin = ANNE.UTILS.formatNumber($annies/100, true);
        ANNE.GUI_STUFF.doAnneSpan(el, "for ", annecoin);

        var sp3 = document.createElement("span");
        sp3.classList="msg-block";
        sp3.innerHTML="@block <b>"+$height+"</b>";
        el.appendChild(sp3);

        var msg = await this.addNewMsg("annex", "",el, $showtime, sound);
        msg.height = $height;
        msg.msgObj = $msgObj;
        if (sound2!=null) msg.sound2 = sound2; 
        this.showNextMessage(); 
    }


    /**
     * TO DO ---> alter sound based on level.
     *       ---> alter sound based on current user and their involvement
     * @param {*} $msgObj
     * @param {*} $showtime 
     */
    doBoosty=async($msgObj, $showtime=5000)=> {
        var sound = null;
        var bInvolved = false;
        var $asset_nid = $msgObj.nid;
        var $sponsor = $msgObj.sponsornid;
        var $annies = $msgObj.annies;
        var $lvl = $msgObj.lvl;
        var $height = $msgObj.height;
        
        if ($sponsor==USER._userNObj.nid) {
            if (ANNE.SETTINGS.isPrefValue("show_my_boosties", false)==true) {
                console.log("skipping show of my boosty");
                return;
            }
            if (ANNE.SETTINGS.isPrefValue("sound_my_boosties", false)==false) {
                sound = ANNE.SETTINGS.theme["my_boosty"];
            }
            bInvolved = true;    
        }
        else {
            if (this._msgs.length>MAX_BAIL_ON_NON_RELATED_BOOSTIES) return;
            if (ANNE.SETTINGS.isPrefValue("show_other_boosties", false)==true) {
                console.log("skipping show of other boosty");
                return;
            } 
            if (ANNE.SETTINGS.isPrefValue("sound_other_boosties", false)==false) {
                sound = ANNE.SETTINGS.theme["other_boosty"];
            }
            bInvolved = false
        }

        var el = document.createElement("span");
        el.classList.add("msg-msg");
        
        await ANNE.MSGS.doThumb(el, $asset_nid);

        this.makeNeuronLink(el, $asset_nid, "msg-neuron-link");
        
        var sp = document.createElement("span");
        sp.innerHTML="pumped up";
        sp.setAttribute("title", "at L"+$lvl+" height "+$height);
        el.appendChild(sp);

        var annecoin = ANNE.UTILS.formatNumber($annies/100, true);
        ANNE.GUI_STUFF.doAnneSpan(el, "+", annecoin," <span class='msg-whitebgtype'>boosties</span> by");
        
        if (bInvolved==false) {
            this.makeNeuronLink(el, $sponsor, "msg-neuron-link");
        }
        else {
            var sp2 = document.createElement("span");
            sp2.classList="msg-whitetype highlight-self";
            sp2.innerHTML="you";
            el.appendChild(sp2);
        }

        var sp3 = document.createElement("span");
        sp3.classList="msg-block";
        sp3.innerHTML="@block <b>"+$height+"</b>";
        el.appendChild(sp3);

        var msg = await this.addNewMsg("boosty", "", el, $showtime, sound);
        msg.height = $height;
        msg.msgObj = $msgObj;

        this.showNextMessage();
    }


    /**
     * TO DO:  (not yet passing from annode)
     * @param {*} $nid 
     * @param {*} $annies 
     * @param {*} $height 
     * @param {*} $showtime 
     * @returns 
     */
    doBoostyDrawingWinner=async($nid, $annies, $height, $showtime=5000)=> {
        var sound = null;
        var sound2 = null;
        var bInvolved = false;
        if ($nid==USER._userNObj.nid) {
            sound = ANNE.SETTINGS.theme["boosties_drawing_winner"];    //add to inception (or post add new one is fine)
            sound2 = "celebrate";
            bInvolved = true;
        }
        else {
            sound = ANNE.SETTINGS.theme["boosties_drawing_winner"];    //add to inception (or past add is fine)
        }
        
        var el = document.createElement("span");
        el.classList.add("msg-msg");
        this.makeNeuronLink(el, $asset_nid, "msg-neuron-link");
        var annecoin = ANNE.UTILS.formatNumber($annies/100, true);
        ANNE.GUI_STUFF.doAnneSpan(el, "+", annecoin);
        var sp = document.createElement("span");
        sp.innerHTML="<span class='msg-whitebgtype'>boosties</span> from drawing to";
        sp.setAttribute("title", "at L"+$lvl+" height "+$height);
        el.appendChild(sp);
        if (bInvolved==false) {
            this.makeNeuronLink(el, $sponsor, "msg-neuron-link");
        }
        else {
            var sp2 = document.createElement("span");
            sp2.classList="msg-whitetype highlight-self";
            sp2.innerHTML="you";
            el.appendChild(sp2);
        }

        var sp3 = document.createElement("span");
        sp3.classList="msg-block";
        sp3.innerHTML="@block <b>"+$height+"</b>";
        el.appendChild(sp3);

        var msg = await this.addNewMsg("boosty", "", el, $showtime, sound);
        msg.height = $height;
        if (sound2!=null) msg.sound2 = sound2;
        this.showNextMessage();
    }
    

    /**
     * TO DO ---> alter sound based on level.
     * @param {*} $msgObj
     * @param {*} $showtime 
     */
    doNewBlock=async($msgObj, $showtime=5000, $sm=false)=> {
        var sound = null; 
        if (ANNE.SETTINGS.isPrefValue("sound_other_mined_blocks", false)==false) {
            sound = ANNE.SETTINGS.theme["newblock"]; 
        }
        var $miner_nid = $msgObj.generatorId;
        var $blockId = $msgObj.blockId;
        var $height = $msgObj.height;

        var bInvolved = false;
        var el = document.createElement("span");
        el.classList.add("msg-msg");
        if ($miner_nid==USER._userNObj.nid) {
            bInvolved = true;
            if (ANNE.SETTINGS.isPrefValue("show_my_mined_blocks", false)==true) {
                console.log("skipping show of my mined blocks");
                return;
            }
        }
        else {
            if (ANNE.SETTINGS.isPrefValue("show_other_mined_blocks", false)==true) {
                console.log("skipping show of other mined blocks");
                return;
            }
        }
        
        var sp = document.createElement("span");
        sp.innerHTML="Block <b class='block-msg'>"+$height+"</b> mined by";
        sp.setAttribute("titie", "BlockId "+$blockId);
        el.appendChild(sp);
        if (bInvolved==false) {
            this.makeNeuronLink(el, $miner_nid, "msg-neuron-link");
        }
        else {
            var sp2 = document.createElement("span");
            sp2.classList="msg-whitetype highlight-self";
            sp2.innerHTML="you";
            el.appendChild(sp2);
        }
        var msg = await this.addNewMsg("newblock", "",  el, $showtime, sound);
        msg.msgObj = $msgObj;
        
        if (bInvolved==true) {
            if (ANNE.SETTINGS.isPrefValue("sound_my_mined_blocks", false)==false) {
                msg.sound2 = ANNE.SETTINGS.theme["my_newblock"];
            }
        }
        else if ($sm==true) {
            var sp2 = document.createElement("span");
            sp2.classList="msg-whitetype highlight-self";
            sp2.innerHTML="you were a share miner!";
            el.appendChild(sp2);
            if (ANNE.SETTINGS.isPrefValue("sound_my_share_mines", false)==false) {
                msg.sound2 = "sharethelove";
                msg.showtime = 9000;
            }
        }

        msg.height = $height;
        this.showNextMessage();
    }



    /**
     * 
     * @param {*} $type 
     * @param {*} $msg 
     * @param {*} $msg_el 
     * @param {*} $showtime 
     * @param {*} $sound 
     * @param {*} $recourseCallback 
     * @author {Mr.Scatman}
     * @returns 
     */
    addNewMsg = async($type, $msg, $msg_el, $showtime=5000, $sound=null, $recourseCallback=null)=> {
        if (this._bINIT==false) {
            console.warn("MSGS mod has not been init!");
            return;
        }

        var amsg = new anne_msg($type, $msg, $msg_el, $showtime, $sound, $type+"-slideico", $recourseCallback);
        this._msgs.push(amsg);

        //only show the next message if we don't have an active recourse pending.
        if (this._activeMsg==null || (this._activeMsg && this._activeMsg.recourseCallback==null)) {
            this.showNextMessage(); 
        }

        return amsg;
    }


    /**
     * 
     * @param {*} $msgSlideDiv 
     * @param {*} $msgObj 
     * @param {*} $max 
     */
    spliceInOthersLikeThis = function($msgSlideDiv, $msgObj, $max=10) {
        var others = [];
        var type = $msgObj.type;
        var h = $msgObj.h;

        if (type=="newblock") $max = 4;

        //console.log("getOthersOf: "+type)
        for (var m=0; m < this._msgs.length; m++) {
            
            //no skips if we have a new block stretch but others in between.
            if (type=="newblock") {
                if (this._msgs[m].type!=type) break;
                if ($msgObj.sm==true && this._msgs[m].sm==false) {
                    break;
                }
                if ($msgObj.sm==false && this._msgs[m].sm==true) {
                    break;
                }
            }

            //if we hit a new block on our scan-forward for a non newblock type, 
            //we don't want to bunch up the alerts with differing heights.
            else {
                if (this._msgs[m].type=="newblock") break;
            }

            if (this._msgs[m].type==type) {
                others.push(this._msgs[m]);
                this._msgs.splice(0,1);
                m=m-1;
                //console.log("found other of "+type);
                if (others.length>=$max) break;
                continue;
            }
        }
        
        if (others.length>0) {
            for (var o=0; o<others.length; o++) {
                //console.log("audit type:"+others[o].type);
                others[o].msg_el.classList.add("bullet-point");
                $msgSlideDiv.append(others[o].msg_el);
            }
        }
    }


    /**
     * Back after nothing -- goes to last.
     * Back while something, goes to the prev before that.
     * @returns 
     */
    showPrevMessage = async()=> {
        if (ANNE.SETTINGS.debug()==true) console.log("%c showPrevMessage", TALK.bggreen);
        if (ANNE.MSGS._activeMsg!=null && ANNE.MSGS._activeMsg.recourseCallback!=null) {
            return;
        }

        if (this._OLD_MSGS.length>0 || this._activeMsg!=null) {

            if (this._activeMsg.sound!=null) {
                await ANNE.SETTINGS.stopAllMemes(this._activeMsg.sound);
            }
            
            //we want to interrupt the current msg, 
            //and go to the one before it.
            if (this._bMSGINPROGRESS==true) {
                this._msgs.unshift(this._activeMsg);        //put the LAST msg back in the front of the line.
                this._activeMsg.bDEADEVENTS=true;
                this._bMSGINPROGRESS = false;
                
                //we must break any javascript timers/events/loops/asyncs
                //that come back after we want this object to go bye bye
                ANNE.MSGS.remove(this._activeMsg.el);

                //set new active msg to the msg BEFORE this one (that is playing)
                this._activeMsg = this._OLD_MSGS.pop(); 
            }
        } 

        else return;
            
        if (this._activeMsg.st_index!=1 && this._activeMsg.recourseCallback==null) {
            ANNE.A.show(this.el_back);
        }
        else {
            ANNE.A.hide(this.el_back);
        }

        return this.showSlide(this._activeMsg.el);  //don't await this.
    }


    /** 
     * @author {Mr.Scatman}
     */
     showNextMessage = async()=> {
        if (this._bMSGINPROGRESS==true) return;
        if (ANNE.__DO_NOT_INTERRUPT==true) return;
        
        if (this._msgs.length>0) {
            if (this._activeMsg!=null) {
               this._OLD_MSGS.push(this._activeMsg);
            }
            
            //shift the first from the array.
            this._activeMsg = this._msgs.shift();    //get the next in the queue

            if (this._activeMsg.st_index!=1 && this._activeMsg.recourseCallback==null) {
                ANNE.A.show(this.el_back);
            }
            else {
                ANNE.A.hide(this.el_back);
            }
            
            var msgSlideDiv = null;
            if (this._activeMsg.el!=null) {
                //console.log("this is a re-showing");
                msgSlideDiv=this._activeMsg.el;
            }
            else {
                msgSlideDiv = document.createElement("div");
                msgSlideDiv.classList = "show msg-slide "+this._activeMsg.type+"-slide active";
                if (this._activeMsg.msg_el==null) {
                    var fullmsg = "<span class='"+this._activeMsg.ico+"'></span><span>"+this._activeMsg.msg+"</span>";
                    msgSlideDiv.innerHTML = fullmsg;    
                }
                else {
                    var sp = document.createElement("span");
                    sp.classList = this._activeMsg.ico;
                    msgSlideDiv.append(sp);
                    msgSlideDiv.append(this._activeMsg.msg_el);
                    //if (this._activeMsg.type=="newblock") {
                       //this.spliceInOthersLikeThis(msgSlideDiv, this._activeMsg, 4);
                    //}
                }
                if (this._activeMsg.recourseCallback!=null) {
                    this.buildRecourseEl(msgSlideDiv);
                }
                this._activeMsg.el = msgSlideDiv;
            }

            await this.showSlide(msgSlideDiv)
        }
    }


    /**
     * 
     * @param {*} $msgSlideDiv 
     */
    showSlide=async($msgSlideDiv)=> {
        //console.log("%c showSlide %c msg "+ANNE.MSGS._activeMsg.msg, TALK.bggreen, TALK.bgyellow);
        this._bMSGINPROGRESS = true;

        var showtime = ANNE.MSGS._activeMsg.showtime;
        showtime = ANNE.MSGS.adjustShowtime(showtime);
        ANNE.MSGS.el_messages.appendChild($msgSlideDiv);
        $msgSlideDiv.style.opacity=0;
        ANNE.A.fadeIn($msgSlideDiv, ANNE.MSGS._activeMsg.showDelay);
        const msg = ANNE.MSGS._activeMsg;

        //the show sound...
        var actualDuration = 0;
        if (ANNE.MSGS._activeMsg.sound!=null) {
            actualDuration = await ANNE.SETTINGS.playMeme(ANNE.MSGS._activeMsg.sound);
        }
                
        if (ANNE.MSGS._activeMsg.sound2!=null) {
            //const msg2 = ANNE.MSGS._activeMsg;
            //ANNE.A.delayThen(msg2, 1000, function($msg) {
            var secondDuration = await ANNE.SETTINGS.playMeme(ANNE.MSGS._activeMsg.sound2);
            //});
            if (actualDuration==0) actualDuration = secondDuration;
            actualDuration = Math.max(secondDuration, actualDuration);
        }

        //we want the song to finish.
        var maxshowtime = Math.max(actualDuration*1000, showtime);
        //console.log(maxshowtime);
        ANNE.A.delayThen(msg, maxshowtime, function($msg) {
            if ($msg.bDEADEVENTS==true) { 
                ANNE.MSGS.remove($msg.el);
                $msg.bDEADEVENTS=false;
                ANNE.MSGS._bMSGINPROGRESS = false;
                console.log("graceful kill of old pending message");
                return;
            }
            if (ANNE.MSGS._activeMsg.recourseCallback!=null) {
                console.warn("RECOURSE NEEDED -- handle the alert!");
            }
            else {
                const oldMsgEl = ANNE.MSGS._activeMsg.el;
                ANNE.A.fadeOut(oldMsgEl, 500, 0, "power1.out", function(){
                    ANNE.MSGS.remove(oldMsgEl);
                    ANNE.MSGS._bMSGINPROGRESS = false;
                    ANNE.MSGS.showNextMessage();
                });
            }
        });
        
    }


    /**
     * 
     * @param {*} $msgSlideDiv 
     */
    buildRecourseEl=function($msgSlideDiv) {
        var btnlink = document.createElement("span");
        btnlink.innerHTML="take action!";
        btnlink.classList.add("sys-warning-link");
        $msgSlideDiv.appendChild(btnlink);
        var mainlogo = document.getElementById("main_logo");
        if (mainlogo!=null) {
            mainlogo.src = "../imgs/anne_logo_black.png";
        }
        const __CALLBACK__ = this._activeMsg.recourseCallback;
        btnlink.addEventListener("click", e=>{
            var mainlogo = document.getElementById("main_logo");
            if (mainlogo!=null) {
                mainlogo.src = "../imgs/anne_logo.png";
            }
            const oldMsgEl = ANNE.MSGS._activeMsg.el;
            ANNE.A.fadeOut(oldMsgEl, 500, 0, "power1.out", function(){
                ANNE.MSGS.remove(oldMsgEl);
                ANNE.MSGS._bMSGINPROGRESS = false;
                ANNE.MSGS.showNextMessage();
            });
             __CALLBACK__(e);
        });
    }



    /**
     * 
     * @param {*} $showtime 
     * @returns 
     */
    adjustShowtime = function($showtime) {
        if (this._msgs.length<12) return $showtime;
        if (this._msgs.length<36) return $showtime/2;
        if (this._msgs.length<72) return $showtime/3;
        return $showtime/4;
    }


    remove = function($el) {
        if (this.el_messages==null) return;
        if (this.el_messages.contains($el)==true) {
            this.el_messages.removeChild($el);
        }
    }


    /**
     * Default page (link type) is dossier view.
     * pass a valid page type to alter the link being created.
     */
    makeNeuronLink=function($el, $nid, $class="", $page="dossier") {
        if ($nid==undefined || $nid==null) {
            return null;
        }
        if ($el==null) {
            return null;
        }
        var el = ANNE.A.__getEl($el);
        if (el==null) {
            console.log("missing el");
            return null;
        }
        var span=document.createElement("span");
        
        span.classList="btn-launch "+$class;
        var nObj = MEMG.getOrMakeIfNew($nid);
        var ico = EXT_BTNS.doBestIco(nObj, ico);
        if (nObj.text=="") span.classList.add("msg-neuron-link-needs-update");
        span.innerHTML = ico+nObj.bestNameHTML();
        span.setAttribute("nid", $nid);
        span.addEventListener("click", e=>PAGES.launchNeuron($nid, $page, e));
        el.append(span);
        if($page==null || $page==undefined || typeof $page!="string") $page="";
        span.setAttribute("page", $page);
        return span;
    }

}

var MSGS = new anne_messages();