
class app_setting {
    constructor($uniqueID, $misc_value, $gui_lbl="") {
        this.uniqueID = $uniqueID;
        this.misc_value = $misc_value;
        this.lbl = $gui_lbl;
        this.user_nid = ANNE.USER._userNObj.nid;
    }    
}

class anne_theme {
    constructor() {
        this.prefs = [];
        this.themeNOBJ = null;
        this.bTEMPLATE_LOADED=false;

        this.prefKeys = [];

        this.mna_l1 = "996521064301576896";
        this.mna_l2 = "17824765796982100075";
        this.mna_l3 = "11184944955394493688";
        this.mna_l4 = "10294198808226867626";
        this.mna_l5 = "4300015670485404424";
        this.mna_l6 = "12616883919027597127";
        this.mna_l7 = "4906224273794375165";
        this.mna_l8 = "8789137472706815334"; 
        
        this.ian_l1 = "16323476955851933691";
        this.ian_l2 = "5294989851292560166";
        this.ian_l3 = "17589218429643319107";
        this.ian_l4 = "4043028941454787233";
        this.ian_l5 = "2933439000888073077";
        this.ian_l6 = "12662041291037980641";
        this.ian_l7 = "14503828866437816472";
        this.ian_l8 = "7024879988342290014";

        this.fomo1 = "9498169532497325891";
        this.fomo2 = "2371191317338754318";
        this.fomo3 = "10573729000266298899";
        this.fomo4 = "243051425726245576";
        this.fomo5 = "16846158618903457559";
        this.fomo6 = "10003390746960320220";
        this.fomo7 = "14503828866437816472";

        this.my_neuron_hanaid = "3010279832609565908";           //you got the love
        this.other_neuron_hanaid = "10489040092802317893";       //country road

        this.my_boosty = "14860455264892603684";    //pump up the jam
        this.other_boosty = "9096817755716534506";  //you got to pump it up

        this.newblock = "16305046316222181999";
        this.my_newblock = "3302896526091730295";
        this.slowdown = "12553820840916844419";
        this.boosties_drawing_winner = "16182940446251723219";
        this.kaching = "650151099554609727";
        
    }

    /**
     * load the definition of the theme.
     * @param {*} $themeNOBJ 
     */
    __loadThemeTemplate = function($themeNOBJ) { 
        this.themeNOBJ = ANNE.MEM.ANNE_THEME;

        var rels = ANNE.MEMG.getAllParamRelons($themeNOBJ.outs);
        //console.log("sb 32 "+rels.length);
        for (var r=0; r < rels.length; r++) {
            var rel = rels[r];
            if (rel.to_s!=ANNE.MEM.preference.nid) {
                //console.log("non pref param, skip here.")
                continue;
            }
            var prefNOBJ = MEMG.getNeuronByNid(rel.reln);
            this.prefs.push(prefNOBJ);
            this.prefKeys.push(prefNOBJ.nid);
        }

        //console.log("total prefs in template:"+this.prefs.length);
        this.bTEMPLATE_LOADED=true;
    }


    /**
     * 
     * @param {*} $themeInstNObj 
     */
    loadThemeInst = async($themeInstNObj)=> {
        if (this.bTEMPLATE_LOADED==false) {
            alert("load theme template first");
            return;
        }

        if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("mapping inst "+$themeInstNObj.text+" to "+this.prefs.length+" prefs");
        var mapped = 0;

        var lookup_dagnab=[];
        
        for (var p=0; p < this.prefs.length; p++) {
            var prefNOBJ = this.prefs[p];
            
            //console.log("pref name:"+prefNOBJ.text+" nid:"+prefNOBJ.nid);
            var prefRel = ANNE.MEMG.getHasRelon($themeInstNObj.outs, prefNOBJ.temp_nid);
            if (prefRel==null) {
                lookup_dagnab.push(prefNOBJ.nid);
            }
        }

        if (lookup_dagnab.length>0) {
            lookup_dagnab.push($themeInstNObj.nid);
            console.log("missing "+lookup_dagnab.length+" nids");
            await IDB.lookupNids(null, lookup_dagnab, [], "missing theme nids from preload");
            var lookup_dagnab2 = [];
            for (var p=0; p < this.prefs.length; p++) {
                var prefNOBJ = this.prefs[p];
                
                //console.log("pref name:"+prefNOBJ.text+" nid:"+prefNOBJ.nid);
                var prefRel = ANNE.MEMG.getHasRelon($themeInstNObj.outs, prefNOBJ.temp_nid);
                if (prefRel==null) {
                    lookup_dagnab2.push(prefNOBJ.nid);
                }
            }
            if (lookup_dagnab2.length>0) await ANNE.API.lookupNids(lookup_dagnab2, [0,1,2,3,4], false, false, "missing bootup theme nids");
        }

        var still_missing=0;
        for (var p=0; p < this.prefs.length; p++) {
            var prefNOBJ = this.prefs[p];
            
            //console.log("pref name:"+prefNOBJ.text+" nid:"+prefNOBJ.nid);
            var prefRel = ANNE.MEMG.getHasRelon($themeInstNObj.outs, prefNOBJ.temp_nid);
            if (prefRel!=null) {
                mapped+=1;

                var valueNOBJ = MEMG.getOrMakeIfNew(prefRel.to_s);

                //console.log("value:"+valueNOBJ.text);
                var dataRelativePath = ANNE.MEMG.getHasRelon(valueNOBJ.outs, MEM.dataRelativePath.temp_nid);
                var dataUrl = ANNE.MEMG.getHasRelon(valueNOBJ.outs, MEM.dataUrl.temp_nid);
                var afile = new anne_file();
                afile.nid = valueNOBJ.nid;
                this[prefNOBJ.nid] = afile;
                    
                if (dataRelativePath!=null) {
                    await afile.setFromLocalRelativePathAndLoad(valueNOBJ, dataRelativePath.to_s);
                    //console.log("did pref nid "+prefNOBJ.nid);
                }

                //load by neuron and dataUrl.
                else {
                    afile.setFromNeuronAndLoad(valueNOBJ);
                }
            }
            else {
                still_missing+=1;
                console.warn("file neuron "+prefNOBJ.text+" still not found... :(")
            }
        }
        if (still_missing>0) {
            console.warn("still missing sound neurons:"+still_missing);
        }
        
        if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("total mapped:"+mapped);
    }
}

class anne_settings {
    constructor() {
        this._aActions = [];
        this._actionsHistory = [];
        this._aSettings = [];

        //volume
        this._pref_volume_onoff = 1;
        this.el_volume = null;

        this.el_debug = null;

        this._tmdb_key = "f6c6c0a4bff37a87365e3099e7caf7ff";    //for now, use mine.
        this._next_action_id = 0;

        this._bINIT = false;

        this.theme = new anne_theme(); //load default theme template.
        this.current_key = "";

		this.PDNS_active = false;
        this.BOUNTY_active = false;
        this.ASDF_active = false;
        this.ANNDLE_active = false;

        this.bSERVERSIDE_ERROR_LOGGING = false; //(TODO) send debug logs to js dev peer
        this.bDATAMESSAGES = true;              //let the app stream in new data messages

        this.bCONSOLE_DEBUG = false;            //debug print various areas
        this.bCONSOLE_DEBUG_EXTERNAL = true;    //print extended debug prints for api/extended coms
        this.bPRELOADALLDATA = true;           //on anneid page, first load, load all data
        this.bUICOS = false;
        
        //experimental setting to just load all IDB data into the app straightaway.
        //This would be a fine design decision for small or medium footprints. 
        //It gets sketchy with very large numbers of relons/neurons.
        this.bMAXIMIZE_JS_MEM = true;

        //not yet enforced
        this.bANTORIMGSONLY=false;

        this.bDOWIKIPEDIA = true;
        this.bDOWIKISPOOKS = true;
        this.bAUTOHANAI=true;

        this._maxMsgBlockGap = 10;
    }  


    debug = function() { return this.bCONSOLE_DEBUG;}
    debugOn = function() {  return this.bCONSOLE_DEBUG;}
    isDebug = function() { return this.bCONSOLE_DEBUG;}
    
    isDebugExternal = function() { return this.bCONSOLE_DEBUG_EXTERNAL;}
    debugExternals = function() { return this.bCONSOLE_DEBUG_EXTERNAL;}
    debugExternal = function() { return this.bCONSOLE_DEBUG_EXTERNAL;}
    
    playSlowDown=async()=>{
        if (this.current_key!=undefined) {
            this.stopMeme( this.current_key);
        }
        if (this.theme==null) return;
        if (this.theme.slowdown==undefined || this.theme.slowdown==null) return;
        return this.playMeme(this.theme.slowdown);
    }


    /**
     * 
     * @param {*} $key 
     * @returns 
     */
    playMeme=async($key)=> {
        if (ANNE.SETTINGS!=null && ANNE.SETTINGS.soundOk()==false) return 0;
        if ($key=="" || $key==null || $key==undefined) return;
        var afile = this.theme[$key];
        this.current_key = $key;
        if (afile==null) {
            ANNE.A.play($key);
            return 0;
        }

        if (afile.last_audio==null) afile.last_audio = new Audio(afile.b64data);
        
        if (afile.last_audio!=null && isNaN(afile.last_audio.duration)==true || afile.last_audio.duration==undefined || afile.last_audio.duration==null) {
            return new Promise((resolve, reject) => {
                afile.last_audio.addEventListener('loadedmetadata', function() {
                    //console.log('Duration: ' + afile.last_audio.duration + ' seconds');
                    afile.last_audio.play();
                    return resolve(afile.last_audio.duration);
                });
            });
        }
        else {
            afile.last_audio.play();
            return afile.last_audio.duration;
        }
    }

    
    stopAllMemes = async($keyStopFirst="")=> {
        console.log("STOP ALL MEME SOUNDS "+this.theme.prefs.length);
        if ($keyStopFirst!="") this.stopMeme($keyStopFirst);
        for (var p=0; p < this.theme.prefKeys.length; p++) {
            var key = this.theme.prefKeys[p];
            if (key==$keyStopFirst) continue;
            this.stopMeme(key);
        }
        return;
    }

    
    stopLastMeme=function() {
        if (this.current_key=="") return;
        this.stopMeme(this.current_key);
    }

    
    stopMeme=function($key) {
        if ($key==undefined || $key==null || $key=="") return;
        var afile = this.theme[$key];
        if (afile==null) {
            ANNE.A.stopPlay($key);
            return;
        }
        if (afile.last_audio!=null) {
            afile.last_audio.pause();
            afile.last_audio.currentTime = 0;
        }
    }

  
    /** 
     * init the settings -- init the msgs 
     * load the meme/site theme.
     * @author {Mr.Scatman}
     */
    init=async($volIcoEl="footer_link_sound", $debugEl="footer_link_debug")=> {
        if (this._bINIT==true) return;

        if (ANNE.MSG!=null) {
            ANNE.MSG.init(this);
        }
        this.initVolume($volIcoEl);
        this.initDebug($debugEl);
        this._bINIT = true;

        //load up theme.
        
        this.theme.__loadThemeTemplate(ANNE.MEM.ANNE_THEME);
        this.theme.loadThemeInst(ANNE.MEM.THEME_default);

        this.msgPrefsMap = new Object();
        this.msgPrefsForDAT = {};
    }

    loadPrefIfExists=function($prefKey, $default=true) {
        var localPref = this.getPref($prefKey);
        if (localPref==null) {
            this.msgPrefsForDAT[$prefKey]=$default;
            return;
        }
        this.msgPrefs[$prefKey] = localPref;
        if (localPref.misc_value=="true") localPref.misc_value=true;
        else localPref.misc_value=false;
        
        this.msgPrefsForDAT[$prefKey] = localPref.misc_value;
    }

    loadMsgPrefGUI = function($folder) {
        //console.log(this._aSettings);
        this.msgPrefs = {};
        var folderMsgBanner = $folder.addFolder("DataStream", "dg-d2");
        var folderMsgShow = folderMsgBanner.addFolder("show", "dg-d3");
        var folderMsgSound = folderMsgBanner.addFolder("sound", "dg-d3");
        
        var local_prefs_loader = [
            {pref:"show_my_hanais", default:true, title:"my hanais"},
            {pref:"sound_my_hanais", default:true, title:"my hanais"},
            {pref:"show_other_hanais", default:true, title:"other hanais"},
            {pref:"sound_other_hanais", default:true, title:"other hanais"},
            
            {pref:"show_my_mined_blocks", default:true, title:"my mined blocks"},
            {pref:"sound_my_mined_blocks", default:true, title:"my mined blocks"},
            {pref:"show_other_mined_blocks", default:true, title:"other mined blocks"},
            {pref:"sound_other_mined_blocks", default:true, title:"other mined blocks"},
            
            {pref:"show_my_share_mines", default:true, title:"my share mines"},
            {pref:"sound_my_share_mines", default:true, title:"my share mines"},
            
            {pref:"show_my_boosties", default:true, title:"my boosties"},
            {pref:"sound_my_boosties", default:true, title:"my boosties"},
            {pref:"show_other_boosties", default:true, title:"other boosties"},
            {pref:"sound_other_boosties", default:true, title:"other boosties"},
            
            {pref:"show_i_annexed", default:true, title:"i annexed"},
            {pref:"sound_i_annexed", default:true, title:"i annexed"},
            {pref:"show_i_got_annexed", default:true, title:"I got annexed"},
            {pref:"sound_i_got_annexed", default:true, title:"my annexes"},
            {pref:"show_other_annexed", default:true, title:"other annexed"},
            {pref:"sound_other_annexed", default:true, title:"other annexes"},
        ];

        for (var p=0; p < local_prefs_loader.length; p++) {
            var lp = local_prefs_loader[p];
            this.loadPrefIfExists(lp.pref, lp.default);

            var folder = folderMsgSound;
            if (lp.pref.indexOf("show")==0) folder = folderMsgShow;

            if (lp.misc_value==false || lp.misc_value=="false") {
                consol.log(lp);
            }

            
            folder.add(ANNE.SETTINGS.msgPrefsForDAT, lp.pref).name(lp.title).onChange(
                function(value){
                    console.log(value);
                    console.log(this);
                    var val = "blah";
                    var prop = this.property;
                    if (value==true) val = "true";
                    else val = "false";
                    ANNE.SETTINGS.setPref(prop, val, "");
                }
            );
        }
    }

    
    /**
     * 
     * @returns 
     */
    soundOk = function() {
        if (this._pref_volume_onoff==-1) return false;
        return true;
    }


    
    /** 
     * Load the settings from the db.
     * 
     * @param {array}
     * @author {Mr.Scatman}
     */
     setSettings = async($aSiteSettings, $volIcoEl="footer_link_sound", $debugEl="footer_link_debug")=> { 
        await this.init($volIcoEl, $debugEl);
        
        if ($aSiteSettings.length) {
            await this.__loadSettings($aSiteSettings);    
        }

        return;
    }


    /**
     * 
     * @param {*} $volIcoEl 
     * @returns 
     */
    initVolume=function($volIcoEl="footer_link_sound") {
        this.el_volume = ANNE.A.__getEl($volIcoEl);
        if (this.el_volume==null) return;
        this.el_volume.addEventListener("click", this.event_flipVolume);
        this.setVolumeHTML(this.el_volume);
    }
    initDebug=function($debugEl="footer_link_debug") {
        this.el_debug = ANNE.A.__getEl($debugEl);
        if (this.el_debug==null) return;
        this.el_debug.addEventListener("click", this.event_flipDebug);
        this.setDebugHTML(this.el_debug);
    }

    
    /**
     * @author {Mr.Scatman}
     */
    event_flipVolume=async()=> {
        if (ANNE.SETTINGS.debug()==true) console.log("flipVolume");
        ANNE.SETTINGS._pref_volume_onoff = ANNE.SETTINGS._pref_volume_onoff*-1;

        ANNE.SETTINGS.setVolumeHTML(ANNE.SETTINGS.el_volume);

        //alter the setting in our db.
        ANNE.SETTINGS.__addEditSetting("explorerapp_volume", ANNE.SETTINGS._pref_volume_onoff, ANNE.SETTINGS.el_volume.id);

        //broadcast sound event.
        const customEvent = new CustomEvent(ANNE.EVENT_SOUND_CHANGE, { bubbles: true, cancelable: true, });
        document.dispatchEvent(customEvent);
    }

    event_flipDebug=async()=> {
        if (ANNE.SETTINGS.debug()==true) console.log("flipDebug");
        if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) ANNE.SETTINGS.bCONSOLE_DEBUG=false; 
        else ANNE.SETTINGS.bCONSOLE_DEBUG=true; 

        ANNE.SETTINGS.setDebugHTML(ANNE.SETTINGS.el_debug);

        //alter the setting in our db.
        ANNE.SETTINGS.__addEditSetting("explorerapp_debug", ANNE.SETTINGS.bCONSOLE_DEBUG+"", ANNE.SETTINGS.el_debug.id);
    }


    /**         
     * @author {Mr.Scatman} 
     */
     __setVolumePref=function($volPref=1, $volIcoEl="footer_link_sound") {
        this._pref_volume_onoff = $volPref;
        if (ANNE.SETTINGS.debug()==true) console.log("volume set to:"+this._pref_volume_onoff);
        this.setVolumeHTML($volIcoEl);
    }
    __setDebugPref=function($debugPref=true, $debugIcoEl="footer_link_debug") {
        if ($debugPref=="true") this.bCONSOLE_DEBUG = true;
        else this.bCONSOLE_DEBUG =false;
        console.log("volume debug to:"+this.bCONSOLE_DEBUG);
        this.setDebugHTML($debugIcoEl);
    }


    /**
     * 
     * @param {*} $volIcoEl 
     */
    setVolumeHTML=function($volIcoEl) {
        if (ANNE.SETTINGS._pref_volume_onoff==-1) {
            ANNE.A.setHTML($volIcoEl,'<i class="ai-volume-mute"></i>volume.<b class="pr4"><span class="text-red">off</span></b>&nbsp;');
            ANNE.SETTINGS.stopLastMeme();
        }
        else ANNE.A.setHTML($volIcoEl, '<i class="ai-volume-up"></i> volume.<b class="pr4"><span class="text-green">on</span></b>&nbsp;');
    }

    setDebugHTML=function($volIcoEl) {
        if (ANNE.SETTINGS.bCONSOLE_DEBUG==false) ANNE.A.setHTML($volIcoEl,' debug.<b class="pr4"><span class="text-red">off</span></b>&nbsp;');
        else ANNE.A.setHTML($volIcoEl, ' debug.<b class="pr4"><span class="text-green">on</span></b>&nbsp;');
    }
    

    /**
     * This is the main function called from external on a generalized setting
     * setting --- or update.
     * 
     * @param {*} $unique 
     * @param {*} $misc_value 
     * @param {*} $gui_id_or_lbl 
     * @param {*} $bTESTVALUE 
     * @returns 
     */
    setPref = async($unique="", $misc_value, $gui_id_or_lbl="", $bTESTVALUE=false)=> {
        if ($unique=="tmdb_key") {
            ANNE.SETTINGS._tmdb_key = $misc_value;
        }
        return await this.__addEditSetting($unique, $misc_value, $gui_id_or_lbl, $bTESTVALUE);
    }


    /**
     * @param {*} $unique 
     * @param {*} $misc_value 
     * @param {*} $lbl 
     * @param {*} $bTESTVALUE 
     * @returns 
     */
    __addEditSetting = async ($uniqueID="", $misc_value, $gui_id_or_lbl="", $bTESTVALUE=false)=>{
        
        //there is no updating the setting because the key is unique+misc_val+user.
        //if the val changes the setting is dead.
        
        var setting = this.__existingSetting($uniqueID, $misc_value, $bTESTVALUE);
        if (setting==null) {
            if (ANNE.SETTINGS.debug()==true) console.log("(__addEditSetting) inserting new preference");
            setting = this.__makeSettingObj($uniqueID, $misc_value, $gui_id_or_lbl);
            ANNE.playSound("click");
            this._aSettings.push(setting); 
            return await ANNE.DB.___insert_single(setting, "settings");
        }
        else {
            if (ANNE.SETTINGS.debug()==true) console.log("(__addEditSetting) updating preference");
            ANNE.playSound("click");
            await ANNE.DB.___deleteSetting(setting.uniqueID, setting.misc_value, USER._userNObj.nid);
            
            setting.misc_value = $misc_value; //alter the setting in memory.

            return await ANNE.DB.___insert_single(setting, "settings");
        }
    }

    
    /**
     * 
     * @param {*} $setting 
     * @param {*} $bTESTVALUE 
     * @returns 
     */
    __existingSetting = function ($uniqueID, $misc_value, $bTESTVALUE=true) {
        for (var a=0; a < this._aSettings.length; a++) {
            var setting = this._aSettings[a];
            if (setting.user_nid != USER._userNObj.nid) continue;
            if (setting.uniqueID != $uniqueID) continue;
            if ($bTESTVALUE==true && setting.misc_value != $misc_value) continue;
            return setting;
        }
        return null;
    }

    
    /**         
     * This makes a setting obj but doesn't yet store it in local DB memory.
     * @param {string}
     * @param {string} - nid longstring
     * @param {string} - a label
     * 
     * @author {Mr.Scatman} 
     */
    __makeSettingObj = function($unique="", $misc_value="", $gui_id_or_lbl="") {
        var setting = new app_setting($unique, $misc_value, $gui_id_or_lbl);
        return setting;
     }


    /**
     * 
     */
    __loadSettings = async ($aSiteSettings)=> {
        for (var a=0; a < $aSiteSettings.length; a++) {
            var settingsObj = $aSiteSettings[a];
            if (ANNE.SETTINGS.debug()==true) console.log(settingsObj);
            
            if (settingsObj.user_nid!=USER._userNObj.nid) continue;
            
            this._aSettings.push(settingsObj);

            var setting = new app_setting (settingsObj.uniqueID, settingsObj.misc_value, settingsObj.lbl);

            //we stored text of boolean, not boolean.
            if (setting.misc_value=="false") setting.misc_value=false;
            else if(setting.misc_value=="true") setting.misc_value = true;

            //preload the volume of the exploreapp, if it is a setting.
            if (setting.uniqueID=="explorerapp_volume") {
                this.__setVolumePref( parseInt(setting.misc_value), setting.lbl);
            }
            else if (setting.uniqueID=="explorerapp_debug") {
                this.__setDebugPref(setting.misc_value, setting.lbl);
            }

            //should have used the uniqueID as the same ID in either SETTINGS or ANNE space mem.
            //then i don't need custom handlers here.  Will do that for the else.

            else if (setting.uniqueID=="data_messages") {
                this.bDATAMESSAGES = setting.misc_value;
                if (this.bDATAMESSAGES==false) {
                    if (ANNE.NET!=null) ANNE.NET.stopInterval();
                }
            }

            else if (setting.uniqueID=="send_js_debug") {
                this.bSERVERSIDE_ERROR_LOGGING = setting.misc_value;
                
            }
            

            //preload the tmdb_key if it is a setting
            else if (setting.uniqueID=="tmdb_key") {
                this._tmdb_key = setting.misc_value;
            }

            else {
                if (setting.uniqueID=="bICOS") continue; //dead, ignore it.
                console.log("setting anne settings var '"+setting.uniqueID+"' to: "+setting.misc_value)
                this[setting.uniqueID]=setting.misc_value;
            }
        }
    }


    getPref = function($uniqueID) {
        return this.getSetting($uniqueID);
    }
    getSetting=function($uniqueID) {
        for (var p=0; p < this._aSettings.length; p++) {
            var setting=this._aSettings[p];
            if (setting.user_nid!=USER._userNObj.nid) continue;
            if (setting.uniqueID==$uniqueID) {
                return setting;
            }
        }
        return null;
    }
    isBoolLike=function($val) {
        return /^(true|false)$/i.test($val);
    }
    isPrefValue=function($uniqueID, $val) {
        var pref = this.getPref($uniqueID);
        if (pref==null) return false;
        if (pref.misc_value==$val) {
            return true;
        }
        if (ANNE.SETTINGS.isBoolLike(pref.misc_value)==true) {
            $val = $val+"";
            if (pref.misc==$val) return true;
        }
        return false;
    }

    /**
     * 
     * @param {*} $class_nid 
     * @returns 
     */
    getAllPrefsByClass=function($uniqueID) {
        var prefs=[];
        for (var p=0; p < this._aSettings.length; p++) {
            var setting=this._aSettings[p];
            if (setting.uniqueID!=$uniqueID) continue;
            prefs.push(setting);
        }
        return prefs;
    }




    /** 
     * @author {Mr.Scatman}
     */
    _addAction=function($action) {
        this._aActions.push($action);
        $action._nid = this._next_action_id++;
    }


    /** 
     * @author {Mr.Scatman}
     */
     _deleteAdminAction=function($action) {
        alert("what is this?")
        for (var a = 0; a < this._aActions.length; a++) {
            var action = this._aActions[a];
            if (action._nid==$action._nid) {
                this._aActions.splice(a, 1);
                return;
            }
        }
        return;
    }

    /**
     * 
     * @param {*} $innerDOMDiv 
     * @param {*} $class 
     * @param {*} $msg 
     * @param {*} $id 
     * @param {*} $insertAfter 
     */
    makeAlert=function($innerDOMDiv,$class,$msg,$id="",$insertAfter=null) {
        var alert='<div class="alert '+$class+'" id="'+$id+'" role="alert">'+$msg+'</div>';
        if($innerDOMDiv!=null) {
            if($insertAfter!=null) $insertAfter.after(alert);
            else $innerDOMDiv.append(alert);
        }
    }
}


var SETTINGS = new anne_settings();