
/** 
 * ez functions for doing things clean and fast
 */

 class mem_ez extends anne_singleton {
    constructor () {
        super(false);
        this.MEM = null;
    }
    init = function($MEM) {
        this.MEM=$MEM;
    }


    getConstituentLine=function($nObj, $line=[], $depth=0) {
        var line = $line;
        if ($depth > 10) return line;

        for (var r=0; r < $nObj.outs.length; r++) {
            if ($nObj.outs[r].to_type != TO_TYPE_ANNE) continue;
            if ($nObj.outs[r].r != ANNE.MEM.constituent_of.temp_nid) continue;
            if (line.indexOf($nObj.nid)!=-1) {
                console.log("ut oh.");
                return line;
            }
            line.push($nObj.nid);
            var cNOBJ = MEMG.getNeuronByTempNid($nObj.outs[r].t);
            return this.getConstituentLine(cNOBJ, line, ($depth+1));
        }

        return line;
    }


    /**
     * 
     * @param {*} $fromNOBJ 
     * @param {*} $reln 
     * @param {*} $test_loc_to_s 
     * @returns 
     */
    isBestLocation=function($fromNOBJ, $reln, $test_loc_to_s=null) {    
        if ($test_loc_to_s==null) {
            ANNE.consoleError("must have (isBestLocation) $test_loc_to_s here");
            return false;
        }
        
        var tests = [];

        for (var r=0; r < $fromNOBJ.outs.length; r++) {
            if ($fromNOBJ.outs[r].reln!=$reln) continue;
            if ($fromNOBJ.outs[r].to_type!=TO_TYPE_ANNE) continue;
            tests.push($fromNOBJ.outs[r]);
        }

        if (tests.length==0) {
            return true;
        }
        
        var testLOC = MEMG.getNeuronByNid($test_loc_to_s);
        console.log("test for new best location: %c"+testLOC.text, ANNE.TALK.bggreen);
        
        var constituent_line = this.getConstituentLine(testLOC);
        //ANNE.TALK.printNids(constituent_line, "candidate for new best location")

        for (var t=0; t < tests.length; t++) {
            var toNOBJ = MEMG.getNeuronByTempNid(tests[t].t);

            //We have this exact location.
            if (toNOBJ.nid==$test_loc_to_s) {
                return true;    
            }
            
            //our new neuron is better info than the existing... as 
            //our existing location is in the constituent line of our new neuron.
            if (constituent_line.indexOf(toNOBJ.nid)!=-1) {
                console.log("new line is the best, but we already have an inferior one we should be pruning.");
                return true;
            }

            //if the neuron we have already includes the test_loc_to_s line,
            //then it is not better.
            var line = this.getConstituentLine(toNOBJ);
            ANNE.TALK.printNids(line, "existing location line")
            if (line.indexOf($test_loc_to_s)!=-1) {
                console.log("existing line is more refined");
                return false;
            }
        }

        return true;
    }


        
    /********** EZ query/search pattern based ez functions **********/
    /*** ALL EZ FUNCTIONS only use the .r, .f, .t, .owned_by, .sponsored_by
        "from.be", and "to.bes" dennotations.
    ***/

    /**
     * Get nObjs of all the instance neurons for this class.
     * These are children that instantiated this class.
     * @param {Object} - The neuron
     */
    ez_getInst_nObjs = function($nObj) {
        if ($nObj.children.length==0) return [];
        var nObjs = [];
        for (var c=0; c< $nObj.children.length; c++) {
            var childNOBJ = MEMG.getNeuronByTempNid($nObj.children[c]);
            if (childNOBJ.type==NTYPE_INST) nObjs.push(childNOBJ);   
        }
        return nObjs;
    }


    /**
     * Get all nObjs that match in the inbound pattern.
     * return nObjs matching the pat. 
     * @param {Object} - The neuron
     * @param {Object} - The pattern 
     */
    ez_getIns_nObjs = function($nObj, $pat) {
        var relons = MEMZ.ez_getIns($nObj, $pat);
        var nObjs = [];
        if (relons.length) {
            nObjs = MEM.extractFromNObjsFromRelons(relons, false, false); 
            console.log(nObjs);
        }
        return nObjs;
    }


    /**
     * Get all relons that match in the inbound pattern.
     * return relons matching the pat. 
     * 
     * 
     * @param {Object} - The neuron
     * @param {Object} - The pattern
     * 
     * @author {Mr.Scatman}
     */
    ez_getIns = function($nObj, $pat) {
        var ins = $nObj.ins;
        var relons = [];
        for (var i=0; i < ins.length; i++) {
            var rObj = ins[i];
            if ($pat.type!=undefined && rObj.type!=$pat.type) continue;
            if ($pat.r!=undefined && rObj.r!=$pat.r) continue;
            
            var fNOBJ = null;
            if ($pat.owned_by!=undefined && $pat.owned_by!="") {
                fNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                if (fNOBJ.owned_by!=$pat.owned_by) continue;
            }
            if ($pat['from.be']!=undefined) {
                var from_be = $pat['from.be'];
                if (fNOBJ==null) fNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                if (MEM.besOf(fNOBJ, from_be)==false) continue;
            }
            relons.push(rObj);
        }
        return relons;
    }


    //this gets all children of a class..
    //matches for a class..
    //then verfies a supporting relon exists.
    //used in getGlobalLocation to get locations,
    //match children,
    //then confirm the location is a constituent of a certain neuron.

    //a better pattern would be: search for the constituent parent..
    //(narrows results)
    //then search for constiuent ofs which match the text. (fewer checks)
    ez_testGraphPat1=function($be_temp_nid, $textMatch, $restrictR, $restrictTo, $to_type=TO_TYPE_ANNE, $bDONOBJS=true) {
        var pats = [];
        var pat1 = {type:"neuron", subtype:"getAllChildren", be:$be_temp_nid};
        pats.push(pat1);
        var pat2 = {type:"neuron", subtype:"textMatch", casesensitive:false, partials:false, target:$textMatch, nObjs:[], temp_nids:[]};
        pats.push(pat2);
        var pat3 = {type:"relon", subtype:"relnTo", reln_temp_nid:$restrictR, to:$restrictTo, to_type:TO_TYPE_ANNE, bDONOBJS:$bDONOBJS, nObjs:[], temp_nids:[]};
        pats.push(pat3);
        return MEMZ.ez_getNeuronByGraphPat(pats);
    }

    ez_testGraphPat2=function($be_temp_nid, $restrictR, $restrictToTnid, $to_type=TO_TYPE_ANNE, $bDONOBJS=true) {
        var pats = [];
        var pat1 = {type:"neuron", subtype:"getAllChildren", be:$be_temp_nid, nObjs:[], temp_nids:[]};
        pats.push(pat1);
        var pat3 = {type:"relon", subtype:"relnTo", reln_temp_nid:$restrictR, to:$restrictToTnid, to_type:TO_TYPE_ANNE, bDONOBJS:$bDONOBJS, nObjs:[], temp_nids:[]};
        pats.push(pat3);
        return MEMZ.ez_getNeuronByGraphPat(pats);
    }


    //resolves multi relons to a single concept.
    //can be made robust to allow for optional values to match
    //(or not to match)
    //or values to not contradict (but not have to be present)
    ez_multiRelResolver=function($be_temp_nid, $relToPartials=[]) {
        var pats = [];
        var pr = $relToPartials[0];
        var pat1 = {type:"relon", subtype:"relnToNid", be:$be_temp_nid, reln_temp_nid:pr.r, to:pr.t, to_type:TO_TYPE_ANNE, nObjs:[], temp_nids:[] };
        pats.push(pat1);
        for (var r=1; r < $relToPartials.length; r++) {
            var pr = $relToPartials[r];
            var patx = {type:"relon", subtype:"relnTo", reln_temp_nid:pr.r, to:pr.t, to_type:TO_TYPE_ANNE, bDONOBJS:true, nObjs:[], temp_nids:[]};
            pats.push(patx);
        }
        return MEMZ.ez_getNeuronByGraphPat(pats);
    }

    //WORK IN PROGRESS..
    //a new implementation of the concept of searching by pat..
    //This is a baby step towards a full ACQL implementation.
    ez_getNeuronByGraphPat = function($pats) {
        var temp_nids = [];
        var active_nids = [];
        var last_pat = null;
        for (var p=0; p < $pats.length; p++) {
            var pat = $pats[p];
            if (pat.type==undefined) {
                console.log("MALFORMED PAT. Must have type.");
                return;
            }
            //search for neurons
            if (pat.type=="neuron") {
                if (pat.subtype=="getAllChildren") {
                    var be = pat.be;
                    pat.temp_nids = MEMG.getNeuronByTempNid(be).children;
                    last_pat = pat;
                }
                else if (pat.subtype=="textMatch") {
                    if (pat.partials!=undefined && pat.partials==true) {}
                    else {
                        var target = "";
                        if (pat.casesensitive==undefined && pat.casesensitive==true) {
                            target = pat.target;
                        }
                        else target = pat.target.toUpperCase();
                        
                        pat.temp_nids = [];

                        //optimize by looping nObjs instead, if we have them.
                        if (last_pat.nObjs!=undefined) {
                            for (var n=0; n < last_pat.nObjs.length; n++) {
                                var nObj = last_pat.nObjs[n];
                                if (nObj.text.toUpperCase()==target) {
                                    pat.temp_nids.push(nObj.temp_nid);
                                }
                            }
                        }
                        else {
                            for (var n=0; n < last_pat.temp_nids.length; n++) {
                                var nObj = MEMG.getNeuronByTempNid(last_pat.temp_nids[n]);
                                if (nObj.text.toUpperCase()==target) {
                                    pat.temp_nids.push(nObj.temp_nid);
                                }
                            }
                        }
                        last_pat = pat;
                    }
                }
            }

            //seach for relons filters
            else {
                if (pat.subtype=="relnToNid"){
                    var reln_temp_nid = pat.reln_temp_nid;
                    var to = pat.to;
                    var to_type = pat.to_type;
                    var be = pat.be;
                    if (be==undefined) be = null;
                    var bDONOBJS = false;
                    if (pat.bDONOBJS==true) bDONOBJS=true;
                    pat.temp_nids = [];
                    var toNOBJ = MEMG.getNeuronByTempNid(to);
                    var ins = toNOBJ.ins;
                    for (var r=0; r < ins.length; r++) {
                        if (ins[r].r!=reln_temp_nid) continue;
                        if (ins[r].to_type!=to_type) continue;
                        var nObj = MEMG.getNeuronByTempNid(ins[r].f);
                        if (be!=null) {
                            if(nObj.isT(be)==false) continue;
                        }
                        if (bDONOBJS==true) {
                            pat.nObjs.push(nObj);
                        }
                        pat.temp_nids.push(nObj.temp_nid);
                    }
                    last_pat = pat;
                }
                else if (pat.subtype=="relnTo") {
                    var reln_temp_nid = pat.reln_temp_nid;
                    var to = pat.to;
                    var to_type = pat.to_type;
                    var bDONOBJS = false;
                    if (pat.bDONOBJS==true) bDONOBJS=true;
                    pat.temp_nids = [];
                    if (bDONOBJS==true) pat.nObjs = [];
                    for (var n=0; n < last_pat.temp_nids.length; n++) {
                        var nObj = MEMG.getNeuronByTempNid(last_pat.temp_nids[n]);
                        for (var r=0; r < nObj.outs.length; r++) {
                            var rObj = nObj.outs[r];
                            if (rObj.to_type!=to_type) continue;
                            if (rObj.r!=reln_temp_nid) continue;
                            if (to_type==TO_TYPE_ANNE) {
                                if(rObj.t!=to) continue;
                            }
                            else if (to!=rObj.to_s) continue;
                            if (bDONOBJS==true) {
                                pat.nObjs.push(nObj);
                            }
                            pat.temp_nids.push(nObj.temp_nid);
                        }
                    }
                    last_pat = pat;
                }
            }
        }

        return last_pat;
    }



    /**
    * @author {Mr.Scatman}
    */
    ez_setNARRPtrsForNew=function($rObj) {
        if ($rObj==null) return;
        if (govenor.isCollabRespReln($rObj.r)==true && $rObj.type==TYPE_SYS) {
            return; //we can do this AFTER the send and confirmation of receipt.
        }

        var nObj = MEMG.getNeuronByTempNid($rObj.f);
        
        if (nObj==null) return;
        if (nObj.parent!="") $rObj.parent = nObj.parent;
        if (nObj.owned_by!="") $rObj.owned_by = nObj.owned_by;
        if (nObj.sponsored_by!="") $rObj.sponsored_by = nObj.sponsored_by;
        //if (nObj.annother!="") $rObj.annother = nObj.annother;
        $rObj.ntype = nObj.ntype;
        if (nObj.text!=null && nObj.text && $rObj.type==TYPE_BE) $rObj.text = nObj.text;
    }


    /**
    * @author {Mr.Scatman}
    */
    ez_new_param=async($fromNOBJ, $reln, $to_type, $to_s, $bSINGLESEND=true, $gui_extras=null, $callback=null, $ghostModeOveride=false)=> {
        if (ANNE._txMode==TXMODE_GHOST || $ghostModeOveride==true) {
            if ($fromNOBJ==null) {
                console.log("we need a neuron (temp or real) here");
                return null;
            }
            var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_PARAM, $reln, $to_type, $to_s, true);
            if ($gui_extras!=null) rObj.gui_extras=$gui_extras;
            var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
            return rObj;
        }
        else {
            //we are in ANNE TX mode but this neuron is not real yet.
            //It needs some help.
            if ($fromNOBJ==null || $fromNOBJ.temp==true) {
                await SENDQ.pendingFromRelon(TYPE_PARAM, $reln, $to_type, $to_s, TXB.TXTYPE_CHILD_RELON, $gui_extras, $bSINGLESEND, $callback);
            }

            else {
                var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_PARAM, $reln, $to_type, $to_s, true);
                if ($gui_extras!=null) rObj.gui_extras=$gui_extras;
                var TXTTYPE = ANNE.TXB.calcTXTTYPE(rObj);    
                await SENDQ.addRelonToSendQ(rObj, $bSINGLESEND, TXTTYPE, $callback);
            }
        }
    }



    /**
     * This does not create a clump, it creates a TYPE_CLUMP relon pointing to one.
     * @author {Mr.Scatman}
     */
    ez_new_clump=async($fromNOBJ, $reln, $to_type, $to_s, $bSINGLESEND=true, $gui_extras=null, $callback=null, $ghostModeOveride=false)=> {
        if (ANNE._txMode==TXMODE_GHOST || $ghostModeOveride==true) {
            if ($fromNOBJ==null) {
                console.log("we need a neuron (temp or real) here");
                return null;
            }
            var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_HAS, $reln, $to_type, $to_s, true);
            if ($gui_extras!=null) rObj.gui_extras=$gui_extras;
            var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
            return rObj;
        }
        
        else {
            //we are in ANNE TX mode but this neuron is not real yet.
            //It needs some help.
            if ($fromNOBJ==null || $fromNOBJ.temp==true) {
                await SENDQ.pendingFromRelon(TYPE_CLUMP, $reln, $to_type, $to_s, TXB.TXTYPE_CHILD_RELON, $gui_extras, $bSINGLESEND, $callback);
            }

            else {
                var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_CLUMP, $reln, $to_type, $to_s, true);
                if ($gui_extras!=null) rObj.gui_extras=$gui_extras;
                var TXTTYPE = ANNE.TXB.calcTXTTYPE(rObj);    
                await SENDQ.addRelonToSendQ(rObj, $bSINGLESEND, TXTTYPE, $callback);
            }
        }
        return rObj;
    }


    /**
     * no ghost for ez new sys.  Just real relons.
     * @author {Mr.Scatman}
     */
    ez_new_sys_msg = async($fromNOBJ, $reln, $to_type, $to_s, $gui_extras=null, $callback=null)=> {
        if ($reln==null) return null;
        if ($to_s==null) return null;
        if ($fromNOBJ==null) {
            console.log("we need a neuron (temp or real) here");
            return null;
        }
        if (typeof $fromNOBJ === "string") {
            $fromNOBJ = MEMG.getNeuronByNid($fromNOBJ);
            if ($fromNOBJ instanceof anne_neuron == false) {
                console.warn("bad data in fromNOBJ, needs to be an anne_neuron");
                return null;
            }
        }
        var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_SYS_MSG, $reln, $to_type, $to_s, true);
        if (rObj==null) {
            console.warn("skipping relon, rObj from makeTemprelon is null");
            return null;
        }
        var bDUPEOK = false;

        if ($gui_extras!=null) {
            rObj.gui_extras=$gui_extras;
            if ($gui_extras.dupe_ok!=undefined && $gui_extras.dupe_ok==true) {
                bDUPEOK = true;
            }
            if ($gui_extras.payment!=undefined) rObj.annies = $gui_extras.payment;
            if ($gui_extras.sys_ref_txid!=undefined) rObj.sys_ref_txid = $gui_extras.sys_ref_txid;
        }
        if (ANNE.SETTINGS.debug()==true) ANNE.TALK.printRelon(rObj);
        var TXTTYPE = ANNE.TXB.calcTXTTYPE(rObj);    
        var cmdObj = await SENDQ.addRelonToSendQ(rObj, false, TXTTYPE, $callback, bDUPEOK);
        if ($gui_extras!=null && $gui_extras.annies_offset!=undefined) cmdObj.annies += $gui_extras.annies_offset; //adjust.
        return rObj;
    }



    /**
     * Send an awareness edge.
     * 
     * Awareness edges will only ever be sent from the identity.  They cannot be collab'd on
     * as they are temporal representations of live run-time feelz and opinions.
     * 
     * FEELZ are meant to capture what is "felt".  
     * They are used to indicate how the target (relon.to_s) makes them feel.
     * IT IS NOT HOW THEY FEEL ABOUT IT.  That linguistic pattern is often 
     * short-hand for how one thinks/believes.  We want FEELZ to focus on HOW THEY MAKE YOU FEELZ.
     * 
     * Opinionz are held.  They indicate what one thinks/believes about the target.
     * 
     * We have semantic short-hand relons to capture these in a single edge without doing a full
     * semantic clump with roles.
     * 
     * "That guy is a jerk" would be an OPINIONZ. USER-> (opinionz:jerk) -> That guy.
     * If you read an article and feelz HATE because of it, that's a USER-> (feelz:HATE)->the article.
     * 
     * Note: technically, the full clump for "that is a jerk" would be:
     * NEW CLUMP.
     * NEW CLUMP-> role:who -> that guy (nid of the guy)
     * NEW CLUMP-> role:be -> is/be
     * NEW CLUMP-> role:state -> jerk
     * 
     * @author {Mr.Scatman}
     */
    ez_new_awareness=async($reln, $to_type, $to_s, $bSINGLESEND=true, $gui_extras=null, $callback)=> {
        //if (ANNE.AWARE==null) {
            //alert("you must include the awareness.js to use awareness edges");
        //}

        if ($to_type!=TO_TYPE_ANNE && $to_type!=TO_TYPE_TXID) {
            alert("awareness edges must be to_type BITCOIN or TXID");
            return;
        }

        var rObj = MEM.makeTempRelon(USER._userNObj, TYPE_AWARENESS, $reln, $to_type, $to_s, true);
        if ($gui_extras!=null) rObj.gui_extras=$gui_extras;

        if (ANNE._txMode==TXMODE_GHOST) {
            var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
            return rObj;
        }
        else {
            var tempCmdObj = await SENDQ.addRelonToSendQ(rObj, $bSINGLESEND, ANNE.TXB.TXTYPE_SELF_RELON, $callback);
        }

        return rObj;
    }




    /************************ EZ GUI STUFF ********************/
    
    /** 
     * @author {Mr.Scatman}
     */
     ezDisplayfrom_tnidList = function($el, $lbl, $list, $icoclass="", $linkType=LINKS_NEURON_TBL_VIEW) {
        if ($list==null) return;
        var links=[];
        for(var l=0; l<$list.length; l++) {
            var nObj = MEMG.getNeuronByTempNid($list[l]);
            var link = null;//LINKS.makeNeuronLink(nObj, $linkType);
            link = "FIXTHIS ezDisplayFrom_tnidList";
            links.push(link);
        }

        var hrefs="";
        if (links.length > 1) hrefs = $lbl+" "+links.join(",");
        else hrefs = $lbl+" "+links[0];

        ANNE.A.ezIcoSpan($el, "solo", $icoclass, hrefs);
    }



    /** 
     * @author {Mr.Scatman}
     */
    ezOwnerSpan=function($nObj,$divid,$lbl="owned by",$linkType=LINKS_NEURON_USER) {
        if($nObj.owned_by=="") return;
        var obNOBJ=MEMG.getOrMakeIfNew($nObj.owned_by);
        var link = "FIXTHIS ezOwnerSpan";//LINKS.makeNeuronLink(obNOBJ, $linkType);
        ANNE.A.ezlblSpan($divid,$lbl,link,"solo");
    }


    /** 
     * @author {Mr.Scatman}
     */
    ez_propDisplaySpan=function($parentdivid,$lbl,$htmlVal,$sep=": ") {
        var parent=ANNE.A.__getEl($parentdivid);
        if(parent==null) return;
        var span=document.createElement("span");
        span.style.display="inline";
        var innerspanhtml="<span style='display:inline; font-weight:bold'>"+$htmlVal+"</span>"
        span.innerHTML=$lbl+$sep+innerspanhtml;
        parent.append(span);
    }

    /**
     * @author {Mr.Scatman}
     */
    ezBesLinkPath=function($el, $nObj, $bINCLUDECLASS=false) {
        if ($nObj == null) return;
        if ($nObj.bes.length == 0) return;

        var safetyfirsteverybody = 0;
        var bes = [];
        while ($nObj.bes.length) {
            bes.push($nObj.bes[0]);
            $nObj = MEMG.getNeuronByTempNid($nObj.bes[0]);
            if ($bINCLUDECLASS==false && $nObj.temp_nid == MEM.class.temp_nid) break;
            if (safetyfirsteverybody++ > 20) break;
        }

        var revbes = bes.reverse();
        MEMZ.linkify_neurons($el, revbes);

        return;
    }
    
    linkify_neurons = function($el, $tnids, $delim="&nbsp;/&nbsp;", $max=20, $linkclass="") {
        for (var b=0; b < $tnids.length; b++) {
            var nObj = MEMG.getNeuronByTempNid($tnids[b]);
            var linkel = EXT_BTNS.makeNeuronALink($el, nObj.nid);
            if (linkel!=null && $linkclass!="") linkel.classList.add($linkclass);
            var slash = document.createElement("span");
            slash.style='display:inline-block';
            slash.innerHTML = $delim;
            $el.append(slash);
            if (b>=$max) {
                slash.innerHTML = slash.innerHTML+" ...";
                return;
            }
        }
    }


    /**
     * @author {Mr.Scatman}
     */
    ezBesCdxLinkPathWSchema=function($el, $nObj, $bINCLUDECLASS=false, $linkType=LINKS_NEURON_ANNET) {
        var el=typeof $el==="string"? document.getElementById($el):el=$el;
        if (el == null) return null;
        if ($nObj == null) return;
        if ($nObj.bes.length == 0) return;
        var nObj = $nObj;
        var p_bes = [];
        var safetyfirsteverybody = 0;
        while ($nObj.bes.length) {
            $nObj = MEMG.getNeuronByTempNid($nObj.bes[0]);
            if ($bINCLUDECLASS==false && $nObj.temp_nid == MEM.class.temp_nid) break;
            //var link = LINKS.makeNeuronLink($nObj, $linkType);
            var link = "FIXTHIS ezBesCdxLinkPathWSchema";
            p_bes.push(link);
            if (safetyfirsteverybody++>20) break;
        }
        p_bes.reverse();
        var html="";
        if (nObj.ntype=="class") {
            if (p_bes.length>1) html="subclass of "+p_bes.join("->");
            else if (p_bes.length==1) html="subclass of "+p_bes[0];
        }
        else if (p_bes.length) {
            if (p_bes.length>1) html="instance of "+p_bes.join("->");
            else if(p_bes.length==1) html="instance of "+p_bes[0];
        }
        ANNE.A.setHTML(el,html,true);
    }


    /**
     * @author {Mr.Scatman}
     */
    ezBesToLinksSpan=function($nObj,$divid,$lbl="Bes") {
        if ($nObj==null) return;
        var bes = $nObj.bes;
        if (bes.length==0) return;
        var links = [];
        for(var b=0; b<bes.length; b++) {
            var nObj = MEMG.getNeuronByTempNid(bes[b]);
            //var link = LINKS.makeNeuronLink(nObj, LINKS_NEURON_TBL_VIEW);
            var link = "FIXTHIS ezBesToLinksSpan";
            if (b==0) link = "<b>"+link+"</b>";
            links.push(link);
        }
        ANNE.A.ezlblSpan($divid, $lbl, links.join(", "));
    }

    /**
     * @author {Mr.Scatman}
     */
    ez_neuronSchemaSpan_set=function($divid,$type) {
        var el = document.getElementById($divid);
        if (el == null) {
            console.log($divid+" doesn't exist in the DOM");
            return;
        }
        el.classList.add("ai-"+$type);
        el.setAttribute("title", "this is a "+$type+" neuron");
    }

    /**
     * @author {Mr.Scatman}
     */
    ez_neuronSchemaSpan_make=function($divid,$type,$html,$classAdd) {
        var el = document.getElementById($divid);
        if(el == null) {
            console.log($divid+" doesn't exist in the DOM");
            return;
        }
        el.innerHTML = $html;
        var span = document.createElement("span");
        span.classList.add("ai-"+$type);
        if( $classAdd!="") span.classList.add($classAdd);
        span.setAttribute("title","this is a "+$type+" neuron");
        el.append(span);
    }
    
    /**
     * @author {Mr.Scatman}
     */
    ez_relon_checks=function($relons,$uniqueid="jj",$pre_msg) {
        var div=document.createElement("div");
        div.setAttribute("id","ezchks_"+$uniqueid);
        if ($pre_msg) {
            var span=document.createElement("span");
            span.innerHTML = $pre_msg;
            div.append(span);
            div.append(br);
        }
        for (var r=0; r<$relons.length; r++) {
            var relon = $relons[r];
            var talkmsg=ANNE.TALK.humanReadableRelon(relon,false);
            var checked=true;
            var disabled=true;
            if (relon.type == TYPE_HAS) disabled=false;
            A.ezCheckMark(div, "chk_"+$uniqueid+relon.txid, relon.txid, talkmsg, checked, disabled);
            var br=document.createElement("br");
            div.append(br);
        }
        div.setAttribute("id","ezchks_"+$uniqueid);
        return div;
    }



    /**
     * @author {Mr.Scatman}
     */
    ez_propDisplayRow=function($parentdivid,$lbl,$htmlVal) {
        var parent=document.getElementById($parentdivid);
        if(parent==null) return;
        var row=document.createElement("div");
        row.classList.add("row");
        var span=document.createElement("span");
        row.append(span);
        span.style.display="inline";
        var innerspanhtml="<span style='display:inline; font-weight:bold'>"+$htmlVal+"</span>"
        span.innerHTML=$lbl+": "+innerspanhtml;
        parent.append(row);
    }


    /**
     * @author {Mr.Scatman}
     */
    ez_propsDisplayRow=function($parentdivid, $objs) {
        var parent=document.getElementById($parentdivid);
        if(parent==null) return;
        var row=document.createElement("div");
        row.classList.add("row");
        var span=document.createElement("span");
        row.append(span);
        span.style.display="inline";
        var html="";
        for(var o=0;o<$objs.length;o++) {
            var innerspanhtml="<span style='display:inline; font-weight:bold'>"+$objs[o].value+"</span>"
            html=$objs[o].name+": "+innerspanhtml;
        }

        var innerspanhtml="<span style='display:inline; font-weight:bold'>"+html+"</span>"
        span.innerHTML=html;
        parent.append(row);
    }


    /**
     * Ez display props row
     * 
     * Intended for use with array of json objsct with .name and .value
     * 
     * @params {string} - div to render the results in
     * @params {array} - array of objects with prop .name and .value
     * @author {Mr.Scatman}
     * 
     */ 
    ez_propsDisplayRow2 = function($parentdivid, $objs) {
        var parent = document.getElementById($parentdivid);
        if (parent==null) return;
        var row = document.createElement("div");
        row.classList.add("row");
        var span = document.createElement("span");
        row.append(span);
        span.style.display="inline";
        var html = "";
        for (var o=0; o < $objs.length; o++) {
            var innerspanhtml = "<span style='font-weight:bold'>"+$objs[o].value+"</span>"
            html += "<div padding-left:4px;'>"+$objs[o].name+": "+innerspanhtml+"</div>";
        }
        span.innerHTML = html;
        parent.append(row);
    }


    /**
     * @author {Mr.Scatman}
     */ 
    ez_img = function($el,$ref,$w=32,$h=0,$imgClassAdd="") {
        $el.append(this.html_img($ref,$w,$h,$imgClassAdd));
    }

    html_img=function($ref,$w=32,$h=0,$imgClassAdd="") {
        if($w&&$h) return '<img src="'+$ref+'" alt="" id="'+$imgElName+'" class="img-thumbnail'+$imgClassAdd+'" height="'+$h+'" width="'+$w+'">';
        else if($h) return '<img src="'+$ref+'" alt=""  class="img-thumbnail'+$imgClassAdd+'" height="'+$h+'">';
        else if($w) return '<img src="'+$ref+'" alt="" class="img-thumbnail'+$imgClassAdd+'" width="'+$w+'">';
    }

    /**
     * @author {Mr.Scatman}
     */ 
    ez_delete_relon_span = function($el,$txid) {
        var span=document.createElement("span");
        $el.append(span);
        var deleteIt='<a href="javascript:relon_table.deleteThisRelon(\''+$txid+'\')"><span style="color:red"><i class="far fa-times-circle"></i></span></a>';
        span.innerHTML=deleteIt;
        return {span: span,deleteIt: deleteIt};
    }


    /**
     * @author {Mr.Scatman}
     */ 
    ezNeuronGarden=async($el, $nObj, $linkType=LINKS_NEURON_USER, $bDOLETDENY=true)=> {
        if ($nObj.bISIDENTITY!=null && $nObj.bISIDENTITY==true) return;
        var el = ANNE.A.__getEl($el);
        if (el==null) return null;
        var srcgarden = document.createElement("div");
        srcgarden.classList = "src-garden";
        srcgarden.id = "garden_"+$nObj.temp_nid;
        el.append(srcgarden);
        await MEMZ.ezDSGardenInfo(srcgarden, $nObj, $linkType, $bDOLETDENY);
    }


    /**
     * @author {Mr.Scatman}
     */ 
    ezNeuronSignal = function($el, $nObj, $linkType=LINKS_NEURON_USER, $guid="") {
        if ($nObj._napl!=undefined && $nObj._napl!=null && $nObj._napl.sell_status!=0) {
            $nObj._napl.sell_status_txt = MEMG.getNeuronByNid($nObj._napl.sell_status).text;
            var el = ANNE.A.__getEl($el);
            if (el==null) return null;
            var srcsignal = document.createElement("div");
            srcsignal.classList = "src-sell-signal";
            $el.append(srcsignal);
            //var link = LINKS.makeNeuronLink($nObj, $linkType, {text:$nObj._napl.sell_status_txt});
            var link = "FIXTHIS ezNeuronsignal";
            srcsignal.innerHTML="<b>sell signal</b>&nbsp;"+link;
            return srcsignal;
        }
        else if ($nObj._napl) $nObj._napl.sell_status_txt = "none";

        return null;
    }


    /**
     * @author {Mr.Scatman}
     */ 
    ezNeuronSponsor = function($el, $nObj, $linkType=LINKS_NEURON_USER, $guid="") {
        if ($nObj.sponsored_by!=undefined && $nObj.sponsored_by!=null && $nObj.sponsored_by!="") {
            var el = ANNE.A.__getEl($el);
            if (el==null) return null;
            var srcsponsoredby = document.createElement("span");
            srcsponsoredby.classList = "src-sponsoredBy";
            $el.append(srcsponsoredby);
            var sponsoredByNOBJ = MEMG.getOrMakeIfNew($nObj.sponsored_by);
            EXT_BTNS.makeNeuronALink(srcsponsoredby, sponsoredByNOBJ.nid, "", "sponsor&nbsp;");
            srcsponsoredby.title = "sponsor";
            if (sponsoredByNOBJ.nid==USER._userNObj.nid) srcsponsoredby.append(ANNE.A.span("&nbsp;(this is you!)", "text-smallest"));
            return srcsponsoredby;
        }
        return null;
    }


    /**
     * 
     * @param {*} $nObj 
     * @param {*} $instChildren 
     * @returns 
     */
    ezInstChildren = function($nObj, $instChildren=[]) {
        for (var c=0; c  < $nObj.children.length; c++) {
            var childNObj = MEMG.getNeuronByTempNid($nObj.children[c]);
            if (childNObj.ntype==NTYPE_CLASS) {
                this.ezInstChildren(childNObj, $instChildren);
            }
            else if (childNObj.ntype==NTYPE_INST) $instChildren.push(childNObj);
        }
        return $instChildren;
    }


    /**
     * @author {Mr.Scatman}
     */ 
    ezKnownChildren=function($el, $nObj) {
        if ($nObj.ntype==NTYPE_INST) return null;

        //get normal children.
        var subclassesTnids = [];
        var instTnids = [];
        for (var c=0; c  < $nObj.children.length; c++) {
            var childNObj = MEMG.getNeuronByTempNid($nObj.children[c]);
            if (childNObj.ntype==NTYPE_CLASS) subclassesTnids.push(childNObj.temp_nid);
            else if (childNObj.ntype==NTYPE_INST) instTnids.push(childNObj.temp_nid);
        }

        //functional children (instances of another class but still a child)
        if ($nObj.functional_childparent_parent!=undefined && 
            $nObj.functional_childparent_parent!=null) {
            var childrenNOBJS = ANNE.MEM.getChildrenDynamic($nObj);
            for (var c=0; c  < childrenNOBJS.length; c++) {
                var childNObj = childrenNOBJS[c];
                if (childNObj.ntype==NTYPE_CLASS) subclassesTnids.push(childNObj.temp_nid);
                else if (childNObj.ntype==NTYPE_INST) instTnids.push(childNObj.temp_nid);
            }
        }

        if ($el!=null) {
            var el_known_children = null;
            if (subclassesTnids.length || instTnids.length) {
                el_known_children = document.createElement("div");
                el_known_children.classList = "known-children";
                $el.append(el_known_children);
            }
    
            if (subclassesTnids.length) {
                var el = ANNE.A.ezEl(el_known_children, "div", "known-subclasses", "<b>known subclasses</b>&nbsp;");
                el.classList.add("dib");
                MEMZ.linkify_neurons(el, subclassesTnids, ",&nbsp");
            }
            
            if (instTnids.length) {
                var el = ANNE.A.ezEl(el_known_children, "div", "known-insts", "<b>known insts</b>&nbsp;");
                el.classList.add("dib");
                MEMZ.linkify_neurons(el, instTnids, ",&nbsp", 20, "rem8opac");
            }

            return el_known_children;
        }


        return instTnids;
    }



    /**
     * @author {Mr.Scatman}
     */ 
    ezNeuronOwner = function($el, $nObj, $linkType=LINKS_NEURON_USER, $guid="") {
        if ($nObj.bISIDENTITY!=null && $nObj.bISIDENTITY==true)  return;    //no owner displays for identity
        var el = ANNE.A.__getEl($el);
        if (el==null) return null;
        var srcOwnedBy = document.createElement("span");
        srcOwnedBy.classList = "src-ownedby";
        el.append(srcOwnedBy);
        if ($nObj.owned_by!="") {
            var owned_byNOBJ = MEMG.getOrMakeIfNew($nObj.owned_by);
            EXT_BTNS.makeNeuronALink(srcOwnedBy, owned_byNOBJ.nid, "", "<b>owner</b>&nbsp;", false, "");
            if (owned_byNOBJ.nid==USER._userNObj.nid) {
                srcOwnedBy.append(ANNE.A.span("&nbsp;(this is you!)", "text-smallest"));
            }
            else if (ANNE.isANNE(owned_byNOBJ.nid)==true) {
                srcOwnedBy.append(ANNE.A.span("&nbsp;"+ANNE.ico, "text-smallest"));
            }
            else {
                srcOwnedBy.append(ANNE.A.span("&nbsp;<span class='tiny-text bg-danger'>non-anne owned</span>", "text-smallest"));
            }
        }
        else srcOwnedBy.innerHTML = 'no owner on record';
        return srcOwnedBy;
    }
    

    ezVIPLET = function($el, $nObj, $linkType=LINKS_NEURON_TBL_VIEW) {
        var el = ANNE.A.__getEl($el);
        if (el==null) return null;
        if ($nObj._vip_let==null || $nObj._vip_let.length==0) return;
        var srcLets = document.createElement("div");
        srcLets.classList = "vip-let";
        el.append(srcLets);
        srcLets.innerHTML = "<b>vip let</b> "+LINKS.linkifyTnids($nObj._vip_let);
    }

    

    /**
     * $linkType is no longer relevant in the ANNODE APP..
     * all linkTypes launch the dossier page for that neuron.
     * (in prev iterations it could launch different widgets)
     * @author {Mr.Scatman}
     */ 
    ezNeuronBes = function($el, $nObj, $linkType=LINKS_NEURON_TBL_VIEW, $bDOREALBE=true, $classPre="neuron") {
        var el = ANNE.A.__getEl($el);
        if (el==null) return null;
        var srcBes = document.createElement("div");
        srcBes.classList = $classPre+"-bes";
        el.append(srcBes);

        if ($nObj.bes.length) {
            var ico = "";
            var ntype = "";
            if ($nObj.ntype==NTYPE_CLASS) {
                if ($nObj.be_lvl==0) ntype = "class";
                else if ($nObj.be_lvl>=1) ntype = "subclass";
            }
            else if ($nObj.ntype==NTYPE_INST) ntype = "instance";
            else ntype = "unk if class or inst";

            if ($nObj && $nObj.ai_ico!=undefined && $nObj.ai_ico!="" && $nObj.ai_ico!=null) ico = '<i class="'+$nObj.ai_ico+'"></i>';
            var span = document.createElement("span");
            span.style.display="inline-block";
            span.innerHTML=ico+'<b>be</b>:&nbsp;<span class="ntype-'+$nObj.ntype+'">'+ntype+'</span>&nbsp;of&nbsp;';
            srcBes.append(span);

            //new ext frenly.
            MEMZ.ezBesLinkPath(srcBes, $nObj, $linkType);
        }
        else srcBes.innerHTML="parent not set";

        //TO DO: fix for EXT.. no inline js links
        if ($nObj.functional_childparent_reln!=null) {
            var cpr = MEMG.getNeuronByTempNid($nObj.functional_childparent_reln);
            if ($nObj.functional_childparent_parent!=null) {
                var pa = MEMG.getNeuronByTempNid($nObj.functional_childparent_parent);
                var realBe = document.createElement("div");
                realBe.classList = "neuron-real-be-msg";
                var msg = "<b>not instantiable<</b> "+pa.bestNameHTML();
                msg = msg + " with a "+cpr.bestNameHTML()+" relationship to "+$nObj.bestNameHTML();
                realBe.innerHTML = msg
                el.append(realBe);
            }
            
            else {
                var realBe = document.createElement("div");
                realBe.classList = $classPre+"-real-be-msg";
                var msg = "children have "+cpr.bestNameHTML()+" relationship to "+$nObj.bestNameHTML();
                realBe.innerHTML = msg
                el.append(realBe);
            }
        }
        
        //check if this is an alt child a definition on its heirarchical 
        //standard parent.
        //the standard parent would have a xx->BE_PARENT-> (parent)
        else {
            if ($nObj.functional_be!=null) {
                var pasNOBJ = MEMG.getNeuronByTempNid($nObj.functional_be);
                var realBe = document.createElement("div");
                realBe.classList = $classPre+"-real-be";
                realBe.innerHTML = "<b>functional be</b> ";
                EXT_BTNS.makeNeuronALink(realBe, pasNOBJ.nid);//, $linkType);
                el.append(realBe);
            }
            else {
                var potentialAlts = $nObj.getParentAlts();
                if(potentialAlts==undefined || potentialAlts==null) potentialAlts=[];
                for (var pas=0; pas < potentialAlts.length; pas++) {
                    var pasNOBJ = MEMG.getNeuronByTempNid(potentialAlts[pas]);
                    if (pasNOBJ==null) continue;
                    //console.log("psbl alt parent:"+pasNOBJ.text);
                    if (pasNOBJ.functional_childparent_reln!=null) {
                        //console.log("psbl alt parent has functional_childparent_reln listed:"+pasNOBJ.functional_childparent_reln);

                        //country->REAL_CHILLPARENT_RELN->polity
                        //look for this reln on THIS NEURON...
                        var trobj = MEMG.getRelonByTempR($nObj.outs, pasNOBJ.functional_childparent_reln);
                        
                        //if we have this relon..
                        if (trobj!=null && trobj.t==pasNOBJ.temp_nid) {
                            $nObj.functional_be = pasNOBJ.temp_nid;
                            var realBe = document.createElement("div");
                            realBe.classList = $classPre+"-real-be";
                            realBe.innerHTML = "<b>functional be<b> ";
                            EXT_BTNS.makeNeuronALink(realBe, pasNOBJ.nid);
                            el.append(realBe);
                        }
                    }
                }
            }
        }

        return srcBes;
    }


    /**
     * Display garden and collab infos for a neuron.
     * 
     * Note: For datasources you pass the lowest (final) DS.. 
     * it has the wv_let and wv_deny and also sideways-be-inherits the _gt of the
     * last datasource.
     * 
     * @author {Mr.Scatman}
     * 
     */
    ezDSGardenInfo = async($el, $nObj, $linkType=LINKS_NEURON_DOSSIER, $bDOLETDENY=true)=> {
        var el=ANNE.A.__getEl($el);
        if (el==null) return null;

        //if they haven't been set for the user for this neuron, set them.
        await $nObj.setGovRights(USER._userNObj);

        var span = ANNE.A.createElement(el, "span", "garden-msg");
        var gardenmsg = "default";
        if ($nObj.collab_ACTION==govenor.THIS_IS_YOU) {
            gardenmsg = "No Collab on identites"
            span.classList.add("gt-nocollab");
        }
        else if ($nObj.collab_ACTION==govenor.COLLAB_NOCOLLABIDENTITY) {
            gardenmsg = "No Collab on identites"
            span.classList.add("gt-nocollab");
        }

        if ($nObj.ntype==NTYPE_CLASS) {
            if ($nObj._gt!=null) {
                var gtNOBJ = MEMG.getNeuronByTempNid($nObj._gt.t);
                if (gtNOBJ!=null) {
                    gardenmsg = gtNOBJ.text;
                    if ($nObj._gt.t==MEM.gt_owner_only.temp_nid) {
                        span.classList.add("gt-owner-only");
                    }
                }
            }
        }
        else if ($nObj.ntype==NTYPE_INST) {
            if ($nObj._gti!=null) {
                var gtiNOBJ = MEMG.getNeuronByTempNid($nObj._gti.t);
                if (gtiNOBJ!=null) {
                    gardenmsg = gtiNOBJ.text;
                    if ($nObj._gti.t==MEM.gt_owner_only.temp_nid) {
                        span.classList.add("gt-owner-only");
                    }
                }
            }
        }

        var el_gt = ANNE.A.createElement(span, "span", "", gardenmsg);
        var ico = ANNE.A.createElement(el_gt, "img", "seed-ico");
        ico.src = "../imgs/seedling_ico.png";
        ico.setAttribute("height", 20);
        ico.setAttribute("width", 20); 

        var collab_msg = await $nObj.getCollabStatusMsgHTML();
        var divx = document.createElement("div");
        divx.classList = "collab-status";
        divx.innerHTML = collab_msg;
        el.append(divx);

        if ($bDOLETDENY==false) return divx;

        //do the let/deny list.
        //this DISPLAYS the lists, it doesn't enforce them.
        if ($nObj._wv_let!=undefined && $nObj._wv_let.length) {
            if ($nObj._wv_let) MEMZ.ezDisplayfrom_tnidList($el, "<b>let</b>", $nObj._wv_let, "ai-check", $linkType);
        }
        if ($nObj._wv_deny!=undefined && $nObj._wv_deny.length) {
            if ($nObj._wv_deny) MEMZ.ezDisplayfrom_tnidList($el, "<b>deny</b>", $nObj._wv_deny, "ai-ban", $linkType);
        }
        return divx;
    }

        
    /**
     * 
     */
    genDisplayListOtherBes = function($nObj) {
        var outs = $nObj.outs;
        var other_bes = [];
        for (var r=0; r < outs.length; r++) {
            var rel = outs[r];
            if (rel.type==TYPE_BE && (rel.r!=MEM.class.temp_nid && rel.r!=MEM.inst.temp_nid && rel.r!=MEM.name.temp_nid)) {
                other_bes.push(rel);
            }
        }
        if (other_bes.length) {
            return this.genKeyPairDisplayListFromRelons(other_bes);
        }

        return "";
    }


    /**
     * 
     */
    genKeyPairDisplayListFromRelons=function($arr) {
        var kps = [];
        if  ($arr.length==0) return "";
        for (var r=0; r < $arr.length; r++) {
            var relon = $arr[r];
            var rNOBJ = MEMG.getNeuronByTempNid($arr[r].r);
            //var link = LINKS.makeNeuronLink(rNOBJ, LINKS_NEURON_ANNET);
            var link = "FIXTHIS genKeyPair";
            var reln_link = "";
            var toNOBJ = MEMG.getNeuronByTempNid(relon.t);
            if (toNOBJ && relon.type==TO_TYPE_ANNE) {
                //reln_link = LINKS.makeNeuronLink(toNOBJ, LINKS_NEURON_ANNET, {linkclass:"link-green"});
                reln_link = "FIXTHIS genKeyPairDisplayListFromRelons";
            }

            else reln_link = MEMG.__MASTER_DISPLAY_RELON_TO(relon);
            var final = link+":"+reln_link;
            kps.push(final);
        }
        return kps.join(" | ");
    }


}

var MEMZ = new mem_ez();
//freeze this ?