var ACHAT = {};
ACHAT._sessions = [];
ACHAT.defaultBlockTimeWindow = ANNE.blocks_time.week;   //1-week of time free.  Msgs retained.
ACHAT.warningBlockTimeWindow = ANNE.blocks_time.day;  
ACHAT.decryptedMax = 148;
ACHAT.last_msg_id_for_this_sesh = 0;
ACHAT._authorNOBJ = null;
ACHAT._topicNOBJ = null;
ACHAT.bVOTABLE = true;
ACHAT.bACTIVE = true;
ACHAT._voteCalls = [];
ACHAT._distroNOBJS = [];
ACHAT.bDISTROFORTHISAUTHORALREADY = false;
ACHAT.distroForThisWHO = null;
ACHAT.bANJ = false;

ACHAT.init=async($misc)=>{
    console.log($misc);
    ACHAT.last_msg_id_for_this_sesh = 0;
    ACHAT._authorNOBJ = null
    ACHAT._topicNOBJ = null;
    ACHAT.bVOTABLE = true;  //default (only using bounty chat)
    ACHAT.bACTIVE = true;   //default until we build a status after passed vote.
    ACHAT._sessions = [];
    ACHAT._voteCalls = [];
    ACHAT._distroNOBJS = [];
    ACHAT.bDISTROFORTHISAUTHORALREADY = false;
    ACHAT.distroForThisWHO = null;
    ACHAT.bANJ = false;

    var el_ca_uri = document.getElementById("achat_current_annode_uri");
    el_ca_uri.innerHTML = ANNE._annodesLS.last_uri;
    var el_active_session_name = document.getElementById("achat_active_session");
    el_active_session_name.innerHTML="";
    var el_sesh_details = document.getElementById("achat_sesh_details");
    ANNE.A.hide(el_sesh_details);
    var el_chat = document.getElementById("achat_chat");
    ANNE.A.hide(el_chat);
    var el_msgs = document.getElementById("achat_msgs");
    ANNE.A.setHTML(el_msgs, "please select a session");

    await ACHAT.getAndProcessMyACHATSessions();

    ANNE.A.setHTML("achat_name", USER._userNObj.bestNameHTML());


    //achat_msgs
    var el_achat_input = document.getElementById("achat_input");
    el_achat_input.addEventListener("input", e=>ACHAT.achat_input(e));
    el_achat_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));

    var btn_send_achat = document.getElementById("btn_send_achat");
    btn_send_achat.addEventListener("click", e=>ACHAT.achat_send(e));
    
    //get chat sessions.  store them in local db tbl w/ optmizer.
    if ($misc && $misc.achat_sesh_id!=undefined) {
        //default the ACHAT to the achat_sesh_id w/ cursor in the text field.
        await ACHAT.loadSession($misc.achat_sesh_id, true);
    }

    var bcr=el_msgs.getBoundingClientRect();
    var windowH=window.innerHeight;
    var maxmsgheight = windowH-(bcr.top);
    ANNE.A.setMaxHeights(el_msgs, maxmsgheight, maxmsgheight);
    el_msgs.scrollTop = el_msgs.scrollHeight;

    ANNE.A.hide("achat_error");
}
    

/**
 */
returnKeyPress = async($e, $this)=> {
    $e.preventDefault();
    if ($e.keyCode === 13) ACHAT.achat_send(null);
}


/**
 */
ACHAT.achat_input = async($e)=> {
    var val = ANNE.A.getValue("achat_input");
    if (val.length>ACHAT.decryptedMax) {
        val = val.substring(0, ACHAT.decryptedMax-1);
        ANNE.A.setValue("achat_input", val);
    }
    if (val.length>0) ANNE.A.show("btn_send_achat");
    else ANNE.A.hide("btn_send_achat");
}


/**
 * Send the ACHAT msg via the proveIt method.
 * NOTE: This is not an ANNE TX.  This is a p2p ANNODE msg that is validated
 * via the proveIt method.  The ANNODE being used is trusted (since you are using it) 
 * and **SHOULD** be one owned/controlled by one of the parties in the chat.  
 * It is ok if it isn't but that means technically 
 * the annode operator can see the contents of you chat when the messages are decrypted.
 * The user only sends an encrypted msg to the ANNODE (one), even if there are 1000 participants.
 * The ANNODE decrypts that on-demand and re-encrypts it w/ the shared key of the requesting party
 * when they request to see their messages.
 * 
 * Those messages are stored locally in the local indexedDB to reduce the load and optmize
 * message retrieval. 
 * 
 * Str length of 146 max will still produce an encrypted string <= 254, our limit.
 */
ACHAT.achat_send = async($e)=> {
    var val = ANNE.A.getValue("achat_input");
    ANNE.A.setValue("achat_input", "");
    if (val.length>ACHAT.decryptedMax) {
        val = val.substring(0, ACHAT.decryptedMax-1);
        ANNE.A.setValue("achat_input", val);
    }

    if (val=="") return;

    //store msg on ANNODE.
    //ANNODE will store it encrypted.
    //return all new msgs since block x (including block for those done now)
    //on return we store all new msgs (including this one) in our local DB.
    //and return them to here to process.
    var amsgs = await ANNE.CHASE.sendACHATMsgForSeshId(val, ACHAT._activeSesh.sesh_id, "achat_error");
    console.log(amsgs);
    ACHAT.addMsgs(amsgs);
}


/**
 * Any anjucator can call for a bounty distribution vote from the achat.
 */
ACHAT.activateCallVote=async($e)=>{

    //if we have no funds, there is no vote to be called or instant vote!
    var balanceObj = ACHAT._topicNOBJ.balanceObj;
    if (parseInt(balanceObj.annies) < anne_bounty.getPayout(ACHAT._topicNOBJ)) {
        console.log("not enough balance left to pay this out.");
        return;
    }
    
    var el_btn = ANNE.A.showParent("btn_call_vote", true);
    if (el_btn==undefined) return;

    //if dictator, this is instant vote.
    //a simple yes vote will trigger payment of the bounty.
    if (ACHAT._topicNOBJ.bes.indexOf(MEM.bounty.temp_nid)!=-1) {
        var ab = new anne_bounty(ACHAT._topicNOBJ);
        ab.setVals();
        var balance = 0;
        if (balanceObj!=null) balance = balance.annies;
        
        if (ab.canInstantVote(balance)==true) {
            var btn = document.getElementById("btn_instant_vote");
            ANNE.A.hide("btn_call_vote");
            btn.addEventListener("click", e=>ACHAT.instantVoteYes(e));
        }
        else {
            var btn = document.getElementById("btn_call_vote");
            ANNE.A.hide("btn_instant_vote");
            btn.addEventListener("click", e=>ACHAT.callVote(e));
        }
    }
}
    
    


/**
 * I DONT WANT TO CALL A VOTE IF I AM THE ONLY ANJUCATOR AS DICTATOR...
 * 
 * grrrrrrrrrrrrrr
 */
ACHAT.callVote = async($e)=>{
    console.warn("callVote");
    ANNE.A.hideParent("btn_call_vote", true);
    if (ACHAT._topicNOBJ.nid==null) return;
    if (ACHAT._authorNOBJ==null) return;
    await ANNE.callVote(ACHAT._topicNOBJ.nid, ACHAT._authorNOBJ.nid);
}

ACHAT.instantVoteYes = async($e)=>{
    console.warn("callVote");
    ANNE.A.hideParent("btn_call_vote", true);
    if (ACHAT._topicNOBJ.nid==null) return;
    if (ACHAT._authorNOBJ==null) return;
    await ANNE.instantVoteYes(ACHAT._topicNOBJ.nid, ACHAT._authorNOBJ.nid);
}


/**
 * in various places from annode returns we update GLKB
 */
ACHAT.updateCurrentBlockDisplay = function() {
    console.log(HISTORY._GREATEST_LAST_KNOWN_BLOCK);
    ANNE.A.setHTML("achat_current_block", HISTORY._GREATEST_LAST_KNOWN_BLOCK); 
}


/**
 * We will save sessions because the query for new sessions only gets sessions
 * from the local ANNODE being hit.
 */
ACHAT.getAndProcessMyACHATSessions = async()=> {
    var el_chat_sessions = document.getElementById("achat_sessions");
    ANNE.A.empty(el_chat_sessions);
    var sesh_participants = await ANNE.CHASE.getAllACHAT_sessions(true, "achat_error");
    var sesh_map = new Object();
    for (var s=0; s < sesh_participants.length; s++) {
        var seshp = sesh_participants[s];
        console.log(seshp);

        //if (seshp.anne_app_user!=USER._userNObj.nid) continue;
        var seshObj = sesh_map[seshp.sesh_id];
        if (seshObj==undefined) {
            seshObj = {
                sesh_id:seshp.sesh_id, 
                sesh_name:seshp.sesh_name,
                chat_permit:seshp.chat_permit,
                author_nid:seshp.author_nid,
                txid_ref:seshp.txid_ref,
                block_start:seshp.block_start,
                annode_uri:seshp.annode_uri,
                topic_nid:seshp.topic_nid,
                participants:[seshp.sesh_participant_id]
            }
            sesh_map[seshp.sesh_id]=seshObj;
            ACHAT._sessions.push(seshObj);    
        }
        else {
            if (seshObj.participants.indexOf(seshp.sesh_participant_id)==-1) {
                seshObj.participants.push(seshp.sesh_participant_id);
            }
        }
    }
    console.log(ACHAT._sessions);
    if (ACHAT._sessions.length) {
        ACHAT.buildSessionsLinks(el_chat_sessions);
    }
    ACHAT.updateCurrentBlockDisplay();
}


/**
 */
 ACHAT.buildSessionsLinks=function($el) {
    console.log("(buildSessionsLinks)");
    for (var s=0; s < ACHAT._sessions.length; s++) {
        var sesh = ACHAT._sessions[s];
        var span = ANNE.A.ezEl($el, "span", "btn-session-block", "•"+sesh.sesh_name);
        span.addEventListener("click", e=>ACHAT.sessionClicked(e, sesh.sesh_id));
        span.id="sesh_link_"+sesh.sesh_id;
    }
}


/**
 * Load the session details and snag the session msgs.
 */
 ACHAT.sessionClicked = async($e, $seshID)=> {
    console.log("(sessionClicked) seshID:"+$seshID);
    console.log($seshID);
    if (ACHAT._activeSesh && ACHAT._activeSesh.sesh_id==$seshID) return;
    var el_msgs = document.getElementById("achat_msgs");
    ANNE.A.empty(el_msgs);
    await ACHAT.loadSession($seshID, true);
 }


 /**
  */
 ACHAT.loadSession=async($seshID, $bGETNEW=true)=>{
    ACHAT.last_msg_id_for_this_sesh = 0;
    ANNE.A.empty("achat_error");
    ACHAT._activeSesh = ACHAT._getSesh($seshID);
    if (ACHAT._activeSesh==null) {
        ANNE.A.setHTML("achat_error", "can't find that achat sesh for this anne id", true);
        return;
    }
    
    //highlight the sesh link clicked.
    var els_sesh_links = ANNE.A.__getEl("achat_sessions").children;
    for (var e=0; e < els_sesh_links.length; e++) {
        var elsesh = els_sesh_links[e];
        if (elsesh.id=="sesh_link_"+$seshID) {
            if (elsesh.classList.contains("active-sesh")==false) elsesh.classList.add("active-sesh");
        }
        else elsesh.classList.remove("active-sesh");
    }

    ACHAT._topicNOBJ = null;
    ACHAT._authorNOBJ = null;
    ACHAT.bVOTABLE = true;  //default (only using bounty chat)
    ACHAT.bACTIVE = true;   //default until we build a status after passed vote.
    ACHAT._voteCalls = [];
    ACHAT._distroNOBJS = [];
    ACHAT.bDISTROFORTHISAUTHORALREADY = false;
    ACHAT.distroForThisWHO = null;

    //NOTE: we're going to need to pull a specifc set of relons
    //from each participant in order to have all the information we need
    //to show their potential votes. 

    if (ACHAT._activeSesh.topic_nid!="") {
        ACHAT._topicNOBJ = MEMG.getNeuronByNid(ACHAT._activeSesh.topic_nid);
        
        //load topic relons.
        var done = await CHASE.queryForOutsAndIns(ACHAT._topicNOBJ, true, [0,1,2,3]);
        ANNE.TALK.printRelons(done);
    }

    var el_active_session_name = document.getElementById("achat_active_session");
    ANNE.A.empty(el_active_session_name);
    //.innerHTML=ACHAT._activeSesh.sesh_name;
    
    //this is a bounty claim.
    if (ACHAT._topicNOBJ) {
        ACHAT._authorNOBJ = MEMG.getNeuronByNid(ACHAT._activeSesh.author_nid);
        if(ACHAT._topicNOBJ.bes[0]==MEM.bounty.temp_nid) {
            ANNE.A.setHTML("topic_msg", "<b>"+ACHAT._authorNOBJ.bestNameHTML()+"</b>&nbsp;has claimed the bounty.");
            EXT_BTNS.makeNeuronLink(el_active_session_name, ACHAT._topicNOBJ.nid, "", "");
        }
        else ANNE.A.setHTML("topic_msg", ACHAT._authorNOBJ.bestNameHTML()+" achat about <b>"+ACHAT._topicNOBJ.bestNameHTML()+"</b>");
    }
    else ANNE.A.setHTML("topic_msg", "unknown topic");
   
    console.log(ACHAT._activeSesh);

    var el_participants = ANNE.A.empty("sesh_participants");
    var rel_distro_srcs = MEMG.getHasRelonsTo(ACHAT._topicNOBJ.ins, MEM.distro_src.temp_nid, ACHAT._topicNOBJ.nid);
    for (var r=0; r < rel_distro_srcs.length; r++) {
        var rel_distro_src = rel_distro_srcs[r];
        var distroSrcNOBJ = MEMG.getNeuronByTempNid(rel_distro_src.f);
        if (distroSrcNOBJ==null) continue;
        console.warn("WE HAVE A DISTRO NEURON FOR THIS TOPIC(bounty) "+distroSrcNOBJ.text);
        distroSrcNOBJ.printRelons();
        ACHAT._distroNOBJS.push(distroSrcNOBJ);
        
        //we must have the distro relons. If we don't, there may have been a local
        //reset and we need to chase them.
        var rel_distro_to_who = MEMG.getHasRelon(distroSrcNOBJ.outs, MEM.distro_to_whom.temp_nid);
        if (rel_distro_to_who==null) {
            var done = await CHASE.queryForOuts(distroSrcNOBJ, true, [0,1,2,3]); 
        }

        if (rel_distro_to_who!=null) {
            var distroToWHONOBJ = MEMG.getNeuronByNid(rel_distro_to_who.to_s);
            console.warn("DISTRO TO "+distroToWHONOBJ.bestNameHTML());
            if (distroToWHONOBJ.nid == ACHAT._authorNOBJ.nid) {
                ACHAT.bDISTROFORTHISAUTHORALREADY=true;
                ACHAT.distroForThisWHO = distroToWHONOBJ;
            }
        }
    }

    for (var p=0; p < ACHAT._activeSesh.participants.length; p++) {
        var participant = ACHAT._activeSesh.participants[p];
        var pel = ANNE.A.ezEl(el_participants, "span", "dib");
        pel.style["padding-left"]="4px";
        if (participant==USER._userNObj.nid) ACHAT.bANJ=true;
        EXT_BTNS.makeNeuronLink(pel, participant);
        var participantNOBJ = MEMG.getNeuronByNid(participant);
        if (ACHAT._distroNOBJS.length) {
            await ACHAT.doVoteCallSection(participantNOBJ);
        }
    }

    //the bounty claimer could have called a vote (that's confidence!)
    await ACHAT.doVoteCallSection(ACHAT._authorNOBJ);

    ACHAT.showDistroReq();
     
    //to do, display link to VOTE CALL.
    //VOTE CALL will also gen an LNOT but the vote should be 
    //reachable here too.

    //NOTE: also should be reachable via the bounty neuron! (only by anjs)
    //NOTE: also should have a "call vote" button for anjs to call (if they did they bounty!)
    //in the dossier.. without need of chat.
    console.log("vote calls:", ACHAT._voteCalls);

    //if not the author of the ACHAT and this is votable and active,
    //activate the call a vote!
    //This should be an anjucator lest the vote call should fail.
     
     //ACHAT.bDISTROFORTHISAUTHORALREADY==false 
     
    if (ACHAT.bANJ==true && ACHAT.bVOTABLE==true && ACHAT.bACTIVE==true) {
        ACHAT.activateCallVote();
    }

    else {
        var el_btn = ANNE.A.showParent("btn_call_vote", true);
        el_btn.parentElement.innerHTML="<span class='notice'>A vote has been called</span>";
    }

    //TODO: alter relns here to include approval/denial
    await ANNE.API.participantChase(ACHAT._activeSesh.participants, [0,1,2], [MEM.distro_vote.nid], ACHAT._activeSesh.block_start);

    var el_msg = document.getElementById("achat_msgs");
    ANNE.A.empty(el_msg);
    var el_sesh_details = ANNE.A.show("achat_sesh_details");

    ANNE.A.show("achat_chat");

    //turn bg red and activate connect to this annode btn.
    if (ACHAT._activeSesh.annode_uri!=ANNE._annodesLS.last_uri) {
        ANNE.A.addRemoveClass(el_sesh_details, "bg-green", "bg-danger");
        ANNE.A.show("btn_achat_connect_to_annode");
    }
    else ANNE.A.hide("btn_achat_connect_to_annode");
    
    //blocks left beore the ACHAT self-destructs (to save room on the ANNODE)
    var blocks_used = parseInt( HISTORY._GREATEST_LAST_KNOWN_BLOCK) - parseInt(ACHAT._activeSesh.block_start);
    var blocks_left = ACHAT.defaultBlockTimeWindow-blocks_used;

    if (blocks_left<0) {
        ANNE.A.addRemoveClasses(el_sesh_details, "bg-danger", ["bg-green", "bg-warning"]); 
    }
    else if (blocks_left < ACHAT.warningBlockTimeWindow) {
        ANNE.A.addRemoveClasses(el_sesh_details, "bg-warning", ["bg-danger", "bg-green"]);
    }
    else ANNE.A.addRemoveClasses(el_sesh_details, "bg-green", ["bg-danger", "bg-warning"]);

    ANNE.A.setHTML("blocks_left", blocks_left);

    var el_achat_input = document.getElementById("achat_input");
    el_achat_input.focus();

    ACHAT.loadMsgsForSession($seshID, $bGETNEW=true);
}


ACHAT.showDistroReq = function() {
    if (ACHAT._distroNOBJS.length==0) {
        ANNE.A.hide("achatdistros");
        return;
    }
    
    var el_distros = ANNE.A.show("achatdistros");

    for (var d=0; d < ACHAT._distroNOBJS.length; d++) {
        var distroNOBJ = ACHAT._distroNOBJS[d];
        EXT_BTNS.makeNeuronLink(el_distros, distroNOBJ.nid);
        
    }
    
}

//DISTRO NEURON-> distro_src-> (BOUNTY NEURON)
//Anj user -> MEM.distro_vote.nid -> distro neuron);

ACHAT.doVoteCallSection = async($participantNOBJ)=>{
    //TYPE_HAS xdistro->distro_src.nid->topic 
    $participantNOBJ.printRelonsTypeAndReln(TYPE_SYS_MSG, MEM.distro_vote.temp_nid);
    
    //loop the distros.. There are neurons calling for a distribution.  They require a vote.
    //check for a vote call relon from a given participant.
    for (var d=0; d < ACHAT._distroNOBJS.length; d++) {
        var distroNOBJ = ACHAT._distroNOBJS[d];
        var rel_vote_calls = MEMG.getHasRelonsTo($participantNOBJ.outs, MEM.distro_vote.temp_nid, distroNOBJ.nid);
        if (rel_vote_calls.length) {
            for (var v=0; v < rel_vote_calls.length; v++) {
                var rel_vote_call = rel_vote_calls[v];
                ACHAT._voteCalls.push(rel_vote_call);
                var btncallvote = ANNE.A.showParent("btn_call_vote", false);
                ANNE.A.hide(btncallvote);
                EXT_BTNS.makeRelonViewLinkWithPre_SMART("pending vote", btncallvote.parentNode, rel_vote_call, false, 8, true);
            }
        }
    }
}



/**
 */
ACHAT.loadMsgsForSession=async($seshID, $bGETNEW=true)=>{
    if ($bGETNEW==false) return;
    var local_db_msgs = await DB_local.__getACHATMsgsOnly();
    ACHAT.addMsgs(local_db_msgs);
    //get msgs from annode for this session (that we haven't already gotten)
    var amsgs = await ANNE.CHASE.getACHATMsgsForSeshId(ACHAT._activeSesh.sesh_id, "achat_error");
    console.log(amsgs);
    ACHAT.addMsgs(amsgs);
}


/**
 * add the msgs for the sesh
 */
 ACHAT.addMsgs = function($aMsgs) {
    var el_msgs = document.getElementById("achat_msgs");
    if ($aMsgs.length) {
        $aMsgs.sort( function($a, $b) {
            if ($a.msg_id > $b.msg_id) return 1;
            else if ($a.msg_id < $b.msg_id) return -1;
            return 0;
        });
    }
    for (var m=0; m < $aMsgs.length; m++) {
        var msg = $aMsgs[m];
        if (msg.sesh_id!=ACHAT._activeSesh.sesh_id) continue;
        msg.num = m+1;
        console.log(msg);
        if (msg.msg_id < ACHAT.last_msg_id_for_this_sesh) continue;
        var fromWHO = MEMG.getNeuronByNid(msg.from_nid);
        var el_thismsg = ANNE.A.ezEl(el_msgs, "div", "achat-msg");
        var msgid = "#"+msg.num;
        var when = "<i>block "+msg.height+"&nbsp;</i>";
        ANNE.A.ezEl(el_thismsg, "div", "achat-msg-who", msgid+"&nbsp;<b>"+fromWHO.bestNameHTML()+"</b>&nbsp;"+when);
        ANNE.A.ezEl(el_thismsg, "div", "achat-msg-msg", msg.msg_decrypted);
        if (msg.msg_id>ACHAT.last_msg_id_for_this_sesh) {
            ACHAT.last_msg_id_for_this_sesh=msg.msg_id;
        }
    }
    el_msgs.scrollTop = el_msgs.scrollHeight;
    ACHAT.updateCurrentBlockDisplay();
}



/**
 */
ACHAT._getSesh = function($sesh_id) {
    for (var s=0; s < this._sessions.length; s++) { 
        if (this._sessions[s].sesh_id==$sesh_id) return this._sessions[s]; 
    }
    return null;
}