class data_resolver {
    constructor($name="", $wikipart="", $to_s="", $extras=[]) {
        this.name=$name;
        this.wikipart=$wikipart;
        this.to_s=$to_s;
        this.extras=$extras;

        //non-conceptualized assoc words to tag this with.
        this.assocs_to = [];
    }

    addExtra = function($type, $reln, $to_type, $to_s) {
        this.extras.push({type:$type, reln:$reln, to_type:$to_type, to_s:$to_s});
    }
}

/** 
 * specialized for people from wikipedia as we extract quick infos.
 */
class data_resolver_person extends data_resolver{
    constructor($name="", $wikipart="", $birth="", $death="", $person_desc="", $to_s="", $extras=[]) {
        super($name, $wikipart, $to_s, $extras);
        this.birth=$birth;
        this.death=$death;
        this.person_desc = $person_desc;
        this.targetClass=ANNE.MEM.person.nid;

        this.last_name = "";
        var parts = $name.split(" ");
        if (parts.length>1) this.last_name = parts[ parts.length-1];
        
        this.known_for = [];
        this.known_for_debug = [];
    }


    /**
     * 
     * @param {*} $aec 
     * @param {*} $text 
     * @returns 
     */
    extractKnownFor=async($text="")=> {
        if ($text.length==0) return;
        this.known_for_debug = $text.split(" and ");
    }


    /**
     * 
     * @param {*} ourObj 
     * @param {*} person_desc 
     */
    extractPersonExtras=async($text)=> {
        var lower = $text.toLowerCase();
        for (var n=0; n < ANNE.MEM.nationality.ins.length; n++) {
            var natNOBJ = ANNE.MEMG.getNeuronByTempNid(ANNE.MEM.nationality.ins[n].f);
            var nLower = natNOBJ.text.toLowerCase();

            if (lower.indexOf(nLower)!=-1) {
                this.addExtra(TYPE_BE, ANNE.MEM.nationality.nid, TO_TYPE_ANNE, natNOBJ.nid);
                lower = lower.replace(nLower, "").trim();
                $text = $text.replace(natNOBJ.text, "").trim();
            }
            else if (natNOBJ.aka_lower!=undefined && natNOBJ.aka_lower.length>0) {
                for (var a=0; a < natNOBJ.aka_lower.length; a++) {
                    if (lower.indexOf(natNOBJ.aka_lower[a])!=-1) {
                        this.addExtra(TYPE_BE, ANNE.MEM.nationality.nid, TO_TYPE_ANNE, natNOBJ.nid);
                        lower = lower.replace(nLower, "").trim();
                        $text = $text.replace(natNOBJ.aka[a], "").trim();
                    }
                }
            }
        }

        await this.extractKnownFor($text);
    }
}


class field_mapper {
    constructor($cb_resolve_obj, $aec_tag, $src_prop_name, $anne_prop_name, $type, $reln, $to_type, $incr="") {
        this.resolve_obj = $cb_resolve_obj;
        this.resolve_subj = null;
        this.resolve_alt = null;
        this.aec_tag = $aec_tag;
        this.src_prop_name = $src_prop_name;    //the source data propery
        this.anne_prop_name = $anne_prop_name;  //a property name fo ranne
        this.type = $type;                      //type of relon we will conceptualize
        this.reln = $reln;                      //reln we will conceptualize
        this.to_type = $to_type;                //to type we will conceptualize towards
        this.incr = $incr;                      //for old method of attempting to disambiguate type still used on some connectors
        this.json_objs = null;
    
        this.apply_to_types = [];
    }


    /**
     * 
     * @param {*} $type_conformed 
     * @returns 
     */
    applyToType=function($type_conformed="") {
        if (this.apply_to_types.length==0) return true;
        
        if ($type_conformed=="") {
            console.log("without a type_conformed we can't assess whether to apply this property or not.");
            return false;
        }

        //if apply to types is set, then the type conformed coming in must be in the apply to types.
        //otherwise, just skip it

        if (this.apply_to_types.indexOf($type_conformed)!=-1) return true;
        return false;
    }
}

//anne external conector search object
class aec_so {
    constructor() {

    }
}

class anne_external_connector {
    constructor($baseUri="", $src="dp", $CIRCUIT_MOD=null){
        this.baseUri = $baseUri;
        this.src=$src;
        this.CIRCUIT_MOD=$CIRCUIT_MOD;
        this.trackerMap = null;         //helps prevent same-run dupes.
        this._altConsole = null;        //alt way to print outside of CIRCUIT_MOD
        this._new_external_data=0;
    }

    resolveAmbigs = function() {

    }

    trackerIsReady=function() {
        if (this.trackerMap==undefined || this.trackerMap==null) return false;
        if (this.trackerMap.tracker==undefined || this.trackerMap.tracker==null) return false;
        return true;
    }

    setTracker = function($trackerMap) {
        this.trackerMap = $trackerMap;
    }

    hasLocation = function($location) {
        if (typeof $location !=="string") {
            return false;
        }
        if (this.trackerIsReady()==false) return false;
        var lower = $location.toLowerCase();
        var nObj = this.trackerMap.tracker.locations[lower];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return true;
        return false;
    }
    getLocation = function($location) {
        if (typeof $location !=="string") {
            return null;
        }
        if (this.trackerIsReady()==false) return null;
        var nObj = this.trackerMap.tracker.locations[$location.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return nObj;
        return null;
    }
    addLocation = function($nObj) {
        if ($nObj==null) return null;
        if (this.trackerIsReady()==false) return false;
        if (this.trackerMap.tracker.locations==undefined) {
            this.trackerMap.tracker.locations = new Object();
        }
        this.trackerMap.tracker.locations[$nObj.text.toLowerCase()] = $nObj;
        this._new_external_data+=1;
    }

    hasPerson = function($personName) {
        if (typeof $personName !=="string") {
            return false;
        }
        if (this.trackerIsReady()==false) return false;
        var nObj = this.trackerMap.tracker.people[$personName.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return true;
        return false;
    }
    
    getPerson = function($personName) {
        if (typeof $personName !=="string") {
            return null;
        }
        if (this.trackerIsReady()==false) return null;
        var nObj = this.trackerMap.tracker.people[$personName.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return nObj;
        return null;
    }
    
    addPerson = function($nObj) {
        if ($nObj==null) return null;
        if (this.trackerIsReady()==false) return false;
        this.trackerMap.tracker.people[$nObj.text.toLowerCase()] = $nObj;
        this._new_external_data+=1;
    }
    
    hasCorp = function($corpName) {
        if (typeof $corpName !=="string") {
            return false;
        }
        if (this.trackerIsReady()==false) return false;
        var nObj = this.trackerMap.tracker.corps[$corpName.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return true;
        return false;
    }
    
    getCorp = function($corpName) {
        if (typeof $corpName !=="string") {
            return null;
        }
        if (this.trackerIsReady()==false) return false;
        var nObj = this.trackerMap.tracker.corps[$corpName.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return nObj;
        return null;
    }
    
    addCorp = function($nObj) {
        if ($nObj==null) return;
        if (this.trackerIsReady()==false) return false;
        this.trackerMap.tracker.corps[$nObj.text.toLowerCase()] = $nObj;
        this._new_external_data+=1;
    }
    
    hasGroup = function($groupName) {
        if (typeof $groupName !=="string") {
            return false;
        }
        if (this.trackerIsReady()==false) return false;
        var nObj = this.trackerMap.tracker.groups[$groupName.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return true;
        return false;
    }
    
    getGroup = function($groupName) {
        if (typeof $groupName !=="string") {
            return null;
        }
        if (this.trackerIsReady()==false) return null;
        var nObj = this.trackerMap.tracker.groups[$groupName.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return nObj;
        return null;
    }
    
    addGroup = function($nObj) {
        if ($nObj==null) return false;
        if (this.trackerIsReady()==false) return false;
        this.trackerMap.tracker.groups[$nObj.text.toLowerCase()] = $nObj;
        this._new_external_data+=1;
    }

    hasReligion = function($religionName) {
        if (typeof $religionName !=="string") {
            return false;
        }
        if (this.trackerIsReady()==false) return false;
        var nObj = this.trackerMap.tracker.religions[$religionName.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return true;
        return false;
    }
    getReligion = function($religionName) {
        if (typeof $religionName !=="string") {
            return null;
        }
        if (this.trackerIsReady()==false) return null;
        var nObj = this.trackerMap.tracker.religions[$religionName.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return nObj;
        return null;
    }
    addReligion = function($nObj) {
        if ($nObj==null) return false;
        if (this.trackerIsReady()==false) return false;
        this.trackerMap.tracker.religions[$nObj.text.toLowerCase()] = $nObj;
        this._new_external_data+=1;
    }

    hasGroupEvent = function($groupEventName) {
        if (typeof $groupEventName !=="string") {
            return false;
        }
        if (this.trackerIsReady()==false) return false;
        var nObj = this.trackerMap.tracker.groupEvents[$groupEventName.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return true;
        return false;
    }
    getGroupEvent = function($groupEventName) {
        if (typeof $groupEventName !=="string") {
            return null;
        }
        if (this.trackerIsReady()==false) return false;
        var nObj = this.trackerMap.tracker.groupEvents[$groupEventName.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return nObj;
        return null;
    }
    addGroupEvent = function($nObj) {
        if ($nObj==null) return false;
        if (this.trackerIsReady()==false) return false;
        this.trackerMap.tracker.groupEvents[$nObj.text.toLowerCase()] = $nObj;
        this._new_external_data+=1;
    }

    hasOccupation = function($occupation) {
        if (typeof $occupation !=="string") {
            return false;
        }
        if (this.trackerIsReady()==false) return false;
        var nObj = this.trackerMap.tracker.occupations[$occupation.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return true;
        return false;
        
    }
    getOccupation = function($occupation) {
        if (typeof $occupation !=="string") {
            return null;
        }
        if (this.trackerIsReady()==false) return false;
        var nObj = this.trackerMap.tracker.occupations[$occupation.toLowerCase()];
        if (nObj!=undefined && nObj.dead!=undefined && nObj.dead!=true) return nObj;
        return null;
    }
    addOccupation = function($nObj) {
        if ($nObj==null) return false;
        if (this.trackerIsReady()==false) return false;
        this.trackerMap.tracker.occupations[$nObj.text.toLowerCase()] = $nObj;
        this._new_external_data+=1;
    }

    setAltConsole=function($altConsole) {
        this._altConsole = $altConsole;
    }

    printf = function(...$args) {
        var msg = ANNE.TALK.printf(...$args);
        this.addToConsole(msg);
    }

    addToConsole = function($msg) { 
        if (this.CIRCUIT_MOD!=null && $msg!="") {
            this.CIRCUIT_MOD.addToConsole($msg);
        }
        else if (this._altConsole!=null && $msg!="") {
            this._altConsole($msg);
        }
    }


    
    
    /**
     * Estimtae by text similary a class within a class tree (of any kind)
     * This is primary targetted at corporations which use company type to further narrow down what they are.
     * 
     * We could do a NN pool and fire neurons but it is a bit overkill at this stage in the game.
     * (tho, i shouldn't be lazy and should do a pool here)
     *
     * @param {*} $lookupval 
     * @param {*} $parentClass 
     * @returns {anne_neuron}
     */
    estimateClass = async($lookupval, $parentClassNOBJ, $min=.7, $clue="")=> {
        var highest_sim = $min;
        var highest_nObj = $parentClassNOBJ;
        var downline = [];

        //query for more?  TODO.
        await ANNE.API.queryNid($parentClassNOBJ.nid);  //should do this once, only, per class

        //best default can be school here..
        if ($lookupval.indexOf("school")!=-1 || $lookupval.indexOf("School")!=-1) {
            highest_nObj = ANNE.MEM.school;
        }

        else if ($lookupval.toLowerCase().indexOf("university")!=-1) {
            highest_nObj = ANNE.MEM.university;  
        }
        
        $parentClassNOBJ.getAllDownlineChildren(downline,0, false, false, false, false); 
        for (var d=0; d <downline.length; d++) {
            var ctNOBJ = downline[d];
            //console.log("d="+d+" text: "+ctNOBJ.text);
            var sim = ANNE.UTILS.similarity(ctNOBJ.text, $lookupval);
            if ($lookupval.indexOf("St.")!=-1) {
                if (ctNOBJ.text=="Trade School") sim=sim/3;
                else if (ctNOBJ.text=="Prep School") sim=sim*1.3;
                else if ($clue!="" && ctNOBJ.text.toLowerCase().indexOf($clue)!=-1) {
                    sim=sim*1.3;
                }
            }

            if ($lookupval.indexOf(ctNOBJ.text)!=-1) {
                sim+=.4;
            }
            if (sim > highest_sim) {
                highest_nObj = ctNOBJ;
                highest_sim = sim;   
            }
            
            if(ctNOBJ.aka!=undefined && ctNOBJ.aka.length>0) {
                for (var a=0; a < ctNOBJ.aka.length; a++) {
                    sim = ANNE.UTILS.similarity(ctNOBJ.aka[a], $lookupval);
                    if ($lookupval.indexOf(ctNOBJ.aka[a])!=-1) sim=sim*3;
                    if ($clue!=null && $clue!="" && $clue.toLowerCase()==ctNOBJ.aka[a].toLowerCase()) {
                        sim=1;
                    }
                    if (sim > highest_sim) {
                        highest_nObj = ctNOBJ;
                        highest_sim = sim;
                    }
                }
            }
        }

        if (highest_nObj) console.log("(estimateClass) esimating class %c"+highest_nObj.text+" %cfor text %c"+$lookupval, TALK.bgblue, TALK.bgblack, TALK.bggreen);
        
        if (highest_sim < $min) highest_nObj=null;
        
        return highest_nObj;
    }
    


    /**
     * For wikispooks RDF parsing
     * @param {*} $obj 
     * @returns 
     */
    prepRDFObj = function ($propObj, $obj) {
        var attr = $obj["@attributes"];
        if (attr == undefined) return null;
        var rez = attr["rdf:resource"];
        if ($propObj!=null && $propObj.bKEEPASIS==true) return last_slash;
        var slash = rez.split("/");
        var last_slash = slash[slash.length - 1].replace("_", " ");
        return last_slash;
    }

    /**
     * For wikispooks rdf parsing
     * @param {*} $arr 
     * @returns 
     */
    prepRDFArr = function ($propObj, $arr) {
        var data_arr = [];
        for (var a = 0; a < $arr.length; a++) {
            var val = $arr[a];
            if (typeof val === "string") {
                var newval = val.replace("_", "");
                data_arr.push(newval);
            }
            else if (Array.isArray(val) == true) {
                var obj = this.prepRDFArr($propObj, val);
                data_arr.push(obj)
            }
            else {
                var obj = this.prepRDFObj($propObj, val);
                data_arr.push(obj)
            }
        }
        return data_arr;
    }


    mappedToExisting($val, $nObj, $classNOBJ=null) {
        if ($classNOBJ==null) this.printf("mapped", _GREEN, $val+"to existing", _YELLOW,$nObj.text);
        else this.printf("mapped", _GREEN, $val+"to existing", _CYAN, $classNOBJ.text, _YELLOW,$nObj.text);
    }

    
    /**
     * 
     * @param {Function} $cb_resolve - callback to parse/handle the prop (if not auto as-is)
     * @param {String} $src_prop_name - prop name in the external source
     * @param {String} $anne_prop_name - string of the name of the reln
     * @param {int} $type - type of reln we will make
     * @param {String} $reln - nid longstring of the reln 
     * @param {ing} $to_type 
     */
    makeFM=function($cb_resolve_obj=null, $src_prop_name="propname", $anne_prop_name="annename", $type=3, $reln="", $to_type="", $incr=null) {
        return new field_mapper($cb_resolve_obj, this.src, $src_prop_name, $anne_prop_name, $type, $reln, $to_type, $incr);
    }  


    /**
     * 
     * @param {*} $txt 
     * @param {*} $intended_type 
     */
    getData = async ($url) => {
        return new Promise((resolve, reject) => {
            var xhr;
            if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
            else xhr = new ActiveXObject("Microsoft.XMLHTTP");
            xhr.onreadystatechange = function() {
                
                if (xhr.readyState === xhr.DONE) {
                    if (xhr.status === 200) {
                        return resolve({response:this.response, status:"good"});
                    }
                    else if(xhr.status == 502) {
                        console.log('502 Bad Gateway Error');
                        return resolve({response:null, status:"bad"});
                    }
                    else if(xhr.status == 404) {
                        console.log('404 not found');
                        return resolve({response:null, status:"bad"});
                    }
                    else if(xhr.status == 500) {
                        console.log('500 internal server error');
                        return resolve({response:null, status:"bad"});
                    }
                }

            }
            xhr.onerror = function() { // only triggers if the request couldn't be made at all
                if(xhr.status == 502) {
                    console.log('502 Bad Gateway Error');
                }
                else if(xhr.status == 404) {
                   console.log('404 not found');
                }
                else if(xhr.status == 500) {
                   console.log('500 internal server error');
                }
                return resolve({response:null, status:"bad"});
            };
            xhr.open("GET", $url, true);
            xhr.setRequestHeader('Accept', 'application/json');
            xhr.overrideMimeType('application/json');
            xhr.send();
        });
    }



    xmlToJson = function (xml) {
        // Create the return object
        var obj = {};
    
        if (xml.nodeType == 1) {
            // element
            // do attributes
            if (xml.attributes.length > 0) {
                obj["@attributes"] = {};
                for (var j = 0; j < xml.attributes.length; j++) {
                    var attribute = xml.attributes.item(j);
                    obj["@attributes"][attribute.nodeName] = attribute.nodeValue;
                }
            }
        }
        else if (xml.nodeType == 3) {
            // text
            obj = xml.nodeValue;
        }
    
        // do children
        // If all text nodes inside, get concatenated text from them.
        var textNodes = [].slice.call(xml.childNodes).filter(function (node) {
            return node.nodeType === 3;
        });
        if (xml.hasChildNodes() && xml.childNodes.length === textNodes.length) {
            obj = [].slice.call(xml.childNodes).reduce(function (text, node) {
                return text + node.nodeValue;
            }, "");
        }
        else if (xml.hasChildNodes()) {
            for (var i = 0; i < xml.childNodes.length; i++) {
                var item = xml.childNodes.item(i);
                var nodeName = item.nodeName;
                if (typeof obj[nodeName] == "undefined") {
                    obj[nodeName] = xmlToJson(item);
                } else {
                    if (typeof obj[nodeName].push == "undefined") {
                        var old = obj[nodeName];
                        obj[nodeName] = [];
                        obj[nodeName].push(old);
                    }
                    obj[nodeName].push(this.xmlToJson(item));
                }
            }
        }
        return obj;
    }
}