class tmdb_connector  {
    constructor($CIRCUIT, $nObj=null, $rezId="console_print", $addThumbCallback=null, $callbackDone=null) {
        
        //no aec here?
        this.aec = new anne_external_connector("", "tmdb", $CIRCUIT);
        
        this.resolvedNOBJ = $nObj;
        this.addThumbCallback = $addThumbCallback;
        this._callback_done = $callbackDone;
        this.el_rez = ANNE.A.__getEl($rezId);
        this._new_external_data = 0;
        this.ambiguous_resolutions = [];
        this.known_classes_to_chase = [ANNE.MEM.movie.temp_nid, ANNE.MEM.person.temp_nid, ANNE.MEM.company.temp_nid];
        this.new_akas = [];
    }


    //TODO --- handle these via user gui to differentiate which one.
    addAmbiguous=function($jsonobj, $matches, $lookupval="") {
        var ambig = {jsonobj:$jsonobj, matches:$matches, lookupval:$lookupval};
        this.ambiguous_resolutions.push(ambig);
        if (ANNE.SETTINGS.debugExternal()==true) console.log("%c AMBIGUIOUS RESULTS ", TALK.bgred);
        if (ANNE.SETTINGS.debugExternal()==true) console.log(ambig); 
    }


    /**
     */
    gotPersonData=async($rez, $searchVal)=> {
        if (ANNE.SETTINGS.debugExternal()==true) console.log($rez);
        if ($rez==undefined || $rez==null || $rez.length==0) {
            //try again with long name.
            if (this.resolvedNOBJ.aka!=undefined && this.resolvedNOBJ.aka.length>0 && $searchVal==this.resolvedNOBJ.aka[0]) {
                //var searchrez_el = ANNE.A.setHTML('search_rez', "");
                return await ANNE.CHASE.searchTMDBByString(this.resolvedNOBJ.text, this.gotPersonData, ["person"]);
            }
            ANNE.A.setHTML(this.el_rez, "no TMDB results for '"+$searchVal+"'", true);
            return;
        }
        var hit=0;
        for (var r=0; r < $rez.length; r++) {
            var rez = $rez[r];
            if (rez.adult==true) return;    //no adult content in ANNE
            if (rez.profile_path==null || rez.profile_path=="") {
                continue;
            }
            var profile_path = "";
            if (rez.profile_path!="") profile_path =  ANNE.IMAGES.TMDB_profile_base+rez.profile_path;
            
            var gender = "";
            if (rez.gender==2) gender = "male"; 

            var imgbtn = ANNE.A.imgButton(this.el_rez, "", profile_path, "search-img-finder", e=>this._getTMDBPerson(e));
            imgbtn.setAttribute("tmdb_id", rez.id);
            if (gender!="") imgbtn.setAttribute("gender", rez.gender);
            imgbtn.title="click to extract TMDB data";
            hit+=1;
        }

        if (hit>1) this.el_rez.prepend("which one?");
        else if (hit==0) {
            this.el_rez.prepend("No images available.");
        }
        ANNE.A.show("tmdb_search_rez");
    }



    /**
     */
     _getTMDBPerson=async($e)=>{
        var target = $e.target;
        if (target==undefined  || target==null) return;
        var id = target.getAttribute("tmdb_id");
        if (id==undefined || id==null) return;
        ANNE.A.empty(this.el_rez, true);
        await ANNE.CHASE.getMovieDBPerson(id, this._gotDataByID);
    }

    
    /**
     */
    queryPersonWithKnownID=async($id)=> {
        await ANNE.CHASE.getMovieDBPerson($id, this._gotDataByID);
    }

    queryCompanyWithKnownID=async($id)=> {
        //await CHASE.getMovieDBPerson($id, this._gotDataByID);
    }

    queryMovieWithKnownID=async($id)=> {
        //await CHASE.getMovieDBPerson($id, this._gotDataByID);
    }

    
    /**
     * ???
     */
    _gotDataByID=async($rez, $tmdb_id, $type="person")=> {
        if (ANNE.SETTINGS.debugExternal()==true) console.log($rez); 
        await this._processIMDBData($rez);
    }


    /**
     */
    _processIMDBData=async($rez)=> {
        ANNE.A.show("loading");
        console.log($rez);

        var ghost_rels = [];
        
        //AUDIT THIS FIRST --- as we may have the wrong one!!!!

        var birthday = $rez.birthday;
        if (birthday!=undefined) {
            console.log("birthday format tmdb:"+birthday);   //1980-11-07
            var ad = new anne_date(birthday);
            if (ad!=null) {
                var bMAKEGHOSTIFNOTFOUND=true;
                await ad.testDate(bMAKEGHOSTIFNOTFOUND);
                if (ad.nObj!=null) {
                    var bday_relon = MEMG.getRelonFromWithRToType(this.resolvedNOBJ.outs, TYPE_BE, ANNE.MEM.birthday.temp_nid, TO_TYPE_ANNE);
                    
                    if (bday_relon==null) {
                        var g1 = await ANNE.GHOSTDATA.new_ghost_be(this.resolvedNOBJ, ANNE.MEM.birthday.nid, TO_TYPE_ANNE, ad.nObj.nid);
                        ghost_rels.push(g1);
                        this._new_external_data+=1;
                    }
                    
                    //bday contradiction!!!
                    else if (bday_relon.to_s!=ad.nObj.nid) {
                        alert("ABORTING TMDB PARSE.  CONTRADICTATORY BDAY INFO -- potentially wrong person!!!");
                        if (this._callback_done!=undefined && this._callback_done!=null) {
                            this._callback_done(ghost_rels);
                        }
                    }

                }
            }
        }


        //map these akas to their lang.. so we have native multi-lang.
        //we will store non-eng as TYPE_BE -> (lang) -> text
        //essentially the MEM.name relon is another reln for MEM.english (/en)
        var akas = $rez.also_known_as;
        if (akas!=undefined && akas.length) {
            for (var a=0; a < akas.length; a++) {
                var aka = akas[a];
                var lang = ANNE.MEM.LANG.ascertain_lang(aka);
                if (lang!=null) {
                    console.log("%c"+aka+" %c"+lang.text, ANNE.TALK.green, ANNE.TALK.bgpink);
                    
                    //for eng we store akas.  For other langs we will store be relons to the string with reln of lang.
                    if (lang.nid==ANNE.MEM.lang_english.nid) {
                        
                        var hrel = MEMG.getBeRelonTo(this.resolvedNOBJ.outs, ANNE.MEM.aka.temp_nid, aka);
                        if (hrel!=null) continue;   //dupe 
                        if (this.resolvedNOBJ.text==aka) continue; //dupe
                        this.new_akas.push({text:aka, reln:ANNE.MEM.aka});  //will be 
                        
                        //we want to make a relon here.
                        var g1 = await ANNE.GHOSTDATA.new_ghost_be(this.resolvedNOBJ, ANNE.MEM.aka.nid, TO_TYPE_STRING, aka);
                        ghost_rels.push(g1);
                        this._new_external_data+=1;
                    }

                    else {
                        //we can also do more robust handling (later) for words (in this case proper nouns).
                        //They can be a "thing" neuron with a lang relon pointing to their lang
                        //instead of a quick/short-hand LANG reln pointing to the string of the name.
                        var hrel = MEMG.getBeRelonTo(this.resolvedNOBJ.outs, lang.temp_nid, aka);
                        if (hrel!=null) continue;   //dupe 
                        this.new_akas.push({text:aka, reln:lang});  //will be 
                        var g1 = await ANNE.GHOSTDATA.new_ghost_be(this.resolvedNOBJ, lang.nid, TO_TYPE_STRING, aka);
                        ghost_rels.push(g1);
                        this._new_external_data+=1;
                    }
                }
            }
        }

        var tmbd_gender = $rez.gender;
        if (tmbd_gender!=undefined && (tmbd_gender==1 || tmbd_gender==2)) {
            if (tmbd_gender==2) tmbd_gender = ANNE.MEM.male.nid;
            else if (tmbd_gender==1) tmbd_gender = ANNE.MEM.female.nid;
            else tmbd_gender = null;
            if (tmbd_gender!=null) {
                var gender_relon = MEMG.getRelonFromWithRToType(this.resolvedNOBJ.outs, TYPE_HAS, ANNE.MEM.gender.temp_nid, TO_TYPE_ANNE);
                if (gender_relon==null) {
                    gender_relon = MEMG.getRelonFromWithRToType(this.resolvedNOBJ.outs, TYPE_BE, ANNE.MEM.gender.temp_nid, TO_TYPE_ANNE);
                }
                if (gender_relon==null) {
                    var g1 = await ANNE.GHOSTDATA.new_ghost_be(this.resolvedNOBJ, ANNE.MEM.gender.nid, TO_TYPE_ANNE, tmbd_gender);
                    ghost_rels.push(g1);
                    this._new_external_data+=1;
                }
            }
        }

        var tmdb_id = $rez.id;
        var fb_id = $rez.facebook_id;
        var imdb_id = $rez.imdb_id;
        var instagram_id = $rez.instagram_id;
        var twitter_id = $rez.twitter_id;

        if (tmdb_id!=undefined && tmdb_id!=null) {
            var tmdb_relon = MEMG.getRelonFromWithRToType(this.resolvedNOBJ.outs, TYPE_HAS, ANNE.MEM.TMDB_id.temp_nid, TO_TYPE_NUMBER);
            if (tmdb_relon==null) {
                var g1 = await ANNE.GHOSTDATA.new_ghost_has(this.resolvedNOBJ, ANNE.MEM.TMDB_id.nid, TO_TYPE_NUMBER, tmdb_id);
                ghost_rels.push(g1);
                this._new_external_data+=1;
            }
        }
        
        if (imdb_id!=undefined && imdb_id!=null) {
            var imdb_relon = MEMG.getRelonFromWithRToType(this.resolvedNOBJ.outs, TYPE_HAS, ANNE.MEM.IMDB_id.temp_nid, TO_TYPE_STRING);
            if (imdb_relon==null) {
                var g1 = await ANNE.GHOSTDATA.new_ghost_has(this.resolvedNOBJ, ANNE.MEM.IMDB_id.nid, TO_TYPE_STRING, imdb_id);
                ghost_rels.push(g1);
                this._new_external_data+=1;
            }
        }

        if (instagram_id!=undefined && instagram_id!=null) {
            var insta_relon = MEMG.getRelonFromWithRToType(this.resolvedNOBJ.outs, TYPE_HAS, ANNE.MEM.instagram_id.temp_nid, TO_TYPE_STRING);
            if (insta_relon==null) {
                await ANNE.GHOSTDATA.new_ghost_has(this.resolvedNOBJ, ANNE.MEM.instagram_id.nid, TO_TYPE_STRING, instagram_id);
                this._new_external_data+=1;
            }
        }

        if (twitter_id!=undefined && twitter_id!=null) {
            var twitter_relon = MEMG.getRelonFromWithRToType(this.resolvedNOBJ.outs, TYPE_HAS, ANNE.MEM.twitter_id.temp_nid, TO_TYPE_STRING);
            if (twitter_relon==null) {
                var g1 = await ANNE.GHOSTDATA.new_ghost_has(this.resolvedNOBJ, ANNE.MEM.twitter_id.nid, TO_TYPE_STRING, twitter_id);
                ghost_rels.push(g1);
                this._new_external_data+=1;
            }
        }
        
        if (fb_id!=undefined && fb_id!=null) {
            var fb_relon = MEMG.getRelonFromWithRToType(this.resolvedNOBJ.outs, TYPE_HAS, MEM.facebook_id.temp_nid, TO_TYPE_STRING);
            if (fb_relon==null) {
                var g1 = await ANNE.GHOSTDATA.new_ghost_has(this.resolvedNOBJ, ANNE.MEM.facebook_id.nid, TO_TYPE_STRING, fb_id);
                ghost_rels.push(g1);
                this._new_external_data+=1;
            }
        }
        
        var imgs = $rez.images;
        var img_profiles = null;
        if (imgs!=null) img_profiles = imgs.profiles;
        
        //we need to take the first one and make it the default profile thumb (if we don't have that)
        if (ANNE.SETTINGS.debugExternal()==true) {
            if (ANNE.SETTINGS.debugExternal()==true) console.log(img_profiles);
        }
        
        if (img_profiles!=null && img_profiles.length) {
            for (var i=0; i < img_profiles.length; i++) {
                var img = img_profiles[i];
                var url = ANNE.IMAGES.TMDB_profile_base+img.file_path;
                
                //we should have a unique by finger too?
                //in case no data URL?
                if (ANNE.IMAGES.uniqueByUrl(this.resolvedNOBJ, url)==false) continue;

                var anneimg = await ANNE.IMAGES.getImgMetaFromUrl(url);
                if (anneimg==undefined || anneimg==null) continue;

                //?? is this right?
                var imgNOBJ = await anneimg.makeGhost(null, this.resolvedNOBJ, TYPE_HAS, ANNE.MEM.neuronImg.nid);
                
                this._new_external_data+=1;
            
                if (anneimg.tie_rel) {
                    ghost_rels.push(anneimg.tie_rel);
                }

                //"ghost-img search-img-small
                if (this.addThumbCallback!=null) {
                    this.addThumbCallback(url, anneimg);
                }
            }
        }


        //ghost_rels.push();

        //TO DO later.. have to build neurons for assocs and that
        //taps into the nlp/lang/words side.
        //var known_for_department = $rez.known_for_department; 

        var deathday = $rez.deathday;
        if (deathday!=undefined) {
            console.log("deathday format tmdb:"+deathday); //1980-11-07
            var ad = new anne_date(deathday);
            if (ad!=null) {
                var bMAKEGHOSTIFNOTFOUND=true;
                await ad.testDate(bMAKEGHOSTIFNOTFOUND);
                if (ad.nObj!=null) {
                    var dday_relon = MEMG.getRelonFromWithRToType(this.resolvedNOBJ.outs, TYPE_BE, ANNE.MEM.deathday.temp_nid, TO_TYPE_ANNE);
                    if (dday_relon==null) {
                        var g1 = await ANNE.GHOSTDATA.new_ghost_be(this.resolvedNOBJ, ANNE.MEM.deathday.nid, TO_TYPE_ANNE, ad.nObj.nid);
                        ghost_rels.push(g1);
                        this._new_external_data+=1;
                    }
                    else {

                    }
                }
            }
        }

        if (placeofbirth=="Ne")
        var placeofbirth = $rez.place_of_birth;
        if (placeofbirth!=undefined) {
            placeofbirth.replace("New York, New York", "NYC, New York");
            var anne_loc = new anne_location(placeofbirth);
            var bMAKEGHOSTIFNOTFOUND = true;

            await anne_loc.processFull([], false, bMAKEGHOSTIFNOTFOUND);
            anne_loc.print();

            if (anne_loc.nObj!=null) {
                var bplace_relon = MEMG.getRelonFromWithRToType(this.resolvedNOBJ.outs, TYPE_HBE, ANNE.MEM.birthplace.temp_nid, TO_TYPE_ANNE);
                if (bplace_relon==null) {
                    var g1 = await ANNE.GHOSTDATA.new_ghost_has(this.resolvedNOBJ, ANNE.MEM.birthplace.nid, TO_TYPE_ANNE, anne_loc.nObj.nid);
                    ghost_rels.push(g1);
                    this._new_external_data+=1;
                    if (anne_loc.nObj.bNEW==undefined || anne_loc.nObj.bNEW==false) {
                        if (this.CIRCUIT_MOD!=null && $msg!="") this.CIRCUIT_MOD.addToConsole($msg);
                        this.mappedToExisting(placeofbirth, anne_loc.nObj, ANNE.MEM.location); //just a note in the console
                    }
                }
            }
            else {
                if (ANNE.SETTINGS.debugExternal()==true) console.log("location not made????? %c"+placeofbirth, TALK.bgred);
            }
        }

        //we still have some data we can extract.
        if (this._new_external_data>0) {
            ANNE.playSound("ding");
        }
        else {
            ANNE.A.setHTML(this.el_rez, "No new TMDB data", true);
        }

        if (this._callback_done!=undefined && this._callback_done!=null) {
            this._callback_done(ghost_rels);
        }
    }

    
    /**
     * 
     * @param {*} $val 
     * @param {*} $nObj 
     */
    mappedToExisting($val, $nObj, $classNOBJ=null) {
        this.aec.mappedToExisting($val, $nObj, $classNOBJ);
    }

}