class anne_alert{
    constructor($title, $body, $cb_confirm=null, $cb_no=null, $cb_close=null){
        var el_alert_header = document.getElementById("alerta_header");
        el_alert_header.innerHTML = $title;

        var el_alert_text = document.getElementById("alerta_text");
        el_alert_text.innerHTML = $body;

        var el_alert_left_btns =  ANNE.A.empty("alerta_left_btns")
        var el_alert_right_btns =  ANNE.A.empty("alerta_right_btns")
        
        var el_alert_close = document.getElementById("alerta_header_close");
        el_alert_close.addEventListener("click", function($e){
            if ($cb_close!=null) $cb_close();
            ANNE.A.hide("alerta");
        })

        var btns = [];

        //confirm callback.  (if exists make confirm/yes button)
        if ($cb_confirm!=null) {
            var btnconf = document.createElement("button");
            btns.push(btnconf);
            btnconf.classList = "alerta-btn-confirm";
            btnconf.innerHTML = "yes";
            el_alert_left_btns.append(btnconf);
            el_alert_left_btns.addEventListener("click", function($e){
                $e.stopPropagation();
                $e.preventDefault();
                for (var b=0; b<btns.length;b++){
                    ANNE.A.removeSelf(btns[b]);
                }
                el_alert_text.innerHTML="";
                el_alert_header.innerHTML="";
                $cb_confirm();
                ANNE.A.hide("alerta");
            });
            ANNE.A.show(el_alert_left_btns);
        }

        //no callback (if exists make no button)
        if ($cb_no!=null) {
            var btnno = document.createElement("button");
            btns.push(btnno);
            btnno.classList = "alerta-btn-no";
            btnno.innerHTML = "no";
            el_alert_right_btns.append(btnno);
            el_alert_right_btns.addEventListener("click", function($e){
                $e.stopPropagation();
                $e.preventDefault();
                for (var b=0; b<btns.length;b++){
                    ANNE.A.removeSelf(btns[b]);
                }
                el_alert_text.innerHTML="";
                el_alert_header.innerHTML="";
                $cb_no();
                ANNE.A.hide("alerta");
            });
            ANNE.A.show(el_alert_left_btns);
        }

        ANNE.A.fadeIn("alerta");
    }
}


class anne_toggle_obj {
    constructor($divObj) {
        var divObj = $divObj.div;
        var btnObj = $divObj.btn;

        this.div_el = null; //will be set to the el that is made for this anne_toggle_obj

        if (divObj.id!=undefined) this.id = divObj.id;
        else this.id="";

        if (divObj.title!=undefined) this.title = divObj.title;
        else this.title="";
        
        if (divObj.style!=undefined) this.style = divObj.style;
        else this.style="";

        if (divObj.text!=undefined) this.text = divObj.text;
        else this.text="";
        
        if (divObj.div_class!=undefined) this.div_class = divObj.div_class;
        else this.divclass="";
        
        if (divObj.cb!=undefined && typeof divObj.cb==="function") this.cb = divObj.cb;
        else this.cb=null;

        //btn for the toggling.
        this.btn_el = null;
        this.btn_toggle_id = "";
        this.btn_text = "";
        this.btn_class = "";
        this.btn_tnid = "";

        if (btnObj!=undefined) {
            if (btnObj.id!=undefined) this.btn_toggle_id = btnObj.id;
            if (btnObj.text!=undefined) this.btn_text = btnObj.text;
            if (btnObj.btn_class!=undefined) this.btn_class = btnObj.btn_class;
            if (btnObj.btn_tnid!=undefined) this.btn_tnid = btnObj.btn_tnid;   
        }
    }
}


/**
 * 
 */
class anne_toggle_set {
    constructor($objs) {
        this.atos = [];
        if ($objs.length) {
            for (var a=0; a < $objs.length; a++) {
                var ato = new anne_toggle_obj($objs[a]);
                this.atos.push(ato);
            }
        }
    }

    /**
     * 
     */
    makeToggleSetFromAwarePol=function(){
    }

    /**
     * 
     */
    makeToggleSetFromAwareBucket=function(){
    }

}


/**
 * 
 */
class anne_select_option {
    constructor($selVal="", $selDisplayVal="", $titleHTML="", $bodyHTML="", $val2=""){
        this.selval = $selVal;
        this.selDispVal = $selDisplayVal;
        this.titleHTML = $titleHTML;
        this.bodyHTML = $bodyHTML;
        this.val2 = $val2;
        this.gui_id = UTILS.randHex(8);
        this.el_opt = null;
    }
}

class anne_select {
    constructor($w="400px", $el, $options, $misc) {
        this.width = $w;
        this.el = ANNE.A.__getEl($el);
        
        if (this.el == null) return null;
        
        this.options = $options;

        if ($misc.defaultLbl!=undefined) this.defaultLbl = $misc.defaultLbl;
        else this.deafultLbl = "";

        if ($misc.addNewCb!=undefined) this.addNewCb=$misc.addNewCb;
        else this.addNewCb = null;

        if ($misc.cb!=undefined) this.cb = $misc.cb;
        else this.cb=null;

        if ($misc.cb_ddopen!=undefined) this.cb_ddopen = $misc.cb_ddopen;
        else this.cb_ddopen = null;

        if ($misc.cb_ddclose!=undefined) this.cb_ddclose = $misc.cb_ddclose;
        else this.cb_ddclose = null;

        if ($misc.ddclass!=undefined) this.ddclass = $misc.ddclass;
        else this.ddclass = "";

        if ($misc.max_height!=undefined) this.max_height=$misc.max_height;
        //default 660px
    }


}


/******************* anne_dom - a vanilla GUI/DOM stuff *********************
*           lighter, faster, and simpler for my style of coding.            *
****************************************************************************/
class anne_dom extends anne_singleton {
    constructor() {
        super();
    }

    /**
     * Create a button that launches a dialogue w/ various details and callbacks.
     * @param {*} $el 
     * @param {*} $btnClass 
     * @param {*} $title 
     * @param {*} $msg 
     * @param {*} $cbYes 
     * @param {*} $cbNo 
     * @param {*} $cbOk 
     */
    btnToLaunchConfirm=async($el, $btnClass="anne-btn2", $title, $msg, $cbYes=null, $cbNo=null, $cbOk=null)=>{
        this.ezButton($el, "", $title, $btnClass, async($e)=>{
            new anne_alert($title, $msg, $cbYes, $cbNo, $cbOk);
        });
    }


    /**
     * 
     * @param {*} $wPx 
     * @param {function} $clickCB
     * @returns 
     */
    memeframer = function($wPx="900px", $clickCB=null, $name="testjpg") {
        const el_meme = document.createElement("div");
        el_meme.classList="meme-container";
        el_meme.style['max-width']=$wPx;
        el_meme.style['width']=$wPx;
        
        var row = document.createElement("div");
        row.style['min-width']='100%';
        row.classList = "meme-row";
        el_meme.appendChild(row);

        el_meme.setAttribute("file_name", $name);

        var img = document.createElement("img");
        img.src="../imgs/anne_logo.png";
        img.setAttribute("alt", "logo");
        img.classList="meme-logo";
        row.appendChild(img);

        const btn = document.createElement("button");
        btn.classList="meme-btn-make";
        btn.innerHTML="make meme!"
        row.append(btn);
        
        var row2 = document.createElement("div");
        row2.style['min-width']='100%';
        row2.classList = "meme-body";
        el_meme.appendChild(row2);


        if ($clickCB!=null && typeof $clickCB==="function") {
            btn.addEventListener("click", (e)=>{
                ANNE.A.hide(btn);
                var name = el_meme.getAttribute("file_name");
				$clickCB(el_meme, name);
			});
        }

		return {el:el_meme, body:row2};
    }


    buildGridNeuron = function($el, $test, $class, $afile=null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.classList.add("grid-neuron-holder");
        var neuron = document.createElement("div");
        neuron.classList.add("grid-neuron");
        
        if ($afile!=null) {
            ANNE.A.doImageB64(neuron, "", $afile, 0, 99, "", 99);
        }
        else {
			neuron.innerHTML = $test;
			neuron.classList.add($class);
		}
        el.appendChild(neuron);
    }


    buildGridArrow=function($el, $arrowClass, $lbl="test") {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.classList.add("grid-"+$arrowClass); 
        var lbl = document.createElement("div");
        lbl.innerHTML = $lbl;
        lbl.classList.add("grid-arrow-lbl");
        lbl.classList.add($arrowClass+"-text");
        el.appendChild(lbl);
        return;
    }


    /**
     * [x][->][x][<-][x]
     * @param {*} $el 
     */
    build1con1con=function($el, $m0, $m1, $w="495px") {
        var el = null;
        if ($el==null) {
            el = document.createElement("div");
        }
        else {
            el = this.__getEl($el);
            if (el == null) return null;
        }
        el.style['max-width']=$w;
        el.style['width']=$w;
        var grid = this.buildDOMGrid(el, 5, 1);
        console.log(grid);
        
        this.buildGridNeuron(grid["i0"], $m0[0].text, "gyellow", $m0[0].afile);
        this.buildGridArrow(grid["i1"], "right", $m0[0].reln_text);
        this.buildGridNeuron(grid["i2"], $m0[1].text, "ggreen", $m0[1].afile);
        this.buildGridArrow(grid["i3"], "left", $m1[0].reln_text);
        this.buildGridNeuron(grid["i4"], $m1[0].text, "gblue", $m1[0].afile);
        grid.parent_el = el;
        return grid;
    }
    

    build1con2con=function($el, $m0, $m1, $w="495px") {
        var el = null;
        if ($el==null) {
            el = document.createElement("div");
            //so we can call this 
        }
        else {
            el = this.__getEl($el);
            if (el == null) return null;
        }
        el.style['max-width']=$w;
        el.style['width']=$w;
        
        var grid = this.buildDOMGrid(el, 5, 4);
        console.log(grid);
        this.buildGridNeuron(grid["i0"], $m0[0].text, "gyellow");
        this.buildGridArrow(grid["i5"], "ne", "");
        this.buildGridArrow(grid["i6"], "right", $m0[0].reln_text);
        this.buildGridNeuron(grid["i7"], $m0[1].text, "ggreen");
        
        this.buildGridNeuron(grid["i4"], $m1[0].text, "gblue");
        this.buildGridArrow(grid["i9"], "down", $m1[0].reln_text);
        this.buildGridNeuron(grid["i14"], $m1[1].text, "gblue");

        this.buildGridArrow(grid["i13"], "horizontal", $m1[1].reln_text);
        this.buildGridArrow(grid["i12"], "left-up", "");
        
        grid.parent_el = el;
        return grid;
    }



    build2con1con=function($el, $m0, $m1, $w="495px") {
        var el = null;
        if ($el==null) {
            el = document.createElement("div");
            //so we can call this 
        }
        else {
            el = this.__getEl($el);
            if (el == null) return null;
        }

        //this will determine the actual rows.
        el.style['max-width']=$w;
        el.style['width']=$w;
        
        var grid = this.buildDOMGrid(el, 5, 4);
        console.log(grid);
        this.buildGridNeuron(grid["i0"], $m0[0].text, "gyellow");
        this.buildGridArrow(grid["i5"], "down", $m0[0].reln_text);
        this.buildGridNeuron(grid["i10"], $m0[1].text, "gblue");
        this.buildGridArrow(grid["i11"], "horizontal", $m0[1].reln_text);
        this.buildGridArrow(grid["i12"], "right-up", "");

        this.buildGridNeuron(grid["i4"], $m1[0].text, "gblue");
        this.buildGridArrow(grid["i9"], "nw", $m1[0].reln_text);
        this.buildGridArrow(grid["i8"], "left", "");
        this.buildGridNeuron(grid["i7"], $m0[2].text, "ggreen");
        
        grid.parent_el = el;
        return grid;
    }

    /**
     * [a]     [b]
     *  |       |
     * [c]     [d]
     *  |       |   
     *   ->[e]<-
     * @param {*} $el 
     * @param {*} $w 
     * @returns 
     */
    build2con2con=function($el, $m0, $m1, $w="495px") {
        var el = null;
        if ($el==null) {
            el = document.createElement("div");
            //so we can call this 
        }
        else {
            el = this.__getEl($el);
            if (el == null) return null;
        }

        //this will determine the actual rows.
        el.style['max-width']=$w;
        el.style['width']=$w;
        
        var grid = this.buildDOMGrid(el, 5, 4);
        console.log(grid);
        this.buildGridNeuron(grid["i0"], $m0[0].text, "gyellow");
        this.buildGridArrow(grid["i5"], "down", $m0[0].reln_text);
        this.buildGridNeuron(grid["i10"], $m0[1].text, "gyellow");
        this.buildGridArrow(grid["i15"], "ne", "");
        this.buildGridArrow(grid["i16"], "right", $m0[1].reln_text);
        this.buildGridNeuron(grid["i17"], $m0[2].text, "ggreen");

        this.buildGridNeuron(grid["i4"], $m1[0].text, "gblue");
        this.buildGridArrow(grid["i9"], "down", $m1[0].reln_text);
        this.buildGridNeuron(grid["i14"], $m1[1].text, "gblue");
        this.buildGridArrow(grid["i19"], "nw", "");
        this.buildGridArrow(grid["i18"], "left", $m0[1].reln_text);
        

        grid.parent_el = el;
        return grid;
    }

    build3con2con=function($el, $m0, $m1, $w="495px") {
        var el = null;
        if ($el==null) {
            el = document.createElement("div");
            //so we can call this 
        }
        else {
            el = this.__getEl($el);
            if (el == null) return null;
        }

        //this will determine the actual rows.
        el.style['max-width']=$w;
        el.style['width']=$w;
        
        var grid = this.buildDOMGrid(el, 5, 4);
        console.log(grid);
        this.buildGridNeuron(grid["i0"], $m0[0].text, "gyellow");
        this.buildGridArrow(grid["i5"], "down", $m0[0].reln_text);
        this.buildGridNeuron(grid["i10"], $m0[1].text, "gyellow");
        this.buildGridArrow(grid["i15"], "down", $m0[1].reln_text);
        this.buildGridNeuron(grid["i20"], $m0[2].text, "gyellow");
        this.buildGridArrow(grid["i21"], "horizontal", $m0[2].reln_text);
        this.buildGridArrow(grid["i22"], "right-up", "");
        this.buildGridNeuron(grid["i17"], $m0[3].text, "ggreen");

        this.buildGridNeuron(grid["i4"], $m1[0].text, "gblue");
        this.buildGridArrow(grid["i9"], "down", $m1[0].reln_text);
        this.buildGridNeuron(grid["i14"], $m1[1].text, "gblue");
        this.buildGridArrow(grid["i13"], "left", "");
        this.buildGridArrow(grid["i12"], "left-down", "");
        
        
        grid.parent_el = el;
        return grid;
    }


    build2con3con=function($el, $m0, $m1, $w="495px") {
        var el = null;
        if ($el==null) {
            el = document.createElement("div");
            //so we can call this 
        }
        else {
            el = this.__getEl($el);
            if (el == null) return null;
        }

        //this will determine the actual rows.
        el.style['max-width']=$w;
        el.style['width']=$w;
        
        var grid = this.buildDOMGrid(el, 5, 4);
        console.log(grid);
        this.buildGridNeuron(grid["i0"], $m0[0].text, "gyellow");
        this.buildGridArrow(grid["i5"], "down", $m0[0].reln_text);
        this.buildGridNeuron(grid["i10"], $m0[1].text, "gyellow");
        this.buildGridArrow(grid["i11"], "right", $m0[1].reln_text);
        this.buildGridArrow(grid["i12"], "right-down", $m0[1].reln_text);
        this.buildGridNeuron(grid["i17"], $m0[2].text, "ggreen");
        
        this.buildGridNeuron(grid["i4"], $m1[0].text, "gblue");
        this.buildGridArrow(grid["i9"], "down", $m1[0].reln_text);
        this.buildGridNeuron(grid["i14"], $m1[1].text, "gblue");
        this.buildGridArrow(grid["i19"], "down", $m1[1].reln_text);
        this.buildGridNeuron(grid["i24"], $m1[2].text, "gblue");
        this.buildGridArrow(grid["i23"], "left", "");
        this.buildGridArrow(grid["i22"], "left-up", "");
    
        grid.parent_el = el;
        return grid;
    }


    build3con3con=function($el, $m0, $m1, $w="495px") {
        var el = null;
        if ($el==null) {
            el = document.createElement("div");
            //so we can call this 
        }
        else {
            el = this.__getEl($el);
            if (el == null) return null;
        }

        //this will determine the actual rows.
        el.style['max-width']=$w;
        el.style['width']=$w;
        
        var grid = this.buildDOMGrid(el, 5, 4);
        console.log(grid);
        this.buildGridNeuron(grid["i0"], $m0[0].text, "gyellow");
        this.buildGridArrow(grid["i5"], "down", $m0[0].reln_text);
        this.buildGridNeuron(grid["i10"], $m0[1].text, "gyellow");
        this.buildGridArrow(grid["i15"], "down", $m0[1].reln_text);
        this.buildGridNeuron(grid["i20"], $m0[2].text, "gyellow");
        this.buildGridArrow(grid["i21"], "right", $m0[2].reln_text);
        this.buildGridNeuron(grid["i22"], $m0[3].text, "ggreen");
        
        this.buildGridNeuron(grid["i4"], $m1[0].text, "gblue");
        this.buildGridArrow(grid["i9"], "down", $m1[0].reln_text);
        this.buildGridNeuron(grid["i14"], $m1[1].text, "gblue");
        this.buildGridArrow(grid["i19"], "down", $m1[1].reln_text);
        this.buildGridNeuron(grid["i24"], $m1[2].text, "gblue");
        this.buildGridArrow(grid["i23"], "left", "");
    
        grid.parent_el = el;
        return grid;
    }


    /**
     * [x0]   [y1]-->[y3]
     *  |      |      |
     * [x1]   [y0]   [y4]
     *  |             |
     * [x2]-->[x3]->[match]  
     * @param {*} $el 
     * @param {*} $m0 
     * @param {*} $m1 
     * @param {*} $w 
     * @returns 
     */
    build4con4con=function($el, $m0, $m1, $w="495px") {
        var el = null;
        if ($el==null) {
            el = document.createElement("div");
            //so we can call this 
        }
        else {
            el = this.__getEl($el);
            if (el == null) return null;
        }

        //this will determine the actual rows.
        el.style['max-width']=$w;
        el.style['width']=$w;
        
        var grid = this.buildDOMGrid(el, 5, 4);
        console.log(grid);
        this.buildGridNeuron(grid["i0"], $m0[0].text, "gyellow");
        this.buildGridArrow(grid["i5"], "down", $m0[0].reln_text);
        this.buildGridNeuron(grid["i10"], $m0[1].text, "gyellow");
        this.buildGridArrow(grid["i15"], "down", $m0[1].reln_text);
        this.buildGridNeuron(grid["i20"], $m0[2].text, "gyellow");
        this.buildGridArrow(grid["i21"], "right", $m0[2].reln_text);
        this.buildGridNeuron(grid["i22"], $m0[3].text, "gyellow");
        this.buildGridArrow(grid["i23"], "right", $m0[3].reln_text);
        this.buildGridNeuron(grid["i24"], $m0[4].text, "ggreen");

        
        this.buildGridNeuron(grid["i12"], $m1[0].text, "gblue");
        this.buildGridArrow(grid["i7"], "up", $m1[0].reln_text);
        this.buildGridNeuron(grid["i2"], $m1[1].text, "gblue");
        this.buildGridArrow(grid["i3"], "right", $m1[1].reln_text);
        this.buildGridNeuron(grid["i4"], $m1[2].text, "gblue");
        this.buildGridArrow(grid["i9"], "down", $m1[2].reln_text);
        this.buildGridNeuron(grid["i14"], $m1[3].text, "gblue");
        this.buildGridArrow(grid["i19"], "down", $m1[3].reln_text);

        grid.parent_el = el;
        return grid;
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $rejected_broadcasts 
     * @returns 
     */
    displayPostMortem=function($el, $rejected_broadcasts) {
        var el = this.__getEl($el);
        if (el == null) return null;

        //{cmdObj:$cmdObj, innerRez:$innerRezObj}
        el.innerHTML="TO DO: show post mortem of "+$rejected_broadcasts.length+" rejected broadcasts here";
        console.log($rejected_broadcasts);
        ANNE.A.show(el);
    }


    buildDOMGrid=function($el, $flexWidth = 5, $rows = 5, $pre="gridx") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var grid = new Object();
        el.classList.add("grid-container");
        for (let i = 0; i < $flexWidth * $rows; i++) {
            const gridSquare = document.createElement('div');
            gridSquare.classList.add('gridSquare');
            gridSquare.style.setProperty('--flexWidth', $flexWidth);
            el.appendChild(gridSquare);
            var r = Math.floor((i+$flexWidth)/$flexWidth)-1;
            var row = grid["r"+r];
            if (row==undefined) {
                row = new Object();
                grid["r"+r]=row;
            }
            var c = (i+$flexWidth) % $flexWidth;
            el.setAttribute("id",$pre+"_"+r+"_"+c)
            row["c"+c] = gridSquare;
            grid["i"+i]=gridSquare;
        }

        return grid;
    }


    
    /**
     * Make a nifty little HTML DD for the users DD.
     * @param {*} $el 
     * @param {*} $users 
     * @param {*} $defaultLbl 
     * @param {*} $cb 
     */
    makeHTMLDD_fromUserObjs = function($w="400px", $el, $users, $configs) {
        var options = [];
        for (var n=0; n < $users.length; n++) {
            var user = $users[n];
            var userNOBJ = MEMG.getNeuronByNid(user.public_nid);
            var lastKnownAnnies = user.last_known_annies;
            if (lastKnownAnnies==undefined || lastKnownAnnies==null) lastKnownAnnies = "0";
            //else 
            var titleHTML = "";
            var bodyHTML = "";
            var sel_disp_val = "";
            if (user.text!="") {
                titleHTML ='<span class="acct-name">'+user.text+'</span>';
                sel_disp_val = user.text;
            }
            else {
                titleHTML ="<span class='acct-name'>"+user.public_nid+"</span>";
                sel_disp_val = user.public_nid;
            }

            bodyHTML = "<span class='bal-small bal-"+userNOBJ.temp_nid+"'>"+UTILS.displayAnneValue(lastKnownAnnies)+"<span style='font-size:1.6rem;'>&#x1d110;</span></span>";
            
            var opt = new anne_select_option(user.public_nid, sel_disp_val, titleHTML, bodyHTML);
            options.push(opt);
        }
        var ASELECT  = new anne_select($w, $el, options, $configs);
        this.makeHtmlDD(ASELECT);
    }


    
    /**
     * make a dropdown of annodes
     */
    makeANNODEDD = async($el="main_annodes", $configs=null)=> {
        var configs = $configs;
        if (configs==null) configs = {
            defaultLbl:ANNE._annodesLS.last_uri,
            ddclass:"annodedd",
            addNewCb:function(){
                console.log("add new item")
            },
            cb:async($annode_nid, $uri)=>{
                console.log("select new annode! "+$annode_nid);
                if ($annode_nid!=undefined && $annode_nid!=null && $uri!=undefined && $uri!=null) {
                    if (typeof ANNE.setNewAnnodeURI==="function") {
                        ANNE.setNewAnnodeURI($annode_nid, $uri);
                    }
                }
            //app_main
            }, cb_ddopen:function(){
                ANNE.A.smartDefocus(true);
            }, cb_ddclose:function() {
                ANNE.A.smartDefocus(false);
            }
        };
        ANNE.A.makeHTMLDD_fromAnnodeObjs("400px", $el, ANNE._annodesLS.annodes, configs);
    }


    /**
     * 
     * @param {*} $bDEFOCUS 
     */
    smartDefocus = async($bDEFOCUS=true)=> {
        if ($bDEFOCUS==true) {
            var el = ANNE.A.addClass("scrollable_"+this.ID, "defocus");
            el.setAttribute("disabled",true);
        }
        else {
            var el = ANNE.A.removeClass("scrollable_"+this.ID, "defocus");
            el.removeAttribute("disabled",false);
        }
    }

    /**
     * 
     * @param {*} $el 
     * @param {*} $annodes 
     * @param {*} $defaultLbl 
     * @param {*} $cb 
     */
    makeHTMLDD_fromAnnodeObjs = function($w="400px", $el, $annodes, $configs) { 
        var options = [];
        for (var n=0; n < $annodes.length; n++) {
            var annode = $annodes[n];
            var titleHTML = annode.nickname+' - '+annode.nid;
            var bodyHTML = annode.uri;
            var sel_disp_val = annode.nickname+" "+annode.uri;
            var opt = new anne_select_option(annode.nid, sel_disp_val, titleHTML, bodyHTML, annode.uri);
            options.push(opt);
        }
        var ASELECT  = new anne_select($w, $el, options, $configs);
        this.makeHtmlDD(ASELECT);
    }



    /**
     * 
     * @param {*} $el 
     * @param {*} $options
     * @param {*} config $defaultLbl, $cb
     * 
     * @param {*} $defaultLbl 
     * @param {*} $cb 
     * @returns 
     */
    makeHtmlDD=function($ASELECT) {
        if ($ASELECT.el==null) return;
        if ($ASELECT.el.classList.contains("selectbox")==false) {
            var sb = document.createElement("div");
            sb.classList = "selectbox";
            $ASELECT.el.appendChild(sb);
        }
        else sb = $ASELECT.el;

        sb.style.width = $ASELECT.width;

    
        if ($ASELECT.addNewCb!=null) {
            //var plusSpan = document.createElement("span");
            //$ASELECT.el.parentNode.appendChild(plusSpan);
            //plusSpan.innerHTML = "[+]";
            //plusSpan.classList = "btn-select-add-option"; 
        }
        
        const optionsContainer = document.createElement("div");
        optionsContainer.classList = "options-containersb";
        sb.appendChild(optionsContainer);

        if ($ASELECT.max_height!=undefined) {
            sb.style['max-height']=$ASELECT.max_height;
            optionsContainer.style['max-height']=$ASELECT.max_height;
        }

        const selectedsb = document.createElement("div");
        selectedsb.classList = "selectedsb";

        if ($ASELECT.ddclass!="") {
            selectedsb.classList.add($ASELECT.ddclass);
        }
        selectedsb.style.width = $ASELECT.width;

        sb.appendChild(selectedsb);
        if ($ASELECT.defaultLbl!="") {
            var lbl_sp3 = document.createElement("span");
            lbl_sp3.classList = "sbh3 pr30";
            lbl_sp3.innerHTML = $ASELECT.defaultLbl;
            selectedsb.append(lbl_sp3);
        }

        //create options
        for (var i=0; i  < $ASELECT.options.length; i++) {
            var opt = $ASELECT.options[i];
            var selval = opt.selval;
            var val2 = opt.val2;
            const divopt = document.createElement("div");
            optionsContainer.appendChild(divopt);
            divopt.classList = "optionsb";
            if (selval!=null) divopt.setAttribute("selval", selval);
            if (val2!=null) divopt.setAttribute("val2", val2);
            if (opt.selDispVal!=null) divopt.setAttribute("dispval", opt.selDispVal);
            
            var divopt_rad = document.createElement("input");
            divopt_rad.setAttribute("type", "radio");
            divopt_rad.classList = "radiosb";
            divopt_rad.id = opt.gui_id;
            divopt.appendChild(divopt_rad);
            
            var divopt_lbl = document.createElement("label");
            divopt_lbl.setAttribute("for", divopt_rad.id);
            divopt.appendChild(divopt_lbl);
            
            var lbl_sp3 = document.createElement("span");
            lbl_sp3.classList = "sbh3";
            lbl_sp3.innerHTML = opt.titleHTML;
            divopt_lbl.append(lbl_sp3);
            
            var lbl_sp5 = document.createElement("span");
            lbl_sp5.classList = "sbh5";
            lbl_sp5.innerHTML = opt.bodyHTML;
            divopt_lbl.append(lbl_sp5);
            opt.el_opt = divopt;

            opt.el_opt.addEventListener("click", ($e) => {
                $e.stopPropagation();
                $e.preventDefault();
				var selval = divopt.getAttribute("selval");
                var val2 = divopt.getAttribute("val2");
                if (val2==undefined) val2 = null;
                var dispval =  divopt.getAttribute("dispval");
				//selectedsb.innerHTML = divopt.querySelector("label").innerHTML;
				//selectedsb.innerHTML = selval;
                ANNE.A.empty(selectedsb);
                var lbl_sp3 = document.createElement("span");
                lbl_sp3.classList = "sbh3 pr30";
                if (dispval) lbl_sp3.innerHTML = dispval;
                else lbl_sp3.innerHTML = selval;
                selectedsb.append(lbl_sp3);

                document.removeEventListener("click", clickout);
                optionsContainer.style['z-index']=-1;
				optionsContainer.classList.remove("active");
                if ($ASELECT.cb!=null) {
                    if ($ASELECT.cb_ddclose!=null) $ASELECT.cb_ddclose();
                    $ASELECT.cb(selval, val2);
                }
			});
        }

        const clickout = function(){
            console.log("clickout");
            optionsContainer.style['z-index']=-1;
            document.removeEventListener("click", clickout);
            optionsContainer.classList.toggle("active");
            if ($ASELECT.cb_ddclose!=null) $ASELECT.cb_ddclose();
        }

        optionsContainer.addEventListener("mouseout", $e=> {
            if (optionsContainer.classList.contains("active")==true) {
                const fromElement = $e.relatedTarget;
                if (!optionsContainer.contains(fromElement)) {
                    clickout();
                }
            }
        });

        selectedsb.addEventListener("click", ($e) => {
            $e.stopPropagation();
            $e.preventDefault();
			if (optionsContainer.classList.contains("active")==true) {
                console.log("oc active, make inactive");
                clickout();
            }
            else {
                console.log("oc inactive, make active");
                document.addEventListener("click", clickout);
                optionsContainer.style['z-index']=9999;
                optionsContainer.style['opacity']=1;
                optionsContainer.classList.toggle("active");
                if ($ASELECT.cb_ddopen!=null) $ASELECT.cb_ddopen();
            }   
           
		});
    }

    

    /**
     * Standardized link color maker based on the neuron (not the relon)
     * This will be used to generated links for neurons.
     */
    getLinkColorClass = function($nObj) {
        if ($nObj==undefined || $nObj==null) return "link-black";
        if ($nObj.ghost==true) return "link-blue";

        //presume ANNE ownership if not set (in the js)
        if (ANNE.isANNE($nObj.owned_by)==true 
            || $nObj.owned_by==ANNE.MEM.ANNE_ACCTID) return "link-yellow";  //anne yellow
        
        else {
            if ($nObj.owned_by==ANNE.USER._userNObj.nid) {
                //possible hanai could be here.  Look for pending hanai.
                if ($nObj.bPENDING_HANAI==undefined) {
                    var pending_hanai = ANNE.HANAI.getPendingHanai($nObj);
                    if (pending_hanai!=null) {
                        $nObj.bPENDING_HANAI=true;
                        return "link-pink";  //hanai pink
                    }
                }
                return "link-red";   //red for self owned
            }
            else {
                return "link-grey";  //black for someone else's neuron (not ANNE's).
            }
        }
    }


    /**
     */
    getNeuronColorClass = function($nObj, $pre="title-", $post, $default="other") {
        if ($pre!="" && $pre[ $pre.length-1]!="-") $pre = $pre+"-";
        if ($post!="" && $post[ $post.length-1]!="-") $post = "-"+$post;

        if (ANNE.isANNE($nObj.owned_by)==false && $nObj.ghost==false && $nObj.bPENDING_HANAI==undefined) {
            var pending_hanai = ANNE.HANAI.getPendingHanai($nObj);
            if (pending_hanai!=null) {
                $nObj.bPENDING_HANAI=true;
                return $pre+"hanai"+$post;  
            }
        }
        else if ($nObj.bPENDING_HANAI==true) return $pre+"hanai"+$post; 

        else if ($nObj.ghost==true) {
            return $pre+"ghost"+$post;  
        }
        else if (ANNE.isANNE($nObj.owned_by)==true) {
            return $pre+"anne"+$post;  
        }
        else if ($nObj.owned_by==USER._userNObj.nid) {
            return $pre+"self"+$post; 
        }
        return $pre+$default+$post;  //hanai pink
    }


    /**
     */
    addClass = function ($el, $classname) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if (el.classList.contains($classname) == false) el.classList.add($classname);
        return el;
    }

    
    /**
     * Quickly add an ai-ico class image (see anne-icos.css).
     * 
     * @param {*} $el 
     * @param {*} $icoClass 
     * @returns 
     */
    addIco = function ($el, $icoClass) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var span = document.createElement("span");
        span.classList = $icoClass;
        el.appendChild(span);
    }


    addRemoveClass = function ($el, $addclass, $removeclass) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if (el.classList.contains($addclass) == false) el.classList.add($addclass);
        if (el.classList.contains($removeclass) == true) el.classList.remove($removeclass);
        return el;
    }

    addRemoveClasses = function ($el, $addclass, $removeClasses) {
        var el = this.__getEl($el);
        if (el == null) return null;
        for (var r = 0; r < $removeClasses.length; r++) {
            if (el.classList.contains($removeClasses[r]) == true) el.classList.remove($removeClasses[r]);
        }
        if (el.classList.contains($addclass) == false) el.classList.add($addclass);
        return el;
    }

    /**
     * Same as addRemoveClass but checks if the removeclass is on.
     */
    addRemoveClassIf = function ($el, $addclass, $removeclass) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if (el.classList.contains($addclass) == false) {
            if (el.classList.contains($addclass) == false) el.classList.add($addclass);
        }
        if (el.classList.contains($removeclass) == true) el.classList.remove($removeclass);
        return el;
    }


    animateProp = function ($el, $prop, $propVal, $timestring = "0.5s ease-out", $removeClass = "hide") {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($removeClass) el.classList.remove($removeClass);
        el.style[$prop] = $propVal;
        el.style.transition = $prop + " " + $timestring;
    }
    animateProps = function ($el, $jsonprops, $dur = ".5s", $delay = "0", $ease = "ease-out", $removeClass = "hide") {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($removeClass) el.classList.remove($removeClass);
        var keys = Object.keys($jsonprops);
        var propstrs = [];
        for (var k = 0; k < keys.length; k++) {
            var prop = keys[k];
            var val = $jsonprops[prop];
            propstrs.push(prop);
        }
        el.style['transition-property'] = propstrs.join(",");
        el.style['transition-duration'] = $dur;
        el.style['transition-timing-function'] = $ease;
        if ($delay != "") el.style['animation-delay'] = $delay;

        //set the props after the transition styling.
        for (var k = 0; k < keys.length; k++) {
            var prop = keys[k];
            var val = $jsonprops[prop];
            el.style[prop] = val;
        }
    }





    /**
     * Disambig chases of information from external lookups.
     * @param {*} $neurons 
     * @param {*} $val 
     * @param {*} $ambigObj 
     * @param {*} $el_console 
     * @param {*} $resolveAmbigs 
     * @returns 
     */
    disambigInner=async($neurons, $val, $ambigObj, $el_console, $resolveAmbigs)=> {
        if ($neurons==undefined || $neurons==null || $neurons.length==0) {
            return $resolveAmbigs(); //call the next one.
        }
        var el_dchoice = document.createElement("div");
        var sp = document.createElement("div");
        sp.innerHTML="original text: <b>"+$val+"</b>";
        sp.style.display="block";
        el_dchoice.appendChild(sp);

        //the choice (and all options)
        $el_console.appendChild(el_dchoice);

        for (var n=0; n < $neurons.length; n++) {
            var el_choice = document.createElement("div");
            el_choice.classList = "neuron-choice";
            el_dchoice.appendChild(el_choice);
            
            var el_choice_info = document.createElement("div");
            el_choice_info.classList = "neuron-choice-info";
            
            var nObj = $neurons[n];
            await ANNE.GUI_STUFF.disambigHTMLStr(el_choice_info, nObj, ["sp"]);
            el_choice.appendChild(el_choice_info);
            
            var el_choice_btn = document.createElement("div");
            el_choice_btn.classList = "neuron-choice-btn-holder";  
            el_choice.appendChild(el_choice_btn);
            
            var el_btn = ANNE.A.ezButton(el_choice_btn, "", "choose match "+(n+1), "anne-tiny-btn btn-purple-sq btn-maxH", async(e)=>{
                var nid_x = e.target.getAttribute("nid");
                var nObjx = MEMG.getNeuronByNid(nid_x);
                
                ANNE.A.empty(e.target.parentElement, true);//empty and hide choice div.
                
                //key to set this.
                $ambigObj.jsonobj.to_s = nObjx.nid;
                return await $resolveAmbigs(); //call the next one.
            });
            el_btn.setAttribute("nid", nObj.nid);
            el_btn.setAttribute("val", $val);
            $el_console.appendChild(el_dchoice);
        }

        //skip option.
        var el_skip = document.createElement("div");
        el_skip.classList = "neuron-choice";
        el_dchoice.appendChild(el_skip);

        var el_skip_info = document.createElement("div");
        el_skip_info.classList = "neuron-choice-skip";
        el_skip.appendChild(el_skip_info);     
        var el_skip_btn = document.createElement("div");
        el_skip_btn.classList = "neuron-choice-btn-holder";  
        el_skip.appendChild(el_skip_btn);
        var el_btn = ANNE.A.ezButton(el_skip_btn, "", "SKIP THIS", "anne-tiny-btn btn-red-sq btn-maxH", async(e)=>{
            ANNE.A.empty(el_dchoice. true);//empty and hide choice div.
            $ambigObj.jsonobj.to_s = null;
            return await $resolveAmbigs(); //call the next one.
        });
        

        //make new
        var el_new = document.createElement("div");
        el_new.classList = "neuron-choice";
        el_dchoice.appendChild(el_new);
        var el_new_info = document.createElement("div");
        el_new_info.classList = "neuron-choice-new";
        el_new.appendChild(el_new_info);     
        var el_new_btn = document.createElement("div");
        el_new_btn.classList = "neuron-choice-btn-holder";  
        el_new.appendChild(el_choice_btn);
        var el_btn = ANNE.A.ezButton(el_choice_btn, "", "NEW", "anne-tiny-btn btn-blue-sq btn-maxH", async(e)=>{
            ANNE.A.empty(el_dchoice. true); //empty and hide choice div.
            console.log($ambigObj);
            $ambigObj.jsonobj.to_s = null;
            //this is going to need a callback to make a "NEW" correctly!!!!
            return await $resolveAmbigs(); //call the next one.
        });
        $el_console.appendChild(el_dchoice);
    }


    /**
     * Generalized ez annies entry.
     * i_min_val, i_max_val and i_placeholder attrs can be added to the outter button.
     * They will passthrough to the input field.
     * 
     * @param {*} $el 
     * @param {*} $cb_submit - submit callback
     * @param {*} $btnTitle - title of outter button
     * @param {*} $cb_entry - callback on entry of data (if more than just formatting of annies is desired)
     * @param {*} $idpre - Used to create a unique ezAnnecoin_entry if there is more than one in the DOM at once.
     * @returns 
     */
    ezAnnecoin_entry = function($el, $cb_submit=null, $btnTitle="accept available risk", $btn2Title="accept risk", 
                                $cb_entry=null, $idpre="unique", $btnClassStr = "noround btn-someanniesaction") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var el_holder = ANNE.A.ezEl(el, "div", "flexrow");
        const idpre = $idpre;
        const btn_aar = ANNE.A.ezButton(el_holder, "btn_main_"+$idpre, $btnTitle, $btnClassStr, async(e)=>{
            
            //snag passthrough attrs we put on button AFTER we created here.
            //these will be ready for this event since we created them outside of this funct on the return
            //of the gui creation. (optional attrs)
            var min_val = btn_aar.getAttribute("i_min_val");
            var max_val = btn_aar.getAttribute("i_max_val");
            var placeholder = btn_aar.getAttribute("i_placeholder");

            //create the btn clone so we get the button input button functionality
            var btnClone = btn_aar.cloneNode(true);
            const disp = document.createElement("div");
            btnClone.id = "btn_"+idpre+"_final";
            btnClone.setAttribute("tied_input", "input_"+idpre);
            ANNE.A.hide(btn_aar);
    
            const input_field = document.createElement("input");
            input_field.setAttribute("size", 24);
            input_field.setAttribute("type", "text");
            input_field.id="input_"+idpre;
            input_field.setAttribute("el_display", "annies_"+idpre+"_disp");
            input_field.setAttribute("el_submit", "btn_"+idpre+"_final");
            if (min_val!=undefined) input_field.setAttribute("min_val", min_val);
            if (max_val!=undefined) input_field.setAttribute("max_val", max_val);
            if (placeholder!=undefined) input_field.setAttribute("placeholder", placeholder);
            
            //add th input field after the btn_aar
            btn_aar.after(input_field);

            var max_btn = null;
            var min_btn = null;


            //add max btn
            if (max_val!=undefined) {
                max_btn = document.createElement("button");
                max_btn.innerHTML="max";
                max_btn.classList = 'btn-minmax';
                max_btn.addEventListener("click", function($e){
                    input_field.value = max_val;
                    ANNE.A.hide(max_btn);
                    ANNE.A.show(btnClone);
                    if (typeof $cb_entry=="function") $cb_entry(input_field.value, disp);
                })
                input_field.after(max_btn)
            }

            //add max btn
            if (min_val!=undefined) {
                min_btn = document.createElement("button");
                min_btn.classList = 'btn-minmax';
                min_btn.innerHTML="min";
                min_btn.addEventListener("click", function($e){
                    input_field.value = min_val;
                    ANNE.A.hide(min_btn);
                    ANNE.A.show(btnClone);
                    if (typeof $cb_entry=="function") $cb_entry(input_field.value, disp);
                })
                input_field.after(min_btn)
            }


            //add input input event
            input_field.addEventListener("input", async($e)=>{
                await ANNE.A.anne_entered($e);
                if (typeof $cb_entry=="function") $cb_entry(input_field.value, disp);
            });


            //a display for the formatted/summary version of what the user typed.
            disp.classList="flexrow";
            disp.id="annies_"+idpre+"_disp";

            //if we have max, add disp after it.  else add disp after input field.
            if (max_btn!=null) max_btn.after(disp);
            else if (min_btn!=null) min_btn.after(disp);
            else input_field.after(disp);

            disp.after(btnClone);
            btnClone.innerHTML=$btn2Title;
            ANNE.A.hide(btnClone);

            //add submit callback.
            if (typeof $cb_submit=="function") {
                btnClone.addEventListener("click", async($e)=>{
                    var val = input_field.value;
                    $cb_submit(val)
                });
            }
        });
        return el_holder;
    }


    /**
     * annies entered
     * This can handle el-display (and display value entered)
     * This can handle el-submit (and show a submit btn after valid entry)
     * @param {*} $e 
     */
    anne_entered = async($e, $target=null)=>{
        var el_input = $target;
        if (el_input==null && $e!=null && $e.target!=null) {
            el_input = $e.target;
        }
        if (el_input==null) return;
        
        var val = el_input.value+"";
        var lastChar = val[val.length-1];

        var el_display = el_input.getAttribute("el_display");
        if (el_display!=null) el_display = document.getElementById(el_display);

        var el_submit = el_input.getAttribute("el_submit");
        if (el_submit!=null) el_submit = document.getElementById(el_submit);

        var minval = el_input.getAttribute("min_val");
        var maxval = el_input.getAttribute("max_val");
        
        var final_val = 0;

        if (lastChar=="k" || lastChar=="K") {         //shorthand for thousands
            var newval = Number.parseFloat(ANNE.A.getValue(el_input)) * 1000;
            el_input.value = newval;
        }
        else if (lastChar=="m" || lastChar=="M") {    //shorthand for millions
            var newval = Number.parseFloat(ANNE.A.getValue(el_input)) * 1000000;
            el_input.value = newval;
        }
        else if (lastChar=="b" || lastChar=="B") {    //shorthand for billions
            var newval = Number.parseFloat(ANNE.A.getValue(el_input)) * 1000000000;
            el_input.value = newval;
        }
        else if ("0123456789.,".indexOf(lastChar)==-1) {
            var newval = "";
            var amt = el_input.value;
            for (var a=0; a < amt.length; a++) {
                if ((a!=(amt.length-1)) && ("kKmMbB".indexOf(amt[a])!=-1)) continue;
                else if ("0123456789.,".indexOf(amt[a])!=-1) continue;
                newval = newval+amt[a];
            }
            el_input.value = newval;
        }

        var val  = el_input.value;
        if (val=="") {
            return;
        }
        final_val = parseInt(val);

        if (minval!=undefined && final_val < minval) {
            if (el_submit!=null) ANNE.A.hide(el_submit);
            if (el_display!=null) ANNE.A.setHTML(el_display, "<span class='min-msg'>minimum "+minval+" annecoin</span>"); 
        }

        else if (maxval!=undefined && final_val > maxval) {
            if (el_submit!=null) ANNE.A.hide(el_submit);
            if (el_display!=null) ANNE.A.setHTML(el_display, "<span class='max-msg'>max "+maxval+" annecoin</span>"); 
        }

        else if (final_val>0) {
            if (el_submit!=null) ANNE.A.show(el_submit);
            if (el_display!=null) ANNE.A.ezAnnecoinDisplay(el_display, final_val, true); 
        }
        else {
            if (el_submit!=null) ANNE.A.hide(el_submit);
            if (el_display!=null) ANNE.A.ezAnnecoinDisplay(el_display, 0, true); 
        }
    }


    append = function ($el, $misc, $bSHOW = false) {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        el.append($misc);
        if ($bSHOW == true) this.show(el);
        return el;
    }

    appendStringList=function($el, $strArr, $size="10px") {
        var el = this.__getEl($el);
        if (el==null) {
            console.log("missing el");
            return null;
        }
        if ($strArr==undefined || $strArr==null || Array.isArray($strArr)==false || $strArr.length==0) return;
        var spanlist=document.createElement("span");
        spanlist.style['display']="inline-block";
        spanlist.style['font-size']=$size;
        spanlist.innerHTML="("+$strArr.join(", ").trim()+")";
        el.append(spanlist);
    }

    addEmojisFromRelTos=function($el, $rels, $title) {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;

        for (var r=0; r < $rels.length; r++) {
            var rel = $rels[r];
            var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
            if (toNOBJ._uico!=undefined) {
                var sp = document.createElement("span");
                sp.innerHTML = toNOBJ._uico;
                sp.setAttribute("title", $title+" "+toNOBJ.bestNameHTML());
                sp.setAttribute("txid", rel.txid);
                el.appendChild(sp);
            }
        }
    }


    /**
     * 
     * @param {*} $str 
     * @returns 
     */
    getAnum=function($str) {
        let annum = 0;
        const normalizedText = $str.normalize("NFD").replace(/[\u0300-\u036f]/g, "").toLowerCase().trim();
        for (let i = 0; i < normalizedText.length; i++) {
            const c = normalizedText.charAt(i);
            const asciiValue = c.charCodeAt(0);
            if (asciiValue < 49) continue;
            if (asciiValue <= 57) {
                annum += asciiValue - 48;
                continue;
            }
            else if (asciiValue < 97 || asciiValue > 123) {
                continue;
            }
            else annum += asciiValue - 96;
        }
        return annum;
    }

    
    /**
     * 
     * @param {*} $el 
     * @param {*} $text 
     * @param {*} $classpost 
     */
    doAnumWithCalc = function($el, $text, $classpost="") {
        var num = this.getAnum($text+"");
        this.doAnum($el, num+"", $classpost);
        return num;
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $num 
     * @param {*} $classpost 
     * @returns 
     */
    doAnum=function($el, $num, $classpost="") {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;

        if(el.classList.contains("anumbox"+$classpost)==false) el.classList.add("anumbox"+$classpost);
        el.innerHTML="";

        $num=$num+"";
        
        for (var n=0; n <$num.length; n++) {
            var sp = document.createElement("span");
            sp.classList = "anum"+$classpost;
            sp.innerHTML = $num[n];
            el.appendChild(sp);
        }
        return;
    }


    /**
     * 
     * @param {*} $rels 
     * @param {*} $title 
     * @param {*} $skips 
     * @returns 
     */
    getEmojisFromRelTos_html=function($rels, $title, $skips=[]) {
        if (ANNE.SETTINGS && ANNE.SETTINGS.bUICOS==false) return "";
        var html = "";
        for (var r=0; r < $rels.length; r++) {
            var rel = $rels[r];
            if ($skips.indexOf(rel.txid)!==-1) continue;
            var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
            if (toNOBJ._uico!=undefined) {
                var span = "<span title='"+$title+" "+toNOBJ.bestNameHTML()+"' txid='"+rel.txid+"'>"+toNOBJ._uico+"</span>";
                html+=span;
                $skips.push(rel.txid);
            }
        }
        return html;
    }


    click = function ($el) {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        el.click();
        return el;
    }

    //this clones the DOM node.
    //DOM node doesn't have to be in the DOM.. it can just be a temp made
    //el that is not yet appended.
    cloneAndAppend = function ($getel, $putel, $bCLONE = true, $bSHOWPUTEL = true) {
        if ($bCLONE == true) {
            var getel = this.__getEl($getel);
            if (getel == null) return null;
            var clone = getel.cloneNode(true);
        }
        else clone = this.__getEl($getel);
        if (clone == null) return null;
        var putel = this.__getEl($putel);
        if (putel == null) return null;
        putel.appendChild(clone);
        if ($bSHOWPUTEL == true) this.show($putel);
        return clone;
    }

    //this clones the .content of the template
    cloneAndAppendTemplate = function ($getel, $putel, $bSHOWPUTEL = true) {
        var getel = this.__getEl($getel);
        if (getel == null) return null;
        var clone = getel.content.cloneNode(true);
        var putel = this.__getEl($putel);
        if (putel == null) return null;
        putel.appendChild(clone);
        if ($bSHOWPUTEL == true) this.show($putel);
        return clone;
    }



    createElement = function ($el, $tag, $class = "", $html = "", $value = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var newtag = document.createElement($tag);
        if ($class != "") newtag.classList = $class;
        if ($html != "") newtag.innerHTML = $html;
        if ($value != "") newtag.value = $value;
        el.append(newtag);
        return newtag;
    }

    /**
     */
    doImageDyno = function ($div, $imgElId = "", $src = "", $imgClass = "left_dyno_w") {
        if ($src == "") return;
        var newImgEl = document.createElement('img');
        if ($imgElId != "") newImgEl.setAttribute("id", $imgElId);
        if ($imgClass != "") this.__classListParse(newImgEl, $imgClass);  //need to do this elsewhere
        newImgEl.addEventListener('load', function () {
            newImgEl.style.top = "0px";
            ANNE.A.append($div, newImgEl);
            var attr_fix = newImgEl.getAttribute("ssfixpostload");
            if (attr_fix != undefined) ANNE.A.smartScroll(attr_fix);
        });
        newImgEl.setAttribute('src', $src); // Loads the image.
        return newImgEl;
    }


    /**
     * 
     * @param {*} $div 
     * @param {*} $imgElId 
     * @param {anne_file} $afile - ANNE FILE
     * @param {*} $imgClass 
     * @returns 
     */
    doImageDynoB64 = function ($div, $imgElId = "", $afile=null, $imgClass = "left_dyno_w") {
        
        if ($afile == null) return null;
        if ($afile.b64data==null) return null;

        var newImgEl = document.createElement('img');
        if ($imgElId != "") newImgEl.setAttribute("id", $imgElId);
        if ($imgClass != "") this.__classListParse(newImgEl, $imgClass);  //need to do this elsewhere
        newImgEl.addEventListener('load', function () {
            newImgEl.style.top = "0px";
            ANNE.A.append($div, newImgEl);
            var attr_fix = newImgEl.getAttribute("ssfixpostload");
            if (attr_fix != undefined) ANNE.A.smartScroll(attr_fix);
        });
        $afile.imgel = newImgEl;
        if ($afile.b64data.indexOf("data:")!=-1) newImgEl.setAttribute('src', $afile.b64data); 
        else newImgEl.setAttribute('src', 'data:'+$afile.mimetype+';base64,'+$afile.b64data);
        return newImgEl;
    }


    /**
     * @param {*} $div 
     * @param {*} $imgElId 
     * @param {*} $src 
     * @param {*} $biggest 
     * @param {*} $imgClass 
     * @returns 
     */
    doImageDyno2 = function ($div, $imgElId = "", $src = "", $biggest = 200, $imgClass = "left_dyno_w") {
        if ($src == "") return;
        var newImgEl = document.createElement('img');
        if ($imgElId != "") newImgEl.setAttribute("id", $imgElId);
        if ($imgClass != "") this.__classListParse(newImgEl, $imgClass);  //need to do this elsewhere
        newImgEl.addEventListener('error', function () {
            console.log('Error loading image');
            return;
        });
        newImgEl.addEventListener('load', function () {
            newImgEl.style.top = "0px";
            ANNE.A.append($div, newImgEl);
            var realW = this.width;
            var realH = this.height;
            var ratio = realW / realH;
            var biggestD = realW;
            var bgd = "w";
            if (realH > realW) {
                biggestD = realH;
                bgd = "h";
            }
            if (biggestD > $biggest) {
                if (bgd == "w") {
                    newImgEl.setAttribute("width", $biggest);
                    var newH = $biggest / ratio;  //(>1 ratio)
                    newImgEl.setAttribute("height", newH);
                }
                else {
                    newImgEl.setAttribute("height", $biggest);
                    var newW = $biggest * ratio; //<1 ratio
                    newImgEl.setAttribute("width", newW);
                }
            }
            var attr_fix = newImgEl.getAttribute("ssfixpostload");
            if (attr_fix != undefined) ANNE.A.smartScroll(attr_fix);
        });
        
        newImgEl.setAttribute('src', $src); // Loads the image.
        return newImgEl;
    }


    /**
     * @param {*} $div 
     * @param {*} $imgElId 
     * @param {*} $afile 
     * @param {*} $biggest 
     * @param {*} $imgClass 
     * @returns 
     */
    doImageDyno2_B64 = function ($div, $imgElId = "", $afile = null, $biggest = 200, $imgClass = "left_dyno_w") {
        if ($afile == null) return;
        var newImgEl = document.createElement('img');
        if ($imgElId != "") newImgEl.setAttribute("id", $imgElId);
        if ($imgClass != "") this.__classListParse(newImgEl, $imgClass);  //need to do this elsewhere
        newImgEl.addEventListener('error', function () {
            console.log('Error loading image');
            return;
        });
        newImgEl.addEventListener('load', function () {
            newImgEl.style.top = "0px";
            ANNE.A.append($div, newImgEl);
            var realW = this.width;
            var realH = this.height;
            var ratio = realW / realH;
            var biggestD = realW;
            var bgd = "w";
            if (realH > realW) {
                biggestD = realH;
                bgd = "h";
            }
            if (biggestD > $biggest) {
                if (bgd == "w") {
                    newImgEl.setAttribute("width", $biggest);
                    var newH = $biggest / ratio;  //(>1 ratio)
                    newImgEl.setAttribute("height", newH);
                }
                else {
                    newImgEl.setAttribute("height", $biggest);
                    var newW = $biggest * ratio; //<1 ratio
                    newImgEl.setAttribute("width", newW);
                }

            }
            var attr_fix = newImgEl.getAttribute("ssfixpostload");
            if (attr_fix != undefined) ANNE.A.smartScroll(attr_fix);
        });
        $afile.imgel = newImgEl;
        if ($afile.b64data.indexOf("data:")!=-1) newImgEl.setAttribute('src', $afile.b64data); 
        else newImgEl.setAttribute('src', 'data:'+$afile.mimetype+';base64,'+$afile.b64data);
        return newImgEl;
    }


    /**
     */
    doBadImg = function ($div, $imgElId = "", $src = "", $imgClass = "left_dyno_w") {
        var newImgEl = this.ezEl($div, "span", $imgClass + " img-bad-audit", "FAILED<BR>AUDIT");
        if ($imgElId != "") newImgEl.setAttribute("id", $imgElId);
        newImgEl.style.top = "0px";
        if ($src != undefined && $src != null && $src != "") {
            newImgEl.setAttribute('bad-audit-url', $src);
        }
        var attr_fix = newImgEl.getAttribute("ssfixpostload");
        if (attr_fix != undefined) ANNE.A.smartScroll(attr_fix);
        return newImgEl;
    }



    /**
     * 
     * @param {*} $div 
     * @param {*} $imgElId 
     * @param {*} $src 
     * @param {*} $w 
     * @param {*} $h 
     * @param {*} $imgClassAdd 
     * @param {*} $max 
     * @returns 
     */
    doImage = function ($div, $imgElId, $src, $w = 600, $h = 900, $imgClassAdd = "", $max = 0) {
        console.log("src "+$src);
        
        const newImgEl = document.createElement('img');
        newImgEl.setAttribute("id", $imgElId);
        if ($imgClassAdd != "") this.__classListParse(newImgEl, $imgClassAdd);  //need to do this elsewhere
        newImgEl.onerror = function(image) {
            newImgEl.src = "";
            newImgEl.onerror = null; // Prevent infinite loop if fallback image also fails to load
            return;
        }
        
        newImgEl.addEventListener('load', function () {
            newImgEl.style.top = "0px";
            var realW = this.width;
            var realH = this.height;
            var ratio = realW / realH;
            if ($w && $h) {
                newImgEl.setAttribute("width", $w);
                newImgEl.setAttribute("height", $h);
            }
            else if ($w) {
                if ($w < realW) {
                    if ($max && ($w / ratio) > $max) {
                        newImgEl.setAttribute("height", $max);
                    }
                    else newImgEl.setAttribute("width", $w);
                }
                else {
                    if ($max!=0 && realH > $max) {
                        newImgEl.setAttribute("height", $max);
                    }
                    else newImgEl.setAttribute("width", realW);
                }
            }
            else if ($h) {
                if ($h < realH) {
                    if ($max && (ratio * $h) > $max) {
                        newImgEl.setAttribute("width", $max);
                    }
                    newImgEl.setAttribute("height", $h);
                }
                else newImgEl.setAttribute("height", realH);
            }
            ANNE.A.append($div, newImgEl);
            var attr_fix = newImgEl.getAttribute("ssfixpostload");
            if (attr_fix != undefined) ANNE.A.smartScroll(attr_fix);
        });
        newImgEl.setAttribute('src', $src); // Loads the image.
        return newImgEl;
    }


    /**
     * 
     * @param {*} $div 
     * @param {*} $imgElId 
     * @param {anne_file} $afile 
     * @param {int} $w 
     * @param {int} $h 
     * @param {string} $imgClassAdd 
     * @param {int} $max 
     * @returns 
     */
    doImageB64 = function ($div, $imgElId, $afile=null, $w = 600, $h = 900, $imgClassAdd = "", $max = 0) {      

		const newImgEl = document.createElement('img');
        newImgEl.setAttribute("id", $imgElId);

		if ($afile==null) {
			console.log("must have an afile here");
			return newImgEl;
		}

        if ($imgClassAdd != "") this.__classListParse(newImgEl, $imgClassAdd);  //need to do this elsewhere
		
        newImgEl.onerror = function($img) {
            newImgEl.src = "";
            newImgEl.onerror = null; // Prevent infinite loop if fallback image also fails to load
            return;
        }
        
        newImgEl.addEventListener('load', function () {
            newImgEl.style.top = "0px";
            var realW = this.width;
            var realH = this.height;
            var ratio = realW / realH;
            if ($w && $h) {
                newImgEl.setAttribute("width", $w);
                newImgEl.setAttribute("height", $h);
            }
            else if ($w) {
                if ($w < realW) {
                    if ($max && ($w / ratio) > $max) {
                        newImgEl.setAttribute("height", $max);
                    }
                    else newImgEl.setAttribute("width", $w);
                }
                else {
                    if ($max!=0 && realH > $max) {
                        newImgEl.setAttribute("height", $max);
                    }
                    else newImgEl.setAttribute("width", realW);
                }
            }
            else if ($h) {
                if ($h < realH) {
                    if ($max && (ratio * $h) > $max) {
                        newImgEl.setAttribute("width", $max);
                    }
                    newImgEl.setAttribute("height", $h);
                }
                else newImgEl.setAttribute("height", realH);
            }
            ANNE.A.append($div, newImgEl);
            var attr_fix = newImgEl.getAttribute("ssfixpostload");
            if (attr_fix != undefined) ANNE.A.smartScroll(attr_fix);
        });
        $afile.imgel = newImgEl;

		if ($afile.b64data==undefined || $afile.b64data==null) {
			console.log("problem with b64 data");
			return newImgEl;
		}
		
        if ($afile.b64data.indexOf("data:")!=-1) {
			newImgEl.src = $afile.b64data;
		}
        else {
			newImgEl.setAttribute('src', 'data:'+$afile.mimetype+';base64,'+$afile.b64data);
		}
        return newImgEl;
    }

    emptySelfAfterChild=function($el, $childIndex=0, $bHIDE=false) {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        for (var c=0; c < el.children.length; c++) {
            if (c<=$childIndex) continue;
            el.removeChild( el.children[c]);
            c=c-1;
        }
        if ($bHIDE == true) this.hide($el);
        return el;
    }

    emptySelf = function($el, $bHIDE=false){ return this.empty($el, $bHIDE);}   //i keep thinking it is named this.
    empty = function ($el, $bHIDE = false) {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        while (el.firstChild) el.removeChild(el.firstChild);
        el.innerHTML = "";
        if ($bHIDE == true) this.hide($el);
        return el;
    }
    emptyParent = function ($el, $bHIDE = false) {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        var el_parent = el.parentNode;
        if (el_parent) this.empty(el_parent);
        else return el;
        if ($bHIDE == true) this.hide(el_parent);
        return el_parent;
    }

    emptyAllBut=function($el, $skipEl, $bHIDE = false) {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        var el_parent = el.parentNode;
        for (var c=0; c < el_parent.children.length; c++) {
            var child = el_parent.children[c];
            if (child==$skipEl) continue;
            el_parent.removeChild(child);
        }
        if ($bHIDE == true) this.hide(el);
        return;
    }


    ezAlert = function ($el, $class, $id_pre, $id, $msg = "", $insertAfter = null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        const alert = document.createElement("div");
        var classList = "alert fade show";
        if ($class) classList = classList + " " + $class; //could be multiple ones.
        alert.classList = classList;
        alert.setAttribute("role", "alert");
        if ($id_pre != "" && $id != "") alert.setAttribute("id", $id_pre + "_" + $id);
        else if ($id != "") alert.setAttribute("id", $id);
        if ($msg != "") alert.innerHTML = $msg;
        if ($insertAfter != null) $insertAfter.after(alert);
        else el.append(alert);
        return alert;
    }


    /**
     * HTML is silly.
     * @param {*} $el - the select el or string of the id
     * @param {String} $attr - property to extract 
     * @returns 
     */
    getSelectedProp=function($el, $attr) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var selectedOption = el.options[el.selectedIndex];
        if (selectedOption==null) return null;
        return selectedOption.getAttribute($attr);
    }

    //var el_lvl = ANNE.A.setHTML("annex_lvl", aplex.price_lvl);
    ezAnniesToAnneDisplay = function ($el, $val = 0, $bdclass="balance-display", $ico="annecoin-small-ico", $valClass="annecoin-balance-value", $bRESET=true) {
        var el = this.__getEl($el);
        if (el == null) return null;

		if ($bRESET==true) el.innerHTML="";
		
        if ($val == 0) {
            el.classList.add("text-danger-lbl");
            el.innerHTML = "0";
            return;
        }
        var annecoin = $val / ANNE.ANNE_TO_ANNIES;
        var span = ANNE.A.ezSpan(el, "", $bdclass);
        var val = UTILS.formatNumberCommas(annecoin);
        //console.log(el.id + " val:" + val);
        ANNE.A.ezSpan(span, "", $valClass, val + "");
        ANNE.A.ezSpan(span, "", $ico);
    }

    /**
    * annies are never decimal, only whole
    */
    validateAndFormatAnnecoin = function ($el_input, $displayEl, $annecoinstring, $bRESET = true) {
        var str = "";
        var lastchar = $annecoinstring[$annecoinstring.length - 1];
        var multiplier = 0;
        if (lastchar == "k") {
            multiplier = 1000;
            $annecoinstring = $annecoinstring.substring(0, $annecoinstring.length - 1)
        }
        else if (lastchar == "m") {
            multiplier = 1000000;
            $annecoinstring = $annecoinstring.substring(0, $annecoinstring.length - 1)
        }
        else if (lastchar == "b") {
            multiplier = 1000000000;
            $annecoinstring = $annecoinstring.substring(0, $annecoinstring.length - 1)
        }
        for (var s = 0; s < $annecoinstring.length; s++) {
            if ("0123456789".indexOf($annecoinstring[s]) == -1) continue;
            str = str + $annecoinstring[s];
        }
        if (multiplier != 0) str = (parseInt(str) * multiplier) + "";
        $el_input.value = str;

        if (str.length > 0) {
            this.ezAnnecoinDisplay($displayEl, str, $bRESET);
        }
    }

    
    /**
     * 
     */
    ezAddNote = function($el, $noteText, $class="small-note") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var span = document.createElement("span");
        span.innerHTML = $noteText;
        span.classList = $class;
        el.append(span);
    }

    displayAnnecoinWithCommas = function ($el, $annecoin = 0, $bRESET=false, $pre = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($annecoin=="" || $annecoin==undefined) $annecoin=0;
        if ($bRESET == true) ANNE.A.empty(el);
        var span = ANNE.A.ezSpan(el, "", "balance-display");
        var annecoin = ANNE.UTILS.commas($annecoin);
        if ($pre != "") $pre = "&nbsp;" + $pre;
        ANNE.A.ezSpan(span, "", "annecoin-balance-value", $pre + annecoin + "");
        ANNE.A.ezSpan(span, "", "annecoin-small-ico");
    }

    ezAnnecoinDisplay = function ($el, $annecoin = 0, $bRESET = false, $pre = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($annecoin=="" || $annecoin==undefined) $annecoin=0;
        if ($bRESET == true) ANNE.A.empty(el);
        var span = ANNE.A.ezSpan(el, "", "balance-display");
        var annecoin = Math.round(parseInt($annecoin)*100)/100;
        var acval = UTILS.formatNumber(annecoin);
        if ($pre != "") $pre = "&nbsp;" + $pre;
        ANNE.A.ezSpan(span, "", "annecoin-balance-value", $pre + acval + "");
        ANNE.A.ezSpan(span, "", "annecoin-small-ico");
    }

    /**
     * will round for better display
     */
    ezAnneDisplayApprox = function ($el, $val = 0, $bRESET = false, $emptyClass="text-danger-lbl") {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($bRESET == true) ANNE.A.empty(el);
        if ($val == 0) {
            var span = ANNE.A.ezSpan(el, "", "balance-display");
            ANNE.A.ezSpan(span, "", "annecoin-balance-value", 0 + "");
            ANNE.A.ezSpan(span, "", "annecoin-small-ico")
            return;
        }
        var span = ANNE.A.ezSpan(el, "", "balance-display");
        var annecoin = $val / ANNE.ANNE_TO_ANNIES;
        var acval = UTILS.formatNumber(annecoin, true);
        ANNE.A.ezSpan(span, "", "annecoin-balance-value", acval + "");
        ANNE.A.ezSpan(span, "", "annecoin-small-ico")
    }


    /**
     * 
     * Get and display our annies balance.
     * 
     * Get and display the annies balance in both ANNE coin and annies.
     */
    ezDisplayAnnecoinWithNeuron = async ($el, $nObj, $lbl = "") => {
        var balanceObj = $nObj.balanceObj;
        if (balanceObj == null && $nObj.ghost == false && $nObj.temp == false) {
            balanceObj = await USER.checkBalance($nObj.nid);
        }
        if (balanceObj!=null) {
            if (balanceObj.annies != undefined) {
                var annies = parseInt(balanceObj.annies);
                ANNE.GUI_STUFF.doAnniesToAnneSpanFull($el, $lbl, annies);
            }
        }
    }


    ezDisplayPendingAnnies = async ($el, $nObj, $lbl = "") => {
        var balanceObj = $nObj.balanceObj;
        if (balanceObj == null && $nObj.ghost == false && $nObj.temp == false) {
            balanceObj = await USER.checkBalance($nObj.nid);
        }
        if (balanceObj) {
            if (balanceObj.avail_soon_annies != undefined) {
                var annies = parseInt(balanceObj.avail_soon_annies);
                ANNE.GUI_STUFF.doAnniesToAnneSpanFull($el, $lbl, annies);
            }
        }
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $id 
     * @param {*} $value 
     * @param {*} $lbl 
     * @param {*} $checked 
     * @param {*} $disabled 
     * @param {*} $truncateClass 
     * @param {*} $cb 
     * @returns 
     */
    ezCheckMark = function ($el, $id, $value, $lbl, $checked = true, $disabled = false, 
                            $truncateClass = "", $cb=null, $chkclass="chk-parent") {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($id=="" || $id==null) $id = ANNE.UTILS.randHex(3);
        const div = document.createElement("div");
        if ($chkclass!="") div.classList.add($chkclass);
        if ($truncateClass != "") div.classList.add($truncateClass);
        el.append(div);
        const chk = document.createElement("input");
        chk.setAttribute("type", "checkbox");
        if ($id!="") chk.setAttribute("id", $id);
        if ($id!="") chk.setAttribute("name", $id);
        chk.setAttribute("value", $value);
        if ($checked) chk.setAttribute("checked", true);
        if ($disabled) chk.setAttribute("disabled", true);
        div.append(chk);
        const lbl = document.createElement("label");
        lbl.classList="chk-label";
        lbl.setAttribute("for", $id);
        lbl.innerHTML = $lbl;
        div.append(lbl);

        //simple callback
        if ($cb) {
            chk.addEventListener("change", $e=>$cb($e));
        }
        return chk;
    }


    /**
     */
    ezInputText = function ($el, $id = "", $classList = "", $placeholder = "", $inputEventCallback = null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var el_input = document.createElement("input");
        el_input.setAttribute("type", "text");
        if ($classList != "") this.__classListParse(el_input, $classList);
        if ($id != "") el_input.setAttribute("id", $id);
        if ($placeholder) el_input.setAttribute("placeholder", $placeholder);
        el.append(el_input);
        if ($inputEventCallback != null && typeof $inputEventCallback === "function") {
            el_input.addEventListener("input", async ($e) => {
                var val = $e.target.value;
                $inputEventCallback(val);
            });
        }
        return el_input;
    }


    /** 
     * @param {element or string} - parent element to append to
     * @param {anne_neuron} - class to apply uom to.
     */
    ezInput = function ($el, $classNOBJ = null, $id = "", $class = "",
        $placeholder = "", $inputEventCallback = null, $inputFilterCallback = null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($class != "") {
            var div = document.createElement("div");
            div.classList = $class;
            el.append(div);
        }
        else div = el;

        const input = document.createElement("input");
        input.setAttribute("type", "text");
        if ($id != "") input.setAttribute("id", $id);
        if ($placeholder) input.setAttribute("placeholder", $placeholder);
        div.append(input);
        var uom = null;
        if ($classNOBJ != null) uom = MEM.unitOfMeasure($classNOBJ);
        if (uom != null) {
            var span = document.createElement("span");
            span.style.display = 'inline-block';
            span.classList = 'uom-symbol';
            div.appendChild(span);
        }
        if ($inputEventCallback != null && typeof $inputEventCallback === "function") {
            div.addEventListener("input", async ($e) => {
                var val = $e.target.value;
                if ($inputFilterCallback != null && typeof $inputFilterCallback === "function") {
                    val = await $inputFilterCallback(val);
                    $e.target.value = val;
                }
                if (uom != null) {
                    var thisconv = null;
                    if (uom.conversions != undefined && uom.conversions["_" + val] != undefined) {
                        thisconv = uom.conversions["_" + val];
                    }
                    else thisconv = selector_number.convert(val, uom);
                    span.innerHTML = thisconv.total + "<span>&nbsp;" + thisconv.post + "</span>";
                }
                $inputEventCallback(val);
            });
        }
        return div;
    }


    //should do radios.
    ezRadio = function ($el, $id, $value, $lbl, $checked = true, $disabled = false, $truncateClass = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        const div = document.createElement("div");
        if ($truncateClass != "") div.classList.add($truncateClass);
        el.append(div);
        const chk = document.createElement("input");
        chk.setAttribute("type", "radio");
        chk.setAttribute("id", $id);
        chk.setAttribute("name", $id);
        chk.setAttribute("value", $value);
        if ($checked) chk.setAttribute("checked", true);
        if ($disabled) chk.setAttribute("disabled", true);
        div.append(chk);
        const lbl = document.createElement("label");
        lbl.setAttribute("for", $id);
        lbl.innerHTML = $lbl;
        div.append(lbl);
        return chk;
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $class 
     * @param {*} $cb 
     */
    injectInputAfter=function($el, $wrapperclass, $inputclass, $cb, $bDOCANCEL=true){
        var el = this.__getEl($el);
        if (el == null) return null;
        var wrapperdiv=document.createElement("div");
        if ($wrapperclass!="") wrapperdiv.classList = $wrapperclass;
        var newel = document.createElement("input");
        if ($inputclass!="") newel.classList = $inputclass;
        newel.style['flex-grow']=1;
        newel.style.cursor='auto';

        wrapperdiv.append(newel);
        this.appendAfter(el, wrapperdiv);
        ANNE.A.makeReturnPressEvent(newel, $cb);
        ANNE.A.injectEnterAfter(wrapperdiv, async($e)=>{
            $cb(newel);
            ANNE.A.removeSelf(wrapperdiv);
        })
        if ($bDOCANCEL==true) ANNE.A.injectCancelAfter(wrapperdiv, async($e)=>{
            $cb(newel);
            ANNE.A.removeSelf(wrapperdiv);
        });
        return newel;
    }

    injectEnterAfter = function($el, $cb, $class="") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var btnEnter = document.createElement("button");
        btnEnter.innerHTML = "enter";
        if ($class!="") btnEnter.classList = $class;
        el.append(btnEnter);
        btnEnter.addEventListener("click", $cb);
    }

    injectCancelAfter = function($el, $cb, $class="btn-red-sq") {
        var el = this.__getEl($el);
        if (el == null) return null;
        const btnCancel = document.createElement("button");  
        if ($class!="") btnCancel.classList=$class;         
        btnCancel.innerHTML = "[x]";
        el.appendChild(btnCancel);
        btnCancel.addEventListener("click", $cb);
    }


    /**
     * Make a return press event to callback the $cb.
     * @param {*} $el 
     * @param {*} $cb 
     * @returns 
     */
    makeReturnPressEvent = async($el, $cb)=>{
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($cb!=null) {
            el.addEventListener("keyup", async($e)=>{
                if ($e.keyCode === 13) {
                    $cb(el);
                }
            });    
        }
        return;
    }

    
    /**
     * Make a new element just like the $el and inject it after the $el as a sibbling.
     * @param {*} $el 
     * @returns 
     */
    makeSibAfter=function($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var clone = $el.cloneNode(true);
        clone.innerHTML="";
        clone.id="newidclon_"+Math.floor(Math.random()*1000);
        this.appendAfter(el, clone);
        return clone;
    }


    /**
     * 
     * @param {anne_gui_role} $agr - the gui role object 
     */
    ezRoleEdit = function ($el, $clump_nid, $rel, $guid, $bEDIT = false, $bMOD = false, $el_inject = "", $newcb = null, $cancelcb = null, $deletecb = null, $span2 = null) {
        var span2 = $span2;
        if (span2 == null) span2 = this.ezRoleDisplay($el, $rel, $guid);
        else span2 = ANNE.A.__getEl($span2);

        var el_inject = ANNE.A.__getEl($el_inject);
        if (el_inject) {
            span2.setAttribute("el_inject", $el_inject.id);
        }

        span2.setAttribute("clump_nid", $clump_nid);
        span2.setAttribute("guid", $guid);

        if ($bEDIT == true) {
            var btnAdd = document.createElement("button");
            btnAdd.innerHTML = "+add";
            btnAdd.id = "add_" + $rel.rid + "_" + $guid;
            span2.append(btnAdd);
            btnAdd.addEventListener("click", e => ANNE.A.editRoleLaunchSelector(span2, $newcb, $cancelcb));
            span2.setAttribute("delete_ok", 1);
            btnAdd.style['margin-left'] = '4px';

            if ($rel.type == TYPE_ROLE) {
                var btndelete = document.createElement("button");
                btndelete.innerHTML = "[remove]";
                btndelete.id = "delete_" + $rel.rid + "_" + $guid;
                span2.append(btndelete);
                btndelete.setAttribute("txid", $rel.txid);
                btndelete.addEventListener("click", e => $deletecb(span2, btndelete));
                btndelete.style['margin-left'] = '4px';
            }

        }

        if ($bMOD == true) {
            var btnmod = document.createElement("button");
            btnmod.innerHTML = "+mod";
            btnmod.id = "mod_" + $rel.rid + "_" + $guid;
            btnmod.style['margin-left'] = '4px';
            btnAdd.addEventListener("click", e => function (e) { alert("todo"); });
            div.append(btnmod);
        }

        var ptxid = "";
        var to_s = "";
        if ($rel != null) {
            ptxid = $rel.txid;
            to_s = $rel.to_s;
        }

        var default_class_nid = null;
        var clumpNOBJ = MEMG.getNeuronByNid($clump_nid);

        if (ptxid != "") default_class_nid = clumpNOBJ.getDefaultClassForParam(ptxid);
        if (default_class_nid != null) span2.setAttribute("classRestrictNid", default_class_nid);
        else if (to_s != "") span2.setAttribute("classRestrictNid", to_s);
        else if ($default_class_nid != null) span2.setAttribute("classRestrictNid", $default_class_nid);
    }


    /**
     * An editable role has been clicked on, launch the selector
     * @param {*} $span2 
     */
    editRoleLaunchSelector = async ($span2, $cb_new = null, $cb_cancel = null, $cb_defocus = null) => {
        var tnid = $span2.getAttribute("role_tnid");
        var el_inject = $span2.getAttribute("el_inject");
        var roleNOBJ = MEMG.getNeuronByTempNid(tnid);
        var misc = {};
        misc.smartDefocus = $cb_defocus;
        misc.bCALLBACKONLY = true;
        var pObj = new page_params($cb_new, $cb_cancel, null, roleNOBJ.nid);
        pObj.misc = misc;
        var contextNOBJ = null;
        var classRestrictNid = $span2.getAttribute("classRestrictNid");
        if (classRestrictNid != undefined) {
            pObj.misc.classRestrictNid = classRestrictNid;
            contextNOBJ = MEMG.getNeuronByNid(classRestrictNid);
        }
        var page = PAGES.getDefaultSelectorPageForClass(roleNOBJ, null, contextNOBJ);
        console.log("%cPAGE "+page, TALK.bggreen);
        var clump_nid = $span2.getAttribute("clump_nid");
        pObj.misc.from_nid = clump_nid;   //all TYPE_ROLE relons will be put on the clump.
        pObj.misc.type = TYPE_ROLE;
        pObj.misc.reln_nid = roleNOBJ.nid;
        ANNE.A.empty(el_inject);
        pObj.injection_div = el_inject;
        var guid = $span2.getAttribute("guid");
        if (guid == null) return;
        var pgui = PAGES.getPguiByGuid(guid);
        if (pgui.INST && typeof pgui.INST.smartDefocus === "function") {
            pgui.INST.smartDefocus(true);
        }
        if (pgui == null) return;
        await pgui.loadPart(page, pObj);
    }


    /**
     * @param {*} $rel 
     */
    ezRoleDisplay = function ($el, $rel, $guid) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var roleNOBJ = MEMG.getNeuronByTempNid($rel.r);
        var _roletname = roleNOBJ.text.replaceAll("_", "-");

        //frienly replacement of role name from affected_thing to who
        //when dealing with persons in the that slot.
        if ($rel.to_type == TO_TYPE_ANNE) {
            if (_roletname == "role-affected-thing") {
                var toNOBJ = MEMG.getNeuronByTempNid($rel.t);
                if (toNOBJ.is(MEM.person) == true) _roletname = "role-affected-who";
            }
            else if (_roletname == "role-actor") {
                var toNOBJ = MEMG.getNeuronByTempNid($rel.t);
                if (toNOBJ.is(MEM.person) == true) _roletname = "role-actor-who";
            }
        }

        var div = document.createElement("div");
        div.classList = "role2 " + _roletname + "-outter";
        el.append(div);
        var span1 = document.createElement("span");
        span1.classList = _roletname + "-" + "lbl";
        div.append(span1);
        var span2 = document.createElement("span");
        span2.classList = "r-inner";
        span2.id = "val_" + roleNOBJ.temp_nid + "_" + $guid;
        span2.setAttribute("role_tnid", roleNOBJ.temp_nid);
        div.append(span2);

        //display only if a role relon
        if ($rel.type == TYPE_ROLE) {
            if ($rel.to_type == TO_TYPE_ANNE) {
                ANNE.MEM_UDF.makeNeuronLink(div, $rel.to_s);
            }
            else if ($rel.to_type == TO_TYPE_TXID) {
                ANNE.MEM_UDF.makeRelonViewLink(div, $rel.to_s);
            }
            else {
                var totxt = MEMG.__MASTER_DISPLAY_RELON_TO($rel);
                ANNE.A.setHTML(div, totxt);
            }
        }

        return span2;
    }


    ezSQDWrapper = function ($el, $class, $display = "", $callback, $callbackParams, $size = "36px", $title = "remove member") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var termdelete = document.createElement("div");
        el.append(termdelete);
        if ($class != "") termdelete.classList = $class;
        if ($display != "") termdelete.style.display = $display;
        ANNE.A.ezSquareDelete(termdelete, $callback, $callbackParams, $size, $title);
        return termdelete;
    }

    ezSquareDelete = function ($el, $callback, $callbackParams, $size = "36px", $title = "remove member") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var dsquare = document.createElement("div");
        dsquare.classList = "delete-square";
        el.append(dsquare);
        var boxX = ANNE.A.ezEl(dsquare, "span", "boxX", "<img src='../imgs/boxX.png' height='" + $size + "' width='" + $size + "'>", "", $title);
        var sl1c = this.sl1c;
        if (typeof $callback !== "function") {
            console.log("callback jacked up in ezSquareDelete");
            return;
        }
        boxX.addEventListener("click", e => $callback(...$callbackParams));
    }

    
    /**
     * 
     * @param {*} $el 
     * @param {*} $prop 
     * @param {*} $maxgens 
     * @returns 
     */
    extractNearestObjByProp=function($el, $prop="tnid", $maxgens = 4) {
        var gens = 5;
        while ($el != null) {
            gens++;
            var attr_val = $el.getAttribute($prop);
            if (attr_val != null) return $el;
            $el = $el.parentElement;
            if ($el == null) return null;
            if (gens > $maxgens) return null;
        }
        return null;
    }

    /**
     * Extract the prop of a nearest-ancestor
     * @param {*} $el 
     * @param {*} $prop 
     * @param {*} $maxgens 
     * @returns 
     */
    extractNearest=function($el, $prop="tnid", $maxgens = 4) {
        var gens = 5;
        while ($el != null) {
            gens++;
            var attr_val = $el.getAttribute($prop);
            if (attr_val != null) return attr_val;
            $el = $el.parentElement;
            if ($el == null) return null;
            if (gens > $maxgens) return null;
        }
        return null;
    }

    
    /**
     * @param {Element} $el
     */
    ez_getNearestParentWithProp = function ($el, $prop="nid", $maxgens = 4) {
        var gens = 0;
        while ($el != null) {
            gens++;
            var nid = $el.getAttribute($prop);
            if (nid != null) return nid;
            $el = $el.parentElement;
            if ($el == null) return null;
            if (gens > $maxgens) return null;
        }
        return null;
    }

    /**
     */
    ez_floatActionIco = async ($nid, $ainame, $titleOverride = "")=> {
        var title = ""
        var actionz = "";

        if ($ainame == "mine") {
            title = "This is your data.  Click on it to delete it.";
            actionz = "delete";
        }

        else if ($ainame == "collab") {
            title = "This is data you can collab on.  Click on it to delete it.";
            actionz = "delete";
        }

        //this is locally ghosted data..
        else if ($ainame == "ghost") {

            if (ANNE._txMode == TXMODE_GHOST) {
                title = "This is your ghost.  Only you see it.";
            }

            //if in ANNE mode...
            else if (ANNE._txMode == TXMODE_ANNE) {

                //if it is upgradable...
                var nObj = MEMG.getNeuronByTempNid($nid);
                if (nObj._govenor == null) await nObj.setGovRights(USER._userNObj, false);
                if (nObj.collab_ACTION >= govenor.COLLAB_REQ_OK) {
                    title = "Save your ghost to ANNE.";
                    $ainame = "ghost-to-anne";
                    actionz = "upgrade-ghost-to-anne";
                }
                else {
                    title = "This class of local ghost data cannot be upgraded to ANNE Ghost data.";
                }
            }
        }

        var newspan = document.createElement("span");
        newspan.classList = "hoverable";
        newspan.setAttribute("title", title);
        var itag = document.createElement("i");
        itag.classList = "ai-" + $ainame + " actions-ico";

        //this will trigger DOM events on class clicks to optimize (minimize) events.
        //the widget calling this helper will have to be listening.
        if (actionz) itag.setAttribute("actionz", actionz);

        newspan.append(itag);
        return newspan;
    }

    /**
     */
    ez_auto_inject_close_btn = function ($el, $class, $hrefid, $spanClass = "hoverable", $icoclass = "ai-times-circle ai-2x", $bPREPEND = false) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var betterEl = el.querySelector(".inject-close-here");

        //always prepend into the 
        if (betterEl) el = betterEl;

        var bPREPEND = true;    //if we didn't find a better el, PREPEND (to injection div)
        return ANNE.A.ezHrefBtn(el, $class, $hrefid, $spanClass, $icoclass, bPREPEND);
    }


    /**
     * EXT - NOT IN USE IN EXT...
     * 
     * This will render a gui ico for deleting or updgrading ur own records.
     */
    ez_floatActionIcos = async ($nObj, $el, $ownStatus = "collab")=> {
        var el = this.__getEl($el);
        if (el == null) return null;
        var bSHOW = false;

        if ($nObj.mine == true) {
            var floatico = await ANNE.A.ez_floatActionIco($nObj.temp_nid, "mine");
            floatico.style = "cursor:default";
            el.append(floatico);
            bSHOW = true;
        }

        //only one of these...
        else if ($nObj.ghost == true) {
            var floatico = await ANNE.A.ez_floatActionIco($nObj.temp_nid, "ghost");
            el.append(floatico);
            bSHOW = true;
        }
        else if ($ownStatus == "collab") {
            var floatico = await ANNE.A.ez_floatActionIco($nObj.temp_nid, "collab");
            el.append(floatico);
            bSHOW = true;
        }

        if (bSHOW == true) ANNE.A.show(el);
    }


    /**
     * text dd
     */
    ezDD_basic = function ($el, $items, $prompt = "select", $callback = null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var selectel = null;
        if (el.tagName == "SELECT") selectel = el;
        else {
            selectel = document.createElement("select");
            el.appendChild(selectel)
        }
        ANNE.A.empty(selectel);
        if ($callback != null && typeof $callback === "function") {
            selectel.addEventListener("change", e => $callback(selectel.value));
        }
        var opt = document.createElement("option");
        opt.setAttribute("value", "");
        opt.innerHTML = $prompt;
        selectel.append(opt);
        for (var i = 0; i < $items.length; i++) {
            var item = $items[i];
            var opt = document.createElement("option");
            opt.setAttribute("value", item);
            opt.innerHTML = item;
            selectel.append(opt);
        }
        ANNE.A.show(selectel);
        return selectel;
    }


    /** 
     */
    ezDD = function ($el, $temp_nids, $callback = null, $msg = "select something", $bSORTTEXT = true, $ddClass = "", $bINSTOK = true, $bSHOWNID = false, $skiptnids = []) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var selectel = null;
        if (el.tagName == "SELECT") selectel = el;
        else {
            selectel = document.createElement("select");
            el.appendChild(selectel)
        }

        if ($ddClass != "") selectel.classList.add($ddClass);
        if ($callback != null && typeof $callback === "function") {
            selectel.addEventListener("change", e => $callback(e));
        }
        ANNE.A.empty(selectel);
        var headerO = document.createElement("option");
        headerO.setAttribute("data-divider", true);
        headerO.setAttribute("value", null);
        headerO.innerHTML = $msg;
        selectel.append(headerO);
        var aNObjs = MEMG.getNObjsFromTempNidList($temp_nids);
        if ($bSORTTEXT == true) aNObjs.sort(ANNE.UTILS.sortByTextNoCase);
        for (var n = 0; n < aNObjs.length; n++) {
            var nObj = aNObjs[n];
            if ($bINSTOK == false && nObj.ntype == NTYPE_INST) continue;
            if ($skiptnids.length && $skiptnids.indexOf(nObj.temp_nid) != -1) continue;
            var opt = document.createElement("option");
            opt.setAttribute("value", nObj.nid);

            opt.innerHTML = nObj.bestNameHTML("", $bSHOWNID);

            selectel.append(opt);
        }
        selectel.setAttribute('selectedIndex', 0);
        ANNE.A.show(selectel);
        return selectel;
    }


    /**
     * used in pref dds 
     */
    ezDD_masterDDObj = function ($el, $masterOBJS, $callback = null, $msg = "easy access acct nids", $ddClass = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var selectel = null;
        if (el.tagName == "SELECT") selectel = el;
        else selectel = this.ezEl(selectec, "select");

        if ($ddClass != "") selectel.classList.add($ddClass);
        if ($callback != null && typeof $callback === "function") {
            selectel.addEventListener("change", e => $callback(e));
        }
        ANNE.A.empty(selectel);
        var headerO = document.createElement("option");
        headerO.setAttribute("data-divider", true);
        headerO.setAttribute("value", null);
        headerO.innerHTML = $msg;
        selectel.append(headerO);

        for (var n = 0; n < $masterOBJS.length; n++) {
            var masterOBJ = $masterOBJS[n];
            var nObj = masterOBJ.nObj;
            var type = masterOBJ.type;
            var nick = masterOBJ.nick;
            var opt = document.createElement("option");
            opt.setAttribute("value", nObj.nid);
            var text = "";
            if (nick == nObj.nid) opt.innerHTML = "(" + type + ") " + nObj.nid;
            else opt.innerHTML = "(" + type + ") " + nick + " - " + nObj.nid;
            selectel.append(opt);
        }
        selectel.setAttribute('selectedIndex', 0);
        ANNE.A.show(selectel);
        return selectel;
    }

    /**
     */
    ezDD_nObjs = function ($el, $nObjs, $callback = null, $msg = "select something", $bSORTTEXT = true, $ddClass = "", $bINSTOK = true, $bSHOWNID = false) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var selectel = null;
        if (el.tagName == "SELECT") selectel = el;
        else {
            selectel = document.createElement("select");
            el.appendChild(selectel)
        }

        if ($ddClass != "") selectel.classList.add($ddClass);
        if ($callback != null && typeof $callback === "function") {
            selectel.addEventListener("change", e => $callback(e));
        }
        ANNE.A.empty(selectel);
        var headerO = document.createElement("option");
        headerO.setAttribute("data-divider", true);
        headerO.setAttribute("value", null);
        headerO.innerHTML = $msg;
        selectel.append(headerO);
        //var aNObjs=MEMG.getNObjsFromTempNidList($temp_nids);
        if ($bSORTTEXT == true) $nObjs.sort(ANNE.UTILS.sortByTextNoCase);
        for (var n = 0; n < $nObjs.length; n++) {
            var nObj = $nObjs[n];
            if (nObj == null) continue;
            if ($bINSTOK == false && nObj.ntype == NTYPE_INST) continue;
            var opt = document.createElement("option");
            opt.setAttribute("value", nObj.nid);
            if (nObj.local_nickname != undefined) opt.innerHTML = nObj.local_nickname;
            else opt.innerHTML = nObj.bestNameHTML("", $bSHOWNID);

            selectel.append(opt);
        }
        selectel.setAttribute('selectedIndex', 0);
        ANNE.A.show(selectel);
        return selectel;
    }

    doGoogleMap = function ($el, $lat = -34.397, $long = 150.644) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var map = new google.maps.Map(el, {
            center: { lat: $lat, lng: $long },
            zoom: 8,
        });
        return map;
    }

    /**
     */
    ezDDWithGens = function ($el, $temp_nids, $callback = null, $msg = "select something", $bSORTTEXT = true, $ddClass = "", $bINSTOK = true) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var selectel = null;
        if (el.tagName == "SELECT") selectel = el;
        else {
            selectel = document.createElement("select");
            el.appendChild(selectel)
        }
        if ($ddClass != "") selectel.classList.add($ddClass);
        if ($callback != null && typeof $callback === "function") {
            selectel.addEventListener("change", e => $callback(e));
        }
        ANNE.A.empty(selectel);
        var headerO = document.createElement("option");
        headerO.setAttribute("data-divider", true);
        headerO.setAttribute("value", null);
        headerO.innerHTML = $msg;
        selectel.append(headerO);
        var aNObjs = MEMG.getNObjsFromTempNidList($temp_nids);
        if ($bSORTTEXT == true) aNObjs.sort(ANNE.UTILS.sortByTextNoCase);

        //aNOBJS are the are the tops.  
        //We want to dig down and get their children.
        for (var n = 0; n < aNObjs.length; n++) {
            var nObj = aNObjs[n];
            if ($bINSTOK == false && nObj.ntype == NTYPE_INST) continue;
            var downline = [];
            nObj.getAllDownlineChildren(downline, 0, false, false, true, false);
            var opt = document.createElement("option");
            opt.setAttribute("value", nObj.nid);
            opt.innerHTML = nObj.bestNameHTML();
            opt.classList = "option-top";
            selectel.append(opt);

            for (var a = 0; a < downline.length; a++) {
                var childNOBJ = downline[a];
                //doHeading(nObj);
                var indent = "&#9494;";
                var space = '&#160;';
                if (childNOBJ.be_lvl == 0) space = "";
                else {
                    for (var i = 0; i < childNOBJ.be_lvl - 1; i++) { space += '&#160;'; }
                    space = space + indent;
                }
                var opt2 = document.createElement("option");
                opt2.setAttribute("value", childNOBJ.nid);
                opt2.innerHTML = space + childNOBJ.bestNameHTML();
                selectel.append(opt2);
                //items.push({id: nObj.temp_nid,text: '<div>'+space+nObj.text+' ('+nObj.nid+')</div>',value: nObj.nid});
            }
            //results.push({text: $heading,children: items});
        }
        selectel.setAttribute('selectedIndex', 0);
        ANNE.A.show(selectel);
        return selectel;
    }

    /**
     */
    ezDDWithGens_ACTIONS = function ($el, $temp_nids, $callback = null, $msg = "select something", $bSORTTEXT = true, $ddClass = "", $bINSTOK = true, $V1ONLY = true) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var selectel = null;
        if (el.tagName == "SELECT") selectel = el;
        else {
            selectel = document.createElement("select");
            el.appendChild(selectel)
        }
        if ($ddClass != "") selectel.classList.add($ddClass);
        if ($callback != null && typeof $callback === "function") {
            selectel.addEventListener("change", e => $callback(e));
        }
        ANNE.A.empty(selectel);
        var headerO = document.createElement("option");
        headerO.setAttribute("data-divider", true);
        headerO.setAttribute("value", null);
        headerO.innerHTML = $msg;
        selectel.append(headerO);
        var aNObjs = MEMG.getNObjsFromTempNidList($temp_nids);
        if ($bSORTTEXT == true) aNObjs.sort(ANNE.UTILS.sortByTextNoCase);

        //aNOBJS are the are the tops.  
        //We want to dig down and get their children.
        for (var n = 0; n < aNObjs.length; n++) {
            var nObj = aNObjs[n];
            if ($bINSTOK == false && nObj.ntype == NTYPE_INST) continue;

            //we only want V1 vbs.
            if ($V1ONLY == true) {
                var rel_vbForm = MEMG.getBeRelon(nObj.outs, MEM.vb_form.temp_nid);
                if (rel_vbForm != null) {
                    if (rel_vbForm.t != MEM.vb_v1.temp_nid) {
                        console.log("skipping non v1");
                        continue;
                    }
                }
            }

            var downline = [];
            nObj.getAllDownlineChildren(downline, 0, false, false, true, false);
            var opt = document.createElement("option");
            opt.setAttribute("value", nObj.nid);
            opt.innerHTML = nObj.bestNameHTML();
            opt.classList = "option-top";
            selectel.append(opt);

            for (var a = 0; a < downline.length; a++) {
                var childNOBJ = downline[a];

                //we only want v1 vbs.
                if ($V1ONLY == true) {
                    var rel_vbForm = MEMG.getBeRelon(childNOBJ.outs, MEM.vb_form.temp_nid);
                    if (rel_vbForm != null) {
                        if (rel_vbForm.t != MEM.vb_v1.temp_nid) {
                            console.log("skipping non v1");
                            continue;
                        }
                    }
                }

                var indent = "&#9494;";
                var space = '&#160;&#160;&#160;';
                if (childNOBJ.be_lvl == 0) space = "";
                else {
                    for (var i = 0; i < childNOBJ.be_lvl - 1; i++) { space += '&#160;&#160;&#160;'; }
                    space = space + indent;
                }
                var opt2 = document.createElement("option");
                opt2.setAttribute("value", childNOBJ.nid);
                opt2.innerHTML = space + childNOBJ.bestNameHTML();
                selectel.append(opt2);
            }
        }
        selectel.setAttribute('selectedIndex', 0);
        ANNE.A.show(selectel);
        return selectel;
    }

    /**
     * 
     * @param {*} $el 
     * @param {*} $val 
     * @returns 
     */
    setSelectedIndexByValue=function($el, $val) {
        var el = this.__getEl($el);
        if (el == null) return null;
        for (var i=0; i<el.options.length; i++) {
            if (el.options[i].value==$val) {
                selectel.setAttribute('selectedIndex', i);
                break;
            }
        }
    }


    /**
     * ez row with 2 col
     */
    ez2Col = function ($el, $v1 = "", $v2 = "", $v1extraclass = "", $v2extraclass = "") {
        var v1class = "simple-col";
        if ($v1extraclass != "") v1class = v1class + " " + $v1extraclass;
        var v2class = "simple-col";
        if ($v2extraclass != "") v2class = v2class + " " + $v2extraclass;
        var row = ANNE.A.ezEl($el, "div", "simple-row");
        ANNE.A.ezEl(row, "div", v1class, $v1);
        ANNE.A.ezEl(row, "div", v2class, $v2);
        return row;
    }


    //intended for new divs, spans, and other elements that
    //you want to also givev a class, id and style.
    ezEl = function ($el, $type, $classList = "", $text = "", $id = "", $title = "", $style = null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var newEl = document.createElement($type);
        if ($classList != "") this.__classListParse(newEl, $classList);
        if ($text != "") newEl.innerHTML = $text;
        if ($title != "") newEl.setAttribute("title", $title);
        if ($id != "") newEl.setAttribute("id", $id);
        if ($style != null) ANNE.A.setStyle($el, $style);
        el.append(newEl);
        return newEl;
    }
    ezElPrepend = function ($el, $type, $classList = "", $text = "", $id = "", $title = "", $style = null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var newEl = document.createElement($type);
        if ($classList != "") this.__classListParse(newEl, $classList);
        if ($text != "") newEl.innerHTML = $text;
        if ($title != "") newEl.setAttribute("title", $title);
        if ($id != "") newEl.setAttribute("id", $id);
        if ($style != null) ANNE.A.setStyle($el, $style);
        el.prepend(newEl);
        return newEl;
    }


    /**
     * ??????? not called anymore?
     * @param {*} $parentNOBJ 
     * @param {*} $nObj 
     * @param {*} $el 
     * @param {*} $w 
     * @param {*} $callback 
     * @param {*} $attrs 
     * @returns 
     */
    loadImageDefault=async($parentNOBJ, $nObj, $el, $w=100, $callback=null, $attrs=null)=> {
        var afile = await IMAGES.getDNI_lad2($parentNOBJ, $nObj, $el, $w, 0, $w);
        if (afile && afile.imgel!=null) {
            var imgnid = afile.imgel.getAttribute("nid");
            if (imgnid && $attrs!=null) {
                var keys = Object.getKeys($attrs);
                for (var k=0; k < keys.length; k++) {
                    if (afile.imgel.getAttribute(keys[k])==null) {
                        afile.imgel.setAttribute(keys[k], $attrs[ keys[k] ]);
                    }
                }
                afile.imgel.addEventListener("click", $callback);
            }
            ANNE.A.show($el);
            return;
        }
        var url = ANNE.A.getThumbImgUrl($nObj, null);
        if (url!="") { 
            var imgel = ANNE.A.doImageDyno2($el, "", url, 100, "");
            imgel.addEventListener("click", $callback);
        }
        else ANNE.A.hide($el);
    }

    
    doImgB64 = function($el, $nObj, $icostyle="dossier", $w=84, $h=0) {     
        var el = this.__getEl($el);
        if (el == null) return null;
        var url = ANNE.A.getThumbImgUrl($nObj, $icostyle);
        if (url.length) {
            ANNE.A.doImageB64(el, "", $afile, $w, $h);
        }
    }



    /**
     * 
     * @param {*} $nObj 
     * @returns 
     */
    getThumbImgUrl=function($nObj) {
        var parentNOBJ = $nObj.getParent();
        var neuronImgNOBJ = MEM.__GET_DEFAULT_IMG_NEURON(parentNOBJ, $nObj);
        if (neuronImgNOBJ!=null) {
            var url = IMAGES.getUrl(neuronImgNOBJ);
            if (url!="") return url;
        }

        //we're going to nixx all this drama.
        return ANNE.A.getThumbImgUrlFromRelons($nObj);
    }


    /**
     * 
     * @returns 
     */
    getThumbImgUrlFromRelons = function($nObj, $icostyle=null) {
        var test = MEMG.getHasRelon($nObj.outs, MEM.wcImgUriPart_thumbnail.temp_nid);
        if (test==null) {
            test = MEMG.getHasRelon($nObj.outs, MEM.wcImgUriPart_Skyline.temp_nid);
            if (test==null) {
                test = MEMG.getHasRelon($nObj.outs, MEM.wcImgUriPart_Map.temp_nid);
                if (test==null) {
                    test = MEMG.getHasRelon($nObj.outs, MEM.wcImgUriPart_Flag.temp_nid); 
                    if (test==null) test = MEMG.getHasRelon($nObj.outs, MEM.wcImgUriPart_Seal.temp_nid); 
                }
            }
        }
        if (test!=null) { 
            return "http://commons.wikimedia.org/wiki/Special:FilePath/"+test.to_s+"?width=200";
        }

        //console.log("not enough info on "+$nObj.text+" for img or ico");
        return "";
    }


    focusTextFix = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.addEventListener("focus", function () {
            el.setSelectionRange(0, 0);
        });
    }

    
    __classListParse = function ($el, $cl) {
        if ($cl == "") return;

        if ($cl != "") {
            if ($cl.indexOf(" ") != -1) {
                var cl = $cl.split(" ");
                for (var c = 0; c < cl.length; c++) {
                    var clstr = cl[c].trim();
                    if (clstr == "") return;
                    $el.classList.add(clstr);
                }
            }
            else $el.classList = $cl;
        }
    }

    //we can inject a close button into a model with this..
    //and then wire it to its pgui.close function, automatically. :)
    ezHrefBtn = function ($el, $hrefClass, $hrefid=null, $spanClass = "hoverable", $icoclass = "ai-times-circle ai-2x", $bPREPEND = false) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var href = document.createElement("a");
        if ($hrefid!=null) href.setAttribute("id", $hrefid);
        if ($hrefClass) href.classList = $hrefClass;
        if ($bPREPEND == false) $el.append(href);
        else $el.prepend(href);
        ANNE.A.ezIcoSpan(href, $spanClass, $icoclass);
        return href;
    }

    /**
     * ez ico img using the css ico classes
     */
    ezIcoImgSpan = function ($el, $img_class, $msg, $bEMPTY = true, $bSHOW = true) {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        if ($bEMPTY == true) ANNE.A.empty(el);
        var span = document.createElement("span");
        span.classList = $img_class;
        el.append(span);
        if ($msg != "") {
            var msg_span = document.createElement("span");
            msg_span.innerHTML = $msg;
            el.append(msg_span);
        }
        if ($bSHOW == true) ANNE.A.show(el);
    }


    ezIcoLink = function ($el, $href = "#", $ico_class = "ai-anne") {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        var link = document.createElement("a");
        link.setAttribute("href", $href);
        el.append(link);
        var link_i = document.createElement("i");
        link_i.classList = $ico_class;
        link.append(link_i);
    }


    ezHref = function ($el, $href = "#", $target = "_blank", $txt = "", $ico_class = "") {
        var el = this.__getEl($el);
        var link = document.createElement("a");
        link.setAttribute("href", $href);
        link.setAttribute("target", $target);
        if ($txt == "") link.innerHTML = $href;
        else link.innerHTML = $txt;
        el.append(link);
        if ($ico_class != "") {
            var link_i = document.createElement("i");
            link_i.classList = $ico_class;
            link.append(link_i);
        }
    }


    ezIcoSpan = function ($el, $spanClass, $icoClass, $spanMsg = "", $stylejson = null) {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        //if (el==null) return null;
        var newel = document.createElement("span");
        if ($spanClass) newel.classList = $spanClass;
        if (el != null) el.append(newel); //append if we have it, else we just return the new one
        if ($stylejson != null) el.style = $stylejson;
        var ico = document.createElement("i");
        ico.classList = $icoClass;
        newel.append(ico);
        if ($spanMsg != "") newel.innerHTML = newel.innerHTML + $spanMsg;
        return newel;
    }

    ezlblSpan = function ($el, $lbl, $value = "", $spanclass = "", $valclass = "", $sep = "&nbsp;") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var newel = document.createElement("span");
        if ($spanclass != "") newel.classList = $spanclass;
        if ($valclass == "") newel.innerHTML = $lbl + $sep + $value;
        else newel.innerHTML = $lbl + $sep + '<span class="' + $valclass + '">' + $value + '</span>';
        el.append(newel);
        return newel;
    }

    ezTextList = function ($el, $outs, $relnNOBJ, $lbl = "", $class = "simple-row", $exclude = [TYPE_PARAM], $sep = ", ") {
        var list = TALK.printListByReln($outs, $relnNOBJ.temp_nid, $exclude, $sep);
        if (list.length > 0) {
            var eltextlist = document.createElement("div");
            if ($class != "") eltextlist.classList = $class;
            if ($lbl != "") eltextlist.innerHTML = $lbl + list;   //lbl should have trailing space if it is needed.
            $el.append(eltextlist);
        }
    }

    
    ezTwoColTextList = function ($el, $outs, $relnNOBJ, $lbl = "", $exclude = [TYPE_PARAM], $lblClass = "span-lbl", $dataClass = "span-data") {
        var relons = MEMG.getRelonsByTempR($outs, $relnNOBJ.temp_nid, $exclude);
        if (relons.length == 0) return "";

        var elrow = this.ezEl($el, "div", "simple-row");
        var lblcol = this.ezEl(elrow, "div", "simple-col tal");
        this.ezSpan(lblcol, "", $lblClass, $lbl);

        var datacol = this.ezEl(elrow, "div", "simple-col tal");

        for (var r = 0; r < relons.length; r++) {
            var rel = relons[r];
            var totxt = MEMG.__MASTER_DISPLAY_RELON_TO(rel);
            var el_link = EXT_BTNS.makeRelonViewLink(datacol, rel.txid, false, 8, true, "", totxt);
            el_link.style.display = "block";
        }
    }

    ezSortCol = function ($el, $colObj, $tbldivid, $sort) {
        var el = this.__getEl($el);
        if (el == null) return null;

        var classList = ["sortico", "hoverable-green"];

        if ($colObj.ttype == "number") classList.push("ai-sort-amount-down");
        else if ($colObj.ttype == "string" || $colObj.ttype == "anne") classList.push("ai-sort-alpha-down");
        else if ($colObj.ttype == "date") classList.push("ai-sort-down");

        var span = document.createElement("span");
        span.innerHTML = $colObj.text + "&nbsp;";
        el.append(span);
        var ico = document.createElement("i");
        ico.classList = classList.join(" ");
        ico.setAttribute("prop", $colObj.ttype);
        ico.setAttribute("sort", $sort);
        ico.setAttribute("tbl", $tbldivid);
        span.append(ico);

        return ico; //return the sortico (so we can easily put events on it)
    }


    ezSpan = function ($el, $id, $class, $innermsg, $styleJson = null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var span = this.ezSpanSolo($id, $class, $innermsg, $styleJson);
        el.append(span);
        return span;
    }

    //make it even if empty.
    ezSpan2 = function ($el, $id, $class, $innermsg, $callback = null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var span = this.ezSpanSolo($id, $class, $innermsg, null);
        el.append(span);
        if ($callback) span.addEventListener("click", $e=>$callback($e));
        return span;
    }

    /**
     * does not append, just creates
     */
    ezSpanSolo = function ($id = "", $class = "", $innermsg = "", $styleJson = null) {
        var newel = document.createElement("span");
        if ($class) newel.classList = $class;
        if ($id != "") newel.setAttribute("id", $id);
        newel.innerHTML = $innermsg;
        if ($styleJson != null) newel.style = $styleJson;   //not working as i thought
        return newel;
    }

    ezButton = function ($el, $id = "", $text = "save", $class = "anne-btn btn-success", $callback = null) {
        var el = this.__getEl($el);
        if (el == null) return;
        var btn = document.createElement("button");
        btn.classList = $class;
        btn.innerHTML = $text;
        if ($id != "") btn.setAttribute("id", $id);
        el.appendChild(btn);
        if ($callback != null && typeof $callback === "function") {
            btn.addEventListener("click", function ($e) { 
                $e.preventDefault();
                $callback($e); 
            });
        }
        return btn;
    }

    ezButtonWithIcoClass = function ($el, $id = "", $text = "save", $class = "anne-btn btn-success", $callback = null, $icoClass="") {
        var el = this.__getEl($el);
        if (el == null) return;
        var btn = document.createElement("button");
        btn.classList = $class;
        var icoEl = document.createElement("span");
        icoEl.classList = $icoClass;
        btn.appendChild(icoEl);
        icoEl.style['pointer-events']= 'none';
        var textEl = document.createElement("span");
        textEl.innerHTML = $text;
        textEl.style['pointer-events']= 'none';
        btn.appendChild(textEl);
        if ($id != "") btn.setAttribute("id", $id);
        el.appendChild(btn);
        if ($callback != null && typeof $callback === "function") {
            btn.addEventListener("click", function ($e) { 
                $e.preventDefault();
                $callback($e); 
            });
        }
        
        return btn;
    }

    ezFbwBtn = function ($el, $tnid, $guid, $classList = "", $callback = null) {
        var el = this.__getEl($el);
        if (el == null) return;
        var btn = document.createElement("button");
        if ($classList != "") this.__classListParse(btn, $classList);
        if ($tnid) btn.setAttribute("tnid", $tnid);
        if ($tnid && $guid) btn.setAttribute("id", $guid + "_" + $tnid);
        if ($callback != null && typeof $callback === "function") {
            btn.addEventListener("click", $callback);
        }
        el.appendChild(btn);
        return btn;
    }

    ezFbwBtn_prepend = function ($el, $tnid, $guid, $classList = "", $callback = null) {
        var el = this.__getEl($el);
        if (el == null) return;
        var btn = document.createElement("button");
        if ($classList != "") this.__classListParse(btn, $classList);
        if ($tnid) btn.setAttribute("tnid", $tnid);
        if ($tnid && $guid) btn.setAttribute("id", $guid + "_" + $tnid);
        if ($callback != null && typeof $callback === "function") {
            btn.addEventListener("click", $callback);
        }
        el.prepend(btn);
        return btn;
    }

    /**
     */
    getPrintNameIcoSpan = function ($nObj) {
        if ($nObj.temp == true) return "<span class='temp-neuron'>" + $nObj.bestName() + "</span>";
        else if ($nObj.ghost == true) return "<span class='ghost-neuron'><span class='ghost-small-blue-ico'></span>" + $nObj.bestName() + "</span>";
        else if (ANNE.isANNE($nObj.owned_by)==true) return "<span class='real-neuron'><span class='anne-small-black-ico'></span>" + $nObj.bestName() + "</span>";
        else if ($nObj.owned_by == USER._userNObj.nid) return "<span class='real-neuron'><span class='mine-small-ico'></span>" + $nObj.bestName() + "</span>";
        return $nObj.text;
    }


    imgBadAudit = function ($el, $id = "", $imgref = "", $imgclass = "search-img-small", $callback = null) {
        var el = this.__getEl($el);
        if (el == null) return;
        var spanEl = this.doBadImg(el, $id, $imgref, $imgclass)
        if ($callback != null && typeof $callback === "function") {
            spanEl.addEventListener("click", function (e) { $callback(e); });
        }
        return spanEl;
    }


    imgButton = function ($el, $id = "", $imgref, $imgclass = "search-img-small", $callback = null) {
        var el = this.__getEl($el);
        if (el == null) return;
        var imgEl = this.doImageDyno(el, $id, $imgref, $imgclass)
        if ($id != "") imgEl.setAttribute("id", $id);
        el.appendChild(imgEl);
        if ($callback != null && typeof $callback === "function") {
            imgEl.addEventListener("click", function (e) { $callback(e); });
        }
        return imgEl;
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $id 
     * @param {anne_file} $afile 
     * @param {*} $imgclass 
     * @param {function} $callback 
     * @returns {element}
     */
    imgButtonB64 = function ($el, $id = "", $afile=null, $imgclass = "search-img-small", $callback = null) {
        if ($afile==null || $afile==undefined) {
			return null;
		}
        var el = this.__getEl($el);
        if (el == null) {
			return null;
		}
        var imgEl = this.doImageDynoB64(el, $id, $afile, $imgclass)
        if (imgEl==undefined || imgEl==null) {
			return null;
		}
		if ($id != "") imgEl.setAttribute("id", $id);
        el.appendChild(imgEl);
        if ($callback != null && typeof $callback === "function") {
            imgEl.addEventListener("click", function (e) { $callback(e); });
        }
        return imgEl;
    }

    
    /**
     * Insert an element into the DOM after another element.
     * lolz, as this is the same as the native .after, so we should just use that.
     * @param {Element or String} $existingNode 
     * @param {Element} $newNode 
     * @returns 
     */
    insertAfter = function($existingNode, $newNode) {
        var el = this.__getEl($existingNode);
        if (el == null) return;
        //if (el.parentNode==null) return;
        //el.parentNode.insertBefore($newNode, el.nextSibling);
        $existingNode.after($newNode);
        return;
    }

    /**
     * Move an el to be after another el.
     */
    moveElAfter=function($el1, $insertAfterThisEl) {
        var el1 = this.__getEl($el1);
        if (el1 == null) return;
        var insertAfterThisEl = this.__getEl($insertAfterThisEl);
        if (insertAfterThisEl == null) return;
        insertAfterThisEl.after($el1);
    }

    appendAfter = function($existingNode, $newNode) {
        this.insertAfter($existingNode, $newNode);
    }

    //triple toggle,  asc, desc, none
    sortToggle = function ($el, $colNumb, $sort = "desc", $callback = null, $desc = "ai-sort-desc", $asc = "ai-sort-asc") {
        var el = this.__getEl($el);
        if (el == null) return;
        var btn = document.createElement("span");
        btn.style.cursor = "pointer";
        btn.classList = "ez-sort-btn";
        btn.setAttribute("col_num", $colNumb);
        if ($sort == "desc") {
            btn.classList.add($desc);
            btn.classList.add("active");
        }
        else if ($sort == "asc") {
            btn.classList.add($asc);
            btn.classList.add("active");
        }

        //none is parked on open desc (not selected);
        else btn.classList.add($desc);

        btn.setAttribute("sort_val", $sort);

        el.appendChild(btn);

        if ($callback != null) {
            //CLICK ORDER CYYCLE::
            //NONE->DESC->ASC
            btn.addEventListener("click", function (e) {
                var target = e.target;
                target = ANNE.A.getFirstParentOf(target, "ez-sort-btn");
                var colNumb = target.getAttribute("col_num");
                var sort_val = target.getAttribute("sort_val");
                if (sort_val == "desc") {
                    target.setAttribute("sort_val", "asc");
                    ANNE.A.addClass(target, "active");
                    ANNE.A.addRemoveClassIf(target, "ai-sort-asc", "ai-sort-desc");
                    $callback(colNumb, "asc");
                }

                //asc becomes NONE.. not active.
                //sits on desc icon tho..
                else if (sort_val == "asc") {
                    target.classList.remove("active");
                    target.setAttribute("sort_val", "none");
                    ANNE.A.addRemoveClassIf(target, "ai-sort-desc", "ai-sort-asc");
                    $callback(colNumb, "none");
                }

                else if (sort_val == "none") {
                    target.setAttribute("sort_val", "desc");
                    ANNE.A.addClass(target, "active");
                    ANNE.A.addRemoveClassIf(target, "ai-sort-desc", "ai-sort-asc");
                    $callback(colNumb, "desc");
                }


            });

            //init sort.
            //if ($sort=="desc" || $sort=="asc") $callback( $colNumb, $sort);
        }
    }

    /**
     * simple toggle of a bool attribute with get/set
     */
    toggleElAttributeBool=function($el, $prop) {
        if ($el==null) return;
        if ($el.getAttribute($prop)==true) $el.setAttribute($prop, false);
        else $el.setAttribute($prop, true);
    }

    toggleBtn = function ($el, $nObj, $class = "", $callback = null, $on = true, $lbl = "", $ton = "toggled-on", $toff = "toggled-off") {
        var el = this.__getEl($el);
        if (el == null) return;
        var btn = document.createElement("button");
        btn.classList = "toggle-btn " + $class;
        if ($on == true) btn.classList.add($ton);
        else btn.classList.add($toff);
        btn.setAttribute("tnid", $nObj.temp_nid);
        if ($lbl.length) btn.innerHTML = $lbl;
        else btn.innerHTML = nObj.bestNameHTML();
        el.appendChild(btn);

        btn.addEventListener("click", function (e) {
            var target = e.target;

            //if this is off we are turning it on.
            //if it is on.. it stays on even when clicked again.
            if (target.classList.contains($toff)) {
                target.classList.remove($toff);
                target.classList.add($ton);
            }
            else {
                target.classList.remove($ton);
                target.classList.add($toff);

                //callback.
                if ($callback != null && typeof $callback === "function") $callback(e);
            }
        });

        return btn;
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $masterObj 
     * @param {*} $eltype 
     */
    makeToggleSet = function($el, $masterObj, $eltype="div") {
        var ats = new anne_toggle_set($masterObj);
        this.makeToggleSetGUI($el, ats, $eltype);
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $class 
     * @returns 
     */
    geAllSibs = function($el, $class) {
        var el = this.__getEl($el);
        if (el == null) return;
        var parent_el = el.parentNode;
        if (parent_el==null) return null;
        return parent_el.querySelectorAll("."+$class);
    }


    /**
     * Creates divs from array of anne_toggle_objs.
     * Will allow for toggle of each div via a toggle btn.
     * @param {*} $el 
     * @param {anne_toggle_set} ats 
     * @param {*} $eltype 
     * @returns {anne_toggle_set}
     */
    makeToggleSetGUI = function($el, $ats, $eltype="div") {
        var el = this.__getEl($el);
        if (el == null) return;

        var el_btn_row = ANNE.A.ezEl($el, "div", "tg-btns", "", "");
        var el_toggle_divs = ANNE.A.ezEl($el, "div", "tg-toggle-divs", "", "");

        for (var i=0; i < $ats.atos.length; i++) {
            const ato = $ats.atos[i];
            console.log("btn tnid "+ato.btn_tnid);
            
            ato.el_toggle_divs = el_toggle_divs;

            //put new button in btn row
            var btn = ANNE.A.ezButton(el_btn_row, "", ato.btn_text, ato.btn_class);
            ato.btn_el = btn;
            if (ato.btn_tnid!="") btn.setAttribute("tnid", ato.btn_tnid);

            //put new div in the .tg-set div.
            var newEl = ANNE.A.ezEl(el_toggle_divs, $eltype, ato.div_class+" tg-set", ato.text, ato.id, ato.title, ato.style);
            ato.div_el = newEl;
            btn.setAttribute("btn_tnid", ato.btn_tnid);

            
            btn.addEventListener("click", async($e)=>{
                if (ato.div_el.classList.contains("active")==true) {
                    ato.div_el.classList.remove("active");
                    if (ato.cb!=null) ato.cb(ato, false);
                }
                else {
                    //should get all tg-set divs
                    //var els = ANNE.A.geAllSibs(ato.div_el, "tg-set");
                    for (var e = 0; e < el_toggle_divs.children.length; e++) {
                        el_toggle_divs.children[e].remove("active");
                    }
                    ato.div_el.classList.add("active");
            
                    if (ato.cb!=null) ato.cb(ato, true)
                };
            });
        }
        return $ats;
    }


    /**
     * simple toggle set of buttons
     */
    toggleBtnSet = function ($el, $nObjs, $classes, $callback, $defaultNid = null, $lbloverride = []) {
        var el = this.__getEl($el);
        if (el == null) return;
        if ($nObjs.length == 0) return;
        var elset = document.createElement("div");
        elset.classList = "toggle-btn-set";
        el.appendChild(elset);
        for (var n = 0; n < $nObjs.length; n++) {
            var nObj = $nObjs[n];
            var btnclass = $classes[n];
            var btn = document.createElement("button");
            btn.classList = "toggle-btn " + btnclass;
            if ($defaultNid && nObj.nid == $defaultNid) btn.classList.add("toggled-on");
            else btn.classList.add("toggled-off");
            btn.setAttribute("nid", nObj.nid);
            if ($lbloverride.length) btn.innerHTML = $lbloverride[n];
            else btn.innerHTML = nObj.text;
            elset.appendChild(btn);
            btn.addEventListener("click", function (e) {
                var target = e.target;
                //if this is off we are turning it on.
                //if it is on.. it stays on even when clicked again.
                if (target.classList.contains("toggled-off")) {
                    //turn off the curren toggled btn.
                    var btnset = ANNE.A.getFirstParentOf(target.parentNode, "toggle-btn-set", true);
                    if (btnset != null) {
                        var onbtn = btnset.querySelector(".toggled-on");
                        if (onbtn != null) {
                            onbtn.classList.remove("toggled-on");
                            onbtn.classList.add("toggled-off");
                        }
                    }
                    //turn on this one.
                    target.classList.remove("toggled-off");
                    target.classList.add("toggled-on");

                    //callback.
                    if ($callback != null && typeof $callback === "function") $callback(e);
                }
            });
        }
        return elset;
    }

    wireShowHideToggler=function($el_to_click, $el_showhide) {
        var el = this.__getEl($el_to_click);
        if (el == null) return;

		var elshowhide = null;
		if (el.classList.contains("hide")==true) {
			elshowhide = ANNE.A.setHTML($el_showhide, "show"); 
		}
		else {
			elshowhide = ANNE.A.setHTML($el_showhide, "hide"); 
		}

		if (elshowhide && elshowhide.getAttribute("showlink_id")==undefined) {
			elshowhide.setAttribute("showlink_id", el.id);
		}
		
        el.addEventListener("click", (e)=>{
            var newval = ANNE.A.toggle($el_showhide);
            //self fixing if things get whacky
            if (newval=="show") {
                if (el.innerHTML === 'show') el.innerHTML = 'hide';
            }
            else if(newval=="hide") {
                el.innerHTML = 'show';
            }
        });
    }

    toggleShowHideLink=function($el) {
        var el = this.__getEl($el);
        if (el == null) return;
        var el = document.getElementById('toggleLink');
        if (el.innerHTML === 'hide') el.innerHTML = 'show';
        else el.innerHTML = 'hide';
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $idToToggle 
     * @param {*} $addText 
     * @param {*} $defaultOpen 
     * @param {*} $ss 
     * @returns 
     */
    toggleMinMaxBtn = function ($el, $idToToggle, $addText = "", $defaultOpen = true, $ss = null, $addClass="") {
        var el = this.__getEl($el);
        if (el == null) return;
        var btn = document.createElement("div");
        btn.setAttribute("toggle_divid", $idToToggle);
        btn.classList = "ezMinMax hover";
        if ($addClass!="") btn.classList.add($addClass)
        if ($defaultOpen == false) {
            btn.innerHTML = "<span class='ai-right-triangle'></span>" + $addText;
            ANNE.A.hide($idToToggle);
        }
        else {
            btn.innerHTML = "<span class='ai-down-triangle'></span>" + $addText;
            ANNE.A.fadeIn($idToToggle);
        }
        btn.style.cursor = "pointer";
        btn.style.display = "inline-block";
        el.append(btn);
        const ss = $ss;
        btn.addEventListener("click", function (e) {
            var target = e.target;
            target = ANNE.A.getFirstParentOf(target, "ezMinMax");
            var idToToggle = target.getAttribute("toggle_divid");
            if (idToToggle == undefined || idToToggle == null) return;
            var classz = ANNE.A.toggleWithFade(idToToggle);
            if (classz == "hide") {
                btn.innerHTML = "<span class='ai-right-triangle'></span>" + $addText;
            }
            else if (classz == "show") {
                btn.innerHTML = "<span class='ai-down-triangle'></span>" + $addText;
                var ssEl = ANNE.A.__getEl(ss);

                var percentagePosition = (el.offsetTop / ssEl.scrollHeight) * 100;
                ssEl.scrollTop = (ssEl.scrollHeight * percentagePosition) / 100;
                console.log("show section");
                //var scrollHeight = ssEl.scrollHeight;
                //ssEl.scrollTop = scrollHeight;
            }

            if ($ss != null) {
                ANNE.A.smartScroll(ss);
            }
        });

        return btn;
    }


    __getEl = function ($el) {
        if (typeof $el === "string") {
            if ($el[0] == ".") return document.querySelector($el);

            //legacy references to jquery will have # in front of them.
            else if ($el[0] == "#") return document.getElementById($el.substring(1));

            return document.getElementById($el);
        }
        return $el;
    }

    delayThen = async ($dataparam, $delayms = 300, $callback = null) => {
        await UTILS.sleep($delayms);
        if ($callback != null) $callback($dataparam);
    }

    //we may add a delay to this..
    fadeIn = function ($el, $ms = 500, $ease = "power1.in", $displayProp = "") {
        const el = this.__getEl($el);
        if (el == null) return null;
		el.style.opacity=0;
		
        gsap.to(el, {
            opacity:1,
            duration:$ms/1000,
            ease:$ease,
            onComplete:function() {
                el.style.display = $displayProp;
                el.classList.add("show");
                el.classList.remove("hide");
            }
        });

        return el;
    }

    fadeInPop = function ($el, $addglowclass = "", $displayProp = "") {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        el.classList.add("show");
        el.classList.remove("hide");
        el.style.opacity = 1;
        el.style.display = $displayProp;
        el.style.transition = "all 2000ms cubic-bezier(.39,.54,0,1.6);";
        if ($addglowclass != "") el.classList.add($addglowclass);
        return el;
    }


    fadeInDelayFadeOut = async ($el, $delayms, $inms = 500, $intt = "ease-in", $outms = 500, $outtt = "ease-out") => {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        el.classList.add("show");
        el.classList.remove("hide");
        el.style.opacity = 1;
        el.style.display = "";
        el.style.transition = "all " + $innms + "ms " + $intt + ";";
        await UTILS.sleep($inms + $delayms);
        el.classList.add("hide");
        el.classList.remove("show");
        el.style.opacity = 0;
        el.style.display = "none";
        el.style.transition = "all " + $outms + "ms " + $outtt + ";";
        return el;
    }


    /**
     * This is blocking if it is awaited on!
     * Don't await it!
     */
    fadeOut = async ($el, $ms = 500, $delay = 0, $ease = "power1.out", $onComplete=null) => {
        const el = this.__getEl($el);
        if (el == null) return null;
        
        //max 2 sec delay to avoid accidents
        if ($delay > 0) await UTILS.sleep();

        gsap.to(el, {
            delay: Math.min(2, $delay/1000),
            opacity:0,
            duration:$ms/1000,
            ease:$ease,
            onComplete:function() {
                el.style.display = "none";
                el.classList.add("hide");
                el.classList.remove("show");
                if ($onComplete!=null) $onComplete();
            }
        });

        return el;
    }


    /**
     * Tired of doing this.. so I will do it here.
     */
    formatSpanStrings = function ($el, $classes, $vars, $str, $bSHOW = true) {
        var el = this.__getEl($el);
        if ($classes.length == 0) return $str;
        if ($classes.length != $vars.length) {
            console.log("(formatSpanStrings) classes array and vars array are different lengths.  This may not do what you think it should do.");
        }
        for (var c = 0; c < $classes.length; c++) {
            var clz = $classes[c];
            var i = $str.indexOf("%");
            if (i >= 0) $str = $str.replace("%", "<span class='" + clz + "'>" + $vars[c] + "</span>");
        }
        el.innerHTML = $str;
        if ($bSHOW == true) ANNE.A.show(el);
    }

    getBottom = function ($dfc = ".smart-scroll-framer") {
        return parseInt(document.querySelector($dfc).getBoundingClientRect().bottom);
    }

    getElIndex = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return -1;
        return Array.prototype.indexOf.call(el.parentElement.children, el);
    }

    //because i forget names.
    getNearestParentOf = function($el, $stopClass, $bINCLUDESELF = true) {
        return this.getFirstParentOf($el, $stopClass, $bINCLUDESELF);
    }

    getFirstParentOf = function ($el, $stopClass, $bINCLUDESELF = true) {
        if ($stopClass == "") return null;
        var el = this.__getEl($el);
        if (el == null) return null;
        var safety = 0;
        if ($bINCLUDESELF == true) {
            if (el.classList.contains($stopClass) == true) return el;
        }
        while (el.parentNode != null) {
            if (safety > 20) return null;
            el = el.parentNode;
            if (el == null || el == undefined) return null;
            if (el.nodeName == "#document") return null;
            if (el.classList.contains($stopClass) == true) return el;
            safety++;
        }
        return null;
    }

    getFirstParentAttr = function ($el, $stopClass, $getAttribute) {
        if ($getAttribute == "") return null;
        var el = this.getFirstParentOf($el, $stopClass);
        if (el == null) return null;
        return el.getAttribute($getAttribute);
    }


    getHTML = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        return el.innerHTML;
    }

    getValue = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        return el.value;
    }

    /**
     * input (w/ inputid) marked with class="rqd" wired to element with mod-el=inputid of rqd class el
     * displays helper msg
     * DOM wires rqd element with a .modxx ptr to "mod-el" span element
     * uses css::before to display color/status in the mod-el span.
     */
    applyRQD = function ($el, $bVALID = true, $msg = "required") {
        var el = this.__getEl($el);
        if (el == null) return null;
        if (el.classList.contains("rqd") == true && el.modxx != undefined) {
            if ($bVALID) {
                el.modxx.style['color'] = "#00db00";
                el.modxx.innerHTML = 'ok';
            }
            else {
                el.modxx.style['color'] = "red";
                el.modxx.innerHTML = $msg;
            }
        }
        return el;
    }


    hasClass = function ($el, $class) {
        var el = this.__getEl($el);
        if (el == null) return null;
        return el.classList.contains($class);
    }


    hide = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return null;

        if (el.getAttribute("showlink_id")!=undefined) {
			var showlink = document.getElementById(el.getAttribute("showlink_id"));
			if (showlink!=null) {
				showlink.innerHTML = "show";
			}
		}

        if (el.classList==undefined || el.classList==null) {
            alert("what in the world???");
            return;
        }
        if (el.classList.contains("hide") == false) el.classList.add("hide");
        if (el.classList.contains("show") == true) el.classList.remove("show");
        el.style.display = "none";
        return el;
    }
    hideParent = function ($el, $bHIDESELFTOO = false) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var parent_el = el.parentNode;
        this.hide(parent_el);
        if ($bHIDESELFTOO == true) this.hide(el);
    }

    hideMulti = function ($arrDivids) {
        var els = document.querySelectorAll($arrDivids);
        for (var e = 0; e < els.length; e++) {
            var el = els[e];
            el.classList.add("hide");
            el.classList.remove("show");
            el.style.display = "none";
        }
        return el;//return the last el
    }
    emptyAndHideMulti = function ($arrDivids) {
        var els = document.querySelectorAll($arrDivids);
        for (var e = 0; e < els.length; e++) {
            var el = els[e];
            el.classList.add("hide");
            el.classList.remove("show");
            el.style.display = "none";
            el.innerHTML="";
        }
        return el;//return the last el
    }

    showAll = function($arr) {
        var el = null;
        for (var a=0; a < $arr.length; a++) {
            el = ANNE.A.show($arr[a]);
        }
        return el;
    }

    hideAll = function ($arr) {
        var el = null;
        for (var a=0; a < $arr.length; a++) {
            el = ANNE.A.hide($arr[a]);
        }
        return el;
    }

    jsonSyntaxHighlight = function ($json) {
        if ($json == null) return "";
        if (typeof $json != 'string') {
            $json = JSON.stringify($json, undefined, 2);
        }
        $json = $json.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
        return $json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
            var cls = 'number';
            if (/^"/.test(match)) {
                if (/:$/.test(match)) {
                    cls = 'key';
                } else {
                    cls = 'string';
                }
            } else if (/true|false/.test(match)) {
                cls = 'boolean';
            } else if (/null/.test(match)) {
                cls = 'null';
            }
            return '<span class="' + cls + '">' + match + '</span>';
        });
    }



    masterThumbImg = function ($el, $beNOBJ, $nObj, $imgClass = "", $bNOIMGIMG = false) {
        var el = this.__getEl($el);
        if (el == null) return null;

        var img = document.createElement("img");
        if ($imgClass != "") img.classList = $imgClass;

        //get the thumb for this if we have it,
        //falls back on class pic if we don't have thumb for this.
        var url = MEM.__GET_DEFAULT_IMG_NEURON($beNOBJ, $nObj);
        if (url == "") {
            if ($bNOIMGIMG == true) img.setAttribute("src", "imgs/unknown.png");
        }
        else img.setAttribute("src", url);
        el.append(img);
        return img;
    }


    setElBorder = function ($el, $nObj, $pendingHanai = null) {
        var el = this.__getEl($el);
        if (el == null) return;
        if ($pendingHanai != null) el.classList.add("hanai-border");
        else if ($nObj.ghost == true) el.classList.add("ghost-border");
        else if ($nObj.freeze == true) el.classList.add("freeze-border");
        else if ($nObj.owned_by == USER._userNObj.nid || $nObj.nid == USER._userNObj.nid) el.classList.add("self-owned-border");
        else if (ANNE.isANNE($nObj.owned_by)==true) el.classList.add("anne-owned-border");
        else el.classList.add("other-owned-border");
    }

    getImgBorder = function ($nObj) {
        if ($nObj == null) return "";
        if ($nObj.ghost == true) return "ghost-img";
        else if ($nObj.owned_by == USER._userNObj.nid) return "self-owned-img";
        else if (ANNE.isANNE($nObj.owned_by)==true) return "anne-owned-img";
        else return "other-owned-img";
    }


    injectPartFail = function ($x) {
        console.log("newNeuronFail");
        console.log($x);
    }


    /**
     * Update SIF options from outside
     * @param {*} $el_datalist 
     * @param {*} $nObjs 
     * @param {*} $bEMPTY 
     */
    addSIF_opts_externalupdate=function($el_datalist, $nObjs, $bEMPTY=true) {
        var el_datalist = this.__getEl($el_datalist);
        if ($bEMPTY==true) ANNE.A.empty(el_datalist);
        for (var n=0; n < $nObjs.length; n++) {
            var nObj = $nObjs[n];
            var option = document.createElement("option");
            option.setAttribute("value", nObj.bestSelectDisplay("", true, true));
            option.setAttribute("temp_nid", nObj.temp_nid);
            option.setAttribute("text", nObj.text); //for willy wonka datalist using value as lbl 
            el_datalist.append(option);
        }
    }
    

    /**
     * This is intended for lists and lookups that have potentially GINORMOUS result sets.
     * We don't want the entire universe of possibilities in a data object in the gui.
     * A neuron class with 100000 options would have 100k elements in a datalist.  This is silly.
     * 
     * Here we default to what the user has been doing in the app. (context of neurons)
     * 
     * When they click that local memory AND ANNODE memory is searched.
     * 
     * @param {Element or String} $el 
     * @param {Function} $search_cb 
     * @param {int} $seachCharMin 
     * @returns 
     */
    makeANNE_SIF=function($el, $search_locl_only_cb, $search_cb=null, $selected_cb=null, 
                                $defaultNOBJS=[], $searchCharMin=2, $bDODELETE=true, $findMoreClass="") {
        const el = this.__getEl($el);
        const local_cb = $search_locl_only_cb;
        const selected_cb = $selected_cb;

        if (el == null) return;
        if (el.type!="text" && el.nodeName!="INPUT"){
            console.log("to make an ANNE SIF we need to start with an input field!");
            return;
        }

        if(typeof $search_cb!=="function") {
            console.log("to make an ANNE SIF we need a search cb!");
            return;
        }

        el.classList.add("ANNE-SIF");

        const searchCharMin = $searchCharMin;

        el.setAttribute("autocomplete", "off");
        
        var bcr = el.getBoundingClientRect();
        var el_datalist = document.createElement("datalist");
        el_datalist.setAttribute("id", el.id+"__list");
        el.parentElement.append(el_datalist);
        el.setAttribute("list", el.id+"__list");       //tie input to data list.

        const btn = document.createElement("button");  
        btn.classList="btn-yellow-sq";
        if ($findMoreClass!="") btn.classList.add($findMoreClass);
        btn.setAttribute("id", el.id+"_sif");             
        btn.innerHTML = "find more";
        //btn.style.position="absolute";
        //btn.style['margin-left'] = (bcr.right-70)+"px";
        btn.setAttribute("list_id", el.id+"__list");
        el.parentNode.append(btn);
        if (bcr.height>0) {
            btn.style['max-height']=Math.floor(bcr.height)+2+"px";
            btn.style['height']=Math.floor(bcr.height)+2+"px";
        }
        else {
            btn.style['max-height']=32+"px";
            btn.style['height']=32+"px";
        }
        btn.style['max-width']='70px';
        btn.style['width']='70px';
        ANNE.A.hide(btn);
        
        const btn2 = document.createElement("button");  

        if ($bDODELETE) {
            btn2.classList="btn-red-sq";   
            btn2.setAttribute("id", el.id+"_sif_x");             
            btn2.innerHTML = "[x]";
            //btn2.style.position="absolute";
            //btn.style['margin-left'] = (bcr.right-40)+"px";
            btn2.setAttribute("list_id", el.id+"__list");
            el.parentNode.append(btn2);
            if (bcr.height>0) {
                btn2.style['max-height']=Math.floor(bcr.height)+2+"px";
                btn2.style['height']=Math.floor(bcr.height)+2+"px";
            }
            else {
                btn2.style['max-height']=32+"px";
                btn2.style['height']=32+"px";
            }
            btn2.style['max-width']='40px';
            btn2.style['width']='40px';

            //clear the selection.
            btn2.addEventListener("click", function(e){
                el.value="";
                ANNE.A.hide(btn);
                ANNE.A.hide(btn2);
                if (selected_cb!=null) selected_cb(-1);
                return;
            });

            ANNE.A.hide(btn2);
        }


        function addOpts($nObjs) {
            if ($nObjs==undefined || $nObjs==null) return;
            for (var n=0; n < $nObjs.length; n++) {
                var nObj = $nObjs[n];
                var option = document.createElement("option");
                option.setAttribute("value", nObj.bestSelectDisplay("", true, true));
                option.setAttribute("temp_nid", nObj.temp_nid);
                option.setAttribute("text", nObj.text); //for willy wonka datalist using value as lbl 
                el_datalist.append(option);
            }
        }
        //add in any default tnids (like local favs)
        if ($defaultNOBJS.length) addOpts($defaultNOBJS);

        el.setAttribute("search-roots", ""); 
        el.setAttribute("local-search-roots", ""); 

        function isInRoot($val, $which="search-roots") {
            var searchRootsArr = [];
            var search_roots = el.getAttribute($which);
            if (ANNE.UTILS.isset(search_roots)==true) {
                searchRootsArr = search_roots.split(",");
                for (var s=0; s < searchRootsArr.length; s++) {
                    if (searchRootsArr[s]=="") continue;
                    if ($val.indexOf(searchRootsArr[s])==0) {
                        return true;
                    }
                }
            }
            //jam the new search root val back in.  This optimizes lookups so we don't 
            //needlessly chase extended strings of strings we've already looked up!
            searchRootsArr.push($val.trim());
            el.setAttribute($which, searchRootsArr.join(","));
            return false;
        }

        var getActualVal = function() {
            //see if it matches anything we have in the datalist.
            //if so, it is selected -- so call the callback.
            //if there are multiples matching this text the user can use the dd to selecte which one they want.
            var selected_tnid = -1;
            var lowerz = el.value.toLowerCase();
            var actualVal = el.value;

            //find the selected datalist item by its unique name.
            for (var j = 0; j < el_datalist.options.length; j++) {
                if (el_datalist.options[j].value.toLowerCase()==lowerz) {
                    selected_tnid = parseInt(el_datalist.options[j].getAttribute("temp_nid") );
                    actualVal = el_datalist.options[j].getAttribute("text");
                    break;
                }
            }
            return {actualVal:actualVal, selected_tnid:selected_tnid};
        }

        
        //CALLED ON TEXT INPUT.
        var testLocal = async($e)=>{
            //willy wonka data lists only use the value prop as display.
            //if we want a disambig display in the option then that becomes the value.
            //use extra text attr in option for real text value.
            var avObj = getActualVal();
            var actualVal = avObj.actualVal;
            var selected_tnid = avObj.selected_tnid;

            //already searched for this and it is in the widget.
            //if (actualVal.length) {//} && isInRoot(actualVal, "local-search-roots")==false) {
            if (actualVal.length>0 && local_cb!=null) {
                ANNE.A.show("loading");
                var nObjs = await local_cb(actualVal);
                ANNE.A.hide("loading");
                if (ANNE.UTILS.isset(el_datalist)==false) {
                    el_datalist = document.getElementById(btn.getAttribute("list_id"));
                    if (ANNE.UTILS.isset(el_datalist)==false) return;
                }
                ANNE.A.empty(el_datalist);
                addOpts(nObjs);
            }
            //}

            if (selected_tnid>-1 && selected_cb!=null) {
                ANNE.A.hide(btn);
                ANNE.A.show(btn2);
                selected_cb(selected_tnid);
                return;
            }
            if (actualVal.length>searchCharMin) {
                ANNE.A.hide(btn2);
                ANNE.A.show(btn);
            }
            else {
                if (selected_tnid==-1 && selected_cb!=null) {
                    ANNE.A.hide(btn2);
                    ANNE.A.hide(btn);
                    selected_cb(-1);
                    return;
                }
            }
        }
    
        
        const returnKeyPress = async($e)=> {
            $e.preventDefault();
            if ($e.keyCode === 13) {
                if (btn.classList.contains("show")==true) {
                    var event = new MouseEvent('click', {
                        'view': window,
                        'bubbles': true,
                        'cancelable': true
                    })
                    btn.dispatchEvent(event);
                }
            }
        }

        //if more than the search min, open up the anne search btn.
        //if we haven't touched this search root yet, do a local ajax style search.
        el.addEventListener("input", $e=>testLocal($e));
        el.addEventListener("keyup", $e=>returnKeyPress($e));

        //find more button
        btn.addEventListener("click", async($e)=>{
            ANNE.A.show("loading");
            ANNE.A.hide(btn);

            var avObj = getActualVal();
            var actualVal = avObj.actualVal;
            
            //already searched for this and it is in the widget.
            if (actualVal.length>0 && isInRoot(actualVal, "search-roots")==true) return;

             //add in to local-search-roots too so data list feature takes over.
            if (actualVal.length>0) isInRoot(actualVal, "local-search-roots");  
        
            var nObjs = await $search_cb($e);
            if (ANNE.UTILS.isset(el_datalist)==false) {
                el_datalist = document.getElementById(btn.getAttribute("list_id"));
            }
            if (ANNE.UTILS.isset(el_datalist)==false) return;
            ANNE.A.empty(el_datalist);
            addOpts(nObjs);
            ANNE.A.hide("loading");
        });

        return btn;
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $cb 
     * @returns 
     */
    makeQuickDeleteBtn = function($el, $cb=null) {
        var el = this.__getEl($el);
        if (el == null) return;
        const btn = document.createElement("button");  
        btn.classList="btn-red-sq";                
        btn.innerHTML = "[x]";
        el.append(btn);

        if ($cb!=null && typeof $cb ==="function") {
            btn.addEventListener("click", e=>$cb(e));
        }
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $injid 
     * @param {*} $paramRelon 
     * @param {*} $GUID 
     * @param {*} $page 
     * @param {*} $existingClumpNid 
     * @param {*} $lbl 
     * @param {*} $bNEWOK 
     * @returns 
     */
    makeANTFromParam = function ($el, $injid, $paramRelon, $GUID, $page = "selector_action", $existingClumpNid = "", $lbl = "", $bNEWOK = true) {
        var el = this.__getEl($el);
        if (el == null) return;
        if ($paramRelon == undefined || $paramRelon == null) return;
        var relNOBJ = MEMG.getNeuronByTempNid($paramRelon.r);
        var toNOBJ = MEMG.getNeuronByTempNid($paramRelon.t);
        var antag = document.createElement("an");
        antag.setAttribute("role", relNOBJ.text);
        antag.setAttribute("rolereln", relNOBJ.nid);
        antag.setAttribute("newok", +$bNEWOK);
        antag.setAttribute("role_class_nid", toNOBJ.nid);
        if ($lbl == "") {
            var parts2 = relNOBJ.text.split("_");
            parts2.shift();
            $lbl = parts2.join("_");
        }
        antag.setAttribute("lbl", $lbl);
        antag.setAttribute("injid", $injid);
        antag.setAttribute("pguid", $GUID);
        antag.setAttribute("clump_nid", $existingClumpNid);
        antag.setAttribute("page", $page);
        el.append(antag);
    }

    /**
     * Using clone will destroy the existing events. (that's what it is here for)
     */
    moveElement = function ($subj2bmoved, $el_destination, $bCLONE = true) {
        if ($subj2bmoved == null) return;
        var el_parent = $subj2bmoved.parentElement;
        if (el_parent == null) return;
        var el_destination = this.__getEl($el_destination);
        if (el_destination == null) return;
        el_parent.removeChild($subj2bmoved);
        if ($bCLONE == true) {
            return this.cloneAndAppend($subj2bmoved, el_destination, true);
        }
        else el_destination.appendChild($subj2bmoved);
        return $subj2bmoved;
    }

    /**
     * Take a DOM node from its parent and move it to the spot of first child (prepend)
     */
    moveToFirst = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return;
        var parent = el.parentNode;
        if (parent == null) return;
        parent.removeChild(el);
        parent.prepend(el);
    }
    moveToEnd = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return;
        var parent = el.parentNode;
        if (parent == null) return;
        parent.removeChild(el);
        parent.append(el);
    }


    /**
     */
    parseANT_sentence = function ($ant) {
        console.log("%c (parseANT_sentence)", TALK.bgpink)
    }

    /**
     * Parse the ANTag (<an/>) which can show up in a blob.
     */
    parseANTags = function ($el, $bCHASE = false, $vars = null, $extraClass = "") {
        var el = this.__getEl($el);
        if (el == null) return;
        var ants = el.getElementsByTagName("an");

        for (var a = 0; a < ants.length; a++) {
            var ant = ants[a];

            //sentence type is for parsing sentence
            var type = ant.getAttribute("type");
            if (type != undefined) {
                console.log("%c ANT TAG TYPE " + type, TALK.bgpink)
                if (type == "sentence") {
                    this.parseANT_sentence(ant);
                    continue;
                }
            }

            var nid = ant.getAttribute("nid");
            if (nid != undefined && nid != "") {
                var nObj = MEMG.getNeuronByNid(nid);
                var txt = "";
                var dnrt = ant.getAttribute("dnrt");
                if (dnrt != null && dnrt == 1) {
                    txt = ant.innerHTML;
                }

                ant.innerHTML = "";

                if (nObj != null) {
                    EXT_BTNS.makeNeuronLink(ant, nid, $extraClass, "", false, txt);

                }
                else if ($bCHASE == true) {
                    console.log("we need to go get this value");
                }
            }

            // to do. create helpful injectable gui
            if ($vars != null) {
                var varname = ant.getAttribute("varname");
                if (varname != undefined) {
                    var dyno = $vars[varname];
                    if (dyno != undefined) {
                        ant.innerHTML = dyno;
                        ant.classList = "dynamic-value";
                    }
                }
            }

        }
    }


    /**
      * Parse the ANTag (<an/>) which can show up in a blob.
      * only do vars, not text/html tags.
      */
    parseANTagsVarsOnly = function ($el, $vars = null) {
        var el = this.__getEl($el);
        if (el == null) return;
        var ants = el.getElementsByTagName("an");
        for (var a = 0; a < ants.length; a++) {
            var ant = ants[a];
            if ($vars != null) {
                var varname = ant.getAttribute("varname");
                if (varname != undefined) {
                    var dyno = $vars[varname];
                    if (dyno != undefined) {
                        ant.innerHTML = dyno;
                        ant.classList = "dynamic-value";
                    }
                }
            }
        }
    }

    stopPlay = function($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.pause();
        el.currentTime = 0;
    }
    pausePlay = function($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.pause();
    }
    stopSound = function($el) { 
        this.stopPlay($el);
    }
    startSound = function($el) { this.play($el); }
    playSound = function($el) { this.play($el); }
    play = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.play();
    }

    pointerEventsNone = function($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.style.pointerEvents="none";
        return el;
    }
    pointerEventsAll = function($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.style.pointerEvents="all";
        return el;
    }

    removeSelf = function ($el) {
        var el = this.__getEl($el);
        if (el == null || el.parentNode == null) return null;
        el.parentNode.removeChild(el);
        return el;
    }

    /**
     * 
     * @param {*} $nObj 
     * @param {*} $bEMULATE 
     * @param {*} $prefName 
     * @param {*} $featureProp
     * @param {*} $fpLbl
     * @param {*} $fpClass
     * 
     * @returns 
     */
    neuronIdentityDisplay = async($nObj, $bEMULATE=false, $prefName="", $featureProp="did_annex", $fpLbl="ANNEX'd neurons", $fpClass="color-green")=> {
        var anneid = $nObj._anneid;
        if (anneid==undefined || anneid==null) {
            if ($bEMULATE==true) {
                anneid = AWARE.emulateANNEID($nObj);
            }
            else {
                anneid = await ANNE.API.getANNEID($nObj, false);
            }
        }
        var el_acf = document.createElement("div");
        el_acf.classList = "anneid-circ-full";
            
        var el_donut = document.createElement("div");
        el_donut.classList = "donutNONE";
        el_acf.appendChild(el_donut);
        
        var p2 = document.createElement("p");
        p2.classList = "n-circ-imgfix";
        el_acf.appendChild(p2);

        if ($nObj.getParent()==null) {
            await ANNE.CHASE.queryMinBem($nObj);
        }
        await ANNE.IMAGES.loadElIntoBG($nObj, p2);

        var acn = document.createElement("div");
        acn.classList="anneid-circ-name";
        el_acf.appendChild(acn);
        var acn2 = document.createElement("div");
        acn2.classList = "acn";
        var name = $prefName;
        if (name=="") name = $nObj.bestNameHTML();
        acn2.innerHTML = name;
        if (acn2.innerText.length>25) acn2.innerText = acn2.innerText.substring(0, 25);
        //if ($prefName[$prefName.length-1]!=")") acn2.innerText+=")";
        acn.appendChild(acn2);

        //anneid
        var fp = UTILS.commas(anneid[$featureProp]);
        var acs = document.createElement("div");
        acs.classList = "acs";
        acs.classList.add("acs-"+$nObj.nid);    //find the smart-reference.. however we update that.
        acs.innerHTML = "<span class='"+$fpClass+"'>"+fp+"</span>&nbsp;"+$fpLbl;
        acn.appendChild(acs);
        
        return el_acf;
    }


    /**
     * 
     * @param {*} $nObj 
     * @param {object} $match
     * @param {object} $arr
     * @returns 
     */
    neuronRevelatianMatchDisplay = async($nObj, $match, $lvlOffsets)=> {
        var beNOBJ = $nObj.getParent();
        if (beNOBJ==null) {
            console.log("nid:"+$nObj.nid+" text:"+$nObj.tex+" needs a parent");    
            return;
        }

        //console.log($match);

        var el_acf = document.createElement("div");
        el_acf.classList = "rev-circ-full";
        el_acf.setAttribute("overlay", true);
        el_acf.setAttribute("tnid", $nObj.temp_nid);
        el_acf.setAttribute("id", "match_tnid_"+$nObj.temp_nid);
            
            var el_donut = document.createElement("div");
            el_donut.classList = "donutNONE";
            el_acf.appendChild(el_donut);
    
            var p1 = document.createElement("p");
            p1.classList="n-circ-annex";
            el_acf.appendChild(p1);
                var sp = document.createElement("span");
                sp.classList = "REV-ico";
                p1.appendChild(sp);

                var sp2 = document.createElement("span");
                sp2.style="color:color-green font-size:20px; font-weight:900";
                sp2.innerHTML="";
                p1.appendChild(sp2)

            var p2 = document.createElement("p");
            p2.classList = "n-circ-imgfix";
            el_acf.appendChild(p2);

        await ANNE.IMAGES.loadElIntoBG($nObj, p2);

            var el_revcirc = document.createElement("div");
            el_revcirc.classList="rev-circ-name";
            el_acf.appendChild(el_revcirc);
            
                var acn2 = document.createElement("div");
                acn2.classList = "rev";
                var name = $nObj.bestNameHTML();
                acn2.innerHTML = name;
                el_revcirc.appendChild(acn2);

                var lbl = document.createElement("div");
                lbl.classList="revelatian-sublbl";
                
                if ($nObj.ntype==NTYPE_INST) lbl.innerHTML = beNOBJ.bestNameHTML() + "<span class='rev-tiny-ntype'>inst</span>";
                else if ($nObj.ntype==NTYPE_CLASS) lbl.innerHTML = beNOBJ.bestNameHTML()+ "<span class='rev-tiny-ntype'>class</span>";
                el_revcirc.appendChild(lbl);

                //var lvloffset0 = document.createElement("span");
                //if ($lvlOffsets[0]!=undefined) {
                   // lvloffset0.innerHTML = "<span class='rev-lvl0ffset0'>"+$lvlOffsets[0]+"</span>";
                //}
				//lbl.appendChild(lvloffset0);
                //var lvloffset1 = document.createElement("span");
                //if ($lvlOffsets[1]!=undefined) {
                   // lvloffset1.innerHTML = "<span class='rev-lvl0ffset1'>"+$lvlOffsets[1]+"</span>";
                //}
				//lbl.appendChild(lvloffset1);

                var pathways = document.createElement("div");
                pathways.setAttribute("id", "pathways_"+$nObj.temp_nid);
                pathways.classList="revelatian-pathways";
                el_revcirc.appendChild(pathways);

        // var match = {tnid:$matchPt.tnid, myl:1, paths:paths};
        // paths (arraymap) = {pathid:path, hits:1}
        return {el:el_acf, el_pathways:pathways};
    }


    /**
     * @param {*} $nObj 
     * @param {*} $bEMULATE 
     */
    neuronRevelatianDisplay = async($nObj)=> {
        var beNOBJ = $nObj.getParent();
        if (beNOBJ==null) {
            console.log("nid:"+$nObj.nid+" text:"+$nObj.tex+" needs a parent");    
            return;
        }
        var el_acf = document.createElement("div");
        el_acf.classList = "rev-circ-full";
            
        var el_donut = document.createElement("div");
        el_donut.classList = "donutNONE";
        el_acf.appendChild(el_donut);
       
        var p1 = document.createElement("p");
        p1.classList="n-circ-annex";
        el_acf.appendChild(p1);
        var sp = document.createElement("span");
        sp.classList = "REV-ico";
        p1.appendChild(sp)
        var sp2 = document.createElement("span");
        sp2.style="color:color-green font-size:20px; font-weight:900";
        sp2.innerHTML="";
        p1.appendChild(sp2)
        var p2 = document.createElement("p");
        p2.classList = "n-circ-imgfix";
        el_acf.appendChild(p2);

        await ANNE.IMAGES.loadElIntoBG($nObj, p2);

        var acn = document.createElement("div");
        acn.classList="rev-circ-name";
        el_acf.appendChild(acn);
        var acn2 = document.createElement("div");
        acn2.classList = "rev";
        var name = $nObj.bestNameHTML();
        if (name.length>25) name = name.substring(0, 25);
        acn2.innerHTML = name;
        acn.appendChild(acn2);

        var lbl = document.createElement("div");
        lbl.classList="revelatian-sublbl";
       
        lbl.innerHTML = "<span>parent&nbsp;<b>"+beNOBJ.bestNameHTML().substring(0, 25)+"</b></span>";
        acn.appendChild(lbl);
        return el_acf;
    }


    /**
     * make and populate an html element to display goodies for an annexable neuron
     * this is short-hand used for the user to click to get to a more in-depth view.
     * @param {*} $nObj 
     * @param {*} $bEMULATE 
     */
    neuronAplexDisplay = async($nObj, $bEMULATE=false, $prefName="", $colorClass="green", $icopost="2")=> {
        var apx = $nObj._aplex;
        if (apx==null) {
            if ($bEMULATE==true) {
                apx = new aplex($nObj, $nObj.nid, null);    //3rd param applex obj
                apx.emulateAplex();
            }
            else {
                apx = await ANNE.CHASE.get_aplex_data($nObj.nid, false, "neuronAplexDisplay");
            }
        }

        var el_acf = document.createElement("div");
        el_acf.classList = "awarez-circ-full";
            
        var el_donut = document.createElement("div");
        el_donut.classList = "donut";
        el_acf.appendChild(el_donut);
        if (apx.posPer==null) apx.initPercents();
        var l1 = Math.round(apx.posPer*360);
        var l2 = Math.round(apx.negPer*360);
        var varstring = "--l1:0deg "+l1+"deg; --l2:"+l1+"deg "+(l1+l2)+"deg; --l3:"+(l1+l2)+"deg 360deg;";
        el_donut.style=varstring;

        var p1 = document.createElement("p");
        p1.classList="n-circ-annex";
        el_acf.appendChild(p1);
        var sp = document.createElement("span");
        sp.classList = "annex-"+$colorClass+"-ico"+$icopost;
        p1.appendChild(sp)
        var sp2 = document.createElement("span");
        sp2.style="color:color-"+$colorClass+" font-size:20px; font-weight:900";
        sp2.innerHTML=apx.price_lvl;
        p1.appendChild(sp2)
        var p2 = document.createElement("p");
        p2.classList = "n-circ-imgfix";
        el_acf.appendChild(p2);

        await ANNE.IMAGES.loadElIntoBG($nObj, p2);

        var acn = document.createElement("div");
        acn.classList="awarez-circ-name";
        el_acf.appendChild(acn);
        var acn2 = document.createElement("div");
        acn2.classList = "acn";
        if ($prefName!="") {
            acn2.innerHTML = $prefName;
        }
        else acn2.innerHTML = $nObj.text;
        acn.appendChild(acn2);

        if ($nObj.sponsored_by!="") {
            var spNOBJ = MEMG.getOrMakeIfNew($nObj.sponsored_by);
            var acs = document.createElement("div");
            acs.classList = "acs";
            acs.innerHTML = spNOBJ.bestName();
            acn.appendChild(acs);
        }

        return el_acf;
    }



    /**
     * 
     * @param {*} $el 
     * @returns 
     */
    removeParent = function ($el) {
        var el = this.__getEl($el);
        if (el == null || el.parentNode == null) return null;
        var parent = el.parentNode;
        return this.removeSelf(parent);
    }

    /**
     * 
     * @param {*} $el 
     * @returns 
     */
    removeParentParent = function ($el) {
        var el = this.__getEl($el);
        if (el == null || el.parentNode == null) return null;
        var parent = el.parentNode;
        var parentParent = parent.parentNode;
        if (parentParent == null) return this.removeSelf(parent);
        return this.removeSelf(parentParent);
    }

    /**
     * 
     * @param {*} $el 
     * @param {*} $classname 
     * @returns 
     */
    removeClass = function ($el, $classname) {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.classList.remove($classname);
        return el;
    }

    /**
     * 
     * @param {*} $el 
     * @param {*} $childClass 
     * @returns 
     */
    removeByParentAndClass = function ($el, $childClass) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var els = el.querySelectorAll("." + $childClass);
        for (var e = 0; e < els.length; e++) {
            var elchild = els[e];
            el.removeChild(elchild);
        }
    }

    /**
     * remove the $removeClass from all element children inside of $el
     * that match the selector.  Adds it back to the targetEl.   
     * This is used to turn an active off, then on for the selected item.
     */
    removeAddClassOfAllIn = function ($el, $selector, $removeClass, $targetEl) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($selector[0] != "#" && $selector[0] != ".") $selector = "." + $selector; //presume class.
        el.querySelectorAll($selector).forEach(target => {
            target.classList.remove($removeClass);
        });
        var targetEl = typeof $targetEl === "string" ? el.getElementById($targetEl) : targetEl = $targetEl;
        if (targetEl == null) return;
        if (targetEl != null) targetEl.classList.add($removeClass);
    }

    setRadioVals = function ($pre, $numMax, $checkedVal) {
        for (var c = 0; c < $numMax; c++) {
            var el = this.__getEl($pre + "_" + c);
            if (el == null) return null;
            if ($checkedVal == c) el.checked = true;
            else el.checked = false;
        }
        return;
    }


    setBodyBackground = function ($url) {
        var newImgEl = document.createElement('img');
        newImgEl.addEventListener('load', function () {
            document.body.style['background-image'] = "url('" + $url + "')";
            ANNE.A.removeSelf(newImgEl);

        });
        newImgEl.setAttribute('src', $url); // Loads the image.
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $ease 
     * @returns 
     */
    gs_alphaOut=function($el, $duration=1, $ease="power1.out"){
        if (ANNE.gsap==null) ANNE.A.hide($el);
        var el = this.__getEl($el);
        if (el == null) return null;
        var restore = el.style.display;
        if (el.getAttribute("display_restore")==undefined && restore!="" && restore!="none") {
            el.setAttribute("display_restore", restore);
        }

        if (ANNE.gsap==undefined || ANNE.gsap==null) {
            ANNE.A.hide(el);
            el.style.alpha=0;
            return;
        }
        
        ANNE.gsap.to(el, {
            ease:$ease,
            duration: $duration,
            alpha: 0,
            onUpdate: function() {
            },
            onComplete: async()=> {
                if (el.classList.contains("hide")==false) el.classList.add("hide");
                el.style.display = "none";
            }
        } );
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $duration 
     * @param {*} $ease 
     * @returns 
     */
    gs_alphaScaleOut=function($el, $duration=1, $scale=0.1, $ease="power1.out"){
        if (ANNE.gsap==null) ANNE.A.hide($el);
        var el = this.__getEl($el);
        if (el == null) return null;
        var restore = el.style.display;
        if (el.getAttribute("display_restore")==undefined && restore!="" && restore!="none") {
            el.setAttribute("display_restore", restore);
        }
        ANNE.gsap.to(el, {
            ease:$ease,
            duration: $duration,
            transform:'scale('+$scale+')',
            alpha: 0,
            onUpdate: function() {
            },
            onComplete: async()=> {
                el.classList.add("hide");
                el.style.display = "none";
            }
        } );
    }
    

    /**
     * 
     * @param {*} $el 
     * @param {*} $ease 
     * @param {*} $displayProp 
     * @returns 
     */
    gs_alphaIn=function($el, $duration=1, $ease="power1.in", $displayProp="", ){
        if (ANNE.gsap==null) ANNE.A.show($el);
        var el = this.__getEl($el);
        if (el == null) return null;
        el.alpha=0;
        el.classList.remove("hide");

        if (ANNE.gsap==undefined || ANNE.gsap==null) {
            ANNE.A.show(el);
            el.style.alpha=1;
            return;
        }
        
        ANNE.gsap.to(el, {
            ease:$ease,
            duration:$duration,
            alpha: 1,
            onUpdate: function() {
            },
            onComplete: async()=> {
                if ($displayProp!="") {
                    el.style.display=$displayProp;
                }
                else {
                    var restore = el.getAttribute("display_restore");
                    if (restore!=undefined) el.style.display=restore;
                    else el.style.display="";
                    el.classList.remove("hide"); //incase another animation
                }
            }
        } );
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $duration 
     * @param {*} $ease 
     * @param {*} $displayProp 
     * @returns 
     */
    gs_alphaScaleIn=function($el, $duration=1, $ease="power1.in", $scale=1, $displayProp="", ){
        if (ANNE.gsap==null) ANNE.A.show($el);
        var el = this.__getEl($el);
        if (el == null) return null;
        el.alpha=0;
        el.classList.remove("hide");
        
        ANNE.gsap.to(el, {
            ease:$ease,
            duration:$duration,
            transform:'scale('+$scale+')',
            alpha: 1,
            onUpdate: function() {
            },
            onComplete: async()=> {
                if ($displayProp!="") {
                    el.style.display=$displayProp;
                }
                else {
                    var restore = el.getAttribute("display_restore");
                    if (restore!=undefined) el.style.display=restore;
                    else el.style.display="";
                }
            }
        } );
    }


	showing = function($el) {
		var el = this.__getEl($el);
        if (el == null) return null;
        if (el.classList.contains("show") == true) return true;
		if (el.classList.contains("hide") == true) return false; 
		if (el.style.display == "none") return false;
		return true;
	}
	
    /**
     * 
     * @param {*} $el 
     * @param {*} $displayProp 
     * @returns 
     */
    show = function ($el, $displayProp = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        if (el.classList.contains("show") == false) el.classList.add("show");
        if (el.classList.contains("hide") == true) el.classList.remove("hide");
        if (el.classList.contains("faded-neuron") == true) el.classList.remove("faded-neuron");

		if (el.getAttribute("showlink_id")!=undefined) {
			var showlink = document.getElementById(el.getAttribute("showlink_id"));
			if (showlink!=null) {
				showlink.innerHTML = "hide";
			}
		}
		
        if ($displayProp == "") {
            var restore = el.getAttribute("display_restore");
            if (restore!=null && restore.length>0) {
				el.style.display = restore;
			}
            else if (el.style.display == "none") {
				el.style.display = "";
			}
        }
        else el.style.display = $displayProp;
        return el;
    }


    showParent = function ($el, $bSHOWSELFTOO = true) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var parent_el = el.parentNode;
        this.show(parent_el);
        if ($bSHOWSELFTOO == true) this.show(el);
        return el;
    }

    showMulti = function ($arrDivids, $displayProp = "") {
        var els = document.querySelectorAll($arrDivids);
        for (var e = 0; e < els.length; e++) {
            var el = els[e];
            if (el == null) continue;
            el.classList.add("show");
            el.classList.remove("hide");
            el.style.display = $displayProp;
            el.style.opacity = 1; //correct in case a fadeOut was used prior
        }
        return el;//return the last el
    }

    setAttribute = function ($el, $attribute, $value, $bSHOW = false, $addclass = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.setAttribute($attribute, $value);
        if ($bSHOW == true) this.show(el);
        if ($addclass != "") el.classList.add($addclass);
        return el;
    }

    setDeactiveWLbl = function ($el, $prepend = false) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($prepend == true) var dl = ANNE.A.ezElPrepend(el, "span", "dib deactivate-lbl", "");
        else var dl = ANNE.A.ezEl(el, "span", "dib deactivate-lbl", "");
        ANNE.A.ezEl(dl, "span", "dm", "");
        return dl;
    }

    setHTML = function ($el, $html, $bSHOW = false, $addclass = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.innerHTML = $html;
        if ($bSHOW == true) this.show(el);
        if ($addclass != "") el.classList.add($addclass);
        return el;
    }

    setJSON = function ($el, $json, $bSHOW = true, $addclass = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($json == undefined || $json == null) return;
        var str = this.jsonSyntaxHighlight($json);
        el.innerHTML = str;
        if ($bSHOW == true) this.show(el);
        if ($addclass != "") el.classList.add($addclass);
        return el;
    }


    /**
     * Set key up date event.
     * All dates get handled by our doDateFormat handler
     */
    setKeyUpDate = function ($el, $callback = null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($callback != null) {
            el.addEventListener('keyup', function (e) {
                MEM.doDateFormat(e);
                $callback(e);
            });
        }
        else el.addEventListener('keyup', MEM.doDateFormat);
    }

    setKeyUpTime = function ($el, $callback = null) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if ($callback != null) {
            el.addEventListener('keyup', function (e) {
                MEM.doTimeFormat(e);
                $callback(e);
            });
        }
        else el.addEventListener('keyup', MEM.doTimeFormat);
    }


    setStyle = function ($el, $jsoncss, $bSHOW = false, $addclass = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var keys = Object.keys($jsoncss);
        for (var k = 0; k < keys.length; k++) {
            var prop = keys[k];
            var val = $jsoncss[prop];
            el.style[prop] = val;
        }
        if ($bSHOW == true) this.show(el);
        if ($addclass != "") el.classList.add($addclass);
        return el;
    }

    setStyleVar = function ($el, $prop, $val) {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.style.setProperty($prop, $val);
    }


    setValue = function ($el, $value, $bSHOW = false, $addclass = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.value = $value;
        if ($bSHOW == true) this.show(el);
        if ($addclass != "") el.classList.add($addclass);
        return el;
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $localRef 
     */
    soundFileLink = function($el, $localRef, $bDOWAVEFORM=true) {
        var el = this.__getEl($el);
        if (el == null) return null;
    
        
        var el_btn = document.createElement("span");
        el_btn.innerHTML = "▶️";
		el_btn.style.cursor = "pointer";
		el_btn.classList = "hoverable";
        el.appendChild(el_btn);

        
        var audio_tag = document.createElement("audio");
        audio_tag.src = $localRef;
        el.append(audio_tag);

        el_btn.addEventListener('click', function() {
            audio_tag.play();
        });


        if ($bDOWAVEFORM==false) return audio_tag;
		
        var el_wf_canvas = document.createElement("canvas");
		el_wf_canvas.style["height"]="90px";
		el_wf_canvas.style["min-width"]="100px";
		
        el.append(el_wf_canvas);
        this.drawWaveform(audio_tag, el_wf_canvas);

        return audio_tag;
    }


    /**
     * 
     * @param {*} $audio_tag 
     * @param {*} $cavasForWaveform 
     */
    drawWaveform=function($audio_tag, $cavasForWaveform) {
        const audioElement = this.__getEl($audio_tag);
        if (audioElement==null) return;

        const canvas = this.__getEl($cavasForWaveform);
        if (canvas==null) return;

        const audioContext = new (window.AudioContext || window.webkitAudioContext)();
        const audioSrc = audioContext.createMediaElementSource(audioElement);
        const analyser = audioContext.createAnalyser();

        audioSrc.connect(analyser);
        analyser.connect(audioContext.destination);

        const bufferLength = analyser.frequencyBinCount;
        const dataArray = new Uint8Array(bufferLength);

        const canvasCtx = canvas.getContext('2d');

        function draw() {
        const WIDTH = canvas.width;
        const HEIGHT = canvas.height;

        analyser.getByteTimeDomainData(dataArray);

        canvasCtx.fillStyle = 'rgb(200, 200, 200)';
        canvasCtx.fillRect(0, 0, WIDTH, HEIGHT);

        canvasCtx.lineWidth = 2;
        canvasCtx.strokeStyle = 'rgb(0, 0, 0)';

        canvasCtx.beginPath();

        const sliceWidth = (WIDTH * 1.0) / bufferLength;
        let x = 0;

        for (let i = 0; i < bufferLength; i++) {
            const v = dataArray[i] / 128.0;
            const y = (v * HEIGHT) / 2;

            if (i === 0) {
            canvasCtx.moveTo(x, y);
            } else {
            canvasCtx.lineTo(x, y);
            }

            x += sliceWidth;
        }

        canvasCtx.lineTo(canvas.width, canvas.height / 2);
        canvasCtx.stroke();

        requestAnimationFrame(draw);
        }

        draw();
    }


    copyIco = function ($el, $val) {
        var el = this.__getEl($el);
        if (el) {
            ANNE.A.empty(el);
            this.addCopyIco(el, $val);
        }
    }



    addCopyIco=function($el, $data){
        if (ANNE.UTILS==null) return;
        var spanpre=document.createElement("span");
        spanpre.innerHTML="&#x2398";
        spanpre.classList="btn-copy";
        spanpre.title = "copy to clipboard";
        spanpre.setAttribute("data-copy", $data);
        spanpre.addEventListener("click", e=>ANNE.UTILS.copyToClipboard($data));
        var el = ANNE.A.__getEl($el)
        if (el==null) return;
        el.append(spanpre);
    }


    setMaxHeights = function ($el, $maxheight = 0, $height = 0) {
        var el = this.__getEl($el);
        if (el == null) return;
        if ($maxheight > 0) el.style["max-height"] = $maxheight + "px";
        if ($height > 0) el.style["height"] = $height + "px";
    }


    /**
     * The el here is the INNER CONTENT you want to scroll with a div frame of reference.
     * The div is marked with .smart-scroll-framer.. if it is already overflowing
     * it changes the scroll height of the inner DIV we actually want to scroll.
     */
    smartScroll = function ($el, $pad=10) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var bcr = el.getBoundingClientRect();
        var biggestBottom = bcr.bottom;//bcr.y+bcr.height;
        var windowH = window.innerHeight;

        //this is the frame of what we want to keep on screen in full view.
        //document.querySelector(".smart-scroll-framer");

        //we use the first in the parent line that we find.
        var el_ssf = ANNE.A.getFirstParentOf(el, "smart-scroll-framer", true);
        if (el_ssf) {
            var ssf = el_ssf.getBoundingClientRect();

            var height = ssf.bottom - bcr.top - $pad;

            var pad = el_ssf.style.padding;

            if (bcr.height > height) {
                ANNE.A.setStyle(el,
                    {
                        'max-height': (height) + 'px',
                        'height': (height) + 'px',
                        'overflow-y': 'auto',
                    },
                    true, "smart-scroll-y");
            }
            else {
                ANNE.A.setStyle(el,
                    {
                        'max-height': (height) + 'px',
                        'height': (height) + 'px',
                        'overflow-y': 'none',
                    },
                    true, "smart-scroll-y");
            }
            return;
            
        }

        //we have no defined frame...
        if (biggestBottom > windowH) {
            var diff = (biggestBottom - windowH);
            ANNE.A.setStyle($el,
                {
                    'max-height': ((bcr.height - diff) - 2) + 'px',
                    'overflow-y': 'auto',
                },
                true, "smart-scroll-y")
        }
        else {
            el.classList.remove("smart-scroll-y");
        }
    }


    //updates any class, ie, 'bal-[temp_nid]' tags in the DOM
    quickBalanceUpdate = function ($class, $html) {
        var bals = document.querySelectorAll(".bal-" + USER._userNObj.temp_nid);
        for (var b = 0; b < bals.length; b++) {
            bals[b].innerHTML = $html;
        }
    }

    //return the span
    span = function ($html, $class = "") {
        var span = document.createElement("span");
        if ($class != "") span.classList = $class;
        span.innerHTML = $html;
        return span;
    }

    /* strip all occurances of a class out from an el or its decendants */
    stripClass = function ($el, $class, $addClass = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var children = $el.querySelectorAll("." + $class);
        if (children == null || children.length == 0) return;
        for (var c = 0; c < children.length; c++) {
            children[c].classList.remove($class);
            if ($addClass != "") children[c].classList.add($addClass);
        }
    }

    toggleWithFade = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if (el.classList.contains("show")) {
            this.fadeOut($el);
            return "hide";
        }
        else {
            this.fadeIn($el);
            return "show";
        }
    }

    toggle = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if (el.classList.contains("show")) {
            this.hide($el);
            return "hide";
        }
        else {
            this.show($el);
            return "show";
        }
    }


    toggleClass = function ($el, $class) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if (el.classList.contains($class) == true) el.classList.remove($class);
        else el.classList.add($class);
    }

    /**
     * if class1 is turned on (after the fucntion) it is -1
     * if class2 is turned on (after the function) it is 1
     */
    toggleClass2 = function ($el, $class1, $class2) {
        var el = typeof $el === "string" ? document.getElementById($el) : el = $el;
        if (el == null) return null;
        if (el.classList.contains($class1) == true) {
            el.classList.remove($class1);
            el.classList.add($class2);
            return 1;
        }
        else if (el.classList.contains($class2) == true) {
            el.classList.remove($class2);
            el.classList.add($class1);
            return -1;
        }
        return 0;
    }

    triggerHover = function ($el) {
        var el = this.__getEl($el);
        if (el == null) return null;
        var event = new MouseEvent('mouseover', {
            'view': window,
            'bubbles': true,
            'cancelable': true
        });
        el.dispatchEvent(event);
    }


    setMaxH = function ($el, $maxH) {
        var el = this.__getEl($el);
        if (el == null) return null;
        el.style['max-height'] = parseInt($maxH) + "px";
        el.style['height'] = parseInt($maxH) + "px"
    }

    toggleByClass = function ($el, $topSelector, $targetClassSelector, $displayProp = "") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var parent = el.closest("." + $topSelector);
        if (parent != null) {
            var toggleTarget = parent.querySelector("." + $targetClassSelector);
            if (toggleTarget != null) {
                if (toggleTarget.classList.contains("show")) this.hide(toggleTarget);
                else this.show(toggleTarget, $displayProp);
            }
        }
    }


    /**
     * Forgot about this one.. should try it again (lol)
     * 
     * @param {*} $el 
     * @param {*} $msg 
     * @param {*} $hovertext 
     * @param {*} $attr 
     * @param {*} $classList 
     * @returns 
     */
    tooltip = function ($el, $msg, $hovertext = "hover over me", $attr = "data-text", $classList = "tooltip") {
        var el = this.__getEl($el);
        if (el == null) return null;
        var span = document.createElement("span");
        span.classList = $classList;
        span.setAttribute($attr, $msg);
        span.innerHTML = "&nbsp;&#9432;"+$hovertext;
        el.append(span);
        return span;
    }

    /**
     * 
     * @param {*} $el 
     * @param {*} $event 
     * @param {*} $bHIDE 
     * @returns 
     */
    trigger = function ($el, $event, $bHIDE = false) {
        var el = this.__getEl($el);
        if (el == null) return null;
        if (el[$event] != undefined && typeof el[$event] === 'function') {
            el[$event]();
        }
        else {
            console.log("(anne_DOM.trigger) cannot trigger event " + $event + " on element " + el.id);
            return;
        }
        if ($bHIDE == true) this.hide(el);
    }

    /**
     * 
     * @param {*} $input_el 
     * @param {*} $showbtn 
     * @param {*} $rNObj 
     * @param {*} $voNOBJ 
     * @param {*} $txt 
     * @param {*} $validc 
     * @param {*} $invalidc 
     * @returns 
     */
    validator = function ($input_el, $showbtn, $rNObj = null, $voNOBJ = null, $txt = "", $validc = "valid", $invalidc = "invalid") {
        if ($txt.length) {
            if ($rNObj != null && $rNObj.format_validator != null) {
                var valid_check_rez = $rNObj.format_validator($txt);
                if (valid_check_rez != true) {
                    ANNE.A.hide($showbtn);
                    $input_el.classList.remove($validc);
                    $input_el.classList.add($invalidc);
                    return false;
                }
                else {
                    ANNE.A.show($showbtn);
                    $input_el.classList.remove($invalidc);
                    $input_el.classList.add($validc);
                    return true;
                }
            }
            else if ($voNOBJ != null && $voNOBJ.format_validator != null) {
                var valid_check_rez = $voNOBJ.format_validator($txt);
                if (valid_check_rez != true) {
                    ANNE.A.hide($showbtn);
                    $input_el.classList.remove($validc);
                    $input_el.classList.add($invalidc);
                    return false;
                }
                else {
                    ANNE.A.show($showbtn);
                    $input_el.classList.remove($invalidc);
                    $input_el.classList.add($validc);
                    return true;
                }
            }
            else {
                ANNE.A.show($showbtn);
                $input_el.classList.remove($invalidc);
                $input_el.classList.add($validc);
                return true;
            }
        }
        else {
            ANNE.A.hide($showbtn);
            $input_el.classList.remove($validc);
            $input_el.classList.add($invalidc);
            return false;
        }

        return false;
    }


    /**
     * YES, this is dangerous, if we were loading external scripts.  We aren't.
     * We are loading scripts in our own pages.
     * 
     * @param {*} $loadIntoEl 
     * @param {*} $pgui 
     * @param {*} $url 
     * @param {*} $loadClass 
     * @returns 
    */
    load = async ($loadIntoEl, $pgui, $url, $loadClass = "load-wrapper") => {
        var loadIntoEl = typeof $loadIntoEl === "string" ? document.getElementById($loadIntoEl) : loadIntoEl = $loadIntoEl;
        this.show(loadIntoEl);
        if (loadIntoEl == null) return;
        var xhr;
        if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
        else xhr = new ActiveXObject("Microsoft.XMLHTTP");

        var tempEl = document.createElement("div");
        if ($loadClass != "") tempEl.classList = $loadClass;

        return new Promise((resolve, reject) => {
            xhr.onreadystatechange = function () {
                if (this.readyState == 4 && this.status == 200) {
                    var resp = this.response;
                    var newEl = document.createElement("div");
                    if ($loadClass != "") newEl.classList = $loadClass;
                    else newEl.classList = "pichachu";
                    newEl.innerHTML = resp;
                    loadIntoEl.append(newEl);
                    var scripts = newEl.getElementsByTagName('script');
                    for (var s = 0; s < scripts.length; s++) {
                        var newscript = document.createElement("script");
                        newscript.type = 'text/javascript';
                        newscript.innerHTML = scripts[s].innerHTML;
                        if (scripts[s].parentNode == newEl) {
                            newEl.removeChild(scripts[s]);
                        }
                        newEl.append(newscript);
                        //eval(newscript);
                    }

                    //if this has a guid, clone it.  This is crucial to not
                    //getting DOM ID conflicts when using templates and injecting 
                    //them multiple times.
                    if ($pgui.guid && ($pgui.page.multiples == true || $pgui.page.instantiate == true)) {
                        var items = newEl.querySelectorAll('.dynamic');

                        //any divs marked as class=dynamic get their ID altered.
                        //this will allow us to have multiple copies of these templates in
                        //the dom and stil be able to uniquely reference their elements by id.
                        var mod_els = [];
                        var temp_list = [];

                        for (var i = 0; i < items.length; i++) {
                            var item = items[i];
                            if (item.id != null && item.id != "") {
                                temp_list[item.id.substring(0)] = item;
                                item.id = item.id + "_" + $pgui.guid;
                            }
                            var forattr = item.getAttribute("for");
                            if (forattr != null) item.setAttribute("for", forattr + "_" + $pgui.guid);
                            var nameattr = item.getAttribute("name");
                            if (nameattr != null) item.setAttribute("name", nameattr + "_" + $pgui.guid);
                            var mod_el_attr = item.getAttribute("mod-el");
                            if (mod_el_attr != null) {
                                item.setAttribute("mod-el", mod_el_attr + "_" + $pgui.guid);
                                mod_els.push({ el: item, mod_el_attr: mod_el_attr });
                            }
                        }

                        //create .modxx and tie it to the element that was tagged with mod-el
                        //and the id of the target.
                        for (var m = 0; m < mod_els.length; m++) {
                            var me = mod_els[m];
                            var srcel = temp_list[me.mod_el_attr];
                            if (srcel == undefined) continue;
                            srcel.modxx = me.el;
                        }

                        if ($pgui.pObj && $pgui.pObj.noshow != undefined);
                        else ANNE.A.show(loadIntoEl);
                        return resolve(newEl);
                    }

                    else {
                        if ($pgui.pObj && $pgui.pObj.noshow != undefined);
                        else ANNE.A.show(loadIntoEl);
                        return resolve(newEl);
                    }
                }
            };

            xhr.open("GET", $url + "?v=" + Math.random() * 10, true);
            xhr.responseType = "";
            xhr.send();
        });
    }
}

var A = new anne_dom();
A.set_init(A);