
class anne_babytalk {
    constructor($output, $order, $part_of_anne, $tense_lbl="") {
        this.output = $output;
        this.order = $order;
        this.poa = $part_of_anne;
        this.tense_lbl = $tense_lbl;
    }
}

class v1actionx {
    constructor($nid){
        this.nid=$nid;
        this.v2 = null;
        this.v3 = null;
        this.v4 = null;
        this.v5 = null;
        
         //inherited TYPE_ROLE assigned to any action vb parent in the BE line.
        //this is the "meaning" of the action, in full, with def of all BEM line roles
        this._meaning_roles = null;

        //roles this action assigns.
        //This will be stored on both inst and class action neurons.
        //It is inherited from the BEM line.
        this._param_roles = null;
    }
}

class clump_lookup {
    constructor() {
        this.nObj = null;
        this.parent = null;
        this._non_action_roles = [];
        this._rolesMap = new Object();
        this._ROLES_BY_NAME = [];
    }

    addRole=function($roleNid, $roleValueNid) {
        var ROLE_NOBJ = ANNE.MEMG.getNeuronByNid($roleNid);

        //the clump will instantiate this neuron.
        if (ROLE_NOBJ.nid==ANNE.MEM.role_action.nid) {
            this.parent = ANNE.MEMG.getNeuronByNid($roleValueNid);
        }

        //do not put action in here.
        else this._non_action_roles.push({role:$roleNid, role_value:$roleValueNid}) 
        
        if (this._rolesMap[$roleNid]==undefined) {
            this._rolesMap[$roleNid]=new arraymap();
            this._rolesMap[$roleNid].setMapKey("nid");
            this._ROLES_BY_NAME[ROLE_NOBJ.text.toUpperCase()] = [];
        }
        var roleValNOBJ = MEMG.getNeuronByNid($roleValueNid);
        this._rolesMap[$roleNid].addU(roleValNOBJ);
        this._ROLES_BY_NAME[ROLE_NOBJ.text.toUpperCase()].push(roleValNOBJ);
    }

    testNeuronForRoles = function($clumpNOBJ, $roles) {
        if ($clumpNOBJ==null) {
            console.warn("fix this, no null clump here");
            return false;
        }
        
        if ($roles==undefined || $roles==null) {
            console.warn("fix this, no null/undefined roles here");
            return false;
        }
        
        for (var r=0; r < $roles.length; r++) {
            var role = $roles[r];
            var roleNOBJ = ANNE.MEMG.getNeuronByNid(role.role);
            var valueNOBJ = ANNE.MEMG.getNeuronByNid(role.role_value);
            console.log("testing '"+$clumpNOBJ.text+"' for role ["+roleNOBJ.text.toLowerCase()+"] value "+valueNOBJ.text);
            var bGOOD = ANNE.MEMG.hasRoleRelon($clumpNOBJ.outs, role.role, role.role_value);
            if (bGOOD==false) {
                console.log("DO NOT HAVE THIS ROLE to value:"+valueNOBJ.nid+" ::: not a match");
                return false;
            }
        }
        return true;
    }


    //with a proper action, fidn the clump.
    findClump=async($bMAKE=true)=> {
        if (this.parent==null) {
            return await this.findClumpPartial();
        }

        //quick local test (we may have a ghost and we don't want dupes since
        //it won't be yet found on the node)
        await ANNE.IDB.queryForIns(null, this.parent.nid);
        
        var matches = [];
        var candidates = [];
        var pull_froms = [];
        
        for (var r=0; r < this.parent.ins.length; r++) {

            //action role OR parent of clump. is what we are looking for here.
            if (this.parent.ins[r].type!=TYPE_ROLE && this.parent.ins[r].type!=TYPE_BE) continue;  
            
            var clumpNOBJ = ANNE.MEMG.getNeuronByNid(this.parent.ins[r].from_nid);
            
            console.log("candidate match: "+clumpNOBJ.text);
            if (pull_froms.indexOf(clumpNOBJ.nid)==-1) {
                pull_froms.push(clumpNOBJ.nid);
                candidates.push(clumpNOBJ);
            }
        }

        //get all the roles so we can try to match the already-in-our-local-mem clump.
        if (pull_froms.length) {
            await ANNE.IDB.lookupNids(null, pull_froms);
        }

        for (var c=0; c < candidates.length; c++) {           
            if (this.testNeuronForRoles(candidates[c], this._non_action_roles)==true) {
                matches.push(candidates[c]);
            }
            else {
                console.log("NOT A MATCH");
            }
        }

        //no luck in mem, look it up in the ANNODE.
        if (matches.length==0) { //TEST THE API.
            var results = await ANNE.API.findClump(this.parent.nid, this._non_action_roles);   
        }
        else {
            var results = matches;
        }

        //handle results from annode (or local mem)
        if (results.length==1) {
            this.nObj = results[0];
            console.log(this.nObj.text);
            return {status:"good", match:[this.nObj]};
        }
        else if (results.length>1) {
            console.log("ambiguous results");
            this.nObj=null;
            return {status:"ambiguous", matches:results}
        }
        else if ($bMAKE==true) {
            this.setName();
            var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(this.parent, this.name, NTYPE_INST);
            for (var r=0; r < this._non_action_roles.length; r++) {
                var role = this._non_action_roles[r];
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, ghostNOBJ, role.role, TO_TYPE_ANNE, role.role_value);
            }
            return {status:"good", match:ghostNOBJ};
        }

        return {status:"new", match:[]};
    }

    setName = function() {
        var parts = [];
        if (this._rolesMap[ANNE.MEM.role_actor.nid]!=undefined) {
            var subj = this._rolesMap[ANNE.MEM.role_actor.nid].arr[0];
            parts.push(subj.text);
        }
        parts.push(this.parent.text);

        //one of these is fine.
        if (this._rolesMap[ANNE.MEM.role_theme_thing.nid]!=undefined){
            var theme = this._rolesMap[ANNE.MEM.role_theme_thing.nid].arr[0];
            parts.push(theme.text);
        }
        else if (this._rolesMap[ANNE.MEM.role_posn_thing.nid]!=undefined) {
            var posn_thing = this._rolesMap[ANNE.MEM.role_posn_thing.nid].arr[0];
            parts.push(posn_thing.text);
        }
        else if (this._rolesMap[ANNE.MEM.role_be_thing.nid]!=undefined) {
            var role_be_thing = this._rolesMap[ANNE.MEM.role_be_thing.nid].arr[0];
            parts.push(role_be_thing.text);
        }

        if (this._rolesMap[ANNE.MEM.role_when.nid]!=undefined){
            var when = this._rolesMap[ANNE.MEM.role_when.nid].arr[0];
            parts.push(when.text);
        }
        if (this._rolesMap[ANNE.MEM.role_where.nid]!=undefined) {
            var where = this._rolesMap[ANNE.MEM.role_where.nid].arr[0];
            parts.push(where.text);
        }

        this.name = parts.join(" ");
        console.log(this.name);
    }


    findClumpPartial=async()=>{
        return;
    }
}




/**
    Deault garden - no delegation, no LET, no DENY.
    Defaults to restricting collab requests to PARAMs in the parent class.

    Communal garden - Honors owner set delegation to allow collab approvals.  
    Defaults to BLACKLIST mode for denys (ignores lets, all are let).
    Anyone can make collab relon requests.
    Delegated admins can auto make approved requests equal to their delegation rights
    or approved pending collab req equal or less than their granted rights.
    gui - Neurons owned by the owner or adopted will be displayed

    Owner collab - Honors owner set delegation to allow collab approvals.
    Defaults to WHITELIST mode for lets.  (ignores denies, all are default denied)
    Only those listed in lets can make collab relons.
    Delegated admins can auto make approved requests equal to their delegation rights
    or approved pending collab req equal or less than their granted rights.
    gui - Neurons owned by the owner or adopted will be displayed

    Owner Only - No delegation, no lets, no denys, no one can make collab relons,
    gui - Neurons owned by the owner will be displayed
*/
class anne_neuron {

    /**
     * @param {string} - default name of neuron
     * @param {int} - ntype int of neuron type
     * @param {string} - Long string of nid.
     */
    constructor ($text, $ntype=NTYPE_UNKNOWN, $nid="") {
        this.text = $text;
        this.short = null;      //the shortest be alt name, aka, abbreviation or text.

        this.ntype = $ntype;
        if (this.ntype==="") this.ntype=NTYPE_UNKNOWN;
        this.nid = $nid;
        this.be = ""; 
        this.be_lvl = -1;
        this.bNEW=false;
        this.dead = false;

        this.owned_by = "";
        this.sponsored_by = "";
        this.parent = "";  //same as bes[0]
        this.annother = null;
        this.polarity = null;
        this.origin = null; //important to know for key'd vs not key'd.

        //allocated arrays
        this.bes = [];
        this.outs = [];
        this.outs_r = new Object();
        this.ins = [];
        this.ins_r = new Object();
        this.children = [];
        
        //assigned TYPE_ROLE relons for any ation vb instance neuron.
        //this is a unique semantic sentence/thought
        //All sentences/statements/thoughts/clumps are store by instantiating the 
        //action vb which they are using.
        //If there are dual action vbs.  (he punched and kicked the man) we can either
        //create a new compound action neuron "punched and kicked"
        //OR we can create two clumps "he punched the man" -> AND -> "he kicked the man".
        //Both semantically work.

        //for classes this is the specific meaning from THIS neuron (not inherited meanings)
        this._roles = null;

        //inherited TYPE_ROLE assigned to any action vb parent in the BE line.
        //this is the "meaning" of the action, in full, with def of all BEM line roles
        this._meaning_roles = null;

        //roles this action assigns.
        //This will be stored on both inst and class action neurons.
        //It is inherited from the BEM line.
        this._param_roles = null;

        this.be_time = -1; //the time of the be relon (used to sort new neurons)

        //entire feelz summary w/ APLEX status
        this._napl = null;

        //this is a TYPE_SYS relon 
        //we inherit gt from classes down to subclasses.
        //it is only relevant to classes
        this._gt = null;
        
        //this is a TYPE_SYS relon
        //we inherit gti from classes down through subclasses down to instances
        //it is only relevant to instances
        this._gti = null;

        //don't allocate for these until we need them
        //even an empty array hits us bigly.
        this._wv_let = null;          //wvs that are let to collab (relevant in WHITELIST owner-collab garden)
        this._wv_deny = null;         //wvs that are denied to collab (relevant in BLACKLIST communual garden)
        this._vip_let = null;         //misc context (like VIP neurons)
        this.trusted_adopt = null;    //relevant in all gardens.
        this.abandon = null;          //will delete at protocol layer.  Array relevant for session.
        this.delegation = null;       //relevant to all keyless neurons with garden of owner-collab or communual
        this.ap = null;

        this.inhibit_txs = null;
        this.owns = null;
        this.aka = [];

        this.no_new_children = null;
        this.classes_only = null;
        this.insts_only = null;
        
        //used on the logged-in identity to tally nids (not tnids) we have delgation
        //rights to.  We use this to do the andy query to setup the andy area of ANNE
        //for managing collab requests.
        this.andy_nids = null;          

        //only relevant for identities, for US (logged in) and anyone we chase for this purpose
        //like in a profile view
        this.my_sponsored = null;  

        this.PARAM_NAME = null;
        this.REL_PARAM_NAME = null;

        //bools
        this.emulated = false
        this.bMINE = false;
        this.preloaded = false;
        this.temp = false;
        this.ghost = false;

        if (this.nid=="" || (this.nid.length && this.nid[0]=="z")) {
            this.ghost=true;
            this.mine=true; //ghosts that are not ghost_owner=USER are not processed.
        }

        this.bTERMINATING_TYPE = false;

        this.requires_validation = false;
        this.bISIDENTITY=null;

        this.ai_ico = null;
        
        //inheritable sys functions.
        this.set_value = null;
        this.set_value2 = null;
        this.formatter = null;
        this.format_validator = null;
        this.requires_validation = null;
        this.fire_circuit = null;

        this.temp_nid=-1;

        this.value = null;

        //collab/delegation, only set when encountered.
        this.collab_ACTION = null;      // COLLAB_REQ_OK etc.
        this.egrs_tnids = null;         // extra garden relns

        //hack prop for queue rollbacks of TYPE_BE MEM.name sends.
        //we should consider putting this elsewhere.
        this.rollbackText = null;   

        //json data for pos/neg/neu summary last_sell_price and annnies_in
        this._aplex = null;

        this.SYS_ALIAS = null;
        this.SYS_ENUM_VAL = null;
        this.SYS_CODE= null;

        //see country, state, city, town, township, borrough, neighborhood. etc
        //all are sub-classes of POLITY. all have children, however, which are 
        //instances of LOCATION.
        this.functional_childparent_reln = null;
        this.functional_childparent_parent = null; 
        this.functional_be = null;                  //for children with a functional parent

        this.freeze = NEURON_NOT_FROZE;

        this._anndle = null;
        this._anndle_resolution = null;
        
        this.ec_type_tnid = null;    //time saver if we calc it, save it.

        this.latestNameRelon =  null;
        this.adate = null;              //for neurons as dates
        this._liferange = null;         //for neurons with liferanges (company/corp, person, nation etc)

        if (MEMP!=undefined) MEMP.__hashNeuron(this);
    }


    setValue = function($v) {
        if (isNaN($v)==true) {
            console.log(this);
            console.log(this.text);
            alert("tell mr scatman about this bullocks");
            return;
        }
        this.value = $v;
    }

    getECTop=function() {
        return this.getParentOfLvl(2);
    }


    /**
     * Go up the be tree until a specific lvl.
     * @param {*} $lvl 
     * @returns 
     */
    getParentOfLvl=function($lvl) {
        if (this.be_lvl>$lvl) {
            var parent = this.getParent();
            if (parent==null) return null;
            return parent.getParentOfLvl($lvl);
        }
        else if (this.be_lvl==$lvl) return this;
        return null;
    }

    getConstituentOf=function() {
        var rel = ANNE.MEMG.getBeRelon(this.outs, ANNE.MEM.constituent_of.temp_nid);
        if (rel!=null) return ANNE.MEMG.getNeuronByTempNid(rel.t);
        return null;
    }

    hasConstitParentOf=function($nid) {
        var rel = ANNE.MEMG.getBeRelon(this.outs, ANNE.MEM.constituent_of.temp_nid);
        if (rel==null) return null;
        if (rel.to_s==$nid) return true;
    }


    /**
     * Optimized to calc once, then store.
     * Stores ec_type_tnid
     * This type is crucial for FIRST-PASS-CONCEPTUALIZATION.
     * The types we handle are all the types used in communication.
     * 
     * NOTE: this should match static nlp_roles.getRoleFromECTop
     * 
     * @returns {anne_neuron}
     */
    setECConceptualizingParent=function() {
        if (this.dead==true) return;
        if (this.ec_type_tnid!=null) {
            return this.ec_type_tnid;
        }

        //nouns
        if (this.anyParentHasBeOf(MEM.ec_thing.temp_nid)==true) this.ec_type_tnid = MEM.ec_thing.temp_nid;
        
        //adjs
        else if (this.anyParentHasBeOf(MEM.ec_state.temp_nid)==true) this.ec_type_tnid = MEM.ec_state.temp_nid;
        
        //vbs
        else if (this.anyParentHasBeOf(MEM.ec_action.temp_nid)==true) this.ec_type_tnid = MEM.ec_action.temp_nid;
        
        //advs
        else if (this.anyParentHasBeOf(MEM.ec_manner.temp_nid)==true) this.ec_type_tnid = MEM.ec_manner.temp_nid;
        
        //modals
        else if (this.anyParentHasBeOf(MEM.ec_mode.temp_nid)==true) this.ec_type_tnid = MEM.ec_mode.temp_nid;
        
        //be vbs
        else if (this.anyParentHasBeOf(MEM.ec_is.temp_nid)==true) this.ec_type_tnid = MEM.ec_is.temp_nid;
        
        //posn vbs
        else if (this.anyParentHasBeOf(MEM.ec_posn.temp_nid)==true) this.ec_type_tnid = MEM.ec_posn.temp_nid;
        
        //when signals
        else if (this.anyParentHasBeOf(MEM.ec_expect_when.temp_nid)==true) this.ec_type_tnid = MEM.ec_expect_when.temp_nid;
        
        //where signals
        else if (this.anyParentHasBeOf(MEM.ec_expect_where.temp_nid)==true) this.ec_type_tnid = MEM.ec_expect_where.temp_nid;
        
        //cjs
        else if (this.anyParentHasBeOf(MEM.ec_expect_more_of_prev.temp_nid)==true) this.ec_type_tnid = MEM.ec_expect_more_of_prev.temp_nid;
        
        //infinitive
        else if (this.anyParentHasBeOf(MEM.ec_expect_actionthing.temp_nid)==true) this.ec_type_tnid = MEM.ec_expect_actionthing.temp_nid;
        
        //question wds
        else if (this.anyParentHasBeOf(MEM.ec_expect_question.temp_nid)==true) this.ec_type_tnid = MEM.ec_expect_question.temp_nid;
        
        //aux
        else if (this.anyParentHasBeOf(MEM.ec_expect_action.temp_nid)==true) this.ec_type_tnid = MEM.ec_expect_action.temp_nid;
        
        //preps and other sig wds
        else if (this.anyParentHasBeOf(MEM.ec_expection.temp_nid)==true) this.ec_type_tnid = MEM.ec_expection.temp_nid;
        
        //pns, countables etc
        else if (this.anyParentHasBeOf(MEM.ec_resolve.temp_nid)==true) this.ec_type_tnid = MEM.ec_resolve.temp_nid;
        
        //anne sys classes are things.
        else if (this.anyParentHasBeOf(MEM.__ANNE_SYS_CLASS.temp_nid)==true) {
            this.ec_type_tnid = MEM.ec_thing.temp_nid;
        }

        if (this.ec_type_tnid==null) {
            console.log("%c NO EC TYPE FOR NEURON '"+this.text+"' "+this.nid, TALK.bgred);
            this.printParentLine();
            return null;
        }

        //if ($matchObj!=null) $matchObj.ec_type_tnid = this.ec_type_tnid;
        return this.ec_type_tnid;
    }

    //TODO convert this to an array of annothers.
    //even though the NARR in ANNODE only quick indexes one,
    //we will still get ANNOTHER relons for multiple relons..
    //we just won't get them in quick indexes.  We will have to go look for them.
    /** 
     * 
     * @author {Mr.Scatman} 
     */
    addAnother=function($annother) {
        if (this.dead==true) return;
        this.annother = $annother;
    }


    /** 
     * This is adopting someone else's neuron.
     * You do not need their permission but they can change it, at will.
     * It is best to figure out which worldview will be the resource and get the 
     * neurons into that worldview with a HANAI_IN or HANAI_OUT
     * @author {Mr.Scatman} 
     */
    addTrustedAdopt=function($temp_nid) {
        if (this.dead==true) return;
        if (this.trusted_adopt==null) this.trusted_adopt = [$temp_nid];
        else if (this.trusted_adopt.indexOf($temp_nid)==-1) this.trusted_adopt.push($temp_nid);
    }


    /** 
     * 
     * @author {Mr.Scatman} 
     */
    addAbandom=function() {
        if (this.dead==true) return;
        if (this.abandon==null) this.abandon = [$temp_nid];
        else if (this.abandon.indexOf($temp_nid)==-1) this.abandon.push($temp_nid);
    }


    /**
     * Add a non-dag (not a inst/class reln) BE to a neuron.
     * 
     * NON-CLASS/INST BES DO NOT GO INTO THEIR BE's CHILD ARRAY.
     * THAT ARRAY IS RESERVED FOR LEGIT ANNE PARENT/CHILDREN. 
     * THE .bes array is for ANY BE relationship with any reln, but the [0] 
     * slot in the bes array is reserved for the class/be RELON! 
     * 
     * DONE
     * 
     * @author {Mr.Scatman} 
     * 
     */
     addAltBE=function($rObj) {

        if (this.dead==true) return;
        //do not add be->eval relons to the bes
        //this should be sys or has anyhow!
        if ($rObj.r==MEM.eval.temp_nid) return;

        var bes = this.bes;
        if (bes==undefined) {
            this.bes = [];
            this.be="";
        }

        if ($rObj.to_type==TO_TYPE_ANNE) {    
            this["be_"+$rObj.r] = $rObj.t;  //quick be tracker for direct reference
            
            //the children of country are actually polity relns pointing to country.
            //country->be_child->polity
            if ($rObj.r==MEM.BE_CHILDREN.temp_nid) {
                this.functional_childparent_reln=$rObj.t;
            }

            //the children of country with polity relns pointing to country
            // must be instances of BE_PARENT reln: to.  (in this case, location.)
            //country->be_parent->location
            else if ($rObj.r==MEM.BE_PARENT.temp_nid) {
                this.functional_childparent_parent=$rObj.t; //this is ACTUAL parent class
            }

            if (this.bes.indexOf($rObj.t)!=-1) return;
            
            if (this.bes.length && $rObj.t==MEM.class.temp_nid) return; 

            else if (this.bes.length>0 && this.bes[0]==MEM.class.nid) {
                this.bes[0]=$rObj.t;  //hijack it.
                var matching_index = MEM.class.children.indexOf($rObj.t);
                if (matching_index!=-1) MEM.class.children.splice (matching_index,1); 
            }
            else {
                if (this.bes.length && ($rObj.r==MEM.class.temp_nid || $rObj.r==MEM.inst.temp_nid)) {
                    if (this.bes.indexOf($rObj.t)==-1) {
                        this.bes.unshift($rObj.t);
                        this.be_time = $rObj.time;
                    }
                }
                else if (this.bes.indexOf($rObj.t)==-1) {

                    this.bes.push($rObj.t);
                }
            }
        }
    }

    
    /** 
     * cascade wv_lets inline here in this function.
     * they do not cascade to instances.  Instances look at the parent class
     * to enforce the deny.
     * @author {Mr.Scatman} 
     */
    addLet=function($temp_nid) {
        if (this.dead==true) return;
        if (this._wv_let==null) this._wv_let=[$temp_nid];
        else if (this._wv_let.indexOf($temp_nid)==-1) this._wv_let.push($temp_nid);
        for (var c=0; c < this.children.length; c++) {
            var nObj = this.children[c];
            if (nObj.ntype!=NTYPE_CLASS) continue;
            if (nObj._wv_let==null) nObj.addLet($temp_nid);
        }
    }
    

    addVipLet=function($temp_nid) {
        if (this.dead==true) return;
        if (this._vip_let==null) this._vip_let=[$temp_nid];
        else if (this._vip_let.indexOf($temp_nid)==-1) this._vip_let.push($temp_nid);
    }


    /** 
     * cascade wv_denies inline here in this function.
     * they do not cascade to instances.  Instances look at the parent class
     * to enforce the deny.
     * @author {Mr.Scatman} 
     */
    addDeny=function($temp_nid) {
        if (this.dead==true) return;
        if (this._wv_deny==null) this._wv_deny=[$temp_nid];
        else if (this._wv_deny.indexOf($temp_nid)==-1) this._wv_deny.push($temp_nid);
        for (var c=0; c < this.children.length; c++) {
            var nObj = this.children[c];
            if (nObj.ntype!=NTYPE_CLASS) continue;
            if (nObj._wv_deny==null) nObj.addDeny($temp_nid);
        }
    }


    /** 
     * Process delegated rights for a neuron.
     * 
     * Delegation clump relons contain delegation param rights.  These are specific columns
     * that the owner authorizes the delegated owner to make or approve of at their own discretion
     * without requiring workflow/approval from the author.  The delegated rights ARE the approval.
     * 
     * A full semantic clump is required since there are more than the 3 short-hand roles
     * required to store the params w/ respect to both a nid and an identity.
     * These clumps follow the form:
     * 
     * [what_role] - the nid which is providing the rights
     * [action_role] - the rights being granted (in our case this will only be the permits reln right)
     * [obj_who_role] - the identity who is getting the rights
     * [obj_what_role] - the param (relns/columns) which are permitted.  Multiples are 
     * ok here -- or a new clump can be made for each individual column.  
     *
     * Note:  we can model any sentence in any language using semantic roles.
     * In ANNE we want to define ONLY THE MOST BASIC ROLES of who/what/when/where. etc.
     * and the attempt (a lofty one) is to learn more refined roles through observation 
     * and experience of language (in any language).   Roles such as target, receiver, giver, instrument etc are hotly debated
     * in linguistic circles.  We can avoid all such debates by starting only with a minimal base
     * (since we don't have language acquisition from zero point we must have "a" base of something).  
     * In ANNE we have the "early concepts" neurons which stand in the place of foundational "pegs" for which
     * all alive entities acquire via experience...  which all other learnings use as a tangible reference..
     * (avoding the relative definition problem where everything is defined by something that is defined
     * by something else).
     * 
     * From a minimal "early concepts" base we can
     * achieve a learning/experience based circuit building model --- the best we can.
     * by programming the least possible and allowing the experiences to program.
     *
     * We can push the line back further wo what the ANNE SI learns via experience as we 
     * gain access to more ANNE sensory input channels.  (text, sound, IP, bytestreams. etc)
     *  
     * The R&D side of ANNE, the ANNE SI... builds her brain by using her brain.
     * The semantic side stores semantic information without having to "understand" what it actually is.
     * (even with that we can pull of more impressive AI feats than the current market does with 
     * their smoke-n-mirror charrades).
     * 
     * THING->delegationrights->to some identity
     * 
     * @author {Mr.Scatman} 
     */
     addDelegation=function($rObj) {
        if (this.dead==true) return;
        if (this.delegation==null) this.delegation=[];
        for (var d=0; d<this.delegation.length; d++) {
            if (this.delegation[d].txid==$rObj.txid) return;
        }
        this.delegation.push($rObj);
    }

    /**
     * we only track these for the logged in user.
     */
    addAndy=function($nid) {
        if (this.dead==true) return;
        if (this.andy_nids==null) this.andy_nids = [];
        if (this.andy_nids.indexOf($nid)==-1) {
            this.andy_nids.push($nid); 
        }
    }


    resetAndyNids=function() {    
        if (this.dead==true) return;
        this.andy_nids= [];
        for (var i=0; i < this.ins.length; i++) {
            var rObj = this.ins[i];
            if (rObj.type!=TYPE_SYS) continue;
            if (this.andy_nids.indexOf(rObj.from_nid)==-1) {
                this.andy_nids.push(rObj.from_nid);
            }
        }

        return this.andy_nids;
    }


    addAka = function($rObj) {
        if (this.dead==true) return;
        var akaval = "";
        if ($rObj.to_type==TO_TYPE_ANNE) {
            var akaNeuron = MEMG.getNeuronByTepNid($rObj.t);
            if (akaNeuron!=null) {
                akaval = akaNeuron.to_s;   
            }                     
        } 
        else akaval = $rObj.to_s;

        if (this.aka.length==0) {
            this.aka = [akaval];
            this.aka_lower = [akaval.toLowerCase()];
        }
        else {
            if (this.aka.indexOf(akaval)==-1) {
                this.aka.push(akaval);
                this.aka_lower.push(akaval.toLowerCase());
            }
        }

        //dont set short by other lang akas.  just standard aka. 
        if ($rObj.r==MEM.aka.temp_nid && akaval.length && akaval.length < this.text.length) {
            if (this.short==null || (this.short!=undefined && akaval.length < this.short.length)) this.short = akaval;
        }
    }

    anyNamesEqual = function($name) {
        $name = $name.toLowerCase();
        if (this.aka_lower!=undefined) {
            if (this.aka_lower.indexOf($name)!=-1) return true;
        }
        if ($name.toLowerCase()==this.text.toLowerCase()) return true;
        return false;
    }

    addAkaManual = function($aka) {
        if (this.aka.length==0) {
            this.aka = [$aka];
            this.aka_lower = [$aka.toLowerCase()];
            if ($aka.length<this.short) this.short=$aka;
        }
        else {
            if (this.aka.indexOf($aka)==-1) {
                this.aka.push($aka);
                if ($aka.length<this.short) this.short=$aka;
                this.aka_lower.push($aka.toLowerCase());
            }
        }
    }


    /** 
     * 
     * @author {Mr.Scatman} 
     */
    addGardenRule=function($rObj) {
        if (this.dead==true) return;
        if (this.egrs_tnids==null) this.egrs_tnids=[$rObj.t];
        else if (this.egrs_tnids.indexOf($rObj.t)===-1) {
            this.egrs_tnids.push($rObj.t);
        }
    }
   

     /** 
     * 
     * @author {Mr.Scatman} 
     */
    addOwnedBy=function($nid) {
        if (this.dead==true) return;
        
        if (this.owned_by=="") {
            this.owned_by = $nid; 
            var ob = MEMG.getOrMakeIfNew($nid);
            if (ob) ob.addOwns(this.temp_nid);
        }
        else {
            if (this.owned_by!=$nid) {
                //console.log("%cwe have a conflict in owned_by indexes", TALK.bgred);
                if (this.ghost==false) {
                    if (ANNE.isANNE(this.owned_by)==false && ANNE.isANNE($nid)==true) {
                        this.owned_by = $nid;
                    }
                }
                else {
                    if (ANNE.isANNE($nid)==false) {
                        this.owned_by = $nid;
                    }
                }
            }
            else {
                var ob = MEMG.getOrMakeIfNew($nid);
                if (ob) ob.addOwns(this.temp_nid);
            }
        }
        if (USER._userNObj!=null && this.owned_by==USER._userNObj.nid) this.mine=true;
    }

    addOwns=function($temp_nid) {
        if (this.dead==true) return;
        if (this.owns==null) this.owns=[];
        if (this.owns.length==0) this.owns.push($temp_nid);
        else if (this.owns.indexOf($temp_nid)===-1) this.owns.push($temp_nid);
    }


    /** 
     * 
     * @author {Mr.Scatman} 
     */
     addSponsoredBy=function($sponsored_by) {
        if ($sponsored_by==null || $sponsored_by==undefined) {
            alert("fix this messed up sponsored by");
            this.sponsored_by="";
            return;
        }
        if (this.dead==true) return;               
        if (this.sponsored_by=="") MEMG.getOrMakeIfNew($sponsored_by);  //this may be the only reference to this neuron we have..
        this.sponsored_by = $sponsored_by;
        
        if ($sponsored_by==USER._userNObj.nid) {
            if (USER._userNObj.my_sponsored==null) USER._userNObj.my_sponsored=[this.temp_nid];
            else if (USER._userNObj.my_sponsored.indexOf(this.temp_nid)==-1) {
                USER._userNObj.my_sponsored.push(this.temp_nid);
            }
        }
    }


    /**
     * Only tracked for logged-in user.
     * @param {*} $relon_sponsor 
     * @returns 
     */
    addUsAsRelonSponsor=function($rel) {
        if ($rel==undefined || $rel==null) {
            alert('fix this');
            return;
        }
        if (this.dead==true) return;               
        if (this.relon_sponsored==undefined) {
            this.relon_sponsored=[$rel];
            return;
        }
        var txid = $rel.txid;
        for (var r=0; r < this.relon_sponsored.length; r++) {
            if (this.relon_sponsored[r].txid==txid) return;
        }
        this.relon_sponsored.push($rel);
    }
    

    
    /**
     * Add a unique be to the bes array.
     * 
     * This is called for all TYPE_BE relons.
     * Parent/hierarchical bes will be routed through setBeTempNid.
     * All other BEs are routed through the addAltBe handler.
     * 
     * @param {Object} - The TYPE_BE relon.
     * @author {Mr.Scatman} 
     */
     addUniqueBe = function($rObj) {
        if (this.dead==true) return;
        if ($rObj == null) return;
        if ($rObj.r == MEM.class.temp_nid) {
            if ($rObj.ntype!=1 && $rObj.ntype!=2) {
                this.ntype = NTYPE_CLASS;
            }
        }
        else if ($rObj.r == MEM.inst.temp_nid) {
            if ($rObj.ntype!=1 && $rObj.ntype!=2) {
                this.ntype = NTYPE_INST;
            }
            this.be_time = $rObj.time;
        }
        else {
            this.addAltBE($rObj);
            return;
        }
        var parentNOBJ = MEMG.getNeuronByTempNid($rObj.t);
        this.setBeTempNid(parentNOBJ.temp_nid);
    }

    /**
     * Add a unique Be.
     * @author {Mr.Scatman} 
     */
     addUniqueBe_fastIndex = function($parentNObj) {
        if (this.dead==true) return;
        if (this.temp_nid==-1) {
            alert("fix this (addUniqueBe_fastIndex) temp_nid = -1");
            return;
        }

        if ($parentNObj==null) {
            alert("What?"); 
            return;
        }
        if (($parentNObj instanceof anne_neuron) == false) {
            alert("you must pass a neuron into addUniqueBe_fastINdex");
        }

        var bes = this.bes;
        if (bes==null) {
            this.bes = [];
            this.be="";
        }

        //might be overkill as this is the nid of the temp_nid in bes[0]
        //the notation comes from the NARR record in the ANNODE.
        this.parent = $parentNObj.nid;  

        //now we know we need the array.
        if ($parentNObj.children==null) $parentNObj.children=[];

        //this["be_"+MEM.name.temp_nid] = $parentNObj.temp_nid;

        //we have a more refined be class, override it.
        if (this.bes.length && this.bes[0]==MEM.class.nid) {
            this.bes[0]=$parentNObj.temp_nid;
            
            //remove it from the children of the "class" neuron
            var matching_index = MEM.class.children.indexOf($parentNObj.temp_nid);
            if (matching_index!=-1) MEM.class.children.splice (matching_index,1); 
        }
        else {

            //class/inst hierarchical BES must be in the slot [0] of the bes array!
            if (this.bes.length && ($parentNObj.temp_nid==MEM.class.temp_nid || $parentNObj.temp_nid==MEM.inst.temp_nid)) {
                if (this.bes.indexOf($parentNObj.temp_nid)==-1) {
                    this.bes.unshift($parentNObj.temp_nid);
                }
            }
            else if (this.bes.indexOf($parentNObj.temp_nid)==-1) {
                //this be parent is a sub class of what we had before. this is more specific.
                this.bes.unshift($parentNObj.temp_nid);
            }
        }

        this.setBeLevel($parentNObj);
        if ($parentNObj.bTERMINATING_TYPE==true) {
            this.bTERMINATING_TYPE=true;
            //ensure any children are also bTERMINATING_TYPE just in case 
            //we preloaded or found them in an order that missed this.
            //ie.  ticker2->subclasses ticker1-> subclasses text.
            //if we see ticker2 first we don't get the BE info of it being a descendant of text.
            if ($parentNObj.children==null) $parentNObj.children=[];

            if ($parentNObj.children) {   //obviously should have them..
                for (var c=0; c <$parentNObj.children.length; c++) {
                    MEMG.getNeuronByTempNid($parentNObj.children[c]).bTERMINATING_TYPE=true;
                }
            }
        }
                
        if ($parentNObj.children.indexOf(this.temp_nid)==-1) $parentNObj.children.push(this.temp_nid);
        if ($parentNObj.text!="") this.be = $parentNObj.text;

        //fix lvls and text while we are at it.
        //iterate through be children.
        if ($parentNObj.children.length>0) { 
            if ($parentNObj.bes && $parentNObj.bes.length>0) {
                var beBeNOBJ = MEMG.getNeuronByTempNid($parentNObj.bes[0]);
                if (beBeNOBJ) $parentNObj.setBeLevel(beBeNOBJ);
            }
        }
    }


    /**
     * Add a unique in to a neurons ins array.
     * 
     * @param {Object} - the in
     * 
     * @author {Mr.Scatman}
     */
    addUniqueIns=function($rObj) {
        if (this.dead==true) return;
        if (this.ins==null) this.ins=[];
        else {
            if (this.ins_r[($rObj.rid)]!=undefined) return;
            this.ins.push($rObj);
            this.ins_r[$rObj.rid]=null;
                
            //for (var r=0; r < this.ins.length; r++) {if ($rObj.rid==this.ins[r].rid || $rObj.txid==this.ins[r].txid) return;}
        }


        //setting _anndle and _anndle_resolution ptrs.
        //if ($rObj.reln==MEM.anndle_resolution.nid) {
            //var fromNOBJ = MEMG.getNeuronByTempNid($rObj.f);
            //if (fromNOBJ.owned_by==MEM.ANNE_ACCTID && fromNOBJ.bes.length && fromNOBJ.bes[0]==MEM.anndle.temp_nid) {
              //  this._anndle = fromNOBJ;
               // fromNOBJ._anndle_resolution = this;
           // }
       // }

        return;
    }

        
    /**
     * 
     * @author {Mr.Scatman}
     */
     addUniqueLocalArborPrune=function($rObj) {
        if (this.dead==true) return;
        if ($rObj.from_nid!=this.nid) {
            console.log("nid doesn't match. big trouble little china")
            return;
        }
        if ($rObj.reln!=MEM.arbor_prune.nid) return; //local arbor prune
        $rObj.active=false;
        var txid = $rObj.to_s.trim();
        if (this.ap==null) this.ap=[];
        else {
            for (var r=0; r < this.ap.length; r++) {
                var a = this.ap[r];
                var ap_txid = this.ap[r].trim();
                if (ap_txid == txid) return;
            }
        }
        this.ap.push($rObj.to_s);    //the TXID we want to prune!
    }



    
    /**
     * Add a unique out to a neurons outs array.
     * 
     * @param {Object} - the out
     * 
     * @author {Mr.Scatman}
     */
     addUniqueOut=function($rObj) {
        if (this.dead==true) return;
        if ($rObj.from_nid!=this.nid) {
            console.log("nid doesn't match. big trouble little china")
            return;
        }

        if (this.outs==null) this.outs = [];
        
        //this txid is already in our arbor prune list for THIS local neuron.
        //do not allow this txid in.
        if (this.ap!=null && this.ap.length) {
            if (this.ap.indexOf($rObj.txid.trim())>=0) {
                $rObj.active=false;
                return;
            }
        }
        if (this.inhibit_txs!=null && this.inhibit_txs.length) {
            if (this.inhibit_txs.indexOf($rObj.txid.trim())>=0) {
                $rObj.active=false;
                return;
            }
        }

        //this IS a new local arbor prune or inhibit
        if ($rObj.r==MEM.arbor_prune.temp_nid || $rObj.r==MEM.inhibit_relon.temp_nid) { 
            
            //locals only are allowed to prune TXIDS from their neuron
            var killObj = MEMG.lookupRelonByTXID($rObj.to_s, this.outs);
            
            //turn it off before it gets in any arrays (or else we have to go find it in post ops);
            if (killObj != null) {
                this.addUniqueLocalArborPrune($rObj);
                killObj.active = false;
                this.removeByTXID('outs', killObj.txid); //remove it if we already have it in 
            }
            return;
        }

        //this is a necrosis 
        if ($rObj.r==MEM.necrosis.temp_nid) {
            return;
        }

        if ($rObj.active==false) return;

        if (this.outs_r[$rObj.rid]!=undefined) return;
         
        //local .outs array dupe check
        //for (var r=0; r < this.outs.length; r++) { if (this.outs[r].rid==$rObj.rid) return; }
        
        this.outs.push($rObj);
        this.outs_r[$rObj.rid]=null;
    }

    anyParentHasBeOf=function($temp_nid) {
        if (this.dead==true) return false;
        var nObj = this;
        var safety=16;
        if (nObj.temp_nid==$temp_nid) return true;

        //var testToMatchNOBJ = MEMG.getNeuronByTempNid($temp_nid);
        //console.log("testing for '"+nObj.text+"' having any parent or w/ alt be of: '"+testToMatchNOBJ.text+"' nid:"+testToMatchNOBJ.nid);
        while (nObj!=null && nObj.be_lvl>0 && safety>0) {
            if(nObj.bes.indexOf($temp_nid)!=-1) {
                return true;
            }
            nObj = nObj.getParent();
            safety=safety-1;
            if (nObj==null) break;
        }
        return false;
    }


    //we can display disambigs in here.
    bestSelectDisplay = function($pre="", $bOWNEDBY=false, $bPARENT=false) {
        if (this.dead==true) return "";
        var parts = [];
        if ($bOWNEDBY==true) {
            var lbl = this.owned_by;
            if (this.owned_by==ANNE.MEM.ANNE_ACCTID) lbl = "ANNE";
            parts.push("owner:"+lbl+"");
        }
        if ($bPARENT==true && this.getParent()!=null) {
            parts.push("parent:"+this.getParent().text+"");
        }
        else {
           parts.push("parent:?");  
        }
        if (parts.length) return $pre+this.text+" ("+parts.join(" ")+")";
        return $pre+this.text;
    }


    uicoWithName = function() {
        var name = "";
        this._uico = undefined;

        if (this.text==undefined || this.text==null) this.text="";
        
        if (this.text.length) name = this.text;
        else name = this.nid;

        return name;
    }
    


    bestName = function($default="", $bPOSTFIXNID=false) {
        if (this.dead==true) return "";
        var prepend = "";
        if (this.ghost==true) prepend = '(gh)';
    
        if (this.bTERMINATING_TYPE==true) {
            if(this.value!=null && this.value!="") return prepend+this.value;
            else if (this.set_value!=null) this.set_value(this);
            if (this.value!=null && this.value!="") return prepend+this.value;
        }
        if (this.text!="") {
            if ($bPOSTFIXNID==false) return prepend+this.text;
            else return prepend+this.text+" - "+this.nid;
        }
        if ($default!="") return prepend+$default;
        //check if be-line is a role_action, if so put "actionevent: '[name of role]'"
        if (MEMG.besOf(this, MEM.ec_action.temp_nid)==true) {
            var beNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
            return "actionevent: "+prepend+beNOBJ.text;
        }
        return prepend+this.nid;
    }

    //unlike shortName, this attempts to find the shortest alias 
    //to use in an alt-search of external data when we have no viable options found
    //on our first attempt.
    getShortestAlias = function() {
        if (this.aka==undefined || this.aka==null) return this.shortName;
        var shortest = this.aka[0];
        for (var a=1; a < this.aka.length; a++) {
            if (this.aka[a].length < shortest.length) {
                shortest = this.aka[a];
            }
        }
        return shortest;
    }


    /**
     * 
     * @param {*} $default 
     * @param {*} $bPOSTFIXNID 
     * @returns 
     */
    bestNameHTML = function($default="", $bPOSTFIXNID=false) {
        if (this.dead==true) return "";
        var prepend = "";
        var post = "";
        if (this.ghost==true) prepend = '<img class="dib" src="../imgs/ghost_ico.png" width="12px" title="Ghost (local neuron).">&nbsp;';

        //distinguish image neurons with an img ico to avoid confusion.
        if (this.bes.length && this.bes.indexOf(MEM.neuronImg.temp_nid)!=-1) post = "📷";
        
        if (this.bTERMINATING_TYPE==true) {
            if(this.value!=null && this.value!=isNaN(this.value) && this.value!="") return prepend+this.value+post;
            else if (this.set_value!=null) this.set_value(this);
            if (this.value!=null && this.value!="") return prepend+this.value+post;
        }

        //use short name here, if we have it.
        //ie, for District of Columbia we can use DC.
        var str = this.text;
        if (str!="") {
            if ($bPOSTFIXNID==false) return prepend+str+post;
            else return prepend+str+" - "+this.nid+post;
        }

        if ($default!="") return prepend+$default;

        //check if be-line is a role_action, if so put "actionevent: '[name of role]'"
        if (MEMG.besOf(this, MEM.ec_action.temp_nid)==true) {
            var beNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
            return "actionevent: "+prepend+beNOBJ.text+post;
        }

        return prepend+this.nid+post;
    }


    /**
     * Try a custom set_value function first.
     * If that doesn't exist, try for an eval relon.
     */ 
    bestValue = function() {
        if (this.dead==true) return null;
        if (this.set_value!=undefined && typeof this.set_value === 'function') {
            return this.set_value(this);
        }
        return MEM.eval.set_value(this);
    }

    getSpouses = function() {
        var spouse_rels = ANNE.MEMG.getHasRelons(this.outs, ANNE.MEM.spouse.temp_nid);
        if (spouse_rels==null || spouse_rels.length==0) return [];
        return ANNE.MEMG.getNObjsFromRels(spouse_rels);
    }

    //blow out the disambig however we like here..
    //setDisambigForLightContextResolution=function() {
    //}


    /**
     * Text search of a disambig list associated with this neuron in RAM.
     * Score it if there are any hits to the context array passed in.
     * @param {*} $context 
     * @returns 
     */
    contextAdditive=function($context=[]) {
        if ($context.length==0) return 0;
        
        var additive = 0;
        for (var d=0; d < this.disambig.length; d++) {
            if ($context.includes(this.disambig[d])==true) {
                additive+=1;
            }
        }
        return additive;
    }


    printDisambig=function($bSET=false, $max=3) {
        if ($bSET==true) this.setDisambigArrStr($max);
        return this.bestName()+"["+this.disambig.join(",")+"]";
    }

    /**
     * 
     */
    setDisambigArrStr = function($max=3, $skipsTNIDS=[]) {
        this.disambig = [];
        for (var r=0; r < this.outs.length; r++) {
            if (this.disambig.length==$max) {
                return;
            }
            var rel = this.outs[r];
            if ($skipsTNIDS.length>0 && $skipsTNIDS.indexOf(rel.r)!=-1) continue;
            if (rel.type!=TYPE_BE && rel.type!=TYPE_BRAIN && rel.type!=TYPE_HAS) continue;
            if (rel.type==TYPE_HAS && rel.r!=MEM.brain_assoc.temp_nid && rel.r!=MEM.brain_assoc_strong.temp_nid) continue;
            if (rel.r==ANNE.MEM.class.temp_nid) continue;
            if (rel.r==ANNE.MEM.inst.temp_nid) continue;
            if (rel.r==ANNE.MEM.birthplace.temp_nid) continue;
            if (rel.r==ANNE.MEM.birthday.temp_nid) continue;
            if (rel.r==ANNE.MEM.deathplace.temp_nid) continue;
            if (rel.r==ANNE.MEM.deathday.temp_nid) continue;
            if (rel.r==ANNE.MEM.nationality.temp_nid) continue;
            if (rel.r==ANNE.MEM.name.temp_nid) continue;
            if (rel.to_type==TO_TYPE_ANNE && rel.type==TYPE_BE) {
                var toNOBJ = MEMG.getNeuronByNid(rel.to_s);
                if (toNOBJ==null || toNOBJ.text==null) {
                    console.log("?????");
                    continue;
                }
                if (toNOBJ.text=="") continue;
                if (this.text==null || this.text==undefined) {
                    console.log("WHAT IN THE HECK???");
                }
                if (toNOBJ.text==undefined || toNOBJ.text==null) {
                    console.log("toNOBJ probs");
                }
                if (toNOBJ.text.toLowerCase()==this.text.toLowerCase()) continue;
                if (toNOBJ!=null && this.disambig.includes(toNOBJ.text.toLowerCase())==false) {
                    this.disambig.push(toNOBJ.text.toLowerCase());
                }
            }
            if (this.disambig.length==$max) {
                return;
            }
        }
        

        for (var r=0; r < this.outs.length; r++) {
            if (this.disambig.length==$max) {
                return;
            }
            var rel = this.outs[r];
            if ($skipsTNIDS.length>0 && $skipsTNIDS.indexOf(rel.r)!=-1) continue;
            if (rel.type!=TYPE_BE && rel.type!=TYPE_BRAIN) continue;
            if (rel.r==ANNE.MEM.class.temp_nid) continue;
            if (rel.r==ANNE.MEM.inst.temp_nid) continue;
            if (rel.r==ANNE.MEM.birthplace.temp_nid) continue;
            if (rel.r==ANNE.MEM.birthday.temp_nid) continue;
            if (rel.r==ANNE.MEM.deathplace.temp_nid) continue;
            if (rel.r==ANNE.MEM.deathday.temp_nid) continue;
            if (rel.r==ANNE.MEM.nationality.temp_nid) continue;
            if (rel.r==ANNE.MEM.name.temp_nid) continue;
            if (rel.to_type==TO_TYPE_STRING && rel.type==TYPE_BE) {
                if (rel.to_s.toLowerCase()==this.text.toLowerCase()) continue;
                if (this.disambig.includes(rel.to_s.toLowerCase())==false) this.disambig.push(rel.to_s.toLowerCase());
            }
            if (this.disambig.length==$max) {
                return;
            }
        }

        if (this.disambig.length==0) {
            var parentNOBJ = this.getParent();
            if (parentNOBJ!=null && parentNOBJ.text!="") this.disambig.push(parentNOBJ.text);
        }

        return;
    }



    //get a short name, if we have it,
    //otherwise fall back on the bestName.
    shortName = function() {
        if (this.dead==true) return "";
        if (this.short!=null && this.short!="") return this.short;
        else if (this.text!="") return this.text;
        else return this.nid;
    }

    
    /**
     * Cascade properties down to children.
     * 
     * NOTE: now that we use this heavily we will have to check
     * for circular paths in our TYPE_BE DAG structure.
     * 
     * This would cause the MEM manager to hang.
     *  
     * @author {Mr.Scatman} 
     */
    cascadePropsDownChildrenClasses=function($propsObj, $chain=[]) {
        ANNE.MEM._cascadePropsDownChildrenClasses_cnt+=1;

        if (this.dead==true) return;
        if (this.children==null) return;

        for (var n=0; n < this.children.length; n++) {
            var childNOBJ = MEMG.getNeuronByTempNid(this.children[n]);
            
            if (childNOBJ.bes.indexOf(this.temp_nid)==-1) {
                alert("this should never happen");
                continue;
            }
            
            //func inherits
            if (this.ntype==NTYPE_CLASS) {
                if (childNOBJ.set_value!=undefined && childNOBJ.set_value!=null) {
                    $propsObj["set_value"]=childNOBJ.set_value;
                }
                if (childNOBJ.set_value2!=undefined && childNOBJ.set_value2!=null) {
                    $propsObj["set_value2"]=childNOBJ.set_value2;
                }
                if (ANNE.UTILS.isset(childNOBJ.formatter==true)) {
                    console.log("%c"+childNOBJ.text+" has formatter to inherit", TALK.bggreen);
                    $propsObj["formatter"]=childNOBJ.formatter;
                    if (this.nid==MEM.string.nid || childNOBJ.nid==MEM.string.nid) {
                        console.log("%c (cascadePr0psDownChildrenClasses) hunting string bug", TALK.bggreen);
                    }
                }
                if (childNOBJ.format_validator!=undefined && childNOBJ.format_validator!=null) {
                    $propsObj["format_validator"]=childNOBJ.format_validator;
                    
                }
                if (childNOBJ.requires_validation!=undefined && childNOBJ.requires_validation!=null) {
                    $propsObj["requires_validation"]=childNOBJ.requires_validation;
                }
                if (childNOBJ.fire_circuit!=undefined && childNOBJ.fire_circuit!=null) {
                    $propsObj["fire_circuit"]=childNOBJ.fire_circuit;
                }

                //TODO:
                //not a func, but inheritable.  (CHECK THIS WITH OUR NEW CLUMP HANDLING)
                if (childNOBJ.role_action!=undefined && childNOBJ.role_action!=null) {
                    console.log("%c REVIEW THIS", TALK.bgred);
                    $propsObj["role_action"]=childNOBJ.role_action;
                }
                
                if (childNOBJ.target_type!=undefined && childNOBJ.target_type!=null) {
                    $propsObj["target_type"]=childNOBJ.target_type;
                }
            }
    
            var props = Object.keys($propsObj);

            for (var p=0; p < props.length; p++) {
                var prop = props[p];

                if (prop=="set_value" && $propsObj[prop].name!=undefined && $propsObj[prop].name=="setNumber") {
                    console.log(childNOBJ.text+" lvl:"+childNOBJ.be_lvl+" is inheriting set_value: setNumber!");
                }

                //only set the child prop with the parent prop if the child
                //prop isn't already set.
                if (childNOBJ[prop]==undefined || childNOBJ[prop]==null) {
                    childNOBJ[prop] = $propsObj[prop];//this[prop];       //this prop OR  $propsObj[prop] ?
                }

                //if we had a child prop already set, replace that in our props
                //array as we will cascade this value down to the next gen of children,
                //not the less accurate gparent value.
                else $propsObj[prop]=childNOBJ[prop];
            
            }

            //no need to chase inst children.
            //no such thing, other than our creative "MIRROR" neuron which is an
            //inst of an inst.. but we will handle that run-time on demand.
            if (childNOBJ.ntype==NTYPE_INST) continue;

            $chain.push(this.text+"->"+childNOBJ.text+" lvl:"+this.be_lvl);

            var propsObj = $propsObj
            var keys = Object.keys($propsObj);
            
            //we need a copy to traverse as we may change a value from another downline
            //and we don't want that in a higher branch.
            if (keys.length>0) {
                propsObj = [];
                for (var k=0; k < keys.length; k++) {
                    propsObj[ keys[k] ] = $propsObj[ keys[k] ];
                }     
            }
            
            //childNOBJ.cascadePropsDownChildrenClasses(propsObj, $chain);
        }
        return;
    }


    /**
     * The child has severed its ties with its parent.
     * @author {Mr.Scatman}
     */
    childDisavowsParent=function($parent_temp_nid) {
        if (this.dead==true) return;
        this.removeParentFromChild($parent_temp_nid);
        var parentNOBJ = MEMG.getNeuronByTempNid($parent_temp_nid);
        if (parentNOBJ==null) return;
        parentNOBJ.removeChild(this.temp_nid);
        return;
    }


    /** 
     * 
     * @author {Mr.Scatman} 
     */
     disambigIDHTMLStr($el) {
        if (this.dead==true) return;
        if ($el==undefined || $el==null) return;
        $el = ANNE.A.__getEl($el);
        ANNE.A.empty($el);
        ANNE.A.show($el);

        var span = ANNE.A.ezEl($el, "span", "text-success-lbl", this.text);

        var pieces = 0;
        
        if (this.bes.length) {
            var beNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
            if (beNOBJ.text!="") ANNE.MEM_UDF.makeNeuronLink($el, beNOBJ.nid, "", "<b>parent</b>&nbsp;");
            pieces+=1;
        }
        if (this.owned_by!="") {
            var ownedBYNOBJ = MEMG.getNeuronByNid(this.owned_by);
            if (ownedBYNOBJ) ANNE.MEM_UDF.makeNeuronLink($el, ownedBYNOBJ.nid, "", "<b>owner</b>&nbsp;");
            pieces+=1;
        }
        if (this.sponsored_by!="") {
            var sponsoredBYNOBJ = MEMG.getNeuronByNid(this.sponsored_by);
            if (sponsoredBYNOBJ) ANNE.MEM_UDF.makeNeuronLink($el, sponsoredBYNOBJ.nid, "", "<b>sponsor</b>&nbsp;") ;
            pieces+=1;
        }

        //to do, make sure aka full neurons are put in the aka array as text strings.
        if (this.aka!=null) {
            var span = document.createElement("span");
            span.innnerHTML = "also known as <b>"+this.aka.join("/")+"</b>";
            $el.append(span);
            pieces+=1;
        }

        if (this.pubKey!=undefined) {
            var span = document.createElement("span");
            span.innnerHTML = "pubkey <b>"+this.pubKey+"</b>";
            $el.append(span);
            pieces+=1;
        }

        if (pieces==0) {
            ANNE.A.ezEl($el, "span", "bg-danger roundify", "<b>WARNING</b>: this is an unnamed unclassified NID. This is treated as an onboarding.");
        }
    }


    /** 
     * Show disambig (with clickable links) or just text to help differentiate what this is.
     * @author {Mr.Scatman} 
     */
    disambigHTMLStr($el, $bSHOWNID=false, $bSHOWSELF=false, $selfPre="<b>selected&nbsp;</b", $lblClass="", $disambig_text_only=false) {
        if (this.dead==true) return;
        console.log(this);
        if ($el==undefined || $el==null) return;
        var el = ANNE.A.empty($el);

        if ($bSHOWSELF) {
            if ($lblClass!="") {
                var span = document.createElement("span");
                span.classList.add($lblClass);
                el.append(span);
                span.innerHTML=$selfPre;

                var span2 = document.createElement("span");
                el.append(span2);
                span2.classList="disambig-neuron";

                if ($disambig_text_only==true) span2.innerHTML+="["+this.text+"]";
                else EXT_BTNS.makeNeuronLink(span2, this.nid, "");
                el = span2; //for the rest of the additions.
                
            }
            else EXT_BTNS.makeNeuronLink(el, this.nid, "", $selfPre);
        }

        if (this.bes.length) {
            var beNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
            if (beNOBJ.text!="") {
                 if ($disambig_text_only==true) el.innerHTML+="[<b>parent&nbsp;</b>"+beNOBJ.text+"]";
                 else EXT_BTNS.makeNeuronLink(el, beNOBJ.nid, "", "<b>parent&nbsp;</b>");
            }
        }
        if (this.owned_by!="") {
            var ownedBYNOBJ = MEMG.getNeuronByNid(this.owned_by);
            if (ownedBYNOBJ) {
                if ($disambig_text_only==true)el.innerHTML+="[<b>owner&nbsp;</b>"+ownedBYNOBJ.text+"]";
                else EXT_BTNS.makeNeuronLink(el, ownedBYNOBJ.nid, "", "<b>owner</b>&nbsp;");
            }
        }
        if (this.sponsored_by!="") {
            var sponsoredBYNOBJ = MEMG.getNeuronByNid(this.sponsored_by);
            if (sponsoredBYNOBJ) {
                if ($disambig_text_only==true)el.innerHTML+="[<b>sponsor&nbsp;</b>"+sponsoredBYNOBJ.text+"]";
                else EXT_BTNS.makeNeuronLink(el, sponsoredBYNOBJ.nid, "", "<b>sponsor</b>&nbsp;") ;
            }
        }
        if ($bSHOWNID==true) {
            var span = document.createElement("span");
            if ($disambig_text_only==true) span.innerHTML = "[<b class='show-nid'>nid</b> "+this.nid+"]";
            else span.innerHTML = "<b class='show-nid'>nid</b> "+this.nid;
            el.append(span);
        }

        //to do, make sure aka full neurons are put in the aka array as text strings.
        if (this.aka!=null) {
            var span = document.createElement("span");
            span.innnerHTML = "also known as <b>"+this.aka.join("/")+"</b>";
            el.append(span);
        }

        ANNE.A.show(el);
    }



    /** 
     * Ensure this child is a legit child of the class and not a rogue unsanctioned creation.
     * 
     * Reminder: (cheap) Adopt get a neuron made in another wordlview into the acceptable
     * worldview of the class.
     * 
     * @author {Mr.Scatman} 
     */


    //TODO: REDO THIS FOR  gt and gti
    enforceGardenUp=function() {
        if (this.dead==true) return;
        var parentNOBJ = null;
        if (this.bes.length==0) return true;
        if (this.mine==true) return true;       //anything we own is ok to show in our gui
        if (this._gt==null) {
            if (this.bes.length==0) return true;
            //quick check for parent _gt if we missed it.
            var parentNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
            if (parentNOBJ==null) return true;
            if (parentNOBJ._gt!=null) this.setGtRelon(parentNOBJ._gt);
            else return true;
        }

        //Communal garden - Honors owner set delegation to allow collab approvals.  
        //Deny entry will OVERRIDE delegated rights
        //Defaults to BLACKLIST mode for denys (ignores those on the LET list).
        //Anyone can make collab relon requests.
        //Anyone can make keyless children (that they own)
        //gui - Neurons owned by the owner or anyone not in the deny list will be displayed.
        else if (this._gt.reln==MEM.gt_communal.nid) {
            //if ($nObj._wv_let!=undefined && $nObj._wv_let.length) {
               // if ($nObj._wv_let) MEMZ.ezDisplayfrom_tnidList($el, "<b>let</b>", $nObj._wv_let, "ai-check", $linkType);
           // }
            //if (this._wv_deny!=undefined && this._wv_deny.length) {
               // if (this._wv_deny
            //}
            return true;
        }
        
        
        //Owner collab - Honors owner set delegation to allow collab approvals.
        //Defaults to WHITELIST mode for LETS.
        //Only those listed in LETS can make collab relon request and keyless children (that they own).
        //gui - Only those neurons owned by the owner, or the LETS, will be displayed.
        else if (this._gt.reln==MEM.gt_owner_collab.nid) {
            return true;
        }

        //for owner only:
        parentNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
        if (parentNOBJ.owned_by==this.owned_by) return true;
        if (parentNOBJ.trusted_adopt!=null && parentNOBJ.trusted_adopt.length && parentNOBJ.trusted_adopt.indexOf(this.temp_nid)) return true;
        
        //see PDN classes
        if (parentNOBJ.wvBIPASS!=undefined && parentNOBJ.wvBIPASS==true) return true;

        return false;
    }

    /**
     * other neuron props extracted from relons.
     */
    extractOtherPropsFromRelon=function($rObj) {
        if (this.dead==true) return;
        
        if ($rObj.pubKey!=undefined && (this.pubKey==undefined || this.pubKey==null || this.pubKey=="")) {
            this.pubKey=$rObj.pubKey;
        }

        if ($rObj.freeze!=undefined) {
            this.freeze = $rObj.freeze;
        }

        //essentially a TYPE_SYS clump.
        if ($rObj.type==TYPE_CLUMP) {
            //we are pointing to a delegation rights clump
            if (MEM.delegation_rights.temp_nid==$rObj.r) {
                this.addDelegation($rObj);
            }
        }

        //do some quick mojos here.
        else if ($rObj.type==TYPE_SYS) {

            //set the eval value
            //we don't do this for the TYPE BE evals.
            //they have their type_be value already.
            if($rObj.r==MEM.eval.temp_nid) {
                MEM.eval.set_value(this);
            }
            else if ($rObj.r==MEM.garden_type.temp_nid) {
                this.setGtRelon($rObj);     //we will want this to cascade down the be tree
            }
            else if ($rObj.r==MEM.inst_garden_type.temp_nid) {
                this.setGtiRelon($rObj);     //we will want this to cascade down the be tree
            }
            else if ($rObj.r==MEM.let_wv.temp_nid) {
                this.addLet($rObj.t);       //we will want this to cascade down the be tree
            }
            else if ($rObj.r==MEM.deny_wv.temp_nid) {
                this.addDeny($rObj.t);      //we will want this to cascade down the be tree
            }
            else if ($rObj.r==MEM.viplet.temp_nid) {
                this.addVipLet($rObj.t);
            }
            else if ($rObj.r==MEM.trusted_adopt.temp_nid) this.addAdopt($rObj.t);
            else if ($rObj.r==MEM.abandon.temp_nid) this.addAbandon($rObj.t);
            
            else if ($rObj.r==MEM.gt_permit_reln.temp_nid) {
                //ANNE.TALK.printRelon($rObj);
                //if (MEM.location.temp_nid==$rObj.f) {
                    //console.log("%c CONFIRM EGRS HERE", 'background: white; color: red');
                //}
                this.addGardenRule($rObj);
            }
            else if (MEM.delegation_reln_tnids.indexOf($rObj.r)!==-1) {
                this.addDelegation($rObj);
            
                //all delegation relons stored in: this.delegation
                //note, these are not yet cascaded.
                //that happens run-time when needed.

                //store this for quick test/helper.
                
                if ($rObj.r==MEM.dr_andy_hanai_in.temp_nid) {
                    //set some helpful arrays for IDENTITIES.hanai_admin
                    //and nonidentityneuron.hanai_admins
                    var fromNOBJ = MEMG.getNeuronByNid($rObj.from_nid);
                    if (fromNOBJ!=null) {
                        //non-identity neurons get hanai_admins array.
                        if (fromNOBJ.hanai_admins==undefined) fromNOBJ.hanai_admins=[$rObj.t];
                        else if (fromNOBJ.hanai_admins.indexOf($rObj.t)==-1) fromNOBJ.hanai_admins.push($rObj.t);
                    }
                    
                    //identities get a hanai_admin array.  (mostly only relevant for USER._userNObj)
                    var toNOBJ = MEMG.getNeuronByNid($rObj.to_s);
                    if (toNOBJ!=null) {                    
                        if (toNOBJ.hanai_admin==undefined) toNOBJ.hanai_admin=[$rObj.f];
                        else if (toNOBJ.hanai_admin.indexOf($rObj.f)==-1) toNOBJ.hanai_admin.push($rObj.f);
                    }
                }
            }

            //unique on.. to help w/ disambig.
            else if ($rObj.r==MEM.uo.temp_nid) {
                if(this.uo==undefined) this.uo=[$rObj.t];
                else this.uo.push($rObj.t);
            }

            
            //mark this to_class requiring validation.
            //if it is used as a reln, the to will have to be validated
            //according to the set validator for that type.
            else if ($rObj.r==MEM.require.temp_nid && $rObj.t==MEM.validation.temp_nid) this.requires_validation=true; 
            
            //clean these up for param. must be alpha start and alphanum only
            //if non_alpha start prepend "p_";
            else if ($rObj.r==MEM.PARAM_NAME.temp_nid) {
                var cleanPropName = UTILS.cleanPropName($rObj.to_s);
                if (MEM._RESERVED_PROPS.indexOf(cleanPropName)==-1) {
                    this.PARAM_NAME=$rObj.to_s;
                }
            }

            //relon param name for this nObj
            else if ($rObj.r==MEM.REL_PARAM_NAME.temp_nid) {
                var cleanPropName = UTILS.cleanPropName($rObj.to_s);
                if (MEM._RESERVED_PROPS.indexOf(cleanPropName)==-1) {
                    this.REL_PARAM_NAME=$rObj.to_s;
                }
            }
            else if ($rObj.r==MEM.no_new_children.temp_nid && Boolean($rObj.to_s)==true) this.no_new_children=true;
            else if ($rObj.r==MEM.classes_only.temp_nid && Boolean($rObj.to_s)==true) this.classes_only=true;
            
        }

        else if ($rObj.type==TYPE_BE) {


            /********************/
            //ANNODE .from_text index
            //Our neurons tbl in ANNODE now stores the .text.
            //We send it over as from_text since it is a view tied to relons.
            //Relons do too, but for some node-made-neurons we don't make
            //the MEM.name-> relon.  We make a sponsor, or a BE class, etc.
            //Text comes through with the NARR record so process it here.
            //We only want to bother with TYPE_BE returns for the TEXT.. as it
            //will be on ALL RELONS in the NARR view. 
            if ($rObj.r!=MEM.name.temp_nid && $rObj.from_text!=undefined && $rObj.from_text.length) {
                if (this.text.length < $rObj.from_text.length) {
                    if (this.text=="") {
                        this.text = $rObj.from_text;
                    }
                    if (this.text==undefined) { 
                        this.text=""; //???
                    }

                    //we really should be storing "latest name" for MEM.name relons.
                    else {
                        //if (this.latest_name_relon.time > $rObj.time) {
                          //  this.addAkaManual(this.latest_name_relon.to_s);
                           // this.text = $rObj.from_text;
                        //}
                    }
                    
                }
            }

            if ($rObj.r==MEM.ANNE_DDS_SRC.temp_nid) {
                var toNObj = MEMG.getNeuronByTempNid($rObj.t);
                if (toNOBJ._gt!=null && this._gt==null) this.setGtRelon(toNObj._gt);    
                this.addAltBE($rObj);   
            }
        }

        else if ($rObj.type==TYPE_HAS) {
            //local memmanger ico propert
            // (easy access prop) for this version of the memory manager.
            if ($rObj.r==MEM.ai_ico_class.temp_nid) this.ai_ico=$rObj.to_s;
        }

        else if ($rObj.type==TYPE_SYS_MSG) {
            
            //pending relon to freeze a neuron 
            if ($rObj.r==MEM.CMD_FREEZE.temp_nid && $rObj.ghost==true) {
                var fromNOBJ = MEMG.getNeuronByTempNid($rObj.f);
                fromNOBJ.freeze=1;
            }
        }
    }


    /**
     * 
     * @param {*} $nameRelon 
     * @returns 
     */
    setLatestNameRelon = function($nameRelon) {
        if (this.latestNameRelon==null) {
            this.latestNameRelon = $nameRelon;
            return;
        }

        if ($nameRelon.time > this.latestNameRelon.time) {
            this.addAkaManual(this.latestNameRelon.to_s);
            this.latestNameRelon = $nameRelon;
        }
        else {
            this.addAkaManual($nameRelon.to_s);
        }
    }


    /**
     * Inherit important functions by class.
     * 
     * .requires_validation  -- this is for external relons that validate    
     * claims.                                                                  
     *
     * .set_value  -- this is to set the default .value of a neuron  
     * (or class of neurons) 
     *  
     * .formatter  -- this is to help format the value of an obj
     *  
     * .format_validator  -- this is for the value being good or bad according  
     * to desired form.  
     * 
     * These can be manually or programmatically set, and if set, they will
     * be inherited down the child tree.   As of now they cascade only by the
     * proper TYPE_BE reln: class/inst type parent/child relationshps, not the creative
     * TYPE_BE other relations using BE_CHILD and BE_PARENT handling (to build dynamic
     * trees and datasources).
     * 
     * NOTE: we also inherit _gt (a relon pointing to the garden type) here to cascade to all children.
     * There are quite a few other things inherited in a hierarchical structure
     * (including lateral BEs on INSTS which inherit params/has from the lateral BE).
     * Those are done run-time when needed.  These are setup ready to be used on the class
     * (not the instances) since the instances will call their class function.
     *  
     * GT is an exception --- we do that here (tho it is not a function) and it is cascaded
     * to all neurons in the BE parent/child tree.
     * 
     * NOTE2: The GT cascades ONLY TO HEIRARCHICAL CHILDREN not dynamic parent/child trees such
     * as the country tree... It uses the BE_PARENT and BE_CHILDREN pattern to inform us that
     * it makes a tree of "locations" which have a BE polity of "country".  This allows for the 
     * most flexible of heirarchies since we can generate the live and transform to various 
     * be tree structures without being locked in.   "AMERICA" or "AUSTRALIA" are countries, per say,
     * but in ANNE they are children of location.  Their parent is the location neuron.  We know
     * they are countries because they have a TYPE_BE polity-> country relon.
     * 
     * @params {Object} - the BE neuron object we inherit from.
     *  
     * @author {Mr.Scatman} 
     */
     __functInherit=function($beObj, $whatCalledThis="") {
        this._uico = undefined;

        //if (ANNE.SETTINGS && ANNE.SETTINGS.bUICOS==false) {
            
        //}
        
        //console.log("(__functInherit)")
        if (this.dead==true) return;
        if ($beObj==null) return;

        var child_props = new Object();
        if (this.ntype==NTYPE_CLASS) {
            if ($beObj.set_value!=undefined && this.set_value==undefined) {
                this.set_value=$beObj.set_value;
                child_props["set_value"]=$beObj.set_value;
            }
            if ($beObj.set_value2!=undefined && this.set_value2==undefined) {
                this.set_value2=$beObj.set_value2;
                child_props["set_value2"]=$beObj.set_value2;
            }
            if ($beObj.formatter!=undefined && this.formatter==undefined) {
                //console.log("%c"+$beObj.text+" formatter to push down to child", TALK.bggreen);
                if ($beObj.nid==this.nid && MEM.string.nid==this.nid){
                    //console.log("SETTING STRING FORMATTER");
                }
                this.formatter=$beObj.formatter;
                child_props["formatter"]=$beObj.formatter;
            }
            if ($beObj.format_validator!=undefined && this.format_validator==undefined) {
                this.format_validator=$beObj.format_validator;
                child_props["format_validator"]=$beObj.format_validator;
            }
            if ($beObj.requires_validation!=undefined) {
                this.requires_validation=true;
                child_props["requires_validation"]=this.requires_validation;
            }
            if ($beObj.fire_circuit!=undefined) {
                this.fire_circuit=$beObj.fire_circuit;
                child_props["fire_circuit"]=$beObj.fire_circuit;
            }

            //review this..
            if ($beObj.role_action!=undefined) {
                console.log("%c REVIEW THIS", TALK.bgred);
                this.role_action=$beObj.role_action;
                child_props["role_action"] = $beObj.role_action;
            }

            //will inform the platform what relon type to make with params using
            //this concept as a reln
            if ($beObj.target_type!=undefined) {
                this.target_type=$beObj.target_type;
                child_props["target_type"] = $beObj.target_type;
            }
        }

        //not a funct but we want to inherit these props too.
        if (this._gt==null) {
            if ($beObj._gt!=null) {
                this.setGtRelon($beObj._gt);
                child_props["_gt"]=$beObj._gt;
            }
        }
        else child_props["_gt"]=$beObj._gt;

        //gti
        if (this._gti==null) {
            if ($beObj._gti!=null) {
                this.setGtRelon($beObj._gti);
                child_props["_gti"]=$beObj._gti;
            }
        }
        else child_props["_gti"]=$beObj._gti;

        //if (this._uico!=undefined) {
            //child_props["_uico"]=this._uico;
        //}
        //else {
           // if ($beObj._uico!=undefined) {
                //this._uico=$beObj._uico;
                //child_props["_uico"]=this._uico;
            //}
        //}

        //nothing key functs (or gt) to inherit.
        if (this.children==null || this.children.length==0) return;

        var keys = Object.keys(child_props);
        if (keys.length>0) {
            var chain = [];
            this.cascadePropsDownChildrenClasses(child_props, chain);
            
            //console.log("chain of props for *****"+this.text+"***** ("+$whatCalledThis+")", chain);
        }
    }


    /**
     * recurse up the be line to generate the BEM nids.
     * @param {*} $arr 
     * @returns 
     */
    getBemNids = function($arr=[]) {
        var bem_nids = $arr;
        if (this.bes.length) {
            var beNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
            bem_nids.push(beNOBJ.nid);
            return beNOBJ.getBemNids(bem_nids);
        }
        return bem_nids;
    }


    /**
     * Look for the greatest firstseen value for a given reln (relationship).
     * Example:  find the most recent 'status' relon (a relon with reln:SL1C_status.nid).
     */
    getLastFirstSeen=function($r) {
        if (this.dead==true) return;
        var biggestFS = null;
        for (var r=0; r < this.outs.length; r++) {
            if (this.outs[r].r!=$r) continue;
            var rel = this.outs[r];
            if (rel.firstseen==undefined || rel.firstseen==null) continue;
            if (biggestFS==null) biggestFS = rel;
            if (rel.firstseen > biggestFS.firstseen) biggestFS = rel;
        }
        if (biggestFS!=null) return biggestFS.firstseen;
        return 0;
    }


    /**
     * @param {anne_neuron}
     * @returns {boolean}
     */
    getNameRelon=function($relNOBJ) {
        for (var r=0; r < this.outs.length; r++) {
            if (this.outs[r].r==$relNOBJ.temp_nid) return this.outs[r];
        }
        return null;
    }
    

    /**
     * Get the default class a param relon is looking to assign.
     * 
     * In normal params we point to the default class via using the reln and or the to.  Either can be used
     * to help us know what the default class of the param is.
     * 
     * With semantic clumps we use the to_s value.
     * 
     * Default class for a param using a ROLE in the reln is used with the to_s, but that is generalized at a high level.
     * 
     * To update or specify a more refined class we can use a TYPE_SYS relon and reference the param.
     * The referenced param the default class applies to is in the sys_ref_txid slot of the relon.
     * 
     * Here we lookup a default class nid for a given class and a given param.
     * This is needed for inherited params that cannot specify this info in the to_s because they are high level and the
     * downstream this value can change.  A param for ROLE_AFFECTED_THING is part of top-level action.  At the top-level it points
     * to an ec_thing.
     * 
     * That top-level action is the parent of a lower-level actions that inherits this parameter,
     * However, at lower levels the action may want/need to specify that the default class of value it points to is something 
     * different than just ec_thing.  
     * 
     * Example: In the case of marry the default class of the ROLE_AFFECTED_THING should be person.  People marry people.
     * We could just store again the relon for PARAM->ROLE_AFFECTED_THING to update it (make it more specific) in the marry 
     * neuron.  We can use either method to get the default.  This function is for the sys_ref_txid method.
     * 
     * @param {string} $ptxid - txid long string of the parameter txid. 
     * @returns 
     */
    getDefaultClassForParam=function($ptxid) {
        for (var r=0; r < this.outs.length; r++) {
            var rel = this.outs[r];
            if (rel.type!=TYPE_SYS) continue;
            if (rel.to_type!=TO_TYPE_ANNE) continue;
            if (rel.r!=MEM._default_class_nid.temp_nid) continue;
            if (rel.sys_ref_txid==undefined || rel.sys_ref_txid=="" || rel.sys_ref_txid!=$ptxid) continue;
            return rel.to_s;
        }
        var prel = MEMG.lookupRelonByTXID($ptxid);
        if (prel!=null) return prel.to_s;   //default param relon
        return null;
    }

    getRelnUsageChildren=function($type) {
        var to_nids = []
        for (var r=0; r < ANNE.MEM._aRelons.length; r++) {
            if (ANNE.MEM._aRelons[r].type!=$type) continue;
            if (ANNE.MEM._aRelons[r].reln!=this.nid) continue;
            if (ANNE.MEM._aRelons[r].to_type!=TO_TYPE_ANNE) continue;
            if (to_nids.indexOf(ANNE.MEM._aRelons[r].to_s)==-1) {
                to_nids.push(ANNE.MEM._aRelons[r].to_s);
            }
        }
        return ANNE.MEMG.getNObjsFromList(to_nids);
    }


    getNameRelon=function(){
        return MEMG.getBeRelon(this.outs, MEM.name.temp_nid);
    }

    /**
     */
    makeNameTempRelon=function($relNOBJ, $name) {
        if (this.dead==true) return;
        return MEM.makeTempRelon(nOBJ, TYPE_BE, $relNOBJ.nid, TO_TYPE_STRING, $name, true);
    } 
    
    /**
     * Is this neuorn an alt parent requirement for any other class?
     * 
     * Hierarchical parents in the BE tree  are not always the real (functional) 
     * hierarchical parent.  All countries, states, towns, villages (etc) are hierarchical 
     * children of "location". State, town, country .. etc.. however, are not SUB-CLASSES of 
     * location.  They are polities.  An instance of a country or state or city is not actually
     * and instance of those classes. They are instances of "location" but their functional parent 
     * is state, town or country.  This is specified with a BE_CHILD from country to "polity" and 
     * then the actual instances of location which ARE countries specify their polity with 
     * polity->country.  This tells ANNE the parent/child reln used is polity to define the actual
     * function parent.  
     * 
     * The BE_PARENT relon specifies that to be a country you must not only have the polity->country relon 
     * but also the neuron must be a child of location.   That relon, the "must be a child of location" is 
     * what we are looking for here. We want to find out if this neuron is being used for ANY 
     * alt be parental lineages. We can use that information to see reclassify the children of 
     * this neuron to their intended (functional) parent.
     */
    getParentAlts = function() {
        if (this.dead==true) return;
        var parent_alts = [];
        if (this.bes.length==0) return parent_alts;
        var beNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
        if (beNOBJ==null) return;
        //console.log("assessing ''"+this.text+"'' parent ''"+beNOBJ.text+"'' for BE PARENT in relons");
        //var audit = MEMG.getNeuronByNid("7775942183860735787");
        //console.log("audit "+audit.temp_nid+" == "+MEM.BE_PARENT.temp_nid)
        for (var i=0; i < beNOBJ.ins.length; i++) {
            if (beNOBJ.ins[i].r!=MEM.BE_PARENT.temp_nid) continue;
            parent_alts.push(beNOBJ.ins[i].f);
        }
        return parent_alts;
    }

    /**
     * We want this to honor the alt be parent line setup..
     * TODO
     */
    getFunctionalParentName = function() {
        if (this.bes.length==0) return "";
        var beNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
        if (beNOBJ==null) return;
        for (var i=0; i < beNOBJ.ins.length; i++) {
            if (beNOBJ.ins[i].r!=MEM.BE_PARENT.temp_nid) continue;
            var fBE = MEMG.getNeuronByTempNid(beNOBJ.ins[i].f);
            if (fBE!=null) return fBE.text;
        }
        return beNOBJ.text;
    }

    //if a user (any user) adopts a class -- they get ALL CHILDREN
    //of the class in their worldview.
    //This may already work with our children search and handling..
    //i will some cases.
    /** 
     * 
     * @author {Mr.Scatman} 
     */
    getAdoptClassChildren=function() {
        alert("TO DO");
    }


    /**
     * UNTESTED
     * 
     * We have a requirement of a relon.. to build a list of neurons.
     * Instead of building  the list of neurons then filtering..
     * We build the list via the filter.
     * user case:  we want a dropdown of all image ---- THAT a user is connected to.
     * I don't want to build the list of all images the filter. 
     * Better to just go to the user and connect to the images and build the list.
     * This could just be a simple function but this is called in a standardized area that 
     * most otherwise DOES want to just provide a list of children (all children).
     * 
     * Test this by connecting to some pictures in a persons neurons.
     * Then -- set the primaryNeuronImg and we should only be presented with a dropdown of 
     * the images that are tied to the neuron already.
     */
    getAllDownlineChildren_cdxFAST=function($cdxs, $downline, $bINSTS=true, $bTNIDLIST=true, $bDOALLBES=false, $bINSTSONLY=false) {
        console.log("%c doing optimized getAllDownlineChildren_cdxFAST", TALK.bgpurple);
        console.log($cdxs); 
        var cdx = $cdxs[0];
        var fromNOBJ = MEMG.getNeuronByNid(cdx.from_nid);
        var nObjs = [];
        var reln = cdx.reln;
        var type = cdx.type;
        var to_type = cdx.to_type;
        if (to_type!=TO_TYPE_ANNE) return [];
        var ntype = null;
        if ($bINSTSONLY) ntype=NTYPE_INST;
        for (var r=0; r < fromNOBJ.outs.length; r++) {
            var rel = fromNOBJ.outs[r];
            if (type!=null && rel.type!=type) continue;
            if (to_type!=null && rel.to_type!=to_type) continue;
            if (reln!=null && rel.reln!=reln) continue;
            var nObj = MEMG.getNeuronByTempNid(rel.t);
            if (MEM.tempBeIsA(nObj.temp_nid, this.temp_nid, ntype)==true) {
                if ($bTNIDLIST==true) $downline.push(nObj.temp_nid);
                else $downline.push(nObj);
            } 
        }
        return nObjs;
    }


    /**
     * UNTESTED;.
     */
    getAllDownlineChildren_cdx=function($cdxs, $downline, $bINSTS=true, $bTNIDLIST=true, $bDOALLBES=false, $bINSTSONLY=false) {
        if ($cdxs.length==1 && $cdxs[0].target_part=="to_s") {
            return this.getAllDownlineChildren_cdxFAST($cdxs, $downline, $bINSTS, $bTNIDLIST, $bDOALLBES, $bINSTSONLY);
        }
        var nObjs = this.getAllDownlineChildren($downline, $lvl, $bINSTS, false, $bDOALLBES, $bINSTSONLY);
        var nObjs_final = [];
        var tnids=[];
        for (var n=0; n<nObjs.length; n++) {
            var nObj = nObjs[n];
            //misc.child_cdx = [{from_nid:for_nOBJ.nid, reln:MEM.neuronImg.nid, to_s:null, type:null, to_type:TO_TYPE_ANNE, target_part:"to_s"}];
            var passed = MEM.enforceCDXS($cdxs, nObj);
            if (passed==false) continue;
            if (tnids.indexOf(nObj.temp_nid)!=-1) continue
            tnids.push(nObj.temp_nid);
            nObjs_final.push(nObj);
        }
        if ($bTNIDLIST==true) return tnids;
        return nObjs_final;
    }


    getClassChildren=function() {
        var downline = [];
        this.getAllDownlineChildren(downline, 0, false, true, false, false);
        return this.children;
    }


   /**
    * Get downline chilrden of a neuron.
    * 
    * We want to chase all the downline of a neuron and build an array..   
    * We want to chase all paths.   Also, if we have the bDOALLBES set we   
    * will snag any inbound relns to this neuron with a TYPE_BE that are   
    * not hierarchical children.                                         
    *                                                                     
    * @author {Mr.Scatman}
    * 
    * @param {*} $downline 
    * @param {*} $lvl 
    * @param {*} $bINSTS 
    * @param {*} $bTNIDLIST 
    * @param {*} $bDOALLBES 
    * @param {*} $bINSTSONLY 
    * @returns 
    */
    getAllDownlineChildren=function($downline, $lvl=0, $bINSTS=true, $bTNIDLIST=true, $bDOALLBES=false, $bINSTSONLY=false) {
        if ($lvl>16) return;
        if ($lvl==0) {
            //get other bes of this thing that are not hierarchical children.
            if ($bDOALLBES==true) {
                for (var i=0; i < this.ins.length; i++) {
                    var inRel = this.ins[i];
                    var childNOBJ = MEMG.getNeuronByTempNid(inRel.f);
                    if ($bINSTS==false && childNOBJ.ntype!=NTYPE_CLASS) continue;
                    if (childNOBJ.enforceGardenUp()==false) continue;
                    
                    if (inRel.type==TYPE_BE && inRel.r!=MEM.class.temp_nid && inRel.r!=MEM.inst.temp_nid) {
                        if ($bTNIDLIST==true) {
                            if ($downline.indexOf(inRel.f)==-1) $downline.push(inRel.f);
                        }
                        else $downline.push(childNOBJ);
                    }
                }
            }
        }

        //add these in if they haven't been done yet.
        //only add unique children.
        if (this['be_'+MEM.BE_CHILDREN.temp_nid]!=undefined) {
            var new_children = MEM.getChildrenDynamic(this, $bTNIDLIST, this.children);
            console.log(new_children);
        }

        if (this.children==null) return; //no more work to be done

        for (var c=0; c < this.children.length; c++) {
            var child_temp_nid = this.children[c];
            var childNObj = MEMG.getNeuronByTempNid(child_temp_nid);
            if (childNObj.enforceGardenUp()==false) continue;
            if ($bINSTS==false && childNObj.ntype!=NTYPE_CLASS) continue;
            if ($bTNIDLIST==true) {
                if ($downline.indexOf(child_temp_nid)==-1) $downline.push(child_temp_nid);
            }
            else $downline.push(childNObj);
            childNObj.getAllDownlineChildren($downline, $lvl+1, $bINSTS, $bTNIDLIST);
        }
        
        //to get inst only we still had to traverse the class tree.
        if ($lvl==0 && $bINSTSONLY==true) {
            var downline = $downline.concat();
            if (ANNE.SETTINGS.debug()==true) console.log("old downline", downline);
            $downline.length=0;
            if (ANNE.SETTINGS.debug()==true) console.log("audit:",$downline);
            for (var d=0; d < downline.length; d++) {
                var val = downline[d];
                //if we were in tnidlist mode, get the nObj and check
                //for inst only.
                if ($bTNIDLIST==true) {
                    var nObj = MEMG.getNeuronByTempNid(val);
                    if (nObj.ntype!=NTYPE_INST) continue;
                }
                else if (val.ntype!=NTYPE_INST) continue;  //not an instances
                $downline.push(val);    //a valid instance..
            }
            
            if (ANNE.SETTINGS.debug()==true) console.log("new downline", $downline);
            //$downline = downline.concat();   //swap out the array ref. (i miss C++ ptrs but this is close)
        }
        return;
    }



    getWikiPart = function() {
        return MEMG.getSysValue(this.outs, MEM.wikipart.temp_nid);
    }

    /**
     * We know the base of the wikipart but here we still look it up
     * to demonstrate how this can be done for any URL based + part.
     */
    getWikiURL = function() {
        var part = MEMG.getSysValue(this.outs, MEM.wikipart.temp_nid);
        if (part!=null) {
            var base = MEMG.getHasValue(MEM.wikipart.outs, MEM.base_url.temp_nid)
            if (base!=null) return base+part;
        }
        return null;
    }


    /**
     * Does this neuron have any ghosts relons?
     */
    hasGhostRelons=function(){
        for (var r=0; r < this.outs.length; r++) {
            if (this.outs[r].ghost==true) return true;
        }
        return false;
    }

    
    hasRelon=function($reln, $to_s) {
        for (var r=0; r < this.outs.length; r++) {
            if (this.outs[r].reln==$reln && this.outs[r].to_s==$to_s) return true;
        }
        return false;
    }


    /**
     * look for smart search relon .. or garden of free for all..
     */
    hasRelonTo=function($type, $to_s, $target) {
        if ($target==TARGET_NID) {
            var toNOBJ = MEMG.getNeuronByTempNid($to);
            var rels = MEMG.getRelonsTo(toNOBJ, $type, TO_TYPE_ANNE, $to_s);
            if (rels.length>0) return true;
        }
        else if ($target==TARGET_TXID) {
            var rels = MEMG.getRelonsToNaked($type, TO_TYPE_TXID, $to_s);
        }

        return false;
    }


    /**
     * look for smart search relon .. or garden of free for all..
     */
    isSmartSearch = function() {
        return true;
    }



    /***** MAKE functions for easy relon creation.
     * These support collab by using the from (this neuron) *****/
    
    /**
     * Make an abandon SYS relon
     * 
     * Abandon is only relevent on previously adopted classes/inst.  This severs
     * the adoption. This is only permitted by the 
     * owner OR delegated owner.  It is not permitted as a collaboration.
     *  
     * @author {Mr.Scatman}
     */
     _makeAbandon  = async($abandonNid)=> {
        if (this.dead==true) return;
        return await GHOSTDATA.new_ghost_sys(this, MEM.abandon, TO_TYPE_ANNE, $wvToDeny);
    }

    /**
     * Make an adopt SYS relon
     * 
     * This adopts a class or inst into this worldview.  This is only permitted by the 
     * owner OR delegated owner.  It is not permitted as a collaboration.
     * 
     * @author {Mr.Scatman}
     */
     _makeAdopt  = async($adoptNid)=> {
        if (this.dead==true) return;
        return await GHOSTDATA.new_ghost_sys(this, MEM.trusted_adopt, TO_TYPE_ANNE, $wvToDeny);
    }
    


    /**
     * Make an arbor prune SYS relon
     * 
     * This prunes a relon from your worldview.   If the relon being pruned is owned
     * by the sender or the sender has delegated owner rights, the relon will be
     * removed from all ANNE indexes and wiped from existence.
     * 
     * If you want to block/hide/ or remove something from view that is not yours,
     * use the inhibit relon.  This will instruct the memory handler to do a run-time
     * block of any relon you inhibit.   It is also useful when MIRRORING an inst with  
     * a MIRROR inst but wanting to negate a few data points (but otherwise keep all the others).
     * 
     * 
     * @author {Mr.Scatman}
     */
    _makeArborPrune=async($txid, $remove=true)=> {
        if (this.dead==true) return;
        if (typeof $txid === "object") {
            $txid = $txid.txid;
            console.log("fix this reference!  pass the txid, not the object!");
        }
        if ($txid==undefined || $txid==null || $txid=="") {
            console.log("bad txid");
            return;
        }
        var rel_to_delete = MEMG.lookupByTXID($txid);
        if (rel_to_delete==null) return;

        //no need for arbor prune if this is a ghost.
        //just delete the ghost.
        if (rel_to_delete.ghost==true) {
            await GHOSTDATA.deleteSingleGhostRelon($txid);
            return;
        }

        //we need an arbor prune..
        //we will make a GHOST arbor prune.
        //the user can broadcast it whenever they like. (or delete it and chg their mind.)
        //the arbor pruned relon is removed from RAM and the local DB.
        //If they change their mind they will delete the ghost and then 
        //upon refresh of the app they will get their relon back in local DB mem (and then RAM) again.
        var rel = await GHOSTDATA.new_ghost_sys(this, MEM.arbor_prune.nid, TO_TYPE_TXID, $txid);
        if ($remove==false) return rel;
        var removed_txids = [];
        this.removeByTXID("outs", $txid, removed_txids);

        var rel_to_ap = MEMG.lookupRelonByTXID($txid);
        if (rel_to_ap!=null) {
            if (rel_to_ap.to_type==TO_TYPE_ANNE) {
                var toNOBJ = MEMG.getNeuronByTempNid(rel_to_ap.t);
                if (toNOBJ!=null) toNOBJ.removeByTXID("ins", $txid, removed_txids);
            }
        }

        await ANNE.DB.___delete([$txid], "relons");
        return rel;
    }

   
    /**
     * Make a deny SYS relon.
     * 
     * Denies ability to send collab requests to the worldview.  This is relevant in the BLACKLIST
     * GARDEN of "communal" as the general public is whitelisted.  
     * 
     * Only relevant when supplying a let on a owned class or a class one has
     * delegation rights to.  Otherwise, collabs of the SYS variety are NOT permitted.
     * 
     * 
     * @author {Mr.Scatman}
     */
     _makeDeny  = async($wvToDeny)=> {
        if (this.dead==true) return;
        return await GHOSTDATA.new_ghost_sys(this, MEM.deny_wv, TO_TYPE_ANNE, $wvToDeny);
    }

    
    /**
     * Make an inhibit SYS relon.
     * 
     * A lighter version of Arbor Prune which does not blot things out of existence.
     * This will handle the inhibit of a relon at run-time in the memory handler.  It is a way
     * to cleanup your view of other worldviews without altering their worldview.
     *
     * @author {Mr.Scatman}
     */
     _makeInhibit=async($txid)=> {
        if (this.dead==true) return;
        //we could do some validation here to make sure the $txid exists
        var rObj = await GHOSTDATA.new_ghost_sys(this, MEM.inhibit_relon.nid, TO_TYPE_TXID, $txid);
    }


    /**
     * Make a let SYS relon.
     * 
     * Only relevant when supplying a LET on a owned class or a class one has
     * delegation super to.  Otherwise, collabs of the SYS variety are NOT permitted.
     * 
     * LETS are relevant in the WHITELIST of COLLAB-OWNER.  Only worldviews LET will have
     * the ability to send collab requests.
     * 
     * @author {Mr.Scatman}
     */
     _makeLet = async($wvToLet)=> {
        if (this.dead==true) return;
        return await GHOSTDATA.new_ghost_sys(this, MEM.let_wv, TO_TYPE_ANNE, $wvToLet);
    }


    /**
    * @author {Mr.Scatman}
    */
    _makeSelfName = async($name)=> {
        if (this.dead==true) return;
        if ($name==undefined || $name==null || $name=="") {
            console.log("name cannot be empty");
            console.log("%c NAME CANNOT BE EMPTY", TALK.bgred);
            return null;
        }
        var rObj = await ANNE.GHOSTDATA.new_ghost_be(this, MEM.name.nid, TO_TYPE_STRING, $name);
    }


    /**
     * This will only create a ghost.  The user has to send that ghost to ANNE to make it real.
     * @author {Mr.Scatman}
     */
     _makeSelfIdentity = async ($identity_class_of, $bSINGLESEND=true)=> {
        if (this.dead==true) return;
        if ($identity_class_of=="") {
            console.log("identity class cannot be empty");
            return null;
        }
        var futureBE = ANNE.MEMG.getNeuronByNid($identity_class_of);

        if (this.bes.length>0 && this.bes[0]==futureBE.temp_nid) {
            return null; //this is already done.
        }
        return await ANNE.GHOSTDATA.new_ghost_be(USER._userNObj, MEM.inst.nid, TO_TYPE_ANNE, futureBE.nid);
    }


    /**
     * Make a necrosis SYS relon.
     * 
     * Completely nuke a neuron and all its outs and ins from existence.  Sender must be
     * the author or approved delegation author (with super rights) to submit necrosis SYS relons.
     * 
     * Collab does not otherwise accept SYS relons.
     * 
     * @author {Mr.Scatman}
     */
    _makeNecrosis=async($nObj)=> {
        if (this.dead==true) return;
        //we can safely nuke this in local mem after it returns back from broadcast.
        return await GHOSTDATA.new_ghost_sys(this, MEM.necrosis.nid, TO_TYPE_ANNE, $nObj.nid);
    }
    
    //_fixName("13664565417915800120", "oracle data run")
    _fixName=async($nid, $newName)=>{
        var fNOBJ = ANNE.MEMG.getNeuronByNid($nid);

        var rel_name = fNOBJ.getNameRelon(MEM.name);
        if (rel_name==null) return;
        
        var rel = await ANNE.GHOSTDATA.new_ghost_sys(fNOBJ, MEM.arbor_prune.nid, TO_TYPE_TXID, rel_name.txid);
        await SENDQ.addRelonToSendQ(rel, false, TXB.TXTYPE_CHILD_RELON);
        
        var newrel = await ANNE.GHOSTDATA.new_ghost_be(fNOBJ, MEM.name.nid, TO_TYPE_STRING, $newName);
        await SENDQ.addRelonToSendQ(newrel, false, TXB.TXTYPE_CHILD_RELON);

        await ANNE.SENDQ.___sendQueue(($msg="update name")=>{
        });
    }

    printBes = function() {
        var bes_text = [];
        for (var b=0; b < this.bes.length; b++) {
            var beNOBJ = MEMG.getNeuronByTempNid(this.bes[b]);
            bes_text.push(beNOBJ.text+" nid:"+beNOBJ.nid);
        }    
        var str =  bes_text.join(" :: ");
        console.log(str);
        return str;
    }
    

    /**
     * 
     */
    printRights = async()=> {
        if (this._govenor==null) await this.setGovRights(USER._userNObj);
        this._govenor.printRights();
    }


    /**
     */
    printBeParentage = function() {
        //console.log("print be parentage for "+this.text+" nid:"+this.nid+" be_lvl:"+this.be_lvl);
        var beNOBJ = null;
        if (this.bes.length==0) return;
        beNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
        while(beNOBJ) {
            //console.log("be_lvl:"+beNOBJ.be_lvl+" "+beNOBJ.text+" nid:"+beNOBJ.nid);
            beNOBJ = MEMG.getNeuronByTempNid(beNOBJ.bes[0]);
        }
    }
    

    fixBeLvls = function() {
        return; //this doesn't make sense when we don't have the full graph with the new JS optimized attempt.
        if (this.dead==true) return false;
        if (this.be_lvl!=-1) return false;
        var beNOBJ = null;
        if (this.bes.length==0) return false;
        beNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
        while(beNOBJ.be_lvl==-1) {
            //console.log(beNOBJ.text+" nid:"+beNOBJ.nid+" be_lvl:"+beNOBJ.be_lvl);
            beNOBJ = MEMG.getNeuronByTempNid(beNOBJ.bes[0]);
            if (beNOBJ==null) {
                //console.log("vat is zis? "+this.nid+ " "+this.text);
                break;
            }
        }

        if (beNOBJ && beNOBJ.be_lvl!=-1) {
            beNOBJ.cascadeChildrenBeLevels();
            return true;
        }
        
        return false;
    }


    /**
     * take a child out of the children array
     * 
     * DONE
     */
     removeChild=function($child_temp_nid) {
        if (this.children==null) return;
        for (var c=0; c<this.children.length; c++) {
            if (this.children[c]==$child_temp_nid) {
                this.children.splice(c,1);
                return;
            }
        } 
    }
    

    /**
     * Remove a parent nid from the bes in-RAM-MEM array and unset the .parent prop.
     * 
     * @author {Mr.Scatman}
     *    
     */
     removeParentFromChild=function($parent_temp_nid, $bGRANNYTAKESOVER=false) {
        this.parent = "";  //quick ptr set by ANNODE on relons.
        if (this.bes.length<=1) return;

        //remove the be out of the bes array.
        for (var b=0; b < this.bes.length;b++) {
            if (this.bes[b]==$parent_temp_nid) {
                this.bes.splice(b, 1);
                break;
            }
        }
        this.be="";

        //RETEST THIS !!!!!

        if ($bGRANNYTAKESOVER==true) {
            var parentNOBJ = MEMG.getNeuronByTempNid($parent_temp_nid);
            if (parentNOBJ!=null) {
                var grandpaNOBJ = MEMG.getNeuronByTempNid($parent_temp_nid);
                if (grandpaNOBJ==null) {
                    this.be_lvl = 0;
                    this.cascadeChildrenBeLevels();
                }

                //set the children be levels properly.
                else {
                    this.be_lvl = grandpaNOBJ+1;
                    this.cascadeChildrenBeLevels();
                }
            }
            else {
                this.be_lvl = 0;
                this.cascadeChildrenBeLevels();
            }
        }
        else {
            this.be_lvl = 0;
            this.cascadeChildrenBeLevels();
        }
    }


    /**  
     * Remove a relon from an array.
     * 
     * This is only used on nObj arrays (not the master MEM._aRelons), safe to do as-is. 
     * 
     * @author {Mr.Scatman} 
     */
     removeByTXID=function($arrName, $txid, $removed_txids=[]) {
        var arr = this[$arrName];
        if (arr==undefined || arr==null) return;
        for (var r=0; r < arr.length; r++) {
            if (arr[r].txid==$txid) {
                if ($removed_txids.indexOf(arr[r].txid)==-1) {
                    $removed_txids.push(arr[r].txid);
                }
                arr.splice(r, 1);
                return true;
            }
        }
        console.log("%c (removeByTXID) didn't find "+$txid, TALK.bgred);
        return false;
    }


    /** 
     * Set the primary hierarchical INST/CLASS be.
     * 
     * Critical to building our primary DAG TYPE_BE class/inst parent/child structure.
     * 
     * ANNE is multi-dimensions as this is merely one dimension, albeit an imortant one.
     * In ANNE there is ONE and **ONLY** ONE hierarchical parent.  This grafts the neuron into the
     * primary BE tree.  Other TYPE_BE relons exist and further define neurons and give them
     * access to "alt" structures.  The primary TYPE_BE relon has a reln of MEM.class.nid or 
     * MEM.inst.nid and the relon.to_s of that relon (which is the hierarchical parent) will 
     * be put in the .parent of the nObj. The temp_nid of the parent will be put into slot 0 of 
     * the nObj.bes array.  All other bes can be found in the .bes array, but after slot [0].
     * 
     * Example.  You are an identity.  Maybe u are a corporation, or an individual, a miner, or a silicon-based intelligence.
     * Whatever the case, your identity neuron points with a TYPE_BE relon reln:MEM.inst.nid to the value of your
     * identity class.  You are an instance of that class (which itself is a sub-class of MEM.identity).  
     * 
     * You may also be many other things.
     * 
     * Maybe you are a father, a mother, a programmer, an ice skater, an ornithologist or maybe
     * a sommelier!  These are also defininig about you but they are not your primary BE class.  These 
     * are TYPE_BE relons too in ANNE but they are alt TYPE BES since their reln will NOT be MEM.class.nid or
     * MEM.inst.nid.  The relon.reln will be something else... (even the generic MEM.ec_is.nid).
     * 
     * There are javascript BE .props made following the syntax nObj."be_%temp_nid%".  (see nObj.addAltBe) 
     * This is to support property/json key/pair notation for easy access in apps.  
     * If you want the polity BE value of a location (which has a relon of some location->polity->some polity value)
     * you can grab the relon or look for  nObj["be_"+MEM.polity.temp_nid].  For the country 
     * United States of America that value will be MEM.country.temp_nid.
     * 
     * nObj.bes[0] will always be the temp_nid of the hierarchical parent.
     * .parent will always be the .nid of the heirarchcal parent. 
     * .be will be a quick text of the hierarchical parent.  (we could nix this for RAM saving)
     * 
     * 
     * @author {Mr.Scatman} 
     */
    setBeTempNid=function($be_tnid) {
        if (this.dead==true) return;
        if (typeof $be_tnid==="object") $be_tnid = $be_tnid.temp_nid;
        if (typeof $be_tnid!=="number") {
            console.log("error with be_nid"); 
            return;
        }

        if ($be_tnid==MEM.class.temp_nid) {
            this.be_lvl=3;
            this.be = "class";
            this.ntype = NTYPE_CLASS; //ideally we'd take the text of the neuron
            this.addUniqueBe_fastIndex(MEM.class);
            return;
        }

        var parentNOBJ = MEMG.getNeuronByTempNid($be_tnid);
        this.addUniqueBe_fastIndex(parentNOBJ);
    }


    /** 
     * 
     * @param {*} $beObj 
     * @author {Mr.Scatman} 
     * @returns 
     */
     setBeLevel=function($beObj) {
        if (this.dead==true) return;
        if ($beObj.be_lvl>-1) this.be_lvl = $beObj.be_lvl+1;       //set the children levels off of the parent
        else if (this.be_lvl>-1) { 
            if ($beObj.be_lvl==-1) $beObj.be_lvl = this.be_lvl-1;  //set the parent from the child, do the grandchildren
        }
        else { //we have no reliable lvl information yet.
            this.be_lvl = -1; 
            return;
        }
        if (this.children==null) this.children=[];
        var child_lvl =  this.be_lvl+1;
        for (var c=0; c < this.children.length; c++) {
            var child = MEMG.getNeuronByTempNid(this.children[c]);

            if (child==undefined) continue;
            child.be_lvl = child_lvl;
            child.cascadeChildrenBeLevels();
        }
    }


    /** 
     * Set the BE TREE BE_LVL of this neuron.
     * 
     * @author {Mr.Scatman} 
     */
    setChildrenBeLevels=function() {
        if (this.dead==true) return;
        if (this.children!=null && this.children.length) {
            var child_lvl =  this.be_lvl+1;
            for (var c=0; c < this.children.length; c++) {
                var child = MEMG.getNeuronByTempNid(this.children[c]);
                child.be_lvl = child_lvl;
            }
        }
    }


    /**
     * 
     * @returns 
     */
    setIsIdentity = function() {
        if (this.dead==true) return;
        this.bISIDENTITY = MEM.tempBeIsA(this.temp_nid, MEM.identity.temp_nid, NTYPE_INST);
    }


    /**
     * 
     * @returns 
     */
    cascadeChildrenBeLevels=function() {
        if (this.dead==true) return;
        if (this.children!=null && this.children.length) {
            var child_lvl =  this.be_lvl+1;
            for (var c=0; c < this.children.length; c++) {
                var child = MEMG.getNeuronByTempNid(this.children[c]);
                child.be_lvl = child_lvl;
                child.setChildrenBeLevels();
            }
        }
    }


    /** 
     * 
     * @author {Mr.Scatman} 
     */
     setGtRelon=function($gtRelon) {
        if (this.dead==true) return;
        //safety check for GT inherit rule.
        var realGTFromNOBJ = MEMG.getNeuronByTempNid($gtRelon.f);
        if (realGTFromNOBJ==null) {
            alert("bad");
            return;
        }

        //test if this is lower or higher
        if (this._gt!=null) {
            var existingBeLVL = this.getGtLvl();
            if (existingBeLVL > realGTFromNOBJ.be_lvl) {
                //alert("exit");
                return;
            }
        }
        this._gt = $gtRelon; //accept new one (lowest most accurate down the tree).
    }

    /**
     * 
     * @param {*} $gtRelon 
     * @returns 
     */
    setGtiRelon=function($gtRelon) {
        if (this.dead==true) return;
        //safety check for GT inherit rule.
        var realGTiFromNOBJ = MEMG.getNeuronByTempNid($gtRelon.f);
        if (realGTiFromNOBJ==null) {
            alert("bad");
            return;
        }

        //test if this is lower or higher
        if (this._gti!=null) {
            var existingBeLVL = this.getGtiLvl();
            if (existingBeLVL > realGTiFromNOBJ.be_lvl) {
                //alert("exit");
                return;
            }
        }
        this._gti = $gtRelon; //accept new one (lowest most accurate down the tree).
    }


    getGtRelon=function() { return this._gt; }
    getGtiRelon=function() { return this._gti; }
    getGtLvl=function() {
        if (this._gt==null) return -1;
        var nObj = MEMG.getNeuronByTempNid(this._gt.f);
        if (nObj==null) return -1;
        return nObj.be_lvl;
    }


    /**  
     */
    getGtiLvl=function() {
        if (this._gti==null) return -1;
        var nObj = MEMG.getNeuronByTempNid(this._gti.f);
        if (nObj==null) return -1;
        return nObj.be_lvl;
    }


    /**  
     */
    getParent = function() { 
        if(this.bes.length==0) return null;
        else return MEMG.getNeuronByTempNid(this.bes[0]); 
    }
    

    /**
     * Get runtime relons according to ANNE protocol.
     * Default types used if no types passed
     */
    getAllRelons = async($bPRINT=true, $types=null)=>{
        return await this.getRuntimeRelons($bPRINT, $types);
    }


    /**
     * Get the run-time relons according to protocol rules.
     * @param {Boolean} $bPRINT 
     * @param {Array} $types 
     * @returns 
     */
    getRuntimeRelons = async($bPRINT=true, $types=null)=> {
        var all_relons = await MEMG.getRuntimeRelons(this.nid, $types);
        var txids = [];
        for (var a=0; a < all_relons.length; a++) {
            if (txids.indexOf(all_relons[a].txid)==-1) txids.push(all_relons[a].txid);
        }

        //make sure our outs are in this runtimerelons  (all types, not just $types)
        for (var r=0; r < this.outs.length; r++) {
            if (txids.indexOf(this.outs[r].txid)==-1) {
                all_relons.push(this.outs[r]);
                txids.push(this.outs[r].r);
            }
        }  
        if ($bPRINT==true) ANNE.TALK.printRelons(all_relons);
        return all_relons;
    }


    /**
     * 
     * @param {*} $owned_tnid 
     * @returns 
     */
    _removeOwns=function($owned_tnid){
        if (this.dead==true) return;
        if (this.owns==undefined) return;
        var ii = this.owns.indexOf($owned_tnid);
        if (ii>-1) this.owns.splice(ii,1);
    }


    /**
     * 
     * @param {*} $sponsored_by_tnid 
     * @returns 
     */
    _removeSponsoredBy=function($sponsored_by_tnid) {
        if (this.dead==true) return;
        if (this.my_sponsored==undefined) return;
        var ii = this.my_sponsored.indexOf($sponsored_by_tnid);
        if (ii>-1) this.my_sponsored.splice(ii,1);
    }


    /** 
     * @param {string}
     * @author {Mr.Scatman} 
     */
    setOwner=function($owned_by) {
        if (this.dead==true) return;
        if (typeof $owned_by==="string") this.owned_by = $owned_by;
        else if (typeof $owner==="object") {
            if ($owned_by.nid!=undefined) {
                this.owned_by=$owner.nid;
            }
        }
        else if (ANNE.USER._userNObj.nid) this.owned_by = USER._userNObj.nid;
        else this.owned_by="";
    }


    /**
     * Set the value of a neuron with its set_value function
     * run-time funct to utilize any set_value functions we have on our TT
     * @author {Mr.Scatman}
     *
     */
     __setValueOfNeuron=function($beNOBJ, $TTSYSOBJ=null) {
        if (this.dead==true) return;
        if (this.ntype==NTYPE_CLASS) return;

        //set the value first..  if there is a be class set_value function.
        if (this.set_value!=undefined) this.set_value(this);
        
        else if ($beNOBJ!=null && $beNOBJ.set_value!=undefined) {
            $beNOBJ.set_value(this);
            this.set_value = $beNOBJ.set_value;
        }

        //set the value first.. if there is a TTSYSOBJ set_value function.  
        else if ($TTSYSOBJ!=null && $TTSYSOBJ.set_value!=undefined) {
            $TTSYSOBJ.set_value(this);
            $beNOBJ.set_value = $TTSYSOBJ.set_value;
            this.set_value = $beNOBJ.set_value;
        }

        //next do the validator
        if (this.format_validator!=undefined) this.format_validator(this); 
        else if ($beNOBJ!=null && $beNOBJ.format_validator!=undefined) {
            $beNOBJ.format_validator(this);    
            this.format_validator=$beNOBJ.format_validator;
            if (this.nid=="7777506478065484896" || $beNOBJ.nid=="7777506478065484896") {
                console.log("TEST HERE");
            }
        }
        else if ($TTSYSOBJ!=null && $TTSYSOBJ.format_validator!=undefined) {
            $TTSYSOBJ.format_validator(this);
            this.format_validator=$TTSYSOBJ.format_validator;
            if (this.nid=="7777506478065484896") {
                console.log("TEST HERE");
            }
        }
        return;
    }

    /**
     */
    topClass = function() {
        if (this.bes.length) {
            var nObj = MEMG.getNeuronByTempNid(this.bes[0]);
            while(nObj.be_lvl>0) {
                nObj = MEMG.getNeuronByTempNid(nObj.bes[0]);
            }
            return nObj.nid;
        }
        return this.nid;
    }



/***** COLLAB AND GARDEN STUFF ******/



    /**
     * Get the WV for a query.
     * 
     * The WV scope for a neuron is the owner of the nid.
     * This can only be extended by the nid in question having
     * adopts registered.  Adopted nids are grafted in to the worldview.
     * 
     * The exception is FREE FOR ALL.  If This is a FREE FOR ALL garden then 
     * there is no WV enforced for queries.
     * 
     * @author {Mr.Scatman}  
     */
     getWVForQuery=function() {
        if (this.emulated==true) {
            console.log("There is no results when querying emulated neurons.  They aren't real.  They were .... emulated.");
            return null;
        }
        if (this.ntype==NTYPE_INST) {
            console.log("this function is not needed to directly query instances");
            return null;
        }

        //if (this._gt!=null && this._gt.t==MEM.gt_free_for_all.temp_nid) {
           // console.log("free for all!  no worldview enforced");
           // return [];
       // }

        if (this.bCHASED_min==false && this.preloaded==false) {
            console.log("FRENLY WARNING :: YOU SHOULD HAVE ATLEAST CHASED THE MIN ON THIS NOBJ BEFORE THIS");
        }

        if (this.trusted_adopt!=null && this.trusted_adopt.length) return this.trusted_adopt.concat(this.owned_by);
        return [this.owned_by];
    }
       

    /** 
     * 
     * NOT IN USE IN EXT??? 
     * 
     * Get the valid params for collab..
     * 
     * This can help buiid guis.
     * 
     * @param {anne_neuron} - The identity we are assesssing access rights for.
     * @param {array} - An array of neurons which are the params (relns of relons) we want to check for access to.
     * @author {Mr.Scatman}
     * 
     */
     getParamsValidForCollab=async($identityNObj, $param_nids)=> {
        await this.setGovRights($identityNObj);

        //any is fine.
        if (this.egrs_tnids==null || this.egrs_tnids.length==0) return $param_nids;

        var valid_param_temp_nids = [];
        for (var p=0; p < $param_nids.length; p++) {
            if (this.egrs_tnids.indexOf($param_nids[p])!=-1) valid_param_temp_nids.push(param);
        }
        return valid_param_temp_nids;
    }


    /** 
     * Return a friendly message for collab status.
     */
    getCollabStatusMsgHTML =async()=> {
        if (this._govenor==null) await this.setGovRights(USER._userNObj);
        var statusStr = govenor.actionText[this.collab_ACTION];
        if (this.collab_ACTION==govenor.COLLAB_REQ_AUTOREJECT) {
            return "<div class='red-garden'>"+statusStr+"</div>";
        }
        else if (this.collab_ACTION==govenor.COLLAB_NOCOLLABIDENTITY) {
            return "<div class='red-garden'>"+statusStr+"</div>";
        }
        else if (this.collab_ACTION==govenor.COLLAB_REQ_NO_COLLAB_RIGHTS) {
            return "<div class='red-garden'>"+statusStr+"</div>";
        }
        else if (this.collab_ACTION==govenor.COLLAB_REQ_OK) {
            return "<div class='green-garden'>"+statusStr+"</div>";
        }
        else if (this.collab_ACTION==govenor.DELEGATE_NOW) {
            return "<div class='yellow-garden'>"+statusStr+"</div>";
        }
        else if (this.collab_ACTION==govenor.SELF_OWNED) {
            if (this.ghost==true) {
                return "<div class='ghost-garden'>"+statusStr+"</div>";
            }
            return "<div class='green-garden'>"+statusStr+"</div>";
        }
        else if (this.collab_ACTION==govenor.THIS_IS_YOU) {
            if (this.ghost==true) {
                return "<div class='ghost-garden'>"+statusStr+"</div>";
            }
            return "<div class='green-garden'>"+statusStr+"</div>";
        }
    }

    isAltBe=function($temp_nid) {
        if (this['be_'+$temp_nid]!=undefined) return true;

        //TEMPORARY AUDIT!!
        if (this.bes.indexOf($temp_nid)!=-1) {
            console.log("fix this -- why is nt there a quick be_?");
            return true;
        }

        return false;
    }

    //convienance for debugging.
    printGhosts=function(){
        var ghosts = [];
        for(var g=0; g < this.outs.length; g++) {
            var rel = this.outs[g];
            if (rel.ghost==true) ghosts.push(ghost);
        }
        ANNE.TALK.printRelons(ghosts);
    }

    printBes=function($outs=null) {
        var bes = [];
        if ($outs==null) $outs = this.outs;
        for(var p=0; p < this.outs.length; p++) {
            var rel = this.outs[p];
            if (rel.type==TYPE_BE) bes.push(rel);
        }
        ANNE.TALK.printRelons(bes);
    }

    /**
     * 
     * @param {Array} $outs - optional, if not provided, uses only outs from this neuron 
     */
    printParams=function($outs=null) {
        var params = [];
        if ($outs==null) $outs = this.outs;
        for(var p=0; p < this.outs.length; p++) {
            var rel = this.outs[p];
            if (rel.type==TYPE_PARAM) params.push(rel);
        }
        ANNE.TALK.printRelons(params);
    }


    printChildren=function(){
        for (var c=0; c < this.children.length; c++) {
            var child = MEMG.getNeuronByTempNid(this.children[c]);
            console.log("child - "+child.text);
        }
    }

    
    /**
     * For debugging specific relon types+relns.
     * @param {*} $type - the relone type
     * @param {*} $r - the temp nid for the reln (not the nid)
     */
    printRelonsTypeAndReln=function($type, $r) {
        for (var r=0; r < this.outs.length; r++) {
            if (this.outs[r].r!=$r) continue;
            if (this.outs[r].type!=$type) continue;
            ANNE.TALK.printRelon(this.outs[r]);
        }
    }


    printSysRelons=function($plainText=true, $bDOTEMPNIDS=false, $consoleColor=-1) {
        this.printOnlyRelons(TYPE_SYS, $plainText=true, $bDOTEMPNIDS=false, $consoleColor=-1)
    }
    printSysMsgRelons=function($plainText=true, $bDOTEMPNIDS=false, $consoleColor=-1) {
        this.printOnlyRelons(TYPE_SYS_MSG, $plainText=true, $bDOTEMPNIDS=false, $consoleColor=-1)
    }
    printOnlyRelons=function($TYPE, $plainText=true, $bDOTEMPNIDS=false, $consoleColor=-1) {
        ANNE.TALK.printOnlyRelons($TYPE, this.outs, $plainText, $bDOTEMPNIDS, $consoleColor);
    }

    printRelons = function() {
        ANNE.TALK.printRelons(this.outs);
    }


    printParentLine=function() {
        var safety=16;
        console.log("%cPRINT PARENT LINE", TALK.bgblack);
        var nObj = this;
        while(nObj!=null && ((safety--)>0)) {
            console.log("%c"+nObj.text+" %c > be lvl "+nObj.be_lvl, TALK.green, TALK.black);
            nObj = nObj.getParent();
        }
    }

    printInsAndOuts=function() {
        this.printIns();
        this.printRelons();
    }

    printIns=function() {
        ANNE.TALK.printRelons(this.ins);
    }
    printOwns=function() {
        ANNE.TALK.printFromTempNidArray(this.owns);
    }



    /** 
     * NOT IN USE FOR EXT, use via console.
     * 
     * For quick debugging of this most epic adventure.
     * 
     * @author {Mr.Scatman} 
     */
    printGardenDebug=async()=> {
        this._govenor = null;   //redo this everytime to help us test.

        await this.setGovRights(USER._userNObj, true);
        console.log("govenor action for "+this.text+" ::"+govenor.actionText[this.collab_ACTION]);
        
        if (this.delegation) ANNE.TALK.printRelons(this.delegation);

        if (this.collab_ACTION >= govenor.COLLAB_REQ_OK) {
            if( this.egrs_tnids!=null && this.egrs_tnids.length) {
                for (var c=0; c < this.egrs_tnids.length; c++) {
                    var nObj = MEMG.getNeuronByTempNid(this.egrs_tnids[c]);
                    console.log("collab param ok if param: "+nObj.text);
                }
            }
            else console.log("any reln ok for collab req");
        }
       
        if (this.collab_ACTION >= govenor.DELEGATE_NOW) {
            if (this._govenor.dr_restrict_reln_tnids!=null && this._govenor.dr_restrict_reln_tnids.length) {
                for (var p=0; p < this._govenor.dr_restrict_reln_tnids.length; p++) {
                    var nObj = MEMG.getNeuronByTempNid(this._govenor.dr_restrict_reln_tnids[p]);
                    console.log("delegation param ok if param: "+nObj.text);
                }
            }
            else {
                console.log("all relns ok for delegation");
            }
        }
    }

            
    /**
     * 
     * Can this identity collab/delegate on this nObj?
     * 
     * NOTE: used by ANNET.initInfoTabData
     * 
     * @param {anne_neuron} - The identity neuron we are assessing access for.
     * @param {boolean} - Force a redo of the govenor even if we've done it for this user.
     * 
     * @author {Mr.Scatman}
     */
     setGovRights=async($identityNObj, $bFORCEREDO=false)=> {
        if (($identityNObj instanceof anne_neuron) == false) {
            throw "you must pass an anne_neuron as the identityNObj";
        }
        return await this._setGovenorForUser($identityNObj);
    }


    /**
     * If this user is the last applied for identity in the govenor, redo it.
     * If it isn't done yet, do it.
     * 
     * @param {anne_neuron} - user neuron to apply this govenor to
     * @return {integer} - action code
     */
    _setGovenorForUser=async($userNOBJ)=> {
        this._govenor = new govenor(this);
        await this._govenor.applygardenRulesForIdentity($userNOBJ.nid);
        return this._govenor.action;
    }


    /**
     * snag the class description relon (if it exists)
     * @returns 
     */
    getClassDesc = function() {
        if (this.ntype==NTYPE_INST) return ""; //we could look at the parent for this
        var rel = ANNE.MEMG.getRelonFromWithRToType(this.outs, TYPE_SYS, ANNE.MEM.class_desc.temp_nid, TO_TYPE_BLOB);
        if (rel!=null) return rel.to_s;
    }


    anyBe = function($classNOBJ) {
        if ($classNOBJ==null) return false;
        if (this.bes.indexOf($classNOBJ.temp_nid)!=-1) return true;
        return false;
    }
    
    /**
     * 
     * @param {*} $classNOBJ 
     * @returns 
     */
    is = function($classNOBJ) {
        if ($classNOBJ==undefined || $classNOBJ==null) {
            console.log("hunt this down");
            return false;
        }
        var nid = "";

        //derp mistakes.
        if (($classNOBJ instanceof anne_neuron) == false) {
            console.log("fix this -- pass the nOBJ not the nid");
            if (typeof $classNOBJ==="string") $classNOBJ = MEMG.getNeuronByNid(nid);
            else if (typeof $classNOBJ==="object") {
                if ($classNOBJ.nObj!=undefined) {
                    $classNOBJ = $classNOBJ.nObj;
                }
            }            
            if ($classNOBJ==undefined || $classNOBJ==null) return false;
        }

        return MEMG.beIsA(this, $classNOBJ.temp_nid);
    }


    isT = function($temp_nid) {
        return MEMG.beIsA(this, $temp_nid);
    }
    

    /**
     * 
     * @param {*} $tnids 
     * @returns 
     */
    isMultiT = function ($tnids) {
        for (var t=0; t < $tnids.length; t++) {
            if (this.isT($tnids[t])==true) return true;
        }
        return false;
    }
    

    /**
     * called for the identity using ANNE...
     */
    isAndyForThisRelon=async($relon)=> {
        var fNOBJ = MEMG.getNeuronByTempNid($relon.f);
        if (fNOBJ==null) return false;
        return await fNOBJ.userIsAndyForThisRelon(this, $relon);
    }


    /**
     * We have an ANDY with ANDY rights to a neuron..
     * but can they administer THIS particular relon?
     */
    userIsAndyForThisRelon=async($identityNOBJ, $relon)=> {
        var ttxtype =await this.validateCollabReq($identityNOBJ, $relon.r);
    
        if (ttxtype==TXB.TXTYPE_COLLAB_REQ_EXP_DEL) return true;    //we're delegated admin for this
        if (ttxtype==TXB.TXTYPE_CHILD_RELON) return true;           //we own this.
            
        return false;
    }


    /**
     * @author {Mr.Scatman}
     */ 
    validateCollabReq=async($identityNObj, $target_reln_temp_nid)=> {
        if (this._govenor == null) this._govenor = new govenor(this);
        if (this._govenor._applied_for_identity_nid==null) await this._govenor.applygardenRulesForIdentity($identityNObj.nid);
        return await this._govenor.isValidCollabReq($identityNObj.nid, $target_reln_temp_nid);    
    }



    /** 
     * EXT NO USING THIS???
     * 
     * Validate a collaboration request response.
     * 
     * Use the govenor to determine if this admin is actually and admin
     * and if the collab  request is legit.
     * 
     * @author {Mr.Scatman} 
     */
    validCollabRespAction=async($admin_nid, $tnid_action_taken, $target_reln_temp_nid)=> {
        if (this._govenor == null || this._govenor._applied_for_identity_nid==null) {
            await this.setGovRights($admin_nid);
        }
        return await this._govenor.isValidCollabResponse($admin_nid, $tnid_action_taken, $target_reln_temp_nid);    
    }


    /**
     * TO DO, what about the ANNE EPOCH DAY NUMBER? 
     */
    processAsDateNeuron=function(){
        if (this.year!=undefined || this.month!=undefined || this.day!=undefined) return;//already done.

        var rel_year = MEMG.getRelonFromWith(this.outs, TYPE_HAS, MEM.year.nid);
        if (rel_year==null) this.year = null;
        else this.year = rel_year.to_s;
        
        var rel_month = MEMG.getRelonFromWith(this.outs, TYPE_HAS, MEM.month.nid);
        if (rel_month==null) this.month=null;
        else this.month = rel_month.to_s;
        
        var rel_day = MEMG.getRelonFromWith(this.outs, TYPE_HAS, MEM.day.nid);
        if (rel_day==null) this.day=null;
        else rel_day = rel_day.to_s;

        var rel_era = MEMG.getRelonFromWith(this.outs, TYPE_HAS, MEM.era.nid);
        if (rel_era==null) this.era = MEM.era_ad.nid;
        else this.era = rel_era.to_s;
    }


    /**
     * Delete a role from a ghost clump.
     * Clean up the quick prop for the ROLE_NAME that points to an array of those relons.
     * These quick objects are created (or updated) when we run the processAsClumpNeuron
     * @param {String} $txid - txid long string 
     * @returns {Array} - the relon array of roles that are remaining in that specific role bucket after this deletion.
     */
    deleteRolefromClump=async($txid)=>{
        if (this.ghost==false) return;
        var rel_to_delete = MEMG.lookupByTXID($txid);
        var relnNOBJ = MEMG.getNeuronByTempNid(rel_to_delete.r);
        var rel_arr = this[relnNOBJ.text.toLowerCase()];
        for (var r=0; r < rel_arr.length; r++) {
            if (rel_arr[r].txid==$txid) {
                rel_arr.splice(r, 1);
                break;
            }
        }

        //delete it, there are no more here.
        if (rel_arr.length==0) delete this[relnNOBJ.text.toLowerCase()];
        await ANNE.GHOSTDATA.deleteSingleGhostRelon($txid);

        //note if in the dossier, you need to delete from all_relons to cleanup that page view.
        //it cleans up on next view auto if you don't do that.

        return rel_arr;
    }


    
    defaultRolesForClumpForNLP=async()=> {
        if (this.dead==true) return;
        //pull param roles for this action.. so we can default some extra buttons.
        var role_params = [];
        var all_relons = await MEMG.getRuntimeRelons(this.nid);

        for (var p=0; p < all_relons.length; p++) {
            var paramRelon = all_relons[p];
            if (paramRelon.type!=TYPE_PARAM) continue;
            if (MEM.isRoleR(paramRelon.r)==false) continue;
            var relNOBJ = MEMG.getNeuronByTempNid(paramRelon.r);
            var toNOBJ = MEMG.getNeuronByTempNid(paramRelon.t);
            if (relNOBJ.r==MEM.role_action.temp_nid) continue;

            var roleParam = {
                                roleNOBJ:relNOBJ, 
                                roleTempNid:relNOBJ.temp_nid,
                                role_name:relNOBJ.text, 
                                toNOBJ:toNOBJ, 
                                to_text:toNOBJ.text, 
                                found:false
                            };
            
            role_params[relNOBJ.temp_nid]=roleParam;

            if (MEM.role_standards.indexOf(relNOBJ.temp_nid)==-1) {
                roleParam.priority=1;
            }

            else roleParam.priority=0;

            //note, roles themselves can assign roles.. 
            //WHERE is connected to WHERE_POS_MOD
            //WHEN is connected to WHEN_MOD
            //we don't want to go too deep into a hole, 
            //so just look at default we already have. 
            //only TYPE_PARAMS qualify here
            for (var pp=0; pp < relNOBJ.outs.length; pp++) {
                if (relNOBJ.outs[pp].type==TYPE_PARAM) {
                    if (MEM.isRoleR(relNOBJ.outs[pp].r)==false) continue;
                    var ppRelnNOBJ = MEMG.getNeuronByTempNid(relNOBJ.outs[pp].r);  //the role assigned by the role
                    if (relNOBJ.outs[pp].r==MEM.role_action.temp_nid) continue;
                    var ppToNOBJ = MEMG.getNeuronByTempNid(paramRelon.t);
                    //add the role assigned by the role if we don't have that slot taken already by THIS
                    //clump/vb which would takes precedent.
                    if (role_params[ppRelnNOBJ.temp_nid]==undefined) {
                        var roleParam = {found:false, roleNOBJ:ppRelnNOBJ, roleTempNid:ppRelnNOBJ.temp_nid, role_name:ppRelnNOBJ.text, toNOBJ:ppToNOBJ, to_text:ppToNOBJ.text};
                        role_params[ppRelnNOBJ.temp_nid]=roleParam;
                    }
                }
            }
        }

        return role_params;
    }


    /**
     * 
     * @param {nlp_parse} $nlpP 
     * @returns 
     */
    setTense = function($nlpP=null) {
        this.tense = "present tense";
        this.tenseNOBJ = MEM.tense_present;
        this.shift_lang = false;

        if (this.ntype==NTYPE_INST) {
            
            //insts can shift the concept of a v1 with the tense relon if there
            //is no tensified concept in memory.  (eg, an action like "divorce" does not have a "divorced" subclass)
            //if the user wants "divorced" then can shift divorce with a R_TENSE relon in the instance.
            //They could also create a "divorced" as a sub-class of "divorce" and "divorced" would have a vb_form of v2.
            var rel_tense = MEMG.getRoleRelon(this.outs, MEM.role_tense.temp_nid);
            if (rel_tense!=null) {
                this.tenseNOBJ = MEMG.getNeuronByTempNid(rel_tense.t);
                this.tense = this.tenseNOBJ.text;
                this.shift_lang = true;
                if ($nlpP!=null) $nlpP.setTense(this.tenseNOBJ);
                return this.tense;
            }
            
            if (this.bes.length==0) return "";
            var parentNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
            this.tense = parentNOBJ.setTense();
            this.tenseNOBJ = parentNOBJ.tenseNOBJ;
            this.shift_lang = false;
            if ($nlpP!=null) $nlpP.setTense(this.tenseNOBJ);
            return this.tense;
        }

        //actual tense relon on this concept.
        //this will be a ROLE relon.
        var rel_tense = MEMG.getRoleRelon(this.outs, MEM.role_tense.temp_nid);
        if (rel_tense!=null) {
            this.tenseNOBJ = MEMG.getNeuronByTempNid(rel_tense.t);
            this.tense = this.tenseNOBJ.text;
            this.shift_lang = false;
            if ($nlpP!=null) $nlpP.setTense(this.tenseNOBJ);
            this.setVs();
            return this.tense;
        }

        //forms (v1/v2/v3/v4/v5) are TYPE_BE relons.
        //OTHER forms (not the one this is) are TYPE_HAS
        var rel_vbForm = MEMG.getBeRelon(this.outs, MEM.vb_form.temp_nid);
        if (rel_vbForm!=null) {
            var toNOBJ = MEMG.getNeuronByTempNid(rel_vbForm.t); //the vb form..

            //the tense role is on the vb form.
            var tense_role = MEMG.getRoleRelon(toNOBJ.outs, MEM.role_tense.temp_nid);
            if (tense_role!=null) {
                this.tenseNOBJ = MEMG.getNeuronByTempNid(tense_role.t);
                this.tense = this.tenseNOBJ.text;
                this.shift_lang = false;
                if ($nlpP!=null) $nlpP.setTense(this.tenseNOBJ);
                return this.tense;
            }
        }

        //simple tense relon (not v1,v2,v3,v4,v5)
        var rel_tense = MEMG.getBeRelon(this.outs, MEM.tense.temp_nid);
        if (rel_tense) {
            this.tenseNOBJ = MEMG.getNeuronByTempNid(rel_tense.t);
            this.tense = this.tenseNOBJ.text;
            this.shift_lang = false;
            if ($nlpP!=null) $nlpP.setTense(this.tenseNOBJ);
            return this.tense;
        }

        this.setVs();
        
        return this.tense;
    }


    /**
     * 
     */
    processAsDate=function(){
        if (this.adate!=null) return;
        this.adate = new anne_date();
        this.adate.loadFromNeuron(this, false);
    }


    /**
     * 
     * @param {Array} $all_relons - if passsed in, use it.  Otherwise we gen it in dprc 
     * @param {Boolean} $bDODEBUG - print debug
     * @returns 
     */
    processActionNeuron=async($all_relons=[], $bDODEBUG=false, $skipRoles=[], $el_printouts=null)=>{
        this._roles = [];
        this._param_roles = [];
        this._meaning_roles = [];

        $all_relons = await this.defaultParamRolesForClump($all_relons);
        
        var talkobj = await this.processAsClumpNeuron(null, $skipRoles, $el_printouts);
        
        if ($bDODEBUG==true) this.printRoleDebug();
                
        //nestd meta meaning is a meaning defined by another clump and not by embedded roles.
        //this is done when a concept's definition already exists in another concept.
        //ie, a synonym-like concept where this concept has no definition and relies upon the other for its defintion.
        //This can often be the case in idioms that reference other idioms or already-defined concepts.
        var meta_meaning = MEMG.getRelonByTypeAndR(this.outs, MEM.role_meta_meaning.temp_nid, TYPE_CLUMP);
        if (meta_meaning) {
            var MM = MEMG.getNeuronByTempNid(meta_meaning.t);
            var all_mm_relons = await MM.getRuntimeRelons(false);
            var meta_talkobj = await MM.processActionNeuron(all_mm_relons, $bDODEBUG, $skipRoles, $el_printouts);
            talkobj.meta_meaning_talk = meta_talkobj;
            talkobj.meta_meaning_NOBJ = MM;
            talkobj.meta_meaning_rel = meta_meaning;
        }

        return talkobj;
    }


    /**
     * 
     * @param {*} $all_relons 
     * @param {*} $bDODEBUG 
     * @param {*} $skipRoles 
     * @param {*} $el_printouts 
     * @returns 
     */
    processIdiom=async($all_relons=[], $bDODEBUG=true, $skipRoles=[], $el_printouts=null)=>{
        this._roles = [];
        this._param_roles = [];
        this._meaning_roles = [];
        $all_relons = await this.defaultParamRolesForClump($all_relons);
        var talkobj = await this.processAsClumpNeuron(null, $skipRoles, $el_printouts);
        if ($bDODEBUG==true) this.printRoleDebug();
        return talkobj;
    }


    /**
     * 
     */
    printRoleDebug = async()=> {
        var typelbl = "class";
        if (this.ntype==NTYPE_INST) typelbl = "inst";
        else if (this.ntype==NTYPE_UNKNOWN) typelbl = "unknown type";

        //console.log("_roles", this._roles);
        if (this._roles!=null) ANNE.TALK.printRelons(this._roles);
        //console.log("_param_roles", this._param_roles);
        if (this._param_roles!=null) ANNE.TALK.printRelons(this._param_roles);
        //console.log("_meaning_roles", this._meaning_roles);
        if (this._meaning_roles!=null) ANNE.TALK.printRelons(this._meaning_roles);
        //console.log("%c '"+this.text+"'%c ntype:"+typelbl+"%c tense:"+this.tense+" %c belvl:"+this.be_lvl, TALK.bggreenbig, TALK.bgyellow, TALK.bggreen, TALK.bgred);    
        //console.log("_nested_meaning_roles", this._nested_meaning_roles);

        if (this.is(MEM.ec_action)==true) {
            this.printVs();
        }
    }


    /**
     * set the verb forms to easiy reference/map back to others.
     */
    setVs = function() {
        var setV = function($this, $var, $tnid) {
            var vNOBJ = MEMG.getNeuronByTempNid($tnid);
            $this[$var]=vNOBJ;
            $this[$var+"_txt"]=vNOBJ.text;
        }

        //the form of this neuron. (could be any of the 5)
        if (this.vb_form_rel==undefined) {
            this.vb_form_rel = MEMG.getBeRelon(this.outs, MEM.vb_form.temp_nid);
            if (this.vb_form_rel!=null) {
                if (this.vb_form_rel.t==MEM.vb_v1.temp_nid) setV(this, "v1", this.temp_nid);
                else if (this.vb_form_rel.t==MEM.vb_v2.temp_nid) setV(this, "v2", this.temp_nid);
                else if (this.vb_form_rel.t==MEM.vb_v3.temp_nid) setV(this, "v3", this.temp_nid);
                else if (this.vb_form_rel.t==MEM.vb_v4.temp_nid) setV(this, "v4", this.temp_nid);
                else if (this.vb_form_rel.t==MEM.vb_v5.temp_nid) setV(this, "v5", this.temp_nid);
            }
        }

        //creates .v1, .v2, .v3, .v4 and .v5 (with _txt)
        for (var v=1; v <=5; v++) {
            if (this["v"+v]==undefined || this["v"+v]==null) {
                this["v"+v] = null;
                var vrel = MEMG.getHasRelon(this.outs, MEM['vb_v'+v].temp_nid);
                if (vrel!=null) setV(this, "v"+v, vrel.t);
            }
        }

        //if this wasnt v1, we can get the vs from v1.
        if (this.vb_form_rel!=null && this.vb_form_rel.t!=MEM.vb_v1.temp_nid) {
            if(this.v1!=null) {
                this.setVsFromParent(this.v1)
            }
        }
    }


    /**
     * 
     * @param {*} $parentNOBJ 
     */
    setVsFromParent=function($parentNOBJ) {
        $parentNOBJ.setVs();
        for (var v=1; v <=5; v++) {
            if ($parentNOBJ["v"+v]!=undefined && $parentNOBJ["v"+v]!=null) {
               this["v"+v]=$parentNOBJ["v"+v];
               this["v"+v+"_txt"]=$parentNOBJ["v"+v+"_txt"];
            }
        }
    }


    /**
     * 
     */
    printVs = function() {
        var obj = {v1:this.v1, v1_txt:this.v1_txt, v2:this.v2, v2_txt:this.v2_txt, 
                    v3:this.v3, v3_txt:this.v3_txt, v4:this.v4, v4_txt:this.v4_txt, 
                    v5:this.v5, v5_txt:this.v5_txt};
        if (this.v1) console.log("v1 "+this.v1+" "+this.v1_txt);
        if (this.v2) console.log("v2 "+this.v2+" "+this.v2_txt);
        if (this.v3) console.log("v3 "+this.v3+" "+this.v3_txt);
        if (this.v4) console.log("v4 "+this.v4+" "+this.v4_txt);
        if (this.v5) console.log("v5"+this.v5+" "+this.v5_txt);
        console.log(obj);
        return obj;
    }


    /**
     * Here we get PARAM relons with ROLE reln values.
     * These are telligng us what roles this action/posn/is assigns.
     * 
     * Huge note:
     * Instances are actual clumps (not classes) that will most often be a sub-class of an action neuron.
     * The TYPE_ROLEs specified in the upline are conceptually defining for the concept.
     * They are NOT inherited by the instance.  ONLY TYPE_ROLE  ROLE_TENSE is inherited by the instance.
     * While the TYPE_ROLEs of the parent do applyl to understanding the concept, the new instance clump will be 
     * providing its own ROLES to specify the semantic parts of the information it is encoding.
     * 
     * Instance DO INHERIT ALL THE TYPE_PARAMS.  These are critical to informing us what ROLES this action typically assigns.
     * 
     * @param {Array} $all_relons 
     * @returns 
     */
     defaultParamRolesForClump=async($all_relons=[])=> {
        if (this.dead==true) return;
        var all_relons = null;
        
        if ($all_relons.length==0) {
            all_relons = await MEMG.getRuntimeRelons(this.nid);
        }
        else all_relons = $all_relons;

        var wanted_outs = [];

        for (var p=0; p < all_relons.length; p++) {
            var relon = all_relons[p];
            if (relon.temp==true && relon.ghost==false) continue;   //temp relon for gui help only
            if (relon.type!=TYPE_ROLE && relon.type!=TYPE_PARAM) continue; 
            if (MEM.isRoleR(relon.r)==false) continue;

            var relNOBJ = MEMG.getNeuronByTempNid(relon.r);

            //class neuron assigned roles are MEANING roles.
            if (relon.type==TYPE_ROLE) {
                if (relon.flathexint==undefined) {
                    relon.flathexint=0;
                    relon.flathex="0";
                }
                wanted_outs.push(relon);
                continue;
            }
            else if (relon.type==TYPE_PARAM) {


                this.addParamRole(relon);

                //note, roles themselves can assign roles.. 
                //WHERE is connected to WHERE_POS_MOD
                //WHEN is connected to WHEN_MOD
                //we don't want to go too deep into a hole, 
                //so just look at default we already have. 
                //only TYPE_PARAMS qualify here
                for (var pp=0; pp < relNOBJ.outs.length; pp++) {
                    var pprel  = relNOBJ.outs[pp];
                    if (pprel.type==TYPE_PARAM) {
                        if (MEM.isRoleR(pprel.r)==false) continue;
                        if (pprel.r==MEM.role_action.temp_nid) continue;
                        if (this.getParamRole(pprel.f, pprel.r)==null) this.addParamRole(pprel);
                    }
                }
            }
        }

        //audit (delete when good)
        wanted_outs.sort(this.__sortRolesByFlathexint);

        for (var p=0; p < wanted_outs.length; p++) {
            var relon = wanted_outs[p];
            
            var fromNOBJ = MEMG.getNeuronByTempNid(relon.f);
            var relNOBJ = MEMG.getNeuronByTempNid(relon.r);

            //if this neuron we are looking at is a class neuron..
            //All TYPE_ROLEs are meaning roles.
            if (fromNOBJ.ntype==NTYPE_CLASS) {
                //console.log(relNOBJ.text);
                this.addMeaningRole(relNOBJ.text, relon);
                continue;
            }

            //if this neuron we are looking at is an inst neuron
            else {

                //this relon is inherited
                //it is a meaning role for the action vb.
                if (relon.f!=this.temp_nid) {
                    this.addMeaningRole(relNOBJ.text, relon);
                    
                    //tense is the ONLY role that inherits as a ._role for 
                    //instances.  An instance of a past tense action is a sentence/thought
                    //that is in the past tense.
                    if (relNOBJ.r==MEM.role_tense.temp_nid) {
                        await this.addRole(relNOBJ.text, relon);
                    }
                }

                //this role relon is supplied on the inst neuron itself.
                //it is semantic expression of the meaning of the inst clump.
                //this is what we store in _roles.
                else await this.addRole(relNOBJ.text, relon);
            }

            //only PARAM relons below here.
            MEMG.getNeuronByTempNid(relon.t);

            //if we have role_tense set at this point (_roles set the this.["role_xxx"] property)
            //we do not add in the PARAM ROLE.
            if (relon.r==MEM.role_tense.temp_nid && ANNE.UTILS.isset(this.role_tense)==true) {
                continue;
            }

            //the toNOBJ can now get upgraded/overriden... by the TYPE_SYS _default_class relon.
            //this can be the case when downline subclasses are more refined and specific with their params.
            //var default_class_nid = this.getDefaultClassForParam(relon.txid);
            //if (default_class_nid!=null) {
                //toNOBJ = MEMG.getNeuronByNid(default_class_nid);
            //}

        }

        return all_relons;
    }


    /**
     * 
     * @param {*} $a 
     * @param {*} $b 
     * @returns 
     */
    __sortRolesByFlathexint=function($a, $b) {
        if($a.flathexint < $b.flathexint) return -1;
        else if($a.flathexint > $b.flathexint) return 1;
        return 0;
    }
    

    getRolesArr = async($gpat=null, $skipRoles=[])=>{
        await this.processAsClumpNeuron($gpat, $skipRoles);
        return this._roles;
    }

    /**
     * 
     * @param {Object} $gpat 
     * @param {Array} $skipRoles 
     * @returns {anne_babytalk}
     */
     processAsClumpNeuron = async($gpat=null, $skipRoles=[])=> {  
        if (this.dead==true) return;

        if ($gpat==null) $gpat = TALK.eng_pat1;
        this._roles = [];
         
        //ANNE.TALK.printRelons(this.outs);
         
        var wanted_outs = [];
        for (var r=0; r < this.outs.length; r++) {
            var rObj = this.outs[r];
            if (rObj.type!=TYPE_ROLE && rObj.type!=TYPE_PARAM) continue; //hmm relook at && rObj.type!=TYPE_CLUMP

            //we do not add ROLES inherited from parents here if we have an instance neuron
            //those roles are conceptually defining for the concept (action) being used.
            //they are very important in understanding but for our inst we will supply our own values for the clump's roles.
            if (this.ntype==NTYPE_INST && rObj.r!=MEM.role_tense.temp_nid  && rObj.f!=this.temp_nid) continue;
 
            if (MEM.isRoleR(rObj.r)!=-1) {
                if (rObj.flathexint==undefined) {
                    rObj.flathexint=0;
                    rObj.flathex="0";
                }
                wanted_outs.push(rObj);
            }
        }

        wanted_outs.sort(this.__sortRolesByFlathexint);
        for (var r=0; r < wanted_outs.length; r++) {
            var rObj = wanted_outs[r];
            var roleNOBJ = MEMG.getNeuronByTempNid(rObj.r);

            var rAUDIT = ANNE.MEMG.getNeuronByNid(rObj.reln);
            console.log("audit "+rAUDIT.text);
           
            //param roles are inherited from uplines.
            //note, to get full params you should run the defaultParamRolesForClump!
            if (rObj.type==TYPE_PARAM) this.addParamRole(rObj);
            else {
                if (rObj.f==this.temp_nid) {
                    await this.addRole(roleNOBJ.text, rObj);
                }
                else {
                    this.addMeaningRole(roleNOBJ.text, rObj);
                }
            }
        }
        

        this.bPROCESSEDCLUMP = true;

        this.setTense();

        //set the default action role if it isnt set in the clump.
        //we can inherit from the parent since that is the verb class.
        //INSTANCE CLUMPS are using the PARENT CLASS ACTION ALREADY.

        //NOTE:
        //CLASS CLUMPS use TYPE_ROLE->ROLE_ACTION to provide the verb of the definition of the clump.
        //Any role that a class clump (action vb) sets is the semantic DEFINITION of that clump!
        //Instances should NOT inherit their parent action's set TYPE_ROLE relons, only the class PARAM roles!!!
        //The inherited TYPE_ROLE relons will go into the .meaning_roles array.   
        if (ANNE.UTILS.isset(this.role_action)==false) {
            if(this.bes.length>0) {
                var beNOBJ = MEMG.getNeuronByTempNid(this.bes[0]);
                if (beNOBJ && MEM.isECAction(beNOBJ, false)==true) {
                    
                    //if beNOBJ is a v1 and this is a v2/v3/v4/v5, we want the ROLE_ACTION of 
                    //the parent vb of the beNOBJ!
                    beNOBJ.setTense();
                    if (beNOBJ.tense=="present tense" && this.tense!="present tense") {
                        //not for saving, only made on-demand when viewing this action.
                        var gparent = beNOBJ.getParent();
                        var temp_rel = MEM.makeTempRelon(this, TYPE_ROLE, MEM.role_action.nid, TO_TYPE_ANNE, gparent.nid);
                        temp_rel.flathexint="0";                   
                    }            
                    else {
                        //not for saving, only made on-demand when viewing this action.
                        var temp_rel = MEM.makeTempRelon(this, TYPE_ROLE, MEM.role_action.nid, TO_TYPE_ANNE, beNOBJ.nid);
                        temp_rel.flathexint="0";
                    }
                    await this.addRole("role_action", temp_rel);
                    this.addMeaningRole("role_action", temp_rel);
                }
            }
        }
    

        //walk this back if this has a tense on it. We want the present tense
        //root verb.  Any non-stems are sub-classes of their parent stem.
        //ie, elected has a parent of elect.  They are both classes still..
        //action clumps (or posn/fact/feelz/thought clumps) will all be instances of the 
        //verb they are using.  If an instance of a non stem (that is ok, we get tense).
        //stem can be used with tense role too for the same conceptual result.
        //if (this.role_action!=undefined && this.role_action!=null && this.role_action.length) {
            //this.stem = MEMG.getNeuronByTempNid( this.role_action[0].t );
        //}
        //else this.stem = null;
        if (this.ntype==NTYPE_CLASS) return ANNE.TALK.verbalizeClassActionDef(this);

        return ANNE.TALK.verbalizeInstActionClump(this, $gpat, $skipRoles, true, false);
    }



    /**
     */
    updateGhostParent=async($newToNid, $instOrClass=MEM.inst)=> {
        if (this.dead==true) return null;
        var be_relon  = MEMG.getRelonFromWithRToType(this.outs, TYPE_BE, $instOrClass.temp_nid, TO_TYPE_ANNE);
        if (be_relon!=null) {
            var annihilated_txids = [];
            MEMP.annihilateRelon_RAM(be_relon, annihilated_txids);
            await DB_local.___delete(annihilated_txids, "ghost_relons");
            console.log(this.bes);
            console.log(this.be);
            this.bes=[];
            this.be="";
        }
        return await ANNE.GHOSTDATA.new_ghost_be(this, $instOrClass.nid, TO_TYPE_ANNE, $newToNid);
    }

    /**
     * not in use in the EXT
     */
    ghostEditName=async($text)=>{
        if (this.dead==true) return;
        var be_relon  = MEMG.getRelonFromWithRToType(this.outs, TYPE_BE, MEM.name.temp_nid, TO_TYPE_STRING);
        if (be_relon!=null) {
            var annihilated_txids = [];
            MEMP.annihilateRelon_RAM(be_relon, annihilated_txids);
            await DB_local.___delete(annihilated_txids, "ghost_relons");
            console.log(this.bes);
            console.log(this.be);
        }
        await ANNE.GHOSTDATA.new_ghost_be(this, MEM.name.nid, TO_TYPE_STRING, $text);
        this.text=$text;
    }


    //cleanup our _roles and [role_name] arrays...
    //even though in most cases we just regen them as needed.
    removeRole=function($p, $r){
        if (this.dead==true) return;
        if (this._roles==null) return;
        UTILS.removeRelonByTxid(this._roles, $r.txid);
        if (this[$p]!=undefined) {
            UTILS.removeRelonByTxid(this[$p], $r.txid);
        }
    }


    /**
     * Find the role in the $arr that has a .flathex = to $mod_of_hex
     * @param {*} $arr 
     * @param {*} $mod_of_hex 
     */
    _getHexRole = function($arr, $mod_of_hex) {
        for (var a=0; a < $arr.length; a++) {
            if ($arr[a].flathex==undefined) continue; //never should be th case!
            if ($arr[a].flathex == $mod_of_hex) return $arr[a];
        }
        return null;
    }


    /**
     * add a role to a helpful prop holder and also the roles array.
     * 
     * @param {*} $role_text 
     * @param {*} $rel 
     * @returns 
     */
    addRole=async($role_text, $rel)=> {
        if (this.dead==true) return;    //what is this??? lolz
        if ($rel==null) return;
        if (this._roles==null) this._roles = [];
        
        if ($rel.flathexint!=undefined && $rel.flathex==undefined) {
            $rel.flathex = $rel.flathexint.toString(16);
            $rel.semantic_lvl = $rel.flathex.length;
            if (ANNE.SETTINGS.debug()==true) {
                console.log("flathexint:"+$rel.flathexint+" flathex:"+$rel.flathex+" lvl:"+$rel.semantic_lvl);
                ANNE.TALK.printRelon($rel);
            }
        }

        var parent_role = null;
        if ($rel.semantic_lvl!=undefined && $rel.semantic_lvl !=1) {
            if (this._nested_roles==undefined) this._nested_roles = [];
            UTILS.addUnique(this._nested_roles, "txid", $rel);
            $rel.mod_of_hex = $rel.flathex.substr(1);//(peel off left most val -- this is a mode of what is remaining.)
            if ($rel.mod_of_hex.length==1) parent_role  = this._getHexRole(this._roles, $rel.mod_of_hex);
            else parent_role = this._getHexRole(this._nested_roles, $rel.mod_of_hex);
            
            if (parent_role==null) {
                var Gmod_of_hex = $rel.mod_of_hex.substr(1);
                if (Gmod_of_hex.length==1) {
                    var gparent_role = this._getHexRole(this._roles, Gmod_of_hex);
                    var emu_mod_role_name = MEMG.getNeuronByTempNid(gparent_role.r).text+"_mod".toLowerCase(); 
                }
                else {
                    var gparent_role = this._getHexRole(this._nested_roles, Gmod_of_hex);
                    var emu_mod_role_name = MEMG.getNeuronByTempNid(gparent_role.r).text+"_mod".toLowerCase();
                }

                //parent role will need to point to a new emulated neuron (only local RAM)
                var gparent_toNOBJ = MEMG.getNeuronByTempNid(gparent_role.t);
                
                var emu_compound = MEM.makeTempNObjOnly(MEM.ANNE_ACCTID, NTYPE_CLASS, "", gparent_toNOBJ, true, false);
                
                var emu_role = MEM[emu_mod_role_name];
                var fromNOBJ = MEMG.getNeuronByTempNid(gparent_role.f);
                var emu_rel = MEM.makeTempRelon(fromNOBJ, TYPE_ROLE, emu_role.nid, TO_TYPE_ANNE, emu_compound.nid, false);
                emu_rel.flathex = $rel.mod_of_hex;
                emu_rel.flathexint = parseInt($rel.mod_of_hex, 16);
                emu_rel.semantic_lvl = emu_rel.flathex.length;
                emu_rel.nameless = true;
                console.log("(EMULATED) flathexint:"+emu_rel.flathexint+" flathex:"+emu_rel.flathex+" lvl:"+emu_rel.semantic_lvl);
                if ($rel.mod_of_hex.length==1) UTILS.addUnique(this._roles, "txid", emu_rel);
                else UTILS.addUnique(this._nested_roles, "txid", emu_rel);
                emu_rel.mods = new Object();
                emu_rel.mods[$rel.flathex]=$rel;   //yay!

                //make sure we link from gparent to the new MOD role we created 
                //(that was not made in the ANNODE mem since the mods themselves in combination ARE the mod!
                //note -- this allows for simple use of a ROLE_X_MOD in annode mem OR for compound mods the use of the flathexint!
                if (gparent_role.mods==undefined) gparent_role.mods=new Object();
                if (gparent_role.mods[emu_rel.flathex]==undefined) gparent_role.mods[emu_rel.flathex]=emu_rel;
                return;
            }

            if (parent_role.mods==undefined) parent_role.mods = new Object();
            if (parent_role.mods[$rel.flathex]==undefined) parent_role.mods[$rel.flathex]=$rel;
            return;
        }

        UTILS.addUnique(this._roles, "txid", $rel);
        
        //only the _role relons will store objects in the neuron for quick access.
        //param and meaning arrays can be iterated through.
        if (this[$role_text]!=undefined) UTILS.addUnique(this[$role_text], "txid", $rel);
        else this[$role_text]=[$rel];
        return;
    }

    
    /**
     * -1, role, but no match.
     * 0, no role
     * 1, match.
     * @param {*} $role_text 
     * @param {*} $nid 
     * @returns 
     */
    hasRole=function($role_text, $nid) {
        $role_text = $role_text.toLowerCase();
        if (this[$role_text]==undefined) return 0;
        
        //if any in the array match, it is a match.
        for (var r=0; r < this[$role_text].length; r++) {
            if (this[$role_text][r].to_s==$nid) {
                return 1;
            }
        }

        //if roles exist but don't match, it is a NO MATCH (contradict)
        return -1;
    }


    /**
     * Note, this is not conceptually testing different date neurons
     * for the same value.  I don't need to support that.
     * Here we are testing for min-union matches with no contraction.
     * 
     * @param {*} $nid 
     * @returns 
     */
    minDateUnionMatch = function($nid) {

        //load up our adate vals
        this.processAsDate();

        var otherTimeValueNOBJ = ANNE.MEMG.getNeuronByNid($nid);
        otherTimeValueNOBJ.processAsDate();
        var other_ad = otherTimeValueNOBJ.adate;

        //find out the lowest common date/type we have to compare.
        //we want a "year" to give a positive match
        var lowest_common_lev = ANNE.MEM.gregorian_date.temp_nid;

        var getLowerLev=function($temp_nid) {
            if ($temp_nid==ANNE.MEM.monthyear.temp_nid) {
                lowest_common_lev = ANNE.MEM.monthyear.temp_nid;
            }
            else if ($temp_nid==ANNE.MEM.daymonth.temp_nid) {
                lowest_common_lev = ANNE.MEM.daymonth.temp_nid;
            }
            else if ($temp_nid==ANNE.MEM.integer.temp_nid) {
                lowest_common_lev = ANNE.MEM.integer.temp_nid;
            }
        }

        getLowerLev(this.bes[0]);
        getLowerLev(otherTimeValueNOBJ.bes[0]);
        
        if (lowest_common_lev==ANNE.MEM.gregorian_date.temp_nid) {
            //comparing date vs date -- must be exact date match.
            if (otherTimeValueNOBJ.bes[0]==ANNE.MEM.gregorian_date.temp_nid) {
                if ($nid!=this.nid) return false;
                return true;
            }
        }

        //comparing date vs date part.
        else if (lowest_common_lev==ANNE.MEM.monthyear.temp_nid) {
            if (other_ad.sameMonthYear(this.adate)==true) return true;
            return false;
        }

        else if (lowest_common_lev==ANNE.MEM.daymonth.temp_nid) {
            if (other_ad.sameDayMonth(this.adate)==true) return true;
            return false;
        }

        else if (lowest_common_lev===ANNE.MEM.integer.temp_nid) {
            if (other_ad.sameYear(this.adate)==true) return true;
            return false;
        }
        else return false;
    }


    /**
     * 
     * @param {*} $role_text 
     * @param {*} $nid 
     * @returns 
     */
    hasTimeRoleNoContradict=async($role_text, $nid)=> {
        $role_text = $role_text.toLowerCase();
        if (this[$role_text]==undefined) return 0;

        //if any in the array match, it is a match.
        for (var r=0; r < this[$role_text].length; r++) {
            if (this[$role_text][r].to_s==$nid) {
                return 1;
            }

            //see if one is a year, and one is a date
            else {
                var toNOBJ = ANNE.MEMG.getNeuronByNid(this[$role_text][r].to_s);
                if (toNOBJ.bes[0].length==0 || (toNOBJ.bes[0]!=ANNE.MEM.integer.temp_nid && toNOBJ.outs.length<5)) {
                    await ANNE.API.getNid(toNOBJ.nid);
                }
                if (toNOBJ.minDateUnionMatch($nid)==true) {
                    return 2;   //2 = new info.
                }
            }
        }

        //if roles exist but don't match, it is a NO MATCH (contradict)
        return -1;
    }



    /**
     * Add a meaning role.
     *
     * TYPE_ROLE relons are meaning roles.  They document the semantic meaning
     * of a neuron concept.
     * 
     * @param {*} $role_text 
     * @param {*} $rel 
     */
    addMeaningRole=function($role_text, $rel) {
        if (this.dead==true) return; //what is this??? lolz
        if ($rel==null) return;
        if (this._meaning_roles==null) this._meaning_roles = [];

        if ($rel.flathexint!=undefined && $rel.flathex==undefined) {
            $rel.flathex = $rel.flathexint.toString(16);
            $rel.semantic_lvl = $rel.flathex.length;
            console.log("flathexint:"+$rel.flathexint+" flathex:"+$rel.flathex+" lvl:"+$rel.semantic_lvl);
            ANNE.TALK.printRelon($rel);
        }
        if ($rel.semantic_lvl!=undefined && $rel.semantic_lvl !=1) {
            if(this._nested_meaning_roles==undefined) this._nested_meaning_roles = [];
            UTILS.addUnique(this._nested_meaning_roles, "txid", $rel);
            $rel.mod_of_hex = $rel.flathex.substr(1);//(peel off left most val -- this is a mode of what is remaining.)
            return;
        }

        UTILS.addUnique(this._meaning_roles, "txid", $rel);

        if (this["_meaning_"+$role_text]!=undefined) {
            var arr = this["_meaning_"+$role_text];
            for (var a=0; a < arr.length; a++) {
                
                //dupe role  R_XX-> NID .. from same from?
                //sometimes when we define things we repeat a role that the 
                //parent already had on it.
                if (arr[a].r==$rel.r && arr[a].t==$rel.t) {
                    if($rel.f==arr[a].f) continue;
                    
                    //keep the lower level one.
                    else {
                        var relFromNOBJ = MEMG.getNeuronByTempNid($rel.f);
                        var relArrNOBJ = MEMG.getNeuronByTempNid(arr[a].f);
                        if (relFromNOBJ.be_lvl>relArrNOBJ.be_lvl) {
                            arr[a] = $rel;
                            return;
                        }
                        else {
                            return; //keep the one we have, no need for $rel, it is same relon but higher up the tree. 
                        }
                    }
                }
            }
            UTILS.addUnique(this["_meaning_"+$role_text], "txid", $rel);
        }
        else this["_meaning_"+$role_text]=[$rel];
    }


    /**
     * Looking for a specific param relon from a specific from.
     * @param {int} $f - temp_nid of from 
     * @param {ing} $r - temp_nid of reln
     * @returns {Object} - return Object, if exists, or null.
     */
    getParamRole=function($f,$r) {
        var fromNOBJ = MEMG.getNeuronByTempNid($f);
        return MEMG.getParamRelon(fromNOBJ.outs, $r);
    }

    addParamRole=function($rel) {
        if (this.dead==true) return;//what is this??? lolz
        if ($rel==null) return;
        if (this._param_roles==null) this._param_roles = [];
        UTILS.addUnique(this._param_roles, "txid", $rel);    
    }


    extractRoles = function($roleNOBJ) {
        if (this.dead==true) return;
        var roles = [];
        if (this._roles==null) return roles;
        for (var r=0; r < this._roles.length; r++) {  
            var role = this._roles[r];
            if (role.r==$roleNOBJ.temp_nid) {
                var toNOBJ = MEMG.getNeuronByTempNid(role.t);
                roles.push(toNOBJ);
            }
        } 
        return roles;
    }


    //allow for multiple roles of the same thng in a clump (optimizing storage for rights).
    //loop all roles looking for the target role and target value.
    validateEquals = function($prop, $val) {
        if (this[$prop]==undefined) return false;
        var role_rObjs = this[$prop];
        ANNE.TALK.printRelons(role_rObjs, "(validateEquals)");
        for (var r=0; r < role_rObjs.length; r++) {  
            var to_s = role_rObjs[r].to_s;
            if (to_s==$val) return true; 
        } 
        return false;
    }


    /**
     * @param {*} $bLOAD 
     * @returns 
     */
    setLifeRange = async($bLOAD=true)=>{
        if (this._liferange!=null) return;
        var birthdeath = ANNE.MEMG.getBirthDeath(this);
        this._liferange = new anne_date_range();
        if ($bLOAD==true)  await this._liferange.loadFromDates(birthdeath.date1, birthdeath.date2)
        return;
    }
    
    printNameWithLR=async($class="")=> {
        if (this._liferange==null) {
            await this.setLifeRange(true);
        }
        
        if (this._liferange==null) {
            return this.bestName();
        }
        
        if ($class!="") return this.bestName()+"<span class='"+$class+"'>"+this._liferange.simpleDisplay+"</span>";
        else return this.bestName()+this._liferange.simpleDisplay;
    }
    
    getLR=function(){
        if (this._liferange==null) return "";
        return this._liferange.simpleDisplay;
    }


    /**
     * 
     * @param {*} $bCHASE 
     * @param {*} $bMUSTPULL 
     * @param {*} $types 
     * @returns 
     */
    loadOuts = async($bCHASE=false, $bMUSTPULL=false, $types=[0,1,2,3,4,5,6,7,8,9,10])=> {
        if ($bCHASE==true) {
            return await ANNE.API.getOuts(this.nid, $bMUSTPULL, $types);
        }
        var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForOuts", $nid);
		await ANNE.IDB.queryForOuts(phObj, this.nid, $types);
        return;
    }

    
    /**
     * Quick attempt to match some (any) text.
     * @param {*} $lookupval 
     * @returns 
     */
    textMatch=function($lookupval) {
        var lower = $lookupval.toLowerCase();
        if (lower==this.text) return true;
        
        if(this.aka_lower==undefined || this.aka_lower.length==0) return false;
        for (var a=0; a < this.aka_lower.length; a++) {
            if (lower==this.aka_lower[a]) return true;
        }
        return false;
    }
}



/**
 * This started a clump for service neurons only..
 * but i am extending it for marriage as well.
 * 
 * 
 */

class wiki_clump_neuron {
    constructor($rand, $aec=null)  {
        this.rand = $rand;
        this.aec = $aec;
        this.nObj = null;
        this.term_start = "";   //text for processing
        this.term_end = "";     //text for processing
        this.term_themes = [];   //text for processing
        this.term_affected_things = [];
        this.term_themes_mod = [];

        //all exepcted to be people, if set.
        this.preceded_by_text = null; //role_prev
        this.preceded_by_nObj = null;
        this.ROLE_PREV = null;
        
        this.succeeded_by_text = null; //role_next
        this.succeeded_by_nObj = null;
        this.ROLE_NEXT = null;

        this.appointed_by_text = null; 
        this.appointed_by_nObj = null;

        //resolved to neurons -- as to make relons.
        this.start_year = "";
        this.ROLE_START = null;         //the start of the term
        this.end_year = "";
        this.ROLE_END = null;           //the end of the term
        this.ROLE_ACTORS = [];           //the office holder, or in marriage, the people married.
        this.ROLE_THEME_THINGS = [];    //the office/role held
        this.ROLE_AFFECTED_THINGS = [];
        this.ROLE_THEME_THINGS_MOD = [];    //the office/role held
        this.text_assocs = [];
        this.nObj_political_party=null; //the party (if applicable)
        
        this.nObj_country = null;      //whatever level of polity applicable.  (city, state, district, country etc)
        
        this.nObj_location = null;      //whatever level of polity applicable.  (city, state, district, country etc)
        this.location_relnNOBJ = ANNE.MEM.location;

        //for house of rep, for example, district -> (14th)
        this.nObj_constituency = null;
        this.constituency_relnNOBJ = null;
        
        this.bCUSTOMWIKIOBJECT = true;
        this.text = "";
        this.to_s = "";
        this.term_length_years = null;
        this.extras2 = [];
        this.pre_text = "";
        this.pt_index=-1;
        this.post_text = "";
    }

    addExtra = function($type, $reln, $to_type, $to_s) {
        this.extras2.push({type:$type, reln:$reln, to_type:$to_type, to_s:$to_s});
    }


    getTermLength = function() {
        if (parseInt(this.start_year)>0 && parseInt(this.end_year)>0) {
            return this.end_year - this.start_year;
        }
        return 0;
    }

    setTermStartManual=async($term_start)=> {
        console.log("setTermStartManual "+$term_start);
        this.ROLE_START = null;
        this.term_start = "";
        this.start_year = "";
        this.term_start = $term_start;
        var ad = new anne_date(this.term_start);
        if (ad==null) {
            return; //problem with parse (skip it)
        }
        var bMAKEGHOSTIFNOTFOUND=true;
        await ad.testDate(bMAKEGHOSTIFNOTFOUND);
        this.ROLE_START = ad.nObj;
        if (this.ROLE_START.bes[0]==ANNE.MEM.gregorian_date.temp_nid) {
            this.start_year = ad.year;
        }
        else {
            this.start_year = parseInt($term_start);
        }
    }


    /**
     * 
     * @param {*} $term_end 
     * @returns 
     */
    setTermEndManual=async($term_end)=> {
        console.log("setTermEndManual "+$term_end);
        this.ROLE_END = null;
        this.term_end = "";
        this.end_year = "";
        this.term_end = $term_end;
        var ad = new anne_date(this.term_end);
        if (ad==null) {
            return;
        } 
        var bMAKEGHOSTIFNOTFOUND=true;
        await ad.testDate(bMAKEGHOSTIFNOTFOUND);
        this.ROLE_END = ad.nObj;
        
        if (this.ROLE_END.bes[0]==ANNE.MEM.gregorian_date.temp_nid) {
            this.end_year = ad.year;
        }
        else {
            this.end_year = parseInt($term_end);
        }
    }


    /**
     * code this to resolve and set location.
     * @param {*} $location 
     */
    setLocation = async($location)=> {
        var al = new anne_location();
        var anne_loc_test = new anne_location($str);
        var stateNOBJ = await anne_loc_test.checkForRegionOrState($str);
        if (stateNOBJ!=null) {
            this.nObj_location = stateNOBJ;
            this.location_relnNOBJ = ANNE.MEM.state;
            this.nObj_country = ANNE.MEM.usa;
            return true;
        }
        else {
            var country = await al.checkCountriesNeuronDirect($location);
            if (country!=null) {
                this.nObj_country = country;
            }
        }
    }

    setGenericMarryText = function($bRETURNONLY=false) {
        var parts = [];
        for (var t=0; t < this.ROLE_ACTORS.length; t++) {
            if (t>0) parts.push("and");
            var txt = this.ROLE_ACTORS[t].text;
            parts.push(txt);
        }
        parts.push("marriage");
        
        if ($bRETURNONLY==false) {
            this.text = parts.join(" ").trim();
        }

        //if (this.end_year!=0)  parts.push(this.start_year+"-"+this.end_year);

        return parts.join(" ").trim();
    }


    /**
     * 
     */
    setGenericText=function($bRETURNONLY=false) {
        var parts = [];
        if (this.pre_text!="") {
            parts.push(this.pre_text);
        }
        const THIS = this;
        var noRolesWithThis=function($txt) {
            for (var t=0; t < THIS.ROLE_THEME_THINGS_MOD.length; t++) {
                if (THIS.ROLE_THEME_THINGS_MOD[t].text.indexOf($txt)!=-1) return false;
            }
            for (var t=0; t < THIS.ROLE_THEME_THINGS.length; t++) {
                if (THIS.ROLE_THEME_THINGS[t].text.indexOf($txt)!=-1) return false;
            }
            return true;
        }

        //dont repeat location/country if it is embedded in a theme/thememod..
        //we don't necessarily conceptualize all roles out into their parts.
        //ie,  "Justice of the Wisconsin Supreme court"
        if (this.nObj_location!=null) {
            if (noRolesWithThis(this.nObj_location.text)==true) {
                if (this.nObj_location.alpha2!=undefined) parts.push(this.nObj_location.alpha2);
                else if (this.nObj_location.shortName()) parts.push(this.nObj_location.shortName());
            }
        }
        else if (this.nObj_country!=null) {
            if (noRolesWithThis(this.nObj_country.text)==true) {
                if (this.nObj_country.alpha3!=undefined) parts.push(this.nObj_country.alpha3);
                else parts.push(this.nObj_country.shortName());
            }
        }

        //we don't want to repeat mod in name if we already had it in pre.
        if (this.ROLE_THEME_THINGS_MOD.length) {
            if (this.pt_index>-1 && this.ROLE_THEME_THINGS_MOD.length>1) {
                parts.push(this.ROLE_THEME_THINGS_MOD[this.ROLE_THEME_THINGS_MOD.length-1].text);
            }
            else if (this.pt_index==-1) {
                parts.push(this.ROLE_THEME_THINGS_MOD[this.ROLE_THEME_THINGS_MOD.length-1].text);
            }
        }

        for (var t=0; t < this.ROLE_THEME_THINGS.length; t++) {
            if (t>0) parts.push("and");
            var txt = this.ROLE_THEME_THINGS[t].text;
            txt = txt.replaceAll("White House", "WH");
            if (txt.endsWith(" of")==true) {
                txt = txt.substring(0, txt.length-3).trim();
            }
            parts.push(txt);
        }
        
        parts.push(this.ROLE_ACTORS[0].text);

        if (this.post_text!="") parts.push(this.post_text);  
        if(this.end_year!=0)  parts.push(this.start_year+"-"+this.end_year);
        var test_text = parts.join(" ").trim();
        if ($bRETURNONLY==false) {
            this.text = parts.join(" ").trim();
        }

        //try it again without the actor name.
        //if we can get this in an anbl, that is ideal.
        if (test_text.length>63) {
            test_text = test_text.replace(this.ROLE_ACTORS[0].text+" ", "").trim();
        }

        return test_text;
    }


    setActor = async($actorNOBJ)=>{
        if ($actorNOBJ==null) return;
        this.ROLE_ACTORS.push($actorNOBJ);
    }
    setThemeThing = function($ttNOBJ) {
        if ($ttNOBJ==null) return;
        this.ROLE_THEME_THINGS.push($ttNOBJ);
    }
    setThemeThingMod = function($ttmodNOBJ) {
        if ($ttmodNOBJ==null) return;
        this.ROLE_THEME_THINGS_MOD.push($ttmodNOBJ);
    }


    /**
     * We can use the update for any of the our clumps..
     * It will process max new info (irrelevant for some clumps)
     * @param {*} $newRESOLVEDNOBJ 
     * @param {*} $MOD 
     */
    updateGenericMax=async($newRESOLVEDNOBJ, $MOD)=>{
        this.nObj=$newRESOLVEDNOBJ;
        var ptb = null;
        if ($MOD!=null && $MOD.printToBest!=undefined && typeof $MOD.printToBest=="functoin") {
            ptb = $MOD.printToBest;
        }
        var pb = function($msg) {
            if (ptb==null) return;
            ptb($msg);
        }

        //for service terms
        if (this.ROLE_THEME_THINGS!=null && this.ROLE_THEME_THINGS.length) {
            for (var r=0; r < this.ROLE_THEME_THINGS.length; r++) {
                var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_ROLE, MEM.role_theme_thing.nid, this.ROLE_THEME_THINGS[r].nid);
                if (x_relon!=null) continue;
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_theme_thing.nid, TO_TYPE_ANNE, this.ROLE_THEME_THINGS[r].nid);
                pb("adding role theme thing", _YELLOW, this.ROLE_THEME_THINGS[r].text);
            }   
        }

        //for service terms
        if (this.ROLE_AFFECTED_THINGS!=null && this.ROLE_AFFECTED_THINGS.length) {
            for (var r=0; r < this.ROLE_AFFECTED_THINGS.length; r++) {
                var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_ROLE, MEM.role_affected_thing.nid, this.ROLE_AFFECTED_THINGS[r].nid);
                if (x_relon!=null) continue;
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_affected_thing.nid, TO_TYPE_ANNE, this.ROLE_AFFECTED_THINGS[r].nid);
                pb("adding role affected thing", _YELLOW, this.ROLE_AFFECTED_THINGS[r].text);
            }   
        }

        //for service terms
        if (this.ROLE_THEME_THINGS_MOD!=null && this.ROLE_THEME_THINGS_MOD.length) {
            for (var r=0; r < this.ROLE_THEME_THINGS_MOD.length; r++) {
                var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_ROLE, MEM.role_theme_thing_mod.nid, this.ROLE_THEME_THINGS_MOD[r].nid);
                if (x_relon!=null) continue;
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_theme_thing_mod.nid, TO_TYPE_ANNE, this.ROLE_THEME_THINGS_MOD[r].nid);
                pb("adding role theme thing mod", _YELLOW, this.ROLE_THEME_THINGS_MOD[r].text);
            }   
        }

        //for service terms, marriages
        if (this.ROLE_START!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_ROLE, MEM.role_start.nid, this.ROLE_START.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_start.nid, TO_TYPE_ANNE, this.ROLE_START.nid);
                pb("adding role start", _YELLOW, this.ROLE_START.text);
            }
        }

        //for service terms, marriages
        if (this.ROLE_END!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_ROLE, MEM.role_end.nid, this.ROLE_END.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_end.nid, TO_TYPE_ANNE, this.ROLE_END.nid);
                pb("adding role end", _YELLOW, this.ROLE_END.text);
            }
        }

        //for service terms
        if (this.preceded_by_nObj!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_HAS, MEM.preceded_by.nid, this.preceded_by_nObj.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, MEM.preceded_by.nid, TO_TYPE_ANNE, this.preceded_by_nObj.nid);
                pb("adding preceded by", _YELLOW, this.preceded_by_nObj.text);
            }
        }

        //this should point to the RESOLVED SERVICE-NEURON OF THE PREV holder of the position.
        //the preceeded by value points to the person, wherase this points to the entire term
        //for service terms, marriages
        if (this.ROLE_PREV!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_ROLE, MEM.role_prev.nid, this.ROLE_PREV.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_prev.nid, TO_TYPE_ANNE, this.ROLE_PREV.nid);
                pb("adding role prev", _YELLOW, this.ROLE_PREV.text);
            }
        }

        //for service terms.
        if (this.succeeded_by_nObj!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_HAS, MEM.succeeded_by.nid, this.succeeded_by_nObj.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, MEM.succeeded_by.nid, TO_TYPE_ANNE, this.succeeded_by_nObj.nid);
                pb("adding succeeded by", _YELLOW, this.succeeded_by_nObj.text);
            }
        }


        //this should point to the RESOLVED SERVICE-NEURON OF THE NEXT holder of the position.
        //the succeeded by value points to the person, wherase this points to the entire term
        //for service terms, marriages.
        if (this.ROLE_NEXT!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_ROLE, MEM.role_next.nid, this.ROLE_NEXT.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_next.nid, TO_TYPE_ANNE, this.ROLE_NEXT.nid);
                pb("adding role next", _YELLOW, this.ROLE_NEXT.text);
            }
        }
        
        //for appointed we want to do ANOTHER CLUMP
        //for the one who appointed..
        //X appointed Y for THIS (this clump)
        //TODO: build this after the othre stuff.
        //for service terms
        if (this.appointed_by_nObj!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_HAS, MEM.appointed_by.nid, this.appointed_by_nObj.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, MEM.appointed_by.nid, TO_TYPE_ANNE, this.appointed_by_nObj.nid);
                pb("adding appointed by", _YELLOW, this.appointed_by_nObj.text);
            }

            //only do this if it is new.
            //await this.makeAppointedClump(this.appointed_by_nObj, this.nObj);
        }

        //for country only
        //for service terms, marriages
        if (this.nObj_country!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_HAS, MEM.country.nid, this.nObj_country.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, ANNE.MEM.country.nid, TO_TYPE_ANNE, this.nObj_country.nid);
                pb("adding country", _YELLOW, this.nObj_country.text);
            }
        }

        //for region (like State, ie, Texas)
        //for service terms, marriages
        if (this.nObj_location!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_HAS, MEM.location_relnNOBJ.nid, this.nObj_location.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, this.location_relnNOBJ.nid, TO_TYPE_ANNE, this.nObj_location.nid);
                pb("adding location", _YELLOW, this.nObj_location.text);
            }
        }

        //for service terms
        if (this.nObj_political_party!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_HAS, MEM.political_party.nid, this.nObj_political_party.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, MEM.political_party.nid, TO_TYPE_ANNE, this.nObj_political_party.nid);
                pb("adding political party", _YELLOW, this.nObj_political_party.text);
            }
        }

        //congressional district etc.
        //for service terms
        if (this.nObj_constituency!=null && this.constituency_relnNOBJ!=null) {
            var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, TYPE_HAS, MEM.constituency_relnNOBJ.nid, this.nObj_constituency.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, this.constituency_relnNOBJ.nid, TO_TYPE_ANNE, this.nObj_constituency.nid);
                pb("adding constituency", _YELLOW, this.nObj_constituency.text);
            }
        }

        //for all.
        if (this.extras2!=undefined && this.extras2.length>0) {
            for (var e=0; e < this.extras2.length; e++) {
                var erel =  this.extras2[e];
                var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, erel.type, erel.reln, erel.to_s);
                if (x_relon!=null) continue;
                await GHOSTDATA.makeGhostRelon(erel.type, this.nObj, erel.reln, erel.to_type, erel.to_s);
                if (erel.to_type==TO_TYPE_ANNE) {
                    var TONOBJ = ANNE.MEMG.getNeuronByNid(erel.to_s);
                    pb("adding extra", _YELLOW, TONOBJ.text);
                }
                else {
                    pb("adding extra", _YELLOW, erel.to_s); 
                }
            }
        }
    }
    

    /**
     * make a quick appointed clump.
     * the actor here is the found/created "person" (likely a president)
     * that appointed this judge
     * (that's our primary use case for this build out here)
     * @param {*} $actorNOBJ 
     * @param {*} $affected_thingNOBJ 
     * @returns 
     */
    makeAppointedClump = async($actorNOBJ, $affected_thingNOBJ)=>{
        var clumplookup = new clump_lookup();
        clumplookup.addRole(ANNE.MEM.role_actor.nid, $actorNOBJ.nid);
        clumplookup.addRole(ANNE.MEM.role_action.nid, ANNE.MEM.appointed.nid);
        clumplookup.addRole(ANNE.MEM.role_affected_thing.nid, $affected_thingNOBJ.nid);
        var rez = await clumplookup.findClump(true);
        if (rez.status=="good") {
            var clump_nid = rez.match.nid;
            var x_relon = MEMG.getRelonFromWithTo($actorNOBJ.outs, TYPE_CLUMP, ANNE.MEM.appointed.nid, clump_nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_CLUMP, $actorNOBJ.nObj, ANNE.MEM.appointed.nid, TO_TYPE_ANNE, clump_nid);
            }
            return rez.match;
        }
        else if (rez.status=="ambiguious") {
            console.log("don't do anything here.");
            return null;
        }
    }
    

    /**
     * Make a new service term neuron based on
     * all the values that have been set.
     * @returns 
     */
    makeMarryNeuron = async()=> {
        var action = MEM.marry;
        this.setGenericMarryText();
        this.nObj = await GHOSTDATA.makeGhostNeuron(action, this.text, NTYPE_INST);
        if (this.ROLE_ACTORS.length) {
            for (var a=0; a < this.ROLE_ACTORS.length; a++) {
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_actor.nid, TO_TYPE_ANNE, this.ROLE_ACTORS[a].nid);
            }
        }
        if (this.ROLE_THEME_THINGS!=null && this.ROLE_THEME_THINGS.length) {
            for (var r=0; r < this.ROLE_THEME_THINGS.length; r++) {
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_theme_thing.nid, TO_TYPE_ANNE, this.ROLE_THEME_THINGS[r].nid);
            }   
        }
        if (this.ROLE_START!=null) {
            console.log("audit start date:"+this.ROLE_START.text);
            await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_start.nid, TO_TYPE_ANNE, this.ROLE_START.nid);
        }
        if (this.ROLE_END!=null) {
            console.log("audit end date:"+this.ROLE_END.text);
            await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_end.nid, TO_TYPE_ANNE, this.ROLE_END.nid);
        }
        if (this.ROLE_PREV!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_prev.nid, TO_TYPE_ANNE, this.ROLE_PREV.nid);
        }
        if (this.ROLE_NEXT!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_next.nid, TO_TYPE_ANNE, this.ROLE_NEXT.nid);
        }
        //for country only
        if (this.nObj_country!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, ANNE.MEM.country.nid, TO_TYPE_ANNE, this.nObj_country.nid);
        }
        //for region (like State, ie, Texas)
        if (this.nObj_location!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, this.location_relnNOBJ.nid, TO_TYPE_ANNE, this.nObj_location.nid);
        }
        if (this.extras2!=undefined && this.extras2.length>0) {
            for (var e=0; e < this.extras2.length; e++) {
                var erel =  this.extras2[e];
                var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, erel.type, erel.reln, erel.to_s);
                if (x_relon!=null) continue;
                await GHOSTDATA.makeGhostRelon(erel.type, this.nObj, erel.reln, erel.to_type, erel.to_s);
            }
        }
        return this.nObj;
    }


    /**
     * Make a new service term neuron based on
     * all the values that have been set.
     * @returns 
     */
    makeServiceTermNeuron = async()=> {
        var action = MEM.service_term;
        this.setGenericText();
        this.nObj = await GHOSTDATA.makeGhostNeuron(action, this.text, NTYPE_INST);
        if (this.ROLE_ACTORS.length) {
            for (var a=0; a < this.ROLE_ACTORS.length; a++) {
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_actor.nid, TO_TYPE_ANNE, this.ROLE_ACTORS[a].nid);
            }
        }
        if (this.ROLE_THEME_THINGS!=null && this.ROLE_THEME_THINGS.length) {
            for (var r=0; r < this.ROLE_THEME_THINGS.length; r++) {
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_theme_thing.nid, TO_TYPE_ANNE, this.ROLE_THEME_THINGS[r].nid);
            }   
        }
        if (this.ROLE_AFFECTED_THINGS!=null && this.ROLE_AFFECTED_THINGS.length) {
            for (var r=0; r < this.ROLE_AFFECTED_THINGS.length; r++) {
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_affected_thing.nid, TO_TYPE_ANNE, this.ROLE_AFFECTED_THINGS[r].nid);
            }   
        }

        if (this.ROLE_THEME_THINGS_MOD!=null && this.ROLE_THEME_THINGS_MOD.length) {
            for (var r=0; r < this.ROLE_THEME_THINGS_MOD.length; r++) {
                await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_theme_thing_mod.nid, TO_TYPE_ANNE, this.ROLE_THEME_THINGS_MOD[r].nid);
            }   
        }

        //not in the brain -- as we intended to later find out what this is and deal with it.
        if (this.text_assocs!=null && this.text_assocs.length) {
            for (var r=0; r < this.text_assocs.length; r++) {
                console.log("%c text_assoc %c "+this.text_assocs[r], ANNE.TALK.bgyellow, ANNE.TALK.bggreen);    
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, MEM.anbl_assoc.nid, TO_TYPE_STRING, this.text_assocs[r]);
            }   
        }

        if (this.ROLE_START!=null) {
            console.log("audit start date:"+this.ROLE_START.text);
            await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_start.nid, TO_TYPE_ANNE, this.ROLE_START.nid);
        }
        if (this.ROLE_END!=null) {
            console.log("audit end date:"+this.ROLE_END.text);
            await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_end.nid, TO_TYPE_ANNE, this.ROLE_END.nid);
        }

        if (this.ROLE_PREV!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_prev.nid, TO_TYPE_ANNE, this.ROLE_PREV.nid);
        }

        if (this.ROLE_NEXT!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_ROLE, this.nObj, MEM.role_next.nid, TO_TYPE_ANNE, this.ROLE_NEXT.nid);
        }

        if (this.appointed_by_nObj!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, MEM.appointed_by.nid, TO_TYPE_ANNE, this.appointed_by_nObj.nid);
            await this.makeAppointedClump(this.appointed_by_nObj, this.nObj);
        }

        if (this.succeeded_by_nObj!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, MEM.succeeded_by.nid, TO_TYPE_ANNE, this.succeeded_by_nObj.nid);
        }

        //for country only
        if (this.nObj_country!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, ANNE.MEM.country.nid, TO_TYPE_ANNE, this.nObj_country.nid);
        }

        //for region (like State, ie, Texas)
        if (this.nObj_location!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, this.location_relnNOBJ.nid, TO_TYPE_ANNE, this.nObj_location.nid);
        }
        if (this.nObj_political_party!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, MEM.political_party.nid, TO_TYPE_ANNE, this.nObj_political_party.nid);
        }

        //congressional district etc.
        if (this.nObj_constituency!=null && this.constituency_relnNOBJ!=null) {
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.nObj, this.constituency_relnNOBJ.nid, TO_TYPE_ANNE, this.nObj_constituency.nid);
        }
        if (this.extras2!=undefined && this.extras2.length>0) {
            for (var e=0; e < this.extras2.length; e++) {
                var erel =  this.extras2[e];
                var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, erel.type, erel.reln, erel.to_s);
                if (x_relon!=null) continue;
                await GHOSTDATA.makeGhostRelon(erel.type, this.nObj, erel.reln, erel.to_type, erel.to_s);
            }
        }
        return this.nObj;
    }


    //picked up some new non-contradicting info along the way...
    doExtras = async()=> {
        if (this.nObj==null) return;
        if (this.extras2!=undefined && this.extras2.length>0) {
            for (var e=0; e < this.extras2.length; e++) {
                var erel =  this.extras2[e];
                var x_relon = MEMG.getRelonFromWithTo(this.nObj.outs, erel.type, erel.reln, erel.to_s);
                if (x_relon!=null) continue;
                await GHOSTDATA.makeGhostRelon(erel.type, this.nObj, erel.reln, erel.to_type, erel.to_s);
            }
        }
    }
    


    /**
     * Resolution of theme (or making a new one)
     * For us and Service Terms, we are only making things...
     * so the classNOBJ will never be different here.
     * @param {*} $classNOBJ 
     */
    resolveOrMakeThemeAndAT=async($classNOBJ, $be_nids=[])=>{

        //these really should be done also with an extra of TYPE_BE-> is -> position.
        this.term_themes = ANNE.UTILS.blowOutAmpersands(this.term_themes);

        for (var t=0; t < this.term_themes.length; t++) {
            var bAPPLYTOBELINES = true;
            var themes2 = await ANNE.CIRCUIT.searchToResolve(this.term_themes[t], $classNOBJ, bAPPLYTOBELINES, $be_nids);
            if (themes2.length==0) {
                var rtheme = await GHOSTDATA.makeGhostNeuron($classNOBJ, this.term_themes[t], NTYPE_CLASS);

                this.ROLE_THEME_THINGS.push(rtheme);

                //safe bet here to say this is a position.
                await ANNE.GHOSTDATA.new_ghost_be(rtheme, ANNE.MEM.ec_is, TO_TYPE_ANNE, ANNE.MEM.position.nid);
            }
            
            else if (themes2.length>0) {
                if (ANNE.BRAIN.ctp_light!=null && themes2.length>1) {
                    var dp = new simple_disambig_pool("theme thing role disambig pool", ANNE.BRAIN.ctp_light);
                    var winnerNOBJ = dp.disambiguate(themes2, [ANNE.MEM.role_theme_thing, $classNOBJ]);
                    this.ROLE_THEME_THINGS.push(winnerNOBJ);
                }
                else {
                    this.ROLE_THEME_THINGS.push(themes2[0]);
                }
            }
        }


        //9th president of .... (federal reserve bank of new york)
        //these "things" will often be named nouns.  If new, we can find them in wikipedia.
        for (var t=0; t < this.term_themes_mod.length; t++) {
            var themesmod2 = await ANNE.CIRCUIT.searchToResolve(this.term_themes_mod[t].text, $classNOBJ, bAPPLYTOBELINES, $be_nids);
            if (themesmod2.length==0) {

                //explore and take whatever wiki gives us for it.
                var wke = await ANNE.exploreWiki(this.term_themes_mod[t].text);
                if (wke!==null && wke._wiki && wke._wiki.resolvedNOBJ!=null) {
                    this.ROLE_THEME_THINGS_MOD.push(wke._wiki.resolvedNOBJ);
                }
                else {
                    var rthemodNOBJ = await GHOSTDATA.makeGhostNeuron($classNOBJ, this.term_themes_mod[t].text, this.term_themes_mod[t].ntype);
                    this.ROLE_THEME_THINGS_MOD.push(rthemodNOBJ);
                }
                   
            }
                
            else if (themesmod2.length>0) {
                //if ambiguous and we have a ctp_light pool to work with.. 
                if (ANNE.BRAIN.ctp_light!=null && themesmod2.length>1) {
                    var dp = new simple_disambig_pool("theme thing mod role disambig pool", ANNE.BRAIN.ctp_light);
                    var winnerNOBJ = dp.disambiguate(themesmod2,[ANNE.MEM.role_theme_thing_mod, $classNOBJ, ANNE.MEM.ec_thing, ANNE.MEM.position, ANNE.MEM.occupation]);
                    this.ROLE_THEME_THINGS_MOD.push(winnerNOBJ);
                }

                //just take the first (not ideal)
                else {
                    this.ROLE_THEME_THINGS_MOD.push(themesmod2[0]);
                }
            }
        }


        //hard to know WHAT this is for?????
        //if it is a new thing...
        this.term_affected_things = ANNE.UTILS.blowOutAmpersands(this.term_affected_things);
        for (var t=0; t < this.term_affected_things.length; t++) {
            var aMatches = await ANNE.CHASE.nakedSearch(this.term_affected_things[t], false, true);
            
            //TODO, RESOLVE WITH CONTEXT THE BETTER ONE!
            if (aMatches.length>0) {
                if (ANNE.BRAIN.ctp_light!=null) {
                    var dp = new simple_disambig_pool("affected thing role disambig pool", ANNE.BRAIN.ctp_light);
                    var winnerNOBJ = dp.disambiguate(aMatches, [ANNE.MEM.role_affected_thing, $classNOBJ, ANNE.MEM.ec_person, ANNE.MEM.location]);
                    this.ROLE_AFFECTED_THINGS.push(winnerNOBJ);
                }
                else {
                    this.ROLE_AFFECTED_THINGS.push(aMatches[0]);
                }
            }

            //hmmm.. text assoc tho?
            else {
                this.text_assocs.push(this.term_affected_things[t]);
                this.post_text = this.term_affected_things[t];
            }
        }

        return;
    }


    /**
     * This is done quick and dirty... sloppy.. and not comprehensive.
     * The proper way would be to store these concepts in neurons (already)
     * and then fire them in a pool when "parsing" --- the winning concepts would
     * have definitions (like how long their terms are) on-data-chain.. and we (uhh, I) wouldn't
     * have to try and code as much.
     *
     * @param {*} $roleparts 
     */
    conceptualizeRoles=async($roleparts)=> {
        var rep = "house of representatives";
        var sen = "senator";
        var prez = "president";
        var govn = "governor";
        var mayor = "mayor";
        var judge = "judge";
        var lgovn = "lieutenant governor";
        var memberof = "member of";
        var roles_arr = null;
        var roles_text_arr = null;
        var anyKnownCountry = async($str)=>{
            var al = new anne_location();
            var country = await al.checkCountriesNeuronDirect($str);
            if (country!=null) {
                this.nObj_country = country;
            }
        }
        var anyKnownCity = async($str)=>{
            var bMAKEGHOSTIFNOTFOUND = false;
            var anne_loc = new anne_location($str);
            await anne_loc.processFull([], false, bMAKEGHOSTIFNOTFOUND);
            if (anne_loc.nObj!=null) {
                this.nObj_location = anne_loc.nObj;
                this.location_relnNOBJ = ANNE.MEM.city;
                return true;
            }
            return false;
        }
        var StateOrRegion = async($str)=> {
            var anne_loc_test = new anne_location($str);
            var stateNOBJ = await anne_loc_test.checkForRegionOrState($str);
            if (stateNOBJ!=null) {
                this.nObj_location = stateNOBJ;
                this.location_relnNOBJ = ANNE.MEM.state;
                this.nObj_country = ANNE.MEM.usa;
                return true;
            }
            return false;
        }
        var extractCaseMirror = function($str1, $str2) {
            var str1lower = $str1.toLowerCase();
            var str2lower = $str2.toLowerCase();
            var i = str2lower.indexOf(str1lower);
            if (i==-1) return $str1;
            return $str2.substring(i, $str1.length).trim();
        }
        var extractCase=function($str, $str2) {
            var i = $str2.toLowerCase().indexOf($str.toLowerCase());
            if (i!=-1) {
                return $str2.slice(0, i) + $str2.slice(i + $str.length);
            }
            return $str;
        }

        const RTTM = this.ROLE_THEME_THINGS_MOD;
        
        var checkPreClues = async($role_part, $mapp=1)=> {
            var pc = $role_part.pre_clues;
            if(pc=="") return;

            //extract ordinal here.
            var numbObj = await ANNE.UTILS.extractNumber2(pc, $mapp);
            if (numbObj!=null) {
                RTTM.push(numbObj.nObj);
                if(t==0) {
                    this.pre_text = numbObj.str;    //this was the ord or num str.
                    this.pt_index = RTTM.length-1;
                }
                $role_part.pre_clues = numbObj.remaining;
                
                if ($role_part.pre_clues.length==0) $role_part.pre_clues_handled=true;
                else $role_part.pre_clues_handled=false;
                return;
            }

            //if this is an ordinalizd number, resolve the number,
            //store in ROLE_THEME_THINGS_MOD.
            $role_part.pre_clues_handled = false;
        }

        //test to parse out the THEME_THING and THEME_THING_MOD
        //var testRoles = await ANNE.wikiThemeModPhraseParse($roleparts[0].arr[0], $roleparts[0].links);
        //console.log(testRoles);

        //clean them to replace the willy wonka indexOf lists ...
        //would be to look at the root phrase (before any signals) in the THEME_THING from the phraseParse..
        
        for (var t=0; t < $roleparts.length; t++) {
            var role_part = $roleparts[t];
            var target_role = role_part.target_role;

            if (target_role==undefined || target_role==null) {
                continue;
            }
           
            if (target_role.nid==ANNE.MEM.role_theme_thing.nid) {
                roles_arr = this.ROLE_THEME_THINGS;
                roles_text_arr = this.term_themes;
            }
            else if (target_role.nid==ANNE.MEM.role_affected_thing.nid) {
                roles_arr = this.ROLE_AFFECTED_THINGS;
                roles_text_arr = this.term_affected_things;
            }

            var bUSA=false;

            if ($roleparts[t].arr.length>1) {
                alert("we found one bigger than one!");
                console.log("testing roleparts[t].arr.length "+$roleparts[t].arr.length);
            }


            //we will set this below if any of the inner parts handle the pre_clues.
            role_part.pre_clues_handled = false;

            
            //loop the inner array.
            //first strip out USA location.
            //would obviously be lovely if we parsed this then handled locations (all)
            //they either come as [LOCATION] [THING]  or some [THING] [LOCATION]
            for (var a=0; a < $roleparts[t].arr.length; a++) {
                
                var value = role_part.arr[a].toLowerCase();
                var valueCaps = role_part.arr[a];

                //we're going to have to upgrade this for other countries..
                //had to start somewhere tho.. 
                if (value.indexOf("u.s.")!=-1 || value.indexOf("usa")!=-1 || value.indexOf("united states")!=-1) {
                    this.nObj_country = ANNE.MEM.usa;
                    bUSA=true;
                    var bHANDLED=false;
                    var starters = ["u.s.", "usa", "united states"];
                    for (var s=0; s < starters.length; s++) {
                        var starter = starters[s];
                        if (value.indexOf(starter)==0) {
                            role_part.remaining = value.substring(starter.length+1).trim();
                            console.log("remaining: %c"+role_part.remaining, ANNE.TALK.bggreen);
                            valueCaps = role_part.arr[a].substring(starter.length+1);
                            console.log("valueCaps: %c"+valueCaps, ANNE.TALK.bggreen);
                            value = valueCaps.toLowerCase();
                            var bFOUND = StateOrRegion(role_part.remaining);
                            if (bFOUND) role_part.remaning="";
                            bHANDLED=true;
                            break;
                        }
                    }

                    if (bHANDLED==false) {
                        var enders = ["of the u.s.", "of the usa", "of the united states"];
                        for (var e=0; e < enders.length; e++) {
                            var ender = enders[e];
                            var indx = value.indexOf(ender);
                            if (indx!=-1) {
                                role_part.remaining = value.substring(0, indx-1).trim();
                                console.log("remaining: %c"+role_part.remaining, ANNE.TALK.bggreen);
                                valueCaps = role_part.arr[a].substring(0, role_part.remaining.length);
                                console.log("valueCaps: %c"+valueCaps, ANNE.TALK.bggreen);
                                value = valueCaps.toLowerCase();
                                var bFOUND = StateOrRegion(role_part.remaining);
                                if (bFOUND==true) role_part.remaning="";
                                break;
                            }
                        }
                    }
                }
            
                
                if (value.indexOf(rep)!=-1) {
                    if (bUSA==true) this.term_length_years = 2; 
                    roles_arr.push(ANNE.MEM.representative);
                    role_part.remaining=extractCase(rep, valueCaps);
                    await checkPreClues(role_part);
                }
                else if (value.indexOf(sen)!=-1) {
                    if (bUSA==true) this.term_length_years = 4;
                    roles_arr.push(ANNE.MEM.senator);
                    role_part.remaining=extractCase(sen, valueCaps);
                    await checkPreClues(role_part);
                }
                else if (value.indexOf(lgovn)!=-1) {
                    if (bUSA==true) this.term_length_years = 4;
                    roles_arr.push(ANNE.MEM.lgovernor);
                    await checkPreClues(role_part);
                    if (value.indexOf("lieutenant governor of")==0) {
                         if (value.indexOf("lieutenant governor of")==0) {
                            role_part.remaining = valueCaps.substring(23).trim();
                            var found = await StateOrRegion(role_part.remaining);
                            if (found==true) role_part.remaining="";
                        }
                    }
                    else {
                        role_part.remaining=extractCase(lgovn, valueCaps);
                    }
                }
                else if (value.indexOf(prez)!=-1) {
                    if (bUSA==true) this.term_length_years = 4;
                    roles_arr.push(ANNE.MEM.president);
                    await checkPreClues(role_part);
                    if (value.indexOf("president of")==0) {
                        role_part.remaining = valueCaps.substring(12).trim();
                        var found = await StateOrRegion(role_part.remaining);
                        if(found==true) role_part.remaining="";
                    }
                    else {
                        role_part.remaining=extractCase(prez, valueCaps);
                    }
                }
                
                else if (value.indexOf(govn)!=-1) {
                    if (bUSA==true) this.term_length_years = 4;
                    roles_arr.push(ANNE.MEM.governor);
                    await checkPreClues(role_part);
                    if (value.indexOf("governor of")==0) {
                         if (value.indexOf("governor of")==0) {
                            role_part.remaining = valueCaps.substring(12).trim();
                            var found = await StateOrRegion(role_part.remaining);
                            if (found==true) role_part.remaining="";
                        }
                    }
                    else {
                        role_part.remaining=extractCase(govn, valueCaps);
                    }
                }
                else if (value.indexOf(mayor)!=-1) {
                    if (bUSA==true) this.term_length_years = 4;
                    roles_arr.push(ANNE.MEM.mayor);
                    if (value.indexOf("mayor of")==0) {
                        role_part.remaining = valueCaps.substring(9).trim();
                        var cities = await ANNE.getQuickCity(role_part.remaining);
                        if (cities.length==1) {
                            this.nObj_location = cities[0];
                            this.location_relnNOBJ = ANNE.MEM.city;
                            role_part.remaining="";
                        }
                        else if (cities.length>1 && ANNE.BRAIN!=null) {
                            this.nObj_location = ANNE.BRAIN.applyPoolWeights(cities, this.ROLE_ACTORS, true);
                            this.location_relnNOBJ = ANNE.MEM.city;
                            role_part.remaining="";
                        }
                        else if (bUSA==true) {
                            var bFOUND = await anyKnownCity(role_part.remaining+", USA");
                            if (bFOUND==true) role_part.remaining="";
                        }
                        else {
                            var bFOUND = await anyKnownCity(role_part.remaining);
                            if (bFOUND==true) role_part.remaining = "";
                        }
                    }
                    else {
                        role_part.remaining=extractCase(mayor, valueCaps);
                    }
                    await checkPreClues(role_part);
                }

                else if (value.indexOf(memberof)!=-1) {
                    roles_arr.push(ANNE.MEM.member_of);
                    if (value.indexOf("member of the")==0) {
                        role_part.remaining = valueCaps.substring(14).trim();
                        var cities = await ANNE.getQuickCity(role_part.remaining);
                        if (cities.length==1) {
                            this.nObj_location = cities[0];
                            this.location_relnNOBJ = ANNE.MEM.city;
                             role_part.remaining="";
                        }
                        else if (cities.length>1 && ANNE.BRAIN!=null) {
                            this.nObj_location = ANNE.BRAIN.applyPoolWeights(cities, this.ROLE_ACTOR, true);
                            this.location_relnNOBJ = ANNE.MEM.city;
                             role_part.remaining="";
                        }
                        else if (bUSA==true) {
                            var bFOUND = await anyKnownCity(role_part.remaining+", USA");
                            if (bFOUND==true)  role_part.remaining="";
                        }
                        else {
                            var bFOUND = await anyKnownCity(role_part.remaining);
                            if (bFOUND==true)  role_part.remaining="";
                        }
                    }
                    else {
                        role_part.remaining=extractCase(memberof, valueCaps);
                    }
                    await checkPreClues(role_part);
                }


                //take the original value. (resolve later)
                else {
                    if (role_part.pre_clues!="") {

                        var pc = role_part.pre_clues.toLowerCase();
                        if (pc.indexOf(rep)!=-1) {
                            if (bUSA==true) this.term_length_years = 2; 
                            roles_arr.push(ANNE.MEM.representative);
                            role_part.pre_clues_handled = true;
                        }
                        else if (pc.indexOf(sen)!=-1) {
                            if (bUSA==true) this.term_length_years = 4;
                            roles_arr.push(ANNE.MEM.senator);
                            role_part.pre_clues_handled = true;
                        }
                        else if (pc.indexOf(lgovn)!=-1) { //lgovn = "lieutenant governor"
                            if (bUSA==true) this.term_length_years = 4;
                            roles_arr.push(ANNE.MEM.lgovernor);
                            role_part.pre_clues_handled = true;
                        }

                        else if (pc.indexOf(prez)!=-1) {
                            if (bUSA==true) this.term_length_years = 4;
                            roles_arr.push(ANNE.MEM.president);
                            role_part.pre_clues_handled = true;
                        }
                                                
                        else if (pc.indexOf(govn)!=-1) {
                            if (bUSA==true) this.term_length_years = 4;
                            roles_arr.push(ANNE.MEM.governor);
                            role_part.pre_clues_handled = true;
                        }
                        else if (pc.indexOf(mayor)!=-1) {
                            if (bUSA==true) this.term_length_years = 4;
                            roles_arr.push(ANNE.MEM.mayor);
                            role_part.pre_clues_handled = true;
                        }
                        else if (pc.indexOf(judge)!=-1) {;
                            roles_arr.push(ANNE.MEM.judge);
                            role_part.pre_clues_handled = true;
                        }
                        else if (pc.indexOf(memberof)!=-1) {;
                            role_part.pre_clues_handled = true;
                                   
                            if (pc.indexOf("member of the")==0) {
                                if (value.indexOf("board")!=-1) {
                                    this.ROLE_THEME_THINGS.push(ANNE.MEM.board_member_of);
                                    var prepre = value.substring(0, value.indexOf("board")-1).trim();
                                    console.log(prepre);
                                    var cities = await ANNE.getQuickCity(prepre);
                                    if (cities.length==1) {
                                        this.nObj_location = cities[0];
                                        this.location_relnNOBJ = ANNE.MEM.city;
                                    }
                                    else if (cities.length>1 && ANNE.BRAIN!=null) {
                                        this.nObj_location = ANNE.BRAIN.applyPoolWeights(cities, this.ROLE_ACTOR, true);
                                        this.location_relnNOBJ = ANNE.MEM.city;
                                    }
                                    else if (bUSA==true) {
                                        if (await anyKnownCity(role_part.remaining+", USA")==false) {
                                            this.ROLE_THEME_THINGS.push(ANNE.MEM.member_of);
                                            this.term_themes_mod.push({text:valueCaps.trim(), ntype:NTYPE_INST});
                                        }
                                    }
                                    else if (await anyKnownCity(role_part.remaining)==false) {
                                        this.ROLE_THEME_THINGS.push(ANNE.MEM.member_of);
                                        this.term_themes_mod.push({text:valueCaps.trim(), ntype:NTYPE_INST});
                                    }
                                }
                                else {
                                     this.ROLE_THEME_THINGS.push(ANNE.MEM.member_of);
                                     this.term_themes_mod.push({text:valueCaps.trim(), ntype:NTYPE_INST});

                                     if (valueCaps.indexOf("Assembly of")==0) {
                                        var remaining = valueCaps.substring(12).trim();
                                        await anyKnownCountry(remaining);
                                     }
                                }
                            }
                            else {
                                this.ROLE_THEME_THINGS.push(ANNE.MEM.member_of);
                            }
                        }
                                
                        else {
                            //unique entries
                            if (roles_text_arr.indexOf(valueCaps.trim())==-1) {

                                //try to extract state (if so we know USA)
                                var parts2 = valueCaps.split(" ");
                                if (parts2.length>0) {
                                    var found = await StateOrRegion(parts2[0]);
                                    if (found==true) {
                                        //valueCaps = valueCaps.replace(parts2[0]+" ", "");
                                    }
                                }
 
                                await checkPreClues(role_part, 8);

                                if (role_part.pre_clues_handled==false) {
                                    if (role_part.pre_clues.endsWith("of the")==true) {
                                        var ot = role_part.pre_clues.indexOf("of the");
                                        var val = role_part.pre_clues.substring(0, ot);
                                    
                                        //chief justice.. or title name..  OF THE.
                                        this.term_themes_mod.push({text:valueCaps.trim(), ntype:NTYPE_CLASS});
                                    
                                        //OF THE ---  indicative of inst.
                                        this.term_themes.push(val.trim());
                                    }
                                }
                                else roles_text_arr.push(valueCaps.trim());
                            }
                            else await checkPreClues(role_part);
                        }
                    }

                    //remaining was just handled here..
                    else {
                        //unique entries.
                        if (roles_text_arr.indexOf(valueCaps.trim())==-1) {
                            roles_text_arr.push(valueCaps.trim());
                            role_part.remaining="";
                        }
                    }

                    //this could be.. any number of nouns. (location/company/?)
                    //"from the 2nd district"
                    if (role_part.post_test!="") {
                        //this would be lovely to parse in a phrase.
                        if (role_part.post_test.indexOf("from")==0) {
                            role_part.likelyLocation = true;

                            if (role_part.post_test.indexOf("from the")==0) {
                                var remaining = role_part.post_test.substring(9);
                                console.log(remaining);
                                role_part.post_test = remaining;

                                remaining = remaining.replace("district","");
                                remaining = remaining.replace("  "," ").trim();
                                if (remaining.length!=role_part.post_test.length) {
                                    var numbNOBJ = await ANNE.UTILS.extractNumber(remaining, 1);
                                    if (numbNOBJ!=null) {
                                        this.addExtra(TYPE_HAS, ANNE.MEM.district.nid, TO_TYPE_ANNE, numbNOBJ.nid); 
                                        role_part.post_test = ""; 
                                    }
                                }
                            }
                            else {
                                var remaining = role_part.post_test.substring(4);
                                console.log(remaining);
                                role_part.post_test = remaining;
                                remaining.replace("district","");
                                remaining.replace("  "," ");
                                if (remaining.length!=role_part.post_test) {
                                    var numbNOBJ = await ANNE.UTILS.extractNumber(pc, 1);
                                    if (numbNOBJ!=null) {
                                        this.addExtra(TYPE_HAS, ANNE.MEM.district.nid, TO_TYPE_ANNE, numbNOBJ.nid);  
                                        role_part.post_test = "";
                                    }
                                }
                            }
                        }

                        //put the post test in the afftected things.
                        if (role_part.post_test!="") {
                            this.term_affected_things.push(role_part.post_test);
                        }
                    }
                    
                }   

                if(role_part.pre_clues_handled==false) {
                    console.log("%c PRE CLUES NOT HANDLED %c "+role_part.pre_clues, ANNE.TALK.bgbigred, ANNE.TALK.bgyellow);    
                }

                if (role_part.remaining!=undefined && role_part.remaining.length>0) {
                    console.log("still remaining "+role_part.remaining);
                    role_part.remaining = extractCaseMirror(role_part.remaining, valueCaps);
                    if (role_part.remaining.indexOf("the ")!=0) {
                        role_part.remaining = role_part.remaining.replace("the ", "").trim();
                    }
                    else role_part.remaining = extractCaseMirror(role_part.remaining, role_part.arr[a]);
                    this.term_themes_mod.push({text:role_part.remaining, ntype:NTYPE_INST});
                }

            }
        }    
        this.nameFunc = this.setGenericText;
    }


    /**
     * 
     * @returns 
     */
    quickPerson=async($person)=> {
        var GMOBJ = await MEMG.getOrMakeIfNewPerson(this.aec, $person);
        if (GMOBJ.status=="good") {
            if (this.aec!=null) {
                if (GMOBJ.match.bNEW==true) this.aec.printf("new person", _BLUE, $person);
                else this.aec.printf("resolved person", _YELLOW, $person);
            }
            return GMOBJ.match;
        }
        
        //resolve this somehow. or do nothing.
        else if (GMOBJ.status=="ambiguous") {
            this.aec.printf("resolved person", _YELLOW, $person);
            return GMOBJ.matches[0];
        }
    }

    
    /**
     * A term neuron from wikipedia. 
     * @param {*} $obj 
     * @param {*} $postfix 
     */
    processServiceTermFromWikipedia=async($obj, $postfix="", $sameOffice=null, $aec=null)=>{
        if ($obj["order"+$postfix]!=undefined) {
            if ($sameOffice[0].pre_clues=="") {
                $sameOffice[0].pre_clues=$obj["order"+$postfix].data.text;
            }
            else {
                if ($sameOffice[0].pre_clues!=$obj["order"+$postfix].data.text) {
                    console.warn("WHAT IS GOING ON HERE????? ");
                    console.log($sameOffice[0].pre_clues+" vs "+$obj["order"+$postfix].data.text);
                }
            }
        }
        
        if ($sameOffice!=null) {
            await this.conceptualizeRoles($sameOffice, $aec);
        }

        //extras.
        if($obj['predecessor'+$postfix]!=undefined) {
            this.preceded_by_text = $obj['predecessor'+$postfix].data.text;
            this.preceded_by_nObj = await this.quickPerson(this.preceded_by_text);
        }
        
        if($obj['successor'+$postfix]!=undefined) {
            this.succeeded_by_text = $obj['successor'+$postfix].data.text;
            this.succeeded_by_nObj = await this.quickPerson(this.succeeded_by_text);
        }
        
        if($obj['appointer'+$postfix]!=undefined) {
            this.appointed_by_text = $obj['appointer'+$postfix].data.text;
            this.appointed_by_nObj = await this.quickPerson(this.appointed_by_text);
        }
        
        //$infobox.data["constituency"+postfix]==undefined
        if($obj['constituency'+$postfix]!=undefined) {
            //"TX's 14th congressional district"
            var constituency = $obj['constituency'+$postfix].data.text;
            console.log(constituency);
            var num = await ANNE.UTILS.extractNumber(constituency);
            if (num!=null) {
                if (constituency.indexOf("district")!=-1) {
                    this.nObj_constituency = num;
                    this.constituency_relnNOBJ = ANNE.MEM.district;
                }
            }
        }

        if ($obj["term_start"+$postfix]!=undefined) {
            this.term_start = $obj["term_start"+$postfix].data.text;
            var ad = new anne_date(this.term_start);
            if (ad==null) {
                return; //problem with parse (skip it)
            }
            var bMAKEGHOSTIFNOTFOUND=true;
            await ad.testDate(bMAKEGHOSTIFNOTFOUND);
            this.ROLE_START = ad.nObj;
            this.start_year = ad.year;
        }

        if ($obj["term_end"+$postfix]!=undefined) {
            this.term_end = $obj["term_end"+$postfix].data.text;
            var ad = new anne_date(this.term_end);
            if (ad==null) {
                return;
            } 
            var bMAKEGHOSTIFNOTFOUND=true;
            await ad.testDate(bMAKEGHOSTIFNOTFOUND);
            this.ROLE_END = ad.nObj;
            this.end_year = ad.year;
        }
    }
}